(function () {
    'use strict';

    angular
        .module('myApp')
        .factory('authHandler', authHandler);

    authHandler.$inject = ['$rootScope', '$ionicPlatform', '$location'];

    function authHandler($rootScope, $ionicPlatform, $location){
        return {
            initialize: initialize
        };

        function ready(){
            $rootScope.isReady = true;
            $rootScope.$broadcast('isReady');//baseInfo初始化完成广播,由$stateChangeStart接收
        }

        function initialize(){
            $rootScope.isReady = false; // baseInfo初始化状态
            $ionicPlatform.ready(function () {
                try {
                    // 20210301
                    yn.plugin.yncordova.baseInfo(function (data) {
                        // 服务器地址、用户id、用户类型 初始化
                        data = JSON.parse(data);
                        if (data.access_token && data.originUrl) {
                            var access_token = data.access_token,
                                originUrl = data.originUrl;
                            originUrl = originUrl.replace('/ynedut', '/smesis');

                            $rootScope.authentication = {
                                'access_token': access_token
                            };
                            basePath = $rootScope.basePath = originUrl;
                            if (window && window.localStorage) {
                                window.localStorage.setItem("authentication", JSON.stringify($rootScope.authentication));
                                window.localStorage.setItem("basePath", JSON.stringify($rootScope.basePath));
                            }
                        } else {
                            if (window && window.localStorage) {
                                $rootScope.authentication = JSON.parse(window.localStorage.getItem("authentication"));
                                basePath = $rootScope.basePath = JSON.parse(window.localStorage.getItem("basePath"));
                            }
                        }
                        ready();
                    }, function (error) {
                        console.log('baseInfo error' + error);
                        ready();
                    });
                } catch (e) {
                    console.error('plugin: baseInfo() not defined.')
                    ready();
                }
            });

            var searchObj = $location.search();
            // 微应用id
            $rootScope.microId = null;
            if (searchObj.microId) {
                $rootScope.microId = searchObj.microId;
                if (window && window.localStorage) {
                    window.localStorage.setItem("microId", JSON.stringify($rootScope.microId));
                }
            }else{
                if (window && window.localStorage) {
                    $rootScope.microId = JSON.parse(window.localStorage.getItem("microId"));
                }
            }
        }
    }

})();
