(function () {
    'use strict';

    angular
        .module('myApp')
        .factory('authInterceptor', authInterceptor);

    authInterceptor.$inject = ['$injector', '$q'];

    function authInterceptor($injector, $q) {
        var initTotalNumber = 0;
        var service = {
            request: request,
            requestError: requestError,
            response: response,
            responseError: responseError
        };
        return service;

        function request(config) {
            initTotalNumber++;
            if (window.localStorage.getItem('authentication') && config.url.indexOf('.html') == -1) {
                var authentication = JSON.parse(window.localStorage.getItem('authentication'));
                config.headers.authorization = 'Bearer ' + authentication.access_token;
                //loading
                if (!loadingDisabled(config.url)) {
                    $injector.get('$ionicLoading').show({
                        template: '<ion-spinner icon="ios"></ion-spinner>',
                        noBackdrop: true,
                        hideOnStateChange: true
                    });
                }
            }
            return config;
        }

        function loadingDisabled(url) {
            return /loading=disabled/.test(url);
        }

        function requestError(rejection) {
            initTotalNumber--;
            $injector.get('$ionicLoading').hide();
            return rejection;
        }

        function response(response) {
            initTotalNumber--;
            if (initTotalNumber == 0) {
                $injector.get('$ionicLoading').hide();
            }
            return response;
        }

        function responseError(response) {
            initTotalNumber--;
            $injector.get('$ionicLoading').hide();
            if (response.status == 401) {
                $injector.get('$state').go('401');
                return $q.reject(response);
            } else {
                return $q.reject(response);
            }
        }
    }
})();
