/**
 * Created by wuhaiying on 2017/4/24.
 */
(function(){
    'use strict';
    angular
        .module('myApp')
        .controller('approveController', approveController);
    approveController.$inject = ['$scope','$ionicLoading','$ionicModal','$ionicPopup','$http','$timeout'];
    function approveController($scope,$ionicLoading,$ionicModal,$ionicPopup,$http,$timeout){
        //点击更多按钮
        $scope.moreButton =false;
        $scope.showMoreButton = function(){
            $scope.moreButton = !$scope.moreButton;
        };
        //审批进行时
        $ionicModal.fromTemplateUrl('approving.html',{
            scope:$scope,
            animation:'slide-in-right'
        }).then(function(modal){
            $scope.modalOne = modal;
        });
        $scope.showApproveModal = function(){
            $scope.modalOne.show();
        };
        $scope.closeApproveModal = function(){
            $scope.modalOne.hide();
        };
        // Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function() {
            $scope.modalOne.remove();
        });
        //提示信息
        $scope.showWarning = function(){
            $ionicLoading.show({
                template:'此申请只能在电脑上进行审批'
            });
            setTimeout(function(){
                $ionicLoading.hide();
            },800)
        };
        //处理意见弹框
        $scope.showHandleIdea = function(){
            var myPopup = $ionicPopup.show({
                template:'<textarea class="form-control" placeholder="输入处理意见，最多X个字"></textarea>',
                title:'处理意见(非必填)',
                scope:$scope,
                buttons:[
                    {
                        text:'取消',
                        type:'button-local button-theme button-outline'
                    },
                    {
                        text:'确定',
                        type:'button-local button-theme'
                    }
                ]
            })
            $timeout(function() {
                myPopup.close(); //close the popup after 3 seconds for some reason
            }, 3000);
        };
        //通过审批
        $ionicModal.fromTemplateUrl('pass-approve.html',{
            scope:$scope
        }).then(function(modal){
            $scope.modalTwo = modal;
        });
        $scope.showPassApproveModal = function(){
            $scope.modalTwo.show();
        };
        $scope.closePassApproveModal = function(){
            $scope.modalTwo.hide();
        };
        // Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function() {
            $scope.modalTwo.remove();
        });

        //选择加班类型
        $ionicModal.fromTemplateUrl('choose-overtime-style.html',{
            scope:$scope
        }).then(function(modal){
            $scope.modalThree = modal;
        });
        $scope.chooseOvertimeStyle = function(){
            $scope.modalThree.show();
        };
        $scope.closeOvertimeStyle = function(){
            $scope.modalThree.hide();
        };
        // Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function() {
            $scope.modalThree.remove();
        });

    }
})();
