/**
 * project:     yineng-corpSysLand
 * title:      business_journal.controller.js
 * author:      xiechangwei
 * date:        2016/12/1 10:23
 * copyright:   2016 www.yineng.com.cn Inc. All rights reserved.
 * description:微应用-出差日记账
 */
(function () {
    'use strict';

    angular
        .module('myApp')
        .config(stateConfig)
        .controller('businessJournalController', businessJournalController)
        .controller('viewFeeController', viewFeeController)
        .controller('addTransController', addTransController)
        .controller('viewTransController', viewTransController)
        .controller('addHotelController', addHotelController)
        .controller('viewHotelController', viewHotelController)
        .controller('addOtherController', addOtherController)
        .controller('viewOtherController', viewOtherController);

    stateConfig.$inject = ['$stateProvider'];

    function stateConfig($stateProvider) {
        $stateProvider
        /*出差日记账主页面*/
            .state('business_journal', {
                homePage: true,
                url: '/business_journal',
                templateUrl: 'views/business_trip_journal/business_journal.html',
                data: {
                    micro: true,
                    title: '出差日记账',
                    prev: null
                },
                controller: 'businessJournalController'
            })
            /*出差日记账查看费用记录*/
            .state('view_fee', {
                url: '/view_fee',
                templateUrl: 'views/business_trip_journal/view_fee.html',
                data: {
                    title: '查看费用记录',
                    prev: 'business_journal'
                },
                controller: 'viewFeeController'
            })

            /*添加交通费用*/
            .state('add_trans', {
                url: '/add_trans',
                templateUrl: 'views/business_trip_journal/add_trans_fee.html',
                data: {
                    title: '添加交通费',
                    prev: 'business_journal'
                },
                controller: 'addTransController'
            })
            /*查看交通费用*/
            .state('view_trans', {
                url: '/view_trans',
                templateUrl: 'views/business_trip_journal/view_trans.html',
                data: {
                    title: '查看交通费',
                    prev: 'business_journal'
                },
                controller: 'viewTransController'
            })

            /*添加住宿费用*/
            .state('add_hotel', {
                url: '/add_hotel',
                templateUrl: 'views/business_trip_journal/add_hotel_fee.html',
                data: {
                    title: '添加住宿费',
                    prev: 'business_journal'
                },
                controller: 'addHotelController'
            })
            /*查看住宿费用*/
            .state('view_hotel', {
                url: '/view_hotel',
                templateUrl: 'views/business_trip_journal/view_hotel.html',
                data: {
                    title: '查看住宿费',
                    prev: 'business_journal'
                },
                controller: 'viewHotelController'
            })

            /*添加其他费*/
            .state('add_other', {
                url: '/add_other',
                templateUrl: 'views/business_trip_journal/add_other_fee.html',
                data: {
                    title: '添加其他费',
                    prev: 'business_journal'
                },
                controller: 'addOtherController'
            })
            /*查看其他费*/
            .state('view_other', {
                url: '/view_other',
                templateUrl: 'views/business_trip_journal/view_other.html',
                data: {
                    title: '查看其他费',
                    prev: 'business_journal'
                },
                controller: 'viewOtherController'
            })
    }

    businessJournalController.$inject = ['$scope', '$ionicPopup', '$http', '$filter', '$ionicLoading', '$ionicScrollDelegate', '$location', '$timeout'];

    function businessJournalController($scope, $ionicPopup, $http, $filter, $ionicLoading, $ionicScrollDelegate, $location, $timeout) {

        //跳转到查看页面
        $scope.goTo = function (item, list) {
            angular.forEach(list, function (val) {
                item.selecter = false;
                if (item.monthDay == val.monthDay) {
                    item.selecter = true;
                }

            })
            $location.path("/view_fee").search({date: item.dataTime});

        }
        $scope.dataList = [];
        $scope.showInfo = false;

        //获取最近的20天的数据
        var i = 3;
        $scope.loadData = function (item) {
            if (!item) {
                item = "";
            }
            i += 3;
            var pageNumber = 3;
            var pageSize = i;
            if (i > 15) {
                $scope.showInfo = true;
                return;
            }

            var searchObj = {pageNumber: pageNumber, pageSize: pageSize, showDate: item};
            $http.get(basePath + "/third/businessjournal/findLatelyTimeAndDate", {params: searchObj}).success(function (data) {
                if (data.status == "0") {
                    //获取时间
                    $scope.dataList = $scope.dataList.concat(data.result);
                    $scope.showDate = $scope.dataList[$scope.dataList.length - 1];
                    $scope.searchDate = $scope.showDate[$scope.showDate.length - 1].dataTime
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }
            });
        }

        //$scope.loadData();


        //动态获取样式

        $scope.getClass = function (item) {
            if (item.dateDay == '[今天]') {
                return 'text-green';
            } else if (item.dateDay == '[昨天]') {
                return 'text-theme';
            } else {
                return 'text-gray';
            }


        }


        //$scope.$on('$stateChangeSuccess', function(item) {
        //    console.log("jjjjjjjjjjjjjjjjjjjjj");
        //    $scope.loadData(2,item);
        //});


    }

    //出差日记账查看费用记录页面控制
    viewFeeController.$inject = ['$scope', '$ionicPopup', '$http', '$filter', '$ionicLoading', '$ionicScrollDelegate', '$location', '$timeout'];

    function viewFeeController($scope, $ionicPopup, $http, $filter, $ionicLoading, $ionicScrollDelegate, $location, $timeout) {
        $scope.compareDate = compareDate;
        //根据数据id和人取查询数据
        $scope.time = $location.search().date;

        //是否显示 添加费用按钮  默认显示
        $scope.showFeiYong = true;

        //获得当前系统日期并查询当前日期数据
        $http.get(basePath + "/third/businessjournal/getOtherFeeDateTime?").success(function (data) {
            if (data.status == 0) {
                $scope.queryDate = data.result[0];//获取当前系统日期
                var editDay = parseInt($scope.compareDate($scope.time, $scope.queryDate));
                if (editDay >= 3) {
                    $scope.showFeiYong = false;
                }
            }
        });
        //是否显示数据
        $scope.showData = false;
        //总共费用
        $scope.countMoney = 0;
        //是否显示点击按钮
        $scope.showClickButton = true;

        var timeList = [];
        if ($scope.time) {
            timeList = $scope.time.split("-");

        } else {
            timeList = $scope.queryDate.split("-");
        }
        $scope.showTime = timeList[1] + "月" + timeList[2] + "日";

        $scope.loadData = function () {
            $http.post(basePath + "/third/businessjournal/findDataByDataIdAndUserId?time=" + $scope.time).success(function (data) {
                if (data.status == "0") {
                    if (data.result != null) {
                        $scope.data = data.result;
                        $scope.showData = true;
                        $scope.countMoney = $scope.data.countMoney;
                    }
                }
            });
        }

        //冒泡提示
        $scope.notifyMsg = function (msg) {
            $ionicLoading.show({
                template: msg
            });
            setTimeout(function () {
                $ionicLoading.hide();
            }, 800);
        }

        //点击按钮显示修改和删除按钮
        $scope.clickButton = function (item) {
            //item.showButton = true;
            var editDay = parseInt($scope.compareDate($scope.time, $scope.queryDate));
            if (parseInt(editDay) < 3) {
                item.showEdit = true;
                item.showClickButton = false;
            }
            var delDay = parseInt($scope.compareDate($scope.time, $scope.queryDate));
            if (parseInt(delDay) < 1) {
                item.showDel = true;
                item.showClickButton = false;
            }
            if (!item.showEdit && !item.showDel) {
                $scope.notifyMsg("该数据不能修改和删除!");
                item.showButton = true;
            }
            $scope.test_1 = item.showButton;

        }
        //点击修改按钮跳转
        $scope.clickEdit = function (item, type) {
            if (type == 0) {
                $location.path("/add_hotel").search({id: item.id, backDate: $scope.time});//酒店费
            }
            if (type == 1) {
                $location.path("/add_trans").search({id: item.id, backDate: $scope.time});//交通费
            }
            if (type == 2) {
                $location.path("/add_other").search({id: item.id, backDate: $scope.time});//其他费
            }

        }
        //点击删除按钮跳转
        //删除记录
        $scope.deleteFun = function (item, index) {
            var confirmPopup = $ionicPopup.confirm({
                title: '提示',
                template: '<h5 class="margin-bottom-0">确定要删除此项费用吗?删除后将无法恢复!',
                buttons: [
                    {
                        text: '取消',
                        type: 'button-theme button-local button-outline'
                    },
                    {
                        text: '确认',
                        type: 'button-theme button-local',
                        onTap: function (e) {
                            $http.post(basePath + "/third/commresource/deleteJSTXAddHotelFee?id=" + item.id + "&index=" + index).success(function (data) {
                                if (data.status == "0") {
                                    window.location.reload();

                                } else {
                                    var alertPopup = $ionicPopup.alert({
                                        title: '删除失败',
                                        template: '<h5 class="margin-bottom-0">data.message</h5>',
                                        buttons: [
                                            {
                                                text: '确定',
                                                type: 'button-theme button-local'

                                            }
                                        ]
                                    });
                                }

                            });

                        }
                    }
                ]
            });


        }
        //查看详细
        $scope.showDetail = function (item, type) {
            if (type == 0) {
                $location.path("/view_hotel").search({id: item.id, backDate: $scope.time});//酒店费
            }
            if (type == 1) {
                $location.path("/view_trans").search({id: item.id, backDate: $scope.time});//交通费
            }
            if (type == 2) {
                $location.path("/view_other").search({id: item.id, backDate: $scope.time});//其他费
            }

        }


        //切换日期
        $scope.nextDay = function (item) {
            if (item == 1) {
                if ($scope.queryDate == $scope.time) {
                    $scope.notifyMsg("已经是最新一天!");
                    return false;
                } else {
                    //获取后一天
                    $scope.time = $scope.dateChange($scope.time, 1);
                    var editDay = parseInt($scope.compareDate($scope.time, $scope.queryDate));
                    if (editDay >= 3) {
                        $scope.showFeiYong = false;
                    } else {
                        $scope.showFeiYong = true;
                    }
                    var timeList = [];
                    timeList = $scope.time.split("-");
                    $scope.showTime = timeList[1] + "月" + timeList[2] + "日";
                    $http.post(basePath + "/third/businessjournal/findDataByDataIdAndUserId?time=" + $scope.time).success(function (data) {
                        if (data.status == "0") {
                            if (data.result != null) {
                                $scope.data = data.result;
                                $scope.showData = true;
                                $scope.countMoney = $scope.data.countMoney;
                            } else {
                                //是否显示数据
                                $scope.showData = false;
                                $scope.countMoney = 0;
                            }
                        }
                    });

                }
            } else {
                //获取前一天
                $scope.time = $scope.dateChange($scope.time, 2);
                var editDay = parseInt($scope.compareDate($scope.time, $scope.queryDate));
                if (editDay >= 3) {
                    $scope.showFeiYong = false;
                } else {
                    $scope.showFeiYong = true;
                }
                var timeList = [];
                timeList = $scope.time.split("-");
                $scope.showTime = timeList[1] + "月" + timeList[2] + "日";
                $http.post(basePath + "/third/businessjournal/findDataByDataIdAndUserId?time=" + $scope.time).success(function (data) {
                    if (data.status == "0") {
                        if (data.result != null) {
                            $scope.data = data.result;
                            $scope.showData = true;
                            $scope.countMoney = $scope.data.countMoney;
                        } else {
                            //是否显示数据
                            $scope.showData = false;
                            $scope.countMoney = 0;
                        }
                    }
                });
            }
            //重新加载数据
            $scope.loadData();

        }

        //按钮控制阻止冒泡
        $scope.goTo = {
            isGoTo: true,
            gotoFun: function (data, item, type) {
                if (this.isGoTo) {
                    if (data == 1) {
                        this.isGoTo = !this.isGoTo;
                        $scope.showDetail(item, type)
                    } else if (data == 2) {
                        this.isGoTo = !this.isGoTo;
                        $scope.clickButton(item);

                    } else if (data == 3) {
                        this.isGoTo = !this.isGoTo;
                        $scope.clickEdit(item, type);

                    } else if (data == 4) {
                        this.isGoTo = !this.isGoTo;
                        $scope.deleteFun(item, type);
                    }
                    setTimeout(function () {
                        $scope.goTo.isGoTo = true;
                    }, 100);

                }
            }
        };

        //返回到主页面
        $scope.goBack = function () {
            $location.path("/business_journal").search({});
        }
        //添加酒店费
        $scope.addTrans = function () {
            $location.path("/add_trans").search({
                id: null,
                backDate: $scope.time,
                date: null,
                showTime: $scope.showTime.replace("月", "-").replace("日", "")
            });

        }

        //添加住宿费
        $scope.addHotel = function () {
            $http.post(basePath + "/third/commresource/findHotelDateAndUserId?date1=" + $scope.time).success(function (data) {
                if (data.status == '0') {
                    $location.path("/add_hotel").search({
                        id: null,
                        backDate: $scope.time,
                        date: null,
                        showTime: $scope.showTime.replace("月", "-").replace("日", "")
                    });
                } else {
                    $scope.showMessage(data.message);

                }
            });


        }
        //添加其他费
        $scope.addOther = function () {
            $location.path("/add_other").search({
                id: null,
                backDate: $scope.time,
                date: null,
                showTime: $scope.showTime.replace("月", "-").replace("日", "")
            });

        }

        //根据两个时间判断返回相差天数
        function compareDate(startDate, endDate) {
            var day = "";
            var arr = startDate.split("-");
            var starttime = new Date(arr[0], arr[1] - 1, arr[2]);
            var starttimes = starttime.getTime();

            var arrs = endDate.split("-");
            var lktime = new Date(arrs[0], arrs[1] - 1, arrs[2]);
            var lktimes = lktime.getTime();
            day = (lktimes - starttimes) / 86400000
            return day;
        }


        //默认加载数据
        $scope.loadData();

        //把时间加一天或者减一天转换
        $scope.dateChange = function (date, type) {
            var translateDate = date.replace("-", "/").replace("-", "/");
            var newDate = new Date(translateDate);
            var nextDate = "";
            if (type == 1) {
                nextDate = new Date(newDate.getTime() + 24 * 60 * 60 * 1000);
            } else {
                nextDate = new Date(newDate.getTime() - 24 * 60 * 60 * 1000);
            }

            var year = nextDate.getFullYear();
            var month = nextDate.getMonth() + 1;
            if (parseInt(month) < 10) {
                month = "0" + month;
            }
            var date = nextDate.getDate();
            if (parseInt(date) < 10) {
                date = "0" + date;
            }
            var time = year + "-" + month + "-" + date;
            return time;
        }

        //修改时提示不允许修改
        $scope.showMessage = function (msg) {
            $ionicLoading.show({
                template: msg
            });
            setTimeout(function () {
                $ionicLoading.hide();
            }, 2000);
        }


    }

    //添加交通费页面控制
    addTransController.$inject = ['$scope', '$ionicPopup', '$http', '$filter', '$ionicLoading', '$ionicScrollDelegate', '$location', 'ynNavigator'];

    function addTransController($scope, $ionicPopup, $http, $filter, $ionicLoading, $ionicScrollDelegate, $location, ynNavigator) {
        $scope.dateBusin = $location.search().backDate;//获得主页面返回的日期数据
        $scope.showTime = $location.search().showTime;//获得主页面返回的日期数据
        $scope.id = $location.search().id;//获得主页面返回的id
        if($scope.id){
            ynNavigator.setNavTitle('修改交通费');
        }

        $scope.backDate = $location.search().backDate;
        var compare = {};//装载比较数据
        $scope.transFeeFun = function () {
            $scope.departArea = {provinceId: -1, cityId: -1, areaId: -1};
            $scope.terminiArea = {provinceId: -1, cityId: -1, areaId: -1};
            $scope.selectModel = {};

            $scope.JSTXAddTransFeeDTO = {
                transDate: "",//初始化日期
                departParentId: "",//出发地省
                departParentName: "",//出发地省Name
                departCityId: "",//出发地市
                departCityName: "",//出发地市Name
                departAreaId: "",//出发地县
                departAreaName: "",//出发地县Name
                depart: "",//出发地字串

                terminiParentId: "",//目的地省
                terminiParentName: "",//目的地省Name
                terminiCityId: "",//目的地市
                terminiCityName: "",//目的地市Name
                terminiAreaId: "",//目的地县
                terminiAreaName: "",//目的地县Name
                termini: "",//目的地县字串
                areaName: "",//所在地区县Name
                vehicle: "",//出行方式CODE
                vehicleName: "",//出行方式code Name
                money: "",//金额
                moneyStr: "",
                message: ""
            };
            compare = angular.copy($scope.JSTXAddTransFeeDTO);//用于比较数据是否修改
        };
        $scope.transFeeFun();//初始化信息
        /**
         * 初始化出行方式 ，出发地，目的地
         * @type {{}}
         */
        //获得出行方式码表值
        $http.get(basePath + "/third/businessjournal/findVehicleCodeTable?").success(function (value) {
            $scope.vehicleCodeData = value;
        });
        //获得今天出差酒店费用信息
        $scope.refreshGrid = function (func) {
            if ($scope.id) {//修改时加载，，，
                //根据id查询数据
                $http.get(basePath + "/third/businessjournal/findJSTXAddTransFeeById?id=" + $scope.id).success(function (data) {
                    if (data.length != 0) {
                        //$scope.totalList = data.result;
                        $scope.JSTXAddTransFeeDTO = data[0];
                        compare = angular.copy($scope.JSTXAddTransFeeDTO);//用于比较数据是否修改
                        /***********数据回填*************/
                        $scope.departArea = {
                            provinceId: $scope.JSTXAddTransFeeDTO.departParentId,
                            cityId: $scope.JSTXAddTransFeeDTO.departCityId,
                            areaId: $scope.JSTXAddTransFeeDTO.departAreaId
                        };
                        $scope.terminiArea = {
                            provinceId: $scope.JSTXAddTransFeeDTO.terminiParentId,
                            cityId: $scope.JSTXAddTransFeeDTO.terminiCityId,
                            areaId: $scope.JSTXAddTransFeeDTO.terminiAreaId
                        };

                        var start = $scope.JSTXAddTransFeeDTO.departParentName + "," + $scope.JSTXAddTransFeeDTO.departCityName;
                        if ($scope.JSTXAddTransFeeDTO.departAreaName != null) {
                            start + "," + $scope.JSTXAddTransFeeDTO.departAreaName;
                        }
                        $scope.departArea.name = start; //出发地区
                        var endName = $scope.JSTXAddTransFeeDTO.terminiParentName + "," + $scope.JSTXAddTransFeeDTO.terminiCityName;
                        if ($scope.JSTXAddTransFeeDTO.terminAreaName != null) {
                            endName + "," + $scope.JSTXAddTransFeeDTO.terminAreaName;
                        }
                        $scope.terminiArea.name = endName;//目的地区
                        $scope.selectModel.dictName = $scope.JSTXAddTransFeeDTO.vehicleName;//交通工具
                    }
                    if (func) {
                        func();
                    }
                }).error(function () {
                    if (func) {
                        func();
                    }
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                });
            } else {
                //获得前天，昨天，今天日期
                $http.get(basePath + "/third/businessjournal/getDateTime?").success(function (value) {
                    $scope.dateTime = value;
                    $scope.dateTimeList = [];//用于不同日期 样式装载
                    for (var i = 0; i < value.length; i++) {
                        var dateTime = {time: "", name: "", check: ""};
                        dateTime.time = value[i].date;//具体日期
                        dateTime.name = (i == 0 ? "前天" : (i == 1 ? "昨天" : "今天(" + value[i].monthDay + ")"))//显示值
                        if (i == value.length - 1) {//初始化赋值样式参数
                            dateTime.check = true;
                        } else {
                            dateTime.check = false;
                        }
                        $scope.dateTimeList.push(dateTime);
                    }
                    ;
                    if ($scope.showTime) {
                        angular.forEach($scope.dateTimeList, function (val) {
                            if (val.time.indexOf($scope.showTime) > -1) {
                                $scope.refresh(val);
                            }
                        });
                    }
                    $scope.transFeeFun();
                    if (func) {
                        func();
                    }
                }).error(function () {
                    if (func) {
                        func();
                    }
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                });
            }

        };
        $scope.refresh = function (item) {//点击查询前天，昨天，今天
            for (var i = 0; i < $scope.dateTimeList.length; i++) {
                if (angular.equals($scope.dateTimeList[i], item)) {
                    $scope.dateTimeList[i].check = true;//动态样式控制
                    if ("前天" == $scope.dateTimeList[i].name || "前天(" + $scope.dateTime[0].monthDay + ")" == $scope.dateTimeList[i].name) {
                        $scope.dateTimeList[0].name = "前天(" + $scope.dateTime[0].monthDay + ")";
                        $scope.dateTimeList[1].name = "昨天";
                        $scope.dateTimeList[2].name = "今天";
                    } else if ("昨天" == $scope.dateTimeList[i].name || "昨天(" + $scope.dateTime[1].monthDay + ")" == $scope.dateTimeList[i].name) {
                        $scope.dateTimeList[0].name = "前天";
                        $scope.dateTimeList[1].name = "昨天(" + $scope.dateTime[1].monthDay + ")";
                        $scope.dateTimeList[2].name = "今天";
                    } else {
                        $scope.dateTimeList[0].name = "前天";
                        $scope.dateTimeList[1].name = "昨天";
                        $scope.dateTimeList[2].name = "今天(" + $scope.dateTime[2].monthDay + ")";
                    }
                } else {
                    $scope.dateTimeList[i].check = false;
                }
            }
        };

        //强制刷新页面
        $scope.refreshEdit = function () {
            $ionicLoading.show({
                template: '正在刷新...'
            });
            $scope.refreshGrid(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };
        //自动加载...............
        $scope.refreshEdit();

        /*
         * 出发地地区选择组件
         */
        $scope.areaDepartSelect = function (item) {
            if (item.length == 3) {
                $scope.JSTXAddTransFeeDTO.departAreaId = item[2].id;
                //取得所选对象
                $scope.departName = item[2].name + "(" + item[1].name + ")";//县（市）
            } else {
                $scope.JSTXAddTransFeeDTO.departAreaId = "";
                $scope.departName = item[1].name + "(" + item[0].name + ")";//直辖市 区（市）
            }
            $scope.JSTXAddTransFeeDTO.departParentId = item[0].id;//省
            $scope.JSTXAddTransFeeDTO.departCityId = item[1].id;//市


        };
        /*
         * 目的地地区选择组件
         */
        $scope.areaTerminiSelect = function (item) {
            //取得所选对象
            if (item.length == 3) {
                $scope.JSTXAddTransFeeDTO.terminiAreaId = item[2].id;//县
                //取得所选对象
                $scope.terminiName = item[2].name + "(" + item[1].name + ")";//县（市）
            } else {
                $scope.JSTXAddTransFeeDTO.terminiAreaId = "";
                $scope.terminiName = item[1].name + "(" + item[0].name + ")";//直辖市 区（市）
            }
            $scope.JSTXAddTransFeeDTO.terminiParentId = item[0].id;//省
            $scope.JSTXAddTransFeeDTO.terminiCityId = item[1].id;//市
        };
        //出发地与目的地切换
        $scope.chooseClick = function () {
            //暂存后者数据
            var temporaryList = {
                name: $scope.terminiArea.name,
                parentId: $scope.JSTXAddTransFeeDTO.terminiParentId,
                cityId: $scope.JSTXAddTransFeeDTO.terminiCityId,
                areaId: $scope.JSTXAddTransFeeDTO.terminiAreaId
            };

            //将前者赋值给后者
            //$scope.terminiArea.name = $scope.departArea.name
            $scope.terminiArea.name = $scope.departArea.name;
            $scope.JSTXAddTransFeeDTO.terminiParentId = $scope.JSTXAddTransFeeDTO.departParentId;//省
            $scope.JSTXAddTransFeeDTO.terminiCityId = $scope.JSTXAddTransFeeDTO.departCityId;//市
            $scope.JSTXAddTransFeeDTO.terminiAreaId = $scope.JSTXAddTransFeeDTO.departAreaId;//县

            //将暂存后者赋值给前者
            $scope.departArea.name = temporaryList.name;
            //$scope.departName = temporaryList.name;
            $scope.JSTXAddTransFeeDTO.departParentId = temporaryList.parentId;//省
            $scope.JSTXAddTransFeeDTO.departCityId = temporaryList.cityId;//市
            $scope.JSTXAddTransFeeDTO.departAreaId = temporaryList.areaId;//县
        };
        //交通工具选择
        $scope.vehicleSelect = function (item) {
            //取得所选对象
            $scope.JSTXAddTransFeeDTO.vehicle = item.dictCode;
        };
        //isBack 保存后是否返回上一级
        $scope.submitData = function (isBack, func) {
            //提交交通费用信息
            $http.post(basePath + "/third/businessjournal/saveJSTXAddTransFee?", $scope.JSTXAddTransFeeDTO).success(function (data) {
                if (func) {
                    func();
                }
                if (data.status == 0) {
                    $ionicLoading.show({
                        template: '提交成功'
                    });
                    setTimeout(function () {
                        $ionicLoading.hide();
                    }, 500);
                    if (isBack == 1) {
                        setTimeout(function () {
                            if ($scope.JSTXAddTransFeeDTO.transDate) {
                                $location.path("/view_fee").search({date: $scope.JSTXAddTransFeeDTO.transDate});
                            } else {
                                $http.post(basePath + "/third/businessjournal/findNowDate").success(function (data) {
                                    if (data.status == "0") {
                                        $location.path("/view_fee").search({date: data.result});
                                    }
                                });
                            }
                        }, 500);
                    } else {
                        $scope.JSTXAddTransFeeDTO.money = 0;
                        $scope.JSTXAddTransFeeDTO.message = "";
                    }
                } else {
                    var alertPopup = $ionicPopup.alert({
                        title: '提交失败',
                        template: '<h5 class="margin-bottom-0">' + data.message + '</h5>',
                        buttons: [
                            {
                                text: '确定',
                                type: 'button-theme button-local'


                            }
                        ]
                    });
                }

            }).error(function () {
                if (func) {
                    func();
                }
                $scope.emptyInfo = true;
                $scope.dataErrorMsg = '加载失败，请重试！';
            });
        };
        //必填验证
        $scope.dateBusinFun = function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '提示',
                template: '<h5 class="margin-bottom-0">' + data + '不能为空!</h5>',
                buttons: [
                    {
                        text: '确定',
                        type: 'button-theme button-local'


                    }
                ]
            });
        };
        //保存数据
        $scope.submit = function (isBack) {
            if (!$scope.id) {
                for (var i = 0; i < $scope.dateTimeList.length; i++) {
                    var date = $scope.dateTimeList[i];
                    if (date.check == true) {
                        $scope.JSTXAddTransFeeDTO.transDate = date.time;//初始化赋值
                    }
                }
            } else {
                $scope.JSTXAddTransFeeDTO.transDate = $scope.dateBusin;
            }
            if ($scope.JSTXAddTransFeeDTO.money > 999999999 || !/^\d*\.?\d{0,2}$/.test($scope.JSTXAddTransFeeDTO.money)) {//验证金额格式，长度（2位小数 && < 9位）
                $scope.notifyMsg("金额只能由小于9位的整数或1到2位小数组成!")
                return false;
            }
            //验证必填效果(费用日期，出行方式，出发地省市县，目的地省市县，金额)
            if (!$scope.JSTXAddTransFeeDTO.money) {
                $scope.notifyMsg("费用金额不能为空!")
                return false;
            }

            if (!$scope.JSTXAddTransFeeDTO.transDate) {
                $scope.notifyMsg("费用日期不能为空!")
                return false;
            }
            if (!$scope.JSTXAddTransFeeDTO.vehicle) {
                $scope.notifyMsg("出行方式不能为空!")
                return false;
            }
            if (!($scope.JSTXAddTransFeeDTO.departParentId && $scope.JSTXAddTransFeeDTO.departCityId)) {
                $scope.notifyMsg("出发地不能为空!")
                return false;
            }
            if (!($scope.JSTXAddTransFeeDTO.terminiParentId && $scope.JSTXAddTransFeeDTO.terminiCityId)) {
                $scope.notifyMsg("目的地不能为空!")
                return false;
            }


            $ionicLoading.show({
                template: '正在提交...'
            });
            $scope.submitData(isBack, function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };

        $scope.notifyMsg = function (msg) {
            $ionicLoading.show({
                template: msg
            });
            setTimeout(function () {
                $ionicLoading.hide();
            }, 800);
        }

        //返回按钮
        $scope.cancel = function () {
            if ($scope.JSTXAddTransFeeDTO.transDate) {
                $location.path("/view_fee").search({date: $scope.JSTXAddTransFeeDTO.transDate});
            } else {
                if ($scope.backDate) {
                    $location.path("/view_fee").search({date: $scope.backDate});
                } else {
                    $http.post(basePath + "/third/businessjournal/findNowDate").success(function (data) {
                        if (data.status == "0") {
                            $location.path("/view_fee").search({date: data.result});
                        }
                    });
                }
            }


        };

        //弹框提示
        $scope.showConfirm = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: '返回提示',
                template: '<h5 class="margin-bottom-0">返回后当前编辑数据将丢失,确定要返回吗?</h5>',
                buttons: [
                    {
                        text: '继续编辑',
                        type: 'button-theme button-local button-outline'
                    },
                    {
                        text: '确定返回',
                        type: 'button-theme button-local',
                        onTap: function (e) {
                            $scope.cancel();
                        }
                    }
                ]
            });
        };
        ynNavigator.registerBackAction(function () {
            $scope.showConfirm();
        }, 101);
        //返回按钮
        $scope.doBack = function () {
            //点击返回编辑过数据 需要提示 您已编辑过内容，是要放弃？
            if (!angular.equals($scope.JSTXAddTransFeeDTO, compare)) {
                $scope.showConfirm();
            } else {
                $scope.cancel();
            }

        };
        //模拟点击事件
        $scope.selectArea = function (index) {
            if (1 == index) {
                angular.element('#departArea').click();
            } else {
                angular.element('#terminiArea').click();
            }
        }

        //修改时提示不允许修改
        $scope.clickDateBusin = function () {
            $ionicLoading.show({
                template: "<p>不允许修改日期！</p>"
            });
            setTimeout(function () {
                $ionicLoading.hide();
            }, 2000);
        }


    }

    //交通费查看页面控制器
    viewTransController.$inject = ['$scope', '$ionicPopup', '$http', '$filter', '$ionicLoading', '$ionicScrollDelegate', '$location', 'ynNavigator'];

    function viewTransController($scope, $ionicPopup, $http, $filter, $ionicLoading, $ionicScrollDelegate, $location, ynNavigator) {

        $scope.compareDate = compareDate;
        $scope.date = $location.search().backDate;//获得主页面返回的日期数据
        $scope.id = $location.search().id;//获得主页面返回的id
        //默认不展示修改和删除按钮
        $scope.showEdit = false;
        $scope.showDel = false;
        //获得当前系统日期并查询当前日期数据
        $http.get(basePath + "/third/businessjournal/getOtherFeeDateTime?").success(function (data) {
            if (data.status == 0) {
                $scope.queryDate = data.result[0];//获取当前系统日期
                var editDay = parseInt($scope.compareDate($scope.date, $scope.queryDate));
                if (parseInt(editDay) < 3) {
                    $scope.showEdit = true;
                }
                var delDay = parseInt($scope.compareDate($scope.date, $scope.queryDate));
                if (parseInt(delDay) < 1) {
                    $scope.showDel = true;
                }
            }
        });

        //获得今天出差酒店费用信息
        $scope.refreshGrid = function (func) {
            $http.get(basePath + "/third/businessjournal/findJSTXAddTransFeeById?id=" + $scope.id).success(function (data) {
                if (data.length != 0) {
                    $scope.trans = data[0];
                }
            })

        };
        $scope.refreshGrid();

        ynNavigator.registerBackAction(function () {
            $scope.goBack();
        },101);


        //返回
        $scope.goBack = function () {
            console.log("交通费返回");
            $location.path("/view_fee").search({date: $scope.date});
            setTimeout(function () {
               $scope.$apply();
            });
        }

        //删除
        $scope.del = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: '提示',
                template: '<h5 class="margin-bottom-0">确定要删除此项费用吗?删除后将无法恢复?</h5>',
                buttons: [
                    {
                        text: '取消',
                        type: 'button-theme button-local button-outline'
                    },
                    {
                        text: '确认',
                        type: 'button-theme button-local',
                        onTap: function (e) {
                            $http.post(basePath + "/third/commresource/deleteJSTXAddHotelFee?id=" + $scope.id + "&index=1").success(function (data) {
                                if (data.status == "0") {
                                    if ($scope.dateBusin) {
                                        $location.path("/view_fee").search({date: $scope.dateBusin});
                                    } else {
                                        $http.post(basePath + "/third/businessjournal/findNowDate").success(function (data) {
                                            if (data.status == "0") {
                                                $location.path("/view_fee").search({date: data.result});
                                            }
                                        });
                                    }
                                } else {
                                    var alertPopup = $ionicPopup.alert({
                                        title: '删除失败',
                                        template: '<h5 class="margin-bottom-0">data.message</h5>',
                                        buttons: [
                                            {
                                                text: '确定',
                                                type: 'button-theme button-local',


                                            }
                                        ]
                                    });
                                }
                            });

                        }


                    }
                ]

            });

        }
        //编辑
        $scope.edit = function () {
            $location.path("/add_trans").search({id: $scope.id, backDate: $scope.date});//交通费
        }

        //加载数据
        $scope.refreshGrid();

        //根据两个时间判断返回相差天数
        function compareDate(startDate, endDate) {
            var day = "";
            var arr = startDate.split("-");
            var starttime = new Date(arr[0], arr[1] - 1, arr[2]);
            var starttimes = starttime.getTime();

            var arrs = endDate.split("-");
            var lktime = new Date(arrs[0], arrs[1] - 1, arrs[2]);
            var lktimes = lktime.getTime();
            day = (lktimes - starttimes) / 86400000
            return day;
        }


    }

    //添加住宿费页面控制
    addHotelController.$inject = ['$scope', '$ionicModal', '$http', '$filter', '$ionicLoading', '$ionicScrollDelegate', "$ionicPopup", "$location", "ynNavigator"];

    function addHotelController($scope, $ionicModal, $http, $filter, $ionicLoading, $ionicScrollDelegate, $ionicPopup, $location, ynNavigator) {
        $scope.indexCount = 0;//计数存在记录条数
        $scope.dateBusin = $location.search().backDate;//获得主页面返回的日期数据
        $scope.backTime = $location.search().backDate;
        $scope.showTime = $location.search().showTime;//获得主页面返回的日期数据
        //数据id
        $scope.id = $location.search().id;
        if($scope.id){
            ynNavigator.setNavTitle('修改住宿费');
        }
        $scope.area = {};
        $scope.hotel = {};
        $scope.selectModel = {};
        $scope.jstxAddHotelFeeDTO = {
            traDate: "",//初始化当前日期
            xzglHotelTraId: "",//出差酒店ID
            xzglHotelTraName: "",//出差酒店Name
            xzglHotelTraCode: "",//出差酒店类型
            xzglHotelTraAddress: "",//出差酒店地址
            provinceId: "",//所在地区省id
            provinceName: "",//所在地区省name
            cityId: "",//所在地区市
            cityName: "",//所在地区市Name
            areaId: "",//所在地区县
            areaName: "",//所在地区县Name
            travelHotelType: "",//房型code
            travelHotelName: "",//房型codeName
            money: ""//金额
        };
        var compare = {};//装载比较数据
        //获得房型码表值
        $http.get(basePath + "/third/businessjournal/findTravelHotRoomTypeCodeTable?").success(function (value) {
            $scope.travelHotelData = value;
        });
        $scope.dateTimeList = [];
        $scope.backDate = $scope.dateBusin;
        //获得今天出差酒店费用信息
        $scope.refreshGrid = function (func) {
            if ($scope.dateBusin && $scope.id) {//修改默认加载数据
                //查询将修改数据
                $http.get(basePath + "/third/businessjournal/findJSTXAddHotelFeeByTime?date1=" + $scope.dateBusin + "&index=0").success(function (data) {
                    if (data.result.length != 0) {
                        $scope.totalList = data.result;
                        $scope.jstxAddHotelFeeDTO = data.result[data.result.length - 1];
                        compare = angular.copy($scope.jstxAddHotelFeeDTO);//用于比较数据是否修改
                        /***********数据回填*************/
                        $scope.area = {
                            provinceId: $scope.jstxAddHotelFeeDTO.provinceId, cityId: $scope.jstxAddHotelFeeDTO.cityId,
                            areaId: $scope.jstxAddHotelFeeDTO.areaId
                        };
                        $scope.area.name = $scope.jstxAddHotelFeeDTO.areaId ? $scope.jstxAddHotelFeeDTO.areaName + "(" + $scope.jstxAddHotelFeeDTO.cityName + ")" :
                            $scope.jstxAddHotelFeeDTO.cityName + "(" + $scope.jstxAddHotelFeeDTO.provinceName + ")";//地区
                        $scope.hotel.name = $scope.jstxAddHotelFeeDTO.xzglHotelTraName;//所住酒店
                        $scope.selectModel.dictName = $scope.jstxAddHotelFeeDTO.travelHotelName;//房型
                    }
                    if (func) {
                        func();
                    }
                }).error(function () {
                    if (func) {
                        func();
                    }
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                });
            } else {
                //获得前天，昨天，今天日期
                $http.get(basePath + "/third/businessjournal/getDateTime?").success(function (value) {
                    $scope.dateTime = value;
                    $scope.dateTimeList = [];//用于不同日期 样式装载
                    for (var i = 0; i < value.length; i++) {
                        var dateTime = {time: "", name: "", check: "", isDis: ""};
                        dateTime.time = value[i].date;//具体日期
                        dateTime.name = (i == 0 ? "前天" : (i == 1 ? "昨天" : "今天(" + value[i].monthDay + ")"))//显示值
                        if (i == value.length - 1) {//初始化赋值样式参数
                            dateTime.check = true;
                        } else {
                            dateTime.check = false;
                        }
                        $scope.dateTimeList.push(dateTime);
                    }
                    ;
                    //动态获得费用日期是否存在记录
                    $http.get(basePath + "/third/businessjournal/findJSTXAddHotelFeeByIsTimeTure?date1=" + $scope.dateTimeList[0].time + "&date2=" + $scope.dateTimeList[1].time
                        + "&date3=" + $scope.dateTimeList[2].time).success(function (data) {
                        $scope.dateStrList = data;
                        //动态获得费用日期是否存在记录 数据处理
                        $scope.indexCount = 0;
                        for (var timeI = 0; timeI < $scope.dateTimeList.length; timeI++) {
                            var dateTimeIsStr = $scope.dateTimeList[timeI], dateIsStr = $scope.dateStrList[timeI];
                            if (dateIsStr == "0") {
                                dateTimeIsStr.isDis = false;
                            } else {
                                $scope.indexCount += 1;//计数存在记录条数
                                dateTimeIsStr.isDis = true;
                            }
                        }
                        /*************************动态日期样式监听********************/
                        var is = 0, os = 0, ds = 0;
                        for (var i = 0; i < $scope.dateTimeList.length; i++) {
                            var y = $scope.dateTimeList[i];
                            if (y.isDis == true) {
                                y.check = false;
                                if (i == 0) is++;
                                if (i == 1) os++;
                                if (i == 2) {
                                    y.name = "今天";
                                    ds++;
                                }
                            }
                        }
                        if (ds == 0) {
                        } else if (os == 0) {
                            $scope.dateTimeList[1].check = true;
                            $scope.dateTimeList[1].name = "昨天(" + $scope.dateTime[1].monthDay + ")";
                        } else if (is == 0) {
                            $scope.dateTimeList[0].check = true;
                            $scope.dateTimeList[0].name = "前天(" + $scope.dateTime[0].monthDay + ")";
                        }
                        //if($scope.showTime){
                        //    angular.forEach($scope.dateTimeList,function(val){
                        //        if(val.time.indexOf($scope.showTime)>-1){
                        //            $scope.refresh(val);
                        //        }
                        //    });
                        //}
                        if (func) {
                            func();
                        }
                    }).error(function () {
                        if (func) {
                            func();
                        }
                        $scope.emptyInfo = true;
                        $scope.dataErrorMsg = '加载失败，请重试！';
                    });

                    //查询展示最新一条数据
                    $http.get(basePath + "/third/businessjournal/findJSTXAddHotelFeeByTime?date1=" + $scope.dateTimeList[0].time + "&date2=" + $scope.dateTimeList[1].time
                        + "&date3=" + $scope.dateTimeList[2].time + "&index=1").success(function (data) {
                        if (data.result.length != 0) {
                            $scope.totalList = data.result;
                            $scope.jstxAddHotelFeeDTO = data.result[data.result.length - 1];
                            compare = angular.copy($scope.jstxAddHotelFeeDTO);//用于比较数据是否修改
                            /***********数据回填*************/
                            $scope.area = {
                                provinceId: $scope.jstxAddHotelFeeDTO.provinceId,
                                cityId: $scope.jstxAddHotelFeeDTO.cityId,
                                areaId: $scope.jstxAddHotelFeeDTO.areaId
                            };
                            $scope.area.name = $scope.jstxAddHotelFeeDTO.areaId ? $scope.jstxAddHotelFeeDTO.areaName + "(" + $scope.jstxAddHotelFeeDTO.cityName + ")" :
                                $scope.jstxAddHotelFeeDTO.cityName + "(" + $scope.jstxAddHotelFeeDTO.provinceName + ")";//地区
                            $scope.hotel.name = $scope.jstxAddHotelFeeDTO.xzglHotelTraName;//所住酒店
                            $scope.selectModel.dictName = $scope.jstxAddHotelFeeDTO.travelHotelName;//房型
                        }
                        if (func) {
                            func();
                        }
                    }).error(function () {
                        if (func) {
                            func();
                        }
                        $scope.emptyInfo = true;
                        $scope.dataErrorMsg = '加载失败，请重试！';
                    });
                });
            }

        };

        $scope.refresh = function (item) {//点击查询前天，昨天，今天
            if (item.isDis == true) {
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: '<h5 class="margin-bottom-0">' + item.name + '已有酒店费用记录,不能再添加！</h5>',
                    buttons: [
                        {
                            text: '确认',
                            type: 'button-theme button-local'

                        }
                    ]
                });
            } else {
                for (var i = 0; i < $scope.dateTimeList.length; i++) {
                    if (angular.equals($scope.dateTimeList[i], item)) {
                        $scope.dateTimeList[i].check = true;//动态样式控制
                        if ("前天" == $scope.dateTimeList[i].name || "前天(" + $scope.dateTime[0].monthDay + ")" == $scope.dateTimeList[i].name) {
                            $scope.dateTimeList[0].name = "前天(" + $scope.dateTime[0].monthDay + ")";
                            $scope.dateTimeList[1].name = "昨天";
                            $scope.dateTimeList[2].name = "今天";
                        } else if ("昨天" == $scope.dateTimeList[i].name || "昨天(" + $scope.dateTime[1].monthDay + ")" == $scope.dateTimeList[i].name) {
                            $scope.dateTimeList[0].name = "前天";
                            $scope.dateTimeList[1].name = "昨天(" + $scope.dateTime[1].monthDay + ")";
                            $scope.dateTimeList[2].name = "今天";
                        } else {
                            $scope.dateTimeList[0].name = "前天";
                            $scope.dateTimeList[1].name = "昨天";
                            $scope.dateTimeList[2].name = "今天(" + $scope.dateTime[2].monthDay + ")";
                        }
                    } else {
                        $scope.dateTimeList[i].check = false;
                    }
                }
            }
        };

        //强制刷新页面
        $scope.refreshEdit = function () {
            $ionicLoading.show({
                template: '正在刷新...'
            });
            $scope.refreshGrid(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };
        //自动加载...............
        $scope.refreshEdit();
        /*
         * 地区选择组件
         */
        $scope.areaSelect = function (item) {
            //取得所选对象
            $scope.jstxAddHotelFeeDTO.provinceId = item[0].id;//省
            $scope.jstxAddHotelFeeDTO.cityId = item[1].id;//市
            if (item.length > 2) {
                $scope.jstxAddHotelFeeDTO.areaId = item[2].id;//县
            } else {
                $scope.jstxAddHotelFeeDTO.areaId = "";
            }
            $scope.area.name = item.length > 2 ? item[2].name + "(" + item[1].name + ")" :
                item[1].name + "(" + item[0].name + ")";//地区
        };
        /*
         * 酒店选择组件
         */
        $scope.hotelSelect = function (item) {
            $scope.jstxAddHotelFeeDTO.provinceId = item.provinceId;//省
            $scope.jstxAddHotelFeeDTO.cityId = item.cityId;//市
            $scope.jstxAddHotelFeeDTO.areaId = item.areaId;//县
            $scope.area.name = item.area;
            //取得所选对象
            $scope.jstxAddHotelFeeDTO.xzglHotelTraId = item.id;
            $scope.jstxAddHotelFeeDTO.xzglHotelTraName = item.name;
            $scope.jstxAddHotelFeeDTO.xzglHotelTraAddress = item.address;
            //酒店类型
            $scope.jstxAddHotelFeeDTO.xzglHotelTraCode = item.hotelTypeCode;
        };
        //房型选择
        $scope.diySelect = function (item) {
            //房型
            $scope.jstxAddHotelFeeDTO.travelHotelType = item.dictCode;
        };
        //isBack 保存后是否返回上一级
        $scope.submitData = function (isBack, func) {
            //提交酒店费用信息
            $http.post(basePath + "/third/businessjournal/saveJSTXAddHotelFee?", $scope.jstxAddHotelFeeDTO).success(function (data) {
                if (func) {
                    func();
                }
                if (data.status == "0") {
                    $ionicLoading.show({
                        template: '提交成功'
                    });
                    setTimeout(function () {
                        $ionicLoading.hide();
                    }, 500);
                    if (isBack == 1) {
                        setTimeout(function () {
                            if ($scope.jstxAddHotelFeeDTO.traDate) {
                                $location.path("/view_fee").search({date: $scope.jstxAddHotelFeeDTO.traDate});
                            } else {
                                $http.post(basePath + "/third/businessjournal/findNowDate").success(function (data) {
                                    if (data.status == "0") {
                                        $location.path("/view_fee").search({date: data.result});
                                    }
                                });
                            }


                        }, 500);
                    } else {
                        $scope.refreshEdit();//刷新
                    }
                } else {
                    var alertPopup = $ionicPopup.alert({
                        title: '提交失败',
                        template: '<h5 class="margin-bottom-0">' + data.message + '</h5>',
                        buttons: [
                            {
                                text: '确认',
                                type: 'button-theme button-local'

                            }
                        ]
                    });
                }

            }).error(function () {
                if (func) {
                    func();
                }
                $scope.emptyInfo = true;
                $scope.dataErrorMsg = '加载失败，请重试！';
            });
        };
        //必填验证
        $scope.dateBusinFun = function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '提示',
                template: '<h5 class="margin-bottom-0">' + data + '不能为空!</h5>',
                buttons: [
                    {
                        text: '确认',
                        type: 'button-theme button-local'

                    }
                ]

            });
        };
        //保存数据
        $scope.submit = function (isBack) {
            if (!$scope.id) {//添加时获得选择日期
                for (var i = 0; i < $scope.dateTimeList.length; i++) {
                    var date = $scope.dateTimeList[i];
                    if (date.check == true) {
                        $scope.jstxAddHotelFeeDTO.traDate = date.time;//初始化赋值
                    }
                }
            } else {
                $scope.jstxAddHotelFeeDTO.traDate = $scope.dateBusin;//修改时赋值
            }
            if ($scope.jstxAddHotelFeeDTO.money > 999999999 || !/^\d*\.?\d{0,2}$/.test($scope.jstxAddHotelFeeDTO.money)) {//验证金额格式，长度（2位小数 && < 9位）
                $scope.notifyMsg("金额只能由小于9位的整数或1到2位小数组成!")
                return false;
            }
            //验证必填效果(地区，酒店，省市县，房型，金额)
            if (!$scope.jstxAddHotelFeeDTO.money) {
                $scope.notifyMsg("金额不能为空!")
                return false;
            }
            if (!$scope.jstxAddHotelFeeDTO.traDate) {
                $scope.notifyMsg("费用日期不能为空!")
                return false;
            }
            if (!($scope.jstxAddHotelFeeDTO.provinceId && $scope.jstxAddHotelFeeDTO.cityId)) {
                $scope.notifyMsg("所在地区不能为空!")
                return false;
            }
            if (!$scope.jstxAddHotelFeeDTO.xzglHotelTraName) {
                $scope.notifyMsg("所住酒店不能为空!")
                return false;
            }
            if (!$scope.jstxAddHotelFeeDTO.travelHotelType) {
                $scope.notifyMsg("房型不能为空!")
                return false;
            }
            $ionicLoading.show({
                template: '正在提交...'
            });
            $scope.submitData(isBack, function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };

        //冒泡提示
        $scope.notifyMsg = function (msg) {
            $ionicLoading.show({
                template: msg
            });
            setTimeout(function () {
                $ionicLoading.hide();
            }, 800);
        }
        //返回
        $scope.cancel = function () {
            if ($scope.jstxAddHotelFeeDTO.traDate) {
                $location.path("/view_fee").search({date: $scope.jstxAddHotelFeeDTO.traDate});
            } else {
                if ($scope.backTime) {
                    $location.path("/view_fee").search({date: $scope.backTime});
                } else {
                    $http.post(basePath + "/third/businessjournal/findNowDate").success(function (data) {
                        if (data.status == "0") {
                            $location.path("/view_fee").search({date: data.result});
                        }
                    });
                }
            }

        };
        $scope.showConfirm = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: '返回提示',
                template: '<h5 class="margin-bottom-0">返回后当前编辑数据将丢失,确定要返回吗？</h5>',
                buttons: [
                    {
                        text: '继续编辑',
                        type: 'button-outline button-theme button-local'
                    },
                    {
                        text: '确定返回',
                        type: 'button-theme button-local',
                        onTap: function (e) {
                            $scope.cancel();
                        }
                    }
                ]

            });
        };
        ynNavigator.registerBackAction(function () {
            $scope.showConfirm();
        }, 101);
        //返回按钮
        $scope.doBack = function () {
            //点击返回编辑过数据 需要提示 您已编辑过内容，是要放弃？
            if (!angular.equals($scope.jstxAddHotelFeeDTO, compare)) {
                $scope.showConfirm();
            } else {
                $scope.cancel();
            }
        };
        //模拟点击事件
        $scope.selectArea = function () {
            angular.element('#area').click();
        };
        //修改时提示不允许修改
        $scope.clickDateBusin = function () {
            $ionicLoading.show({
                template: "不允许修改日期！"
            });
            setTimeout(function () {
                $ionicLoading.hide();
            }, 2000);
        }

    }

    //住宿费查看页面控制器
    viewHotelController.$inject = ['$scope', '$ionicModal', '$http', '$filter', '$ionicLoading', '$ionicScrollDelegate', "$ionicPopup", "$location", "ynNavigator"];

    function viewHotelController($scope, $ionicModal, $http, $filter, $ionicLoading, $ionicScrollDelegate, $ionicPopup, $location, ynNavigator) {
        $scope.compareDate = compareDate;

        $scope.dateBusin = $location.search().backDate;//获得主页面返回的日期数据
        $scope.id = $location.search().id;//获得主页面返回的id
        //默认不展示修改和删除按钮
        $scope.showEdit = false;
        $scope.showDel = false;
        //获得当前系统日期并查询当前日期数据
        $http.get(basePath + "/third/businessjournal/getOtherFeeDateTime?").success(function (data) {
            if (data.status == 0) {
                $scope.queryDate = data.result[0];//获取当前系统日期
                var editDay = parseInt($scope.compareDate($scope.dateBusin, $scope.queryDate));
                if (parseInt(editDay) < 3) {
                    $scope.showEdit = true;
                }
                var delDay = parseInt($scope.compareDate($scope.dateBusin, $scope.queryDate));
                if (parseInt(delDay) < 1) {
                    $scope.showDel = true;
                }
            }
        });

        //查询将修改数据
        $scope.refresh = function () {
            $http.get(basePath + "/third/businessjournal/findJSTXAddHotelFeeByTime?date1=" + $scope.dateBusin + "&index=0").success(function (data) {
                if (data.result.length != 0) {
                    $scope.showData = data.result[0];
                    if ($scope.showData.provinceName && $scope.showData.cityName) {
                        $scope.areaName = $scope.showData.provinceName + $scope.showData.cityName;
                    }
                }
            })
        }
        ynNavigator.registerBackAction(function () {
            $scope.goBack();
        },101);
        //返回数据
        $scope.goBack = function () {
            $location.path("/view_fee").search({date: $scope.dateBusin});
            setTimeout(function () {
                $scope.$apply();
            });
        }
        //删除
        $scope.del = function (item, index) {
            var confirmPopup = $ionicPopup.confirm({
                title: '提示',
                template: '<h5 class="margin-bottom-0">确定要删除此项费用吗?删除后将无法恢复?</h5>',
                buttons: [
                    {
                        text: '取消',
                        type: 'button-theme button-local button-outline'
                    },
                    {
                        text: '确认',
                        type: 'button-theme button-local',
                        onTap: function (e) {
                            $http.post(basePath + "/third/commresource/deleteJSTXAddHotelFee?id=" + item.id + "&index=" + index).success(function (data) {
                                if (data.status == "0") {
                                    if ($scope.dateBusin) {
                                        $location.path("/view_fee").search({date: $scope.dateBusin});
                                    } else {
                                        $http.post(basePath + "/third/businessjournal/findNowDate").success(function (data) {
                                            if (data.status == "0") {
                                                $location.path("/view_fee").search({date: data.result});
                                            }
                                        });
                                    }
                                } else {
                                    var alertPopup = $ionicPopup.alert({
                                        title: '删除失败',
                                        template: '<h5 class="margin-bottom-0">data.message</h5>',
                                        buttons: [
                                            {
                                                text: '确定',
                                                type: 'button-theme button-local',

                                            }
                                        ]
                                    });
                                }
                            });
                        }


                    }
                ]

            });


        }
        //修改
        $scope.edit = function () {
            $location.path("/add_hotel").search({backDate: $scope.dateBusin, id: $scope.id});//酒店费

        }
        //加载数据
        $scope.refresh();

        //根据两个时间判断返回相差天数
        function compareDate(startDate, endDate) {
            var day = "";
            var arr = startDate.split("-");
            var starttime = new Date(arr[0], arr[1] - 1, arr[2]);
            var starttimes = starttime.getTime();

            var arrs = endDate.split("-");
            var lktime = new Date(arrs[0], arrs[1] - 1, arrs[2]);
            var lktimes = lktime.getTime();
            day = (lktimes - starttimes) / 86400000
            return day;
        }

    }

    //添加其他费用页面控制
    addOtherController.$inject = ['$scope', '$ionicPopup', '$http', '$filter', '$ionicLoading', '$ionicScrollDelegate', '$location', 'ynNavigator'];

    function addOtherController($scope, $ionicPopup, $http, $filter, $ionicLoading, $ionicScrollDelegate, $location, ynNavigator) {
        $scope.initData = function () {
            $scope.otherFeeInfo = {
                money: "",//金额
                feeReason: "",//费用事由
                feeSpendDate: ""//费用发生日期
            };
            $scope.today = {};//今天时间
            $scope.yesterday = {};//昨天时间‘
            $scope.anteayer = {};//前天时间
            $scope.selectedDate = "today";//默认选中当前时间
        };
        $scope.backDate = $location.search().backDate;
        $scope.dateBusin = $location.search().backDate;//获得主页面返回的日期数据
        $scope.showTime = $location.search().showTime;//获得主页面返回的日期数据
        $scope.id = $location.search().id;
        if($scope.id){
            ynNavigator.setNavTitle('修改其他费');
        }
        if ($scope.id) {
            $http.post(basePath + "/third/businessjournal/findDataById?id=" + $scope.id).success(function (data) {
                if (data.status == "0") {
                    $scope.otherFeeInfo = data.result;
                }
            })
        }
        $scope.initData();

        $scope.changSelectedDate = function (str) {
            $scope.selectedDate = str;//改变选中的费用日期
            $scope.today.showStr = "今天";
            $scope.yesterday.showStr = "昨天";
            $scope.anteayer.showStr = "前天";
            if ($scope.selectedDate == "today") {
                $scope.today.showStr = "今天(" + $scope.today.showDateStr + ")";
            }
            if ($scope.selectedDate == "yesterday") {
                $scope.yesterday.showStr = "昨天(" + $scope.yesterday.showDateStr + ")";
            }
            if ($scope.selectedDate == "anteayer") {
                $scope.anteayer.showStr = "前天(" + $scope.anteayer.showDateStr + ")";
            }
            setTimeout(function () {
                $scope.$apply();
            })

        };
        $scope.getShowDateStr = function (dateStr) {
            var str = dateStr.split("-");
            return str[1] + "/" + str[2];
        };
        $scope.getDate = function (func) {
            //获取最近3天日期
            $http.get(basePath + "/third/businessjournal/getOtherFeeDateTime?").success(function (data) {
                if (data.status == 0) {
                    $scope.today = {
                        dateStr: data.result[0],
                        showDateStr: $scope.getShowDateStr(data.result[0]),
                        showStr: "今天(" + $scope.getShowDateStr(data.result[0]) + ")"
                    };
                    $scope.yesterday = {
                        dateStr: data.result[1],
                        showDateStr: $scope.getShowDateStr(data.result[1]),
                        showStr: "昨天"
                    };
                    $scope.anteayer = {
                        dateStr: data.result[2],
                        showDateStr: $scope.getShowDateStr(data.result[2]),
                        showStr: "前天"
                    }
                }
                if ($scope.showTime) {
                    if ($scope.today.dateStr.indexOf($scope.showTime) > -1) {
                        $scope.changSelectedDate("today");
                    }
                    if ($scope.yesterday.dateStr.indexOf($scope.showTime) > -1) {
                        $scope.changSelectedDate("yesterday");
                    }
                    if ($scope.anteayer.dateStr.indexOf($scope.showTime) > -1) {
                        $scope.changSelectedDate("anteayer");
                    }
                }
                if (func) {
                    func();
                }
            }).error(function () {
                if (func) {
                    func();
                }
                $scope.emptyInfo = true;
                $scope.dataErrorMsg = '加载失败，请重试！';
            });
        };

        $scope.doRefresh = function () {
            $ionicLoading.show({
                template: '正在刷新...'
            });
            $scope.initData();
            $scope.getDate(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };
        $scope.doRefresh();
        //isBack 保存后是否返回上一级
        $scope.submitData = function (isBack, func) {

            $http.post(basePath + "/third/businessjournal/saveJSTXOtherFee?", $scope.otherFeeInfo).success(function (data) {
                if (func) {
                    func();
                }
                if (data.status == 0) {
                    $ionicLoading.show({
                        template: '提交成功'
                    });
                    setTimeout(function () {
                        $ionicLoading.hide();
                    }, 500);
                    if (isBack) {
                        setTimeout(function () {
                            if ($scope.otherFeeInfo.feeSpendDate) {
                                $location.path("/view_fee").search({date: $scope.otherFeeInfo.feeSpendDate});
                            } else {
                                $http.post(basePath + "/third/businessjournal/findNowDate").success(function (data) {
                                    if (data.status == "0") {
                                        $location.path("/view_fee").search({date: data.result});
                                    }
                                });
                            }

                        }, 500);
                    } else {
                        $scope.otherFeeInfo.money = 0;
                        $scope.otherFeeInfo.feeReason = "";
                    }
                } else {
                    var alertPopup = $ionicPopup.alert({
                        title: "提交失败",
                        template: '<h5 class="margin-bottom-0">' + data.message + '</h5>',
                        buttons: [
                            {
                                text: '确定',
                                type: 'button-theme button-local'

                            }
                        ]
                    });
                }

            }).error(function () {
                if (func) {
                    func();
                }
                $ionicLoading.show({
                    template: '提交失败，请重试！'
                });
                setTimeout(function () {
                    $ionicLoading.hide();
                }, 1500);
            });
        };
        $scope.submit = function (isBack) {
            if ($scope.otherFeeInfo.money > 999999999 || !/^\d*\.?\d{0,2}$/.test($scope.otherFeeInfo.money)) {//验证金额格式，长度（2位小数 && < 9位）
                var alertPopup = $ionicPopup.alert({
                    title: "提交失败",
                    template: '<h5 class="margin-bottom-0">金额只能由小于9位的整数或1到2位小数组成!</h5>',
                    buttons: [
                        {
                            text: '确定',
                            type: 'button-theme button-local'

                        }
                    ]
                });
                return false;
            }
            if ($scope.id) {
                $scope.otherFeeInfo.feeSpendDate = $scope.dateBusin
            } else {
                if ($scope.selectedDate == "today") {
                    $scope.otherFeeInfo.feeSpendDate = $scope.today.dateStr;
                } else if ($scope.selectedDate == "yesterday") {
                    $scope.otherFeeInfo.feeSpendDate = $scope.yesterday.dateStr;
                } else if ($scope.selectedDate == "anteayer") {
                    $scope.otherFeeInfo.feeSpendDate = $scope.anteayer.dateStr;
                }
            }

            $ionicLoading.show({
                template: '正在提交...'
            });
            $scope.submitData(isBack, function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };
        //返回按钮
        $scope.cancel = function () {
            if ($scope.otherFeeInfo.feeSpendDate) {
                $location.path("/view_fee").search({date: $scope.otherFeeInfo.feeSpendDate});
            } else {
                if ($scope.backDate) {
                    $location.path("/view_fee").search({date: $scope.backDate});
                } else {
                    $http.post(basePath + "/third/businessjournal/findNowDate").success(function (data) {
                        if (data.status == "0") {
                            $location.path("/view_fee").search({date: data.result});
                        }
                    });
                }
            }

        };
        $scope.showConfirm = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: "返回提示",
                template: '<h5 class="margin-bottom-0">返回后当前编辑数据将丢失,确定要返回吗?</h5>',
                buttons: [
                    {
                        text: '继续编辑',
                        type: 'button-theme button-local button-outline'
                    },
                    {
                        text: '确定返回',
                        type: 'button-theme button-local',
                        onTap: function (e) {
                            $scope.cancel();
                        }
                    }
                ]
            });
        }
        ynNavigator.registerBackAction(function () {
            $scope.showConfirm();
        }, 101);
        //返回按钮
        $scope.doBack = function () {
            //点击返回编辑过数据 需要提示 您已编辑过内容，是要放弃？
            if ($scope.otherFeeInfo.money != 0 || $scope.selectedDate != "today" || $scope.otherFeeInfo.feeReason) {
                $scope.showConfirm();
            } else {
                $scope.cancel();
            }

        }

        //修改时提示不允许修改
        $scope.clickDateBusin = function () {
            $ionicLoading.show({
                template: "<p>不允许修改日期！</p>"
            });
            setTimeout(function () {
                $ionicLoading.hide();
            }, 2000);

        }


    }

    //其他费用查看控制器
    viewOtherController.$inject = ['$scope', '$ionicPopup', '$http', '$filter', '$ionicLoading', '$ionicScrollDelegate', '$location', 'ynNavigator'];

    function viewOtherController($scope, $ionicPopup, $http, $filter, $ionicLoading, $ionicScrollDelegate, $location, ynNavigator) {
        $scope.compareDate = compareDate;
        //时间和id
        $scope.date = $location.search().backDate;//获得主页面返回的日期数据
        $scope.id = $location.search().id;

        //默认不展示修改和删除按钮
        $scope.showEdit = false;
        $scope.showDel = false;
        //获得当前系统日期并查询当前日期数据
        $http.get(basePath + "/third/businessjournal/getOtherFeeDateTime?").success(function (data) {
            if (data.status == 0) {
                $scope.queryDate = data.result[0];//获取当前系统日期
                var editDay = parseInt($scope.compareDate($scope.date, $scope.queryDate));
                if (parseInt(editDay) < 3) {
                    $scope.showEdit = true;
                }
                var delDay = parseInt($scope.compareDate($scope.date, $scope.queryDate));
                if (parseInt(delDay) < 1) {
                    $scope.showDel = true;
                }
            }
        });
        //加载数据
        $scope.refresh = function () {
            $http.post(basePath + "/third/businessjournal/findDataById?id=" + $scope.id).success(function (data) {
                if (data.status == "0") {
                    $scope.other = data.result;
                }
            })
        }
        ynNavigator.registerBackAction(function () {
            $scope.goBack();
        },101);


        //返回
        $scope.goBack = function () {
            $location.path("/view_fee").search({date: $scope.date});
            setTimeout(function () {
                $scope.$apply();
            });
        }

        //删除
        $scope.del = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: '提示',
                template: '<h5 class="margin-bottom-0">确定要删除此项费用吗?删除后将无法恢复?</h5>',
                buttons: [
                    {
                        text: '取消',
                        type: 'button-theme button-local button-outline'
                    },
                    {
                        text: '确认',
                        type: 'button-theme button-local',
                        onTap: function (e) {
                            $http.post(basePath + "/third/commresource/deleteJSTXAddHotelFee?id=" + $scope.id + "&index=2").success(function (data) {
                                if (data.status == "0") {
                                    if ($scope.dateBusin) {
                                        $location.path("/view_fee").search({date: $scope.dateBusin});
                                    } else {
                                        $http.post(basePath + "/third/businessjournal/findNowDate").success(function (data) {
                                            if (data.status == "0") {
                                                $location.path("/view_fee").search({date: data.result});
                                            }
                                        });
                                    }
                                } else {
                                    var alertPopup = $ionicPopup.alert({
                                        title: '删除失败',
                                        template: '<h5 class="margin-bottom-0">data.message</h5>',
                                        buttons: [
                                            {
                                                text: '确定',
                                                type: 'button-theme button-local'
                                            }
                                        ]

                                    });
                                }
                            });
                        }


                    }
                ]

            });

        }
        //编辑
        $scope.edit = function () {
            $location.path("/add_other").search({id: $scope.id, backDate: $scope.date});//其他费
        }

        //加载数据
        $scope.refresh();

        //根据两个时间判断返回相差天数
        function compareDate(startDate, endDate) {
            var day = "";
            var arr = startDate.split("-");
            var starttime = new Date(arr[0], arr[1] - 1, arr[2]);
            var starttimes = starttime.getTime();

            var arrs = endDate.split("-");
            var lktime = new Date(arrs[0], arrs[1] - 1, arrs[2]);
            var lktimes = lktime.getTime();
            day = (lktimes - starttimes) / 86400000
            return day;
        }


    }


})();
