/**
 * 此文件只用作提供给开发人员在开发调试APP端应用时的快捷入口使用，正式入口文件为app.js
 * @author wangl
 * @date 2020-04-10
 * @type {string}
 */
var originBaseUrl = '';
var localhost = 'http://localhost:8080/ynedut';
angular.module('starter', ['ionic', 'ngCordova', 'ksSwiper', 'staticModule'])
    .run(function ($ionicPlatform, $rootScope, $location, $http) {

        $ionicPlatform.ready(function () {
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);
            }
            if (window.StatusBar) {
                StatusBar.styleLightContent();
            }
            if (!ionic.Platform.isAndroid()) {
                ionic.Platform.fullScreen(true, true);
            }
        });
        originBaseUrl = $rootScope.originBaseUrl = getBasePath();
        $rootScope.authorizationStr = {
            'access_token': null,
            'userId': null,
            'userType': null
        };
        $.ajax({
            url: localhost+'/homepage/queryForLoginInfoFactory.htm?isApp=true',
            cache: false,
            async: false,
            type: "POST",
            dataType: 'json',
            success: function (data) {
                if (data.status == 0) {
                    var userId=data.result.platformSysUserVO.id;
                    var userType=data.result.platformSysUserVO.userType;
                    var client_secret=data.result.client_secret;
                    var url=localhost+'/oauth/token.htm?produce_code=00&terminal_code=00&client_secret='+client_secret+"&token_type=2&client_id="+userId;
                    console.log(url);
                    $.ajax({
                        url: url,
                        cache: false,
                        async: false,
                        type: "POST",
                        dataType: 'json',
                        success: function (data) {
                            $rootScope.authorizationStr.access_token = data.access_token;
                            $rootScope.authorizationStr.userType =userType;
                            $rootScope.authorizationStr.userId =userId ;
                            if (window && window.localStorage) {
                                window.localStorage.setItem("authorizationStr", JSON.stringify($rootScope.authorizationStr));
                                window.localStorage.setItem("originBaseUrl", JSON.stringify($rootScope.originBaseUrl));
                            }
                        }
                    });
                }
            }
        });

    })
    //路由配置
    .config(function ($stateProvider, $ionicConfigProvider, $urlRouterProvider) {

        // $ionicConfigProvider.scrolling.jsScrolling(true);/*这句处理android滚动异常问题*/

        $ionicConfigProvider.templates.maxPrefetch(0);
        $ionicConfigProvider.views.maxCache(0);
        $stateProvider
            //test
            .state('demo', {
                url: '/demo',
                templateUrl: 'templates/demo/demo.html'
            })
            //选人点名
            .state('attendance_people', {

                url: '/attendance_people',
                templateUrl: 'templates/attendance/attendance_people.html'
            })
            //课堂考勤（学生访问）
            .state('attendance_student', {

                url: '/attendance_student',
                templateUrl: 'templates/attendance/attendance_student.html'
            })
            //查看通知公告
            .state('appViewNotice', {

                url: '/appViewNotice',
                templateUrl: 'templates/message/appViewNotice.html'
            })
            //班级情况统计
            .state('class_statistics', {

                url: '/class_statistics',
                templateUrl: 'templates/classSituation/class_statistics.html'
            })
            //班级情况统计 应到学生
            .state('class_ydStudent', {

                url: '/class_ydStudent',
                templateUrl: 'templates/classSituation/class_ydStudent.html'
            })
            //班级情况统计 处分学生
            .state('class_punishStudent', {

                url: '/class_punishStudent',
                templateUrl: 'templates/classSituation/class_punishStudent.html'
            })
            //班级情况统计 请假学生
            .state('class_leaveStudent', {

                url: '/class_leaveStudent',
                templateUrl: 'templates/classSituation/class_leaveStudent.html'
            })
            //课堂考勤统计
            .state('ktkq_atistics', {

                url: '/ktkq_atistics',
                templateUrl: 'templates/classSituation/ktkq_tatistics.html'
            })
            //课堂考勤统计 学生详情
            .state('ktkq_student', {
                url: '/ktkq_student',
                templateUrl: 'templates/classSituation/ktkq_student.html'
            })
            /*************************************移动端选课start**********************************************************/
            //=====选课
            .state('choose_lessons', {
                url: '/choose_lessons',
                templateUrl: 'templates/choose_lessons/choose_lessons.html'
            })
            .state('choose_lessons_detail', {
                url: '/choose_lessons_detail',
                templateUrl: 'templates/choose_lessons/choose_lessons_detail.html'
            })
            /*************************************移动端选课end**********************************************************/
            //班级寝室统计
            .state('dormitory_list', {
                url: '/dormitory_list',
                templateUrl: 'templates/class_dormitory_statistics/dormitory_list.html'
            })

            // 入口
            .state('entry', {
                url: '/entry',
                templateUrl: 'entry.html'
            })
        $urlRouterProvider.otherwise('/entry');
    })
    .config(function ($httpProvider, $provide) {

        $httpProvider.defaults.headers.put['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
        $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
        //全局拦截器
        $httpProvider.interceptors.push('globalHttpInterceptor');

        var param = function (obj) {
            var query = "", name, value, fullSubName, subName, subValue, innerObj, i;
            for (name in obj) {
                value = obj[name];
                if (value instanceof Array) {
                    for (i = 0; i < value.length; ++i) {
                        subValue = value[i];
                        fullSubName = name;
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                } else if (value instanceof Object) {
                    for (subName in value) {
                        subValue = value[subName];
                        fullSubName = name + "[" + subName + "]";
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + "&";
                    }
                } else if (value !== undefined && value !== null) {
                    query += encodeURIComponent(name) + "=" + encodeURIComponent(value) + "&";
                }
            }
            return query.length ? query.substr(0, query.length - 1) : query;
        };
        $httpProvider.defaults.transformRequest = [function (data) {
            return angular.isObject(data) && String(data) !== "[object File]" ? param(data) : data;
        }];
    })
    .factory('globalHttpInterceptor', ['$q', '$rootScope', '$injector', function ($q, $rootScope, $injector) {

        var reqTimes = 0,
            reqTime = 0;
        var $ionicLoading;
        return {
            // optional method
            'request': function (config) {
                $ionicLoading = $injector.get('$ionicLoading');
                if (/\.htm/.test(config.url) && !(/\.html/.test(config.url))) {
                    if (!angular.element('loading-container visible').length) {
                        $ionicLoading.show({
                            noBackdrop: true,
                            hideOnStateChange: true
                        }).then(function () {
                            reqTime = new Date().getTime()
                        });
                    }
                    if (window && window.localStorage && JSON.parse(window.localStorage.getItem("authorizationStr"))) {
                        $rootScope.authorizationStr = JSON.parse(window.localStorage.getItem("authorizationStr"));
                    }
                    if (config.method == 'GET') {
                        if (/\?/.test(config.url)) {
                            config.url += '&access_token=' + $rootScope.authorizationStr.access_token +
                                '&userId=' + $rootScope.authorizationStr.userId +
                                '&userType=' + $rootScope.authorizationStr.userType;
                        } else {
                            config.url += '?access_token=' + $rootScope.authorizationStr.access_token +
                                '&userId=' + $rootScope.authorizationStr.userId +
                                '&userType=' + $rootScope.authorizationStr.userType;
                        }
                    } else {
                        config.data = config.data || {};
                        config.data.access_token = $rootScope.authorizationStr.access_token;
                        config.data.userId = $rootScope.authorizationStr.userId;
                        config.data.userType = $rootScope.authorizationStr.userType;
                        // 过滤utf-16字符
                        var dataString = JSON.stringify(config.data);
                        var newDataString = dataString.replace(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g, '');
                        config.data = JSON.parse(newDataString);
                    }
                }
                return config;
            },
            'requestError': function (rejection) {
                // do something on error
                $ionicLoading.hide();
                return $q.reject(rejection);
            },
            'response': function (response) {
                // do something on success
                reqTimes--;
                if (reqTimes < 1) {
                    reqTimes = 0;
                    var timeDif = new Date().getTime() - reqTime;
                    if (timeDif < 300) {
                        var $timeout = $injector.get('$timeout');
                        $timeout(function () {
                            $ionicLoading.hide();
                        }, 300 - timeDif)
                    } else {
                        $ionicLoading.hide();
                    }
                }
                return response;
            },
            'responseError': function (rejection) {
                // do something on error
                $ionicLoading.hide();
                return $q.reject(rejection);
            }
        };
    }])
    //onFinishRender
    .directive('onFinishRender', function ($timeout) {
        return {
            restrict: 'A',
            link: function (scope, element, attr) {
                if (scope.$last === true) {
                    $timeout(function () {
                        scope.$emit('ngRepeatFinished');
                    });
                }
            }
        }
    })
    //ynuiDatetimepicker fanjiaben
    .directive('ynuiDatetimepicker', [function () {
        return {
            restrict: 'A',
            require: '?ngModel',
            scope: {
                range: '@'
            },
            link: function (scope, elem, attr, ctrl) {
                var type = attr.ynuiDatetimepicker;
                var isRange = function () {
                    return scope.range;
                };
                var rangeOpt = {
                    mode: 'scroller',
                    display: 'modal',
                    lang: 'zh',
                    stepMinute: 1,
                    minWidth: 50,
                    maxDate: new Date((new Date()).getFullYear() + 10, 11, 31, 23, 59),
                    dateFormat: 'yyy-mm-dd',
                    timeFormat: 'HH:ii'
                };
                var optDefault = {
                    mode: 'scroller',
                    display: 'modal',
                    lang: 'zh',
                    stepMinute: 1,
                    minWidth: 50,
                    maxDate: new Date((new Date()).getFullYear() + 10, 11, 31, 23, 59),
                    dateFormat: 'yyy-mm-dd',
                    timeFormat: 'HH:ii',
                    onSelect: function (valueText, inst) {
                        if (ctrl) {
                            ctrl.$setViewValue(valueText);
                        }
                        if (isRange()) {
                            var rangeElem = angular.element('#' + scope.range);
                            rangeOpt.minDate = inst.getVal();
                            bindPicker(rangeElem, rangeOpt);
                            if (valueText > rangeElem.val() && rangeElem.val() != '') {
                                rangeElem.val(valueText);
                                if (ctrl) {
                                    ctrl.$setViewValue(valueText);
                                }
                            }
                        }
                    },
                    onShow: function (html, valueText, inst) {

                    },
                    onHide: function (inst) {

                    }
                };
                var bindPicker = function (bindElem, opt) {
                    switch (type) {
                        case 'YMD':
                            bindElem.mobiscroll().date(opt);
                            break;
                        case 'HI':
                            bindElem.mobiscroll().time(opt);
                            break;
                        default :
                            bindElem.mobiscroll().datetime(opt);
                    }
                };
                bindPicker(elem, optDefault);
            }
        }
    }])
    .directive('viewPicture', ['$ionicModal', function ($ionicModal) {
        return {
            restrict: 'A',
            link: function ($scope, elem, attrs) {
                $scope.modelIsRemove = false;
                $scope.picUrl = null;
                $scope.viewHeight = angular.element(window).height() - 44;
                elem.css('max-width', '100%');
                elem.on('click', function () {
                    $scope.picUrl = attrs.src;
                    $scope.openModal();
                });
                var template = '<ion-modal-view>' +
                    '<ion-header-bar align-title="center">' +
                    '<button class="button button-clear button-primary" ng-click="closeModal()">返回</button>' +
                    '<h1 class="title">预览</h1>' +
                    '</ion-header-bar>' +
                    '<ion-content>' +
                    '<ion-scroll direction="xy" class="text-center" style="height: {{viewHeight}}px">' +
                    '<img ng-src="{{picUrl}}">' +
                    '</ion-scroll>' +
                    '</ion-content>' +
                    '</ion-modal-view>';
                $scope.pictureModel = $ionicModal.fromTemplate(template, {
                    scope: $scope,
                    animation: 'slide-in-up'
                });
                $scope.openModal = function () {
                    if ($scope.modelIsRemove) {
                        $scope.pictureModel = $ionicModal.fromTemplate(template, {
                            scope: $scope,
                            animation: 'slide-in-up'
                        });
                    }
                    $scope.pictureModel.show().then(function () {
                        $scope.modelIsRemove = false;
                    });
                };
                $scope.closeModal = function () {
                    $scope.pictureModel.remove().then(function () {
                        $scope.modelIsRemove = true;
                    });
                };
                // Cleanup the modal when we're done with it!
                $scope.$on('$destroy', function () {
                    $scope.pictureModel.remove();
                });
            }
        }
    }])
    //头像预览
    .directive('viewHead', ['$ionicModal', function ($ionicModal) {
        return {
            restrict: 'A',
            link: function ($scope, elem, attrs) {
                $scope.modelIsRemove = false;
                $scope.picUrl = null;
                $scope.viewHeight = angular.element(window).height() - 44;
                elem.on('click', function ($event) {
                    if (attrs.viewHead) {
                        $scope.picUrl = attrs.viewHead;
                    } else {
                        $scope.picUrl = attrs.src;
                    }
                    if (!$scope.picUrl) {
                        return;
                    }
                    $scope.openModal();
                    if ($event && $event.stopPropagation) {
                        $event.stopPropagation();
                    }
                });
                var template = '<ion-modal-view>' +
                    '<ion-header-bar align-title="center">' +
                    '<button class="button button-clear button-primary" ng-click="closeModal()">返回</button>' +
                    '<h1 class="title">预览</h1>' +
                    '</ion-header-bar>' +
                    '<ion-content>' +
                    '<ion-scroll delegate-handle="viewHeadIonScroll" direction="xy" class="text-center" style="height: {{viewHeight}}px">' +
                    '<img ng-src="{{picUrl}}">' +
                    '</ion-scroll>' +
                    '</ion-content>' +
                    '</ion-modal-view>';
                $scope.pictureModel = $ionicModal.fromTemplate(template, {
                    scope: $scope,
                    animation: 'slide-in-up'
                });
                $scope.openModal = function () {
                    if ($scope.modelIsRemove) {
                        $scope.pictureModel = $ionicModal.fromTemplate(template, {
                            scope: $scope,
                            animation: 'slide-in-up'
                        });
                    }
                    $scope.pictureModel.show().then(function () {
                        $scope.modelIsRemove = false;
                    });
                };
                $scope.closeModal = function () {
                    $scope.pictureModel.remove().then(function () {
                        $scope.modelIsRemove = true;
                    });
                };
                // Cleanup the modal when we're done with it!
                $scope.$on('$destroy', function () {
                    $scope.pictureModel.remove();
                });
            }
        }
    }])
    //ynuiNotification fanjiaben
    .factory('ynuiNotification', [function () {

        var ynuiNotification = {};
        var optDefault = {
            "closeButton": false,
            "debug": false,
            "newestOnTop": false,
            "progressBar": false,
            "positionClass": "toast-top-center",
            "preventDuplicates": false,
            "onclick": null,
            "showDuration": "300",
            "hideDuration": "1000",
            "timeOut": "2000",
            "extendedTimeOut": "1000",
            "showEasing": "swing",
            "hideEasing": "linear",
            "showMethod": "fadeIn",
            "hideMethod": "fadeOut"
        };
        toastr.options = optDefault;
        var beforeShow = function (obj) {
            toastr.remove();
            toastr.options = angular.extend({}, optDefault, obj.opts);
        };
        ynuiNotification.warning = function (obj) {
            beforeShow(obj);
            toastr.warning(obj.msg, obj.title);
        };
        ynuiNotification.success = function (obj) {
            beforeShow(obj);
            toastr.success(obj.msg, obj.title);
        };
        ynuiNotification.error = function (obj) {
            beforeShow(obj);
            toastr.error(obj.msg, obj.title);
        };
        ynuiNotification.clear = function () {
            toastr.clear();
        };
        return ynuiNotification;
    }])
    // 应用入口
    .controller('entryController', ['$scope', 'ynuiNotification', "$http", "$rootScope", function ($scope, ynuiNotification, $http, $rootScope) {
        var vm = $scope.vm = {
            authorizationStr: $rootScope.authorizationStr,
            goProvider: function (provider) {
                var url=originBaseUrl+'/app/microapp.html?1=1#'+provider;
                window.open(url);
            }
        };
        var initMobileApp=function(){
            $http.get(localhost + '/mobileApp/queryMobileAppByUserType.htm',{userType:$rootScope.authorizationStr.userType}).success(function (data) {
                if (data.status == 0) {
                    vm.mobileAppVOList=data.result;
                }
            });
        }
        initMobileApp();
    }])
    //调试用
    .controller('testCtrl', ['$scope', 'ynuiNotification', function ($scope, ynuiNotification,$rootScope) {
        //提示组件Demo
        $scope.notifyTest1 = function () {
            ynuiNotification.success({msg: '成功提示'});
        };
        $scope.notifyTest2 = function () {
            ynuiNotification.error({msg: '成功提示'});
        };
        $scope.notifyTest3 = function () {
            ynuiNotification.warning({msg: '成功提示'});
        };
        $scope.notifyTest4 = function () {
            ynuiNotification.success({msg: '你已学会提示组件用法', title: '设置标题'});
        };
        $scope.notifyTest5 = function () {
            ynuiNotification.success({msg: '设置延迟500ms', opts: {timeOut: 500}});
        };
        $scope.notifyTest6 = function () {
            ynuiNotification.clear();
        }
    }])
    //课堂考勤（学生访问）
    .controller('attendanceStuCtrl', ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', "$location", "$ionicPopup",
        function ($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, $location, $ionicPopup) {
            //获取当前学期
            $http.get(originBaseUrl + "/third/result/getTerm.htm" + "?_datatime=" + new Date().getTime()).success(function (data) {
                if (data.status == 0) {
                    if (data.result.curTerm) {
                        $scope.isCurTerm = true;//用于后面获取教学周信息的判断
                        $scope.term = data.result.curTerm
                        $scope.termId = $scope.term.id;
                        //当前学期的开始时间和结束时间
                        $scope.beginTime = $scope.term.termBeginDateString;
                        $scope.endTime = $scope.term.termEndDateString;
                        $scope.loadData();
                    } else {//如果当前日期不在学期内，就默认为上学期
                        $scope.isCurTerm = false;
                    }
                }
            })
            // 选中的周数
            $scope.selectedWeek = "";
            /**
             * 查询总周数 以及每周的信息
             */
            /**
             * 查询总周数 以及每周的信息
             */
            var firstDayArr = [], endDayArr = [];
            $scope.loadData = function () {
                $http.post(originBaseUrl + "/third/attendance/queryTimeTableWeekTHead.htm", {
                    termId: $scope.termId,
                    requestSource: 2,
                    containChecking: false
                }).success(function (data) {
                    if (data.status == 0) {
                        //当前学期周相关信息
                        $scope.oTableWeekTHead = data.result;
                        if ($scope.oTableWeekTHead.length > 0) {
                            //获取教学周第一周和最后一周的起始时间
                            var firstDate = $scope.oTableWeekTHead[0].startEndDate.split("~")[0],
                                firstDateEnd = $scope.oTableWeekTHead[0].startEndDate.split("~")[1],
                                endDate = $scope.oTableWeekTHead[$scope.oTableWeekTHead.length - 1].startEndDate.split("~")[1];
                            firstDayArr = firstDate.split("-"), endDayArr = endDate.split("-");
                            angular.forEach($scope.oTableWeekTHead, function (o, key) {
                                if (o.isCurrentWeek) {
                                    $scope.selectedWeek = o.week;
                                    var tempArr = o.startEndDate.split("~"),
                                        //校历日期当前周的开始和结束时间
                                        startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                        startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                                    //判断校历日期一周有几天
                                    if (startDay > endDay) {    //跨月
                                        if (key + 1 <= $scope.oTableWeekTHead.length) {
                                            tempArr = $scope.oTableWeekTHead[key + 1].startEndDate.split("~");
                                        } else {
                                            tempArr = $scope.oTableWeekTHead[key - 1].startEndDate.split("~");
                                        }
                                        startDate1 = tempArr[0], endDate1 = tempArr[1];
                                        getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1);
                                    } else {
                                        getDateByStartEndDate(startDate, endDate);
                                    }
                                    getAssembleDate(false, false, new Date().getMonth() + 1, new Date().getDate(), false, false);
                                }
                            });
                            if (!$scope.selectedWeek) {    //当前日期不在教学周内，默认加载教学周第一周的第一天
                                var startMonth = firstDate.split("-")[0], startDay = firstDate.split("-")[1];
                                getDateByStartEndDate(firstDate, firstDateEnd);
                                getAssembleDate(false, false, startMonth, startDay, false, false);
                                $scope.selectedWeek = 1;
                                $scope.oTableWeekTHead[0].isCurrentWeek = true;
                            }
                        }
                    }
                });
            }
            //查询课表信息
            $scope.fLoadTimeTableData = function () {
                $http.post(originBaseUrl + "/third/attendance/queryRollBackByquery.htm",
                    {termId: $scope.termId, week: $scope.selectedWeek, day: $scope.showDay, requestSource: 2}
                ).success(function (data) {
                    if (data.status === 0) {
                        $scope.oTimeTableData = data.result;
                    } else {
                        $scope.showWarning("加载失败，请重试！");
                    }
                }).error(function () {
                    $scope.showWarning("加载失败，请重试！");
                });
            }

            /**
             * 根据开始时间和结束时间计算每周的日期
             * @param start
             * @param end
             * @returns {Array}
             */

            function getDateByStartEndDate(start, end, isAdd, start1, end1) {
                $scope.dateArr = [];
                var startMonthStr = parseInt(start.split("-")[0]), endMonthStr = parseInt(end.split("-")[0]),
                    startDateStr = parseInt(start.split("-")[1]), endDateStr = parseInt(end.split("-")[1]);
                var tempNum = 0;
                if (isAdd) { //跨月
                    $scope.weekNum = Math.abs(parseInt(end1.split("-")[1] - parseInt(start1.split("-")[1]))) + 1;
                } else {
                    $scope.weekNum = Math.abs(endDateStr - startDateStr) + 1;
                }
                if (startMonthStr == endMonthStr) { //同月
                    for (var i = 1; i <= $scope.weekNum; i++) {
                        $scope.dateArr.push({id: i, monthStr: startMonthStr, dateStr: startDateStr + tempNum});
                        tempNum++;
                    }
                } else { //跨月
                    var currentNum = $scope.weekNum - endDateStr,  //当前月占几天
                        tempNumCur = 0;
                    for (var i = 1; i <= currentNum; i++) { //当前月日期
                        $scope.dateArr.push({id: i, monthStr: startMonthStr, dateStr: startDateStr + tempNumCur});
                        tempNumCur++;
                    }
                    for (var j = 1; j <= endDateStr; j++) { //跨月占日期
                        $scope.dateArr.push({id: ++tempNumCur, monthStr: endMonthStr, dateStr: j});
                    }
                }
                return $scope.dateArr;
            }

            /**
             * 获取显示的日期
             * @param month
             * @param date
             * @param up    上一天
             * @param down  下一天
             * @param first 上一天跨周
             * @param end   下一天跨周
             */
            function getAssembleDate(first, end, month, date, up, down) {
                if (first) {
                    $scope.judgePar = {
                        month: $scope.dateArr[$scope.dateArr.length - 1].monthStr,
                        date: $scope.dateArr[$scope.dateArr.length - 1].dateStr
                    };
                    $scope.showDay = $scope.dateArr[$scope.dateArr.length - 1].id;
                } else if (end) {
                    $scope.judgePar = {month: $scope.dateArr[0].monthStr, date: $scope.dateArr[0].dateStr};
                    $scope.showDay = $scope.dateArr[0].id;
                } else {
                    for (var i = 0; i < $scope.dateArr.length; i++) {
                        var item = $scope.dateArr[i];
                        if (item.monthStr == month && item.dateStr == date) {
                            if (up) {
                                $scope.judgePar = {
                                    month: $scope.dateArr[i - 1].monthStr,
                                    date: $scope.dateArr[i - 1].dateStr
                                };
                                $scope.showDay = $scope.dateArr[i - 1].id;
                            } else if (down) {
                                $scope.judgePar = {
                                    month: $scope.dateArr[i + 1].monthStr,
                                    date: $scope.dateArr[i + 1].dateStr
                                };
                                $scope.showDay = $scope.dateArr[i + 1].id;
                            } else {
                                $scope.judgePar = {month: item.monthStr, date: item.dateStr};
                                $scope.showDay = item.id;
                            }
                        }
                    }
                }
                $scope.fLoadTimeTableData();
            }

            /**
             * 上一天、下一天
             * @param item
             */
            $scope.chooseDay = function (item) {
                if (item == 1) {
                    if ($scope.judgePar.month == parseInt(endDayArr[0]) && $scope.judgePar.date == parseInt(endDayArr[1])) {
                        $scope.showWarning("已经是最后一天！");
                        return;
                    }
                    //跨周处理
                    if ($scope.showDay < $scope.weekNum) {
                        getAssembleDate(false, false, $scope.judgePar.month, $scope.judgePar.date, false, true);
                    } else {
                        for (var i = 0; i < $scope.oTableWeekTHead.length; i++) {
                            var val = $scope.oTableWeekTHead[i];
                            if (val.isCurrentWeek) {
                                val.isCurrentWeek = false;
                                $scope.oTableWeekTHead[i + 1].isCurrentWeek = true;
                                $scope.selectedWeek = $scope.oTableWeekTHead[i + 1].week;
                                var tempArr = $scope.oTableWeekTHead[i + 1].startEndDate.split("~"),
                                    startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                    startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                                if (startDay > endDay) {    //跨月
                                    if (i - 2 <= $scope.oTableWeekTHead.length && i - 2 >= 0) {
                                        tempArr = $scope.oTableWeekTHead[i].startEndDate.split("~");
                                    } else {
                                        tempArr = $scope.oTableWeekTHead[i - 2].startEndDate.split("~");
                                    }
                                    startDate1 = tempArr[0], endDate1 = tempArr[1];
                                    getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1)
                                } else {
                                    getDateByStartEndDate(startDate, endDate);
                                }
                                getAssembleDate(false, true);
                                return;
                            }
                        }
                    }

                } else {
                    if ($scope.judgePar.month == parseInt(firstDayArr[0]) && $scope.judgePar.date == parseInt(firstDayArr[1])) {
                        $scope.showWarning("已经是第一天！");
                        return;
                    }
                    if ($scope.showDay > 1) {
                        getAssembleDate(false, false, $scope.judgePar.month, $scope.judgePar.date, true, false);
                    } else {
                        for (var i = 0; i < $scope.oTableWeekTHead.length; i++) {
                            var val = $scope.oTableWeekTHead[i];
                            if (val.isCurrentWeek) {
                                val.isCurrentWeek = false;
                                $scope.oTableWeekTHead[i - 1].isCurrentWeek = true;
                                $scope.selectedWeek = $scope.oTableWeekTHead[i - 1].week;
                                var tempArr = $scope.oTableWeekTHead[i - 1].startEndDate.split("~"),
                                    startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                    startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                                if (startDay > endDay) {    //跨月
                                    if (i - 2 <= $scope.oTableWeekTHead.length && i - 2 >= 0) {
                                        tempArr = $scope.oTableWeekTHead[i].startEndDate.split("~");
                                    } else {
                                        tempArr = $scope.oTableWeekTHead[i - 2].startEndDate.split("~");
                                    }
                                    startDate1 = tempArr[0], endDate1 = tempArr[1];
                                    getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1)
                                } else {
                                    getDateByStartEndDate(startDate, endDate);
                                }
                                getAssembleDate(true, false);
                                return;
                            }
                        }
                    }

                }
            }
            /**
             * 选择周
             * @param item 选中的周数
             */
            $scope.chooseWeek = function (item) {

                if (item == 0) {
                    $scope.showWarning("已经是第一周！");
                    return;
                }
                if (item > $scope.oTableWeekTHead.length) {
                    $scope.showWarning("已经是最后一周！");
                    return;
                }

                var count = true;
                if (item <= $scope.oTableWeekTHead.length && item > 0) {
                    for (var i = 0; i < $scope.oTableWeekTHead.length; i++) {
                        if ($scope.oTableWeekTHead[i].week == item) {
                            var val = $scope.oTableWeekTHead[i];
                            val.isCurrentWeek = true;
                            $scope.selectedWeek = val.week;
                            var tempArr = val.startEndDate.split("~"),
                                startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                            if (startDay > endDay) {    //跨月
                                if (i + 1 <= $scope.oTableWeekTHead.length) {
                                    tempArr = $scope.oTableWeekTHead[i + 1].startEndDate.split("~");
                                } else {
                                    tempArr = $scope.oTableWeekTHead[i - 1].startEndDate.split("~");
                                }
                                startDate1 = tempArr[0], endDate1 = tempArr[1];
                                getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1)
                            } else {
                                getDateByStartEndDate(startDate, endDate);
                            }
                            if ($scope.showDay <= $scope.dateArr[$scope.dateArr.length - 1].id) { //避免每周的天数不一致
                                angular.forEach($scope.dateArr, function (item) {
                                    if (item.id == $scope.showDay && count) {
                                        $scope.judgePar = {month: item.monthStr, date: item.dateStr};
                                        $scope.showDate = item.monthStr + "." + item.dateStr;
                                        $scope.showDay = item.id;
                                        count = false;
                                    }
                                })
                                $scope.fLoadTimeTableData();
                            } else {
                                getAssembleDate(true, false);
                            }
                        } else {
                            $scope.oTableWeekTHead[i].isCurrentWeek = false;
                        }
                    }
                }
            }

            /**
             * 选择大周（大周1相当于星期1）
             */
            $scope.chooseBigWeek = function (obj) {
                angular.forEach($scope.dateArr, function (item) {
                    if (item.id == obj) {
                        $scope.judgePar = {month: item.monthStr, date: item.dateStr};
                        $scope.showDate = item.monthStr + "." + item.dateStr;
                        $scope.showDay = item.id;
                    }
                });
                angular.element("#headDrop1").removeClass('open');
                $scope.fLoadTimeTableData();
            };

            /**
             * 刷新
             */
            $scope.doRefresh = function () {
                $scope.showWarning("正在加载...");
                $scope.fLoadTimeTableData();
            };
            /**
             * 提示信息
             * @param msg 提示内容
             */
            $scope.showWarning = function (msg) {
                $ionicLoading.show({
                    template: msg
                });
                $timeout(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                }, 500);
            };
        }])
    //课堂考勤（教职工访问）
    .controller('ClassAttendanceCtrl', ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', "$location", "$ionicPopup",
        function ($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, $location, $ionicPopup) {
            //获取当前学期
            $http.get(originBaseUrl + "/third/result/getTerm.htm" + "?_datatime=" + new Date().getTime()).success(function (data) {
                if (data.status == 0) {
                    if (data.result.curTerm) {
                        $scope.isCurTerm = true;//用于后面获取教学周信息的判断
                        $scope.term = data.result.curTerm;
                        $scope.termId = $scope.term.id;
                        //当前学期的开始时间和结束时间
                        $scope.beginTime = $scope.term.termBeginDateString;
                        $scope.endTime = $scope.term.termEndDateString;
                        $scope.loadData();
                    } else {//如果当前日期不在学期内，就默认为上学期
                        $scope.isCurTerm = false;
                    }
                }
            });
            // 选中的周数
            $scope.selectedWeek = "";

            /**
             * 查询总周数 以及每周的信息
             */
            var firstDayArr = [], endDayArr = [];
            $scope.loadData = function () {
                $http.post(originBaseUrl + "/third/attendance/queryTimeTableWeekTHead.htm", {
                    termId: $scope.termId,
                    requestSource: 1,
                    containChecking: false
                }).success(function (data) {
                    if (data.status == 0) {
                        //当前学期周相关信息
                        $scope.oTableWeekTHead = data.result;
                        if ($scope.oTableWeekTHead.length > 0) {
                            //获取教学周第一周和最后一周的起始时间
                            var firstDate = $scope.oTableWeekTHead[0].startEndDate.split("~")[0],
                                firstDateEnd = $scope.oTableWeekTHead[0].startEndDate.split("~")[1],
                                endDate = $scope.oTableWeekTHead[$scope.oTableWeekTHead.length - 1].startEndDate.split("~")[1];
                            firstDayArr = firstDate.split("-");
                            endDayArr = endDate.split("-");
                            angular.forEach($scope.oTableWeekTHead, function (o, key) {
                                if (o.isCurrentWeek) {
                                    $scope.selectedWeek = o.week;
                                    var tempArr = o.startEndDate.split("~"),
                                        //校历日期当前周的开始和结束时间
                                        startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                        startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                                    //判断校历日期一周有几天
                                    if (startDay > endDay) {    //跨月
                                        if (key + 1 <= $scope.oTableWeekTHead.length) {
                                            tempArr = $scope.oTableWeekTHead[key + 1].startEndDate.split("~");
                                        } else {
                                            tempArr = $scope.oTableWeekTHead[key - 1].startEndDate.split("~");
                                        }
                                        startDate1 = tempArr[0];
                                        endDate1 = tempArr[1];
                                        getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1);
                                    } else {
                                        getDateByStartEndDate(startDate, endDate);
                                    }
                                    getAssembleDate(false, false, new Date().getMonth() + 1, new Date().getDate(), false, false);
                                }
                            });
                            if (!$scope.selectedWeek) {    //当前日期不在教学周内，默认加载教学周第一周的第一天
                                var startMonth = firstDate.split("-")[0], startDay = firstDate.split("-")[1];
                                getDateByStartEndDate(firstDate, firstDateEnd);
                                getAssembleDate(false, false, startMonth, startDay, false, false);
                                $scope.selectedWeek = 1;
                                $scope.oTableWeekTHead[0].isCurrentWeek = true;
                            }
                        }
                    }
                });
            };

            //查询课表信息
            $scope.fLoadTimeTableData = function () {
                $http.post(originBaseUrl + "/third/attendance/queryRollBackByquery.htm",
                    {termId: $scope.termId, week: $scope.selectedWeek, day: $scope.showDay, requestSource: 1}
                ).success(function (data) {
                    if (data.status === 0) {
                        $scope.oTimeTableData = data.result;
                    } else {
                        $scope.showWarning("加载失败，请重试！");
                    }
                }).error(function () {
                    $scope.showWarning("加载失败，请重试！");
                });
            };

            /**
             * 根据开始时间和结束时间计算每周的日期
             * @param start
             * @param end
             * @returns {Array}
             */

            function getDateByStartEndDate(start, end, isAdd, start1, end1) {
                $scope.dateArr = [];
                var startMonthStr = parseInt(start.split("-")[0]), endMonthStr = parseInt(end.split("-")[0]),
                    startDateStr = parseInt(start.split("-")[1]), endDateStr = parseInt(end.split("-")[1]);
                var tempNum = 0;
                if (isAdd) { //跨月
                    $scope.weekNum = Math.abs(parseInt(end1.split("-")[1] - parseInt(start1.split("-")[1]))) + 1;
                } else {
                    $scope.weekNum = Math.abs(endDateStr - startDateStr) + 1;
                }
                if (startMonthStr == endMonthStr) { //同月
                    for (var i = 1; i <= $scope.weekNum; i++) {
                        $scope.dateArr.push({id: i, monthStr: startMonthStr, dateStr: startDateStr + tempNum});
                        tempNum++;
                    }
                } else { //跨月
                    var currentNum = $scope.weekNum - endDateStr,  //当前月占几天
                        tempNumCur = 0;
                    for (var i = 1; i <= currentNum; i++) { //当前月日期
                        $scope.dateArr.push({id: i, monthStr: startMonthStr, dateStr: startDateStr + tempNumCur});
                        tempNumCur++;
                    }
                    for (var j = 1; j <= endDateStr; j++) { //跨月占日期
                        $scope.dateArr.push({id: ++tempNumCur, monthStr: endMonthStr, dateStr: j});
                    }
                }
                return $scope.dateArr;
            }

            /**
             * 获取显示的日期
             * @param month
             * @param date
             * @param up    上一天
             * @param down  下一天
             * @param first 上一天跨周
             * @param end   下一天跨周
             */
            function getAssembleDate(first, end, month, date, up, down) {
                if (first) {
                    $scope.judgePar = {
                        month: $scope.dateArr[$scope.dateArr.length - 1].monthStr,
                        date: $scope.dateArr[$scope.dateArr.length - 1].dateStr
                    };
                    $scope.showDay = $scope.dateArr[$scope.dateArr.length - 1].id;
                } else if (end) {
                    $scope.judgePar = {month: $scope.dateArr[0].monthStr, date: $scope.dateArr[0].dateStr};
                    $scope.showDay = $scope.dateArr[0].id;
                } else {
                    for (var i = 0; i < $scope.dateArr.length; i++) {
                        var item = $scope.dateArr[i];
                        if (item.monthStr == month && item.dateStr == date) {
                            if (up) {
                                $scope.judgePar = {
                                    month: $scope.dateArr[i - 1].monthStr,
                                    date: $scope.dateArr[i - 1].dateStr
                                };
                                $scope.showDay = $scope.dateArr[i - 1].id;
                            } else if (down) {
                                $scope.judgePar = {
                                    month: $scope.dateArr[i + 1].monthStr,
                                    date: $scope.dateArr[i + 1].dateStr
                                };
                                $scope.showDay = $scope.dateArr[i + 1].id;
                            } else {
                                $scope.judgePar = {month: item.monthStr, date: item.dateStr};
                                $scope.showDay = item.id;
                            }
                        }
                    }
                }
                $scope.fLoadTimeTableData();
            }

            /**
             * 上一天、下一天
             * @param item
             */
            $scope.chooseDay = function (item) {
                if (item == 1) {
                    if ($scope.judgePar.month == parseInt(endDayArr[0]) && $scope.judgePar.date == parseInt(endDayArr[1])) {
                        $scope.showWarning("已经是最后一天！");
                        return;
                    }
                    //跨周处理
                    if ($scope.showDay < $scope.weekNum) {
                        getAssembleDate(false, false, $scope.judgePar.month, $scope.judgePar.date, false, true);
                    } else {
                        for (var i = 0; i < $scope.oTableWeekTHead.length; i++) {
                            var val = $scope.oTableWeekTHead[i];
                            if (val.isCurrentWeek) {
                                val.isCurrentWeek = false;
                                $scope.oTableWeekTHead[i + 1].isCurrentWeek = true;
                                $scope.selectedWeek = $scope.oTableWeekTHead[i + 1].week;
                                var tempArr = $scope.oTableWeekTHead[i + 1].startEndDate.split("~"),
                                    startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                    startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                                if (startDay > endDay) {    //跨月
                                    if (i - 2 <= $scope.oTableWeekTHead.length && i - 2 >= 0) {
                                        tempArr = $scope.oTableWeekTHead[i].startEndDate.split("~");
                                    } else {
                                        tempArr = $scope.oTableWeekTHead[i - 2].startEndDate.split("~");
                                    }
                                    startDate1 = tempArr[0], endDate1 = tempArr[1];
                                    getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1)
                                } else {
                                    getDateByStartEndDate(startDate, endDate);
                                }
                                getAssembleDate(false, true);
                                return;
                            }
                        }
                    }

                } else {
                    if ($scope.judgePar.month == parseInt(firstDayArr[0]) && $scope.judgePar.date == parseInt(firstDayArr[1])) {
                        $scope.showWarning("已经是第一天！");
                        return;
                    }
                    if ($scope.showDay > 1) {
                        getAssembleDate(false, false, $scope.judgePar.month, $scope.judgePar.date, true, false);
                    } else {
                        for (var i = 0; i < $scope.oTableWeekTHead.length; i++) {
                            var val = $scope.oTableWeekTHead[i];
                            if (val.isCurrentWeek) {
                                val.isCurrentWeek = false;
                                $scope.oTableWeekTHead[i - 1].isCurrentWeek = true;
                                $scope.selectedWeek = $scope.oTableWeekTHead[i - 1].week;
                                var tempArr = $scope.oTableWeekTHead[i - 1].startEndDate.split("~"),
                                    startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                    startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                                if (startDay > endDay) {    //跨月
                                    if (i - 2 <= $scope.oTableWeekTHead.length && i - 2 >= 0) {
                                        tempArr = $scope.oTableWeekTHead[i].startEndDate.split("~");
                                    } else {
                                        tempArr = $scope.oTableWeekTHead[i - 2].startEndDate.split("~");
                                    }
                                    startDate1 = tempArr[0], endDate1 = tempArr[1];
                                    getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1)
                                } else {
                                    getDateByStartEndDate(startDate, endDate);
                                }
                                getAssembleDate(true, false);
                                return;
                            }
                        }
                    }

                }
            };

            /**
             * 选择周
             * @param item 选中的周数
             */
            $scope.chooseWeek = function (item) {
                var count = true;
                if (item <= $scope.oTableWeekTHead.length && item > 0) {
                    for (var i = 0; i < $scope.oTableWeekTHead.length; i++) {
                        if ($scope.oTableWeekTHead[i].week == item) {
                            var val = $scope.oTableWeekTHead[i];
                            val.isCurrentWeek = true;
                            $scope.selectedWeek = val.week;
                            var tempArr = val.startEndDate.split("~"),
                                startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                            if (startDay > endDay) {    //跨月
                                if (i + 1 <= $scope.oTableWeekTHead.length) {
                                    tempArr = $scope.oTableWeekTHead[i + 1].startEndDate.split("~");
                                } else {
                                    tempArr = $scope.oTableWeekTHead[i - 1].startEndDate.split("~");
                                }
                                startDate1 = tempArr[0], endDate1 = tempArr[1];
                                getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1)
                            } else {
                                getDateByStartEndDate(startDate, endDate);
                            }
                            if ($scope.showDay <= $scope.dateArr[$scope.dateArr.length - 1].id) { //避免每周的天数不一致
                                angular.forEach($scope.dateArr, function (item) {
                                    if (item.id == $scope.showDay && count) {
                                        $scope.judgePar = {month: item.monthStr, date: item.dateStr};
                                        $scope.showDate = item.monthStr + "." + item.dateStr;
                                        $scope.showDay = item.id;
                                        count = false;
                                    }
                                });
                                $scope.fLoadTimeTableData();
                            } else {
                                getAssembleDate(true, false);
                            }
                        } else {
                            $scope.oTableWeekTHead[i].isCurrentWeek = false;
                        }
                    }
                }
            };

            /**
             * 选择大周（大周1相当于星期1）
             */
            $scope.chooseBigWeek = function (obj) {
                angular.forEach($scope.dateArr, function (item) {
                    if (item.id == obj) {
                        $scope.judgePar = {month: item.monthStr, date: item.dateStr};
                        $scope.showDate = item.monthStr + "." + item.dateStr;
                        $scope.showDay = item.id;
                    }
                });
                angular.element("#headDrop1").removeClass('open');
                $scope.fLoadTimeTableData();
            };

            /**
             * 点名
             */
            $scope.callRoll = function (item) {
                $http.post(originBaseUrl + "/third/attendance/saveKQKtRollCall.htm",
                    {resultsFormalId: item.kpKBid}).success(function (data) {
                    if (data.status == 0) {
                        $scope.callBackId = data.result;
                        item.isOk = "1";
                        item.id = $scope.callBackId;
                        $location.path("/attendance_people").search("id", $scope.callBackId);
                    } else {
                        $scope.showWarning("加载失败，请重试！");
                    }
                }).error(function () {
                    $scope.showWarning("加载失败，请重试！");
                });
            };

            /**
             * 提醒
             */
            $scope.remind = function (item) {
                var opts = {
                    cancelText: "取消",
                    okText: "确定",
                    title: "发送异常信息",
                    template: "确定要将“" + item.courseName + "（" + item.timeStatus + item.sectionName + "）”下，所有考勤异常的学生名单发送给班主任？",
                    buttons: [{
                        text: '取消',
                        type: 'button-default',
                        onTap: function () {
                            return false;
                        }
                    }, {
                        text: '确定',
                        type: 'button-positive',
                        onTap: function () {
                            $http.post(originBaseUrl + "/third/attendance/sendUnusualcMessage.htm", {
                                KQKTRollCallId: item.id
                            }).success(function (data) {
                                if (data.status == 0) {
                                    $scope.showWarning("发送成功！");
                                } else {
                                    $scope.showWarning(data.message);
                                }
                            }).error(function () {
                                $scope.showWarning("加载失败，请重试！");
                            });
                            return true;
                        }
                    }]
                };
                $ionicPopup.confirm(opts);
            };
            /**
             * 刷新
             */
            $scope.doRefresh = function () {
                $scope.showWarning("正在加载...")
                $scope.fLoadTimeTableData();
            };
            /**
             * 提示信息
             * @param msg 提示内容
             */
            $scope.showWarning = function (msg) {
                $ionicLoading.show({
                    template: msg
                });
                $timeout(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                }, 1000);
            };
        }])
    //选人点名
    .controller('AttendancePeopleCtrl', ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', "$ionicPopup", "$location",
        function ($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, $ionicPopup, $location) {
            $scope.searchBar = false;
            $scope.showStatus = false;
            $scope.isLoad = true;
            $scope.callBackId = $location.search().id;
            $scope.clearName = function () {
                $scope.name = "";
                $scope.queryKQKtUserInfo($scope.callBackId, true);
            };
            $scope.changeShow = function () {
                $scope.searchBar = !$scope.searchBar;
                if (!$scope.searchBar) {
                    $scope.name = "";
                    $scope.queryKQKtUserInfo($scope.callBackId, true);
                }
            };


            /**
             * 获取学生信息
             */
            $scope.queryKQKtUserInfo = function (callBackId, isLoad) {
                $http.post(originBaseUrl + "/third/attendance/queryKQKtUserInfo.htm",
                    {callBackId: callBackId, queryStr: $scope.searchBar ? $scope.name : ''}).success(function (data) {
                    if (data.status == 0) {
                        $scope.isLoad = isLoad;
                        $scope.showHead = data.result;
                        $scope.userInfoData = data.result.list;
                        if ($scope.userInfoData.length > 0) {
                            angular.forEach($scope.userInfoData, function (val) {
                                var aliensNumber;
                                if (val.aliens && val.number) {
                                    aliensNumber = "(" + val.aliens + "," + val.number + ")";
                                } else if (val.aliens && !val.number) {
                                    aliensNumber = "(" + val.aliens + ")";
                                } else if (!val.aliens && val.number) {
                                    aliensNumber = "(" + val.number + ")";
                                }
                                val.aliensNumbers = aliensNumber;
                                val.showStatus = false;
                                //处理头像
                                if (val.imageId) {
                                    var tempImgArr = val.imageId.split(".");
                                    tempImgArr[0] += "_2";
                                    val.imageId = tempImgArr[0] + "." + tempImgArr[1];
                                }
                            })
                        }
                        //$scope.queryDictionaryByKeyAndStatus();
                    } else {
                        $scope.showWarning("加载失败！" + data.message);
                    }
                }).error(function () {
                    $scope.showWarning("加载失败，请重试！");
                });
            };


            $scope.changeShowState = function (item) {
                angular.forEach($scope.userInfoData, function (val) {
                    val.showStatus = false;
                });
                item.showStatus = true;
            };


            //查询所有考勤状态
            $scope.queryDictionaryByKeyAndStatus = function () {
                $http.post(originBaseUrl + "/third/attendance/queryDictionaryByKeyAndStatus.htm").success(function (data) {
                    if (data.status == 0) {
                        $scope.ktStatusList = data.result;
                        $scope.queryKQKtUserInfo($scope.callBackId, true);
                    } else {
                        $scope.showWarning("加载失败！" + data.message);
                    }
                }).error(function () {
                    $scope.showWarning("加载失败，请重试！");
                });
            };

            /**
             * 提交考勤状态
             * @param item
             */
            $scope.commitStatus = function (item, dictCode) {
                $http.post(originBaseUrl + '/third/attendance/updateKQStatus.htm', {
                    kqKTInfoId: item.id, dictCode: dictCode
                }).success(function (data) {
                    if (data.status == 0) {
                        $scope.queryKQKtUserInfo($scope.callBackId, true);
                    }
                })
            };

            /**
             * 刷新
             */
            $scope.doRefresh = function () {
                $scope.showWarning("正在加载...");
                $scope.searchBar = false;
                $scope.name = "";
                $scope.queryKQKtUserInfo($scope.callBackId, true);
            };
            /**
             * 提示信息
             * @param msg 提示内容
             */
            $scope.showWarning = function (msg) {
                $ionicLoading.show({
                    template: msg
                });
                $timeout(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                }, 500);
            };

            $scope.back = function () {
                history.back();
            };
            $scope.queryDictionaryByKeyAndStatus();
        }])
    //查看通知公告
    .controller('appViewNoticeController', ["$scope", "$location", "$http", "$sce", "$window", function ($scope, $location, $http, $sce, $window) {
        /**
         * 根据URL mapping获取到对应的值
         * @param firstIndex    需要的获取的值得key
         * @param lastIndex
         * @returns {string|*}
         */
        $scope.getUrlParams = function (firstIndex, lastIndex, indexof) {
            var fi = firstIndex + '=';
            if (lastIndex) {
                //如果不是最后一个参数
                return $location.$$absUrl.substring(($location.$$absUrl.lastIndexOf(fi) + fi.length), ($location.$$absUrl.lastIndexOf(lastIndex)))
            } else {
                return $location.$$absUrl.substring($location.$$absUrl.lastIndexOf(fi) + fi.length);
            }
        };
        //sanitize富文本的内容，使其能正常在页面显示
        $scope.initNoticeContent = function () {
            if ($scope.notice) {
                $scope.notice.noticeContent = $scope.notice.noticeContent ? $sce.trustAsHtml("<div>" + $scope.notice.noticeContent + "</div>") : "";
                if ($scope.notice.messageNoticeSignedTemplateVO) {
                    $scope.notice.messageNoticeSignedTemplateVO.signedContent = $scope.notice.messageNoticeSignedTemplateVO.signedContent ? $sce.trustAsHtml("<div>" + $scope.notice.messageNoticeSignedTemplateVO.signedContent + "</div>") : '';
                }
            }
        };
        //判断客户端是手机还是PC
        var IsPC = function () {
            var userAgentInfo = navigator.userAgent;
            var Agents = ["Android", "iPhone",
                "SymbianOS", "Windows Phone",
                "iPad", "iPod"];
            var flag = true;
            $scope.flagShow = true;
            var AgentsLen = Agents.length;
            for (var v = 0; v < AgentsLen; v++) {
                if (userAgentInfo.indexOf(Agents[v]) > 0) {
                    flag = false;
                    $scope.flagShow = false;
                    break;
                }
            }
            return flag;
        };
        $scope.initData = function () {
            $scope.type = $scope.getUrlParams("type", "&");
            $scope.id = $scope.getUrlParams("id");
            $scope.requestSource = IsPC() ? 0 : 1;
            //根据传过来的参数判断此页面是 “预览公告，查看公告，查看公告（接收）” 中的哪种
            if ($scope.type == 'preview') {
                //$scope.notice = localStorageService.get("previewNoticeObj");
                //查出发布人
                $http.get(originBaseUrl + "/third/notice/queryPublisher.htm" + "?_datatime=" + new Date().getTime(), {
                    params: {
                        id: $scope.id,
                        isUpdate: false,
                        isReceiver: true,
                        timeStamp: new Date().getTime()
                    }
                }).success(function (data) {
                    if (data.status == 0) {
                        $scope.notice.publisherName = data.result.name + "(" + data.result.userNumber + ")";
                    }
                });
                $scope.initNoticeContent();
            } else {
                //查询当前需要查看的通知
                var isReceiver = $scope.type == 'receiver' ? true : false;
                $http.get(originBaseUrl + "/third/notice/queryNotice.htm" + "?_datatime=" + new Date().getTime(), {
                    params: {
                        id: $scope.id,
                        isUpdate: false,
                        requestSource: $scope.requestSource,
                        isReceiver: isReceiver,
                        timeStamp: new Date().getTime()
                    }
                }).success(function (data) {
                    if (data.status == 0) {
                        $scope.notice = data.result;
                        $scope.initNoticeContent();
                        //转换byte格式为kb
                        angular.forEach($scope.notice.messageNoticeAttachmentList, function (item) {
                            item.size = (parseInt(item.size) / 1024).toFixed(2);
                        });
                    }
                });
                if ($scope.type == 'publisher') {
                    //当时发布者查看时，还需要把所有的接收者 阅读情况查出来
                    $http.get(originBaseUrl + "/third/notice/queryReceiverInfo.htm" + "?_datatime=" + new Date().getTime(), {
                        params: {
                            id: $scope.id,
                            timeStamp: new Date().getTime()
                        }
                    }).success(function (data) {
                        if (data.status == 0) {
                            $scope.receiverInfo = data.result;
                            //默认显示所有读取人的信息
                            $scope.readInfoList = $scope.receiverInfo.readList.concat($scope.receiverInfo.unreadList);
                        }
                    });
                }
            }
        };
        $scope.initData();
        //下载
        $scope.downLoad = function (item) {
            $window.open("/ynedut/file/downloadStream.htm?fastDFSId=" + item.attachmentId, "_blank");
        };
        if ($scope.flagShow) {
            angular.element('title').text('通知消息 - YN智慧校园');
        }
    }])
    //班级情况统计
    .controller('ClassTatisticsController', ['$rootScope', '$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location", "$ionicPopup",
        function ($rootScope, $scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location, $ionicPopup) {
            $scope.emptyInfo = false;  //数据加载失败
            //获取当前时间
            $scope.getCurrentTime = function () {
                var addDay = new Date();
                var month2 = (addDay.getMonth() + 1) > 9 ? (addDay.getMonth() + 1) : '0' + (addDay.getMonth() + 1);
                var day2 = addDay.getDate() > 9 ? addDay.getDate() : '0' + addDay.getDate();
                addDay = addDay.getFullYear() + "-" + month2 + "-" + day2;
                return addDay;
            }

            $scope.conditions = {
                queryDate: $scope.getCurrentTime()
            };
            $scope.classInfo = {};
            $scope.classList = [];

            $scope.selectedClass = function (item) {
                $scope.classInfo = item;
                $scope.doRefresh();
            }
            $scope.classCountList = [];
            //查询班级情况统计
            $scope.queryClassConditionCountInfo = function (func) {
                if (!$scope.classInfo.id) {
                    return false;
                }
                $http.get(originBaseUrl + '/third/classStatistics/queryClassConditionCountInfo.htm?&time=' + (new Date()).getTime()).success(function (data) {
                    if (data.status == 0) {
                        $scope.classCountList = data.result;
                        $scope.emptyInfo = false;
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                    if (func) {
                        func();
                    }
                }).error(function () {
                    if (func) {
                        func();
                    }
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                });
            };
            //查询 （type）1：应到 2：请假 3：处分  详情
            $scope.viewDetails = function (type, kqktId) {
                if (type == 1) {
                    $location.path("/tea_my_adminclass").search("item", JSON.stringify({classId: arguments[1]}));
                } else if (type == 2) {
                    $location.path("/class_leaveStudent").search("item", JSON.stringify({
                        classId: arguments[1],
                        queryType: arguments[2]
                    }));
                } else if (type == 3) {
                    $location.path("/class_punishStudent").search("item", JSON.stringify({classId: arguments[1]}));
                }
            };
            $scope.getData = function (func) {
                $scope.queryClassConditionCountInfo(func);
            };
            //查询班级下拉列表
            $.ajax({
                url: originBaseUrl + '/third/classStatistics/queryPlatformAdminClassNoGraduteByUserId.htm?' +
                    'access_token=' + $rootScope.authorizationStr.access_token +
                    '&userId=' + $rootScope.authorizationStr.userId +
                    '&userType=' + $rootScope.authorizationStr.userType,
                cache: false,
                async: false,
                type: "POST",
                dataType: 'json',
                success: function (data) {
                    if (data.status == 0) {
                        $scope.classList = data.result;
                        if ($scope.classList && $scope.classList.length > 0) {
                            $scope.classInfo = $scope.classList[0];
                            $scope.getData();
                        }
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                }
            });
            $scope.doRefresh = function () {
                $ionicLoading.show({
                    template: '正在刷新...'
                });
                $scope.getData(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                });
            };
            $scope.showTips = function () {
                var opts = {
                    okText: "确定",
                    title: "提示",
                    template: '1.请假中：统计当前时刻在请假起止时间内，不出校且审核通过的请假学生人数和要出校且审核通过、未返校的请假学生人数<br/>' +
                        '2.已出校（未逾期）：统计请假还未结束且“已放行未返校”的请假学生人数<br/>' +
                        '3.逾期未返校：统计当前已超过请假结束时间且 “已放行未返校”的请假学生人数',
                    buttons: [{
                        text: '确定',
                        type: 'button-positive',
                        onTap: function () {
                            return false;
                        }
                    }]
                };
                $ionicPopup.alert(opts);
            }
        }])
    //班级考情统计 应到学生
    .controller('classYdStudentCtrl', ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location",
        function ($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location) {
            $scope.classId = JSON.parse($location.search().item).classId;
            $scope.emptyInfo = false;
            $scope.isExistStu = true;
            $scope.getData = function (func) {
                $scope.stuList = [];
                $http.get(originBaseUrl + '/third/classStatistics/queryClassTotalStudentInfo.htm?classId=' + $scope.classId + "&time=" + (new Date()).getTime()).success(function (data) {
                    if (data.status == 0) {
                        $scope.stuList = data.result;
                        angular.forEach($scope.stuList, function (item) {
                            if (item.headUrl != "" && item.headUrl != null) {
                                item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
                            }
                        });
                        $scope.emptyInfo = false;
                        if ($scope.stuList && $scope.stuList.length > 0) {
                            $scope.isExistStu = true;
                        } else {
                            $scope.isExistStu = false;
                        }
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }

                    if (func) {
                        func();
                    }
                }).error(function () {
                    if (func) {
                        func();
                    }
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                });

            };

            $scope.doRefresh = function () {
                $ionicLoading.show({
                    template: '正在刷新...'
                });
                $scope.getData(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                });
            };
            $scope.doRefresh();
            $scope.doBack = function () {
                history.back(-1);
            };
        }])
    //班级考情统计 处分学生
    .controller('classPunishStudentCtrl', ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location",
        function ($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location) {
            $scope.classId = JSON.parse($location.search().item).classId;
            $scope.emptyInfo = false;
            $scope.isExistStu = true;
            $scope.getData = function (func) {
                $scope.stuList = [];
                $http.get(originBaseUrl + '/third/classStatistics/queryClassStudentPunishInfo.htm?classId=' + $scope.classId + "&time=" + (new Date()).getTime()).success(function (data) {
                    if (data.status == 0) {
                        $scope.stuList = data.result;
                        angular.forEach($scope.stuList, function (item) {
                            item.isUnfold = false;
                            if (item.headUrl != "" && item.headUrl != null) {
                                item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
                            }
                        });
                        $scope.emptyInfo = false;
                        if ($scope.stuList && $scope.stuList.length > 0) {
                            $scope.isExistStu = true;
                        } else {
                            $scope.isExistStu = false;
                        }
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }

                    if (func) {
                        func();
                    }
                }).error(function () {
                    if (func) {
                        func();
                    }
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                });

            };
            $scope.clickUnfold = function (item) {
                item.isUnfold = !item.isUnfold;
            };
            $scope.doRefresh = function () {
                $ionicLoading.show({
                    template: '正在刷新...'
                });
                $scope.getData(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                });
            };
            $scope.doRefresh();
            $scope.doBack = function () {
                history.back(-1);
            };
        }])
    //班级考情统计 请假学生
    .controller('classLeaveStudentCtrl', ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location",
        function ($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location) {
            $scope.queryType = JSON.parse($location.search().item).queryType;//0:出校学生  1:请假人数 2:逾期未销假人数
            $scope.classId = JSON.parse($location.search().item).classId;
            $scope.emptyInfo = false;
            $scope.isExistStu = true;
            $scope.getData = function (func) {
                $scope.stuList = [];
                $http.get(originBaseUrl + '/third/classStatistics/queryClassStudentCountInfo.htm?classId=' + $scope.classId + "&queryType=" + $scope.queryType + "&time=" + (new Date()).getTime()).success(function (data) {
                    if (data.status == 0) {
                        $scope.stuList = data.result;
                        angular.forEach($scope.stuList, function (item) {
                            item.isUnfold = false;
                            if (item.headUrl != "" && item.headUrl != null) {
                                item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
                            }
                        });
                        $scope.emptyInfo = false;
                        if ($scope.stuList && $scope.stuList.length > 0) {
                            $scope.isExistStu = true;
                        } else {
                            $scope.isExistStu = false;
                        }
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                    if (func) {
                        func();
                    }
                }).error(function () {
                    if (func) {
                        func();
                    }
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                });

            };
            $scope.clickUnfold = function (item) {
                item.isUnfold = !item.isUnfold;
            };
            $scope.doRefresh = function () {
                $ionicLoading.show({
                    template: '正在刷新...'
                });
                $scope.getData(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                });
            };
            $scope.doRefresh();
            $scope.doBack = function () {
                history.back(-1);
            };
        }])
    //课堂考勤统计
    .controller('ktkqTatisticsController', ['$rootScope', '$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location",
        function ($rootScope, $scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location) {
            $scope.emptyInfo = false;  //数据加载失败
            //获取当前时间
            $scope.getCurrentTime = function () {
                var addDay = new Date();
                var month2 = (addDay.getMonth() + 1) > 9 ? (addDay.getMonth() + 1) : '0' + (addDay.getMonth() + 1);
                var day2 = addDay.getDate() > 9 ? addDay.getDate() : '0' + addDay.getDate();
                addDay = addDay.getFullYear() + "-" + month2 + "-" + day2;
                return addDay;
            };

            $scope.conditions = {
                queryDate: $scope.getCurrentTime()
            };
            $scope.classInfo = {};
            $scope.classList = [];

            $scope.selectedClass = function (item) {
                $scope.classInfo = item;
                $scope.doRefresh();
            };
            $scope.classCountList = [];
            //课堂考勤统计
            $scope.queryKqktClassCountInfo = function (func) {
                if (!$scope.classInfo.id || !$scope.conditions.queryDate) {
                    return false;
                }
                $http.get(originBaseUrl + '/third/attendance/queryKqktClassCountInfo.htm?classId=' + $scope.classInfo.id + "&queryDate=" + $scope.conditions.queryDate + "&time=" + (new Date()).getTime()).success(function (data) {
                    if (data.status == 0) {
                        $scope.kqKTCount = data.result;
                        $scope.emptyInfo = false;
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                    if (func) {
                        func();
                    }
                }).error(function () {
                    if (func) {
                        func();
                    }
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                });
            };
            //查询 （type）1：应到 2：请假 3：处分 4:课堂考勤学生 详情
            $scope.viewDetails = function (kqktId, ktStatus) {
                window.localStorage.setItem("classId", JSON.stringify($scope.classInfo.id));
                window.localStorage.setItem("queryDate", JSON.stringify($scope.conditions.queryDate));
                $location.path("/ktkq_student").search("item", JSON.stringify({
                    classId: $scope.classInfo.id,
                    kqktId: kqktId,
                    ktStatus: ktStatus
                }));
            };
            $scope.getData = function (func) {
                $scope.queryKqktClassCountInfo(func);
            };
            $scope.doRefresh = function () {
                $ionicLoading.show({
                    template: '正在刷新...'
                });
                $scope.getData(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                });
            };
            //查询班级下拉列表
            $.ajax({
                url: originBaseUrl + '/third/classStatistics/queryPlatformAdminClassNoGraduteByUserId.htm?' +
                    'access_token=' + $rootScope.authorizationStr.access_token +
                    '&userId=' + $rootScope.authorizationStr.userId +
                    '&userType=' + $rootScope.authorizationStr.userType,
                cache: false,
                async: false,
                type: "POST",
                dataType: 'json',
                success: function (data) {
                    if (data.status == 0) {
                        $scope.classList = data.result;
                        if ($scope.classList && $scope.classList.length > 0) {
                            var historyClassId = JSON.parse(window.localStorage.getItem("classId"));
                            if (historyClassId) {
                                angular.forEach($scope.classList, function (item) {
                                    if (item.id == historyClassId) {
                                        $scope.classInfo = item;
                                    }
                                });
                                $scope.conditions.queryDate = JSON.parse(window.localStorage.getItem("queryDate"));
                            } else {
                                $scope.classInfo = $scope.classList[0];
                            }
                            $scope.doRefresh();
                        }
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                }
            });
        }])
    //课堂考勤 学生详情
    .controller('ktkqStudentCtrl', ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location",
        function ($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location) {
            $scope.ktStatus = JSON.parse($location.search().item).ktStatus;
            ;//考勤状态 all:应到 act:实到 1：请假 2：缺席 3：迟到 4：早退 5：按时到

            $scope.ktStatusList = [
                {ktStatus: "all", ktStatusName: "应到学生"},
                {ktStatus: "act", ktStatusName: "实到学生"},
                {ktStatus: "1", ktStatusName: "请假学生"},
                {ktStatus: "2", ktStatusName: "缺席学生"},
                {ktStatus: "3", ktStatusName: "迟到学生"},
                {ktStatus: "4", ktStatusName: "早退学生"},
                {ktStatus: "5", ktStatusName: "按时到学生"}
            ];
            $scope.getStatusName = function (ktStatus) {
                var ktStatusName = "";
                if (ktStatus == "all") {
                    ktStatusName = '应到学生';
                }
                if (ktStatus == "act") {
                    ktStatusName = '实到学生';
                }
                if (ktStatus == "1") {
                    ktStatusName = '请假学生';
                }
                if (ktStatus == "2") {
                    ktStatusName = '缺席学生';
                }
                if (ktStatus == "3") {
                    ktStatusName = '迟到学生';
                }
                if (ktStatus == "4") {
                    ktStatusName = '早退学生';
                }
                if (ktStatus == "5") {
                    ktStatusName = '按时到学生';
                }
                return ktStatusName;
            };
            $scope.ktStatusName = $scope.getStatusName($scope.ktStatus);
            $scope.classId = JSON.parse($location.search().item).classId;
            $scope.kqktId = JSON.parse($location.search().item).kqktId;
            $scope.emptyInfo = false;
            $scope.getData = function (func) {
                $scope.stuList = [];
                $http.get(originBaseUrl + '/third/attendance/queryKqktClassStudentCountInfo.htm?classId=' + $scope.classId + "&kqktId=" + $scope.kqktId + "&ktStatus=" + $scope.ktStatus + "&time=" + (new Date()).getTime()).success(function (data) {
                    if (data.status == 0) {
                        $scope.stuList = data.result;
                        angular.forEach($scope.stuList, function (item) {
                            item.isUnfold = false;
                            if (item.headUrl != "" && item.headUrl != null) {
                                item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
                            }
                        });
                        $scope.emptyInfo = false;
                        if ($scope.stuList && $scope.stuList.length > 0) {
                            $scope.isExistStu = true;
                        } else {
                            $scope.isExistStu = false;
                        }
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                    if (func) {
                        func();
                    }
                }).error(function () {
                    if (func) {
                        func();
                    }
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                });

            };
            $scope.clickUnfold = function (item) {
                if (!item.leave) {
                    return false;
                }
                item.isUnfold = !item.isUnfold;
            }
            $scope.doRefresh = function () {
                $ionicLoading.show({
                    template: '正在刷新...'
                });
                $scope.getData(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                });
            };
            $scope.doRefresh();
            $scope.doBack = function () {
                history.back(-1);
            };
        }])
    //班级宿舍统计
    .controller('dormitoryCtrl', ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', '$ionicSlideBoxDelegate', function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $ionicSlideBoxDelegate) {
        $ionicModal.fromTemplateUrl('dormitory_member.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal = modal;
        });
        $scope.selectDormitory = null;
        $scope.openDormitory = function (item) {
            $scope.selectDormitory = item;
            $scope.getDormitoryDetailInfo(item.dormitoryRoomId, $scope.showClassDormitoryInfo.platformSysAdminClassId);

        };
        $scope.closeDormitory = function () {
            $scope.modal.hide();
        };

        $ionicModal.fromTemplateUrl('dormitory_Administrator.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal1) {
            $scope.modal1 = modal1;
        });
        $scope.openAdministrator = function () {
            $scope.modal1.show();
        };
        $scope.closeAdministrator = function () {
            $scope.modal1.hide();
        };
        $scope.showClassDormitoryInfo = null;
        $scope.selectGender = "all";

        $scope.nextSlide = function () {
            $ionicSlideBoxDelegate.next();
        }
        $scope.previousSlide = function () {
            $ionicSlideBoxDelegate.previous();
        }

        $scope.selectGenderChange = function (gender) {
            $scope.selectGender = gender;
            setTimeout(function () {
                $scope.$apply();
            });
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicScrollDelegate.scrollTop();
        }
        //滑动框展示的数据集合固定3个
        $scope.slideList = [{}, {}, {}];
        //滑动框滑动之结束后调用
        $scope.slideChange = function (index) {
            var currentIndex = $ionicSlideBoxDelegate.currentIndex();
            if ($scope.classDormitoryInfoList && $scope.classDormitoryInfoList.length > 0) {
                $scope.showClassDormitoryInfo = $scope.slideList[index];
                $scope.selectGender = "all";
                setTimeout(function () {
                    $scope.$apply();
                });
                $ionicScrollDelegate.scrollTop();
                $scope.setNextAndPreviousClassInfo();
            }
        }
        //设置下一个班级和上一个班级信息
        $scope.setNextAndPreviousClassInfo = function () {
            var currentIndex = $ionicSlideBoxDelegate.currentIndex();
            var currentClassIndex = $scope.slideList[currentIndex].classIndex;
            if (currentClassIndex == $scope.classDormitoryInfoList.length - 1) {
                $scope.slideList[$scope.getNextAndPreviousSlideIndex("next")] = $scope.classDormitoryInfoList[0]
            } else {
                $scope.slideList[$scope.getNextAndPreviousSlideIndex("next")] = $scope.classDormitoryInfoList[currentClassIndex + 1]
            }
            if (currentClassIndex == 0) {
                $scope.slideList[$scope.getNextAndPreviousSlideIndex("previous")] = $scope.classDormitoryInfoList[$scope.classDormitoryInfoList.length - 1];
            } else {
                $scope.slideList[$scope.getNextAndPreviousSlideIndex("previous")] = $scope.classDormitoryInfoList[currentClassIndex - 1];
            }
        }
        //获取下一个或者上一个滑动框的序号
        $scope.getNextAndPreviousSlideIndex = function (type) {
            var currentIndex = $ionicSlideBoxDelegate.currentIndex();
            if (type == "next") {
                if (currentIndex == ($scope.slideList.length - 1)) {
                    return 0;
                } else {
                    return parseInt(currentIndex) + 1;
                }
            } else {
                if (currentIndex == 0) {
                    return $scope.slideList.length - 1;
                } else {
                    return parseInt(currentIndex) - 1;
                }
            }
        }
        $scope.queryClassDormitoryInfoByTeacher = function (func) {
            $http.get(originBaseUrl + '/third/classDormStatistics/queryClassDormitoryInfoByTeacher.htm?' + "_datatime=" + new Date().getTime()).success(function (data) {
                if (data.status == 0) {
                    $scope.emptyInfo = false;
                    $scope.classDormitoryInfoList = data.result;
                    angular.forEach($scope.classDormitoryInfoList, function (item, index) {
                        item.classIndex = index;
                    });
                    if ($scope.classDormitoryInfoList && $scope.classDormitoryInfoList.length > 0) {
                        var currentIndex = $ionicSlideBoxDelegate.currentIndex();
                        $scope.slideList[currentIndex] = $scope.classDormitoryInfoList[0];
                        $scope.setNextAndPreviousClassInfo();
                        $scope.showClassDormitoryInfo = $scope.classDormitoryInfoList[0];
                        if ($scope.classDormitoryInfoList.length == 1) {
                            //使滑动框不能滑动
                            $ionicSlideBoxDelegate.enableSlide(false);
                        } else {
                            $ionicSlideBoxDelegate.enableSlide(true);
                        }
                    } else {
                        //清空滑动框数据
                        $scope.slideList = [{}, {}, {}];
                        $ionicSlideBoxDelegate.enableSlide(false);
                    }
                } else {
                    ynuiNotification.error({msg: data.message});
                }
                if (func) {
                    func();
                }
                $ionicSlideBoxDelegate.update()
            }).error(function () {
                if (func) {
                    func();
                }
                $scope.emptyInfo = true;
                $scope.dataErrorMsg = '加载失败，请重试！';
            });
        }
        //刷新
        $scope.doRefresh = function (temp) {
            var template = '正在刷新...';
            if (temp) {
                template = temp;
            }
            $ionicLoading.show({
                template: template
            });
            $scope.classDormitoryInfoList = [];
            ;
            $scope.queryClassDormitoryInfoByTeacher(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };
        $scope.setectBedInfo = null;
        $scope.clickBedInfo = function (item) {
            $scope.setectBedInfo = item;
        }
        $scope.doRefresh("正在加载...");
        $scope.getDormitoryDetailInfo = function (dormitoryRoomId, platformSysAdminClassId) {
            $ionicLoading.show({
                template: "正在加载..."
            });
            $http.post(originBaseUrl + '/third/classDormStatistics/queryDormitoryDetailInfoById.htm?', {
                dormitoryRoomId: dormitoryRoomId,
                platformSysAdminClassId: platformSysAdminClassId
            }).success(function (data) {
                if (data.status == 0) {
                    $scope.bedDetailInfoList = data.result;
                    if ($scope.bedDetailInfoList.ssMobileBedDetailInfoVOList) {
                        for (var i = 0; i < $scope.bedDetailInfoList.ssMobileBedDetailInfoVOList.length; i++) {
                            if (!$scope.bedDetailInfoList.ssMobileBedDetailInfoVOList[i].isFreeBed) {
                                $scope.clickBedInfo($scope.bedDetailInfoList.ssMobileBedDetailInfoVOList[i]);
                                break;
                            }
                        }
                    }

                    $scope.modal.show();
                } else {
                    ynuiNotification.error({msg: data.message});
                }
                $ionicLoading.hide();
            }).error(function () {
                $ionicLoading.hide();
                ynuiNotification.error({msg: '加载失败！'});
            });
        }
    }]);

/**
 * 获取应用的basePath
 * @returns {string}
 */
function getBasePath() {
    //获取当前网址，如： http://localhost:8080/ems/Pages/Basic/Person.jsp
    var curWwwPath = location.href;
    //获取主机地址之后的目录，如： /ems/Pages/Basic/Person.jsp
    var pathName = location.pathname;
    var pos = curWwwPath.indexOf(pathName);
    //获取主机地址，如： http://localhost:8080
    var localhostPath = curWwwPath.substring(0, pos);
    //获取带"/"的项目名，如：/ems
    var projectName = pathName.substring(0, pathName.substr(1).indexOf('/') + 1);
    //获取项目的basePath   http://localhost:8080/ems
    var basePath = localhostPath + projectName;
    return basePath;
}

+function ($) {
    'use strict';

    // DROPDOWN CLASS DEFINITION
    // =========================

    var backdrop = '.dropdown-backdrop'
    var toggle = '[data-toggle="dropdown"]'
    var Dropdown = function (element) {
        $(element).on('click.bs.dropdown', this.toggle)
    };

    Dropdown.VERSION = '3.3.5'

    function getParent($this) {
        var selector = $this.attr('data-target')

        if (!selector) {
            selector = $this.attr('href')
            selector = selector && /#[A-Za-z]/.test(selector) && selector.replace(/.*(?=#[^\s]*$)/, '') // strip for ie7
        }

        var $parent = selector && $(selector)

        return $parent && $parent.length ? $parent : $this.parent()
    }

    function clearMenus(e) {
        if (e && e.which === 3) return
        $(backdrop).remove()
        $(toggle).each(function () {
            var $this = $(this)
            var $parent = getParent($this)
            var relatedTarget = {relatedTarget: this}
            if (e && (!$parent.hasClass('open') || $(e.target).parents('.holdon').length)) return;

            if (e && e.type == 'click' && /input|textarea/i.test(e.target.tagName) && $.contains($parent[0], e.target)) return;

            $parent.trigger(e = $.Event('hide.bs.dropdown', relatedTarget));

            if (e.isDefaultPrevented()) return;

            $this.attr('aria-expanded', 'false');
            $parent.removeClass('open').trigger('hidden.bs.dropdown', relatedTarget)
        })
    }

    Dropdown.prototype.toggle = function (e) {
        var $this = $(this)

        if ($this.is('.disabled, :disabled')) return

        var $parent = getParent($this)
        var isActive = $parent.hasClass('open')

        clearMenus();

        if (!isActive) {
            if ('ontouchstart' in document.documentElement && !$parent.closest('.navbar-nav').length) {
                // if mobile we use a backdrop because click events don't delegate
                $(document.createElement('div'))
                    .addClass('dropdown-backdrop')
                    .insertAfter($(this))
                    .on('click', clearMenus)
            }

            var relatedTarget = {relatedTarget: this}
            $parent.trigger(e = $.Event('show.bs.dropdown', relatedTarget))

            if (e.isDefaultPrevented()) return

            $this
                .trigger('focus')
                .attr('aria-expanded', 'true')

            $parent
                .toggleClass('open')
                .trigger('shown.bs.dropdown', relatedTarget)
        }

        return false
    };

    Dropdown.prototype.keydown = function (e) {
        if (!/(38|40|27|32)/.test(e.which) || /input|textarea/i.test(e.target.tagName)) return

        var $this = $(this);

        e.preventDefault();
        e.stopPropagation();

        if ($this.is('.disabled, :disabled')) return;

        var $parent = getParent($this);
        var isActive = $parent.hasClass('open');

        if (!isActive && e.which != 27 || isActive && e.which == 27) {
            if (e.which == 27) $parent.find(toggle).trigger('focus');
            return $this.trigger('click')
        }

        var desc = ' li:not(.disabled):visible a';
        var $items = $parent.find('.dropdown-menu' + desc);

        if (!$items.length) return;

        var index = $items.index(e.target)

        if (e.which == 38 && index > 0) index--;        // up
        if (e.which == 40 && index < $items.length - 1) index++;       // down
        if (!~index) index = 0;

        $items.eq(index).trigger('focus')
    };


    // DROPDOWN PLUGIN DEFINITION
    // ==========================

    function Plugin(option) {
        return this.each(function () {
            var $this = $(this);
            var data = $this.data('bs.dropdown');

            if (!data) $this.data('bs.dropdown', (data = new Dropdown(this)))
            if (typeof option == 'string') data[option].call($this)
        })
    }

    var old = $.fn.dropdown;

    $.fn.dropdown = Plugin;
    $.fn.dropdown.Constructor = Dropdown;


    // DROPDOWN NO CONFLICT
    // ====================

    $.fn.dropdown.noConflict = function () {
        $.fn.dropdown = old;
        return this
    };


    // APPLY TO STANDARD DROPDOWN ELEMENTS
    // ===================================

    $(document)
        .on('click.bs.dropdown.data-api', clearMenus)
        .on('click.bs.dropdown.data-api', '.dropdown form', function (e) {
            e.stopPropagation()
        })
        .on('click.bs.dropdown.data-api', toggle, Dropdown.prototype.toggle)
        .on('keydown.bs.dropdown.data-api', toggle, Dropdown.prototype.keydown)
        .on('keydown.bs.dropdown.data-api', '.dropdown-menu', Dropdown.prototype.keydown)

}(jQuery);