/*!
* app 初始化
* */
angular.module('starter').run(function ($ionicPlatform, $rootScope, $location) {
    $rootScope.isReady = false; // baseInfo初始化状态
    function ready(){
        $rootScope.isReady = true;
        $rootScope.$broadcast('isReady');//baseInfo初始化完成广播,由$stateChangeStart接收
    }
    $ionicPlatform.ready(function () {
        if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            cordova.plugins.Keyboard.disableScroll(true);
        }
        if (window.StatusBar) {
            StatusBar.styleLightContent();
        }
        if (!ionic.Platform.isAndroid()) {
            ionic.Platform.fullScreen(true, true);
            try {
                // iOS 需要显示select上面的完成
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
            } catch (e) {
                console.error('plugin: Keyboard not defined.');
            }
        }

        try {
            // 20210301
            yn.plugin.yncordova.baseInfo(function (data) {
                // 服务器地址、用户id、用户类型 初始化
                data = JSON.parse(data);
                if (data.access_token && data.userId && data.userType && data.originUrl) {
                    var access_token = data.access_token,
                        userId = data.userId,
                        userType = data.userType,
                        originUrl = data.originUrl;

                    $rootScope.authorizationStr = {
                        'access_token': access_token,
                        'userId': userId,
                        'userType': userType
                    };
                    originBaseUrl = $rootScope.originBaseUrl = originUrl;
                    if (window && window.localStorage) {
                        window.localStorage.setItem("authorizationStr", JSON.stringify($rootScope.authorizationStr));
                        window.localStorage.setItem("originBaseUrl", JSON.stringify($rootScope.originBaseUrl));
                    }
                } else {
                    if (window && window.localStorage) {
                        $rootScope.authorizationStr = JSON.parse(window.localStorage.getItem("authorizationStr"));
                        originBaseUrl = $rootScope.originBaseUrl = JSON.parse(window.localStorage.getItem("originBaseUrl"));
                    }
                }
                ready();
            }, function (error) {http://localhost:63342/www/app/microapp.html?_ijt=n0h5v02oc46ncv6ij98dg4cgka#/task_list
                console.log('error');
                ready();
            });
        } catch (e) {
            console.error('plugin: baseInfo() not defined.')
                //http://10.6.30.157:8080/ynedut/oauth/token.htm?produce_code=00&terminal_code=00&client_secret=e9ba823389393a9e5c7988ca21ea0d99&token_type=2&client_id=a5fcab81-05e1-4215-bb1a-54bc1712d5ae
            var access_token = "eyJqdGkiOiJjY2RmZThlNS1jMTk0LTRjMmMtOGIyOC01ZmI1OWU4YTY2NjUiLCJpc3MiOiIxIiwiYXVkIjoiMiIsImMiOiI5OTk5NyIsImV4cCI6MTYyOTcyMTYzMX0.EIkIXeuRm-Yq21nOOpyTEYSIiYCGymFpm9UCOYmvxFwLfzE_bnad9DXu3eGKH-ls_SdbZUvpc1YqlLNmAnOjoA",
                userId = "ccdfe8e5-c194-4c2c-8b28-5fb59e8a6665",
                userType = 1,
                originUrl = "http://localhost:8080/ynedut";

            $rootScope.authorizationStr = {
                'access_token': access_token,
                'userId': userId,
                'userType': userType
            };
            originBaseUrl = $rootScope.originBaseUrl = originUrl;
            if (window && window.localStorage) {
                window.localStorage.setItem("authorizationStr", JSON.stringify($rootScope.authorizationStr));
                window.localStorage.setItem("originBaseUrl", JSON.stringify($rootScope.originBaseUrl));
            }

            ready();
        }
    });

    var searchObj = $location.search();
    // 微应用id
    $rootScope.microId = null;
    if (searchObj.microId) {
        $rootScope.microId = searchObj.microId;
        if (window && window.localStorage) {
            window.localStorage.setItem("microId", JSON.stringify($rootScope.microId));
        }
    }else{
        if (window && window.localStorage) {
            $rootScope.microId = JSON.parse(window.localStorage.getItem("microId"));
        }
    }
    if (window.localStorage && window.localStorage.getItem($rootScope.microId)) {
        window.localStorage.removeItem($rootScope.microId);
    }
});
/*!
* 基础配置
* */
angular.module('starter').config(function ($stateProvider, $ionicConfigProvider, $urlRouterProvider) {
    // $ionicConfigProvider.scrolling.jsScrolling(true);/*这句处理android滚动异常问题*/
    $ionicConfigProvider.templates.maxPrefetch(0);
    $ionicConfigProvider.views.maxCache(0);
});
/*!
* http params format application/x-www-form-urlencoded
* */
angular.module('starter').config(function ($httpProvider) {
    //全局拦截器
    $httpProvider.interceptors.push('globalHttpInterceptor');

    $httpProvider.defaults.headers.put['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
    $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';

    var param = function (obj) {
        var query = "", name, value, fullSubName, subName, subValue, innerObj, i;
        for (name in obj) {
            value = obj[name];
            if (value instanceof Array) {
                for (i = 0; i < value.length; ++i) {
                    subValue = value[i];
                    fullSubName = name;
                    innerObj = {};
                    innerObj[fullSubName] = subValue;
                    query += param(innerObj) + '&';
                }
            } else if (value instanceof Object) {
                for (subName in value) {
                    subValue = value[subName];
                    fullSubName = name + "[" + subName + "]";
                    innerObj = {};
                    innerObj[fullSubName] = subValue;
                    query += param(innerObj) + "&";
                }
            } else if (value !== undefined && value !== null) {
                query += encodeURIComponent(name) + "=" + encodeURIComponent(value) + "&";
            }
        }
        return query.length ? query.substr(0, query.length - 1) : query;
    };
    $httpProvider.defaults.transformRequest = [function (data) {
        return angular.isObject(data) && String(data) !== "[object File]" ? param(data) : data;
    }];
});

angular.module('starter').factory('globalHttpInterceptor', ['$q', '$rootScope', '$injector', function ($q, $rootScope, $injector) {
    var reqTimes = 0,
        reqTime = 0;
    var $ionicLoading;
    return {
        // optional method
        'request': function (config) {
            $ionicLoading = $injector.get('$ionicLoading');
            if (/\.htm/.test(config.url) && !(/\.html/.test(config.url))) {
                if (!angular.element('loading-container visible').length && !/loading=disabled/.test(config.url)) {
                    $ionicLoading.show({
                        template:'<ion-spinner icon="ios"></ion-spinner>',
                        noBackdrop: true,
                        hideOnStateChange: true
                    }).then(function () {
                        reqTime = new Date().getTime()
                    });
                }

                if (window && window.localStorage && JSON.parse(window.localStorage.getItem("authorizationStr"))) {
                    $rootScope.authorizationStr = JSON.parse(window.localStorage.getItem("authorizationStr"));
                }

                config.headers.authorization = 'Bearer ' + $rootScope.authorizationStr.access_token;

                // if (config.method == 'GET') {
                //     if (/\?/.test(config.url)) {
                //         config.url += '&access_token=' + $rootScope.authorizationStr.access_token +
                //             '&userId=' + $rootScope.authorizationStr.userId +
                //             '&userType=' + $rootScope.authorizationStr.userType;
                //     } else {
                //         config.url += '?access_token=' + $rootScope.authorizationStr.access_token +
                //             '&userId=' + $rootScope.authorizationStr.userId +
                //             '&userType=' + $rootScope.authorizationStr.userType;
                //     }
                // } else {
                //     config.data = config.data || {};
                //     config.data.access_token = $rootScope.authorizationStr.access_token;
                //     config.data.userId = $rootScope.authorizationStr.userId;
                //     config.data.userType = $rootScope.authorizationStr.userType;
                //     // 过滤utf-16字符
                //     var dataString = JSON.stringify(config.data);
                //     var newDataString = dataString.replace(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g, '');
                //     config.data = JSON.parse(newDataString);
                // }
            }
            return config;
        },
        'requestError': function (rejection) {
            // do something on error
            $ionicLoading.hide();
            return $q.reject(rejection);
        },
        'response': function (response) {
            // do something on success
            reqTimes--;
            if (reqTimes < 1) {
                reqTimes = 0;
                var timeDif = new Date().getTime() - reqTime;
                if (timeDif < 300) {
                    var $timeout = $injector.get('$timeout');
                    $timeout(function () {
                        $ionicLoading.hide();
                    }, 300 - timeDif)
                } else {
                    $ionicLoading.hide();
                }
            }
            return response;
        },
        'responseError': function (rejection) {
            // do something on error
            $ionicLoading.hide();
            return $q.reject(rejection);
        }
    };
}]);
//onFinishRender
angular.module('starter').directive('onFinishRender', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function () {
                    scope.$emit('ngRepeatFinished');
                });
            }
        }
    }
});
//ynuiDatetimepicker fanjiaben
angular.module('starter').directive('ynuiDatetimepicker', [function () {
    return {
        restrict: 'A',
        require: '?ngModel',
        scope: {
            range: '@'
        },
        link: function (scope, elem, attr, ctrl) {
            var type = attr.ynuiDatetimepicker;
            var isRange = function () {
                return scope.range;
            };
            var rangeOpt = {
                mode: 'scroller',
                display: 'modal',
                lang: 'zh',
                stepMinute: 1,
                minWidth: 50,
                maxDate: new Date((new Date()).getFullYear() + 10, 11, 31, 23, 59),
                dateFormat: 'yyy-mm-dd',
                timeFormat: 'HH:ii'
            };
            var optDefault = {
                mode: 'scroller',
                display: 'modal',
                lang: 'zh',
                stepMinute: 1,
                minWidth: 50,
                maxDate: new Date((new Date()).getFullYear() + 10, 11, 31, 23, 59),
                dateFormat: 'yyy-mm-dd',
                timeFormat: 'HH:ii',
                onSelect: function (valueText, inst) {
                    if (ctrl) {
                        ctrl.$setViewValue(valueText);
                    }
                    if (isRange()) {
                        var rangeElem = angular.element('#' + scope.range);
                        rangeOpt.minDate = inst.getVal();
                        bindPicker(rangeElem, rangeOpt);
                        if (valueText > rangeElem.val() && rangeElem.val() != '') {
                            rangeElem.val(valueText);
                            if (ctrl) {
                                ctrl.$setViewValue(valueText);
                            }
                        }
                    }
                },
                onShow: function (html, valueText, inst) {

                },
                onHide: function (inst) {

                }
            };
            var bindPicker = function (bindElem, opt) {
                switch (type) {
                    case 'YMD':
                        bindElem.mobiscroll().date(opt);
                        break;
                    case 'HI':
                        bindElem.mobiscroll().time(opt);
                        break;
                    default :
                        bindElem.mobiscroll().datetime(opt);
                }
            };
            bindPicker(elem, optDefault);
        }
    }
}]);
angular.module('starter').directive('viewPicture', ['$ionicModal', function ($ionicModal) {
    return {
        restrict: 'A',
        link: function ($scope, elem, attrs) {
            $scope.modelIsRemove = false;
            $scope.picUrl = null;
            $scope.viewHeight = angular.element(window).height() - 44;
            elem.css('max-width', '100%');
            elem.on('click', function () {
                $scope.picUrl = attrs.src;
                $scope.openModal();
            });
            var template = '<ion-modal-view>' +
                '<ion-header-bar align-title="center">' +
                '<h1 class="title">预览</h1>' +
                '</ion-header-bar>' +
                '<ion-content>' +
                '<ion-scroll direction="xy" class="text-center" style="height: {{viewHeight}}px">' +
                '<img ng-src="{{picUrl}}">' +
                '</ion-scroll>' +
                '</ion-content>' +
                '</ion-modal-view>';
            $scope.pictureModel = $ionicModal.fromTemplate(template, {
                scope: $scope,
                animation: 'slide-in-up'
            });
            $scope.openModal = function () {
                if ($scope.modelIsRemove) {
                    $scope.pictureModel = $ionicModal.fromTemplate(template, {
                        scope: $scope,
                        animation: 'slide-in-up'
                    });
                }
                $scope.pictureModel.show().then(function () {
                    $scope.modelIsRemove = false;
                });
            };
            $scope.closeModal = function () {
                $scope.pictureModel.remove().then(function () {
                    $scope.modelIsRemove = true;
                });
            };
            // Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function () {
                $scope.pictureModel.remove();
            });
        }
    }
}]);
//头像预览
angular.module('starter').directive('viewHead', ['$ionicModal', function ($ionicModal) {
    return {
        restrict: 'A',
        link: function ($scope, elem, attrs) {
            $scope.modelIsRemove = false;
            $scope.picUrl = null;
            $scope.viewHeight = angular.element(window).height() - 44;
            elem.on('click', function ($event) {
                if (attrs.viewHead) {
                    $scope.picUrl = attrs.viewHead;
                } else {
                    $scope.picUrl = attrs.src;
                }
                if (!$scope.picUrl) {
                    return;
                }
                $scope.openModal();
                if ($event && $event.stopPropagation) {
                    $event.stopPropagation();
                }
            });
            var template = '<ion-modal-view>' +
                '<ion-header-bar align-title="center">' +
                '<h1 class="title">预览</h1>' +
                '</ion-header-bar>' +
                '<ion-content>' +
                '<ion-scroll delegate-handle="viewHeadIonScroll" direction="xy" class="text-center" style="height: {{viewHeight}}px">' +
                '<img ng-src="{{picUrl}}">' +
                '</ion-scroll>' +
                '</ion-content>' +
                '</ion-modal-view>';
            $scope.pictureModel = $ionicModal.fromTemplate(template, {
                scope: $scope,
                animation: 'slide-in-up'
            });
            $scope.openModal = function () {
                if ($scope.modelIsRemove) {
                    $scope.pictureModel = $ionicModal.fromTemplate(template, {
                        scope: $scope,
                        animation: 'slide-in-up'
                    });
                }
                $scope.pictureModel.show().then(function () {
                    $scope.modelIsRemove = false;
                });
            };
            $scope.closeModal = function () {
                $scope.pictureModel.remove().then(function () {
                    $scope.modelIsRemove = true;
                });
            };
            // Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function () {
                $scope.pictureModel.remove();
            });
        }
    }
}]);
//ynuiNotification fanjiaben
angular.module('starter').factory('ynuiNotification', [function () {
    var ynuiNotification = {};
    var optDefault = {
        "closeButton": false,
        "debug": false,
        "newestOnTop": false,
        "progressBar": false,
        "positionClass": "toast-top-center",
        "preventDuplicates": false,
        "onclick": null,
        "showDuration": "300",
        "hideDuration": "1000",
        "timeOut": "2000",
        "extendedTimeOut": "1000",
        "showEasing": "swing",
        "hideEasing": "linear",
        "showMethod": "fadeIn",
        "hideMethod": "fadeOut"
    };
    toastr.options = optDefault;
    var beforeShow = function (obj) {
        toastr.remove();
        toastr.options = angular.extend({}, optDefault, obj.opts);
    };
    ynuiNotification.warning = function (obj) {
        beforeShow(obj);
        toastr.warning(obj.msg, obj.title);
    };
    ynuiNotification.success = function (obj) {
        beforeShow(obj);
        toastr.success(obj.msg, obj.title);
    };
    ynuiNotification.error = function (obj) {
        beforeShow(obj);
        toastr.error(obj.msg, obj.title);
    };
    ynuiNotification.clear = function () {
        toastr.clear();
    };
    return ynuiNotification;
}]);

+function ($) {
    'use strict';

    // DROPDOWN CLASS DEFINITION
    // =========================

    var backdrop = '.dropdown-backdrop'
    var toggle = '[data-toggle="dropdown"]'
    var Dropdown = function (element) {
        $(element).on('click.bs.dropdown', this.toggle)
    };

    Dropdown.VERSION = '3.3.5'

    function getParent($this) {
        var selector = $this.attr('data-target')

        if (!selector) {
            selector = $this.attr('href')
            selector = selector && /#[A-Za-z]/.test(selector) && selector.replace(/.*(?=#[^\s]*$)/, '') // strip for ie7
        }

        var $parent = selector && $(selector)

        return $parent && $parent.length ? $parent : $this.parent()
    }

    function clearMenus(e) {
        if (e && e.which === 3) return
        $(backdrop).remove()
        $(toggle).each(function () {
            var $this = $(this)
            var $parent = getParent($this)
            var relatedTarget = {relatedTarget: this}
            if ( e && ( !$parent.hasClass('open') || $(e.target).parents('.holdon').length)) return;

            if (e && e.type == 'click' && /input|textarea/i.test(e.target.tagName) && $.contains($parent[0], e.target)) return;

            $parent.trigger(e = $.Event('hide.bs.dropdown', relatedTarget));

            if (e.isDefaultPrevented()) return;

            $this.attr('aria-expanded', 'false');
            $parent.removeClass('open').trigger('hidden.bs.dropdown', relatedTarget)
        })
    }

    Dropdown.prototype.toggle = function (e) {
        var $this = $(this)

        if ($this.is('.disabled, :disabled')) return

        var $parent = getParent($this)
        var isActive = $parent.hasClass('open')

        clearMenus();

        if (!isActive) {
            if ('ontouchstart' in document.documentElement && !$parent.closest('.navbar-nav').length) {
                // if mobile we use a backdrop because click events don't delegate
                $(document.createElement('div'))
                    .addClass('dropdown-backdrop')
                    .insertAfter($(this))
                    .on('click', clearMenus)
            }

            var relatedTarget = {relatedTarget: this}
            $parent.trigger(e = $.Event('show.bs.dropdown', relatedTarget))

            if (e.isDefaultPrevented()) return

            $this
                .trigger('focus')
                .attr('aria-expanded', 'true')

            $parent
                .toggleClass('open')
                .trigger('shown.bs.dropdown', relatedTarget)
        }

        return false
    };

    Dropdown.prototype.keydown = function (e) {
        if (!/(38|40|27|32)/.test(e.which) || /input|textarea/i.test(e.target.tagName)) return

        var $this = $(this);

        e.preventDefault();
        e.stopPropagation();

        if ($this.is('.disabled, :disabled')) return;

        var $parent = getParent($this);
        var isActive = $parent.hasClass('open');

        if (!isActive && e.which != 27 || isActive && e.which == 27) {
            if (e.which == 27) $parent.find(toggle).trigger('focus');
            return $this.trigger('click')
        }

        var desc = ' li:not(.disabled):visible a';
        var $items = $parent.find('.dropdown-menu' + desc);

        if (!$items.length) return;

        var index = $items.index(e.target)

        if (e.which == 38 && index > 0)                 index--;        // up
        if (e.which == 40 && index < $items.length - 1) index++;       // down
        if (!~index)                                    index = 0;

        $items.eq(index).trigger('focus')
    };


    // DROPDOWN PLUGIN DEFINITION
    // ==========================

    function Plugin(option) {
        return this.each(function () {
            var $this = $(this);
            var data = $this.data('bs.dropdown');

            if (!data) $this.data('bs.dropdown', (data = new Dropdown(this)))
            if (typeof option == 'string') data[option].call($this)
        })
    }

    var old = $.fn.dropdown;

    $.fn.dropdown = Plugin;
    $.fn.dropdown.Constructor = Dropdown;


    // DROPDOWN NO CONFLICT
    // ====================

    $.fn.dropdown.noConflict = function () {
        $.fn.dropdown = old;
        return this
    };


    // APPLY TO STANDARD DROPDOWN ELEMENTS
    // ===================================

    $(document)
        .on('click.bs.dropdown.data-api', clearMenus)
        .on('click.bs.dropdown.data-api', '.dropdown form', function (e) {
            e.stopPropagation()
        })
        .on('click.bs.dropdown.data-api', toggle, Dropdown.prototype.toggle)
        .on('keydown.bs.dropdown.data-api', toggle, Dropdown.prototype.keydown)
        .on('keydown.bs.dropdown.data-api', '.dropdown-menu', Dropdown.prototype.keydown)

}(jQuery);
