/**
 * Created by liulijiia on 2018/3/29.
 */
angular.module('enrollByOnlineNew', ['ionic', 'ksSwiper', 'staticModule', 'LocalStorageModule'])

    .run(function ($ionicPlatform) {
        $ionicPlatform.ready(function () {
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            }
            if (window.StatusBar) {
                StatusBar.styleDefault();
            }
        })
    })
    .config(function ($httpProvider) {
        $httpProvider.defaults.headers.put['Content-Type'] = 'application/x-www-form-urlencoded';
        $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
        var param = function (obj) {
            var query = "", name, value, fullSubName, subName, subValue, innerObj, i;
            for (name in obj) {
                value = obj[name];
                if (value instanceof Array) {
                    for (i = 0; i < value.length; ++i) {
                        subValue = value[i];
                        fullSubName = name;
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                } else if (value instanceof Object) {
                    for (subName in value) {
                        subValue = value[subName];
                        fullSubName = name + "[" + subName + "]";
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + "&";
                    }
                } else if (value !== undefined && value !== null) {
                    query += encodeURIComponent(name) + "=" + encodeURIComponent(value) + "&";
                }
            }
            return query.length ? query.substr(0, query.length - 1) : query;
        };
        $httpProvider.defaults.transformRequest = [function (data) {
            return angular.isObject(data) && String(data) !== "[object File]" ? param(data) : data;
        }];
    })//onFinishRender
    .directive('onFinishRender', function ($timeout) {
        return {
            restrict: 'A',
            link: function (scope, element, attr) {
                if (scope.$last === true) {
                    $timeout(function () {
                        scope.$emit('ngRepeatFinished');
                    });
                }
            }
        }
    })
    .directive('bindFile', [function () {
        return {
            require: "ngModel",
            restrict: 'A',
            link: function ($scope, el, attrs, ngModel) {
                el.unbind("change");
                el.bind('change', function (event) {
                    ngModel.$setViewValue(event.target.files[0]);
                    $scope.$apply();
                });
                $scope.$watch(function () {
                    return ngModel.$viewValue;
                }, function (value) {
                    if (!value) {
                        el.val("");
                    }
                });
            }
        };
    }])
    .factory('ynuiNotification', [function () {
        var ynuiNotification = {};
        var optDefault = {
            "closeButton": false,
            "debug": false,
            "newestOnTop": false,
            "progressBar": false,
            "positionClass": "toast-top-center",
            "preventDuplicates": false,
            "onclick": null,
            "showDuration": "300",
            "hideDuration": "1000",
            "timeOut": "2000",
            "extendedTimeOut": "1000",
            "showEasing": "swing",
            "hideEasing": "linear",
            "showMethod": "fadeIn",
            "hideMethod": "fadeOut"
        };
        toastr.options = optDefault;
        var beforeShow = function (obj) {
            toastr.remove();
            toastr.options = angular.extend({}, optDefault, obj.opts);
        };
        ynuiNotification.warning = function (obj) {
            beforeShow(obj);
            toastr.warning(obj.msg, obj.title);
        };
        ynuiNotification.success = function (obj) {
            beforeShow(obj);
            toastr.success(obj.msg, obj.title);
        };
        ynuiNotification.error = function (obj) {
            beforeShow(obj);
            toastr.error(obj.msg, obj.title);
        };
        ynuiNotification.clear = function () {
            toastr.clear();
        };
        return ynuiNotification;
    }])
    .controller('enrollByOnlineNewCtrl', ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location", "$ionicModal", "$ionicPopup", 'localStorageService',
        function ($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location, $ionicModal, $ionicPopup, localStorageService) {
            //刚加载页面时什么都不显示
            $scope.hasHttp = false;
            $scope.template = {};
            $scope.templateFunc = {};
            /*模态 下拉搜索 包括依赖和毕业学校*/
            $ionicModal.fromTemplateUrl('searchField.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.template.searchModal = modal;
            });
            $scope.templateFunc.openSearchModal = function () {
                $scope.template.searchModal.show();
            };
            $scope.templateFunc.closeSearchModal = function () {
                $scope.template.searchModal.hide();
            };
            /*模态 大文本*/
            $ionicModal.fromTemplateUrl('textareaField.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.template.textareaModal = modal;
            });
            $scope.templateFunc.openTextareaModal = function () {
                $scope.template.textareaModal.show();
            };
            $scope.templateFunc.closeTextareaModal = function () {
                $scope.template.textareaModal.hide();
            };
            /*模态 推荐人*/
            $ionicModal.fromTemplateUrl('presenterField.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.template.presenterModal = modal;
            });
            $scope.templateFunc.openPresenterModal = function () {
                $scope.template.presenterModal.show();
            };
            $scope.templateFunc.closePresenterModal = function () {
                $scope.template.presenterModal.hide();
            };
            /*复选*/
            $ionicModal.fromTemplateUrl('checkField.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.template.checkModal = modal;
            });
            $scope.templateFunc.openCheckModal = function () {
                $scope.template.checkModal.show();
            };
            $scope.templateFunc.closeCheckModal = function () {
                $scope.template.checkModal.hide();
            };
            /*模态 文本展示*/
            $ionicModal.fromTemplateUrl('viewText.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.template.viewTextModal = modal;
            });
            $scope.templateFunc.openViewTextModal = function () {
                $scope.template.viewTextModal.show();
            };
            $scope.templateFunc.closeViewTextModal = function () {
                $scope.template.viewTextModal.hide();
            };
            //是否全部展示字段
            $scope.conf = {
                isShow: false
            };
            $scope.moreFun = function () {
                $timeout(function () {
                    $scope.conf.isShow = true
                }, 100);
            };
            // $scope.isShow = false;
            $scope.emptyInfo = false;
            $scope.inNetworkReg = false;
            $scope.getOnlineData = function (func) {
                //判断是否在招生时间内
                $http.post(basePath + "/zsgl/registerOnline/queryInNetworkReg.htm?", {openid: openid}).success(function (data) {
                    if (data.status == 0) {

                        $scope.netConfig = data.result;

                        $scope.usedOpenid = data.result.usedOpenid;
                        if (!$scope.usedOpenid) {
                            $scope.inNetworkReg = data.result.inNetworkReg;
                            if ($scope.inNetworkReg || $scope.baseInfoId) {
                                getCustomFieldInfo();
                            }
                        }
                        $scope.emptyInfo = false;
                    } else {
                        $scope.emptyInfo = true;
                    }
                    $scope.dataErrorMsg = "";
                    if (func) {
                        func();
                    }
                    $scope.hasHttp = true;
                }).error(function () {
                    if (func) {
                        func();
                    }
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                    $scope.hasHttp = true;
                });
            };
            $scope.doRefresh = function () {
                $ionicLoading.show({
                    template: '正在刷新...'
                });
                $scope.getOnlineData(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                });
            };
            $scope.doRefresh();

            function getParam(name) {
                var search = document.location.search;
                var pattern = new RegExp("[?&]" + name + "\=([^&]+)", "g");
                var matcher = pattern.exec(search);
                var items = "";
                if (null != matcher) {
                    try {
                        items = decodeURIComponent(decodeURIComponent(matcher[1]));
                    } catch (e) {
                        try {
                            items = decodeURIComponent(matcher[1]);
                        } catch (e) {
                            items = matcher[1];
                        }
                    }
                }
                return items;
            }

            //是否修改
            $scope.baseInfoId = getParam('baseInfoId');
            var credentialType = getParam("credentialType");
            var credentialNumber = getParam("credentialNumber");
            var recruitType = getParam("recruitType");
            //新生办事大厅标志
            $scope.comeType = getParam('comeType');
            $scope.goBack = function(){
                window.location = '/ynedut/open/views/stu/index.html';
            };
            //修改title
            if($scope.baseInfoId){
                document.title = "修改报名信息";
            }
            //特殊组件的展示值 对象集合
            $scope.showNameParam = {};

            /**
             * 报名模板
             * @returns {number}
             */
            function getCode() {
                if($scope.baseInfoId){
                    //统一招生修改
                    if(recruitType == "1"){
                        return 23;
                    }
                    return 21;
                }
                return 12;
            }
            //布尔转字符串
            function booleanChangeStrNum(item) {
                if(item!=undefined){
                    if(item==true){
                        return "1";
                    }
                    if(item==false){
                        return "0";
                    }
                }
                return item;
            }
            //获取字段配置信息
            var getCustomFieldInfo = function () {
                //获取招生信息
                $http.post(basePath + '/zsgl/registerOnline/template/find.htm?baseInfoId=' + $scope.baseInfoId, {
                    code: getCode()
                }).success(function (data) {
                    if (data.status == 0) {

                        var resObj;
                        if (!$scope.baseInfoId) {
                            //添加
                            resObj = data.result;
                            //提交信息
                            $scope.studentVO = {};
                            var cacheVO = window.localStorage.getItem("enrollOnlineAppNew_studentVO");
                            if(cacheVO){
                                //取出来后立即销毁[缓存]
                                $scope.studentVO= JSON.parse(cacheVO);
                                window.localStorage.removeItem("enrollOnlineAppNew_studentVO");
                            }
                        } else {
                            resObj = data.result.fieldInfo;
                            //提交信息
                            $scope.studentVO = data.result.stuDataInfo;
                        }
                        if($scope.studentVO["subsidizeInfo"]){
                            $scope.studentVO["subsidizeInfo"]["isStipend"] = booleanChangeStrNum($scope.studentVO["subsidizeInfo"]["isStipend"]);
                            $scope.studentVO["subsidizeInfo"]["isIndemnify"] = booleanChangeStrNum($scope.studentVO["subsidizeInfo"]["isIndemnify"]);
                            $scope.studentVO["subsidizeInfo"]["isFree"] = booleanChangeStrNum($scope.studentVO["subsidizeInfo"]["isFree"]);
                            $scope.studentVO["subsidizeInfo"]["isFilingCard"] = booleanChangeStrNum($scope.studentVO["subsidizeInfo"]["isFilingCard"]);
                        }
                      if( $scope.studentVO["baseInfo"]){
                          $scope.studentVO["baseInfo"]["isFloatingPopulation"] = booleanChangeStrNum($scope.studentVO["baseInfo"]["isFloatingPopulation"]);
                          $scope.studentVO["baseInfo"]["isMigrateChildren"] = booleanChangeStrNum($scope.studentVO["baseInfo"]["isMigrateChildren"]);
                      }
                        $scope.stuRegisterFieldVO = resObj;

                        angular.forEach($scope.stuRegisterFieldVO.fieldList, function (item) {
                            if (!(item.filedTable in $scope.studentVO)) {
                                $scope.studentVO[item.filedTable] = {};
                            }
                            if (!(item.memberName in $scope.studentVO[item.filedTable])) {
                                $scope.studentVO[item.filedTable][item.memberName] = "";
                                //如果字段为空并且为证件号，判断是否是添加，如果是添加，需要回填字段
                                if (!$scope.baseInfoId) {
                                    if (['ticketNumber','regNumber','mobile'].indexOf(credentialType) != -1) {
                                        //准考证号、报名号、手机号
                                        if(item.memberName == credentialType){
                                            $scope.studentVO[item.filedTable][item.memberName] = credentialNumber;
                                        }
                                    } else {
                                        //回填证件类型
                                        if (item.memberName == "credentialType" && credentialType) {
                                            $scope.studentVO[item.filedTable][item.memberName] = credentialType;
                                        }
                                        //回填证件号码
                                        if (item.memberName == "credentialNumber" && credentialNumber) {
                                            $scope.studentVO[item.filedTable][item.memberName] = credentialNumber;
                                        }
                                    }
                                }
                            }
                            //转成字符串
                            if($scope.studentVO[item.filedTable][item.memberName]!=undefined){
                                $scope.studentVO[item.filedTable][item.memberName] += "";
                            }
                            if (item.componentType || item.componentType == 0) {
                                if (item.componentType == 6) {
                                    //是否入住
                                    $scope.changeStayStatusField(item, true);
                                } else if (item.componentType == 0 || item.componentType == 1 || item.componentType == 2 || item.componentType == 3 || item.componentType == 11 || item.componentType == 12) {
                                    //下拉搜索
                                    $scope.showNameParam[item.memberName] = "请选择";
                                    if($scope.studentVO[item.filedTable][item.memberName]){
                                        angular.forEach(item.dataList,function (value) {
                                            if(value.id ==$scope.studentVO[item.filedTable][item.memberName]){
                                                $scope.showNameParam[item.memberName] = value.name;
                                            }
                                        });
                                    }

                                    if(item.filedTable=="archivesInfo"&&item.memberName=="graduatedUniversity"&&!$scope.studentVO[item.filedTable].isSystemUniversity&&$scope.studentVO[item.filedTable][item.memberName]){
                                        $scope.showNameParam[item.memberName] = $scope.studentVO[item.filedTable][item.memberName];
                                    }
                                    setSearchFieldInfo(item);
                                } else if (item.componentType == 7) {
                                    //推荐人
                                    $scope.showNameParam[item.memberName] = "请选择";
                                    $scope.studentVO[item.filedTable]["innerPresenter"] = "";
                                    $scope.studentVO[item.filedTable]["outerPresenter"] = "";
                                } else if (item.componentType == 8) {
                                    //省市县组件
                                    setProvincialFieldInfo(item);
                                } else if (item.componentType == 10) {
                                    //级联查询企业组件
                                    $scope.studentVO[item.filedTable][item.memberName] = null;
                                    setCompanyFieldInfo(item);
                                    setWatchCompanyRelationProperty(item);
                                } else if (item.componentType == 13 || item.componentType == 14) {
                                    //下拉单选
                                    setSelectField(item);
                                }
                            } else {
                                if (item.controlType == 3) {
                                    //下拉单选
                                    setSelectField(item);
                                } else if (item.controlType == 5) {
                                    //单选按钮
                                    $scope.studentVO[item.filedTable][item.memberName] = item.dataList[0].id;
                                } else if (item.controlType == 6) {
                                    //日期组件
                                    if (item.isCurTime) {
                                        //获取当前时间
                                        $scope.studentVO[item.filedTable][item.memberName] = $scope.getNowDate(item);
                                    }
                                }
                            }

                        });
                        //初始化入住意向
                        if($scope.studentVO["admissionInfo"]&&!$scope.studentVO["admissionInfo"]["platformSysDormitoryTypeId"]){
                            $scope.studentVO["admissionInfo"]["platformSysDormitoryTypeId"] ="";
                        }

                        $scope.stuRegisterFieldList = $scope.stuRegisterFieldVO.fieldList;
                    }
                });
            };

            //查询入学须知
            function getNotice() {
                $http.post(basePath + "/zsgl/registerOnline/notice/find.htm").success(function (data) {
                    $scope.notice = data.result;
                    if ($scope.notice && $scope.notice.open && $scope.notice.noticeContent) {
                        //初始化第一次进入需要看须知
                        if(!window.localStorage.getItem("enrollOnlineAppNew_viewEnrollStuNotice") && !$scope.baseInfoId){
                            window.localStorage.setItem("enrollOnlineAppNew_viewEnrollStuNotice",true)
                            $scope.viewEnrollStuNotice();
                        }
                    }
                });
            }
            getNotice();
            //查看入学须知
            $scope.viewEnrollStuNotice = function () {
                var url = basePath + "/mobile/templates/enrollByOnline/viewEnrollStuNotice.jsp?1=1";
                if(openid){
                    url += "&openid=" + openid;
                }
                if($scope.baseInfoId){
                    url += "&baseInfoId=" + $scope.baseInfoId;
                }
                if(credentialType){
                    url += "&credentialType=" + credentialType;
                }
                if(credentialNumber){
                    url += "&credentialNumber=" + credentialNumber;
                }
                if(recruitType){
                    url += "&recruitType=" + recruitType;
                }
                //新生办事大厅跳转标志
                if($scope.comeType==1){
                    url += "&comeType=" + $scope.comeType;
                }
                //缓存用户输入的数据
                if($scope.studentVO){
                    window.localStorage.setItem("enrollOnlineAppNew_studentVO",JSON.stringify($scope.studentVO));
                }
                window.location.href = url;
            };
            /**
             * 组件相关信息
             */
            //组件配置信息
            $scope.customFieldInfo = {};
            //当前组件字段唯一属性名称
            $scope.memberName = "";
            /**
             * 下拉搜索组件相关
             */
                //初始化组件配置信息
            var setSearchFieldInfo = function (item) {
                    $scope.memberName = item.memberName;
                    if (!(item.memberName in $scope.customFieldInfo)) {
                        $scope.customFieldInfo[item.memberName] = {};
                        $scope.customFieldInfo[item.memberName].name = item.name;
                        $scope.customFieldInfo[item.memberName].notNull = item.notNull;
                        $scope.customFieldInfo[item.memberName].searchInputStr = "";
                        $scope.customFieldInfo[item.memberName].selectValue = $scope.studentVO[item.filedTable][item.memberName];
                        $scope.customFieldInfo[item.memberName].initDataList = angular.copy(item.dataList);
                        $scope.customFieldInfo[item.memberName].dataList = angular.copy(item.dataList);
                        //生源地过多动态改成动态查询
                        if (item.memberName == "zsStudentSourceId" && item.dataList.length > 500) {
                            $scope.customFieldInfo[item.memberName].initDataList = [];
                            $scope.customFieldInfo[item.memberName].dataList = [];
                            $scope.customFieldInfo[item.memberName].isDynimcSearch = true;
                            //初始化搜索状态
                            $scope.customFieldInfo[$scope.memberName].searchType = 1;
                        }
                        $scope.customFieldInfo[item.memberName].filedTable = item.filedTable;
                        if (item.componentType == 11) {
                            //毕业学校
                            $scope.customFieldInfo[item.memberName].hasCustom = true;
                            $scope.customFieldInfo[item.memberName].dataList.unshift({id: "custom", name: "用户自行添加"});
                            $scope.customFieldInfo[item.memberName].customValue = "";
                        } else {
                            $scope.customFieldInfo[item.memberName].hasCustom = false;
                        }
                        //建立监控依赖查询(item.componentType = 13的报读层次、校区本来就只受招生类型和年级限制  所以可以直接建立依赖  不需要在库里配置)
                        if (item.relationProperty && item.relationProperty.length > 0) {
                            setWatchRelationProperty(item);
                        }
                    }
                };
            //打开搜索搜索组件 包括专业 毕业学校
            $scope.openSearchTemplate = function (item) {
                setSearchFieldInfo(item);
                angular.element('input').css('display', 'none');
                angular.element('select').css('display', 'none');
                angular.element('textarea').css('display', 'none');
                //打开弹框
                $scope.templateFunc.openSearchModal();
            };
            //依赖监控查询
            var setWatchRelationProperty = function (item) {
                var url = "";
                if (item.componentType == 1 || item.componentType == 2 || item.componentType == 3) {
                    url = "/zsgl/registerOnline/queryRegSpecialty.htm?"
                } else if (item.componentType == 11) {
                    url = "/zsgl/registerOnline/findByZsStudentSourceIds.htm?"
                } else if (item.componentType == 12) {
                    url = "/zsgl/registerOnline/queryRegMajorInZsPlanByLevel.htm?"
                }
                item.relationProperty = item.relationProperty + ",archivesInfo.enrollType,archivesInfo.platformSysGrade";
                //存在级联关系
                var attrsOne = item.relationProperty.split(",");
                for (var i = 0; i < attrsOne.length; i++) {
                    var attrsTwo = attrsOne[i].split(".");
                    if (!(attrsTwo[0] in $scope.studentVO)) {
                        $scope.studentVO[attrsTwo[0]] = {};
                    }
                    if (!(attrsTwo[1] in $scope.studentVO[attrsTwo[0]])) {
                        $scope.studentVO[attrsTwo[0]][attrsTwo[1]] = "";
                    }
                    var names = "studentVO." + attrsTwo[0] + "." + attrsTwo[1];
                    $scope.$watch(names, function (newVal, oldVal) {
                        if (newVal != oldVal) {
                            var params = {};
                            params.enrollType = $scope.studentVO.archivesInfo.enrollType;
                            params.gradeId = $scope.studentVO.archivesInfo.platformSysGrade;
                            var attrsOne2 = item.relationProperty.split(",");
                            for (var i = 0; i < attrsOne2.length; i++) {
                                var attrsTwo2 = attrsOne2[i].split(".");
                                if (attrsTwo2[0] in $scope.studentVO && attrsTwo2[1] in $scope.studentVO[attrsTwo2[0]]) {
                                    params[attrsTwo2[1]] = $scope.studentVO[attrsTwo2[0]][attrsTwo2[1]];
                                }
                            }
                            $http.post(basePath + url, params).success(function (data) {
                                if (data.status == 0) {
                                    //下拉数据集合
                                    $scope.customFieldInfo[item.memberName].dataList = angular.copy(data.result);
                                    $scope.customFieldInfo[item.memberName].initDataList = angular.copy(data.result);
                                    $scope.customFieldInfo[item.memberName].searchInputStr = "";
                                    if ($scope.customFieldInfo[item.memberName].hasCustom) {
                                        $scope.customFieldInfo[item.memberName].dataList.unshift({
                                            id: "custom",
                                            name: "用户自行添加"
                                        });
                                    }
                                    var needClear = true;
                                    if (!$scope.customFieldInfo[item.memberName].hasCustom || $scope.customFieldInfo[item.memberName].selectValue != "custom") {
                                        angular.forEach($scope.customFieldInfo[item.memberName].dataList, function (ite) {
                                            if (ite.id == $scope.customFieldInfo[item.memberName].selectValue) {
                                                needClear = false;
                                            }
                                        });
                                        if (needClear) {
                                            $scope.clearSearchFunc(item);
                                        }
                                    }
                                }
                            })
                        }
                    });
                }
            };
            var oldParam = {};

            function getFieldKeys(componentType) {
                var keys = [];
                angular.forEach($scope.stuRegisterFieldList, function (value, key) {
                    if (componentType == value.componentType) {
                        keys.push(key);
                    }
                });
                return keys;
            }

            function getMemberNameKeys(memberName) {
                var keys = [];
                angular.forEach($scope.stuRegisterFieldList, function (value, key) {
                    if (memberName == value.memberName) {
                        keys.push(key);
                    }
                });
                return keys;
            }

            /**
             * 层次、校区级联
             */
            function watchLevelOrOrg(item) {
                if (item.memberName !== "enrollType" && item.memberName !== "platformSysGrade") {
                    return false;
                }
                var params = {};
                params.enrollType = $scope.studentVO.archivesInfo.enrollType;
                params.gradeId = $scope.studentVO.archivesInfo.platformSysGrade;
                if (!angular.equals(oldParam, params)) {
                    oldParam = angular.copy(params);
                    //层次
                    params.planId = "level";
                    $http.post(basePath + "/zsgl/registerOnline/orgOrLevel/find.htm?", angular.copy(params)).success(function (data) {
                        if (data.status == 0) {
                            var keys = getFieldKeys(13);
                            angular.forEach(keys, function (value) {
                                $scope.stuRegisterFieldList[value].dataList = angular.copy(data.result);
                                setSelectField($scope.stuRegisterFieldList[value]);
                            });
                        }
                    });
                    //校区
                    params.planId = "org";
                    $http.post(basePath + "/zsgl/registerOnline/orgOrLevel/find.htm?", angular.copy(params)).success(function (data) {
                        if (data.status == 0) {
                            var keys = getFieldKeys(14);
                            angular.forEach(keys, function (value) {
                                $scope.stuRegisterFieldList[value].dataList = angular.copy(data.result);
                                setSelectField($scope.stuRegisterFieldList[value]);
                            });
                        }
                    });
                }
            };
            /**
             * 需要根据全局设置判断弹框
             * qiucheng Lu
             * 2021年1月18日13:56:25
             */
            $http.post(basePath + "/zsgl/registerOnline/global/find.htm?").success(function (data) {
                if (data.status == 0) {
                    $scope.globalSet = data.result;
                }
            });

            //删除所选
            $scope.clearSearchFunc = function (item) {
                $scope.studentVO[item.filedTable][item.memberName] = "";
                $scope.showNameParam[item.memberName] = "请选择";
                $scope.customFieldInfo[item.memberName].selectValue = "";
                if ("customValue" in $scope.customFieldInfo[item.memberName]) {
                    $scope.customFieldInfo[item.memberName].customValue = "";
                }
                if ($scope.customFieldInfo[item.memberName].notNull) {
                    ynuiNotification.error({msg: "请选择" + $scope.customFieldInfo[item.memberName].name});
                }
                //清空报读要求
                if ("firstSpecialty,secondSpecialty,thirdSpecialty".indexOf(item.memberName) != -1) {
                    item.relatiomList = [];
                }
            };
            //搜索过滤
            $scope.filterData = function (ischange) {
                if (ischange && $scope.customFieldInfo[$scope.memberName].isDynimcSearch) {
                    return;
                }
                if ($scope.customFieldInfo[$scope.memberName].isDynimcSearch) {
                    if ($scope.memberName == "zsStudentSourceId") {
                        if (!$scope.customFieldInfo[$scope.memberName].searchInputStr) {
                            $scope.customFieldInfo[$scope.memberName].dataList = [];
                            //初始化搜索状态
                            $scope.customFieldInfo[$scope.memberName].searchType = 1;
                            return;
                        }
                        $http.post(basePath + "/zsgl/registerOnline/source/query.htm", {name: $scope.customFieldInfo[$scope.memberName].searchInputStr}).success(function (data) {
                            $scope.customFieldInfo[$scope.memberName].dataList = data;
                            if (!$scope.customFieldInfo[$scope.memberName].dataList || $scope.customFieldInfo[$scope.memberName].dataList.length == 0) {
                                //没有找到对应数据
                                $scope.customFieldInfo[$scope.memberName].searchType = -1;
                            } else {
                                $scope.customFieldInfo[$scope.memberName].searchType = 2;
                            }

                        })
                    }
                    return;
                }
                $scope.customFieldInfo[$scope.memberName].dataList = [];
                if ($scope.customFieldInfo[$scope.memberName].initDataList.length <= 0) {
                    $http.post(basePath + "/zsgl/registerOnline/graduateSchool/query.htm", {searchStr: $scope.customFieldInfo[$scope.memberName].searchInputStr}).success(function (data) {
                        $scope.customFieldInfo[$scope.memberName].dataList = data.result;
                        if ($scope.customFieldInfo[$scope.memberName].hasCustom) {
                            $scope.customFieldInfo[$scope.memberName].dataList.unshift({id: "custom", name: "用户自行添加"});
                        }
                    });
                } else {
                    if ($scope.customFieldInfo[$scope.memberName].searchInputStr) {
                        angular.forEach($scope.customFieldInfo[$scope.memberName].initDataList, function (item) {
                            if (item.name.indexOf($scope.customFieldInfo[$scope.memberName].searchInputStr) != -1) {
                                $scope.customFieldInfo[$scope.memberName].dataList.push(angular.copy(item));
                            }
                        });
                    } else {
                        $scope.customFieldInfo[$scope.memberName].dataList = angular.copy($scope.customFieldInfo[$scope.memberName].initDataList);
                    }
                    if ($scope.customFieldInfo[$scope.memberName].hasCustom) {
                        $scope.customFieldInfo[$scope.memberName].dataList.unshift({id: "custom", name: "用户自行添加"});
                    }
                }
            };
            //选择下拉
            $scope.selectFunc = function (item) {
                $scope.customFieldInfo[$scope.memberName].selectValue = item.id;
                if ($scope.customFieldInfo[$scope.memberName].hasCustom && item.id == "custom") {
                    $scope.customFieldInfo[$scope.memberName].customValue = "";
                    $scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable][$scope.memberName] = "";
                    $scope.showNameParam[$scope.memberName] = "";
                } else {
                    $scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable][$scope.memberName] = item.id;
                    $scope.showNameParam[$scope.memberName] = item.name;
                    $scope.templateFunc.closeSearchModal();
                    //报读要求
                    findRelatiom(item.id, $scope.memberName);
                }
            };

            /**
             * 获取专业方向报读要求
             */
            function findRelatiom(id, memberName) {
                if (!id || "firstSpecialty,secondSpecialty,thirdSpecialty".indexOf(memberName) == -1) {
                    return;
                }
                var param = {
                    gradeId: "",
                    enrollType: "",
                };
                if (id.indexOf("_") != -1) {
                    var obj = id.split("_");
                    param.schoolAreaOrgNo = obj[0];
                    param.levelId = obj[1];
                } else {
                    param.schoolAreaOrgNo = id;
                }
                $http.post(basePath + "/zsgl/registerOnline/relatiom/find.htm?", param).success(function (data) {
                    if (data.status == 0) {
                        $scope.stuRegisterFieldList[getMemberNameKeys(memberName)].relatiomList = [];
                        if (!data.result.length || data.result.length == 1 && data.result[0] == "允许报读该专业,但不提醒") {
                            return;
                        }
                        $scope.stuRegisterFieldList[getMemberNameKeys(memberName)].relatiomList = data.result;

                        $scope.openViewTextModal(data.result, true);
                    }
                });
            };
            //查看模态框内容
            $scope.openViewTextModal = function (relatiomList, view) {
                $scope.relatiomList = relatiomList;
                $scope.relatiomView = view;
                //弹框
                $scope.templateFunc.openViewTextModal();
            };
            //输入自定义输入框值
            $scope.changeCustom = function () {
                $scope.showNameParam[$scope.memberName] = $scope.customFieldInfo[$scope.memberName].customValue;
                $scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable][$scope.memberName] = $scope.customFieldInfo[$scope.memberName].customValue;
                if ($scope.customFieldInfo[$scope.memberName].notNull && !$scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable][$scope.memberName]) {
                    ynuiNotification.error({msg: $scope.customFieldInfo[$scope.memberName].name + "不能为空!"});
                }
                $scope.templateFunc.closeSearchModal();
            };
            /**
             *自定义单行输入框 包括毕业成绩
             */
                //初始化组件配置信息
            var setInputFieldInfo = function (item) {
                    if (!(item.memberName in $scope.customFieldInfo)) {
                        $scope.customFieldInfo[item.memberName] = {};
                        $scope.customFieldInfo[item.memberName].reg = getCheckRule(item);
                        $scope.customFieldInfo[item.memberName].patternMsg = getCustomMsg(item);
                    }
                };
            //获取最大长度
            $scope.getMaxLength = function (item) {
                var maxLength = item.length;
                if (item.checkRule == 6 || item.checkRule == 8) {
                    //负整数 或 整数
                    maxLength == 1;
                    return maxLength;
                }
                if (item.isNumber && item.checkRule == 0) {
                    //数字  且无验证规则  多一个负号位
                    maxLength += 1;
                    if (item.decimalLength && item.decimalLength > 0) {
                        //存在小数位
                        maxLength += 1 + item.decimalLength;
                    }
                    return maxLength;
                }
                return maxLength;
            };
            //获取验证 正则表达式
            var getCheckRule = function (item) {
                var cusCheckRule = "";
                if (item.isNumber && item.checkRule == 0) {
                    //数字 单行文本框
                    cusCheckRule = /^-?\d+\.?\d*$/;
                    if (item.length && item.length > 0) {
                        cusCheckRule = "cusCheckRule = /^\s*$|^-?" + (item.length == 0 ? "0" : "\\d{1," + item.length) + "}";
                        if (item.decimalLength && item.decimalLength > 0) {
                            cusCheckRule = cusCheckRule + (item.decimalLength == 0 ? "" : "(\\.\\d{1," + item.decimalLength + "})?");
                        }
                        cusCheckRule = cusCheckRule + "$/";
                        eval(cusCheckRule);
                    }
                } else {
                    if (item.checkRule != undefined && item.checkRule != null) {
                        switch (item.checkRule) {
                            case 1:
                                //IP地址
                                cusCheckRule = /^\s*$|^((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))))$/;
                                break;
                            case 2:
                                //英文字母
                                cusCheckRule = /^\s*$|^[a-zA-Z]+$/;
                                break;
                            case 3:
                                //英数字
                                cusCheckRule = /^\s*$|^[a-zA-Z0-9]+$/;
                                break;
                            case 4:
                                //汉字
                                cusCheckRule = /^\s*$|^[\u4E00-\u9FA5]+$/;
                                break;
                            case 5:
                                //email
                                cusCheckRule = /^\s*$|^\w+@\w+([.]{1}\w+)+$/;
                                break;
                            case 6:
                                //负整数  数字单行文本框的小数长度为0的时候会有这些验证
                                cusCheckRule = /^\s*$|^-[1-9]\d*$/;
                                break;
                            case 7:
                                //正整数 数字单行文本框的小数长度为0的时候会有这些验证
                                cusCheckRule = /^\s*$|^[1-9]\d*$/;
                                break;
                            case 8:
                                //整数
                                cusCheckRule = /^\s*$|^-?[1-9]\d*$/;
                                break;
                            default :
                        }
                    }
                }
                return cusCheckRule;
            };
            //验证未通过提示信息
            var getCustomMsg = function (item) {
                var msg = "";
                var error = {
                    msg0: '只能由汉字组成！',
                    msg1: '格式不正确！',
                    msg2: '只能由数字、字母组成！',
                    msg3: '只能由字母组成！',
                    msg4: '格式不正确!',
                    msg5: '只能由负整数组成！',
                    msg6: '只能由正整数组成！',
                    msg7: 'IP地址格式不正确！'
                };
                //数字无规则
                if (item.isNumber && item.checkRule == 0) {
                    msg = "最多只能输入" + item.length + "位整数";
                    if (item.decimalLength) {
                        msg += "和" + item.decimalLength+ "位小数";
                    }
                } else {
                    switch (item.checkRule) {
                        case 1: //IP地址
                            msg = error.msg7;
                            break;
                        case 2://英文字母
                            msg = error.msg3;
                            break;
                        case 3: //英数字
                            msg = error.msg2;
                            break;
                        case 4: //汉字
                            msg = error.msg0;
                            break;
                        case 5://email
                            msg = error.msg4;
                            break;
                        case 6://负整数
                            msg = error.msg5;
                            break;
                        case 7://正整数
                            msg = error.msg6;
                            break;
                        case 8://整数
                            msg = "只能输入最大长度为" + item.length + "位的整数";
                            break;
                        default:
                    }
                }
                return msg ? item.name + msg : "";
            };
            //修改input输入值
            $scope.changeInputField = function (item) {
                setInputFieldInfo(item);
                if (item.notNull && !$scope.studentVO[item.filedTable][item.memberName]) {
                    ynuiNotification.error({msg: item.name + "不能为空!"});
                } else if ($scope.customFieldInfo[item.memberName].reg && $scope.customFieldInfo[item.memberName].reg.test($scope.studentVO[item.filedTable][item.memberName]) === false) {
                    ynuiNotification.error({msg: $scope.customFieldInfo[item.memberName].patternMsg});
                }
            };
            /**
             * 证件号码组件相关
             */
            var setCredentialFieldInfo = function (item) {
                if (!(item.memberName in $scope.customFieldInfo)) {
                    $scope.customFieldInfo[item.memberName] = {};
                    $scope.customFieldInfo[item.memberName].reg = /^[a-zA-Z0-9]+$/;
                    $scope.customFieldInfo[item.memberName].patternMsg = item.name + "只能由数字、字母组成!";
                }
            };
            //获取证件号长度
            $scope.getCredentialMaxLength = function (item) {
                return item.length;
            };
            //修改证件号码
            $scope.changeCredentialField = function (item) {
                setCredentialFieldInfo(item);
                if ($scope.studentVO[item.filedTable][item.memberName]) {
                    if (!("credentialType" in $scope.studentVO[item.filedTable]) || ("credentialType" in $scope.studentVO[item.filedTable] && $scope.studentVO[item.filedTable]["credentialType"] == "01")) {
                        //当不存在证件类型 或者证件类型为身份证时 进行身份证号格式验证
                        if (checkCard($scope.studentVO[item.filedTable][item.memberName])) {
                            if ("baseInfo" in $scope.studentVO && "dateOfBirth" in $scope.studentVO.baseInfo) {
                                $scope.studentVO.baseInfo.dateOfBirth = nowBirthday;
                            }
                            var len = $scope.studentVO[item.filedTable][item.memberName].length;
                            if ("userInfo" in $scope.studentVO && "gender" in $scope.studentVO.userInfo) {//性别code
                                if (len == 18) {
                                    var sexStatus = $scope.studentVO[item.filedTable][item.memberName].substring(16, 17);
                                    if (sexStatus % 2 == 1) {
                                        $scope.studentVO.userInfo.gender = "1";
                                    } else {
                                        $scope.studentVO.userInfo.gender = "2";
                                    }
                                } else if (len == 15) {
                                    var sexStatus = $scope.studentVO[item.filedTable][item.memberName].substring(14, 15);
                                    if (sexStatus % 2 == 1) {
                                        $scope.studentVO.userInfo.gender = "1";
                                    } else {
                                        $scope.studentVO.userInfo.gender = "2";
                                    }
                                }
                            }
                        } else {
                            ynuiNotification.error({msg: "不是正确的身份证号!"});
                        }
                    } else {
                        if ($scope.customFieldInfo[item.memberName].reg && $scope.customFieldInfo[item.memberName].reg.test($scope.studentVO[item.filedTable][item.memberName]) === false) {
                            ynuiNotification.error({msg: $scope.customFieldInfo[item.memberName].patternMsg});
                        }
                    }
                } else {
                    if (item.notNull) {
                        ynuiNotification.error({msg: item.name + "不能为空!"});
                    }
                }
            };
            //从身份证号获取的出生日期
            var nowBirthday = "";
            //输入证件号码时同步更新性别及出生日期的相关方法
            //检查证件号
            var checkCard = function (obj) {
                //校验长度，类型
                if (isCardNo(obj) === false) {
                    return false;
                }
                //检查省份
                if (checkProvince(obj) === false) {
                    return false;
                }
                //校验生日
                if (checkBirthday(obj) === false) {

                    return false;
                }
                // 有效性
                if (cd(obj) === false) {
                    return false;
                }
                return true;
            };

            function cd(num) {
                //参数必须是字符串
                if (!(num === (num + ''))) {
                    return false;
                }
                num = num.toUpperCase();
                //身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X。
                if (!(/(^\d{15}$)|(^\d{17}([0-9]|X)$)/.test(num))) {
                    //身份证号格式不符合规定！15位号码应全为数字，18位号码末位可以为数字或X;
                    return false;
                }
                //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。
                var city = {
                    11: "北京",
                    12: "天津",
                    13: "河北",
                    14: "山西",
                    15: "内蒙古",
                    21: "辽宁",
                    22: "吉林",
                    23: "黑龙江 ",
                    31: "上海",
                    32: "江苏",
                    33: "浙江",
                    34: "安徽",
                    35: "福建",
                    36: "江西",
                    37: "山东",
                    41: "河南",
                    42: "湖北 ",
                    43: "湖南",
                    44: "广东",
                    45: "广西",
                    46: "海南",
                    50: "重庆",
                    51: "四川",
                    52: "贵州",
                    53: "云南",
                    54: "西藏 ",
                    61: "陕西",
                    62: "甘肃",
                    63: "青海",
                    64: "宁夏",
                    65: "新疆",
                    71: "台湾",
                    81: "香港",
                    82: "澳门",
                    91: "国外 "
                };

                if (!city[num.substr(0, 2)]) {
                    return false;
                }
                //下面分别分析出生日期和校验位
                var len, re;
                len = num.length;
                if (len == 15) {
                    re = new RegExp(/^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/);
                    var arrSplit = num.match(re);
                    //检查生日日期是否正确
                    var dtmBirth = new Date('19' + arrSplit[2] + '/' + arrSplit[3] + '/' + arrSplit[4]);
                    var bGoodDay;
                    bGoodDay = (dtmBirth.getYear() == Number(arrSplit[2]))
                        && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3]))
                        && (dtmBirth.getDate() == Number(arrSplit[4]));
                    if (!bGoodDay) {
                        //输入的身份证号里出生日期不对;
                        return false;
                    } else {
                        //将15位身份证转成18位
                        //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。
                        var arrInt = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
                        var arrCh = ['1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2'];
                        var nTemp = 0, i;
                        num = num.substr(0, 6) + '19' + num.substr(6, num.length - 6);
                        for (i = 0; i < 17; i++) {
                            nTemp += num.substr(i, 1) * arrInt[i];
                        }
                        num += arrCh[nTemp % 11];
                        len = num.length;
                    }
                }

                if (len == 18) {
                    re = new RegExp(/^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/);
                    var arrSplit = num.match(re);
                    //检查生日日期是否正确
                    var dtmBirth = new Date(arrSplit[2] + "/" + arrSplit[3] + "/" + arrSplit[4]);
                    var bGoodDay;
                    bGoodDay = (dtmBirth.getFullYear() == Number(arrSplit[2]))
                        && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3]))
                        && (dtmBirth.getDate() == Number(arrSplit[4]));
                    if (!bGoodDay) {
                        //输入的身份证号里出生日期不对;
                        return false;
                    } else {
                        //检验18位身份证的校验码是否正确。
                        //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。
                        var valnum;
                        var arrInt = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
                        var arrCh = ['1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2'];
                        var nTemp = 0;
                        for (var i = 0; i < 17; i++) {
                            nTemp += num.substr(i, 1) * arrInt[i];
                        }
                        valnum = arrCh[nTemp % 11];
                        if (valnum != num.substr(17, 1)) {
                            //校验码不正确;
                            return false;
                        }
                    }
                } else {
                    return false;
                }

                return true;
            }

            //身份证号验证
            var vcity = {
                11: "北京", 12: "天津", 13: "河北", 14: "山西", 15: "内蒙古",
                21: "辽宁", 22: "吉林", 23: "黑龙江", 31: "上海", 32: "江苏",
                33: "浙江", 34: "安徽", 35: "福建", 36: "江西", 37: "山东", 41: "河南",
                42: "湖北", 43: "湖南", 44: "广东", 45: "广西", 46: "海南", 50: "重庆",
                51: "四川", 52: "贵州", 53: "云南", 54: "西藏", 61: "陕西", 62: "甘肃",
                63: "青海", 64: "宁夏", 65: "新疆", 71: "台湾", 81: "香港", 82: "澳门", 91: "国外"
            };
            //检查号码是否符合规范，包括长度，类型
            var isCardNo = function (obj) {
                //身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X
                var reg = /(^\d{15}$)|(^\d{17}(\d|X)$)/;
                if (reg.test(obj) === false) {
                    return false;
                }
                return true;
            };
            //取身份证前两位,校验省份
            var checkProvince = function (obj) {
                var province = obj.substr(0, 2);
                if (vcity[province] == undefined) {
                    return false;
                }
                return true;
            };
            //校验日期
            var verifyBirthday = function (year, month, day, birthday) {
                var now = new Date();
                var now_year = now.getFullYear();
                //年月日是否合理
                if (birthday.getFullYear() == year && (birthday.getMonth() + 1) == month && birthday.getDate() == day) {
                    //判断年份的范围（3岁到100岁之间)
                    var time = now_year - year;
                    if (time >= 0 && time <= 130) {
                        return true;
                    }
                    return false;
                }
                return false;
            };
            //检查生日是否正确
            var checkBirthday = function (obj) {
                var len = obj.length;
                //身份证15位时，次序为省（3位）市（3位）年（2位）月（2位）日（2位）校验位（3位），皆为数字
                if (len == '15') {
                    var re_fifteen = /^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/;
                    var arr_data = obj.match(re_fifteen);
                    var year = arr_data[2];
                    var month = arr_data[3];
                    var day = arr_data[4];
                    var birthday = new Date('19' + year + '/' + month + '/' + day);
                    nowBirthday = year + '-' + month + '-' + day;
                    return verifyBirthday('19' + year, month, day, birthday);
                }
                //身份证18位时，次序为省（3位）市（3位）年（4位）月（2位）日（2位）校验位（4位），校验位末尾可能为X
                if (len == '18') {
                    var re_eighteen = /^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/;
                    var arr_data = obj.match(re_eighteen);
                    var year = arr_data[2];
                    var month = arr_data[3];
                    var day = arr_data[4];
                    var birthday = new Date(year + '/' + month + '/' + day);
                    nowBirthday = year + '-' + month + '-' + day;
                    return verifyBirthday(year, month, day, birthday);
                }
                return false;
            };
            /**
             * 是否住宿+入住意向
             */
            $scope.stayStatusList = [
                {id: "", name: "请选择"},
                {id: "true", name: "是"},
                {id: "false", name: "否"}
            ];
            var setStayStatusFieldInfo = function (item) {
                $scope.memberName = item.memberName;
                if (!(item.memberName in $scope.customFieldInfo)) {
                    $scope.customFieldInfo[item.memberName] = {};
                    $scope.customFieldInfo[item.memberName].dataList = angular.copy(item.dataList);
                    $scope.customFieldInfo[item.memberName].dataList.unshift({id: "", name: "请选择"});
                }
            };
            //更改是否住宿
            $scope.changeStayStatusField = function (item, isInit) {
                setStayStatusFieldInfo(item);
                if (!isInit) {
                    $scope.studentVO[item.filedTable]['platformSysDormitoryTypeId'] = "";
                }
                if ($scope.studentVO[item.filedTable][item.memberName] === "") {
                    if (!isInit && item.notNull) {
                        ynuiNotification.error({msg: "请选择" + item.name + "!"});
                    }
                }
            };
            //更改入住意向
            $scope.changeDormitoryTypeField = function (item) {
                if ($scope.studentVO[item.filedTable]['platformSysDormitoryTypeId'] == "") {
                    if (item.stayIntentionNotNull) {
                        ynuiNotification.error({msg: "请选择入住意向!"});
                    }
                }
                $scope.studentVO[item.filedTable]['stayStatus'] = "true";
            };
            /**
             * 推荐人组件相关
             */
            var setPresenterFieldInfo = function (item) {
                $scope.memberName = item.memberName;
                if (!(item.memberName in $scope.customFieldInfo)) {
                    $scope.customFieldInfo[item.memberName] = {};
                    $scope.customFieldInfo[item.memberName].notNull = item.notNull;
                    $scope.customFieldInfo[item.memberName].userType = "1";
                    $scope.customFieldInfo[item.memberName].searchInputStr = "";
                    $scope.customFieldInfo[item.memberName].selectValue = "";
                    $scope.customFieldInfo[item.memberName].dataList = [];
                    $scope.customFieldInfo[item.memberName].filedTable = item.filedTable;
                }
            };
            //打开校内推荐人弹框
            $scope.openPresenterTemplate = function (item) {
                setPresenterFieldInfo(item);
                //打开弹框
                angular.element('input').css('display', 'none');
                angular.element('select').css('display', 'none');
                angular.element('textarea').css('display', 'none');
                $scope.templateFunc.openPresenterModal();
            };
            //搜索查询教师学生
            $scope.filterPresenterData = function () {
                var oldStr = $scope.customFieldInfo[$scope.memberName].searchInputStr;
                setTimeout(function () {
                    //间隔500毫秒还是一样就查  连续输入太快就不查 间隔500毫秒查
                    if (oldStr == $scope.customFieldInfo[$scope.memberName].searchInputStr) {
                        $scope.customFieldInfo[$scope.memberName].dataList = [];
                        if ($scope.customFieldInfo[$scope.memberName].searchInputStr) {
                            $.ajax({
                                url: basePath + '/zsgl/registerOnline/queryNameNumberByName.htm?',
                                data: {
                                    type: $scope.customFieldInfo[$scope.memberName].userType,
                                    searchStr: $scope.customFieldInfo[$scope.memberName].searchInputStr
                                },
                                cache: false,
                                async: true,
                                type: "POST",
                                dataType: 'json',
                                success: function (data) {
                                    if (data.status == 0) {
                                        $scope.customFieldInfo[$scope.memberName].dataList = angular.copy(data.result);
                                        $scope.safeApply();
                                    }
                                }
                            });
                        }
                        $scope.safeApply();
                    }
                }, 500);
            };
            //选择校内推荐人
            $scope.selectPresenterFunc = function (item) {
                $scope.customFieldInfo[$scope.memberName].selectValue = item.id;
                $scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable]['innerPresenter'] = item.id;
                $scope.showNameParam[$scope.memberName] = item.name;
                if ($scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable]['innerPresenter'] && $scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable]['outerPresenter']) {
                    ynuiNotification.error({msg: "校内/校外推荐人只能填写一个!"});
                }
                $scope.templateFunc.closePresenterModal();
            };
            //删除校内推荐人
            $scope.clearPresenterFunc = function (item) {
                $scope.customFieldInfo[item.memberName].selectValue = "";
                $scope.studentVO[$scope.customFieldInfo[item.memberName].filedTable]['innerPresenter'] = "";
                $scope.showNameParam[item.memberName] = "";
                if ($scope.customFieldInfo[item.memberName].notNull && !$scope.studentVO[$scope.customFieldInfo[item.memberName].filedTable]['outerPresenter']) {
                    ynuiNotification.error({msg: "校内/校外推荐人不能全部为空!"});
                }
            };
            //修改校外推荐人
            $scope.changeOuterPresenterField = function (item) {
                setPresenterFieldInfo(item);
                if ($scope.studentVO[item.filedTable]['innerPresenter'] && $scope.studentVO[item.filedTable]['outerPresenter']) {
                    ynuiNotification.error({msg: "校内/校外推荐人只能填写一个!"});
                }
                if ($scope.customFieldInfo[item.memberName].notNull && !$scope.studentVO[item.filedTable]['innerPresenter'] && !$scope.studentVO[item.filedTable]['outerPresenter']) {
                    ynuiNotification.error({msg: "校内/校外推荐人不能全部为空!"});
                }
            };

            //回填地区
            function backProvicialField(item) {
                var code = $scope.studentVO[item.filedTable][item.memberName];
                if(!code){
                    return;
                }
                var codeList =[];

                for (var i = 0; i < $scope.stuRegisterFieldVO.areaList.length; i++) {
                   var ite = $scope.stuRegisterFieldVO.areaList[i];
                    if (ite.id ==code) {
                        code = ite.parentId;
                        codeList.push(ite.id);
                        break;
                    }
                }
                if (code) {
                    for (var i = 0; i < $scope.stuRegisterFieldVO.areaList.length; i++) {
                        var ite = $scope.stuRegisterFieldVO.areaList[i];
                        if (code && ite.id == code) {
                            code = ite.parentId;
                            codeList.push(ite.id);
                            break;
                        }
                    }
                }
                if(code){
                    for (var i = 0; i < $scope.stuRegisterFieldVO.areaList.length; i++) {
                        var ite = $scope.stuRegisterFieldVO.areaList[i];
                        if (ite.id ==code) {
                            codeList.push(ite.id);
                            break;
                        }
                    }
                }
                 //只有省
                if(codeList.length==1){
                    $scope.customFieldInfo[item.memberName].provincialId =codeList[0];
                }
                //有省市
                if(codeList.length==2){
                    $scope.customFieldInfo[item.memberName].citiesId = codeList[0];
                    $scope.customFieldInfo[item.memberName].provincialId =codeList[1];
                }
                //有省市县
                if(codeList.length==3){
                    $scope.customFieldInfo[item.memberName].countiesId = codeList[0];
                    $scope.customFieldInfo[item.memberName].citiesId = codeList[1];
                    $scope.customFieldInfo[item.memberName].provincialId =codeList[2];

                }

                if ($scope.customFieldInfo[item.memberName].provincialId) {
                    angular.forEach($scope.stuRegisterFieldVO.areaList, function (it) {
                        if ($scope.customFieldInfo[item.memberName].provincialId == it.parentId) {
                            $scope.customFieldInfo[item.memberName].citiesList.push(it);
                        }
                    });
                }
                if ($scope.customFieldInfo[item.memberName].citiesList.length > 0) {
                    $scope.customFieldInfo[item.memberName].citiesList.unshift({id: "", name: "请选择"});
                }

                if ($scope.customFieldInfo[item.memberName].citiesId) {
                    angular.forEach($scope.stuRegisterFieldVO.areaList, function (it) {
                        if ($scope.customFieldInfo[item.memberName].citiesId == it.parentId) {
                            $scope.customFieldInfo[item.memberName].countiesList.push(it);
                        }
                    });
                }
                if ($scope.customFieldInfo[item.memberName].countiesList.length > 0) {
                    $scope.customFieldInfo[item.memberName].countiesList.unshift({id: "", name: "请选择"});
                }

            }
            /**
             * 省市县 相关
             */
            var setProvincialFieldInfo = function (item) {
                if (!(item.memberName in $scope.customFieldInfo)) {
                    $scope.customFieldInfo[item.memberName] = {};
                    $scope.customFieldInfo[item.memberName].provincialId = "";
                    $scope.customFieldInfo[item.memberName].citiesId = "";
                    $scope.customFieldInfo[item.memberName].countiesId = "";
                    $scope.customFieldInfo[item.memberName].provincialList = [{id: "", name: "请选择"}];
                    angular.forEach($scope.stuRegisterFieldVO.areaList, function (ite) {
                        if (!ite.parentId) {
                            $scope.customFieldInfo[item.memberName].provincialList.push(ite);
                        }
                    });
                    $scope.customFieldInfo[item.memberName].citiesList = [];
                    $scope.customFieldInfo[item.memberName].countiesList = [];
                    $scope.customFieldInfo[item.memberName].filedTable = item.filedTable;
                    //回填地区
                    backProvicialField(item);
                    //选择省下拉
                    $scope.customFieldInfo[item.memberName].changeProvincialFunc = function (ite) {
                        $scope.memberName = ite.memberName;
                        $scope.customFieldInfo[ite.memberName].citiesList = [];
                        if ($scope.customFieldInfo[ite.memberName].provincialId) {
                            angular.forEach($scope.stuRegisterFieldVO.areaList, function (it) {
                                if ($scope.customFieldInfo[ite.memberName].provincialId == it.parentId) {
                                    $scope.customFieldInfo[ite.memberName].citiesList.push(it);
                                }
                            });
                        }
                        if ($scope.customFieldInfo[ite.memberName].citiesList.length > 0) {
                            $scope.customFieldInfo[ite.memberName].citiesList.unshift({id: "", name: "请选择"});
                        }
                        $scope.customFieldInfo[ite.memberName].countiesList = [];
                        $scope.customFieldInfo[ite.memberName].citiesId = "";

                        $scope.studentVO[ite.filedTable][ite.memberName] = $scope.customFieldInfo[ite.memberName].provincialId;
                        if (ite.notNull && !$scope.customFieldInfo[ite.memberName].provincialId) {
                            ynuiNotification.error({msg: "请选择" + ite.name + "(省/市)!"});
                        }
                    };
                    //选择市
                    $scope.customFieldInfo[item.memberName].changeCitiesFunc = function (ite) {
                        $scope.customFieldInfo[ite.memberName].countiesList = [];
                        if ($scope.customFieldInfo[ite.memberName].citiesId) {
                            angular.forEach($scope.stuRegisterFieldVO.areaList, function (it) {
                                if ($scope.customFieldInfo[ite.memberName].citiesId == it.parentId) {
                                    $scope.customFieldInfo[ite.memberName].countiesList.push(it);
                                }
                            });
                        }
                        if ($scope.customFieldInfo[ite.memberName].countiesList.length > 0) {
                            $scope.customFieldInfo[ite.memberName].countiesList.unshift({id: "", name: "请选择"});
                        }
                        $scope.customFieldInfo[ite.memberName].countiesId = "";
                        if ($scope.customFieldInfo[ite.memberName].citiesId) {
                            $scope.studentVO[ite.filedTable][ite.memberName] = $scope.customFieldInfo[ite.memberName].citiesId;
                        } else {
                            $scope.studentVO[ite.filedTable][ite.memberName] = $scope.customFieldInfo[ite.memberName].provincialId;
                        }
                        if (ite.notNull && !$scope.customFieldInfo[ite.memberName].citiesId) {
                            ynuiNotification.error({msg: "请选择" + ite.name + "(市/县)!"});
                        }
                    };
                    //选择县
                    $scope.customFieldInfo[item.memberName].changeCountiesFunc = function (ite) {
                        if ($scope.customFieldInfo[ite.memberName].countiesId) {
                            $scope.studentVO[ite.filedTable][ite.memberName] = $scope.customFieldInfo[ite.memberName].countiesId;
                        } else {
                            $scope.studentVO[ite.filedTable][ite.memberName] = $scope.customFieldInfo[ite.memberName].citiesId;
                        }
                        if (ite.notNull && !$scope.customFieldInfo[ite.memberName].countiesId) {
                            ynuiNotification.error({msg: "请选择" + ite.name + "(县)!"});
                        }
                    };
                }
            };
            /**
             * 级联查询企业
             */
            var setCompanyFieldInfo = function (item) {
                if (!(item.memberName in $scope.customFieldInfo)) {
                    $scope.customFieldInfo[item.memberName] = {};
                    $scope.customFieldInfo[item.memberName].dataList = angular.copy(item.dataList);
                }
            };
            //依赖监控查询
            var setWatchCompanyRelationProperty = function (item) {
                var url = "/zsgl/registerOnline/queryRegCompanyInZsPlan.htm?";
                //存在级联关系
                var attrsOne = item.relationProperty.split(",");
                for (var i = 0; i < attrsOne.length; i++) {
                    var attrsTwo = attrsOne[i].split(".");
                    if (!(attrsTwo[0] in $scope.studentVO)) {
                        $scope.studentVO[attrsTwo[0]] = {};
                    }
                    if (!(attrsTwo[1] in $scope.studentVO[attrsTwo[0]])) {
                        $scope.studentVO[attrsTwo[0]][attrsTwo[1]] = "";
                    }
                    var names = "studentVO." + attrsTwo[0] + "." + attrsTwo[1];
                    $scope.$watch(names, function (newVal, oldVal) {
                        if (newVal != oldVal) {
                            var params = {};
                            var attrsOne2 = item.relationProperty.split(",");
                            for (var i = 0; i < attrsOne2.length; i++) {
                                var attrsTwo2 = attrsOne2[i].split(".");
                                if (attrsTwo2[0] in $scope.studentVO && attrsTwo2[1] in $scope.studentVO[attrsTwo2[0]]) {
                                    params[attrsTwo2[1]] = $scope.studentVO[attrsTwo2[0]][attrsTwo2[1]];
                                }
                            }
                            //首先判断下，专业id是不是带有企业id,带有的话，需要截取（如：specialId_companyId）,否则不用截取
                            if (params.firstSpecialty && params.firstSpecialty.indexOf("_") != -1) {
                                var obj = params.firstSpecialty.split("_");
                                params.firstSpecialty = obj[0];
                                params.companyId = obj[1];
                            }
                            if (params.secondSpecialty && params.secondSpecialty.indexOf("_") != -1) {
                                var obj = params.secondSpecialty.split("_");
                                params.secondSpecialty = obj[0];
                                params.companyId = obj[1];
                            }
                            if (params.thirdSpecialty && params.thirdSpecialty.indexOf("_") != -1) {
                                var obj = params.thirdSpecialty.split("_");
                                params.thirdSpecialty = obj[0];
                                params.companyId = obj[1];
                            }
                            $http.post(basePath + url, params).success(function (data) {
                                if (data.status == 0) {
                                    //下拉数据集合
                                    $scope.customFieldInfo[item.memberName].dataList = angular.copy(data.result);
                                    var needClear = true;
                                    angular.forEach($scope.customFieldInfo[item.memberName].dataList, function (ite) {
                                        if (ite.id == $scope.studentVO[item.filedTable][item.memberName]) {
                                            needClear = false;
                                        }
                                    });
                                    if (needClear) {
                                        if ($scope.customFieldInfo[item.memberName].dataList && $scope.customFieldInfo[item.memberName].dataList.length > 0) {
                                            //默认选第一个 级联查询企业用
                                            $scope.studentVO[item.filedTable][item.memberName] = $scope.customFieldInfo[item.memberName].dataList[0].id;
                                        } else {
                                            $scope.studentVO[item.filedTable][item.memberName] = null;
                                        }
                                    }
                                }
                            })
                        }
                    });
                }
            };

            /**
             * 大文本弹出框
             */
            var setTexttareaFieldInfo = function (item) {
                $scope.memberName = item.memberName;
                if (!(item.memberName in $scope.customFieldInfo)) {
                    $scope.customFieldInfo[item.memberName] = {};
                    $scope.customFieldInfo[item.memberName].name = item.name;
                    $scope.customFieldInfo[item.memberName].notNull = item.notNull;
                    $scope.customFieldInfo[item.memberName].length = item.length;
                    $scope.customFieldInfo[item.memberName].filedTable = item.filedTable;
                }
            };
            //打开大文本弹框
            $scope.openTexttareaTemplate = function (item) {
                setTexttareaFieldInfo(item);
                angular.element('input').css('display', 'none');
                angular.element('select').css('display', 'none');
                angular.element('textarea').css('display', 'none');
                $scope.templateFunc.openTextareaModal();
            };
            //修改大文本
            $scope.changeTextFunc = function () {
                if ($scope.customFieldInfo[$scope.memberName].notNull && !$scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable][$scope.memberName]) {
                    ynuiNotification.error({msg: $scope.customFieldInfo[$scope.memberName].name + "不能为空!"});
                }
            };
            //删除大文本
            $scope.clearTexttareaFunc = function (item) {
                $scope.studentVO[item.filedTable][item.memberName] = "";
                if ($scope.customFieldInfo[item.memberName].notNull) {
                    ynuiNotification.error({msg: $scope.customFieldInfo[$scope.memberName].name + "不能为空!"});
                }
            };

            function filterConditionList(list) {
                var filters = [];
                angular.forEach(list,function (value) {
                    if(value.stuData && !value.decideResult){
                        filters.push(value);
                    }
                });
                return filters;
            };


            /***********************************衡阳技师特殊代码start**************************************/
            /**************************下面代码为处理【衡阳技师】特殊需求，如果后期不再需要，可删除下面的代码 | wangl 2018-05-30*****************/
            var henYangJiShi = {
                schoolCode: "0599",
                // 要过滤的报读层次名称
                filterLevelName: "预备技师4年制",
                // 招生对象
                recruitTargetList: [],
                // 报读层次
                schoolLevelList: [],
                // 是否匹配衡阳技师
                isMatchSchool: function () {
                    return this.schoolCode == schoolCode;
                },
                initData: function (item) {
                    if (this.isMatchSchool()) {
                        if (item.memberName) {
                            switch (item.memberName) {
                                case "recruitTarget":
                                    this.recruitTargetList = item.dataList;
                                    break;
                                case "regSchoolLevelId":
                                    this.schoolLevelList = item.dataList;
                                    break;
                                case "secondSchoolLevelId":
                                    this.schoolLevelList = item.dataList;
                                    break;
                                case "thirdSchoolLevelId":
                                    this.schoolLevelList = item.dataList;
                                    break;
                            }
                        }
                    }
                },
                /**
                 * 针对特殊学校的特殊需求增加的验证方法
                 * 需求：当用户选择【招生对象】为：应届初中毕业生、往届初中毕业生时，【报读层次】、【报读层次(第二志愿)】、【报读层次(第三志愿)】不能选择“预备技师4年制”
                 */
                validate: function (stuInfo) {
                    if (this.isMatchSchool()) {
                        // 招生对象
                        if (stuInfo.archivesInfo.recruitTarget) {
                            var recruitTargetName = this.getNameById(this.recruitTargetList, stuInfo.archivesInfo.recruitTarget);
                            if (recruitTargetName == "应届初中毕业生" || recruitTargetName == "往届初中毕业生") {
                                if (stuInfo.admissionInfo.regSchoolLevelId) {
                                    return this.valiateLevel(stuInfo.admissionInfo.regSchoolLevelId, 0, recruitTargetName);
                                }
                                if (stuInfo.admissionInfo.secondSchoolLevelId) {
                                    return this.valiateLevel(stuInfo.admissionInfo.secondSchoolLevelId, 1, recruitTargetName);
                                }
                                if (stuInfo.admissionInfo.thirdSchoolLevelId) {
                                    return this.valiateLevel(stuInfo.admissionInfo.thirdSchoolLevelId, 2, recruitTargetName);
                                }
                            }
                        }
                    }
                    return true;
                },
                valiateLevel: function (levelId, levelIndex, recruitTargetName) {
                    var levelArr = ["报读层次", "报读层次(第二志愿)", "报读层次(第三志愿)"];
                    if (levelId) {
                        var name = this.getNameById(this.schoolLevelList, levelId);
                        // 如果报读层次为“预备技师4年制”，不允许学生选择
                        if (name == this.filterLevelName) {
                            var obj = {
                                msg: "由于您选择的“招生对象”为【" + recruitTargetName + "】，“" + levelArr[levelIndex] + "”不能选择【" + this.filterLevelName + "】，请重新选择！",
                                opts: {
                                    timeOut: "4500"
                                }
                            };
                            ynuiNotification.error(obj);
                            return false;
                        }
                    }
                    return true;
                },
                getNameById: function (list, id) {
                    var name = "";
                    angular.forEach(list, function (item) {
                        if (id == item.id) {
                            name = item.name
                        }
                    });
                    return name;
                }
            };

            /***********************************衡阳技师特殊代码end**************************************/


            /**
             * 用户自定义扩展验证
             * @param stuInfo
             * @returns {boolean}
             */
            function customValidate(stuInfo) {
                // 注意：下面代码为处理【衡阳技师】特殊需求，如果后期不再需要，可删除下面的代码 | wangl 2018-05-30
                return henYangJiShi.validate(stuInfo);
            }

            /**
             * 用户自定义扩展初始化下拉单选数据
             * @param item
             */
            function customInitSelectData(item) {
                // 注意：下面代码为处理【衡阳技师】特殊需求，如果后期不再需要，可删除下面的代码 | wangl 2018-05-30
                henYangJiShi.initData(item);
            }


            /**
             * 下拉单选 相关
             */
            var setSelectField = function (item) {
                if (!item.dataList) {
                    item.dataList = [];
                }
                item.dataList.unshift({id: "", name: "请选择"});
                if (item.defaultCode && !$scope.studentVO[item.filedTable][item.memberName]) {
                    $scope.studentVO[item.filedTable][item.memberName] = item.defaultCode;
                }
                customInitSelectData(item);
            };

            //修改下拉单选
            $scope.changeSelectFunc = function (item) {
                if (item.notNull && !$scope.studentVO[item.filedTable][item.memberName]) {
                    ynuiNotification.error({msg: "请选择" + item.name + "!"});
                }
                /**
                 * 层次、校区级联
                 */
                watchLevelOrOrg(item);
            };
            /**
             * 复选框 相关
             */
            var setCheckFieldInfo = function (item) {
                $scope.memberName = item.memberName;
                if (!(item.memberName in $scope.customFieldInfo)) {
                    $scope.customFieldInfo[item.memberName] = {};
                    $scope.customFieldInfo[item.memberName].name = item.name;
                    $scope.customFieldInfo[item.memberName].notNull = item.notNull;
                    $scope.customFieldInfo[item.memberName].dataList = [];
                    angular.forEach(item.dataList, function (ite) {
                        var selectItem = angular.copy(ite);
                        selectItem.selected = false;
                        $scope.customFieldInfo[item.memberName].dataList.push(selectItem);
                    });
                    $scope.customFieldInfo[item.memberName].filedTable = item.filedTable;
                }
            };
            //打开复选框弹框
            $scope.openCheckTemplate = function (item) {
                setCheckFieldInfo(item);
                angular.element('input').css('display', 'none');
                angular.element('select').css('display', 'none');
                angular.element('textarea').css('display', 'none');
                $scope.templateFunc.openCheckModal();
            };
            //选择复选框值
            $scope.selectCheckFunc = function (item) {
                item.selected = !item.selected;
                $scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable][$scope.memberName] = "";
                angular.forEach($scope.customFieldInfo[$scope.memberName].dataList, function (ite) {
                    if (ite.selected) {
                        if ($scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable][$scope.memberName]) {
                            $scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable][$scope.memberName] += ",";
                        }
                        $scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable][$scope.memberName] += ite.id;
                    }
                });
                if ($scope.customFieldInfo[$scope.memberName].notNull && !$scope.studentVO[$scope.customFieldInfo[$scope.memberName].filedTable][$scope.memberName]) {
                    ynuiNotification.error({msg: $scope.customFieldInfo[$scope.memberName].name + "不能为空!"});
                }
            };
            //清空复选框值
            $scope.clearCheckFunc = function (item) {
                $scope.studentVO[item.filedTable][item.memberName] = "";
                angular.forEach($scope.customFieldInfo[item.memberName].dataList, function (ite) {
                    ite.selected = false;
                });
                if (item.notNull) {
                    ynuiNotification.error({msg: item.name + "不能为空!"});
                }
            };
            /**
             * 日期 相关
             */
            //获取当前时间
            $scope.getNowDate = function (item) {
                var nowDate;
                //yyyy-MM-dd
                if (item.checkRule == 9) {
                    nowDate = moment().format("YYYY-MM-DD");
                }
                // yyyy-MM-dd  HH:mm:ss
                if (item.checkRule == 10) {
                    nowDate = moment().format("YYYY-MM-DD HH:mm");
                }
                //HH:mm:ss
                if (item.checkRule == 11) {
                    nowDate = moment().format("HH:mm");
                }
                return nowDate;
            };
            //清除日期
            $scope.clearDateFunc = function (item) {
                $scope.studentVO[item.filedTable][item.memberName] = "";
                if (item.notNull) {
                    ynuiNotification.error({msg: item.name + "不能为空!"});
                }
            };

            /**
             * 收起
             */
            $scope.chevronUp = function () {
                $scope.conf.isShow = false;
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
                $scope.safeApply();
            };
            $scope.safeApply = function (fn) {
                var phase = this.$root.$$phase;
                if (phase == '$apply' || phase == '$digest') {
                    if (fn && (typeof(fn) === 'function')) {
                        fn();
                    }
                } else {
                    this.$apply(fn);
                }
            };
            /**
             * 提交
             */
            var submitCustomValidFunc = function (stuInfo) {
                var valid = true;
                for (var i = 0; i < $scope.stuRegisterFieldList.length; i++) {
                    if (!$scope.stuRegisterFieldList[i].componentType && $scope.stuRegisterFieldList[i].controlType == 6 && stuInfo[$scope.stuRegisterFieldList[i].filedTable][$scope.stuRegisterFieldList[i].memberName] && $scope.stuRegisterFieldList[i].checkRule != 9) {
                        //手机的时分秒组件只有分 没有秒 所有提交的时候把秒补充上
                        stuInfo[$scope.stuRegisterFieldList[i].filedTable][$scope.stuRegisterFieldList[i].memberName] += ":00";
                    }
                    if (stuInfo.admissionInfo.innerPresenter && stuInfo.admissionInfo.outerPresenter) {
                        ynuiNotification.error({msg: "校内/校外推荐人只能填写一个!"});
                        valid = false;
                        return;
                    }
                    if ($scope.stuRegisterFieldList[i].componentType == 11) {
                        //毕业学校  是否过长
                        if ($scope.studentVO[$scope.stuRegisterFieldList[i].filedTable][$scope.stuRegisterFieldList[i].memberName] && $scope.studentVO[$scope.stuRegisterFieldList[i].filedTable][$scope.stuRegisterFieldList[i].memberName].length > 100) {
                            ynuiNotification.error({msg: "毕业学校名称过长!"});
                            valid = false;
                            return;
                        }
                    }
                    //校验空值必填
                    if ($scope.stuRegisterFieldList[i].notNull && $scope.stuRegisterFieldList[i].componentType != 10) {//企业是必然有值的所以不做必填验证  选择无也算值
                        //是否住宿 和 推荐人 比较特殊 memberName不是实际要存到数据库的值
                        if ($scope.stuRegisterFieldList[i].componentType == 6) {
                            //是否住宿 判断是否必填
                            if (stuInfo.admissionInfo.stayStatus === undefined || stuInfo.admissionInfo.stayStatus === null || stuInfo.admissionInfo.stayStatus === "") {
                                ynuiNotification.error({msg: $scope.stuRegisterFieldList[i].name + "不能为空!"});
                                valid = false;
                                return;
                            } else if (stuInfo.admissionInfo.stayStatus == "true" && $scope.stuRegisterFieldList[i].stayIntentionNotNull) {
                                if (!stuInfo.admissionInfo.platformSysDormitoryTypeId) {
                                    ynuiNotification.error({msg: "入住意向不能为空!"});
                                    valid = false;
                                    return;
                                }
                            }
                        } else if ($scope.stuRegisterFieldList[i].componentType == 7) {
                            //推荐人判断是否必填
                            if (!stuInfo.admissionInfo.innerPresenter && !stuInfo.admissionInfo.outerPresenter) {
                                ynuiNotification.error({msg: "校内/校外推荐人不能全部为空!"});
                                valid = false;
                                return;
                            }
                        } else {
                            if ($scope.stuRegisterFieldList[i].componentType == 8) {
                                //省市县  必填需要 每个都填
                                if (!$scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName].provincialId) {
                                    ynuiNotification.error({msg: "请选择" + $scope.stuRegisterFieldList[i].name + "(省/市)!"});
                                    valid = false;
                                    return;
                                } else if (!$scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName].citiesId) {
                                    ynuiNotification.error({msg: "请选择" + $scope.stuRegisterFieldList[i].name + "(市/县)!"});
                                    valid = false;
                                    return;
                                } else if ($scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName].countiesList.length > 0 && !$scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName].countiesId) {
                                    ynuiNotification.error({msg: "请选择" + $scope.stuRegisterFieldList[i].name + "(县)!"});
                                    valid = false;
                                    return;
                                }
                            } else {
                                //判断是否必填
                                if (!stuInfo[$scope.stuRegisterFieldList[i].filedTable][$scope.stuRegisterFieldList[i].memberName]) {
                                    ynuiNotification.error({msg: $scope.stuRegisterFieldList[i].name + "不能为空!"});
                                    valid = false;
                                    return;
                                }
                            }
                        }
                    }
                    if ($scope.stuRegisterFieldList[i].componentType == 5 && stuInfo[$scope.stuRegisterFieldList[i].filedTable][$scope.stuRegisterFieldList[i].memberName]) {
                        //证件号码
                        if (!("credentialType" in stuInfo[$scope.stuRegisterFieldList[i].filedTable]) || ("credentialType" in stuInfo[$scope.stuRegisterFieldList[i].filedTable] && stuInfo[$scope.stuRegisterFieldList[i].filedTable]["credentialType"] == "01")) {
                            if (!checkCard(stuInfo[$scope.stuRegisterFieldList[i].filedTable][$scope.stuRegisterFieldList[i].memberName])) {
                                ynuiNotification.error({msg: "不是正确的身份证号!"});
                                valid = false;
                                break;
                            }
                        } else {
                            if ($scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName] && $scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName].reg && $scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName].reg.test(stuInfo[$scope.stuRegisterFieldList[i].filedTable][$scope.stuRegisterFieldList[i].memberName]) === false) {
                                ynuiNotification.error({msg: $scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName].patternMsg});
                                valid = false;
                                break;
                            }
                        }
                    }
                    //验证正则表达式
                    if (stuInfo[$scope.stuRegisterFieldList[i].filedTable][$scope.stuRegisterFieldList[i].memberName] && $scope.stuRegisterFieldList[i].memberName in $scope.customFieldInfo && "reg" in $scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName] && $scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName].reg) {
                        //需要验证正则表达式的
                        if ($scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName].reg.test(stuInfo[$scope.stuRegisterFieldList[i].filedTable][$scope.stuRegisterFieldList[i].memberName]) === false) {
                            ynuiNotification.error({msg: $scope.customFieldInfo[$scope.stuRegisterFieldList[i].memberName].patternMsg});
                            valid = false;
                            return;
                        }
                    }
                }
                return valid;
            };
            $scope.prcOperInfo = {inSubmit: false};//是否在提交中
            $scope.submitInfo = function () {
                setTimeout(function () {
                    if ($scope.prcOperInfo.inSubmit) {
                        return;
                    }
                    $scope.prcOperInfo.inSubmit = true;
                    var stuInfo = angular.copy($scope.studentVO);
                    if (!submitCustomValidFunc(stuInfo)) {
                        $scope.prcOperInfo.inSubmit = false;
                        return;
                    }
                    // 自定义扩展验证
                    if (!customValidate(stuInfo)) {
                        $scope.prcOperInfo.inSubmit = false;
                        return;
                    }
                    if (getParam("openid")) {
                        //通过微信公众号报名
                        stuInfo.baseInfo.weChatOpenId = getParam("openid");
                    }
                    //是否微信端
                    stuInfo.baseInfo.weChat = isWeChat();
                    var submitObj = {
                        stuVO: stuInfo,
                        needCheck: true,
                        goAdm: false,
                        fromType:getCode()
                };
                    //首先判断下，专业id是不是带有企业id,带有的话，需要截取（如：specialId_companyId）,否则不用截取
                    if (submitObj.stuVO.admissionInfo.firstSpecialty && submitObj.stuVO.admissionInfo.firstSpecialty.indexOf("_") != -1) {
                        var obj = submitObj.stuVO.admissionInfo.firstSpecialty.split("_");
                        submitObj.stuVO.admissionInfo.firstSpecialty = obj[0];
                        submitObj.stuVO.admissionInfo.firstCompany = obj[1];
                    } else {
                        submitObj.stuVO.admissionInfo.firstCompany = "";
                    }
                    if (submitObj.stuVO.admissionInfo.secondSpecialty && submitObj.stuVO.admissionInfo.secondSpecialty.indexOf("_") != -1) {
                        var obj = submitObj.stuVO.admissionInfo.secondSpecialty.split("_");
                        submitObj.stuVO.admissionInfo.secondSpecialty = obj[0];
                        submitObj.stuVO.admissionInfo.secondCompany = obj[1];
                    } else {
                        submitObj.stuVO.admissionInfo.secondCompany = "";
                    }
                    if (submitObj.stuVO.admissionInfo.thirdSpecialty && submitObj.stuVO.admissionInfo.thirdSpecialty.indexOf("_") != -1) {
                        var obj = submitObj.stuVO.admissionInfo.thirdSpecialty.split("_");
                        submitObj.stuVO.admissionInfo.thirdSpecialty = obj[0];
                        submitObj.stuVO.admissionInfo.thirdCompany = obj[1];
                    } else {
                        submitObj.stuVO.admissionInfo.thirdCompany = "";
                    }

                    justValid(submitObj);
                });
            };
            function isWeChat() {
                var ua = navigator.userAgent.toLowerCase();
                var result = ua.match(/MicroMessenger/i);
                return null != result && result.length >= 1;
            }

            function saveStuRegister(obj) {
                return $http.post(basePath + "/zsgl/registerOnline/saveStuRegister.htm",
                  parseParamForSpringMVC(obj)
                ).success(function (data) {
                    $scope.prcOperInfo.inSubmit = false;
                    if (data.status == 0) {
                        //提交成功
                        ynuiNotification.success({msg: "保存成功!"});
                        //新生办事大厅标志
                        if($scope.comeType==1){
                            setTimeout(function () {
                                $scope.goBack();
                            },500);
                            return;
                        }
                        //判断是否需要缴费
                        $scope.successToOpenPage(data.result.stuBaseInfoId, openid);
                    }
                    return data;
                }).error(function () {
                    $scope.prcOperInfo.inSubmit = false;
                });
            }

            function justValid(submitObj) {
                return $http.post(basePath + "/zsgl/registerOnline/justValid.htm",
                  parseParamForSpringMVC(submitObj)
                ).success(function (data) {
                    if (data.result.errorType == 1) {
                        $scope.errorInfoList = data.result.errorInfoList;
                        $ionicPopup.show({
                            template: '<p ng-repeat="item in errorInfoList">{{$index+1+":"}}{{item.failedReason}}</p>',
                            title: '提示',
                            scope: $scope,
                            buttons: [
                                {
                                    text: '<b>关闭</b>',
                                    type: 'button-positive',
                                    onTap: function () {
                                        $scope.prcOperInfo.inSubmit = false;
                                    }
                                }
                            ]
                        });
                    } else if (data.result.errorType == 2) {
                        //预警信息
                        $scope.popup = {
                            isShow: true,
                            otherWarnInfoList: data.result.conditionFailedInfoVOs,
                            //电话号码警告
                            contactWarnInfoList: data.result.contactWarnInfoList,
                            //证件号码警告
                            credentialWarnInfoList: data.result.credentialWarnInfoList,
                            tips: data.result.tips,
                            number: data.result.number
                        };
                        var isOpenDialog = false;//最终是否打开提示弹出
                        var template = "";
                        if ($scope.popup.contactWarnInfoList && $scope.popup.contactWarnInfoList.length > 0) {
                            if ($scope.popup.contactWarnInfoList[0].userName) {
                                template += "您已经在学校报过名且学籍状态为“" +
                                  "<strong>{{popup.contactWarnInfoList[0].userName.split(':')[1]}}</strong>”</span>，"
                            }
                        } else if ($scope.popup.credentialWarnInfoList && $scope.popup.credentialWarnInfoList.length > 0) {
                            if ($scope.popup.credentialWarnInfoList[0].userName) {
                                template = "您已经在学校报过名且学籍状态为“" +
                                  "<strong>{{popup.credentialWarnInfoList[0].userName.split(':')[1]}}</strong>”</span>"
                            }
                        }
                        if (template) {
                            if ($scope.globalSet && $scope.globalSet.entryAllow) {
                                template += "，请确认是否要继续提交报名信息？";
                                $ionicPopup.show({
                                    template: template,
                                    title: '提示',
                                    scope: $scope,
                                    buttons: [
                                        {
                                            text: '<b>提交</b>',
                                            type: 'button-positive',
                                            onTap: function () {
                                                $scope.prcOperInfo.inSubmit = true;
                                                submitObj.needCheck = false;
                                                submitObj.goAdm = true;
                                                var obj = angular.copy(submitObj);
                                                if ($scope.comeType!=1&&$scope.configStep && $scope.configStep.needMaterial && $scope.configStep.step === 4) {
                                                    // 到采集资料去再提交
                                                    localStorageService.set('stu', obj);
                                                    window.location.href = basePath + '/wx/stuRegister/index.html#/submit';
                                                } else {
                                                    saveStuRegister(obj);
                                                }
                                            }
                                        },
                                        {
                                            text: '<b>取消</b>',
                                            type: 'button-positive',
                                            onTap: function () {
                                                $scope.prcOperInfo.inSubmit = false;
                                            }
                                        }
                                    ]
                                });
                            } else {
                                template += "，不允许再报名！";
                                $ionicPopup.show({
                                    template: template,
                                    title: '提示',
                                    scope: $scope,
                                    buttons: [
                                        {
                                            text: '<b>确定</b>',
                                            type: 'button-positive',
                                            onTap: function () {
                                                $scope.prcOperInfo.inSubmit = false;
                                            }
                                        }
                                    ]
                                });
                            }
                            return false;
                        }
                        isOpenDialog = false;//最终是否打开提示弹出
                        if ($scope.popup.otherWarnInfoList && $scope.popup.otherWarnInfoList.length > 0) {
                            $scope.popup.isShow = false;//是否有专业满人或床位满员提示
                            var regHandleType;
                            var showBtn = false;
                            var spacialIds = [];

                            angular.forEach($scope.popup.otherWarnInfoList, function (data) {
                                var order = 1;
                                angular.forEach(data.conditionList, function (item) {
                                    if (item.decideResult && (item.admConditionCode == 5 || item.admConditionCode == 6)) {
                                        $scope.popup.isShow = true;
                                        isOpenDialog = true;
                                    }
                                    if (!item.decideResult) {
                                        item.order = order;
                                        isOpenDialog = true;
                                        order++;
                                    }
                                });
                                if (data.regHandleType && data.regHandleType == 2) {//不允许报名
                                    regHandleType = data.regHandleType;
                                    if (data.showBtn) {
                                        showBtn = true;
                                        spacialIds.push(data.specialId);
                                    }
                                }
                                //过滤后的list
                                data.filterConditionList = filterConditionList(data.conditionList);
                            });
                            if ($scope.popup.isShow && isOpenDialog) {
                                $ionicPopup.show({
                                    template: ' <div  ng-repeat="item in popup.otherWarnInfoList">\n' +
                                      '            <label ng-repeat="data in item.conditionList">\n' +
                                      '                <strong>{{data.specialTip}}</strong>{{data.tipInfo}}<br>\n' +
                                      // '                <span>{{data.tips}}</span>\n' +
                                      '            </label>\n' +
                                      '        </div>',
                                    title: '提示',
                                    scope: $scope,
                                    buttons: [
                                        {
                                            text: '<b>关闭</b>',
                                            type: 'button-positive',
                                            onTap: function () {
                                                $scope.prcOperInfo.inSubmit = false;
                                            }
                                        }
                                    ]
                                });
                            } else if (regHandleType && regHandleType == 2 && isOpenDialog) {
                                if (showBtn) {
                                    $ionicPopup.show({
                                        template:
                                          '<label>本次报读{{popup.number}}个专业，其中<strong>{{popup.tips}}</strong>不符合报读要求，请重新选择报读其他专业！</label>' +
                                          '  </div>',
                                        title: '提示',
                                        scope: $scope,
                                        buttons: [
                                            {
                                                text: '<b>放弃并继续报名</b>',
                                                type: 'button-positive',
                                                onTap: function () {
                                                    $scope.prcOperInfo.inSubmit = true;
                                                    submitObj.needCheck = false;
                                                    submitObj.goAdm = false;
                                                    if (spacialIds.indexOf(submitObj.stuVO.admissionInfo.secondSpecialty) != -1) {
                                                        submitObj.stuVO.admissionInfo.secondSpecialty = "";
                                                        submitObj.stuVO.admissionInfo.secondSchoolLevelId = "";
                                                        submitObj.stuVO.admissionInfo.secondSchoolAreaOrgNo = "";
                                                        submitObj.stuVO.admissionInfo.secondCompany = "";
                                                    }
                                                    if (spacialIds.indexOf(submitObj.stuVO.admissionInfo.thirdSpecialty) != -1) {
                                                        submitObj.stuVO.admissionInfo.thirdSpecialty = "";
                                                        submitObj.stuVO.admissionInfo.thirdSchoolLevelId = "";
                                                        submitObj.stuVO.admissionInfo.thirdSchoolAreaOrgNo = "";
                                                        submitObj.stuVO.admissionInfo.thirdCompany = "";
                                                    }
                                                    var obj = angular.copy(submitObj);
                                                    if ($scope.comeType!=1&&$scope.configStep && $scope.configStep.needMaterial && $scope.configStep.step === 4) {
                                                        // 到采集资料去再提交
                                                        localStorageService.set('stu', obj);
                                                        window.location.href = basePath + '/wx/stuRegister/index.html#/submit';
                                                    } else {
                                                        saveStuRegister(obj);
                                                    }
                                                }
                                            },
                                            {
                                                text: '<b>关闭</b>',
                                                type: 'button-positive',
                                                onTap: function () {
                                                    $scope.prcOperInfo.inSubmit = false;
                                                }
                                            }
                                        ]
                                    });
                                } else {
                                    $ionicPopup.show({
                                        template:
                                          '<label>本次报读{{popup.number}}个专业，其中<strong>{{popup.tips}}</strong>不符合报读要求，请重新选择报读其他专业！</label>' +
                                          '  </div>',
                                        title: '提示',
                                        scope: $scope,
                                        buttons: [
                                            {
                                                text: '<b>取消</b>',
                                                type: 'button-positive',
                                                onTap: function () {
                                                    $scope.prcOperInfo.inSubmit = false;
                                                }
                                            },
                                            {
                                                text: '<b>查看要求</b>',
                                                type: 'button-positive',
                                                onTap: function () {
                                                    //弹框
                                                    $scope.openViewTextModal(null, false);
                                                    $scope.prcOperInfo.inSubmit = false;
                                                }
                                            }
                                        ]
                                    });
                                }
                            } else {
                                if (isOpenDialog) {
                                    $ionicPopup.show({
                                        template:
                                          '<label>本次报读{{popup.number}}个专业，其中<strong>{{popup.tips}}</strong>不符合报读要求。请确认是否提交报名信息？</label>',
                                        title: '提示',
                                        scope: $scope,
                                        buttons: [
                                            {
                                                text: '<b>提交</b>',
                                                type: 'button-positive',
                                                onTap: function () {
                                                    $scope.prcOperInfo.inSubmit = true;
                                                    submitObj.needCheck = false;
                                                    submitObj.goAdm = false;
                                                    var obj = angular.copy(submitObj);
                                                    if ($scope.comeType!=1&&$scope.configStep && $scope.configStep.needMaterial && $scope.configStep.step === 4) {
                                                        // 到采集资料去再提交
                                                        localStorageService.set('stu', obj);
                                                        window.location.href = basePath + '/wx/stuRegister/index.html#/submit';
                                                    } else {
                                                        saveStuRegister(obj);
                                                    }
                                                }
                                            },
                                            {
                                                text: '<b>查看要求</b>',
                                                type: 'button-positive',
                                                onTap: function () {
                                                    angular.forEach($scope.popup.otherWarnInfoList, function (value) {
                                                        if (value.specialId) {
                                                            var specialIds = value.specialId.split(":");
                                                            var keys = getFieldKeys(specialIds[0]);
                                                            if (keys.length) {
                                                                value.relatiomList = $scope.stuRegisterFieldList[keys[0]].relatiomList;
                                                            }
                                                        }
                                                    });
                                                    //弹框
                                                    $scope.openViewTextModal(null, false);
                                                    $scope.prcOperInfo.inSubmit = false;
                                                }
                                            }
                                        ]
                                    });
                                } else {
                                    $scope.prcOperInfo.inSubmit = true;
                                    //直接保存
                                    submitObj.needCheck = false;
                                    submitObj.goAdm = false;
                                    var obj = angular.copy(submitObj);
                                    if ($scope.comeType!=1&&$scope.configStep && $scope.configStep.needMaterial && $scope.configStep.step === 4) {
                                        // 到采集资料去再提交
                                        localStorageService.set('stu', obj);
                                        window.location.href = basePath + '/wx/stuRegister/index.html#/submit';
                                    } else {
                                        saveStuRegister(obj);
                                    }
                                }

                            }
                        }
                    } else {
                        if ($scope.comeType!=1&&$scope.configStep && $scope.configStep.needMaterial && $scope.configStep.step === 4) {
                            // 到采集资料去再提交
                            localStorageService.set('stu', submitObj);
                            window.location.href = basePath + '/wx/stuRegister/index.html#/submit';
                        } else {
                            saveStuRegister(submitObj);
                        }
                    }
                    return data;
                });
            }

            //保存成功后，判断是否需要缴费
            $scope.successToOpenPage = function (stuBaseInfoId, openid) {
                //修改的时候
                if($scope.baseInfoId){
                    var url = basePath + "/admitResultQuery/admitResultQuery.htm?";
                    if ($scope.studentVO) {
                        //准考证号
                        if ($scope.studentVO.archivesInfo && $scope.studentVO.archivesInfo.examineeNumber) {
                            url += "credentialNumber=" + $scope.studentVO.archivesInfo.examineeNumber + "&credentialType=ticketNumber";
                        }
                        //证件号码
                        var userInfo = $scope.studentVO.userInfo;
                        if (userInfo && userInfo.credentialNumber) {
                            url += "credentialNumber=" + userInfo.credentialNumber + "&";
                            if (userInfo.credentialType) {
                                url += "credentialType=" + userInfo.credentialType;
                            } else {
                                url += "credentialType=01";
                            }
                        }
                    }
                    setTimeout(function () {
                        window.location.href = url;
                    },500);
                    return false;
                }
                var payConfig = {};
                //获取缴费配置
                $.ajax({
                    url: basePath + '/zsgl/registerOnline/judgeGotoPay.htm',
                    data: {stuBaseInfoId: stuBaseInfoId, fromType: 12},
                    cache: false,
                    async: false,
                    type: "POST",
                    dataType: 'json',
                    success: function (data2) {
                        if (data2.status == 0) {
                            payConfig = data2.result;
                        }
                    }
                });
                //获取采集配置
                var collection = {};
                $.ajax({
                    url: basePath + '/zsgl/registerOnline/netRegisterStuMaterialConfig.htm',
                    data: {stuBaseInfoId: stuBaseInfoId},
                    cache: false,
                    async: false,
                    type: "POST",
                    dataType: 'json',
                    success: function (data) {
                        if (data.status == 0) {
                            collection = data.result;
                        }
                    }
                });
                var specialtyName = payConfig.goPay && payConfig.payStage == 0 ? payConfig.specialtyName : collection.specialtyName;
                var button = [];
                //缴费
                if (payConfig.goPay && payConfig.payStage == 0) {
                    button.push({
                        text: '立即缴费',
                        type: 'button-positive',
                        onTap: function (e) {
                            //跳转到缴费页面
                            // window.open(basePath + "/wx/prepay/index.html#/payinfo?openid=" + openid + "&type=" + payConfig.numberType + "&number=" + payConfig.numberStr);
                            window.open(basePath + '/wx/prepay/index.html#/?openid=' + openid + "&stuBaseInfoId=" + stuBaseInfoId);
                        }
                    })
                }
                //采集
                if (collection.step == 0) {
                    button.push({
                        text: '立即采集',
                        type: 'button-positive',
                        onTap: function (e) {
                            //跳转到缴费页面
                            // window.open(basePath + "/wx/stuRegister/index.html");
                            window.open(basePath + '/wx/stuRegister/index.html#/stuSearch?openid=' + openid + "&stuBaseInfoId=" + stuBaseInfoId);
                        }
                    })
                }
                //跳转预交费或者资料采集
                if (((payConfig.goPay && payConfig.payStage == 0) || collection.step == 0) && openid) {
                    var str = "您报读的“'" + specialtyName + "'”专业报名成功后需";
                    if (payConfig.goPay && payConfig.payStage == 0) {
                        str += "<strong style='color: red'>预缴费</strong>";
                    }
                    str += (payConfig.goPay && payConfig.payStage == 0 && collection.step == 0) ? "和" : "";
                    if (collection.step == 0) {
                        str += "<strong style='color: red'>采集上报照片资料</strong>";
                    }
                    $ionicPopup.show({
                        template: str,
                        title: '保存成功！',
                        scope: $scope,
                        buttons: button
                    });
                    return;
                }
                //判断是否需要显示缴费
                if (((payConfig.goPay && payConfig.payStage == 0) || collection.step == 0) && !openid) {
                    var str = "请立即关注学校微信公众号进行";
                    if (payConfig.goPay && payConfig.payStage == 0) {
                        str += "<strong style='color: red'>预缴费</strong>";
                    }
                    str += (payConfig.goPay && payConfig.payStage == 0 && collection.step == 0) ? "和" : "";
                    if (collection.step == 0) {
                        str += "<strong style='color: red'>采集上报照片资料</strong>";
                    }
                    $ionicPopup.show({
                        template: str,
                        title: '保存成功！',
                        buttons: [
                            {
                                text: '关闭',
                                type: 'button-positive',
                                onTap: function (e) {
                                    window.location.href = basePath + "/enrollByOnline/enrollByOnlineApp.htm?openid=" + openid;
                                }
                            }
                        ]
                    });
                } else {
                    window.location.href = basePath + "/enrollByOnline/enrollByOnlineApp.htm?openid=" + openid;
                }
            };
            $scope.$on('modal.shown', function () {
                // 执行动作
                angular.element('input').css('display', 'block');
                angular.element('select').css('display', 'block');
                angular.element('textarea').css('display', 'block');
            });
            //用于将对象转换为springMVC可识别的对象形式
            var parseParamForSpringMVC = function (obj) {
                //最终组合成功的对象
                var resultObj = {};
                //递归方法，用于深度转换每一个参数
                //key 对象时，是属性名
                //value 属性值
                //prefix（关键），和key进行组合相组合成想要的格式类型如name.age（对象）或name[0].age（数组）
                var deepParseParams = function (key, value, prefix) {
                    //先判断是否是数组
                    if (value instanceof Array) {
                        for (var i in value) {
                            deepParseParams("", value[i], prefix + key + "[" + i + "]");
                        }
                    }
                    //再判断是否是对象
                    else if (value instanceof Object) {
                        for (var i in value) {
                            deepParseParams("." + i, value[i], prefix + key);
                        }
                    }
                    //如果不是数组或对象，到了此次递归的最后一次，将完成组合的这条最终数据放在最终组合对象中
                    else {
                        resultObj[prefix + key] = value;
                    }

                };
                //因为传入的转换参数必须是对象,而且第一次传入和第二次开始组合“.”号是很特殊的地方，所有
                //第一次单独循环
                for (var i in obj) {
                    deepParseParams("", obj[i], i);
                }

                //返回转换成功的对象集合
                return resultObj;
            };

            $scope.configStep = null;
            // 查询资料采集设置，如果是报名的同时需要上传资料，则要把资料一起上传
            function getResourceConfig() {
                // web_info_collection_template
                return $http.get(basePath + '/zsgl/registerOnline/queryStuMaterialConfigStep.htm', {
                    params: {
                        businessCode: 'web_info_collection_template'
                    }
                }).success(function (data) {
                    if (data.status === 0) {
                        $scope.configStep = data.result;
                    }
                });
            }

            getResourceConfig();

        }])
    .controller("viewEnrollStuNoticeController", ["$scope", "$window", "$http", "$sce",
        function ($scope, $window, $http, $sce) {
            /**
             * 查询“报名须知”详情
             */
            $http.get("../../../zsgl/registerOnline/notice/find.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.notice = data.result;
                    if($scope.notice.noticeContent){
                        $scope.notice.noticeContent = $sce.trustAsHtml("<div>" + $scope.notice.noticeContent + "</div>");
                    }

                }
            });
            $scope.enrollOnline = function () {
                var url = basePath + "/mobile/templates/enrollByOnline/enrollOnlineAppNew.jsp";
                url += "?openid=" + getParam("openid");
                url += "&baseInfoId=" + getParam("baseInfoId");
                url += "&credentialType=" + getParam("credentialType");
                url += "&credentialNumber=" + getParam("credentialNumber");
                url += "&recruitType=" + getParam("recruitType");
                var comeType =getParam("comeType");
                if(comeType==1){
                    url += "&comeType="+comeType;
                }
                window.location.href = url;
            };

            function getParam(name) {
                var search = document.location.search;
                var pattern = new RegExp("[?&]" + name + "\=([^&]+)", "g");
                var matcher = pattern.exec(search);
                var items = "";
                if (null != matcher) {
                    try {
                        items = decodeURIComponent(decodeURIComponent(matcher[1]));
                    } catch (e) {
                        try {
                            items = decodeURIComponent(matcher[1]);
                        } catch (e) {
                            items = matcher[1];
                        }
                    }
                }
                return items;
            }
        }]);
+function ($) {
    'use strict';

    // DROPDOWN CLASS DEFINITION
    // =========================

    var backdrop = '.dropdown-backdrop';
    var toggle = '[data-toggle="dropdown"]';
    var Dropdown = function (element) {
        $(element).on('click.bs.dropdown', this.toggle)
    };

    Dropdown.VERSION = '3.3.5';

    function getParent($this) {
        var selector = $this.attr('data-target');

        if (!selector) {
            selector = $this.attr('href');
            selector = selector && /#[A-Za-z]/.test(selector) && selector.replace(/.*(?=#[^\s]*$)/, '') // strip for ie7
        }

        var $parent = selector && $(selector);

        return $parent && $parent.length ? $parent : $this.parent()
    }

    function clearMenus(e) {
        if (e && e.which === 3) return;
        $(backdrop).remove();
        $(toggle).each(function () {
            var $this = $(this);
            var $parent = getParent($this);
            var relatedTarget = {relatedTarget: this};
            if (e && (!$parent.hasClass('open') || $(e.target).parents('.holdon').length)) return;

            if (e && e.type == 'click' && /input|textarea/i.test(e.target.tagName) && $.contains($parent[0], e.target)) return;

            $parent.trigger(e = $.Event('hide.bs.dropdown', relatedTarget));

            if (e.isDefaultPrevented()) return;

            $this.attr('aria-expanded', 'false');
            $parent.removeClass('open').trigger('hidden.bs.dropdown', relatedTarget)
        })
    }

    Dropdown.prototype.toggle = function (e) {
        var $this = $(this);

        if ($this.is('.disabled, :disabled')) return;

        var $parent = getParent($this);
        var isActive = $parent.hasClass('open');

        clearMenus();

        if (!isActive) {
            if ('ontouchstart' in document.documentElement && !$parent.closest('.navbar-nav').length) {
                // if mobile we use a backdrop because click events don't delegate
                $(document.createElement('div'))
                    .addClass('dropdown-backdrop')
                    .insertAfter($(this))
                    .on('click', clearMenus)
            }

            var relatedTarget = {relatedTarget: this};
            $parent.trigger(e = $.Event('show.bs.dropdown', relatedTarget));

            if (e.isDefaultPrevented()) return;

            $this
                .trigger('focus')
                .attr('aria-expanded', 'true');

            $parent
                .toggleClass('open')
                .trigger('shown.bs.dropdown', relatedTarget)
        }

        return false
    };

    Dropdown.prototype.keydown = function (e) {
        if (!/(38|40|27|32)/.test(e.which) || /input|textarea/i.test(e.target.tagName)) return;

        var $this = $(this);

        e.preventDefault();
        e.stopPropagation();

        if ($this.is('.disabled, :disabled')) return;

        var $parent = getParent($this);
        var isActive = $parent.hasClass('open');

        if (!isActive && e.which != 27 || isActive && e.which == 27) {
            if (e.which == 27) $parent.find(toggle).trigger('focus');
            return $this.trigger('click')
        }

        var desc = ' li:not(.disabled):visible a';
        var $items = $parent.find('.dropdown-menu' + desc);

        if (!$items.length) return;

        var index = $items.index(e.target);

        if (e.which == 38 && index > 0) index--;         // up
        if (e.which == 40 && index < $items.length - 1) index++;         // down
        if (!~index) index = 0;

        $items.eq(index).trigger('focus')
    };


    // DROPDOWN PLUGIN DEFINITION
    // ==========================

    function Plugin(option) {
        return this.each(function () {
            var $this = $(this);
            var data = $this.data('bs.dropdown');

            if (!data) $this.data('bs.dropdown', (data = new Dropdown(this)));
            if (typeof option == 'string') data[option].call($this)
        })
    }

    var old = $.fn.dropdown;

    $.fn.dropdown = Plugin;
    $.fn.dropdown.Constructor = Dropdown;


    // DROPDOWN NO CONFLICT
    // ====================

    $.fn.dropdown.noConflict = function () {
        $.fn.dropdown = old;
        return this
    };


    // APPLY TO STANDARD DROPDOWN ELEMENTS
    // ===================================

    $(document)
        .on('click.bs.dropdown.data-api', clearMenus)
        .on('click.bs.dropdown.data-api', '.dropdown form', function (e) {
            e.stopPropagation()
        })
        .on('click.bs.dropdown.data-api', toggle, Dropdown.prototype.toggle)
        .on('keydown.bs.dropdown.data-api', toggle, Dropdown.prototype.keydown)
        .on('keydown.bs.dropdown.data-api', '.dropdown-menu', Dropdown.prototype.keydown)

};
