angular.module('starter')
    .config(function ($stateProvider) {
        $stateProvider
        //巡课异常
        .state('abnormal', {
            url: '/abnormal',
            templateUrl: 'templates/abnormal/patrol_course_abnormal.html',
            data: {
                title: '巡课',
                micro: true
            },
            cache: false
        });
    })
.controller('abnormalCtrl', ['$http', '$scope','$document','ynuiNotification','$timeout',
    function ($http, $scope,$document,ynuiNotification,$timeout) {

        var basePath = originBaseUrl + "/third/xcMobileNewRecord";


        var vm = $scope.vm = {
            pkTeachWeekVOS:[],
            recordList:[],
            tableData:[],
            zbData:[],
            showTipsFlag:true,
            currentWeek:{
                info:null,
                week:null,
                date:null
            },
            goLeft:function () {
                var num = null;
                angular.forEach(vm.pkTeachWeekVOS,function (val,index) {
                    if(val == vm.currentWeek.info){
                        num = index;
                    }
                });
                if((num -1) < 0){
                    ynuiNotification.error({msg: "已经是第一周！"});
                }else {
                    var item = vm.pkTeachWeekVOS[(num - 1)];
                    vm.checkWeek(item);
                }
            },
            goRigth:function () {
                var num = null;
                angular.forEach(vm.pkTeachWeekVOS,function (val,index) {
                    if(val == vm.currentWeek.info){
                        num = index;
                    }
                });
                if((num + 1) > (vm.pkTeachWeekVOS.length -1)){
                    ynuiNotification.error({msg: "已经是最后一周！"});
                }else {
                    var item = vm.pkTeachWeekVOS[(num + 1)];
                    vm.checkWeek(item);
                }
            },
            getClass:function (info) {
                if(info.current && info.weekTotalHour == 1){
                    return {active:true};
                }else if(info.current){
                    return {current:true};
                }else if(info.weekTotalHour == 1){
                    return {active:true};
                }
            },
            checkWeek:function (info) {
                angular.forEach(vm.pkTeachWeekVOS,function (val) {
                    val.current = false;
                });
                info.current = true;
                vm.getShowWeek(info);
            },
            getShowWeek:function (val) {
                vm.currentWeek.info = val;
                vm.currentWeek.week = angular.copy(val.week);
                vm.currentWeek.date = "（"+val.weekStartMonthDay.substring(val.weekStartMonthDay.indexOf("-")+1,val.weekStartMonthDay.length).replace("-","/")+
                    "至"+val.weekEndMonthDay.substring(val.weekEndMonthDay.indexOf("-")+1,val.weekEndMonthDay.length).replace("-","/")+"）";
                vm.findRecordAbnormal(val);
            },
            getShowTable:function () {
                /*获取异常数据最大数值*/
                var array = [];
                angular.forEach(vm.tableData,function(datas){
                    if(datas.children.length === 1 && datas.children[0].name.length < datas.name.length){
                        $scope.titleHeight = Math.ceil(datas.name.length/4)*20;
                    }
                    angular.forEach(datas.children,function(data){
                        if(data.userNumber == null){
                            data.userNumber = 0;
                        }else {
                            data.userNumber = Number(data.userNumber);
                        }
                        array.push(data.userNumber);
                        //赋值高度
                        data.height = Math.ceil(data.name.length/4)*18;
                    });
                });
                Array.prototype.max = function(){
                    var max = this[0];
                    var len = this.length;
                    for(var i=1; i<len; i++){
                        if(this[i] > max){
                            max = this[i];
                        }
                    }
                    return max;
                };
                var maxValue = array.max();

                var maxNumber = 0;
                if(maxValue%5 == 0){
                    maxNumber = maxValue
                }else{
                    for(var j = maxValue;j<maxValue+10;j++){
                        j++;
                        if(j%5 == 0){
                            maxNumber = j
                        }
                    }
                }
                for(var i = 0;i < 6;i++){
                    if(maxNumber <= 5){
                        vm.zbData.push({id:i,name:i});
                    }else {
                        vm.zbData.push({id:i,name:parseInt(maxNumber/5*i)});
                    }

                }

                /*计算异常数值*/
                $timeout(function () {
                    var tableWidth = $document.find('.table-coordinates').width()-14;
                    $scope.boxWidth = tableWidth/maxNumber;
                    $scope.zbMarginRight = tableWidth/5-28;
                },1000)

            },
            // 教学周
            findTeachWeekVOList:function () {
                $http.post(basePath+"/findTeachWeekVOList.htm").success(function (data) {
                    if(data.status == 0){
                        vm.pkTeachWeekVOS = angular.copy(data.result);
                        if(vm.pkTeachWeekVOS && vm.pkTeachWeekVOS.length > 0){
                            angular.forEach(vm.pkTeachWeekVOS,function (val) {
                                val.current = false;
                                if(val.weekTotalHour == 1){
                                    val.current = true;
                                    vm.getShowWeek(val);
                                }
                                val.showWeek = val.week.replace("第","");
                            });
                        }
                    }
                });
            },
            // 异常数据
            findRecordAbnormal:function (info) {
                var params = {
                    termId:info.id,
                    week:info.activityWeek,
                    startDate:info.weekStartMonthDay,
                    endDate:info.weekEndMonthDay
                };
                $http.post(basePath+"/findRecordAbnormal.htm",params).success(function (data) {
                    if(data.status == 0 && data.result){
                        vm.showTipsFlag = false;
                        vm.tableData = angular.copy(data.result.recordItemList);
                        if(vm.tableData && vm.tableData.length > 0){
                            angular.forEach(vm.tableData,function (child) {
                                angular.forEach(child.children,function (val) {
                                    val.height = "";
                                })
                            });
                        }
                        vm.recordList = angular.copy(data.result.recordList);
                        vm.zbData = [];
                        vm.getShowTable();
                    }else {
                        vm.showTipsFlag = true;
                        vm.tableData = [];
                        vm.recordList = [];
                        vm.zbData = [];
                    }
                });
            }
        };


        function init() {
            vm.findTeachWeekVOList();
        }

        init();







}]);

