/**
 * 我的课堂考勤
 * @author qiucheng Lu
 * @Date 2021年4月8日14:02:04
 */
(function () {
    'use strict';

    angular.module('starter')
        .config(stateConfig)
        .controller('attendanceStuCtrl', attendanceStuCtrl)

    stateConfig.$inject = ['$stateProvider'];

    function stateConfig($stateProvider) {
        $stateProvider
            //活动打卡【学生考勤】
            .state('sign_in_stu', {
                firstPage: true,
                url: '/sign_in_stu',
                templateUrl: 'templates/sign_in/sign_in.html',
                data: {
                    micro: true,
                    title: '活动打卡',
                    prev: null
                },
                controller: 'signInCtrl',
                controllerAs: 'vm'
            })
            //课堂考勤（学生访问）
            .state('attendance_student', {
                url: '/attendance_student',
                templateUrl: 'templates/attendance/attendance_student.html',
                data: {
                    micro: true,
                    title: '课堂考勤'
                }
            });
    }

    attendanceStuCtrl.$inject = ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', "$location", "$ionicPopup"];

    // 课堂考勤（学生访问）
    function attendanceStuCtrl($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, $location, $ionicPopup)  {
        //获取当前学期
        $http.get(originBaseUrl + "/third/result/getTerm.htm" + "?_datatime=" + new Date().getTime()).success(function (data) {
            if (data.status == 0) {
                if (data.result.curTerm) {
                    $scope.isCurTerm = true;//用于后面获取教学周信息的判断
                    $scope.term = data.result.curTerm
                    $scope.termId = $scope.term.id;
                    //当前学期的开始时间和结束时间
                    $scope.beginTime = $scope.term.termBeginDateString;
                    $scope.endTime = $scope.term.termEndDateString;
                    $scope.loadData();
                } else {//如果当前日期不在学期内，就默认为上学期
                    $scope.isCurTerm = false;
                }
            }
        })
        // 选中的周数
        $scope.selectedWeek = "";
        /**
         * 查询总周数 以及每周的信息
         */
        /**
         * 查询总周数 以及每周的信息
         */
        var firstDayArr = [], endDayArr = [];
        $scope.loadData = function () {
            $http.post(originBaseUrl + "/third/attendance/queryTimeTableWeekTHead.htm", {
                termId: $scope.termId,
                requestSource: 2,
                containChecking: false
            }).success(function (data) {
                if (data.status == 0) {
                    //当前学期周相关信息
                    $scope.oTableWeekTHead = data.result;
                    if ($scope.oTableWeekTHead.length > 0) {
                        //获取教学周第一周和最后一周的起始时间
                        var firstDate = $scope.oTableWeekTHead[0].startEndDate.split("~")[0],
                            firstDateEnd = $scope.oTableWeekTHead[0].startEndDate.split("~")[1],
                            endDate = $scope.oTableWeekTHead[$scope.oTableWeekTHead.length - 1].startEndDate.split("~")[1];
                        firstDayArr = firstDate.split("-"), endDayArr = endDate.split("-");
                        angular.forEach($scope.oTableWeekTHead, function (o, key) {
                            if (o.isCurrentWeek) {
                                $scope.selectedWeek = o.week;
                                var tempArr = o.startEndDate.split("~"),
                                    //校历日期当前周的开始和结束时间
                                    startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                    startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                                //判断校历日期一周有几天
                                if (startDay > endDay) {    //跨月
                                    if (key + 1 <= $scope.oTableWeekTHead.length) {
                                        tempArr = $scope.oTableWeekTHead[key + 1].startEndDate.split("~");
                                    } else {
                                        tempArr = $scope.oTableWeekTHead[key - 1].startEndDate.split("~");
                                    }
                                    startDate1 = tempArr[0], endDate1 = tempArr[1];
                                    getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1);
                                } else {
                                    getDateByStartEndDate(startDate, endDate);
                                }
                                getAssembleDate(false, false, new Date().getMonth() + 1, new Date().getDate(), false, false);
                            }
                        });
                        if (!$scope.selectedWeek) {    //当前日期不在教学周内，默认加载教学周第一周的第一天
                            var startMonth = firstDate.split("-")[0], startDay = firstDate.split("-")[1];
                            getDateByStartEndDate(firstDate, firstDateEnd);
                            getAssembleDate(false, false, startMonth, startDay, false, false);
                            $scope.selectedWeek = 1;
                            $scope.oTableWeekTHead[0].isCurrentWeek = true;
                        }
                    }
                }
            });
        }
        //查询课表信息
        $scope.fLoadTimeTableData = function () {
            $http.post(originBaseUrl + "/third/attendance/queryRollBackByquery.htm",
                {termId: $scope.termId, week: $scope.selectedWeek, day: $scope.showDay, requestSource: 2}
            ).success(function (data) {
                if (data.status === 0) {
                    $scope.oTimeTableData = data.result;
                } else {
                    $scope.showWarning("加载失败，请重试！");
                }
            }).error(function () {
                $scope.showWarning("加载失败，请重试！");
            });
        }

        /**
         * 根据开始时间和结束时间计算每周的日期
         * @param start
         * @param end
         * @returns {Array}
         */

        function getDateByStartEndDate(start, end, isAdd, start1, end1) {
            $scope.dateArr = [];
            var startMonthStr = parseInt(start.split("-")[0]), endMonthStr = parseInt(end.split("-")[0]),
                startDateStr = parseInt(start.split("-")[1]), endDateStr = parseInt(end.split("-")[1]);
            var tempNum = 0;
            if (isAdd) { //跨月
                $scope.weekNum = Math.abs(parseInt(end1.split("-")[1] - parseInt(start1.split("-")[1]))) + 1;
            } else {
                $scope.weekNum = Math.abs(endDateStr - startDateStr) + 1;
            }
            if (startMonthStr == endMonthStr) { //同月
                for (var i = 1; i <= $scope.weekNum; i++) {
                    $scope.dateArr.push({id: i, monthStr: startMonthStr, dateStr: startDateStr + tempNum});
                    tempNum++;
                }
            } else { //跨月
                var currentNum = $scope.weekNum - endDateStr,  //当前月占几天
                    tempNumCur = 0;
                for (var i = 1; i <= currentNum; i++) { //当前月日期
                    $scope.dateArr.push({id: i, monthStr: startMonthStr, dateStr: startDateStr + tempNumCur});
                    tempNumCur++;
                }
                for (var j = 1; j <= endDateStr; j++) { //跨月占日期
                    $scope.dateArr.push({id: ++tempNumCur, monthStr: endMonthStr, dateStr: j});
                }
            }
            return $scope.dateArr;
        }

        /**
         * 获取显示的日期
         * @param month
         * @param date
         * @param up    上一天
         * @param down  下一天
         * @param first 上一天跨周
         * @param end   下一天跨周
         */
        function getAssembleDate(first, end, month, date, up, down) {
            if (first) {
                $scope.judgePar = {
                    month: $scope.dateArr[$scope.dateArr.length - 1].monthStr,
                    date: $scope.dateArr[$scope.dateArr.length - 1].dateStr
                };
                $scope.showDay = $scope.dateArr[$scope.dateArr.length - 1].id;
            } else if (end) {
                $scope.judgePar = {month: $scope.dateArr[0].monthStr, date: $scope.dateArr[0].dateStr};
                $scope.showDay = $scope.dateArr[0].id;
            } else {
                for (var i = 0; i < $scope.dateArr.length; i++) {
                    var item = $scope.dateArr[i];
                    if (item.monthStr == month && item.dateStr == date) {
                        if (up) {
                            $scope.judgePar = {
                                month: $scope.dateArr[i - 1].monthStr,
                                date: $scope.dateArr[i - 1].dateStr
                            };
                            $scope.showDay = $scope.dateArr[i - 1].id;
                        } else if (down) {
                            $scope.judgePar = {
                                month: $scope.dateArr[i + 1].monthStr,
                                date: $scope.dateArr[i + 1].dateStr
                            };
                            $scope.showDay = $scope.dateArr[i + 1].id;
                        } else {
                            $scope.judgePar = {month: item.monthStr, date: item.dateStr};
                            $scope.showDay = item.id;
                        }
                    }
                }
            }
            $scope.fLoadTimeTableData();
        }

        /**
         * 上一天、下一天
         * @param item
         */
        $scope.chooseDay = function (item) {
            if (item == 1) {
                if ($scope.judgePar.month == parseInt(endDayArr[0]) && $scope.judgePar.date == parseInt(endDayArr[1])) {
                    $scope.showWarning("已经是最后一天！");
                    return;
                }
                //跨周处理
                if ($scope.showDay < $scope.weekNum) {
                    getAssembleDate(false, false, $scope.judgePar.month, $scope.judgePar.date, false, true);
                } else {
                    for (var i = 0; i < $scope.oTableWeekTHead.length; i++) {
                        var val = $scope.oTableWeekTHead[i];
                        if (val.isCurrentWeek) {
                            val.isCurrentWeek = false;
                            $scope.oTableWeekTHead[i + 1].isCurrentWeek = true;
                            $scope.selectedWeek = $scope.oTableWeekTHead[i + 1].week;
                            var tempArr = $scope.oTableWeekTHead[i + 1].startEndDate.split("~"),
                                startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                            if (startDay > endDay) {    //跨月
                                if (i - 2 <= $scope.oTableWeekTHead.length && i - 2 >= 0) {
                                    tempArr = $scope.oTableWeekTHead[i].startEndDate.split("~");
                                } else {
                                    tempArr = $scope.oTableWeekTHead[i - 2].startEndDate.split("~");
                                }
                                startDate1 = tempArr[0], endDate1 = tempArr[1];
                                getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1)
                            } else {
                                getDateByStartEndDate(startDate, endDate);
                            }
                            getAssembleDate(false, true);
                            return;
                        }
                    }
                }

            } else {
                if ($scope.judgePar.month == parseInt(firstDayArr[0]) && $scope.judgePar.date == parseInt(firstDayArr[1])) {
                    $scope.showWarning("已经是第一天！");
                    return;
                }
                if ($scope.showDay > 1) {
                    getAssembleDate(false, false, $scope.judgePar.month, $scope.judgePar.date, true, false);
                } else {
                    for (var i = 0; i < $scope.oTableWeekTHead.length; i++) {
                        var val = $scope.oTableWeekTHead[i];
                        if (val.isCurrentWeek) {
                            val.isCurrentWeek = false;
                            $scope.oTableWeekTHead[i - 1].isCurrentWeek = true;
                            $scope.selectedWeek = $scope.oTableWeekTHead[i - 1].week;
                            var tempArr = $scope.oTableWeekTHead[i - 1].startEndDate.split("~"),
                                startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                                startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                            if (startDay > endDay) {    //跨月
                                if (i - 2 <= $scope.oTableWeekTHead.length && i - 2 >= 0) {
                                    tempArr = $scope.oTableWeekTHead[i].startEndDate.split("~");
                                } else {
                                    tempArr = $scope.oTableWeekTHead[i - 2].startEndDate.split("~");
                                }
                                startDate1 = tempArr[0], endDate1 = tempArr[1];
                                getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1)
                            } else {
                                getDateByStartEndDate(startDate, endDate);
                            }
                            getAssembleDate(true, false);
                            return;
                        }
                    }
                }

            }
        }
        /**
         * 选择周
         * @param item 选中的周数
         */
        $scope.chooseWeek = function (item) {

            if (item == 0) {
                $scope.showWarning("已经是第一周！");
                return;
            }
            if (item > $scope.oTableWeekTHead.length) {
                $scope.showWarning("已经是最后一周！");
                return;
            }

            var count = true;
            if (item <= $scope.oTableWeekTHead.length && item > 0) {
                for (var i = 0; i < $scope.oTableWeekTHead.length; i++) {
                    if ($scope.oTableWeekTHead[i].week == item) {
                        var val = $scope.oTableWeekTHead[i];
                        val.isCurrentWeek = true;
                        $scope.selectedWeek = val.week;
                        var tempArr = val.startEndDate.split("~"),
                            startDate = tempArr[0], endDate = tempArr[1], startDate1, endDate1,
                            startDay = startDate.split("-")[1], endDay = endDate.split("-")[1];
                        if (startDay > endDay) {    //跨月
                            if (i + 1 <= $scope.oTableWeekTHead.length) {
                                tempArr = $scope.oTableWeekTHead[i + 1].startEndDate.split("~");
                            } else {
                                tempArr = $scope.oTableWeekTHead[i - 1].startEndDate.split("~");
                            }
                            startDate1 = tempArr[0], endDate1 = tempArr[1];
                            getDateByStartEndDate(startDate, endDate, true, startDate1, endDate1)
                        } else {
                            getDateByStartEndDate(startDate, endDate);
                        }
                        if ($scope.showDay <= $scope.dateArr[$scope.dateArr.length - 1].id) { //避免每周的天数不一致
                            angular.forEach($scope.dateArr, function (item) {
                                if (item.id == $scope.showDay && count) {
                                    $scope.judgePar = {month: item.monthStr, date: item.dateStr};
                                    $scope.showDate = item.monthStr + "." + item.dateStr;
                                    $scope.showDay = item.id;
                                    count = false;
                                }
                            })
                            $scope.fLoadTimeTableData();
                        } else {
                            getAssembleDate(true, false);
                        }
                    } else {
                        $scope.oTableWeekTHead[i].isCurrentWeek = false;
                    }
                }
            }
        }

        /**
         * 选择大周（大周1相当于星期1）
         */
        $scope.chooseBigWeek = function (obj) {
            angular.forEach($scope.dateArr, function (item) {
                if (item.id == obj) {
                    $scope.judgePar = {month: item.monthStr, date: item.dateStr};
                    $scope.showDate = item.monthStr + "." + item.dateStr;
                    $scope.showDay = item.id;
                }
            });
            angular.element("#headDrop1").removeClass('open');
            $scope.fLoadTimeTableData();
        };

        /**
         * 刷新
         */
        $scope.doRefresh = function () {
            $scope.showWarning("正在加载...");
            $scope.fLoadTimeTableData();
        };
        /**
         * 提示信息
         * @param msg 提示内容
         */
        $scope.showWarning = function (msg) {
            $ionicLoading.show({
                template: msg
            });
            $timeout(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            }, 500);
        };
    }
})();
