/**
 * 课堂激励
 */
(function () {
    'use strict';
    angular.module('starter')
        .config(stateConfig)
        .controller('stimulateController', stimulateController)

    stateConfig.$inject = ['$stateProvider'];
    function stateConfig($stateProvider) {
        $stateProvider
        /**
         * 课堂激励
         */
            .state('stimulate', {
                url: '/stimulate',
                templateUrl: 'templates/calss_stimulate/stimulate.html',
                data: {
                    micro: true,
                    title: '课堂激励'
                }
            });
    }

    stimulateController.$inject = ['$scope', 'kqktMobileService', '$ionicModal', '$http','$location','ynuiNotification'];

    /**
     * 课堂激励
     */
    function stimulateController($scope, kqktMobileService, $ionicModal, $http,$location,ynuiNotification) {
        var basePath = originBaseUrl + "/third/kqkt/mobile";

        $scope.data = {
            termInfo: {},//学期

        };

        //初始化
        function initKqkt() {
            kqktMobileService.findKqktRollCallInitInfo().then(function (data) {
                    if (data.status == 0) {
                        var config = data.result.config;
                        var teachWeekList = data.result.teachWeekList;
                        var weekAndDay = data.result.weekAndDay;

                        $scope.data.termInfo.id = config.termId;
                        $scope.data.termInfo.name = config.termName;

                        //爱课币
                        $scope.queryStudentGainInspire();

                    }
                }
            );
        }

        //初始化
        initKqkt();

        $scope.queryStudentGainInspire = function () {
            $http.post(basePath + "/queryInspireRankingByUserAndTeam.htm", {termId: $scope.data.termInfo.id}).success(function (data) {
                if (data.status == 0) {
                    $scope.moblieCourseInfoVo = data.result;
                } else {
                    ynuiNotification.notify("error", "查询失败!");
                }
            });
        }

        $scope.isMoreData = true;
        $scope.item = "";
        $scope.courseGainClick = function (item) {
            $scope.item = item;
            $http.post(basePath + "/courseGainClick.htm?pageNumber=0&&pageSize=10", {
                termId: $scope.data.termInfo.id,
                courseId: item.courseId,
                courseClassIdList: item.courseClassIdList
            }).success(function (data) {
                if (data.status == 0) {
                    $scope.couName = item.courseName;
                    $scope.courseGainList = data.result;
                    $scope.$broadcast('scroll.refreshComplete');//这里是告诉ionic更新数据完成，可以再次触发更新事件
                    $ionicModal.fromTemplateUrl('templates/calss_stimulate/courseGainList.html', {
                        scope: $scope,
                        animation: 'slide-in-up',
                        backdropClickToClose: false
                    }).then(function (modal) {
                        $scope.ynShowModal = modal;
                        $scope.ynShowModal.show();
                    });
                    // $location.path("/courseGainList").search('courseGainList', angular.toJson( $scope.courseGainList));
                } else {
                    ynuiNotification.notify("error", "查询失败!");
                }
                //如果页面数据没有填充完 则不继续加载数据了
                if ($scope.courseGainList.length < 10) {
                    $scope.isMoreData = false;
                }
            });
        }

        $scope.page = 1;
        //加载数据
        $scope.loadMore = function () {
            $http.post(basePath + "/courseGainClick.htm?pageNumber=" + $scope.page + "&pageSize=10", {
                termId: $scope.data.termInfo.id,
                courseId: $scope.item.courseId,
                courseClassIdList: $scope.item.courseClassIdList
            }).success(function (data) {
                if (data.status == "0") {
                    $scope.page++;
                    $scope.courseGainList = $scope.courseGainList.concat(data.result);

                    if (data.courseGainList.length != 0) {
                        $scope.$broadcast('scroll.infiniteScrollComplete');//这里是告诉ionic更新数据完成，可以再次触发更新事件
                    }
                }
                //如果页面数据没有填充完 则不继续加载数据了
                if ($scope.courseGainList.length < 10) {
                    $scope.isMoreData = false;
                }
            })
        };


        //接收event事件,瀑布流
        $scope.$on('stateChangeSuccess', function () {
            $scope.loadMore();
        });

        $scope.doBack = function () {
            $scope.ynShowModal.hide();
        };

    }
})();
