/**
 * 选课
 * @author qiucheng Lu
 * @Date 2021年4月13日15:57:19
 */
(function () {
    'use strict';

    angular.module('starter')
        .config(stateConfig)
        .controller('chooseLessonsCtrl', chooseLessonsCtrl)
        .controller('chooseLessonsDetailCtrl', chooseLessonsDetailCtrl)

    stateConfig.$inject = ['$stateProvider'];

    function stateConfig($stateProvider) {
        $stateProvider
            // 选课
            .state('choose_lessons', {
                url: '/choose_lessons',
                templateUrl: 'templates/choose_lessons/choose_lessons.html',
                data: {
                    micro: true,
                    title: '选课'
                }
            })
            //选择课程
            .state('choose_lessons_detail', {
                url: '/choose_lessons_detail',
                templateUrl: 'templates/choose_lessons/choose_lessons_detail.html',
                data: {
                    title: '选课',
                    prev: 'choose_lessons'
                }
            })
    }

    chooseLessonsCtrl.$inject = ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', '$ionicSlideBoxDelegate', '$location'];
    // 选课
    function chooseLessonsCtrl ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $ionicSlideBoxDelegate, $location) {
        $scope.selectCourseRequire = "";
        $scope.currentTermId = "";
        $scope.windowHeight = $(window).height() - 211;
        if ($location.search().termId) {
            $scope.currentTermId = $location.search().termId;
        }
        $scope.clickTaskDate = function (str) {
            if (str) {
                ynuiNotification.error({msg: str});
            }
        }
        $scope.isInit = true;
        //获取已选择的课程
        $scope.getSelectedCourse = function (termId) {
            $scope.selectCourseRequire = "";
            if (!$scope.isInit) {
                $ionicLoading.show({
                    template: "正在加载..."
                });
            }
            $scope.successStatus = 0;
            $scope.errorStatus = 0;
            $scope.checkStatus = 0;
            $http.post(originBaseUrl + '/third/xkStuMobile/queryMySelectedCourseByMobile.htm', {termId: termId}).success(function (data) {
                $ionicLoading.hide();
                $scope.emptyInfo = false;
                if ($scope.isInit) {
                    $scope.isInit = false;
                }
                if (data.status == 0) {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $scope.selectedCourseVO = data.result;
                    if ($scope.selectedCourseVO) {
                        $scope.currentTermId = $scope.selectedCourseVO.defaultTermId;
                    } else {
                        return;
                    }
                    angular.forEach($scope.selectedCourseVO.xkStuMobileElectiveVOList, function (item) {
                        if (item.status == 1) {
                            $scope.successStatus++;
                        } else if (item.status == 2) {
                            $scope.errorStatus++;
                        } else {
                            $scope.checkStatus++;
                        }
                    })


                    if ($scope.selectedCourseVO.maxCredit != null && $scope.selectedCourseVO.maxCredit != "" && $scope.selectedCourseVO.maxCredit != undefined) {
                        $scope.selectCourseRequire += "选课学分要求不超过" + $scope.selectedCourseVO.maxCredit + "分，";
                    } else {
                        $scope.selectCourseRequire += "选课学分要求不限制，";
                    }
                    if ($scope.selectedCourseVO.maxCourse != null && $scope.selectedCourseVO.maxCourse != "" && $scope.selectedCourseVO.maxCourse != undefined) {
                        $scope.selectCourseRequire += "选课数量要求不超过" + $scope.selectedCourseVO.maxCourse
                    } else {
                        $scope.selectCourseRequire += "选课数量要求不限制";
                    }
                    if ($scope.successStatus > 0) {
                        $scope.findElectiveCourseList(2);
                    } else if ($scope.successStatus == 0 && $scope.checkStatus > 0) {
                        $scope.findElectiveCourseList(3);
                    } else if ($scope.successStatus == 0 && $scope.checkStatus == 0 && $scope.errorStatus > 0) {
                        $scope.findElectiveCourseList(4);
                    } else {
                        $scope.findElectiveCourseList(1);
                    }
                } else {
                    ynuiNotification.error({msg: "服务器异常，请稍后重试！"});
                }

            }).error(function () {
                $ionicLoading.hide();
                if ($scope.isInit) {
                    $scope.isInit = false;
                }
                //  ynuiNotification.error({msg: '加载失败！'});
                $scope.emptyInfo = true;
                $scope.dataErrorMsg = '加载失败，请重试！';
            });
        }
        $scope.electiveCourseList = [];
        $scope.findElectiveCourseList = function (type) {
            $scope.electiveCourseList = [];
            $scope.tab = type;
            if (type == 1) {
                $scope.electiveCourseList = $scope.selectedCourseVO.xkStuMobileElectiveVOList;
            } else {
                angular.forEach($scope.selectedCourseVO.xkStuMobileElectiveVOList, function (item) {
                    if (type == 2 && item.status == 1) {
                        $scope.electiveCourseList.push(item);
                    } else if (type == 3 && item.status == 0) {
                        $scope.electiveCourseList.push(item);
                    } else if (type == 4 && item.status == 2) {
                        $scope.electiveCourseList.push(item);
                    }
                })
            }
        }
        //切换学期
        $scope.switchoverTerm = function () {
            $scope.getSelectedCourse($scope.selectedCourseVO.termId);
        }
        $scope.getSelectedCourse($scope.currentTermId);
        //选课要求提示
        $scope.clickRequire = function () {
            ynuiNotification.error({msg: $scope.selectCourseRequire});
        }
        //撤销选课
        $scope.revocation = function (item) {
            $ionicLoading.show({
                template: "正在撤销..."
            });
            $http.post(originBaseUrl + '/third/xkStuMobile/cancelCourseByMobile.htm', {id: item.id}).success(function (data) {
                if (data.status == 0) {
                    ynuiNotification.success({msg: "撤销成功"});
                    $scope.getSelectedCourse($scope.currentTermId);
                } else {
                    ynuiNotification.error({msg: data.message});
                }
                $ionicLoading.hide();
            }).error(function () {
                $ionicLoading.hide();
                ynuiNotification.error({msg: '提交失败！'});
                //$scope.emptyInfo = true;
                //$scope.dataErrorMsg = '加载失败，请重试！';
            });
        }
        //不选课原因提示
        $scope.notGoReason = function (item) {
            ynuiNotification.error({msg: item.remark});
        }
        // 跳转的选课页面
        $scope.gotoSelectCourse = function () {
            if (!$scope.currentTermId) {
                // ynuiNotification.error({msg: "学期ID不能为空！"});
                // 提示修改
                ynuiNotification.error({msg: "当前不存在任何需要选课的学期！"});
                return;
            }
            $location.path("/choose_lessons_detail").search("termId", $scope.currentTermId);
        }
    }

    chooseLessonsDetailCtrl.$inject = ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', '$sce', 'ynuiNotification', '$ionicSlideBoxDelegate', '$location', "$ionicPopup", "$interval", "ynNavigator"];
    //选择课程
    function chooseLessonsDetailCtrl ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $sce, ynuiNotification, $ionicSlideBoxDelegate, $location, $ionicPopup, $interval, ynNavigator) {

        $scope.termId = $location.search().termId;
        $scope.xkText = "";
        $scope.queryXKRemarkByTermId = function () {
            $http.post(originBaseUrl + "/third/xkStuMobile/queryXKRemarkByTermId.htm", {termId: $scope.termId}).success(function (data) {
                if (data.status == 0 && data.result) {
                    $scope.xkText = $sce.trustAsHtml(data.result);
                    $scope.countDown();
                    $scope.openXKText();
                } else if (data.status == 1) {
                    $scope.xkText = $sce.trustAsHtml(data.message);
                }
            });
        }
        $scope.countDown = function () {
            $scope.second = 10;
            $interval(function () {
                $scope.second--;
                if ($scope.second > 1) {
                    $scope.clearTime = "（" + $scope.second + "S）";
                } else if ($scope.second == 1) {
                    $scope.clearTime = "我知道了（" + $scope.second + "S）";
                } else {
                    $scope.clearTime = "我知道了";
                }
            }, 1000, 60);
        }
        $scope.openXKText = function (type) {
            if (type == 1) {
                $scope.second = 0;
                $scope.clearTime = "我知道了";
            }
            $ionicModal.fromTemplateUrl('termChooseCourseRemark.html', {
                scope: $scope,
                animation: 'slide-in-up',
                backdropClickToClose: false
            }).then(function (modal) {
                $scope.ynShowModal = modal;
                $scope.ynShowModal.show();
            });
        }
        /**
         * 缓存学生已经查看过选课说明
         */
        $scope.clearXKRemark = function () {
            $http.post(originBaseUrl + "/third/xkStuMobile/saveRedisXKRemarkByTermId.htm", {termId: $scope.termId}).success(function (data) {
                $scope.ynShowModal.hide();
            });
        }
        $scope.dataLoading = false;
        $scope.selectCourse = [];//选择的课程
        //获取可以选择的课程
        $scope.getSelectingCorseList = function (type) {
            $ionicLoading.show({
                template: "正在加载..."
            });
            $scope.showCourseList = [];
            $http.post(originBaseUrl + '/third/xkStuMobile/queryStuSelectingCorseByMobile.htm', {termId: $scope.termId}).success(function (data) {
                if (data.status == 0) {
                    $scope.emptyInfo = false;
                    $scope.dataLoading = false;
                    $scope.courseList = data.result;
                    $scope.showCourseList = $scope.courseList;
                    if (type == 1) {
                        $scope.searchCorse($scope.searchValue);
                    }
                    $ionicLoading.hide();
                }
            }).error(function () {
                $ionicLoading.hide();
                $scope.dataLoading = false;
                //  ynuiNotification.error({msg: '加载失败！'});
                $scope.emptyInfo = true;
                $scope.dataErrorMsg = '加载失败，请重试！';
            });
        }
        $scope.tempSelectCorse = null;
        //点击选择课程按钮
        $scope.clickSelectCorse = function (item) {
            if (item.isRequired) {
                $scope.openModal(item);
            } else {
                $scope.selectCorse(item);
            }
        }
        $scope.openModal = function (item) {
            $scope.tempSelectCorse = item;
            $ionicModal.fromTemplateUrl('template.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.modal = modal;
                $scope.modal.show();
            });
        };
        $scope.closeModal = function () {
            $scope.modal.hide();
        };
        //选择课程
        $scope.isFinished = true;
        $scope.selectCorse = function (item) {
            if (item.isRequired) {
                $scope.closeModal();
            }
            if (item.isStuTeachClass != null) {
                return;
            }
            $ionicLoading.show({
                template: "正在选课..."
            });
            if ($scope.isFinished) {
                $scope.isFinished = false;
                $http.post(originBaseUrl + '/third/xkStuMobile/selectCourseByMobile.htm', {
                    termId: $scope.termId,
                    teachClassId: item.id,
                    xkTermInfoId: item.xkTermInfoId
                }).success(function (data) {
                    if (data.status == 0 && data.result.successStuCount > 0) {
                        item.isStuTeachClass = true;
                        $scope.openCourseModal(1);
                        $scope.getSelectingCorseList(1);
                        ynuiNotification.success({msg: "选课成功"});
                    } else {
                        $scope.getSelectingCorseList(1);
                        ynuiNotification.error({msg: "选课失败，" + data.result.errorMsg});
                    }
                    $scope.isFinished = true;
                    $ionicLoading.hide();
                }).error(function () {
                    $scope.isFinished = true;
                    $ionicLoading.hide();
                    //  ynuiNotification.error({msg: '加载失败！'});
                    $scope.emptyInfo = true;
                    $scope.dataErrorMsg = '加载失败，请重试！';
                });
            }
        }

        $scope.searchValue = "";
        $scope.clearSearchValue = function () {
            $scope.searchValue = "";
        }
        $scope.$watch("searchValue", function () {
            if ($scope.searchValue) {
                $scope.searchCorse($scope.searchValue);
            } else {
                $scope.showCourseList = $scope.courseList;
                setTimeout(function () {
                    $scope.$apply();
                });
            }
        });
        // 搜索课程
        $scope.searchCorse = function (searchValue) {
            var currentCourseList = [];
            angular.forEach($scope.courseList, function (group) {
                angular.forEach(group.teachClassDetailVOs, function (item) {
                    if (item.courseName.indexOf(searchValue) != -1) {
                        $scope.assemblyShowCourseList(item, group, currentCourseList);
                    }
                });
            });
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicScrollDelegate.scrollTop();
            $scope.showCourseList = currentCourseList;
            setTimeout(function () {
                $scope.$apply();
            });
        }
        //将搜索出匹配的结果放入showCourseList
        $scope.assemblyShowCourseList = function (item, group, courseList) {
            var isExist = false;
            angular.forEach(courseList, function (currentGroup) {
                if (currentGroup.id == group.id) {
                    currentGroup.teachClassDetailVOs.push(item);
                    if (currentGroup.teachClassDetailVOs.length == group.teachClassDetailVOs.length) {
                        //isShowAll = false 表示不显示“显示此组所有课程”此选项
                        currentGroup.isShowAll = false;
                    } else {
                        currentGroup.isShowAll = true;
                    }
                    isExist = true;
                }
            });
            if (!isExist) {
                var currentGroup = {
                    id: group.id,
                    groupName: group.groupName,
                    groupNum: group.groupNum,
                    isShowAll: group.teachClassDetailVOs.length == 1 ? false : true,
                    teachClassDetailVOs: []
                }
                currentGroup.teachClassDetailVOs.push(item);
                courseList.push(currentGroup);
            }

        }
        //搜索的时候显示全部课程
        $scope.showAllCourse = function (group) {
            var currentGroupAll = null;
            angular.forEach($scope.courseList, function (item) {
                if (item.id == group.id) {
                    currentGroupAll = item;
                }
            });
            angular.forEach(currentGroupAll.teachClassDetailVOs, function (item) {
                var isExist = false;
                angular.forEach(group.teachClassDetailVOs, function (i) {
                    if (item.id == i.id) {
                        isExist = true;
                    }
                });
                if (!isExist) {
                    group.teachClassDetailVOs.push(item);
                }
            });
            setTimeout(function () {
                $scope.$apply();
            });
            group.isShowAll = false;
        }
        ynNavigator.registerBackAction(function () {
            //有待选课程，才判断拦截
            if($scope.showCourseList && $scope.showCourseList.length){
                getBack();
                return false;
            }
            $location.path("/choose_lessons").search("termId", $scope.termId);
            setTimeout(function () {
                $scope.$apply();
            })
        },101);
        // 返回选课记录页面
        function getBack() {
            if (!$scope.dataLoading) {
                $ionicLoading.show({
                    template: "正在加载..."
                });
            }
            $http.post(originBaseUrl + '/third/xkStuMobile/queryMyNoChoiceNumberById.htm', {termId: $scope.termId}).success(function (data) {
                if (data.status == 0) {
                    if (data.result > 0) {
                        $scope.remind(data.result);
                    } else {
                        $location.path("/choose_lessons").search("termId", $scope.termId);
                    }
                }
                $ionicLoading.hide();
            }).error(function () {
                $ionicLoading.hide();
            });
        }
        /**
         * 提醒
         */
        $scope.remind = function (noChoiceNumber) {
            var opts = {
                cancelText: "取消",
                okText: "确定",
                title: "必选未选满",
                template: "学生的必选课程还差" + noChoiceNumber + "门未选，确定返回吗？",
                buttons: [{
                    text: '继续选课',
                    type: 'button-positive',
                    onTap: function () {
                        return false;
                    }
                }, {
                    text: '返回',
                    type: 'button-default',
                    onTap: function () {
                        $location.path("/choose_lessons").search("termId", $scope.termId);
                        return true;
                    }
                }]
            };
            $ionicPopup.confirm(opts);
        };
        $scope.openCourseModal = function (type) {
            $http.post(originBaseUrl + '/third/xkStuMobile/queryMySelectedCourseById.htm', {termId: $scope.termId}).success(function (data) {
                if (data.status == 0) {
                    $scope.selectCourse = data.result;
                    $scope.selectCourseTotal = data.result.length;
                    if (type != 1) {
                        $ionicModal.fromTemplateUrl('courseTempale.html', {
                            scope: $scope,
                            animation: 'slide-in-up'
                        }).then(function (modal) {
                            $scope.courseMmodal = modal;
                            $scope.courseMmodal.show();
                        });
                    }
                }
            }).error(function () {
                $ionicLoading.hide();
            });
        };
        $scope.getSelectingCorseList();
        $scope.openCourseModal(1);
        $scope.queryXKRemarkByTermId();
        //撤销选课
        $scope.xkRevocation = function (item) {
            $ionicLoading.show({
                template: "正在撤销..."
            });
            $http.post(originBaseUrl + '/third/xkStuMobile/cancelCourseByMobile.htm', {id: item.id}).success(function (data) {
                if (data.status == 0) {
                    ynuiNotification.success({msg: "撤销成功"});
                    $scope.getSelectingCorseList(1);
                    $scope.openCourseModal(1);
                    $scope.courseMmodal.hide();
                } else {
                    ynuiNotification.error({msg: data.message});
                }
                $ionicLoading.hide();
            }).error(function () {
                $ionicLoading.hide();
                ynuiNotification.error({msg: '提交失败！'});
            });
        }
    }
})();
