angular.module('starter')
    .config(stateConfig)
    .controller('classInspireController',classInspireController)
    .controller('addTeachClassInspireItemController',addTeachClassInspireItemController)
    .controller('lookStudentCourseGainInspireController',lookStudentCourseGainInspireController)

stateConfig.$inject = ['$stateProvider'];
classInspireController.$inject = ['$scope','$ionicModal','$http','$location','$ionicPopup','$rootScope','$document','$ionicLoading', '$state'];
addTeachClassInspireItemController.$inject = ['$scope','$ionicModal','$http','$location','$ionicPopup','$ionicLoading','ynNavigator'];
lookStudentCourseGainInspireController.$inject = ['$scope','$ionicModal','$http','$location','$ionicPopup','ynNavigator'];

function stateConfig($stateProvider){
    $stateProvider
      .state('class_inspire_by_teacher', {
          url: '/class_inspire_by_teacher',
          templateUrl: 'templates/class_inspire/class_inspire.html',
          data: {
              prev: 'workspaceForTeacher',
              title: '课堂表现'
          },
          controller: classInspireController
      })
      .state('class_inspire', {
          url: '/class_inspire',
          templateUrl: 'templates/class_inspire/class_inspire.html',
          data: {
              title: '课堂表现',
              micro: true,
          },
          controller: classInspireController
      })
      .state('student_inspire', {
          url: '/student_inspire',
          templateUrl: 'templates/class_inspire/class_manifestation_details.html',
          data: {
              title: '课堂表现',
              prev: 'class_inspire'
          },
          controller: lookStudentCourseGainInspireController
      })
      .state('project_maintain', {
          url: '/project_maintain',
          templateUrl: 'templates/class_inspire/project_maintain.html',
          data: {
              title: '课堂表现',
              prev: 'class_inspire'
          },
          controller: addTeachClassInspireItemController
      })
      // 教学班维度
      .state('class_inspire_by_class_teacher', {
          url: '/class_inspire_by_class_teacher',
          templateUrl: 'templates/class_inspire/class_inspire.html',
          data: {
              title: '课堂小助手'
          },
          controller: classInspireController
      })
      // 更多
      .state('class_inspire_by_more', {
          url: '/class_inspire_by_more',
          templateUrl: 'templates/class_inspire/class_inspire.html',
          data: {
              micro: true,
              title: '课堂小助手'
          },
          controller: classInspireController
      })
}
function classInspireController($scope,$ionicModal,$http,$location,$ionicPopup,$rootScope,$document,$ionicLoading,$state) {
    $scope.teachClassId = $location.search().teachClassId;
    $scope.adminClassId = $location.search().adminClassId;
    $scope.tab = $location.search().tab;
    $scope.teacherType = $location.search().teacherType;
    if ($state.$current.name === 'class_inspire_by_class_teacher' || $state.$current.name === 'class_inspire_by_more') {
        $scope.teacherType = 1;
    } else if ($state.$current.name === 'class_inspire_by_teacher') {
        $scope.teacherType = 2;
    }
    $scope.termId = $location.search().termId;
    $scope.scrollOffset = $location.search().scrollOffset;
    $scope.getAdminClassAndTerm = function () {
        $ionicLoading.show({
            template: '正在加载...'
        });
        $http.post(originBaseUrl+"/third/result/getAdminClassAndTerm.htm",{userId:$rootScope.authorizationStr.userId}).success(function (data) {
            $scope.loadError = false;
            var result = data.result;
            $scope.curTerm = result.curTerm;
            var termList = result.termList;
            $scope.adminClassList = result.adminClassList;
            if(!$scope.curTerm){
                if(!angular.isArray(termList) || termList.length<1){
                    $scope.dataLoading = false;
                    $scope.loadError = true;
                    $scope.hideHead = true;
                    $scope.loadErrorMsg = '您没有学期信息，无法查看课堂表现！';
                    return false;
                }
            } else {
                $scope.termList = [];
                for (var i = 0; i < termList.length; i++) {
                    if (termList[i].id == $scope.curTerm.id) {
                        $scope.termList.push(termList[i]);
                        $scope.termList.push(termList[i + 1]);
                        break;
                    }
                }
            }
            //用于判断是否拥有任课教师角色
            $scope.isSHowTeachClassSelect = false;
            $http.post(originBaseUrl+"/third/ktjl/mobile/findTeachClassList.htm",{userId:$rootScope.authorizationStr.userId,termId:$scope.curTerm.id}).success(function (data) {
                $scope.kqktTeachClassVoList = data.result.kQktTeachClassVOPage.content;
                if ($scope.kqktTeachClassVoList && $scope.kqktTeachClassVoList.length > 0) {
                    $scope.isSHowTeachClassSelect = true;
                }
                $ionicLoading.hide();
            });
            if (!$scope.teacherType) {
                if ($scope.adminClassList && $scope.adminClassList.length > 0) {
                    $scope.teacherType = 2;
                    $scope.tab = 0;
                }
            }
            $scope.teacherType = !$scope.teacherType ? 1 : $scope.teacherType;
            $scope.tab = !$scope.tab && $scope.tab != 0 ? 1 : $scope.tab;
            if ($scope.teacherType == 2) {
                $scope.tab = !$scope.tab ? 0 : $scope.tab;
            }
            $scope.chooseRole($scope.teacherType,$scope.tab);
        }).error(function () {
            $scope.dataLoading = false;
            $scope.loadError = true;
            $scope.hideHead = true;
            $scope.loadErrorMsg = '加载失败，请重试！';
        });
    };
    $scope.getAdminClassAndTerm();
    $scope.chooseRole = function (teacherType,tab) {
        $scope.teacherType = teacherType;
        $scope.tab = tab;
        if ($scope.teacherType == 1) {
            $scope.releName = "按教学班查看课堂表现";
            $scope.findTeachClassList();
        } else {
            $scope.releName = "按行政班查看课堂表现";
            if (angular.isArray($scope.adminClassList) && $scope.adminClassList.length > 0) {
                if ($scope.tab == null || $scope.tab == 0 || undefined == $scope.tab) {
                    $scope.tab = 0;
                }
                if ($scope.termId) {
                    angular.forEach($scope.termList,function (item) {
                        if ($scope.termId == item.id) {
                            $scope.selectedTerm = item;
                        }
                    })
                    $scope.chooseTerm($scope.selectedTerm,$scope.tab,false);
                } else {
                    $scope.chooseTerm($scope.curTerm,$scope.tab,false);
                }
            }
        }
    }
    $scope.findTeachClassList = function () {
        $ionicLoading.show({
            template: '正在加载...'
        });
        $http.post(originBaseUrl+"/third/ktjl/mobile/findTeachClassList.htm",{userId:$rootScope.authorizationStr.userId,termId:$scope.curTerm.id}).success(function (data) {
            $ionicLoading.hide();
            $scope.kqktTeachClassVoList = data.result.kQktTeachClassVOPage.content;
            if(!angular.isArray($scope.kqktTeachClassVoList) || $scope.kqktTeachClassVoList.length < 1){
                $scope.dataLoading = false;
                $scope.loadError = true;
                $scope.hideHead = true;
                $scope.loadErrorMsg = '您没有负责的行政班及所教授的教学班，无法查看课堂表现！';
                return false;
            }
            if ($scope.tab == null || $scope.tab == 0 || undefined == $scope.tab) {
                $scope.tab = 1;
            }
            if ($scope.teachClassId && $scope.tab) {
                var flag = true;
                angular.forEach($scope.kqktTeachClassVoList,function (item) {
                    if (item.id == $scope.teachClassId) {
                        $scope.currentTeachClassVo = item;
                        flag = false;
                    }
                })
                if (flag) {
                    $scope.currentTeachClassVo = $scope.kqktTeachClassVoList[0];
                }
            } else {
                $scope.currentTeachClassVo = $scope.kqktTeachClassVoList[0];
            }
            if ($scope.termId) {
                angular.forEach($scope.termList,function (item) {
                    if ($scope.termId == item.id) {
                        $scope.selectedTerm = item;
                    }
                })
                $scope.chooseTerm($scope.selectedTerm,$scope.tab,false);
            } else {
                $scope.chooseTerm($scope.curTerm,$scope.tab,false);
            }
        }).error(function () {
            $scope.dataLoading = false;
            $scope.loadError = true;
            $scope.hideHead = true;
            $scope.loadErrorMsg = '加载失败，请重试！';
        });
    }
    $scope.chooseAdminClass = function (item,tab) {
        $scope.selectedAdminClass = item;
        $scope.queryAllTeachClassCourseByAdminClass();
        $scope.tab = tab;
        if (!$scope.teachClassId || !$scope.tab || $scope.tab == 0) {
            $scope.queryAdminClassInspireRanking(tab);
        }
    };
    $scope.chooseTerm = function (term,tab,isSelect) {
        $scope.tab = tab;
        $scope.selectedTerm = term;
        if ($scope.teacherType == 1) {
            if (isSelect) {
                $ionicLoading.show({
                    template: '正在加载...'
                });
                $http.post(originBaseUrl+"/third/ktjl/mobile/findTeachClassList.htm",{userId:$rootScope.authorizationStr.userId,termId:$scope.selectedTerm.id}).success(function (data) {
                    $ionicLoading.hide();
                    $scope.kqktTeachClassVoList = data.result.kQktTeachClassVOPage.content;
                    if ($scope.kqktTeachClassVoList && $scope.kqktTeachClassVoList.length > 0) {
                        $scope.currentTeachClassVo = $scope.kqktTeachClassVoList[0];
                    } else {
                        $scope.dataLoading = false;
                        $scope.loadError = true;
                        $scope.hideHead = true;
                        $scope.loadErrorMsg = '您没有负责的行政班及所教授的教学班，无法查看课堂表现！';
                        return false;
                    }
                    $scope.queryTeachClassAnalysis(tab);
                });
            } else {
                if ($scope.tab == 1) {
                    $scope.queryTeachClassAnalysis(tab);
                } else if ($scope.tab == 2) {
                    $scope.queryTeachClassInspireRanking(tab);
                } else if ($scope.tab == 4) {
                    $scope.queryTeachClassInspireItemByTeachClassId(tab);
                }
            }
        } else {
            if ($scope.adminClassId) {
                for (var i = 0; i < $scope.adminClassList.length; i++) {
                    if ($scope.adminClassId == $scope.adminClassList[i].id) {
                        $scope.chooseAdminClass($scope.adminClassList[i],tab);
                        break;
                    }
                }
            } else {
                $scope.chooseAdminClass($scope.adminClassList[0],tab);
            }
        }
    };
    $scope.queryAllTeachClassCourseByAdminClass = function () {
        $scope.loadError = false;
        var timer = setInterval(function () {
            if ($scope.selectedTerm) {
                $ionicLoading.show({
                    template: '正在加载...'
                });
                $http.post(originBaseUrl + "/third/ktjl/mobile/queryAllTeachClassCourseByAdminClass.htm", {adminClassId: $scope.selectedAdminClass.id, termId: $scope.selectedTerm.id}).success(function (data) {
                    $ionicLoading.hide();
                    $scope.loadError = false;
                    $scope.dataLoading = false;
                    $scope.kqktTeachClassVoList = data.result;
                    if ($scope.teachClassId && $scope.tab) {
                        angular.forEach($scope.kqktTeachClassVoList,function (item) {
                            if (item.id == $scope.teachClassId) {
                                $scope.currentTeachClassVo = item;
                            }
                        })
                        $scope.previewtabStatus = $scope.teachClassId;
                        if ($scope.tab == 2) {
                            $scope.queryTeachClassInspireRanking($scope.tab);
                        } else {
                            $scope.queryTeachClassInspireItemByTeachClassId($scope.tab);
                        }
                    }
                    setTimeout(function () {
                        if ($scope.scrollOffset && $scope.teacherType == 2) {
                            $('#get-scroll-offset').scrollLeft($scope.scrollOffset);
                        }
                    },100);
                }).error(function () {
                    $scope.dataLoading = false;
                    $scope.loadError = true;
                    $scope.loadErrorMsg = '加载失败，请重试！';
                });
                clearInterval(timer);
            }
        },100);
    };
    $scope.changeSelectCourse = function (item,tab) {
        $scope.currentTeachClassVo = item;
        $scope.previewtabStatus = item.id;
        $scope.tab = tab;
        if (tab == 1) {
            $scope.queryTeachClassAnalysis(tab);
        } else {
            $scope.queryTeachClassInspireRanking(tab);
            $scope.scrollOffset = $document.find('#get-scroll-offset')[0].scrollLeft;
        }
    }
    $scope.queryAdminClassInspireRanking = function (tab) {
        $scope.previewtabStatus = tab;
        $scope.currentTeachClassVo = "";
        $ionicLoading.show({
            template: '正在加载...'
        });
        $http.post(originBaseUrl + "/third/ktjl/mobile/queryAdminClassInspireRanking.htm", {adminClassId: $scope.selectedAdminClass.id, termId: $scope.selectedTerm.id}).success(function (data) {
            $ionicLoading.hide();
            if (data.status == 0) {
                $scope.studentGainInspireVoList = data.result;
                angular.forEach($scope.studentGainInspireVoList,function (item) {
                    item.isShowCourseImpire = false;
                })
                $scope.scrollOffset = $document.find('#get-scroll-offset')[0].scrollLeft;
                $scope.queryTeachClassInspireRankingForStudent($scope.studentGainInspireVoList[0].stuId);
            }
        });
    }
    $scope.lookStudentCourseGainInspire = function (item,stuName,tab) {
        var courseName;
        if (tab == 2) {
            courseName = $scope.currentTeachClassVo.courseName;
        } else {
            courseName = item.courseName;
        }
        if ($scope.teacherType == 2) {
            $location.path("/student_inspire").search({
                "teachClassId":item.teachClassId,
                "adminClassId":$scope.selectedAdminClass.id,
                "stuId": item.stuId,
                "termId": $scope.selectedTerm.id,
                "stuName": stuName,
                "courseName": courseName,
                "tab": tab,
                "teacherType": $scope.teacherType,
                "teachClassSource": 1,
                "scrollOffset": $scope.scrollOffset,
                "prev": $state.$current.name
            });
        } else {
            $location.path("/student_inspire").search({
                "teachClassId":item.teachClassId,
                "stuId": item.stuId,
                "termId": $scope.selectedTerm.id,
                "stuName": stuName,
                "courseName": courseName,
                "tab": tab,
                "teacherType": $scope.teacherType,
                "teachClassSource": $scope.currentTeachClassVo.source,
                "scrollOffset": $scope.scrollOffset,
                "prev": $state.$current.name
            });
        }
    }
    $scope.queryTeachClassInspireRankingForStudent = function (item) {
        if (item.isShowCourseImpire) {
            item.isShowCourseImpire = false;
        } else {
            item.isShowCourseImpire = true;
            $ionicLoading.show({
                template: '正在加载...'
            });
            $http.post(originBaseUrl + "/third/ktjl/mobile/queryTeachClassInspireRankingForStudent.htm", {adminClassId: $scope.selectedAdminClass.id,stuId: item.stuId, termId: $scope.selectedTerm.id}).success(function (data) {
                $ionicLoading.hide();
                if (data.status == 0) {
                    $scope.studentCourseGainInspireVoList = data.result;
                }
            });
        }
    }
    $scope.queryTeachClassInspireRanking = function (tab) {
        $scope.tab = tab;
        $ionicLoading.show({
            template: '正在加载...'
        });
        var teachClassSource = 1;
        if ($scope.teacherType == 1) {
            teachClassSource = $scope.currentTeachClassVo.source;
        }
        $http.post(originBaseUrl + "/third/ktjl/mobile/queryTeachClassInspireRanking.htm", {teachClassId: $scope.currentTeachClassVo.id,teachClassSource: teachClassSource,termId:$scope.selectedTerm.id}).success(function (data) {
            $ionicLoading.hide();
            if (data.status == 0) {
                $scope.inspireRankingList = data.result;
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: "查询失败!",
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        });
    }
    $scope.pageNumber = 0;
    $scope.pageSize = 20;
    $scope.queryInspireDetail = function (tab,isFirst) {
        $scope.tab = tab;
        if (isFirst) {
            $scope.studentGainInspireVoList = [];
            $scope.pageNumber = 0;
            $scope.pageSize = 20;
        }
        $ionicLoading.show({
            template: '正在加载...'
        });
        $http.post(originBaseUrl + "/third/ktjl/mobile/queryStudentGainInspire.htm", {teachClassId: $scope.currentTeachClassVo.id,platformSysTermId:$scope.selectedTerm.id,name :$scope.userName,pageNumber:$scope.pageNumber,pageSize:$scope.pageSize}).success(function (data) {
            $ionicLoading.hide();
            if (data.status == 0) {
                $scope.studentGainInspireVoList = $scope.studentGainInspireVoList.concat(data.result.content);
                $scope.isShowMore = $scope.studentGainInspireVoList.length != data.result.totalElements;
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: "查询失败!",
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        });
    }
    $scope.loadMore = function () {
        $scope.pageNumber ++;
        $scope.queryInspireDetail(3,false);
    }
    $scope.queryTeachClassAnalysis = function (tab) {
        $scope.tab = tab;
        $ionicLoading.show({
            template: '正在加载...'
        });
        $scope.queryTeachClassInspireItemByTeachClassId(tab);
        $http.post(originBaseUrl + "/third/ktjl/mobile/queryTeachClassAnalysis.htm", {teachClassId: $scope.currentTeachClassVo.id,termId:$scope.selectedTerm.id}).success(function (data) {
            $ionicLoading.hide();
            if (data.status == 0) {
                $scope.teachClassAnalysisVo = data.result;
                if ($scope.teachClassAnalysisVo.teachClassInspireItemVoList.length > 0) {
                    var timer = setInterval(function () {
                        if ($scope.flag) {
                            $scope.praise();
                            $scope.improve();
                            clearInterval(timer);
                        }
                    },100);
                } else {
                    var timer = setInterval(function () {
                        if ($scope.flag) {
                            $scope.praise();
                            $scope.improve();
                            clearInterval(timer);
                        }
                    },100);
                }

            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: "查询失败!",
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        });
    }
    $scope.queryTeachClassInspireItemByTeachClassId = function (tab) {
        $scope.praiseItemList = [];
        $scope.improveItemList = [];
        $scope.flag = false;
        $scope.tab = tab;
        $ionicLoading.show({
            template: '正在加载...'
        });
        $http.get(originBaseUrl+"/third/ktjl/mobile/queryTeachClassInspireItemByTeachClassId.htm?teachClassId=" + $scope.currentTeachClassVo.id + "&teachClassSource=1" +
            "&courseId=" + $scope.currentTeachClassVo.courseId + "&termId="+$scope.selectedTerm.id + "userId=" +$rootScope.authorizationStr.userId).success(function(data){
            $ionicLoading.hide();
            if(data.status == 0){
                angular.forEach(data.result,function (item) {
                    if (item.inspireType == 1) {
                        $scope.praiseItemList.push(item);
                    } else {
                        $scope.improveItemList.push(item);
                    }
                })
                $scope.flag = true;
            }
        });
    }
    $scope.addTeachClassInspireItem = function () {
        $location.path("/project_maintain").search({
            "teachClassId":$scope.currentTeachClassVo.id,
            "tab": 4,
            "teacherType": $scope.teacherType,
            "inspireType": 1,
            "coin": 1,
            "termId": $scope.selectedTerm.id,
            "prev": $state.$current.name
        });
    }
    $scope.modifyTeachClassInspireItem = function (item) {
        $location.path("/project_maintain").search({
            "id":item.id,
            "inspireType": item.inspireType,
            "itemName": item.itemName,
            "coin": item.coin,
            "teachClassId":$scope.currentTeachClassVo.id,
            "tab": 4,
            "teacherType": $scope.teacherType,
            "termId": $scope.selectedTerm.id,
            "prev": $state.$current.name
        });
    }
    $scope.praise = function () {
        var indicatorArr = [];
        var dataValueArr = [];
        if ($scope.praiseItemList && $scope.praiseItemList.length > 0) {
            var maxValue = 5;
            angular.forEach($scope.teachClassAnalysisVo.teachClassInspireItemVoList, function (item) {
                if (item.inspireType == 1 && maxValue < item.gainInspirePersonTimes) {
                    maxValue = item.gainInspirePersonTimes;
                }
            })
            if (maxValue % 5 > 0) {
                maxValue = maxValue + (5 - maxValue % 5);
            }
            angular.forEach($scope.praiseItemList,function (praise) {
                var flag = true;
                angular.forEach($scope.teachClassAnalysisVo.teachClassInspireItemVoList,function (item) {
                    if (praise.id == item.id) {
                        indicatorArr.push({name: praise.itemName.length > 5 ? praise.itemName.substring(0,5) + "\n" + praise.itemName.substring(5,praise.itemName.length) : praise.itemName,max: maxValue});
                        dataValueArr.push(item.gainInspirePersonTimes);
                        flag = false;
                    }
                })
                if (flag) {
                    indicatorArr.push({name: praise.itemName.length > 5 ? praise.itemName.substring(0,5) + "\n" + praise.itemName.substring(5,praise.itemName.length) : praise.itemName,max: maxValue});
                    dataValueArr.push(0);
                }
            })
        }
        if (indicatorArr) {
            echarts.init(document.getElementById("praise")).setOption({
                color: ['#22AC38'],
                radar: {
                    name: {
                        textStyle: {
                            color: 'black',
                            fontSize: 12
                        },
                    },
                    center: ['50%', '50%'],
                    // 圆中心坐标，数组的第一项是横坐标，第二项是纵坐标。[ default: ['50%', '50%'] ]
                    radius: 65,
                    indicator: indicatorArr
                },
                series: [{
                    type: 'radar',
                    data: [
                        {
                            value: dataValueArr
                        }
                    ]
                }]
            });
        }
    }
    $scope.improve = function () {
        var indicatorArr = [];
        var dataValueArr = [];
        if ($scope.improveItemList && $scope.improveItemList.length > 0) {
            var maxValue = 5;
            angular.forEach($scope.teachClassAnalysisVo.teachClassInspireItemVoList, function (item) {
                if (item.inspireType == 2 && maxValue < item.gainInspirePersonTimes) {
                    maxValue = item.gainInspirePersonTimes;
                }
            })
            if (maxValue % 5 > 0) {
                maxValue = maxValue + (5 - maxValue % 5);
            }
            angular.forEach($scope.improveItemList,function (praise) {
                var flag = true;
                angular.forEach($scope.teachClassAnalysisVo.teachClassInspireItemVoList,function (item) {
                    if (praise.id == item.id) {
                        indicatorArr.push({name: praise.itemName.length > 5 ? praise.itemName.substring(0,5) + "\n" + praise.itemName.substring(5,praise.itemName.length) : praise.itemName,max: maxValue});
                        dataValueArr.push(item.gainInspirePersonTimes);
                        flag = false;
                    }
                })
                if (flag) {
                    indicatorArr.push({name: praise.itemName.length > 5 ? praise.itemName.substring(0,5) + "\n" + praise.itemName.substring(5,praise.itemName.length) : praise.itemName,max: maxValue});
                    dataValueArr.push(0);
                }
            })
        }
        if (indicatorArr.length > 0) {
            echarts.init(document.getElementById("improve")).setOption({
                color: ['#EB6203'],
                radar: {
                    name: {
                        textStyle: {
                            color: 'black',
                            fontSize: 12
                        }
                    },
                    center: ['50%', '50%'],
                    // 圆中心坐标，数组的第一项是横坐标，第二项是纵坐标。[ default: ['50%', '50%'] ]
                    radius: 65,
                    indicator: indicatorArr
                },
                series: [{
                    type: 'radar',
                    data: [
                        {
                            value: dataValueArr
                        }
                    ]
                }]
            });
        }
    }
    $scope.goBack = function () {
        yn.plugin.yncordova.close();
    }
}
function addTeachClassInspireItemController($scope,$ionicModal,$http,$location,$ionicPopup,$ionicLoading,ynNavigator){
    $scope.inspireItem = {}
    $scope.inspireItem.id = $location.search().id;
    $scope.tab = $location.search().tab;
    $scope.inspireItem.itemName = $location.search().itemName;
    $scope.inspireItem.coin = $location.search().coin;
    $scope.inspireItem.inspireType = $location.search().inspireType;
    $scope.inspireItem.teachClassId = $location.search().teachClassId;
    $scope.teacherType = $location.search().teacherType;
    $scope.termId = $location.search().termId;
    $scope.prev = $location.search().prev;
    $scope.goBack = function() {
        $location.path("/" + $scope.prev).search({
            "teachClassId":$scope.inspireItem.teachClassId,
            "tab": $scope.tab,
            "teacherType": $scope.teacherType,
            "termId": $scope.termId
        });
        $scope.$apply();
    }
    ynNavigator.registerBackAction(function () {
       $scope.goBack();
    },101);
    $scope.changeCoin = function (coin) {
        $scope.inspireItem.coin = coin;
    }
    $scope.changeInspireType = function (inspireType) {
        if (inspireType == 1) {
            $scope.inspireItem.coin = 1;
        } else {
            $scope.inspireItem.coin = -1;
        }
        $scope.inspireItem.inspireType = inspireType;
    }
    $scope.saveOrUpdateInspireItem = function () {
        if (!$scope.inspireItem.inspireType) {
            var alertPopup = $ionicPopup.show({
                title: '提示',
                template: "请选择激励类型!"
            });
            alertPopup.then(function(res) {
            });
            setTimeout(function() {
                myPopup.close(); // 3秒后关闭弹窗
            }, 1000);
            return false;
        }
        if (!$scope.inspireItem.itemName) {
            var alertPopup = $ionicPopup.show({
                title: '提示',
                template: "请输入项目名称!"
            });
            alertPopup.then(function(res) {
            });
            setTimeout(function() {
                alertPopup.close(); // 3秒后关闭弹窗
            }, 1000);
            return false;
        }
        if (!$scope.inspireItem.coin) {
            var alertPopup = $ionicPopup.show({
                title: '提示',
                template: "请选择爱课币!"
            });
            alertPopup.then(function(res) {
            });
            setTimeout(function() {
                alertPopup.close(); // 3秒后关闭弹窗
            }, 1000);
            return false;
        }
        $scope.teachClassInspireItem = {};
        $scope.teachClassInspireItem.id = $scope.inspireItem.id;
        $scope.teachClassInspireItem.teachClassId = $scope.inspireItem.teachClassId;
        $scope.teachClassInspireItem.teachClassSource = 1;
        $scope.teachClassInspireItem.inspireType = $scope.inspireItem.inspireType;
        $scope.teachClassInspireItem.itemName = $scope.inspireItem.itemName;
        $scope.teachClassInspireItem.coin = $scope.inspireItem.coin;
        $ionicLoading.show({
            template: '正在保存...'
        });
        $http.post(originBaseUrl+"/third/ktjl/mobile/saveOrUpdateTeachClassInspireItem.htm",$scope.teachClassInspireItem).success(function(data){
            $ionicLoading.hide();
            if(data.status == 0){
                if (!data.message) {
                    var alertPopup = $ionicPopup.show({
                        title: '提示',
                        template: "保存成功！"
                    });
                    alertPopup.then(function(res) {
                    });
                    setTimeout(function() {
                        alertPopup.close(); // 3秒后关闭弹窗
                    }, 1000);
                    $scope.goBack();
                } else {
                    var alertPopup = $ionicPopup.show({
                        title: '提示',
                        template: data.message
                    });
                    alertPopup.then(function(res) {
                    });
                    setTimeout(function() {
                        alertPopup.close(); // 3秒后关闭弹窗
                    }, 1000);
                }
            } else {
                var alertPopup = $ionicPopup.show({
                    title: '提示',
                    template: "保存失败!"
                });
                alertPopup.then(function(res) {
                });
                setTimeout(function() {
                    alertPopup.close(); // 3秒后关闭弹窗
                }, 1000);
            }
        });
    }
    $scope.deleteTeachClassInspireItem = function () {
        $ionicLoading.show({
            template: '正在删除...'
        });
        $http.post(originBaseUrl + "/third/ktjl/mobile//deleteTeachClassInspireItem.htm", {id: $scope.inspireItem.id}).success(function (data) {
            $ionicLoading.hide();
            if (data.status == 0) {
                if (!data.message) {
                    var alertPopup = $ionicPopup.show({
                        title: '提示',
                        template: "删除成功!"
                    });
                    alertPopup.then(function(res) {
                    });
                    setTimeout(function() {
                        alertPopup.close(); // 3秒后关闭弹窗
                    }, 1000);
                    $scope.goBack();
                } else {
                    var alertPopup = $ionicPopup.show({
                        title: '提示',
                        template: data.message
                    });
                    alertPopup.then(function(res) {
                    });
                    setTimeout(function() {
                        alertPopup.close(); // 3秒后关闭弹窗
                    }, 1000);
                }
            } else {
                var alertPopup = $ionicPopup.show({
                    title: '提示',
                    template: "删除失败!"
                });
                alertPopup.then(function(res) {
                });
                setTimeout(function() {
                    alertPopup.close(); // 3秒后关闭弹窗
                }, 1000);
            }
        });
    }
}
function lookStudentCourseGainInspireController($scope,$ionicModal,$http,$location,$ionicPopup,ynNavigator){
    $scope.teachClassId = $location.search().teachClassId;
    $scope.adminClassId = $location.search().adminClassId;
    $scope.teachClassSource = $location.search().teachClassSource;
    $scope.tab = $location.search().tab;
    $scope.stuId = $location.search().stuId;
    $scope.termId = $location.search().termId;
    $scope.courseName = $location.search().courseName;
    $scope.stuName = $location.search().stuName;
    $scope.teacherType = $location.search().teacherType;
    $scope.scrollOffset = $location.search().scrollOffset;
    $scope.praiseItemList = [];
    $scope.improveItemList = [];
    $scope.flag = false;
    // 上级路由
    $scope.prev = $location.search().prev;
    $http.post(originBaseUrl + "/third/ktjl/mobile/queryInspireExcellentAverage.htm", {teachClassId: $scope.teachClassId,teachClassSource: $scope.teachClassSource,termId:$scope.termId}).success(function (data) {
        if (data.status == 0) {
            $scope.inspireExcellentAverageList = data.result;
        } else {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: "查询失败!",
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        }
    });
    $http.get(originBaseUrl+"/third/ktjl/mobile/queryTeachClassInspireItemByTeachClassId.htm?teachClassId=" + $scope.teachClassId + "&teachClassSource=1").success(function(data){
        if(data.status == 0){
            angular.forEach(data.result,function (item) {
                if (item.inspireType == 1) {
                    $scope.praiseItemList.push(item);
                } else {
                    $scope.improveItemList.push(item);
                }
            })
            $scope.flag = true;
        }
    });
    $http.post(originBaseUrl+"/third/ktjl/mobile/queryInspireDetailByStudent.htm", {teachClassId:$scope.teachClassId,stuId:$scope.stuId,platformSysTermId:$scope.termId}).success(function(data){
        $scope.studentGainInspireVoList = data.result.termStudentGainInspireVoList;
        $scope.sevenStudentGainInspireVoList = data.result.sevenStudentGainInspireVoList;
        $scope.praiseInspireMap = new Map();
        $scope.improveInspireMap = new Map();
        $scope.praiseCoin = 0;
        $scope.improveCoin = 0;
        angular.forEach($scope.studentGainInspireVoList,function (item) {
            if (item.inspireType == "表扬") {
                if ($scope.praiseInspireMap.get(item.teachClassInspireitemId)) {
                    var coin = $scope.praiseInspireMap.get(item.teachClassInspireitemId) + item.coin;
                    $scope.praiseInspireMap.remove(item.teachClassInspireitemId);
                    $scope.praiseInspireMap.put(item.teachClassInspireitemId, coin);
                } else {
                    $scope.praiseInspireMap.put(item.teachClassInspireitemId, item.coin);
                }
                $scope.praiseCoin = $scope.praiseCoin + item.coin;
            } else {
                if ($scope.improveInspireMap.get(item.teachClassInspireitemId)) {
                    var coin = $scope.improveInspireMap.get(item.teachClassInspireitemId) + item.coin;
                    $scope.improveInspireMap.remove(item.teachClassInspireitemId);
                    $scope.improveInspireMap.put(item.teachClassInspireitemId, coin);
                } else {
                    $scope.improveInspireMap.put(item.teachClassInspireitemId, item.coin);
                }
                $scope.improveCoin = $scope.improveCoin + item.coin;
            }
        })
        var timer = setInterval(function () {
            if ($scope.flag && $scope.inspireExcellentAverageList) {
                $scope.personalPraise();
                $scope.personalImprove();
                clearInterval(timer);
            }
        },100);
    });
    $scope.personalPraise = function () {
        var indicatorArr = [];
        var dataValueArr = [];
        var excellentArr = [];
        var averageArr = [];
        if ($scope.praiseItemList && $scope.praiseItemList.length > 0) {
            var maxValue = 5;
            for (var i = 0; i < $scope.praiseInspireMap.keySet().length; i++) {
                if (maxValue < $scope.praiseInspireMap.get($scope.praiseInspireMap.keySet()[i])) {
                    maxValue = $scope.praiseInspireMap.get($scope.praiseInspireMap.keySet()[i]);
                }
            }
            angular.forEach($scope.praiseItemList,function (praise) {
                var flag = true;
                for (var i = 0; i < $scope.inspireExcellentAverageList.length; i++) {
                    if (praise.id == $scope.inspireExcellentAverageList[i].teachClassInspireitemId) {
                        excellentArr.push($scope.inspireExcellentAverageList[i].excellent);
                        averageArr.push($scope.inspireExcellentAverageList[i].average);
                        flag = false;
                        maxValue = maxValue < $scope.inspireExcellentAverageList[i].excellent ? $scope.inspireExcellentAverageList[i].excellent : maxValue;
                        break;
                    }
                }
                if (flag) {
                    excellentArr.push(0);
                    averageArr.push(0);
                }
                if (maxValue % 5 > 0) {
                    maxValue = maxValue + (5 - maxValue % 5);
                }
            });
            angular.forEach($scope.praiseItemList,function (praise) {
                var flag = true;
                for (var i = 0; i < $scope.praiseInspireMap.keySet().length; i++) {
                    if (praise.id == $scope.praiseInspireMap.keySet()[i]) {
                        indicatorArr.push({name: praise.itemName.length > 5 ? praise.itemName.substring(0,5) + "\n" + praise.itemName.substring(5,praise.itemName.length) : praise.itemName, max: maxValue});
                        dataValueArr.push($scope.praiseInspireMap.get($scope.praiseInspireMap.keySet()[i]));
                        flag = false;
                        break;
                    }
                }
                if (flag) {
                    indicatorArr.push({name: praise.itemName.length > 5 ? praise.itemName.substring(0,5) + "\n" + praise.itemName.substring(5,praise.itemName.length) : praise.itemName,max: maxValue});
                    dataValueArr.push(0);
                }
            })
        }
        if (indicatorArr.length > 0) {
            echarts.init(document.getElementById("personalPraise")).setOption({
                color: ['#22AC38','#0081EE','#E4007F'],
                legend: {
                    data: ['个人表现', '班级平均','班级优秀']
                },
                radar: {
                    name: {
                        textStyle: {
                            color: 'black'
                        },
                    },
                    center: ['50%', '50%'],
                    // 圆中心坐标，数组的第一项是横坐标，第二项是纵坐标。[ default: ['50%', '50%'] ]
                    radius: 60,
                    indicator: indicatorArr
                },
                series: [{
                    type: 'radar',
                    data: [
                        {
                            value: dataValueArr,
                            name: '个人表现'
                        },
                        {
                            value: averageArr,
                            name: '班级平均'
                        },
                        {
                            value: excellentArr,
                            name: '班级优秀'
                        }
                    ]
                }]
            });
        }
    }
    $scope.personalImprove = function () {
        var indicatorArr = [];
        var dataValueArr = [];
        if ($scope.improveItemList && $scope.improveItemList.length > 0) {
            var maxValue = 5;
            for (var i = 0; i < $scope.improveInspireMap.keySet().length; i++) {
                if (maxValue < Math.abs($scope.improveInspireMap.get($scope.improveInspireMap.keySet()[i]))) {
                    maxValue = Math.abs($scope.improveInspireMap.get($scope.improveInspireMap.keySet()[i]));
                }
            }
            if (maxValue % 5 > 0) {
                maxValue = maxValue + (5 - maxValue % 5);
            }
            angular.forEach($scope.improveItemList,function (praise) {
                var flag = true;
                for (var i = 0; i < $scope.improveInspireMap.keySet().length; i++) {
                    if (praise.id == $scope.improveInspireMap.keySet()[i]) {
                        indicatorArr.push({name: praise.itemName.length > 5 ? praise.itemName.substring(0,5) + "\n" + praise.itemName.substring(5,praise.itemName.length) : praise.itemName, max: maxValue});
                        dataValueArr.push(Math.abs($scope.improveInspireMap.get($scope.improveInspireMap.keySet()[i])));
                        flag = false;
                        break;
                    }
                }
                if (flag) {
                    indicatorArr.push({name: praise.itemName.length > 5 ? praise.itemName.substring(0,5) + "\n" + praise.itemName.substring(5,praise.itemName.length) : praise.itemName,max: maxValue});
                    dataValueArr.push(0);
                }
            })
        }
        if (indicatorArr.length > 0) {
            echarts.init(document.getElementById("personalImprove")).setOption({
                color: ['#EB6203'],
                radar: {
                    name: {
                        textStyle: {
                            color: 'black'
                        }
                    },
                    center: ['50%', '50%'],
                    // 圆中心坐标，数组的第一项是横坐标，第二项是纵坐标。[ default: ['50%', '50%'] ]
                    radius: 65,
                    indicator: indicatorArr
                },
                series: [{
                    type: 'radar',
                    data: [
                        {
                            value: dataValueArr
                        }
                    ]
                }]
            });
        }
    }
    $scope.goBack = function() {
        $location.path("/" + $scope.prev).search({
            "teachClassId":$scope.teachClassId,
            "adminClassId":$scope.adminClassId,
            "tab":$scope.tab,
            "teacherType": $scope.teacherType,
            "termId": $scope.termId,
            "scrollOffset": $scope.scrollOffset
        });
        $scope.$apply();
    }
    ynNavigator.registerBackAction(function () {
        $scope.goBack();
    },101);
}
