/**
 * 教职工巡课首页
 *
 * @author Jin
 */
(function () {
  'use strict';

  angular
    .module('starter')
    .config(config)
    .controller('classPatrolIndexByTeaCtrl', classPatrolIndexByTeaCtrl);

  config.$inject = ['$stateProvider']

  function config($stateProvider) {
    $stateProvider
      // 首页
      .state('classPatrolIndexByTea', {
        firstPage: true,
        url: '/classPatrolIndexByTea',
        templateUrl: 'templates/classpatrol/index.html',
        data: {
          title: '巡课',
          micro: true
        },
        controller: 'classPatrolIndexByTeaCtrl',
      })
  }

  classPatrolIndexByTeaCtrl.$inject = ['$scope', '$http', '$state', '$ionicModal', '$ionicLoading',
    '$ionicScrollDelegate', '$location', "ynuiNotification", "storageService", "$document",
    "$ionicPopup", "modalManager", "$cordovaBarcodeScanner"]

  function classPatrolIndexByTeaCtrl(
    $scope, $http, $state, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location,
    ynuiNotification, storageService, $document, $ionicPopup, modalManager, $cordovaBarcodeScanner) {
    // 路由信息
    var basePath = originBaseUrl + "/third/xcMobileNewRecord";

    var vm = $scope.vm = {
      // 查询对象
      queryVO: {
        // 教室类型 1=全部教室 2=异常教室
        roomType: 2,
        dateTimes: null,
        termId: null,
        week: null,
        day: null,
        knob: null,
        timeType: null
      },
      currentDate: null,
      // 跳转来源 1=扫一扫，2=单个添加
      sourceType: null,
      // 全部教室数量
      allRoomNum: null,
      all: null,
      // 异常教室数量
      abnormalNum: null,
      // 列表数据
      xcRecordListVOList: [],
      // 所有节次
      knobList: [],
      // 查看、编辑 记录
      oldRecordToViewOrUpdate: null,
      // 批量登记
      batchAdd: function () {
        $state.go('patrol_register_batch');
      },
      // 单个登记
      singleAddScan: function (type) {
        vm.sourceType = type;
        $scope.$on("single_register", function (event, data) {
          if (data) {
            vm.findAllXCRecordList();
          }
        });
        if (type == 1) {
          // 查询教室
          $cordovaBarcodeScanner.scan().then(function (barcodeData) {
            if (!barcodeData || !barcodeData.text) {
              ynuiNotification.error({msg: "没有找到对应教室，请重新扫描教室二维码！"});
              return;
            }
            try {
              // 判断是否为json字符串
              var classRoomScan = JSON.parse(barcodeData.text);
              if (classRoomScan && classRoomScan.classRoomId) {
                // 判断教室是否存在
                $http.post(basePath + "/findAvailableRoom.htm", {id: classRoomScan.classRoomId}).success(function (data) {
                  console.log(data);
                  if (data.status == 0 && data.result) {
                    vm.scanRoomId = data.result;
                    $state.go('patrol_register_single', {oldVm: angular.toJson(vm)});
                  } else {
                    ynuiNotification.error({msg: "没有找到对应教室，请重新扫描教室二维码！"});
                  }
                });

              } else {
                ynuiNotification.error({msg: "请扫描教室对应的二维码！"});
              }
            } catch (er) {
              ynuiNotification.error({msg: "请扫描教室对应的二维码！"});
              return false;
            }

          }, function (error) {
            console.log(error);
            ynuiNotification.error({msg: "扫描失败！"});
          });
        } else {
          $state.go('patrol_register_single', {oldVm: angular.toJson(vm)});
        }
      }
    };
  }
})();
