/**
 * 课堂考勤路由
 */
(function () {
    'use strict';
    angular.module('starter')
        .config(config_)
        .controller('coursesController', coursesController)
        .controller('addAttendanceController', addAttendanceController);

    config_.$inject = ['$stateProvider', '$urlRouterProvider'];

    function config_($stateProvider, $urlRouterProvider) {
        $stateProvider
          .state('attendance_by_teacher', {
              url: '/attendance_by_teacher',
              templateUrl: 'templates/classroom_attendance/teacher/courses.html',
              data: {
                  prev: 'workspaceForTeacher',
                  title: '课堂考勤'
              }
          })
          .state('attendance', {
              url: '/attendance?nowDate&week&day',
              templateUrl: 'templates/classroom_attendance/teacher/courses.html',
              data: {
                  title: '课堂考勤',
                  micro: true
              }
          })
          .state('add_attendance', {
              url: '/add_attendance?prev',
              templateUrl: 'templates/classroom_attendance/teacher/add_attendance.html',
              data: {
                  title: '课堂考勤',
                  prev: 'attendance'
              }
          })
          .state('attendance_list_by_teacher', {
              url: '/attendance_list_by_teacher',
              templateUrl: 'templates/classroom_attendance/common/attendance_list.html',
              data: {
                  title: '课堂考勤',
                  prev: 'attendance_by_teacher'
              },
              controller: 'attendanceListController'
          })
          // 点名
          .state('add_attendance_by_top', {
              url: '/add_attendance_by_top?prev',
              templateUrl: 'templates/classroom_attendance/teacher/add_attendance.html',
              data: {
                  micro: true,
                  title: '点名'
              }
          })
          .state('attendance_list_by_top', {
              url: '/attendance_list_by_top',
              templateUrl: 'templates/classroom_attendance/common/attendance_list.html',
              data: {
                  title: '点名',
                  prev: 'add_attendance_by_top'
              },
              controller: 'attendanceListController'
          })
          // 更多
          .state('attendance_by_more', {
              url: '/attendance_by_more',
              templateUrl: 'templates/classroom_attendance/teacher/courses.html',
              data: {
                  title: '课堂小助手',
                  micro: true
              }
          })
          .state('add_attendance_by_more', {
              url: '/add_attendance_by_more?prev',
              templateUrl: 'templates/classroom_attendance/teacher/add_attendance.html',
              data: {
                  title: '课堂考勤',
                  prev: 'attendance_by_more'
              }
          })
          .state('attendance_list_by_more', {
              url: '/attendance_list_by_more',
              templateUrl: 'templates/classroom_attendance/common/attendance_list.html',
              data: {
                  title: '课堂考勤',
                  prev: 'attendance_by_more'
              },
              controller: 'attendanceListController'
          })

    }

    coursesController.$inject = ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification', '$ionicScrollDelegate', 'kqktMobileService', '$filter', '$ionicPopup', '$state','$stateParams'];

    // 任课老师课程列表
    function coursesController($scope, $ionicModal, $http, $location, ynuiNotification, $ionicScrollDelegate, kqktMobileService, $filter, $ionicPopup, $state,$stateParams) {

        var basePath = originBaseUrl + "/third/kqkt/mobile";

        $scope.changeWeek = changeWeek;
        $scope.changeDay = changeDay;
        $scope.submitTeacherKqkt = submitTeacherKqkt;
        $scope.toAddAtendance = toAddAtendance;

        $scope.prevDay = prevDay;
        $scope.nextDay = nextDay;

        var bizType = "teacher";

        $scope.teacherData = {
            dateStr: "",
            date: "",
            weekInfoStr: "",
            weekInfoCode: "",
            weekDayObjList: [],
            week: "",
            day: "",
            weekInfo: {},
            recordList: []
        };

        function findKqktMobilaWeek() {
            $http.get(basePath + "/findKqktMobilaWeek.htm").success(function (data) {
                if (data.status == 0) {
                    if ($stateParams.nowDate) {
                        data.result.today=$stateParams.nowDate;
                        data.result.week=$stateParams.week;
                        data.result.day=$stateParams.day;
                    }
                    $scope.teacherData.weekInfo = data.result;
                    if ($scope.teacherData.weekInfo) {

                        $scope.teacherData.weekInfoCode = data.result.week + "_" + data.result.day;
                        $scope.teacherData.week = data.result.week;
                        $scope.teacherData.weekInfoStr = convertWeekStr($scope.teacherData.weekInfoCode);
                        var nowDate = $filter('date')(new Date(), 'yyyy-MM-dd');
                        if (data.result.today === nowDate) {
                            $scope.teacherData.dateStr = getTodayStr(data.result.today);
                        } else {
                            $scope.teacherData.dateStr = data.result.today;
                        }
                        $scope.teacherData.date = data.result.today;
                        setWeekDayObjList();
                        findTeacherKqktRecordList();
                    }
                }
            });
        }

        function getTodayStr(today) {
            return "[今天]" + today;
        }

        findKqktMobilaWeek();

        function findTeacherKqktRecordList() {

            var weekObj = getWeekInfoCodeObj();

            var week = weekObj.week;
            var day = weekObj.day;

            var termId = $scope.teacherData.weekInfo.termId;
            var date = $scope.teacherData.date;

            var postData = {date: date, week: week, day: day, termId: termId};
            $http.post(basePath + "/findTeacherKqktRecordList.htm", postData).success(function (data) {
                if (data.status == 0) {
                    if (data.result && data.result.length > 0) {
                        $scope.teacherData.recordList = data.result;
                    } else {
                        $scope.teacherData.recordList = [];
                    }
                    setTimeout(function () {
                        $scope.$apply($scope.teacherData.recordList);
                        $ionicScrollDelegate.$getByHandle('listScroll').scrollTop(false);
                    })
                } else {
                    ynuiNotification.error({msg: "获取数据失败！"});
                }
            });
        }

        function changeDay(weekCode) {

            $scope.teacherData.weekInfoStr = convertWeekStr(weekCode);
            $scope.teacherData.weekInfoCode = weekCode;

            var weekObj = getWeekInfoCodeObj();

            var week = weekObj.week;
            var day = weekObj.day;
            getDayStr(week, day);
            $scope.teacherData.week = week;
        }

        function getDayStr(week, day) {
            var getData = {week: week, day: day, termId: $scope.teacherData.weekInfo.termId};
            $http.get(basePath + "/queryDayStrByTermIdAndWeekAndDay.htm", {params: getData}).success(function (data) {
                if (data.status == 0) {
                    $scope.teacherData.date = data.result;
                    var nowDate = $filter('date')(new Date(), 'yyyy-MM-dd');
                    if (data.result === nowDate) {
                        $scope.teacherData.dateStr = getTodayStr(data.result);
                    } else {
                        $scope.teacherData.dateStr = data.result;
                    }
                    //切换了日期刷新列表
                    findTeacherKqktRecordList();
                }
            });
        }

        function changeWeek(op) {
            var totalWeek = $scope.teacherData.weekInfo.totalWeek;
            if (op == "next") {
                var result = parseInt($scope.teacherData.week) + 1;
                if (result <= totalWeek) {
                    $scope.teacherData.week = result;
                    setWeekDayObjList();
                }
            } else if (op == "prev") {
                var result = parseInt($scope.teacherData.week) - 1;
                if (result > 0) {
                    $scope.teacherData.week = result;
                    setWeekDayObjList();
                }
            }
        }

        function setWeekDayObjList() {
            var weekDayObjList = [];
            var weekDayList = $scope.teacherData.weekInfo.weekDayList;
            var week = $scope.teacherData.week;
            for (var i = 0; i < weekDayList.length; i++) {
                weekDayObjList.push({id: week + "_" + (i + 1), name: weekDayList[i]});
            }
            $scope.teacherData.weekDayObjList = weekDayObjList;
        }

        function convertWeekStr(week) {
            var w = week.split("_");
            return "第" + w[0] + "周" + getWeekDayStr(w[1]);
        }

        function getWeekDayStr(weekDay) {
            var weekDayList = $scope.teacherData.weekInfo.weekDayList;
            for (var i = 0; i < weekDayList.length; i++) {
                if (weekDay == (i + 1)) {
                    return weekDayList[i];
                }
            }
            return "";
        }

        function getWeekInfoCodeObj() {
            var weekInfoCodeArr = $scope.teacherData.weekInfoCode.split("_");
            return {week: weekInfoCodeArr[0], day: weekInfoCodeArr[1]}
        }

        function buildSubmitParams(item) {
            var params = {};
            params.termId = $scope.teacherData.weekInfo.termId;
            params.courseId = item.courseId;
            params.knob = item.knob;
            params.source = item.teachResources;
            params.teachClassId = item.teachClassId;
            params.timeType = item.timeType;

            params.kqTime = $scope.teacherData.date;

            var weekObj = getWeekInfoCodeObj();

            var week = weekObj.week;
            var day = weekObj.day;

            params.day = day;
            params.week = week;
            params.weekStr = getWeekDayStr(day);

            return params;
        }

        function submitTeacherKqkt(item) {
            //如果已点名
            if (item.rollCall) {
                if ($state.$current.name === 'attendance_by_more') {
                    $location.path("/attendance_list_by_more").search({id: item.id, bizType: bizType});
                } else {
                    $location.path("/attendance_list_by_teacher").search({id: item.id, bizType: bizType});
                }
            } else {
                var postData = buildSubmitParams(item);

                // kqktMobileService.recognitionRateFace(1,postData).then(function (data) {
                //     if(data.go){
                //
                //
                //
                //     }
                // });
                $http.post(basePath + "/submitKqktRollCall.htm", postData).success(function (data) {
                    if (data.status == 0) {
                        if (data.result != null) {
                            if ($state.$current.name === 'attendance_by_more') {
                                $location.path("/attendance_list_by_more").search({id: data.result, bizType: bizType});
                            } else {
                                $location.path("/attendance_list_by_teacher").search({id: data.result, bizType: bizType});
                            }
                        }
                    } else if (data.status == 10) {
                        $ionicPopup.confirm({
                            title: '提示',
                            template: "当前时间正在进行课堂自动考勤，确定要手动点名吗？课堂自动考勤将自动生成学生课堂考勤记录，若您仍坚持手动点名，将导致系统无法生成数据。",
                            cancelText: '取消',
                            okText: '确认'
                        }).then(function (res) {
                            if (res) {
                                postData.submitFlag = true;
                                $http.post(basePath + "/submitKqktRollCall.htm", postData).success(function (data) {
                                    if (data.status == 0) {
                                        if (data.result != null) {
                                            if ($state.$current.name === 'attendance_by_more') {
                                                $location.path("/attendance_list_by_more").search({id: data.result, bizType: bizType});
                                            } else {
                                                $location.path("/attendance_list_by_teacher").search({id: data.result, bizType: bizType});
                                            }
                                        }
                                    } else {
                                        ynuiNotification.error({msg: data.message});
                                    }
                                });
                            }

                        });
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                });
            }
        }

        function prevDay() {
            changeDayPrevAndNext('prev');
        }

        function nextDay() {
            changeDayPrevAndNext();
        }

        function changeDayPrevAndNext(f) {
            var weekCode = getWeekInfoCodeObj();
            var week = parseInt(weekCode.week);
            var day = parseInt(weekCode.day);
            var weekLength = $scope.teacherData.weekInfo.weekDayList.length;
            var totalWeek = $scope.teacherData.weekInfo.totalWeek;
            if (f == "prev") {
                if ((day - 1) == 0 && (week - 1) == 0) {
                    ynuiNotification.error({msg: "已经是第一天了！"});
                    return;
                } else if ((day - 1) == 0) {
                    day = weekLength;
                    week = week - 1;
                } else {
                    day = day - 1;
                }
            } else {
                if ((day + 1) > weekLength && (week + 1) > totalWeek) {
                    ynuiNotification.error({msg: "已经是最后一天了！"});
                    return;
                } else if ((day + 1) > weekLength) {
                    day = 1;
                    week = week + 1;
                } else {
                    day = day + 1;
                }
            }
            changeDay(week + "_" + day);
        }

        function toAddAtendance() {
            if ($state.$current.name === 'attendance_by_more') {
                $state.go('add_attendance_by_more', {'prev': $state.$current.name});
            } else {
                $state.go('add_attendance', {'prev': $state.$current.name});
            }
        }

    }

    addAttendanceController.$inject = ['$scope', '$ionicModal', '$http', '$location', '$filter', 'ynuiNotification', '$ionicPopup', 'kqktMobileService', 'ynNavigator', '$stateParams', '$state', 'storageService'];

    //任课老师添加考勤记录
    function addAttendanceController($scope, $ionicModal, $http, $location, $filter, ynuiNotification, $ionicPopup, kqktMobileService, ynNavigator, $stateParams, $state, storageService) {

        var basePath = originBaseUrl + "/third/kqkt/mobile";

        $scope.showPage = false;

        $scope.changeKnob = changeKnob;
        $scope.findTeacherClassList = findTeacherClassList;
        $scope.selectTeachClass = selectTeachClass;
        $scope.saveRollCallInfo = saveRollCallInfo;
        $scope.cancelSave = cancelSave;
        $scope.judgeDate = judgeDate;
        $scope.saveSelectTime = saveSelectTime;

        if ($stateParams.prev) {
            ynNavigator.registerPrev($stateParams.prev);
        }

        var bizType = "teacher";

        $scope.addAttendanceData = {
            //教学周开始日期
            teachingPeriodBeginDate: "",
            //教学周借宿日期
            teachingPeriodEndDate: "",
            //是否在学期之中
            inTerm: false,
            dateStr: "",
            weekAndDay: {},
            now: {},
            selectDate: "",
            selectDateTemp: "",
            kqDate: "",
            knobArr: [],
            knobTime: "",
            knobTimeIndex: 0,
            termInfo: {},
            teacherClassList: [],
            teachingClassSource: "0",
            allowCheck: false,
            selectedTeaClass: {
                id: "",
                courseId: "",
                courseName: "",
                majorClassName: "",
                teacherName: "",
                classRoomName: "",
                source: "",
                classSourceName: ""
            },
            selectTime: {
                startTime: "",
                endTime: ""
            },
            filterCourseValue: ""
        };

        function initDate() {
            kqktMobileService.findKqktRollCallInitInfo()
                .then(function (data) {
                    if (data.status == 0) {
                        var config = data.result.config;
                        var teachWeekList = data.result.teachWeekList;
                        var weekAndDay = data.result.weekAndDay;
                        //如果不在学期内，不操作
                        if (!config.inTerm) {
                            $scope.addAttendanceData.inTerm = false;
                            return;
                        }
                        //标识在学期内
                        $scope.addAttendanceData.inTerm = true;
                        //选中当前节次
                        if($location.search().nowDate){
                            config.nowDate=$location.search().nowDate;
                        }
                        $scope.addAttendanceData.now.date = config.nowDate;
                        $scope.addAttendanceData.now.time = config.nowTime;
                        $scope.addAttendanceData.selectDate = config.nowDate;
                        $scope.addAttendanceData.selectDateTemp = config.nowDate;

                        $scope.addAttendanceData.allowCheck = config.allowCheck;
                        $scope.addAttendanceData.termInfo.id = config.termId;
                        $scope.addAttendanceData.termInfo.name = config.termName;

                        $scope.addAttendanceData.knobArr = teachWeekList;
                        $scope.addAttendanceData.weekAndDay = weekAndDay;

                        $scope.addAttendanceData.teachingPeriodBeginDate = config.teachingPeriodBeginDate;
                        $scope.addAttendanceData.teachingPeriodEndDate = config.teachingPeriodEndDate;
                        //选中当前节次
                        var knobKey = '';
                        if ($location.search().knob) {
                            knobKey = $location.search().knob.split('').join('_');
                        } else {
                            var knob = storageService.getItem('add_attendance_by_top_knob_str');
                            if (knob) {
                                knobKey = knob.split('').join('_');
                            }
                        }
                        if (knobKey) {
                            var knobTimeIndex=getKqTimeIndex(teachWeekList,knobKey);
                            changeKnob(knobTimeIndex);
                        } else {
                            setTeachWeekTime(teachWeekList, config.nowTime);
                        }
                        //加载周和星期
                        loadWeekAndDay(config.termId, config.nowDate).then(function () {
                            findSelectdClass().then(function () {
                                if ($state.$current.name === 'add_attendance_by_top' && knobKey &&
                                  $scope.addAttendanceData.selectedTeaClass.id) {
                                    // 查询当前节次是否已经点名了
                                    checkKqktRollCall();
                                } else {
                                    $scope.showPage = true;
                                }
                            });
                        });
                    }
                }
              );
        }

        function checkKqktRollCall() {
            var submitKqktData = buildSelectClassParams();
            submitKqktData.source = $scope.addAttendanceData.selectedTeaClass.source;
            submitKqktData.teachClassId = $scope.addAttendanceData.selectedTeaClass.id;
            submitKqktData.kqTime = $scope.addAttendanceData.selectDate;

            submitKqktData.studentSource = $scope.addAttendanceData.studentSource;
            submitKqktData.ktStartTime = $scope.addAttendanceData.ktStartTime + ":00";
            submitKqktData.ktEndTime = $scope.addAttendanceData.ktEndTime + ":00";
            submitKqktData.courseId = $scope.addAttendanceData.selectedTeaClass.courseId;
            submitKqktData.weekStr = $scope.addAttendanceData.weekAndDay.dayStr;
            $http.post(basePath + '/checkKqktRollCall.htm', submitKqktData)
              .success(function (data) {
                  if (data.status === 0 && null != data.result) {
                      // 跳转
                      $state.go('attendance_by_more');
                  } else {
                      $scope.showPage = true;
                  }
              });
        }

        //初始化数据
        initDate();

        function getKqTimeIndex(knobArr, knobKey) {
            for (var i = 0; i < knobArr.length; i++) {
                if (knobArr[i].knobKey == knobKey) {
                    return i;
                }
            }
            return 0;
        }

        //初始化节次
        function setTeachWeekTime(knobArr, time) {
            var obj = kqktMobileService.getCurrentTeachWeekTime(knobArr, time);
            if (obj) {
                $scope.addAttendanceData.knobTime = obj.knobKey;
                $scope.addAttendanceData.ktStartTime = obj.ktStartTime;
                $scope.addAttendanceData.ktEndTime = obj.ktEndTime;
                $scope.addAttendanceData.knobTimeIndex = getKqTimeIndex(knobArr, obj.knobKey);
                $scope.addAttendanceData.selectTime.startTime = obj.ktStartTime;
                $scope.addAttendanceData.selectTime.endTime = obj.ktEndTime;
            } else {
                //如果没有找到当前节次，默认第一节
                changeKnob(0);
            }
        }

        function selectTeachClass(item) {
            $scope.addAttendanceData.selectedTeaClass.id = item.id;
            $scope.addAttendanceData.selectedTeaClass.courseId = item.courseId;
            $scope.addAttendanceData.selectedTeaClass.courseName = item.courseName;
            $scope.addAttendanceData.selectedTeaClass.majorClassName = item.majorClassName;
            $scope.addAttendanceData.selectedTeaClass.source = item.source;
            findTeacherClassInfo();
            $scope.addAttendanceTeachClassListModalHide();
        }

        function changeKnob(index) {
            $scope.addAttendanceData.knobTimeIndex = index;
            var knobArr = $scope.addAttendanceData.knobArr;
            var obj = kqktMobileService.getCurrentTeachWeekTimeIndex(knobArr, index);
            if (obj) {
                $scope.addAttendanceData.knobTime = obj.knobKey;
                $scope.addAttendanceData.ktStartTime = obj.ktStartTime;
                $scope.addAttendanceData.ktEndTime = obj.ktEndTime;

                $scope.addAttendanceData.selectTime.startTime = obj.ktStartTime;
                $scope.addAttendanceData.selectTime.endTime = obj.ktEndTime;
            }
            findSelectdClass();
        }

        //获取目标日期数据
        function judgeDate() {
            var allowCheck = $scope.addAttendanceData.allowCheck;
            var date = $scope.addAttendanceData.selectDateTemp;
            var nowDate = $scope.addAttendanceData.now.date;

            var teachingPeriodBeginDate = $scope.addAttendanceData.teachingPeriodBeginDate;
            var teachingPeriodEndDate = $scope.addAttendanceData.teachingPeriodEndDate;

            if (!moment(date).isSame(teachingPeriodBeginDate) && !moment(date).isSame(teachingPeriodEndDate) && (moment(date).isAfter(teachingPeriodEndDate) || moment(date).isBefore(teachingPeriodBeginDate))) {
                ynuiNotification.error({msg: "只能当前学期教学周起止日期内的考勤日期！"});
                //复原日期
                $scope.addAttendanceData.selectDate = $scope.addAttendanceData.selectDateTemp;
                return;
            }
            //选择日期在当前日期之后
            if (moment(date).isAfter(nowDate)) {
                ynuiNotification.error({msg: "不允许添加今天之后上课节次的课堂考勤数据！"});
                //复原日期
                $scope.addAttendanceData.selectDate = $scope.addAttendanceData.selectDateTemp;
                return;
            }
            //不允许任课老师/班干部补登记、修改今天之前的课堂考勤记录,所选日期是小于当前服务器日期
            if (!allowCheck && moment(date).isBefore(nowDate)) {
                ynuiNotification.error({msg: "不允许添加今天之前上课节次的课堂考勤数据！"});
                //复原日期
                $scope.addAttendanceData.selectDate = $scope.addAttendanceData.selectDateTemp;
                return;
            }
            $scope.addAttendanceData.selectDate = $scope.addAttendanceData.selectDateTemp;

            var termId = $scope.addAttendanceData.termInfo.id;
            var selectDate = $scope.addAttendanceData.selectDate;

            loadWeekTimeList(termId, selectDate);
            loadWeekAndDay(termId, selectDate).then(function () {
                findSelectdClass();
            });
        }

        //获取教学班信息
        function findTeacherClassInfo() {
            var params = buildSelectClassParams();
            params.source = $scope.addAttendanceData.selectedTeaClass.source;
            params.teachClassId = $scope.addAttendanceData.selectedTeaClass.id;
            $http.post(basePath + "/findPlaceAndTeacher.htm", params).success(function (data) {
                if (data.status == 0) {
                    $scope.addAttendanceData.selectedTeaClass.classRoomName = data.result.classRoomName;
                    $scope.addAttendanceData.selectedTeaClass.teacherName = data.result.teacherName;
                    $scope.addAttendanceData.studentSource = '0';
                }
            });
        }

        function loadWeekTimeList(termId, date) {
            kqktMobileService.findPkTeachWeekTimeList(termId, date).then(function (data) {
                if (data.status == 0) {
                    $scope.addAttendanceData.knobArr = data.result;
                    $scope.addAttendanceData.selectDate = date;
                    $scope.addAttendanceData.selectDateTemp = date;
                    setTeachWeekTime(data.result, $scope.addAttendanceData.now.time);
                }
            });
        }

        //构建选择教学班的参数
        function buildSelectClassParams() {
            var termId = $scope.addAttendanceData.termInfo.id;
            var week;
            var day;
            if ($scope.addAttendanceData.weekAndDay) {
                week = $scope.addAttendanceData.weekAndDay.week;
                day = $scope.addAttendanceData.weekAndDay.day;
            }
            if ($scope.addAttendanceData.knobTime) {
                var timeKnob = $scope.addAttendanceData.knobTime.split("_");
                var timeType = timeKnob[0];
                var knob = timeKnob[1];
            }
            return {termId: termId, week: week, day: day, timeType: timeType, knob: knob};
        }

        //获取选中的教学班
        function findSelectdClass() {
            return $http.post(basePath + "/findTeacherClassListByFormlInfo.htm", buildSelectClassParams()).success(function (data) {
                if (data.status == 0) {
                    if (data.result != null) {
                        $scope.addAttendanceData.selectedTeaClass = data.result;
                    } else {
                        $scope.addAttendanceData.selectedTeaClass.id = "";
                    }
                }
                return data;
            });
        }

        function loadWeekAndDay(termId, date) {
            return kqktMobileService.findWeekAndDay(termId, date).then(function (data) {
                if (data.status == 0) {
                    $scope.addAttendanceData.weekAndDay = data.result;
                    $scope.addAttendanceData.dateStr = buildKqTimeStr(data.result);
                }
                return data;
            });
        }

        function buildKqTimeStr(weekAndDay) {
            var str = weekAndDay.dateStr + " " + weekAndDay.weekStr + " " + weekAndDay.dayStr;
            if (weekAndDay.dateStr == $scope.addAttendanceData.now.date) {
                str = "[今天]" + str;
            }
            return str;
        }

        //课程信息
        function findTeacherClassList(teachingClassSource) {
            if (!teachingClassSource) {
                teachingClassSource = '0';
            }
            $scope.addAttendanceData.teachingClassSource = teachingClassSource;
            $http.post(basePath + "/findTeacherClassList.htm", {
                termId: $scope.addAttendanceData.termInfo.id,
                source: teachingClassSource
            }).success(function (data) {
                if (data.status == 0) {
                    $scope.addAttendanceData.teacherClassList = data.result.content;
                }
            });
        }

        //提交考勤信息
        function saveRollCallInfo() {
            var submitKqktData = buildSelectClassParams();
            submitKqktData.source = $scope.addAttendanceData.selectedTeaClass.source;
            submitKqktData.teachClassId = $scope.addAttendanceData.selectedTeaClass.id;
            submitKqktData.kqTime = $scope.addAttendanceData.selectDate;

            submitKqktData.studentSource = $scope.addAttendanceData.studentSource;
            submitKqktData.ktStartTime = $scope.addAttendanceData.ktStartTime + ":00";
            submitKqktData.ktEndTime = $scope.addAttendanceData.ktEndTime + ":00";
            submitKqktData.courseId = $scope.addAttendanceData.selectedTeaClass.courseId;
            submitKqktData.weekStr = $scope.addAttendanceData.weekAndDay.dayStr;

            if (!submitKqktData.kqTime) {
                ynuiNotification.error({msg: "请选择考勤日期！"});
                return;
            }
            if (!submitKqktData.timeType) {
                ynuiNotification.error({msg: "请选择考勤节次！"});
                return;
            }
            if (!submitKqktData.teachClassId) {
                ynuiNotification.error({msg: "请选择考勤的上课课程！"});
                return;
            }
            $http.post(basePath + "/commonSubmitKqktRollCall.htm", submitKqktData).success(function (data) {
                if (data.status == 0) {
                    storageService.setItem('add_attendance_by_top_knob_str', (submitKqktData.timeType + '' + submitKqktData.knob));
                    if ($state.$current.name === 'add_attendance_by_top') {
                        $location.path("/attendance_list_by_top").search({id: data.result, bizType: bizType});
                    } else if ($state.$current.name === 'add_attendance_by_more') {
                        $location.path("/attendance_list_by_more").search({id: data.result, bizType: bizType});
                    } else {
                        $location.path("/attendance_list_by_teacher").search({id: data.result, bizType: bizType});
                    }
                    $scope.$apply();
                } else if (data.status == 10) {
                    var confirmPopup = $ionicPopup.confirm({
                        title: "提示",
                        template: '当前时间正在进行课堂自动考勤，确定要手动点名吗？课堂自动考勤将自动生成学生课堂考勤记录，若您仍坚持手动点名，将导致系统无法生成数据。',
                        cancelText: "取消",
                        okText: "确定"
                    });
                    confirmPopup.then(function (res) {
                        if (res) {
                            submitKqktData.submitFlag = true;
                            $http.post(basePath + "/commonSubmitKqktRollCall.htm", submitKqktData).success(function (data) {
                                if (data.status == 0) {
                                    storageService.setItem('add_attendance_by_top_knob_str', (submitKqktData.timeType + '' + submitKqktData.knob));
                                    if ($state.$current.name === 'add_attendance_by_top') {
                                        $location.path("/attendance_list_by_top").search({id: data.result, bizType: bizType});
                                    } else if ($state.$current.name === 'add_attendance_by_more') {
                                        $location.path("/attendance_list_by_more").search({id: data.result, bizType: bizType});
                                    } else {
                                        $location.path("/attendance_list_by_teacher").search({id: data.result, bizType: bizType});
                                    }
                                    $scope.$apply();
                                } else {
                                    ynuiNotification.error({msg: data.message});
                                }
                            });
                        }
                    });

                } else {
                    ynuiNotification.error({msg: data.message});
                }
            });
        }

        function cancelSave() {
            var confirmPopup = $ionicPopup.confirm({
                title: "提示",
                template: '确定要放弃当前编辑内容吗？',
                cancelText: "继续编辑",
                okText: "放弃"
            });
            confirmPopup.then(function (res) {
                if (res) {
                    ynNavigator.pop(true);
                }
            });
        }

        ynNavigator.registerBackAction(function () {
            cancelSave();
        }, 101);

        ynNavigator.registerBackAction(function () {
            if ($scope.addAttendanceTeachClassListModal.isShown()) {
                $scope.addAttendanceTeachClassListModal.hide();
            }
            // 处理选择时间弹框出现点击右上角返回没有关闭选择器的问题
            else if ($scope.selectTime.isShown()) {
                angular.element('.dwb1.dwb-e.dwb').click();
                $scope.selectTime.remove();
            } else {
                cancelSave();
            }
        }, 201);

        function templateInit() {
            $ionicModal.fromTemplateUrl('templates/classroom_attendance/common/dialog/selectTime.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.selectTime = modal;
            });
        }

        templateInit();

        function saveSelectTime() {
            if ($scope.addAttendanceData.selectTime.startTime == "") {
                ynuiNotification.error({msg: "请输入开始时间"});
                return false;
            }
            if ($scope.addAttendanceData.selectTime.endTime == "") {
                ynuiNotification.error({msg: "请输入结束时间"});
                return false;
            }
            var timeFlag = kqktMobileService.compareTime($scope.addAttendanceData.selectTime.startTime, $scope.addAttendanceData.selectTime.endTime);
            if (!timeFlag) {
                ynuiNotification.error({msg: "课堂开始时间不能大于等于课堂结束时间"});
                return false;
            }
            $scope.addAttendanceData.ktStartTime = $scope.addAttendanceData.selectTime.startTime;
            $scope.addAttendanceData.ktEndTime = $scope.addAttendanceData.selectTime.endTime;
            $scope.selectTime.hide();
            return true;
        }

        $ionicModal.fromTemplateUrl('addAttendanceTeachClassList.html', {
            scope: $scope,
            animation: 'slide-in-left'
        }).then(function (modal) {
            $scope.addAttendanceTeachClassListModal = modal;
        });
        $scope.addAttendanceTeachClassListModalShow = function () {
            findTeacherClassList();
            $scope.addAttendanceTeachClassListModal.show();
        };
        $scope.addAttendanceTeachClassListModalHide = function () {
            $scope.addAttendanceTeachClassListModal.hide();
        };
    }

})();
