/**
 * Created by hejiao on 2020/2/9.
 */
angular.module('starter')
    .config(stateConfig)
    .controller('assignmentListController',assignmentListController)
    .controller("guideController",guideController)
    .controller("doOnlineHomeworkController",doOnlineHomeworkController)
    .controller("lookOnlineHomeworkController",lookOnlineHomeworkController)
    .controller("lookHomeworkDetailController",lookHomeworkDetailController)
    .controller("doAttachmentHomeworkController",doAttachmentHomeworkController)
    .controller("lookAttachmentHomeworkController",lookAttachmentHomeworkController)
    .filter('to_trustedQuestion', ['$sce',
        function ($sce) {
            return function (text) {
                return $sce.trustAsHtml(text);
            }
        }
    ]);
stateConfig.$inject = ['$stateProvider','$urlRouterProvider'];
assignmentListController.$inject = ['$scope','$ionicModal','$http','$location','$ionicPopup'];
guideController.$inject = ['$scope','$ionicModal','$http','$location','$ionicPopup'];
doOnlineHomeworkController.$inject = ['$scope','$ionicModal','$http','$location','$ionicPopup','$ionicLoading','$ionicScrollDelegate','$ionicPlatform','storageService','ynNavigator'];
lookOnlineHomeworkController.$inject = ['$scope','$ionicModal','$http','$location','$ionicPopup','ynNavigator','storageService'];
lookHomeworkDetailController.$inject = ['$scope','$ionicModal','$http','$location','$ionicPopup','$ionicLoading','$ionicScrollDelegate','ynNavigator'];
doAttachmentHomeworkController.$inject = ['$scope','$ionicModal','$http','$location','$ionicPopup','$ionicLoading'];
lookAttachmentHomeworkController.$inject = ['$scope','$ionicModal','$http','$location','$ionicPopup','$ionicLoading'];

function stateConfig($stateProvider,$urlRouterProvider){
    $stateProvider
        //学生课程练习作业列表
        .state('assignment_list', {
            url: '/assignment_list',
            templateUrl: 'templates/course_assignment/assignment_list.html',
            data: {
                micro: true,
                title: '作业练习'
            },
            controller: assignmentListController
        })
        //在线作业练习-试卷
        .state('examination_paper', {
            url: '/examination_paper',
            templateUrl: 'templates/course_assignment/examination_paper.html',
            data: {
                title: '作业练习',
                prev:'assignment_list'
            },
            controller: doOnlineHomeworkController
        })
        //在线作业练习-试卷-查看答案首页
        .state('preview_answer', {
            url: '/preview_answer',
            templateUrl: 'templates/course_assignment/preview_answer.html',
            data: {
                title: '作业练习',
                prev:'assignment_list'
            },
            controller: lookOnlineHomeworkController
        })
        //在线作业练习-试卷-查看答案详情页
        .state('preview_answer_particulars', {
            url: '/preview_answer_particulars',
            templateUrl: 'templates/course_assignment/preview_answer_particulars.html',
            data: {
                title: '作业练习',
                prev:'preview_answer'
            },
            controller: lookHomeworkDetailController
        })
        //在线答题引导页
        .state('page_guide', {
            url: '/page_guide',
            templateUrl: 'templates/course_assignment/page_guide.html',
            data: {
                title: '作业练习',
                prev:'assignment_list'
            },
            controller: guideController
        })
        //在线作业练习-附件/文本-提交作业
        .state('add_accessory', {
            url: '/add_accessory',
            templateUrl: 'templates/course_assignment/add_accessory.html',
            data: {
                title: '作业练习',
                prev:'assignment_list'
            },
            controller: doAttachmentHomeworkController
        })
        //在线作业练习-附件/文本-查看答案
        .state('preview_accessory', {
            url: '/preview_accessory',
            templateUrl: 'templates/course_assignment/preview_accessory.html',
            data: {
                title: '作业练习',
                prev:'assignment_list'
            },
            controller: lookAttachmentHomeworkController
        })
};
function assignmentListController($scope,$ionicModal,$http,$location,$ionicPopup){
    if (window.sessionStorage.getItem("homeworkType")) {
        $("[id^='type']").filter(".active").attr("class","tab-item");
        $("#type_"+window.sessionStorage.getItem("homeworkType")).attr("class","tab-item active");
        $scope.type = window.sessionStorage.getItem("homeworkType");
    } else {
        $scope.type = 0;
    }
    $http.post(originBaseUrl + '/third/mobileStudentExame/getCurrentTerm.htm').success(function (data) {
        if (data.status == 0) {
            $scope.term = data.result;
        }else{
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        }
    }).error(function (data) {
        var alertPopup = $ionicPopup.alert({
            title: '',
            template: data.message,
            okText: '关闭'
        });
        alertPopup.then(function(res) {
        });
    });
    $http.post(originBaseUrl + '/third/mobileStudentExame/findStudyClassCourseByUserId.htm').success(function (data) {
        if (data.status == 1) {
            $scope.courseList = data.result;
        }else{
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        }
    }).error(function (data) {
        var alertPopup = $ionicPopup.alert({
            title: '',
            template: data.message,
            okText: '关闭'
        });
        alertPopup.then(function(res) {
        });
    });
    $scope.courseIdList = ['-1'];
    $scope.selectCourseName = "全部";
    if (window.sessionStorage.getItem("statusName")) {
        $scope.statusName = window.sessionStorage.getItem("statusName");
        $scope.statusList = window.sessionStorage.getItem("statusList").split(",");
        angular.forEach($scope.statusList,function (status) {
            if (status == -1) {
                $scope.statusName = "全部";
                $("#statusAll").attr("class","active");
                $scope.statusList.push(-1);
            } else {
                $("#status_"+status).attr("class","active");
            }
        })
        $scope.isFirst = false;
    } else {
        $scope.statusName = "未提交、返回重做";
        $scope.statusList = [0,1];
        $("#status_0").attr("class","active");
        $("#status_1").attr("class","active");
        $scope.isFirst = true;
    }
    $scope.findHomeWorkByUserIdAndCourseIdAndStatus = function() {
        $http.post(originBaseUrl + '/third/mobileStudentExame/findHomeWorkByUserIdAndCourseIdAndStatus.htm',{
            courseIdList:$scope.courseIdList,
            type:$scope.type,
            statusList:$scope.statusList
        }).success(function (data) {
            if (data.status == 1) {
                $scope.testQuestionList = data.result;
            }else{
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }
    $scope.findHomeWorkByUserIdAndCourseIdAndStatus();
    $scope.changeSelectCourse = function(selectCourse) {
        if (selectCourse) {
            $scope.courseIdList = [];
            $("#courseAll").attr("class","");
            var flag = true;
            angular.forEach($("[id^='course_']").filter(".active"), function(course) {
                if (("course_" + selectCourse) == $(course).attr("id")) {
                    flag = false;
                }
            })
            if (flag) {
                $("#course_"+selectCourse).attr("class","active");
            } else {
                $("#course_"+selectCourse).attr("class","");
            }
            $scope.selectCourseName = "";
            angular.forEach($("[id^='course_']").filter(".active"), function(course) {
                $scope.courseIdList.push($(course).attr("id").split("_")[1]);
                if (!$scope.selectCourseName) {
                    $scope.selectCourseName = $($(course).find("a")[0]).text();
                } else {
                    $scope.selectCourseName = $scope.selectCourseName + "、" +$($(course).find("a")[0]).text();
                }
            })
            if (!$scope.selectCourseName) {
                $scope.selectCourseName = "全部";
                $("[id^='course']").filter(".active").attr("class","");
                $("#courseAll").attr("class","active");
                $scope.courseIdList = ['-1'];
            }
        } else {
            $scope.selectCourseName = "全部";
            $("[id^='course']").filter(".active").attr("class","");
            $("#courseAll").attr("class","active");
            $scope.courseIdList = ['-1'];
        }
        $scope.findHomeWorkByUserIdAndCourseIdAndStatus();
    }
    $scope.changeType = function(type) {
        $("[id^='type']").filter(".active").attr("class","tab-item");
        $("#type_"+type).attr("class","tab-item active");
        $scope.type = type;
        window.sessionStorage.setItem("homeworkType",$scope.type);
        $scope.findHomeWorkByUserIdAndCourseIdAndStatus();
    }
    $scope.changeSelectStatus = function(selectStatus) {
        $scope.statusList = []
        if (selectStatus) {
            $("#statusAll").attr("class","");
            $scope.statusName = "";
            var flag = true;
            angular.forEach($("[id^='status']").filter(".active"), function(status) {
                if (("status_" + selectStatus) == $(status).attr("id")) {
                    flag = false;
                }
            })
            if (flag) {
                $("#status_"+selectStatus).attr("class","active");
            } else {
                $("#status_"+selectStatus).attr("class","");
            }
            angular.forEach($("[id^='status']").filter(".active"), function(status) {
                if ($scope.statusName) {
                    $scope.statusName = $scope.statusName + "、" + $($(status).find("a")[0]).text();
                } else {
                    $scope.statusName = $($(status).find("a")[0]).text();
                }
                $scope.statusList.push(parseInt($(status).attr("id").split("_")[1]));
            })
            if (!$scope.statusName) {
                $scope.statusName = "全部";
                $("#statusAll").attr("class","active");
                $scope.statusList.push(-1);
            }
        } else {
            $("[id^='status']").filter(".active").attr("class","");
            $scope.statusName = "全部";
            $("#statusAll").attr("class","active");
            $scope.statusList.push(-1);
        }
        window.sessionStorage.setItem("statusName",$scope.statusName);
        window.sessionStorage.setItem("statusList",$scope.statusList);
        $scope.findHomeWorkByUserIdAndCourseIdAndStatus();
    }
    $scope.entryHomework = function(testQuestion) {
        if ($scope.popup) {
            return;
        }
        if (testQuestion.way == 0) {
            if (testQuestion.submitType == 1 && testQuestion.reviewState != 0 && testQuestion.reviewState != 4) {
                var msg = "";
                if ($scope.type == 0) {
                    msg = "该练习已批阅了一部分试题，无法再修改！"
                } else {
                    msg = "该作业已批阅了一部分试题，无法再修改！"
                }
                $scope.popup = $ionicPopup.show({
                    title: '提示',
                    template: msg,
                    buttons:[
                        {text:"关闭",onTap:function(){
                                $scope.popup = "";
                            }
                        }
                    ]
                });
                return;
            }
            if (testQuestion.submitEndTime){
                var dateNow = new Date();
                var submitDate = new Date(testQuestion.submitEndTime);
                if(dateNow > submitDate){
                    $scope.popup = $ionicPopup.show({
                        title: '提示',
                        template: '作业提交时间已结束，不能作答！',
                        buttons:[
                            {text:"关闭",onTap:function(){
                                    $scope.popup = "";
                                }
                            }
                        ]
                    });
                    return;
                }
            }

            $http.post(originBaseUrl + '/third/mobileStudentExame/queryIsShowPrompt.htm').success(function (data) {
                if (data.status == 1) {
                    if (data.result) {
                        $location.path("/page_guide").search({
                            "title": testQuestion.title,
                            "testPapaerCopyId": testQuestion.testPapaerCopyId,
                            "studyHomeworkId": testQuestion.studyHomeworkId,
                            "studyStuGroupId": testQuestion.studyStuGroupId,
                            "studyStuGroupMiddleId": testQuestion.studyStuGroupMiddleId,
                            "courseName":testQuestion.courseName,
                            "description":testQuestion.description,
                            "completeType":testQuestion.completeType
                        });
                    } else {
                        $location.path("/examination_paper").search({
                            "title":testQuestion.title,
                            "testPapaerCopyId":testQuestion.testPapaerCopyId,
                            "studyHomeworkId":testQuestion.studyHomeworkId,
                            "studyStuGroupId":testQuestion.studyStuGroupId,
                            "studyStuGroupMiddleId":testQuestion.studyStuGroupMiddleId,
                            "courseName":testQuestion.courseName,
                            "description":testQuestion.description,
                            "completeType":testQuestion.completeType,
                            "homeworkRedoReason":testQuestion.homeworkRedoReason
                        });
                    }
                }else{
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        template: data.message,
                        okText: '关闭'
                    });
                    alertPopup.then(function(res) {
                    });
                }
            }).error(function (data) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            });
        } else {
            $location.path("/add_accessory").search({
                "title":testQuestion.title,
                "studyHomeworkId":testQuestion.studyHomeworkId,
                "studyStuGroupId":testQuestion.studyStuGroupId,
                "courseName":testQuestion.courseName,
                "description":testQuestion.description,
                "completeType":testQuestion.completeType,
                "way":testQuestion.way,
                "submitEndTime":testQuestion.submitEndTime,
                "homeworkRedoReason":testQuestion.homeworkRedoReason
            });
        }
    }
    $scope.lookHomework = function(testQuestion) {
        if ($scope.popup) {
            return;
        }
        if(testQuestion.showConfig == 1 && !testQuestion.isFinished){
            var msg = "";
            if ($scope.type == 0) {
                msg = "该练习需要教师设置为结束，您才能查看批阅结果！"
            } else {
                msg = "该作业需要教师设置为结束，您才能查看批阅结果！"
            }
            $scope.popup = $ionicPopup.show({
                title: '提示',
                template: msg,
                buttons:[
                    {text:"关闭",onTap:function(){
                            $scope.popup = "";
                        }
                    }
                ]
            });
            return;
        }
        if (testQuestion.way == 0) {
            $location.path("/preview_answer").search({
                "title": testQuestion.title,
                "testPapaerCopyId": testQuestion.testPapaerCopyId,
                "studyHomeworkId": testQuestion.studyHomeworkId,
                "studyStuGroupId": testQuestion.studyStuGroupId,
                "completeType": testQuestion.completeType,
                "backData":{state:"assignment_list",info:{}}
            });
        } else {
            $location.path("/preview_accessory").search({
                "title": testQuestion.title,
                "studyHomeworkId": testQuestion.studyHomeworkId,
                "studyStuGroupId": testQuestion.studyStuGroupId,
                "studyStuGroupMiddleId":testQuestion.studyStuGroupMiddleId,
                "courseName":testQuestion.courseName,
                "description":testQuestion.description,
                "completeType": testQuestion.completeType,
                "submitEndTime":testQuestion.submitEndTime
            });
        }
    }
    $scope.goBack = function () {
        yn.plugin.yncordova.close();
    }
}
function guideController($scope,$ionicModal,$http,$location){
    $scope.title = $location.search().title;
    $scope.savePrompt = function() {
        if ($("#promt").hasClass("checkbox-wrap active")) {
            $http.post(originBaseUrl + '/third/mobileStudentExame/savePrompt.htm').success(function (data) {
                if (data.status == 1) {
                    $location.path("/examination_paper").search({
                        "title": $location.search().title,
                        "testPapaerCopyId": $location.search().testPapaerCopyId,
                        "studyHomeworkId": $location.search().studyHomeworkId,
                        "studyStuGroupId": $location.search().studyStuGroupId,
                        "studyStuGroupMiddleId": $location.search().studyStuGroupMiddleId,
                        "courseName":$location.search().courseName,
                        "description":$location.search().description,
                        "completeType":$location.search().completeType,
                        "homeworkRedoReason":$location.search().homeworkRedoReason
                    });
                } else {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        template: data.message,
                        okText: '关闭'
                    });
                    alertPopup.then(function(res) {
                    });
                }
            }).error(function (data) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            });
        } else {
            $location.path("/examination_paper").search({
                "title": $location.search().title,
                "testPapaerCopyId": $location.search().testPapaerCopyId,
                "studyHomeworkId": $location.search().studyHomeworkId,
                "studyStuGroupId": $location.search().studyStuGroupId,
                "studyStuGroupMiddleId": $location.search().studyStuGroupMiddleId,
                "courseName":$location.search().courseName,
                "description":$location.search().description,
                "completeType":$location.search().completeType,
                "homeworkRedoReason":$location.search().homeworkRedoReason
            });
        }
    }
    $scope.changePrompt = function () {
        if ($("#promt").hasClass("checkbox-wrap active")) {
            $("#promt").attr("class","checkbox-wrap")
        } else {
            $("#promt").attr("class","checkbox-wrap active")
        }
    }
}
function doOnlineHomeworkController($scope,$ionicModal,$http,$location,$ionicPopup,$ionicLoading,$ionicScrollDelegate,$ionicPlatform,storageService,ynNavigator){
    $scope.homeworkRedoReason = $location.search().homeworkRedoReason;
    /*弹出提示*/
    $scope.dailogClick = function(completeType,courseName,description){
        if ($scope.popup) {
            return;
        }
        var template = "";
        if (completeType == 0) {
            template = '<div class="text-left"><strong>['+courseName+']</strong><span class="help-inline">个人独立完成</span></div>'
        } else {
            template = '<div class="text-left"><strong>['+courseName+']</strong><span class="help-inline">小组成员协作完成</span></div>'
        }
        if (description) {
            template = template + '<div class="margin-top-10 text-left"><strong>要求：</strong><span class="help-block">'+description+'</span></div>'
        }
        $scope.popup = $ionicPopup.show({
            title: '提示',
            template: template,
            buttons:[
                {text:"关闭",onTap:function(){
                        $scope.popup = "";
                    }
                }
            ]
        });
    }
    $scope.replaceStr = window.location.protocol + "//" + window.location.host;
    if (window.location.port) {
        $scope.replaceStr = $scope.replaceStr + ":" + window.location.port;
    }
    $ionicModal.fromTemplateUrl('examinationModal.html',{
        scope:$scope,
        animation:'slide-in-up'
    }).then(function(modal){
        $scope.modal = modal;
    });
    $scope.examinationModalClick = function() {
        $scope.modal.show();
    };
    $scope.closeExaminationModal = function() {
        $scope.modal.hide();
    }
    $scope.subQuestionCardModal = null;
    $ionicModal.fromTemplateUrl('chooseSubQuestion.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.subQuestionCardModal = modal;
    });
    $scope.slideHasChanged = function(type) {
        if (type == 'right') {
            $scope.getQuestion($scope.currentQuestionId,'prev',$scope.questionType)
        } else {
            $scope.getQuestion($scope.currentQuestionId,'next',$scope.questionType)
        }
    }
    ynNavigator.registerBackAction(function () {
        var noDo = 0;
        angular.forEach($scope.allArray, function (sel, index) {
            noDo += sel.selNum.length - sel.do;
        })
        if (noDo > 0) {
            var confirmPopup = $ionicPopup.confirm({
                title: '',
                template: "还有<span style='color: red'>"+noDo+"题未做</span>，您确定要退出？",
                cancelText: '退出做题',
                okText: '继续做题'
            });
            confirmPopup.then(function(res) {
                if (!res) {
                    ynNavigator.pop(true);//强制返回上一级
                }
            })
        } else {
            ynNavigator.pop(true);//强制返回上一级
        }
    },101);
    $scope.title = $location.search().title;
    $scope.completeType = $location.search().completeType;
    if ($scope.completeType == 1) {
        $http.post(originBaseUrl + '/third/mobileStudentExame/findGroupMemberByStudyGroupIdAndHomeworkId.htm',{
            studyGroupId:$location.search().studyStuGroupId,
            studyHomeworkId: $location.search().studyHomeworkId
        }).success(function (data) {
            if (data.status == 1) {
                $scope.groupMemberList = data.result;
                $scope.groupName = $scope.groupMemberList[0].groupName;
                $scope.groupMemberNumber = $scope.groupMemberList.length;
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }
    // 考试名id
    var examPaperId = $location.testPapaerCopyId;
    // 页面所有试题Id/list
    $scope.listQuestionId = [];
    // 页面每道题附件集合
    $scope.attachListFile = [];
    // 默认不显示播放框
    $scope.showPlay = true;
    // 默认不展示播放框
    $scope.showFlag = false;
    // 每道题选项数组
    $scope.selectArray = [];
    // 显示的选项答案 (最后提交出去的答案)
    $scope.selected = "";
    // 选择题的选项个数
    $scope.selectCount = 5;
    // 题型判断标志位 "1"单选 "2" 多选。。。。
    $scope.questionType = "1";
    // 需要显示是数组
    $scope.showSelect = [];
    // 多选每次答案保存数组
    $scope.selectedAll = [];
    // 默认为单选
    $scope.showCurrentType = "1";
    // 当前页面试题id
    $scope.currentQuestionId = "";
    // 当前页面试题内容
    $scope.currentQuestionMessage = "";
    // 当前页面考试的类型 默认为单选
    $scope.currentType = 1;
    // 当前页面第几题 默认第一题
    $scope.currentIndex = 1;
    // 是否是组合题
    $scope.isCombine = false;
    // 初始化NO.1
    $scope.questionIndex = 0;
    // 默认是第一条
    $scope.firstFlag = true;
    // 默认不是最后一条
    $scope.endFlag = false;
    $scope.file = {
        uploadFiles : []
    }

    $scope.headAndFootHeight = window.innerHeight - 125;
    $scope.initWindowSize = function (questionId) {
        var localData = storageService.getItemNoDel("homework:" + questionId);
        if(!localData){
            $scope.windowStatus = 3;
            $scope.childQuestionIndex = 1;
        }else{
            $scope.windowStatus = localData.windowStatus;
            $scope.childQuestionIndex = localData.childQuestionIndex;
        }
        $scope.setWindowSize();
    }
    $scope.heightInfo = {mainQuestionHeight:'500px',subQuestionHeight:'500px'};
    $scope.setWindowSize = function () {
        if($scope.windowStatus == 1){
            $scope.heightInfo.mainQuestionHeight = $scope.headAndFootHeight * 0.1;
            $scope.heightInfo.subQuestionHeight = $scope.headAndFootHeight * 0.9;
        }else if($scope.windowStatus == 2){
            $scope.heightInfo.mainQuestionHeight = ($scope.headAndFootHeight/2);
            $scope.heightInfo.subQuestionHeight = $scope.heightInfo.mainQuestionHeight;
        }else{
            $scope.heightInfo.mainQuestionHeight = $scope.headAndFootHeight * 0.9;
            $scope.heightInfo.subQuestionHeight = $scope.headAndFootHeight * 0.1;
        }
    }

    $scope.changeWindowSize = function (direction) {
        if(direction == 'up'){
            $scope.windowStatus = $scope.windowStatus -1;
        }else{
            $scope.windowStatus = $scope.windowStatus +1;
        }
        $scope.setWindowSize();
    }
    $scope.upOrDownWindow = function (direction) {
        if(direction == 'top'){
            if($scope.windowStatus !=0){
                $scope.windowStatus = 0;
                $scope.heightInfo.mainQuestionHeight = $scope.headAndFootHeight * 0.1;
                $scope.heightInfo.subQuestionHeight = $scope.headAndFootHeight * 0.9;
            }
        }else{
            if($scope.windowStatus !=2){
                $scope.windowStatus = 2;
                $scope.heightInfo.mainQuestionHeight = $scope.headAndFootHeight * 0.9;
                $scope.heightInfo.subQuestionHeight = $scope.headAndFootHeight * 0.1;
            }
        }
    }
    $scope.getAllQuestype = function(){
        // 获取所有题目信息
        $http.post(originBaseUrl + "/third/mobileStudentExame/findQuestypeByCondtion.htm", {
            examPaperId: $location.search().testPapaerCopyId,
            examStuId: $location.search().studyStuGroupId,
            examInfoId:$location.search().studyHomeworkId
        }).success(function (data) {
            if (data.status == 1) {
                $scope.readySelect(data.result);
                $http.post(originBaseUrl + "/third/mobileStudentExame/findLastQuestion.htm", {
                    examStuId: $location.search().studyStuGroupId,
                    examInfoId:$location.search().studyHomeworkId,
                    type:'do'
                }).success(function (data) {
                    if (data.status == 1) {
                        var param;
                        if (data.result) {
                            $scope.showTips = true;
                            param = {
                                id: data.result,
                                examStuId: $location.search().studyStuGroupId,
                                examInfoId:$location.search().studyHomeworkId,
                                type:1
                            }
                        } else {
                            $scope.showTips = false;
                            $scope.dailogClick($location.search().completeType,$location.search().courseName,$location.search().description);
                            param = {
                                id: $scope.listQuestionId[0],
                                examStuId: $location.search().studyStuGroupId,
                                examInfoId:$location.search().studyHomeworkId,
                                type:1
                            }
                        }

                        // 查询出第一道题
                        // 根据id查询出试卷信息
                        $http.post(originBaseUrl + "/third/mobileStudentExame/findEntityByQuesId.htm", param).success(function (data) {
                            if (data.status == 1) {
                                $scope.loadResult(data.result);
                                $scope.showCurrentType = data.result.testPaperTypeCopyId;
                                angular.forEach($scope.allArray,function (array, index) {
                                    if (array.type == data.result.testPaperTypeCopyId) {
                                        angular.forEach($scope.allArray[index].selNum, function (selsel, indexSel) {
                                            if (selsel.id == data.result.id) {
                                                selsel.type = 1;
                                                $scope.currentIndex = indexSel + 1;
                                                return;
                                            }
                                        })
                                    }
                                });
                                if (data.result && data.result.ansAttList && data.result.ansAttList.length > 0) {
                                    $scope.file.uploadFiles = [];
                                    $scope.uploadFiles = [];
                                    angular.forEach(data.result.ansAttList,function (attachmentVo) {
                                        $scope.file.uploadFiles.push(attachmentVo.fsAttachId);
                                        $scope.uploadFiles.push({fsId:attachmentVo.fsAttachId,name:attachmentVo.name});
                                    })
                                }
                            } else {
                                var alertPopup = $ionicPopup.alert({
                                    title: '',
                                    template: data.message,
                                    okText: '关闭'
                                });
                                alertPopup.then(function(res) {
                                });
                            }
                        }).error(function (data) {
                            var alertPopup = $ionicPopup.alert({
                                title: '',
                                template: data.message,
                                okText: '关闭'
                            });
                            alertPopup.then(function(res) {
                            });
                        });
                    } else {
                        var alertPopup = $ionicPopup.alert({
                            title: '',
                            template: data.message,
                            okText: '关闭'
                        });
                        alertPopup.then(function(res) {
                        });
                    }
                }).error(function (data) {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        template: data.message,
                        okText: '关闭'
                    });
                    alertPopup.then(function(res) {
                    });
                });
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }
    // 当前页面第几题 默认第一题
    $scope.getAllQuestype();
    setTimeout(function(){$("#autoGoBack").hide() }, 2000);
    /**
     * 加载出试题默认选中的
     * @param string 默认的答案
     * @param type   试卷的类型
     */
    $scope.checkSeleted = function (string, type) {
        /**
         * 多选题初始化
         */
        var selectArray = [
            {name: 'A', flag: false}
            , {name: 'B', flag: false}
            , {name: 'C', flag: false}
            , {name: 'D', flag: false}
            , {name: 'E', flag: false}
            , {name: 'F', flag: false}
            , {name: 'G', flag: false}
            , {name: 'H', flag: false}
            , {name: 'I', flag: false}
        ];
        // 答案不能为空
        if (null != string && string.length > 0) {
            if (type == "1") {
                // 对答案进行循环
                angular.forEach($scope.showSelect, function (select, index) {
                    //答案和选项 相匹配
                    if (string == select.name) {
                        $scope.showSelect[index].flag = true;
                    }
                })
            } else {
                var selectedArray = string.split(",");
                // 对答案进行循环
                angular.forEach(selectedArray, function (selectSub, index) {
                    angular.forEach(selectArray, function (select, index) {
                        if (select.name == selectSub) {
                            $scope.showSelect[index].flag = true;
                        }

                    })
                })
            }
        }
    }
    /**
     * 根据题型id 转化为显示的名字
     * @typeId        试题类型id
     * @return string 试卷类型
     */
    $scope.changeIdToName = function (typeId) {
        if (typeId == "1") {
            return "单项选择题";

        } else if (typeId == "2") {
            return "多项选择题";

        } else if (typeId == "3") {
            return "填空题";

        } else if (typeId == "4") {
            return "判断题";

        } else if (typeId == "5") {
            return "简答题";

        } else if (typeId == "6") {
            return "组合题";
        }
    };
    /**
     * 加载试题答案
     * @param question 试题对象
     */
    $scope.loadResult = function (question) {
        // 关闭播放窗口
        $scope.showFlag = false;
        // 附件信息清理
        $scope.attachListFile = [];
        $scope.attachansListFile = [];
        $scope.attachcomAttachFile = [];
        // 将题型到页面 方便识别答案区域用那种
        $scope.questionType = question.testPaperTypeCopyId;
        // 匹配名字
        angular.forEach($scope.allArray, function (data, index) {
            // 根据id匹配
            angular.forEach(data.selNum, function (subdata, subIndex) {
                if (subdata.id == question.id) {
                    // 每到题的类型名字
                    $scope.questionName = data.name;
                    $scope.subName = data.littleName;
                }
            })
        })
        // 每到题的类型名字
        $scope.questionName = $scope.changeIdToName( $scope.questionType);
        // 当前页面试题id
        $scope.currentQuestionId = question.id;
        // 当前页面试题内容
        if (question.title.indexOf($scope.replaceStr) > -1) {
            question.title = question.title.replace(new RegExp($scope.replaceStr, 'g'),"");
        }
        $scope.currentQuestionMessage = question.title.replace(new RegExp('\\/fs\\/preview\\/preview.htm\\?', 'g'),originBaseUrl.replace("/ynedut","") + '/fs/preview/preview.htm?');
        // 将答案绑定到$scope.selected
        $scope.selected = question.reason;
        // 如果为单选题
        if ($scope.questionType == "1") {
            // 需要初始化选项
            $scope.getShowSelect(question.optionNumber);
            // 初始化答案
            $scope.selected = question.reson;
            // 默认选中选项
            $scope.checkSeleted(question.reson, 1);
        }
        // 如果为多选题
        if ($scope.questionType == "2") {
            //  需要初始化选项
            $scope.getShowSelect(question.optionNumber);
            //  选中选项
            $scope.selected = question.reson;
            // 默认选出答案
            $scope.checkSeleted(question.reson, 2);
        }
        // 如果为填空题
        if ($scope.questionType == "3") {
            $scope.sel.selected = question.reson;
            $scope.sel.answerState = question.answerState;
            $scope.selected = question.reson;
            // 填空题输入框的个数
            question.optionNumber;
            $scope.userInput = [];
            // 没有答案的时候
            if (null == question.reson || "" == question.reson) {
                // 用户页面输入答题对象
                for (var i = 0; i < question.optionNumber; i++) {
                    // 每道题答案
                    $scope.answer = {};
                    $scope.answer.name = "";
                    // 答案集合
                    $scope.userInput.push($scope.answer);
                }
            } else {
                // 有答案的时候
                angular.forEach(question.reson.split("◆"), function (data) {
                    $scope.answer = {};
                    if ("" == data || null == data) {
                        data = "";
                    }
                    $scope.answer.name = data;
                    // 答案集合
                    $scope.userInput.push($scope.answer);
                })
            }
        }
        // 如果为判断题
        if ($scope.questionType == "4") {
            // 直接显示出来 checkTrue  checkFalse
            if (question.reson) {
                // 选中选项 绑定ng-model 的值
                if (question.reson == "正确") {
                    $scope.selected = "正确";
                    $scope.checkTrue = "1";
                } else {
                    $scope.selected = "错误";
                    $scope.checkFalse = "1";
                }
            }
        }
        // 如果为简答题
        if ($scope.questionType == "5") {
            $scope.selected = question.reson;
            $scope.sel.selected = question.reson;
            $scope.sel.answerState = question.answerState;

            if (null != question.answerState && question.answerState == "0") {
                // 需要判断是否需要附件
                $scope.showAttach = true;
                // 此时可以上传文件
                // 考生试卷信息
                $scope.attachansListFile = question.ansAttList;
            }
        }
        // 如果为组合题目
        if ($scope.questionType == "6") {
            $scope.isCombine = true;
            $scope.selected = question.reson;
            // 将题型到页面 方便识别答案区域用那种
            $scope.questionType = question.testPaperTypeCopyId;
            // 组装新的遍历对象 并且
            // 题目本身附件
            if (null != question.attachVoList && question.attachVoList.length > 0) {
                // 处理出来每道题的附件
                var attachArray = [];
                angular.forEach(question.attachVoList, function (attach) {
                    // 发送请求获得实际的名字和文件路径
                    $http.get(originBaseUrl + "/third/mobileStudentExame/findFileDataMetaTempVoByFastdfsId.htm", {
                        params: {
                            fastDFSId: attach.fsAttachId
                        }
                    }).success(function (data) {
                        $scope.attchFile = {};
                        // 文件实际url
                        $scope.attchFile.url = originBaseUrl + "/third/mobileStudentExame/download.htm?fastDFSId=" + data.fileURLMappingId;
                        // 文件名字
                        $scope.attchFile.name = data.fileName;
                        $scope.attchFile.fileURLMappingId = data.fileURLMappingId;
                        if (data.basePath.split(".")[1] == "mp3"
                            || data.basePath.split(".")[1] == "mp4"
                            || data.basePath.split(".")[1] == "swf"
                            || data.basePath.split(".")[1] == "flv"
                            || data.basePath.split(".")[1] == "f4v"
                            || data.basePath.split(".")[1] == "rmvb"
                            || data.basePath.split(".")[1] == "mkv"
                            || data.basePath.split(".")[1] == "rm"
                            || data.basePath.split(".")[1] == "xv") {
                            // 音频文件
                            $scope.attchFile.type = "3";
                            $scope.attchFile.url = "/" + data.fileURLMappingId;
                        } else if (data.basePath.split(".")[1] == "jpg"
                            || data.basePath.split(".")[1] == "jpeg"
                            || data.basePath.split(".")[1] == "png"
                            || data.basePath.split(".")[1] == "bmp"
                            || data.basePath.split(".")[1] == "gif"
                            || data.basePath.split(".")[1] == "tif") {
                            // 图片文件
                            $scope.attchFile.type = "2";
                        } else {
                            // 常规文件
                            $scope.attchFile.type = "1";
                        }
                        // 将单个附件信息存入附件集合
                        attachArray.push($scope.attchFile);
                    });
                })
                // 保存每到题目的附件集合
                $scope.attachcomAttachFile = attachArray;
            }
            // 子试题不为空
            if (question.children) {
                $scope.comFiles = [];
                angular.forEach(question.children, function (data) {
                    // 组合题中的每一题对象
                    $scope.combine = {};
                    // 子试题的id
                    $scope.combine.id = data.id;
                    // 子试题的题目
                    if (data.title.indexOf($scope.replaceStr) > -1) {
                        data.title = data.title.replace(new RegExp($scope.replaceStr, 'g'),"");
                    }
                    $scope.combine.currentQuestionMessage = data.title.replace(new RegExp('\\/fs\\/preview\\/preview.htm\\?', 'g'),originBaseUrl.replace("/ynedut","") + '/fs/preview/preview.htm?');
                    // 子试题如果为单选或者多选 需要对选项进行初始化
                    if (data.testPaperTypeCopyId == "1" || data.testPaperTypeCopyId == "2") {
                        $scope.combine.showSelect = $scope.getShowSelectCom(data.optionNumber)
                    }
                    // 如果为填空题
                    if (data.testPaperTypeCopyId == "3") {
                        // 填空题输入框的个数
                        data.optionNumber;
                        $scope.userInputCom = [];
                        // 没有答案的时候
                        if (null == data.reson || "" == data.reson) {
                            // 用户页面输入答题对象
                            for (var i = 0; i < data.optionNumber; i++) {
                                // 每道题答案
                                $scope.answer = {};
                                $scope.answer.name = "";
                                // 答案集合
                                $scope.userInputCom.push($scope.answer);
                            }
                        } else {
                            // 有答案的时候
                            angular.forEach(data.reson.split("◆"), function (data) {
                                $scope.answer = {};
                                if ("" == data || null == data) {
                                    data = "";
                                }
                                $scope.answer.name = data;
                                // 答案集合
                                $scope.userInputCom.push($scope.answer);
                            })
                        }
                    }
                    // 如果为填空题-end
                    // 填空题对象
                    $scope.combine.inputAnswer = $scope.userInputCom;
                    // 该试题的类型
                    $scope.combine.questionType = data.testPaperTypeCopyId;
                    // 默认显示"关闭" 播放器的按钮
                    $scope.combine.showFlag = false;
                    $scope.combine.attachListFile = [];
                    // 多选试题答案
                    $scope.combine.selectedAllCom = [];
                    // 单选试题试题答案
                    $scope.combine.selected = data.reason;
                    //$scope.combine.attachListFile = [{name:1,type:1,url:1},{name:2,type:2,url:2},{name:3,type:3,url:3}];
                    // 附件处理
                    if (null != data.attachListFile) {
                        angular.forEach(data.attachVoList, function (attach) {
                            var data = {};
                            // 获取扩展名
                            data.basepath = attach.name;
                            // 发送请求获得实际的名字和文件路径
                            $http.get(originBaseUrl + "/third/mobileStudentExame/findFileDataMetaTempVoByFastdfsId.htm", {
                                params: {
                                    fastDFSId: attach.fsAttachId
                                }
                            }).success(function (data) {
                                $scope.attchFile = {};
                                $scope.attchFile.url = originBaseUrl + "/third/mobileStudentExame/download.htm?fastDFSId=" + data.fileURLMappingId;
                                if (data.basePath.split(".")[1] == "mp3"
                                    || data.basePath.split(".")[1] == "mp4"
                                    || data.basePath.split(".")[1] == "swf"
                                    || data.basePath.split(".")[1] == "flv"
                                    || data.basePath.split(".")[1] == "f4v"
                                    || data.basePath.split(".")[1] == "rmvb"
                                    || data.basePath.split(".")[1] == "mkv"
                                    || data.basePath.split(".")[1] == "rm"
                                    || data.basePath.split(".")[1] == "xv") {
                                    // 音频文件
                                    $scope.attchFile.type = "3";
                                    $scope.attchFile.url = "/" + data.fileURLMappingId;
                                } else if (data.basePath.split(".")[1] == "jpg"
                                    || data.basePath.split(".")[1] == "jpeg"
                                    || data.basePath.split(".")[1] == "png"
                                    || data.basePath.split(".")[1] == "bmp"
                                    || data.basePath.split(".")[1] == "gif"
                                    || data.basePath.split(".")[1] == "tif") {
                                    // 图片文件
                                    $scope.attchFile.type = "2";
                                } else {
                                    // 常规文件
                                    $scope.attchFile.type = "1";
                                }
                                // 文件实际url
                                // 文件名字
                                $scope.attchFile.name = data.basePath;
                                // 将单个附件信息存入附件集合
                                $scope.combine.attachListFile.push($scope.attchFile);
                            });
                        })
                    }
                    if (null != data.ansAttList) {
                        $scope.combine.ansAttList = [];
                        angular.forEach(data.ansAttList, function (attach) {
                            // 文件名字
                            $scope.attchFile =[];
                            $scope.attchFile.name = attach.name;
                            $scope.attchFile.fsAttachId = attach.fsAttachId;
                            // 将单个附件信息存入附件集合
                            $scope.combine.ansAttList.push($scope.attchFile);
                        })
                        $scope.combine.ansAttIds = data.ansAttIds;
                    }
                    $scope.combine.answerState = data.answerState;
                    // 将对象保存到组合试题集合
                    $scope.comFiles.push($scope.combine);
                    if (null != data.reson && data.reson.length > 0) {
                        $scope.checkSeletedCom(data.id, data.reson, data.testPaperTypeCopyId);
                    }
                });
                $scope.showSubQuestionNum();
                $scope.childQuestionIndex = 1;
                $scope.initWindowSize(question.id);
            }
        }
        // 非组合题目的附件处理
        if ($scope.questionType != "6") {
            $scope.attachListFile = [];
            angular.forEach(question.attachVoList, function (attach) {
                $scope.getAttachFile(attach);
            })
        }
        // 如果为其它
        $scope.getAllDo();
    }
    /**
     * 答题卡-切换子试题
     */
    $scope.switchSubQuestion = function (childQuestionId) {
        // 关闭答题卡模态框
        angular.forEach($scope.comFiles, function (childQuestion, index) {
            if(childQuestion.id === childQuestionId){
                $scope.childQuestionIndex = index+1;
            }
        });
        $scope.subQuestionCardModal.hide();
        $ionicScrollDelegate.scrollTop();
    };
    /**
     * 对左边显示数据进行初始化
     */
    // 左边数字对象
    $scope.reSel = {};
    // 每种题型数组
    $scope.numberArray = [];
    // 左边显示数字全部
    $scope.allArray = [];
    $scope.listname="name"
    // 左边所有试题完成数量 统计
    $scope.doArray = [];
    /**
     * 初始化左边数字区域
     * @param datas 所有题的信息
     */
    $scope.readySelect = function (datas) {
        // 初始化 第一部分的题的类型
        $scope.questionType = datas[0].questionTypeId;
        $scope.allArray = [];
        //首先全部初始化为未做
        //第一层题型遍历
        angular.forEach(datas, function (data, index) {
            $scope.reSel = {};
            // 每层清空
            $scope.numberArray = [];
            // 试题分数
            $scope.reSel.score = data.eachScore;
            // 已做试题个数
            $scope.reSel.selected = 0;
            for (var i = 0; i < data.ids.length; i++) {
                $scope.number = {};
                // type = "2" 未做 "1" 当前正在做 "0" 已做
                $scope.number.num = i;
                $scope.number.id = data.ids[i];
                // 如果属于未提交集合中 类型为
                if (data.notCommitId.indexOf(data.ids[i]) != "-1") {
                    $scope.number.type = "2"
                } else {
                    $scope.number.type = "0"
                }
                $scope.numberArray.push($scope.number);
            }
            // 确保下面有试题
            if (data.ids.length > 0) {
                // 每种题型的个数
                $scope.reSel.selNum = $scope.numberArray;
                // 每种题的遍历顺序
                $scope.reSel.index = index;
                // 每种题的类型
                $scope.reSel.type = data.questionTypeId;
                // 题型名
                $scope.reSel.trueName = data.name;
                $scope.reSel.littleName = data.littleName;
                data.name = data.name.replace(/<\/?[^>]*>/g, ''); //去除HTML tag
                data.name.value = data.name.replace(/[ | ]*\n/g, '\n'); //去除行尾空白
                data.name = data.name.replace(/&nbsp;/ig, '');//去掉&nbsp;
                // 题型名
                //$scope.reSel.name = $scope.changeIdToName(data.questionTypeId);
                $scope.reSel.name = data.name;
                // 每种题型已做的个数
                $scope.reSel.do = 0;
                // 全部放进最大层级vo
                $scope.allArray.push($scope.reSel);
            }
            if ($scope.listQuestionId.length == 0) {
                $scope.listQuestionId = data.ids;
            } else {
                $scope.listQuestionId = $scope.listQuestionId.concat(data.ids);
            }
        });
        // 第一道题默认为 当前正在做
        //$scope.allArray[0].selNum[0].type = "1";
        // 第一道题名字
        //$scope.questionName = $scope.allArray[0].trueName;
        //$scope.subName = $scope.allArray[0].littleName;
        // 获得已做题的题数
        $scope.getAllDo();
    };
    /**
     * 获取全部已做题数目
     */
    $scope.getAllDo = function () {
        // 题型匹配 选中点击后的样式
        angular.forEach($scope.allArray, function (sel, index) {
            // 已做数目
            var num = 0;
            // 试题匹配
            angular.forEach($scope.allArray[index].selNum, function (selsel, indexSel) {
                // 已做的试题
                if (selsel.type == 0) {
                    num++;
                }
            });
            // 已做完题的个数
            sel.do = num;
        })
        $scope.doQuestionNumber = 0;
        angular.forEach($scope.allArray, function (sel, index) {
            $scope.doQuestionNumber = $scope.doQuestionNumber + sel.do;
        })
    };
    $scope.sel = {};
    // 获得富文本内容
    $scope.getSeleted = function () {
        $scope.selected = $scope.sel.selected;
    };
    /**
     * 需要显示是数组
     * @param number 需要显示的个数
     */
    $scope.getShowSelect = function (number) {
        /**
         * 多选题初始化
         */
        var selectArray = [
            {name: 'A', flag: false}
            , {name: 'B', flag: false}
            , {name: 'C', flag: false}
            , {name: 'D', flag: false}
            , {name: 'E', flag: false}
            , {name: 'F', flag: false}
            , {name: 'G', flag: false}
            , {name: 'H', flag: false}
            , {name: 'I', flag: false}

        ];
        // 返回数组
        $scope.showSelect = selectArray.splice(0, number);

    };
    /**
     * 对每个选项进行处理
     * @param selected  选项对象
     * @param flag      "1"  "单选"  flag "2" "多选"
     * @param index     序号 每个选项的下标
     */
    $scope.checkSelect = function (selected, flag, index) {
        if (flag == "1") {
            // 单选进来需要清空
            $scope.selected = "";
            $scope.showSelect[index].flag = !$scope.showSelect[index].flag;
            angular.forEach($scope.showSelect, function (showSel,i) {
                if (i != index && showSel.flag) {
                    $scope.showSelect[i].flag = !$scope.showSelect[i].flag;
                }
            });
            if ($scope.showSelect[index].flag) {
                // 页面显示已选答案
                $scope.selected = selected;
            } else {
                $scope.selected = "";
            }
        }
        else {
            // 改变选中样式
            $scope.showSelect[index].flag = !$scope.showSelect[index].flag;
            // 如果等于0 则说明包含了该答案 要移除
            if ($scope.selectedAll.indexOf(selected) != "-1") {
                $scope.selectedAll.splice($scope.selectedAll.indexOf(selected), 1)
            } else {
                $scope.selectedAll.push(selected)
            }
            // 对数组进行排序
            $scope.selectedAll.sort();
            // 清空上一次选项
            $scope.selected = "";
            angular.forEach($scope.showSelect, function (sel) {
                if (sel.flag == true) {
                    $scope.selected += sel.name + ",";
                }
            });
            // 截取后显示到页面
            $scope.selected = $scope.selected.substring(0, $scope.selected.lastIndexOf(","));
        }
    }
    /**
     * 判断答案是否为空  并给出标记
     */
    $scope.checkAnswer = function(answer){
        if(answer){
            $scope.isFinish = true;
        }
    };
    /**
     * 附件学生附件问题解决
     */
    $scope.targetFile = [];
    $scope.getAttach = function () {
        var used = false;
        if($scope.targetFile && $scope.targetFile.length > 0 && $scope.uploadMessage == null){
            $scope.uploadMessage = [];
            angular.forEach($scope.targetFile, function(t){
                $scope.uploadMessage.push(t);
            });
            $scope.targetFile = [];
            used = true;
        }
        // 附件解决(此时说明用户上传了附件)
        if ($scope.uploadMessage && $scope.uploadMessage.length > 0 || null != $scope.attachansListFile && $scope.attachansListFile.length > 0) {
            $scope.attachId = [];
            $scope.attachName = [];
            // 拿出以前的附件信息id和名字
            if (undefined != $scope.attachansListFile && null != $scope.attachansListFile) {
                angular.forEach($scope.attachansListFile, function (data) {
                    //重新组装fstId
                    $scope.attachId.push(data.fsAttachId);
                    // 重新组装附件名称
                    $scope.attachName.push(data.name);
                });
            }
            //组装本次操作的附件id和名字
            if ($scope.uploadMessage && $scope.uploadMessage.length > 0) {
                angular.forEach($scope.uploadMessage, function (data) {
                    $scope.attachId.push(data.uploadToFDFS);
                    $scope.attachName.push(data.name);
                });
            }
        } else {
            // 清空两个属性
            $scope.attachId = null;
            $scope.attachName = null;
        }
        //缓存本次存的附件
        if(!used && $scope.uploadMessage && $scope.uploadMessage.length > 0){
            $scope.targetFile = [];
            angular.forEach($scope.uploadMessage, function(t){
                $scope.targetFile.push(t);
            });
        }
        // 清空上传信息
        $scope.uploadMessage = null;
    };

    /**
     * 删除学生附件
     * @param item  学生附件对象
     * @param index 遍历号
     */
    $scope.deleteAnsAttach = function (item, index) {
        var confirmPopup = $ionicPopup.confirm({
            title: '确定要删除该附件吗？',
            template: "删除后无法恢复!"
        });
        confirmPopup.then(function(res) {
            if (res) {
                $scope.attachansListFile.splice(index, 1);
                /*var alertPopup = $ionicPopup.alert({
                        title: '',
                        template: "删除成功!"
                    });
                    alertPopup.then(function (res) {
                    });*/
                $scope.$apply();
            }
        })
    };
    /**
     * 试题是否有答案（是否已答题）
     * @param question
     * @returns {boolean}
     */
    function hasAnswer(question) {
        if (question.questionType == 1 || question.questionType == 2 || question.questionType == 4) {
            if (question.selected) {
                return true;
            }
        }
        // 如果是填空题，要所有的填空题都作答了才算作已作答
        if (question.questionType == 3) {
            if (question.selected) {
                var realAnswers = question.selected.split("◆");
                var doneNumber = 0;
                angular.forEach(realAnswers, function (answer) {
                    if (answer) {
                        doneNumber++;
                    }
                });
                return doneNumber == question.inputAnswer.length;
            }
        }
        // 如果是简答题
        if (question.questionType == 5) {
            if (question.selected) {
                var realAnswer = question.selected.replace(/◆/ig, '');
                return realAnswer.length > 0;
            }
            // 如果学生答案要求状态 0 在线作答+附件 1在线作答
            if (question.answerState == 0 && question.ansAttList) {
                return question.ansAttList.length > 0;
            }
        }
        return false;
    }
    $scope.subQuestionDoNum = 0;
    $scope.showSubQuestionNum = function(){
        $scope.subQuestionDoNum = 0;
        angular.forEach($scope.comFiles, function (childQuestion, index) {
            // 试题
            if (hasAnswer(childQuestion)) {
                childQuestion.isUnDone = false;
                $scope.subQuestionDoNum ++;
            }else{
                childQuestion.isUnDone = true;
            }
        });
    }
    $scope.showSubQuestion = function(){
        $scope.showSubQuestionNum();
        $scope.subQuestionCardModal.show();
    }
    /**
     * 点击左侧数字响应
     * @param id        试题 id
     * @param type      试题类型
     * @param oTestQues 试题对象
     */
    $scope.submit_i = 0;
    $scope.toQuestionById = function (id) {
        if($scope.showCurrentType == '6'){
            storageService.setItem("homework:"+$scope.currentQuestionId,{windowStatus:$scope.windowStatus,childQuestionIndex:$scope.childQuestionIndex});
        }
        $scope.closeExaminationModal();
        if ($scope.submit_i == 0) {

            $scope.file.uploadFiles = [];
            $scope.submit_i = 1;
            // 清除radio值
            $scope.checkFalse = false;
            $scope.checkTrue = false;
            // 附件问题解决
            $scope.getAttach();
            // 如果有附件上传 清空附件页面附件
            if ($scope.showAttach) {
                $scope.$broadcast("reset", {});
            }
            // 每次切换后不显示上传按钮
            $scope.showAttach = false;
            // 如果直接点击序号切换到其它题目下 应该先保存下
            var idCurr = $scope.currentQuestionId;
            // flag "2" 是没有答案 "0" 有答案
            var flag = 2;
            // 保存试题 试题答案不能为空
            // 不是组合试题
            if ($scope.showCurrentType != "6") {
                // 如果为填空题-sta
                // 默认为全部做了
                var inputFlag = "0";
                if ($scope.showCurrentType == "3") {
                    var answerStr = "";
                    angular.forEach($scope.userInput, function (data) {
                        if (null == data.name || "" == data.name) {
                            // 说明有题没做完
                            inputFlag = 2;
                            data.name = "";
                        }
                        answerStr = answerStr + data.name + "◆";
                    });
                    //将答案复制到答案
                    $scope.selected = answerStr;
                    $scope.selected = $scope.selected.substring(0, $scope.selected.lastIndexOf("◆"));
                }
                // 如果为填空题-end
                // 样式判定标志位
                $scope.updateQuestion($scope.currentQuestionId);
                if ((null != $scope.selected && $scope.selected.length > 0 )
                    || (null != $scope.attachansListFile && $scope.attachansListFile.length > 0)
                    || (null != $scope.attachId && $scope.attachId.length > 0)) {
                    //$scope.updateQuestion($scope.currentQuestionId);
                    // 标记为已做
                    flag = 0;
                } else {
                    $scope.submit_i = 0;
                }
                if ($scope.showCurrentType == "3") {
                    flag = inputFlag;
                }
                // 组合试题
            } else {
                // 默认有答案
                flag = 0;
                var subQuestionNumber = 0;
                var comFiles = $scope.comFiles;
                // 遍历组合试题
                angular.forEach(comFiles, function (com) {
                    // 隐藏
                    com.showFlag = false;
                    // 如果为填空题-sta
                    // 默认为全部做了
                    var inputFlag = "0";
                    if (com.questionType == "3") {
                        var answerStr = "";
                        angular.forEach($scope.userInputCom, function (data) {
                            if (null == data.name || "" == data.name) {
                                // 说明有题没做完
                                inputFlag = 2;
                                data.name = "";
                            }
                            answerStr = answerStr + data.name + "◆";
                        });
                        //将答案复制到答案
                        com.selected = answerStr;
                        com.selected = com.selected.substring(0, com.selected.lastIndexOf("◆"));
                    }
                    // 如果为填空题-end
                    // 有一个子试题,没做,也是没做完
                    if (null == com.selected || com.selected == undefined || com.selected.length == 0) {
                        flag = 2;
                    }
                    // 如果为填空题再次验证是否做完
                    if (com.questionType == "3") {
                        flag = inputFlag;
                    }

                    var stuName = [];
                    var stuFsAttachIds = [];
                    if (com.ansAttList){
                        angular.forEach(com.ansAttList,function (data) {
                            stuFsAttachIds.push(data.fsAttachId);
                            stuName.push(data.name);
                        })
                    }
                    $.ajaxSettings.async = false;
                    $http.post(originBaseUrl + "/third/mobileStudentExame/saveResonByPaperQuesId.htm", {
                        // 试题id
                        paperQuesId: com.id,
                        // 试题答案
                        reson: com.selected,
                        examStuId:  $location.search().studyStuGroupId,
                        examInfoId:$location.search().studyHomeworkId,
                        fsAttachId:stuFsAttachIds,
                        name:stuName,
                        type:1
                    }).success(function (data) {
                        if (data.status == 1) {
                            subQuestionNumber++;
                            if (subQuestionNumber == comFiles.length) {
                                $scope.submit_i = 0;
                            }
                        } else {
                            $scope.submit_i = 0;
                            var alertPopup = $ionicPopup.alert({
                                title: '',
                                template: data.message,
                                okText: '关闭'
                            });
                            alertPopup.then(function(res) {
                            });
                        }
                    }).error(function (data) {
                        var alertPopup = $ionicPopup.alert({
                            title: '',
                            template: data.message,
                            okText: '关闭'
                        });
                        alertPopup.then(function(res) {
                        });
                    });
                })
            }
            $scope.getAllDo();
            // 清空所有答案
            $scope.selected = "";
            // 判断题目答案选择清空
            $scope.checkTrue = null;
            $scope.checkFalse = null;
            // 组合题默认false
            $scope.isCombine = false;
            // 附件id清空
            $scope.attachId = null;
            // 附件名字清空
            $scope.attachName = null;
            $("#tru").removeAttr("checked");
            $("#fal").removeAttr("checked");

            // 加载最新的试题
            $http.get(originBaseUrl + "/third/mobileStudentExame/findEntityByQuesId.htm?time1=" + new Date().getTime(), {
                    params: {
                        id: id,
                        examStuId: $location.search().studyStuGroupId,
                        examInfoId:$location.search().studyHomeworkId,
                        type: 1
                    }
                }
            ).success(function (data) {
                if (data.status == 1) {
                    // 保存当前题型到页面 展示的大标题 题型 不是每题具体的题型
                    $scope.showCurrentType = data.result.testPaperTypeCopyId;
                    // 各种题型所在位置
                    var questionIndex;
                    // 题型匹配 选中点击后的样式
                    angular.forEach($scope.allArray, function (sel, index) {
                        if (sel.type == data.result.testPaperTypeCopyId) {
                            // 试题匹配
                            angular.forEach($scope.allArray[index].selNum, function (selsel, indexSel) {
                                if (selsel.id == id) {
                                    questionIndex = index;
                                    selsel.type = 1;
                                }
                            })
                        }
                    });
                    // 根据点击的题型 然后匹配出当前大题的题型
                    $scope.questionIndex = questionIndex;
                    // 清除掉其它所有正在考试样式_还原出之前的样式
                    // 题型匹配
                    angular.forEach($scope.allArray, function (sel, index) {
                        // 试题匹配
                        angular.forEach($scope.allArray[index].selNum, function (selsel, indexSel) {
                            if (selsel.type == 1) {
                                selsel.type = flag;
                            }
                        })
                    });
                    // 题型匹配 选中点击后的样式
                    angular.forEach($scope.allArray, function (sel, index) {
                        if (sel.type == data.result.testPaperTypeCopyId) {
                            // 试题匹配
                            angular.forEach($scope.allArray[index].selNum, function (selsel, indexSel) {
                                if (selsel.id == id) {
                                    selsel.type = 1;
                                    // 第几题
                                    $scope.currentIndex = indexSel + 1;
                                }
                            })
                        }
                    });
                    $scope.loadResult(data.result);
                    angular.forEach($scope.allArray,function (array, index) {
                        if (array.type == data.result.testPaperTypeCopyId && data.result.reson && data.result.reson.replace(new RegExp("◆","g"),"").length > 0) {
                            angular.forEach($scope.allArray[index].selNum, function (selsel, indexSel) {
                                if (selsel.id == data.result.id) {
                                    selsel.type = 1
                                    return;
                                }
                            })
                            array.do ++;
                            $scope.doQuestionNumber ++;
                        }
                    })

                    $scope.file.uploadFiles = [];
                    $scope.uploadFiles = [];

                    if (data.result && data.result.ansAttList && data.result.ansAttList.length > 0) {
                        angular.forEach(data.result.ansAttList,function (attachmentVo) {
                            $scope.file.uploadFiles.push(attachmentVo.fsAttachId);
                            $scope.uploadFiles.push({fsId:attachmentVo.fsAttachId,name:attachmentVo.name});
                        })
                    }
                } else {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        template: data.message,
                        okText: '关闭'
                    });
                    alertPopup.then(function(res) {
                    });
                }
            });
        } else {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: "答案保存中，请稍后！",
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        }
        $ionicScrollDelegate.scrollTop();
    };
    /**
     * 上一题 下一题
     * @param type     "prev" 上一题 "next" 下一题
     * @param id       当前试题id
     * @param testType 当前试题的类型
     */
    $scope.getQuestion = function (id, type, testType) {
        // 需要展示的试题id
        var getQuestionId = $scope.getNextOrPrevId(type, id);
        if (getQuestionId == "first") {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: '已经是第一题!',
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
            $scope.firstFlag = true;
            $scope.endFlag = false;
            return;
        }
        if (getQuestionId == "end") {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: '已经是最后一题!',
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
            $scope.firstFlag = false;
            $scope.endFlag = true;
            return;
        }
        $scope.endFlag = false;
        $scope.firstFlag = false;
        $scope.toQuestionById(getQuestionId);
    }

    /**
     * 获得上一题或者下一题id
     * @id     当前试题id
     * @param  type "prev" 获取上一题id "next" 获取下一题id
     * @return string 试题id  string = "first" 说明为第一道题  "end" 说明为最后一道题
     */
    $scope.getNextOrPrevId = function (type, id) {
        var ids = $scope.listQuestionId;
        // 如果获取上一道题
        if (type == "prev") {
            if (ids.indexOf(id) == "0") {
                return "first";
            } else {
                // 返回上一条id
                return ids[ids.indexOf(id) - 1];
            }
        } else {
            // 最后一条
            if (ids.indexOf(id) == ids.length - 1) {
                return "end";
            } else {
                // 返回下一条id
                return ids[ids.indexOf(id) + 1];
            }
        }
    }
    $scope.changeCallback = function (photos){
        $scope.uploadFiles = angular.copy(photos);
    }
    /**
     * 保存试题
     * @param id 试题id
     */
    $scope.updateQuestion = function (id) {

        $scope.attachId = [];
        $scope.attachName = [];

        if ($scope.uploadFiles) {
            if ($scope.uploadFiles.length > 10) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: '最多只能上传10个文件!',
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
                return;
            }
            var attIds = [];
            var attNames = [];
            angular.forEach($scope.uploadFiles,function (file) {
                attIds.push(file.fsId);
                attNames.push(file.name)
            })
        }
        if (((null != $scope.selected && $scope.selected.length > 0) || null!=$scope.attachId)) {
            // && $scope.attachId.length == $scope.attachName.length
            $http.post(originBaseUrl + "/third/mobileStudentExame/saveResonByPaperQuesId.htm", {
                // 试题id
                paperQuesId: id,
                // 试题答案
                reson: $scope.selected,
                examStuId:  $location.search().studyStuGroupId,
                fsAttachId: attIds,
                name: attNames,
                examInfoId:$location.search().studyHomeworkId,
                type:1
            }).success(function (data) {
                attIds = null;
                attNames = null;
                $scope.submit_i = 0;
                if (data.status == 0) {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        template: data.message,
                        okText: '关闭'
                    });
                    alertPopup.then(function(res) {
                    });
                }
            }).error(function (data) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            });
        }else{
            $scope.submit_i = 0;
        }
    };
    /**
     * 提交试卷
     */
    var subPaper_i = 0
    $scope.subPaper = function () {
        $scope.getAllDo();
        if (subPaper_i == 0 && $scope.submit_i == 0) {
            subPaper_i = 1;
            // 当前题目类型
            var type = $scope.showCurrentType;
            // 默认当前题答案为空 "0" 为空 "1" 不为空
            var flag = 0;
            // 判断当前题答案是否为空
            if (type != 6) {
                // 附件问题解决
                $scope.getAttach();
                if (type != 3) {
                    // 保存答案
                    $scope.updateQuestion($scope.currentQuestionId);
                    if (null != $scope.selected && $scope.selected.length > 0 || $scope.attachId.length > 0) {
                        flag = 1;
                    }
                }
                // 如果为填空题-sta
                // 默认为全部做了
                var inputFlag = "1";
                var checkFlag = "0";
                if (type == "3") {
                    checkFlag = "1";
                    var answerStr = "";
                    angular.forEach($scope.userInput, function (data) {
                        if (null == data.name || "" == data.name) {
                            // 说明有题没做完
                            inputFlag = 0;
                            data.name = "";
                        }
                        answerStr = answerStr + data.name + "◆";
                    })
                    //将答案复制到答案
                    $scope.selected = answerStr;
                    $scope.selected = $scope.selected.substring(0, $scope.selected.lastIndexOf("◆"));
                    $scope.updateQuestion($scope.currentQuestionId);
                }
                // 如果为填空题-end
                // 如果为填空题
                if (checkFlag == "1") {
                    flag = inputFlag;
                }
                // 组合题目
            } else {
                flag = 1;
                // 遍历组合试题
                angular.forEach($scope.comFiles, function (com) {
                    if (com.selected == undefined || null == com.selected) {
                        flag = 0;
                    }
                    var inputFlag = 1;
                    var checkFlag = 0;
                    // 组合题的子试题为填空题的时候
                    if (com.questionType == 3) {
                        checkFlag = 1;
                        var answerStr = "";
                        angular.forEach(com.inputAnswer, function (data) {
                            if (null == data.name || "" == data.name) {
                                // 说明有题没做完
                                inputFlag = 0;
                                data.name = "";
                            }
                            answerStr = answerStr + data.name + "◆";
                        })
                        //将答案复制到答案
                        com.selected = answerStr;
                        com.selected = com.selected.substring(0, com.selected.lastIndexOf("◆"));
                    }
                    if (checkFlag == 1) {
                        flag = inputFlag;
                    }
                    var  ansAttIds = [];
                    var  ansAttNames = [];
                    if (com.ansAttList){
                        angular.forEach(com.ansAttList,function (amsItem) {
                            ansAttIds.push(amsItem.ansAttIds);
                            ansAttNames.push(amsItem.name);
                        })
                    }
                    // 保存试题答案
                    $.ajaxSettings.async = false;
                    $http.post(originBaseUrl + "/third/mobileStudentExame/saveResonByPaperQuesId.htm", {
                        // 试题id
                        paperQuesId: com.id,
                        // 试题答案
                        reson: com.selected,
                        examStuId:  $location.search().studyStuGroupId,
                        examInfoId:$location.search().studyHomeworkId,
                        fsAttachId:ansAttIds,
                        name:ansAttNames,
                        type:1
                    }).success(function (data) {
                        if (data.status == 0) {
                            var alertPopup = $ionicPopup.alert({
                                title: '',
                                template: data.message,
                                okText: '关闭'
                            });
                            alertPopup.then(function(res) {
                            });
                        }
                    }).error(function (data) {
                        var alertPopup = $ionicPopup.alert({
                            title: '',
                            template: data.message,
                            okText: '关闭'
                        });
                        alertPopup.then(function(res) {
                        });
                    });
                })
            }
            // 当前题目id
            var id = $scope.currentQuestionId;
            // 找到当前题
            // 题型匹配 选中点击后的样式
            angular.forEach($scope.allArray, function (sel, index) {
                if (sel.type == type) {
                    // 试题id
                    // 匹配
                    angular.forEach($scope.allArray[index].selNum, function (selsel, indexSel) {
                        if (selsel.id == id) {
                            // 没做
                            if (flag == 0) {
                                selsel.type = 2;
                                // 做了
                            } else {
                                selsel.type = 0;
                            }
                        }
                    })
                }
            })
            $scope.getAllDo();
            // 没做的试题
            var noDo = 0;
            // 统计出没做的试题
            angular.forEach($scope.allArray, function (sel, index) {
                noDo += sel.selNum.length - sel.do;
            })
            // 还有没完成的试卷
            var tipsMsg ="";
            var cancelText = "";
            var okText = "";
            if (noDo > 0) {
                tipsMsg = "您还有<span style='color: red'>" + noDo + "题未做</span>，您确定提交吗!";
                cancelText = "继续做题";
                okText = '直接提交';
            } else {
                tipsMsg = "您确定提交吗!";
                cancelText = "取消";
                okText = '提交';
            }
            var confirmPopup = $ionicPopup.confirm({
                title: '',
                template: tipsMsg,
                cancelText: cancelText,
                okText: okText
            });
            confirmPopup.then(function(res) {
                if (res) {
                    // 更新学生进入状态为已交卷
                    $http.post(originBaseUrl + "/third/mobileStudentExame/updateStuExamInfo.htm", {
                            middleEntityId: $location.search().studyStuGroupMiddleId
                        }
                    ).success(function (data) {
                        subPaper_i == 0;
                        if (data.status == 1) {
                            var alertPopup = $ionicPopup.alert({
                                title: '',
                                template: "提交成功!",
                                okText: '关闭'
                            });
                            alertPopup.then(function (res) {
                                $location.path("/assignment_list");
                            });
                        } else {
                            var alertPopup = $ionicPopup.alert({
                                title: '',
                                template: data.message,
                                okText: '关闭'
                            });
                            alertPopup.then(function (res) {
                            });
                            return false;
                        }
                    }).error(function (data) {
                        var alertPopup = $ionicPopup.alert({
                            title: '',
                            template: data.message,
                            okText: '关闭'
                        });
                        alertPopup.then(function(res) {
                        });
                    });
                } else {
                    subPaper_i = 0;
                    //重新选上当前题目
                    angular.forEach($scope.allArray, function (sel, index) {
                        if (sel.type == type) {
                            // 试题id
                            angular.forEach($scope.allArray[index].selNum, function (selsel, indexSel) {
                                if (selsel.id == id) {
                                    selsel.type = 1;
                                    $scope.$apply();
                                }
                            })
                        }
                    })
                }
            })
        } else {
            if ($scope.submit_i == 1) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: "答案保存中，请稍后再次提交任务！",
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
            if (subPaper_i == 1) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: "任务提交中，请稍等！",
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        }
    }
    /**
     * 需要显示是数组
     * @param number 需要显示的个数
     */
    $scope.getShowSelectCom = function (number) {
        /**
         * 多选题初始化
         */
        var selectArray = [
            {name: 'A', flag: false}
            , {name: 'B', flag: false}
            , {name: 'C', flag: false}
            , {name: 'D', flag: false}
            , {name: 'E', flag: false}
            , {name: 'F', flag: false}
            , {name: 'G', flag: false}
            , {name: 'H', flag: false}
            , {name: 'I', flag: false}
        ];
        return selectArray.splice(0, number);
    }
    /**
     * 对附件进行处理
     * 分析文件种类 type: 是哪种 "1" 常规文件 "2" 图片文件需要预览"" "3" 音频文件(需要播放)
     * @param attach 附件对象
     */
    $scope.getAttachFileCom = function (attach) {
        var data = {};
        // 获取扩展名
        data.basepath = attach.name;
        $scope.attchFile = {};
        if (data.basePath.split(".")[1] == "mp3"
            || data.basePath.split(".")[1] == "mp4"
            || data.basePath.split(".")[1] == "swf"
            || data.basePath.split(".")[1] == "flv"
            || data.basePath.split(".")[1] == "f4v"
            || data.basePath.split(".")[1] == "rmvb"
            || data.basePath.split(".")[1] == "mkv"
            || data.basePath.split(".")[1] == "rm"
            || data.basePath.split(".")[1] == "xv") {
            // 音频文件
            $scope.attchFile.type = "3";
        } else if (data.basePath.split(".")[1] == "jpg"
            || data.basePath.split(".")[1] == "jpeg"
            || data.basePath.split(".")[1] == "png"
            || data.basePath.split(".")[1] == "bmp"
            || data.basePath.split(".")[1] == "gif"
            || data.basePath.split(".")[1] == "tif") {
            // 图片文件
            $scope.attchFile.type = "2";
        } else {
            // 常规文件
            $scope.attchFile.type = "1";
        }
        // 发送请求获得实际的名字和文件路径
        $http.get(originBaseUrl + "/third/mobileStudentExame/findFileDataMetaTempVoByFastdfsId.htm", {
            params: {
                fastDFSId: attach.id
            }
        }).success(function (data) {
            // 文件实际url
            if ($scope.attchFile.type == "3") {
                $scope.attchFile.url = "/" + data.fileURLMappingId;
            } else {
                $scope.attchFile.url = originBaseUrl + "/third/mobileStudentExame/download.htm?fastDFSId=" + data.fileURLMappingId;
            }
            // 文件名字
            $scope.attchFile.name = data.basePath;
            // 将单个附件信息存入附件集合--不存在才push进去
            if ($scope.attachListFile.indexOf($scope.attchFile) == -1) {
                $scope.attachListFile.push($scope.attchFile);
            }
        });
    }

    /**
     * 加载出试题默认选中的
     * @param id     当前子试题id
     * @param string 默认的答案
     * @param type   试卷的类型
     */
    $scope.checkSeletedCom = function (id, string, type) {
        var question = $scope.getSubQuestion(id);
        var subSelect = question.showSelect;
        question.selected = string;
        /**
         * 多选题初始化
         */
        var selectArray = [
            {name: 'A', flag: false}
            , {name: 'B', flag: false}
            , {name: 'C', flag: false}
            , {name: 'D', flag: false}
            , {name: 'E', flag: false}
            , {name: 'F', flag: false}
            , {name: 'G', flag: false}
            , {name: 'H', flag: false}
            , {name: 'I', flag: false}
        ];
        // 答案不能为空
        if (null != string && string.length > 0) {
            if (type == "1") {
                // 对答案进行循环
                angular.forEach(subSelect, function (select, index) {
                    //答案和选项 相匹配
                    if (string == select.name) {
                        subSelect[index].flag = true;
                    }
                })
            } else if (type == "2") {
                var selectedArray = string.split(",");
                // 对答案进行循环
                angular.forEach(selectedArray, function (selectSub, index) {
                    angular.forEach(selectArray, function (select, index) {
                        if (select.name == selectSub) {
                            subSelect[index].flag = true;
                        }
                    })
                })
                // 加载出富文本
            } else if (type == "3" || type == "5") {
                question.selectedCom = string;
                // 判断题
            } else if (type == "4") {
                if (string == "正确") {
                    question.selected = "正确";
                    question.checkTrue = true;
                } else {
                    question.selected = "错误";
                    question.checkFalse = true;
                }
            }
        }
    }
    /**
     * 判断题点击后
     */
    $scope.checkQuestionTrue = function () {
        if ($scope.selected == "正确") {
            $scope.selected = "";
        } else {
            $scope.selected = "正确";
        }
    }
    $scope.checkQuestionFalse = function () {
        if ($scope.selected == "错误") {
            $scope.selected = "";
        } else {
            $scope.selected = "错误";
        }
    }

    /**
     * @param id 子试题id
     */
    $scope.checkQuestionTrueCom = function (id) {
        var question = $scope.getSubQuestion(id);
        if (question.selected == "正确") {
            question.selected = "";
            question.checkFalse = "0";
            question.checkTrue = "0";
        } else {
            question.selected = "正确";
            question.checkFalse = "0";
            question.checkTrue = "1";
        }
        /*question.selected = "正确";
            question.checkFalse = "0";
            question.checkTrue = "1";*/
        // 验证是否全部多选题目都做完
        $scope.checkComFilesEnd();
    }

    /**
     * @param id 子试题id
     */
    $scope.checkQuestionFalseCom = function (id) {
        var question = $scope.getSubQuestion(id);
        if (question.selected == "错误") {
            question.selected = "";
            question.checkFalse = "0";
            question.checkTrue = "0";
        } else {
            question.selected = "错误";
            question.checkFalse = "1";
            question.checkTrue = "0";
        }
        /*question.selected = "错误";
            question.checkFalse = "1";
            question.checkTrue = "0";*/
        // 验证是否全部多选题目都做完
        $scope.checkComFilesEnd();
    }


    /**
     * 根据id匹配出子试题对象
     * @param id        子试题
     * @return question 子试题对象
     */
    $scope.getSubQuestion = function (id) {
        // 子试题
        var subQuestion;
        // 遍历组合试题list
        angular.forEach($scope.comFiles, function (question, index) {
            // 根据id匹配出子试题
            if (question.id == id) {
                subQuestion = $scope.comFiles[index];
            }
        })
        return subQuestion;
    }

    /**
     * 对每个选项进行处理
     * @param id        子试题id
     * @param selected  选项对象
     * @param flag      "1"  "单选"  flag "2" "多选"
     * @param index     序号 每个选项的下标
     */
    // 组合题的多选题的选项
    $scope.selectedAllCom = [];
    $scope.checkSelectCom = function (id, selected, flag, index) {
        var questionCom = $scope.getSubQuestion(id);
        var subSelectCom = questionCom.showSelect;
        if (flag == "1") {
            // 单选进来需要清空
            questionCom.selected = "";
            subSelectCom[index].flag = !subSelectCom[index].flag;
            angular.forEach(subSelectCom, function (showSel,i) {
                if (i != index && showSel.flag) {
                    subSelectCom[i].flag = !subSelectCom[i].flag;
                }
            });
            if (subSelectCom[index].flag) {
                // 页面显示已选答案
                questionCom.selected = selected;
            } else {
                questionCom.selected = "";
            }
            /*angular.forEach(subSelectCom, function (showSel) {
                    showSel.flag = false;
                })
                // 单选进来需要清空
                questionCom.selected = "";
                subSelectCom[index].flag = !subSelectCom[index].flag;
                // 页面显示已选答案
                questionCom.selected = selected;*/
        }
        else {
            // 改变选中样式
            subSelectCom[index].flag = !subSelectCom[index].flag;
            questionCom.selected = "";
            angular.forEach(subSelectCom, function (sel) {
                if (sel.flag == true) {
                    questionCom.selected += sel.name + ",";
                }
            });
            // 截取后显示到页面
            questionCom.selected = questionCom.selected.substring(0, questionCom.selected.lastIndexOf(","));
        }
        // 验证是否全部多选题目都做完
        $scope.checkComFilesEnd();
    }

    /**
     * 加载组合试题的输入内容
     * @param id     试题id
     * @param string 输入的富文本内容
     */
    $scope.getSeletedCom = function (id, string) {
        // 将答案进行保存
        var questionComInput = $scope.getSubQuestion(id);
        // 将答案绑定上去
        questionComInput.selected = string;
        // 验证是否全部多选题目都做完
        $scope.checkComFilesEnd();
    }
    $scope.previewPhoto = function (photo) {
        if ($scope.loading) {
            return;
        }
        $scope.loading = $ionicLoading.show({
            template: '正在载入中...'
        });
        var cordovaFileOpen = cordova.plugins.disusered.open;
        $scope.attachmentUrl = cordovaFileOpen(originBaseUrl+"/file/downloadStream.htm?fastDFSId="+photo, cordovaFileOpenSuccess, cordovaFileOpenError);
        function cordovaFileOpenSuccess() {
            // 从已安装程序中打开文件完成
            $ionicLoading.hide();
            $scope.loading = "";
        }
        function cordovaFileOpenError(code) {
            if (code === 1) {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '未能在手机已安装APP中找到可预览此文件的程序'
                });
            } else {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '预览时发生了未知错误 #' + code
                });
            }
            $ionicLoading.hide();
            $scope.loading = "";
        }
    };
    /**
     * 判断组合题目是否完成，并且更新页面的状态
     */
    $scope.checkComFilesEnd = function () {
        // 默认有答案
        var flag = 0;
        // 遍历组合试题
        angular.forEach($scope.comFiles, function (com) {
            // 隐藏
            com.showFlag = false;
            // 如果有题目没有答案
            if (null == com.selected || com.selected.length == 0) {
                flag = 2;
            }
        })
        // 没有答案
        if (flag == 2) {
            $scope.comFlag = false;
        } else {
            // 全部有答案
            $scope.comFlag = true;
        }
    }
    /**************附件sta*****************/

    /**
     * 对附件进行处理
     * 分析文件种类 type: 是哪种 "1" 常规文件 "2" 图片文件需要预览"" "3" 音频文件(需要播放)
     * @param attach 附件对象
     */
    $scope.getAttachFile = function (attach) {
        // 文件的类型
        var type;
        var data = {};
        // 获取扩展名
        $scope.attchFile = {};
        if (attach.name.split(".")[1] == "mp3"
            || attach.name.split(".")[1] == "mp4"
            || attach.name.split(".")[1] == "swf"
            || attach.name.split(".")[1] == "flv"
            || attach.name.split(".")[1] == "f4v"
            || attach.name.split(".")[1] == "rmvb"
            || attach.name.split(".")[1] == "mkv"
            || attach.name.split(".")[1] == "rm"
            || attach.name.split(".")[1] == "xv") {
            // 音频文件
            type = "3";
        } else if (attach.name.split(".")[1] == "jpg"
            || attach.name.split(".")[1] == "jpeg"
            || attach.name.split(".")[1] == "png"
            || attach.name.split(".")[1] == "bmp"
            || attach.name.split(".")[1] == "gif"
            || attach.name.split(".")[1] == "tif") {
            // 图片文件
            type = "2";
        } else {
            // 常规文件
            type = "1";
        }
        // 发送请求获得实际的名字和文件路径
        $http.post(originBaseUrl + "/third/mobileStudentExame/findFileDataMetaTempVoByFastdfsId.htm", {
            fastDFSId: attach.fsAttachId
        }).success(function (data) {
            $scope.attchFile = {};
            // 文件实际url
            if (type == "3") {
                $scope.attchFile.url = "/" + data.fileURLMappingId;
            } else {
                $scope.attchFile.url = originBaseUrl + "/third/mobileStudentExame/download.htm?fastDFSId=" + data.fileURLMappingId;
            }
            // 文件名字
            $scope.attchFile.name = data.fileName;
            // 文件类型
            $scope.attchFile.type = type;
            $scope.attchFile.fileURLMappingId = data.fileURLMappingId;
            // 将单个附件信息存入附件集合
            $scope.attachListFile.push($scope.attchFile);
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }


    $scope.changeGroupCallback = function (photos, com){
        com.ansAttList = [];
        if (photos) {
            angular.forEach(photos, function (photo) {
                com.ansAttList.push({fsAttachId: photo.fsId, name: photo.name});
                com.ansAttIds.push(photo.fsId);
            });
        }
    }
}
function lookOnlineHomeworkController($scope,$ionicModal,$http,$location,$ionicPopup,ynNavigator,storageService){
    //缓存查询条件参数
    var search = $location.search();
    if (search && Object.keys(search).length) {
        storageService.setItem("lookOnlineHomework_searchStorage", search);
    } else {
        search = storageService.getItemNoDel("lookOnlineHomework_searchStorage");
    }

    $scope.title = search.title;
    $scope.completeType = search.completeType;
    var backData = search.backData;

    if(backData.state){
        if(backData.state == 'onLine_examination'){
            ynNavigator.setNavTitle("在线考试");
        }
        //动态注册返回路由
        ynNavigator.registerPrev(backData.state);
    }


    $http.post(originBaseUrl + "/third/mobileStudentExame/queryTotalScore.htm", {
        testPapaerCopyId: search.testPapaerCopyId,
        examType: search.examType,
        studyHomeworkId:search.studyHomeworkId
    }).success(function (data) {
        if (data.status == 1) {
            $scope.homeworkScoreVo = data.result;
            $scope.homeworkScoreVo.getScore = parseFloat($scope.homeworkScoreVo.getScore);
            $scope.homeworkScoreVo.totalScore = parseFloat($scope.homeworkScoreVo.totalScore);
        }
    }).error(function (data) {
        var alertPopup = $ionicPopup.alert({
            title: '',
            template: data.message,
            okText: '关闭'
        });
        alertPopup.then(function(res) {
        });
    });
    $http.post(originBaseUrl + "/third/mobileStudentExame/queryQuestionScoreByCondtion.htm", {
        testPapaerCopyId: search.testPapaerCopyId,
        studyStuGroupId: search.studyStuGroupId,
        studyHomeworkId:search.studyHomeworkId
    }).success(function (data) {
        if (data.status == 1) {
            $scope.homeworkQuestionScoreVoList = data.result;
            $scope.errorNumber = 0;
            $scope.rightNumber = 0;
            $scope.hafRightNumber = 0;
            $scope.totalQuestionNumber = 0;
            angular.forEach($scope.homeworkQuestionScoreVoList,function (homeworkQuestionScoreVo,index) {
                var questiontypeErrorNumber = 0;
                var quetionTypeTotalNumber = 0;
                angular.forEach(homeworkQuestionScoreVo.questionGetScoreVoList,function (questionGetScoreVo,index) {
                    if (questionGetScoreVo.score == 0 || questionGetScoreVo.score == null) {
                        $scope.errorNumber = $scope.errorNumber + 1;
                        questiontypeErrorNumber ++;
                    } else if (questionGetScoreVo.score != null && questionGetScoreVo.score == homeworkQuestionScoreVo.eachScore){
                        $scope.rightNumber = $scope.rightNumber + 1;
                    } else if (questionGetScoreVo.score != null && questionGetScoreVo.score > 0 && questionGetScoreVo.score < homeworkQuestionScoreVo.eachScore) {
                        $scope.hafRightNumber = $scope.hafRightNumber + 1;
                    }
                    $scope.totalQuestionNumber = $scope.totalQuestionNumber + 1;
                    quetionTypeTotalNumber ++;
                })
                homeworkQuestionScoreVo.questiontypeErrorNumber = questiontypeErrorNumber;
                homeworkQuestionScoreVo.quetionTypeTotalNumber = quetionTypeTotalNumber;
            })
        }
    }).error(function (data) {
        var alertPopup = $ionicPopup.alert({
            title: '',
            template: data.message,
            okText: '关闭'
        });
        alertPopup.then(function(res) {
        });
    });
    if ($scope.completeType == 1) {
        $http.post(originBaseUrl + '/third/mobileStudentExame/findGroupMemberByStudyGroupIdAndHomeworkId.htm',{
            studyGroupId:search.studyStuGroupId,
            studyHomeworkId: search.studyHomeworkId
        }).success(function (data) {
            if (data.status == 1) {
                $scope.groupMemberList = data.result;
                $scope.groupName = $scope.groupMemberList[0].groupName;
                $scope.groupMemberNumber = $scope.groupMemberList.length;
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }
    $scope.lookHomework = function () {

        $location.path("/preview_answer_particulars").search({
            "title": search.title,
            "testPapaerCopyId": search.testPapaerCopyId,
            "studyHomeworkId": search.studyHomeworkId,
            "studyStuGroupId": search.studyStuGroupId,
            "testQuestionCopyId": $scope.homeworkQuestionScoreVoList[0].questionGetScoreVoList[0].testQuestionCopyId,
            "completeType" : search.completeType,
            "showTips": $scope.showTips,
            "backData":backData
        });

    };

    $scope.toQuestionById = function (questionScore) {
        $location.path("/preview_answer_particulars").search({
            "title": search.title,
            "testPapaerCopyId": search.testPapaerCopyId,
            "studyHomeworkId": search.studyHomeworkId,
            "studyStuGroupId": search.studyStuGroupId,
            "testQuestionCopyId": questionScore.testQuestionCopyId,
            "completeType" : search.completeType,
            "backData":backData
        });
    };
}
function lookHomeworkDetailController($scope,$ionicModal,$http,$location,$ionicPopup,$ionicLoading,$ionicScrollDelegate,ynNavigator){


    var backData = $location.search().backData;

    if(backData.state){
        if(backData.state == 'onLine_examination'){
            ynNavigator.setNavTitle("在线考试");
        }
    }

    $ionicModal.fromTemplateUrl('examinationModal.html',{
        scope:$scope,
        animation:'slide-in-up'
    }).then(function(modal){
        $scope.modal = modal;
    });
    $scope.examinationModalClick = function() {
        $scope.modal.show();
    };
    $scope.closeExaminationModal = function() {
        $scope.modal.hide();
    }
    $scope.replaceStr = window.location.protocol + "//" + window.location.host;
    if (window.location.port) {
        $scope.replaceStr = $scope.replaceStr + ":" + window.location.port;
    }
    $scope.showTips = $location.search().showTips;
    $scope.completeType = $location.search().completeType;
    if ($scope.completeType == 1) {
        $http.post(originBaseUrl + '/third/mobileStudentExame/findGroupMemberByStudyGroupIdAndHomeworkId.htm',{
            studyGroupId:$location.search().studyStuGroupId,
            studyHomeworkId: $location.search().studyHomeworkId
        }).success(function (data) {
            if (data.status == 1) {
                $scope.groupMemberList = data.result;
                $scope.groupName = $scope.groupMemberList[0].groupName;
                $scope.groupMemberNumber = $scope.groupMemberList.length;
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }
    $scope.title = $location.search().title;
    $scope.allArray = [];
    $scope.completeType = $location.search().completeType;
    $scope.getAllQuestype = function(){
        // 获取所有题目信息
        $http.post(originBaseUrl + "/third/mobileStudentExame/queryQuestionScoreByCondtion.htm", {
            testPapaerCopyId: $location.search().testPapaerCopyId,
            studyStuGroupId: $location.search().studyStuGroupId,
            studyHomeworkId:$location.search().studyHomeworkId
        }).success(function (data) {
            if (data.status == 1) {
                $scope.homeworkQuestionScoreVoList = data.result;
                $scope.questionTypeMap = new Map();
                $scope.questionScoreMap = new Map();
                $scope.errorNumber = 0;
                $scope.rightNumber = 0;
                $scope.hafRightNumber = 0;
                angular.forEach($scope.homeworkQuestionScoreVoList,function (homeworkQuestionScoreVo,index) {

                    homeworkQuestionScoreVo.typeIndex = index + 1;
                    homeworkQuestionScoreVo.chineseNumber = toChineseNumber(index);

                    var questiontypeErrorNumber = 0;
                    var quetionTypeTotalNumber = 0;
                    angular.forEach(homeworkQuestionScoreVo.questionGetScoreVoList,function (questionGetScoreVo,index) {

                        questionGetScoreVo.questionIndex = index + 1;

                        $scope.allArray.push(questionGetScoreVo.testQuestionCopyId);
                        $scope.questionTypeMap.put(questionGetScoreVo.testQuestionCopyId,homeworkQuestionScoreVo);
                        $scope.questionScoreMap.put(questionGetScoreVo.testQuestionCopyId,questionGetScoreVo);
                        if (questionGetScoreVo.score == 0 || questionGetScoreVo.score == null) {
                            questiontypeErrorNumber ++;
                            $scope.errorNumber = $scope.errorNumber + 1;
                        } else if (questionGetScoreVo.score != null && questionGetScoreVo.score == homeworkQuestionScoreVo.eachScore){
                            $scope.rightNumber = $scope.rightNumber + 1;
                        } else if (questionGetScoreVo.score != null && questionGetScoreVo.score > 0 && questionGetScoreVo.score < homeworkQuestionScoreVo.eachScore) {
                            $scope.hafRightNumber = $scope.hafRightNumber + 1;
                        }
                        quetionTypeTotalNumber ++;
                    });
                    homeworkQuestionScoreVo.questiontypeErrorNumber = questiontypeErrorNumber;
                    homeworkQuestionScoreVo.quetionTypeTotalNumber = quetionTypeTotalNumber;
                })
                $scope.totalQuestionNumber = $scope.allArray.length;
                $scope.toQuestionById();
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }
    // 当前页面第几题 默认第一题
    $scope.getAllQuestype();
    setTimeout(function(){$("#autoGoBack").hide() }, 2000);
    $scope.slideHasChanged = function(type) {

        if (type == 'right') {
            $scope.getQuestion($scope.testQuestionCopyVo,'prev')
        } else {
            $scope.getQuestion($scope.testQuestionCopyVo,'next')
        }
    };


    function toChineseNumber(index) {
        var a = ["一", "二", "三", "四", "五", "六", "七", "八", "九"];
        return a[index];
    }


    /**
     * 点击左侧数字响应
     * @param id        试题 id
     * @param type      试题类型
     * @param oTestQues 试题对象
     */
    $scope.toQuestionById = function (id) {
        var data = {};
        if (id) {
            $scope.closeExaminationModal();
            data = {
                id: id,
                examStuId: $location.search().studyStuGroupId,
                examInfoId:$location.search().studyHomeworkId,
                type:1
            }
        } else {
            data = {
                id: $location.search().testQuestionCopyId?$location.search().testQuestionCopyId:$scope.homeworkQuestionScoreVoList[0].questionGetScoreVoList[0],
                examStuId: $location.search().studyStuGroupId,
                examInfoId:$location.search().studyHomeworkId,
                type:1
            }
        }
        $http.post(originBaseUrl + "/third/mobileStudentExame/findByQuesId.htm", data).success(function (data) {
            if (data.status == 1) {
                $scope.isShowAnalysis = false;
                $scope.testQuestionCopyVo = data.result;
                if ($scope.testQuestionCopyVo.title.indexOf($scope.replaceStr) > -1) {
                    $scope.testQuestionCopyVo.title = $scope.testQuestionCopyVo.title.replace(new RegExp($scope.replaceStr, 'g'),"");
                }
                $scope.testQuestionCopyVo.title = $scope.testQuestionCopyVo.title.replace(new RegExp('\\/fs\\/preview\\/preview.htm\\?', 'g'),originBaseUrl.replace("/ynedut","") + '/fs/preview/preview.htm?');
                if(!$scope.testQuestionCopyVo.questionAnalysis){
                    $scope.testQuestionCopyVo.questionAnalysis = "<div style='text-align: center;color: #9a9a9a'>无</div>";
                } else {
                    if ($scope.testQuestionCopyVo.questionAnalysis.indexOf($scope.replaceStr) > -1) {
                        $scope.testQuestionCopyVo.questionAnalysis = $scope.testQuestionCopyVo.questionAnalysis.replace(new RegExp($scope.replaceStr, 'g'),"");
                    }
                    $scope.testQuestionCopyVo.questionAnalysis = $scope.testQuestionCopyVo.questionAnalysis.replace(new RegExp('\\/fs\\/preview\\/preview.htm\\?', 'g'),originBaseUrl.replace("/ynedut","") + '/fs/preview/preview.htm?');
                }
                if($scope.testQuestionCopyVo.rightAnswer){
                    if ($scope.testQuestionCopyVo.rightAnswer.indexOf($scope.replaceStr) > -1) {
                        $scope.testQuestionCopyVo.rightAnswer = $scope.testQuestionCopyVo.rightAnswer.replace(new RegExp($scope.replaceStr, 'g'),"");
                    }
                    $scope.testQuestionCopyVo.rightAnswer = $scope.testQuestionCopyVo.rightAnswer.replace(new RegExp('\\/fs\\/preview\\/preview.htm\\?', 'g'),originBaseUrl.replace("/ynedut","") + '/fs/preview/preview.htm?');
                }
                $scope.attachListFile = [];
                $scope.answerAttachListFile = [];
                $scope.attachcomAttachFile = [];
                $scope.homeworkQuestionScoreVo = $scope.questionTypeMap.get($scope.testQuestionCopyVo.id);
                if ($scope.testQuestionCopyVo.attachVoList && $scope.testQuestionCopyVo.attachVoList.length > 0) {
                    angular.forEach($scope.testQuestionCopyVo.attachVoList,function (attachVo) {
                        $scope.getAttachFile(attachVo,false,$scope.homeworkQuestionScoreVo.type);
                    })
                }
                if ($scope.testQuestionCopyVo.ansAttList && $scope.testQuestionCopyVo.ansAttList.length > 0) {
                    angular.forEach($scope.testQuestionCopyVo.ansAttList,function (attachVo) {
                        $scope.getAttachFile(attachVo, true, $scope.homeworkQuestionScoreVo.type);
                    })
                }
                $scope.questionGetScoreVo = $scope.questionScoreMap.get($scope.testQuestionCopyVo.id);
                if ($scope.homeworkQuestionScoreVo.type == 3) {

                    $scope.rightAnswers = $scope.testQuestionCopyVo.rightAnswer ? $scope.testQuestionCopyVo.rightAnswer.split("◆"):{};

                    $scope.answerList = [{name:''}];
                    $scope.rightAnswerList = [{name:''}];
                    if ($scope.rightAnswers) {
                        $scope.rightAnswerList = [];
                        if ($scope.testQuestionCopyVo.reson) {
                            $scope.answerList = [];
                            $scope.answers = $scope.testQuestionCopyVo.reson.split("◆");
                            angular.forEach($scope.rightAnswers,function (data,index) {
                                var rightAnswer = {};
                                rightAnswer.name = data;
                                $scope.rightAnswerList.push(rightAnswer);
                                var answer = {};
                                answer.name = $scope.answers[index];
                                $scope.answerList.push(answer);
                            })
                        }else{


                            angular.forEach($scope.rightAnswers,function (data,index) {
                                var rightAnswer = {};
                                rightAnswer.name = data;
                                $scope.rightAnswerList.push(rightAnswer);
                            })


                        }
                    }


                }
                if ($scope.homeworkQuestionScoreVo.type == 6 && $scope.testQuestionCopyVo) {
                    angular.forEach($scope.testQuestionCopyVo.children,function (questionScoreVo) {
                        if (questionScoreVo.title.indexOf($scope.replaceStr) > -1) {
                            questionScoreVo.title = questionScoreVo.title.replace(new RegExp($scope.replaceStr, 'g'),"");
                        }
                        questionScoreVo.title = questionScoreVo.title.replace(new RegExp('\\/fs\\/preview\\/preview.htm\\?', 'g'),originBaseUrl.replace("/ynedut","") + '/fs/preview/preview.htm?');
                        if (questionScoreVo.questionAnalysis.indexOf($scope.replaceStr) > -1) {
                            questionScoreVo.questionAnalysis = questionScoreVo.questionAnalysis.replace(new RegExp($scope.replaceStr, 'g'),"");
                        }
                        questionScoreVo.questionAnalysis = questionScoreVo.questionAnalysis.replace(new RegExp('\\/fs\\/preview\\/preview.htm\\?', 'g'),originBaseUrl.replace("/ynedut","") + '/fs/preview/preview.htm?');

                        if(!questionScoreVo.questionAnalysis){
                            questionScoreVo.questionAnalysis = "<div style='text-align: center;color: #9a9a9a'>无</div>";
                        }

                        if (questionScoreVo.rightAnswer.indexOf($scope.replaceStr) > -1) {
                            questionScoreVo.rightAnswer = questionScoreVo.rightAnswer.replace(new RegExp($scope.replaceStr, 'g'),"");
                        }
                        questionScoreVo.rightAnswer = questionScoreVo.rightAnswer.replace(new RegExp('\\/fs\\/preview\\/preview.htm\\?', 'g'),originBaseUrl.replace("/ynedut","") + '/fs/preview/preview.htm?');
                        if (questionScoreVo.testPaperTypeCopyId == 3) {
                            var rightAnswers = questionScoreVo.rightAnswer ? questionScoreVo.rightAnswer.split("◆"):{};
                            var answerList = [{name:''}];
                            var rightAnswerList = [{name:''}];
                            if (rightAnswers) {
                                rightAnswerList = [];

                                if (questionScoreVo.reson) {
                                    answerList = [];
                                    $scope.answers = questionScoreVo.reson.split("◆");
                                    angular.forEach(rightAnswers,function (data,index) {
                                        var rightAnswer = {};
                                        rightAnswer.name = data;
                                        rightAnswerList.push(rightAnswer);
                                        var answer = {};
                                        answer.name = $scope.answers[index];
                                        answerList.push(answer);
                                    })
                                }else{

                                    angular.forEach(rightAnswers,function (data,index) {
                                        var rightAnswer = {};
                                        rightAnswer.name = data;
                                        rightAnswerList.push(rightAnswer);
                                    })

                                }
                            }
                            questionScoreVo.answerList = answerList;
                            questionScoreVo.rightAnswerList = rightAnswerList;
                        }
                        $scope.subAnswerAttachFile = [];
                        if (questionScoreVo.ansAttList && questionScoreVo.ansAttList.length > 0) {


                            var files = [];

                            questionScoreVo.ansAttInfoList = [];

                            angular.forEach(questionScoreVo.ansAttList,function (ansAtt) {
                                $scope.getAttachFile(ansAtt, true, $scope.homeworkQuestionScoreVo.type);
                                getAttachFileAnswerFile(ansAtt,questionScoreVo);
                            });
                            questionScoreVo.answerComAttachListFile = $scope.subAnswerAttachFile;
                        }
                    })
                }
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
        $ionicScrollDelegate.scrollTop();
    };
    /**
     * 上一题 下一题
     * @param type     "prev" 上一题 "next" 下一题
     * @param id       当前试题id
     * @param testType 当前试题的类型
     */
    $scope.getQuestion = function (testQuestionCopyVo, type) {
        // 需要展示的试题id
        var getQuestionId = $scope.getNextOrPrevId(type, testQuestionCopyVo);
        if (getQuestionId == "first") {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: '已经是第一题!',
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
            return;
        }
        if (getQuestionId == "end") {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: '已经是最后一题!',
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
            return;
        }
        $scope.toQuestionById(getQuestionId);
    }

    /**
     * 获得上一题或者下一题id
     * @id     当前试题id
     * @param  type "prev" 获取上一题id "next" 获取下一题id
     * @return string 试题id  string = "first" 说明为第一道题  "end" 说明为最后一道题
     */
    $scope.getNextOrPrevId = function (type, testQuestionCopyVo) {
        // 如果获取上一道题
        if (type == "prev") {
            if ($scope.allArray.indexOf(testQuestionCopyVo.id) == 0) {
                return "first";
            } else {
                // 返回上一条id
                return $scope.allArray[$scope.allArray.indexOf(testQuestionCopyVo.id) - 1];
            }
        } else {
            // 最后一条
            if ($scope.allArray.indexOf(testQuestionCopyVo.id) == $scope.allArray.length - 1) {
                return "end";
            } else {
                // 返回下一条id
                return $scope.allArray[$scope.allArray.indexOf(testQuestionCopyVo.id) + 1];
            }
        }
    };

    //获取组合题的附件
    function getAttachFileAnswerFile(attach,questionScoreVo){

        var type;
        // 获取扩展名
        $scope.attchFile = {};
        if (attach.name.split(".")[1] == "mp3"
            || attach.name.split(".")[1] == "mp4"
            || attach.name.split(".")[1] == "swf"
            || attach.name.split(".")[1] == "flv"
            || attach.name.split(".")[1] == "f4v"
            || attach.name.split(".")[1] == "rmvb"
            || attach.name.split(".")[1] == "mkv"
            || attach.name.split(".")[1] == "rm"
            || attach.name.split(".")[1] == "xv") {
            // 音频文件
            type = "3";
        } else if (attach.name.split(".")[1] == "jpg"
            || attach.name.split(".")[1] == "jpeg"
            || attach.name.split(".")[1] == "png"
            || attach.name.split(".")[1] == "bmp"
            || attach.name.split(".")[1] == "gif"
            || attach.name.split(".")[1] == "tif") {
            // 图片文件
            type = "2";
        } else {
            // 常规文件
            type = "1";
        }

        // 发送请求获得实际的名字和文件路径
        $http.post(originBaseUrl + "/third/mobileStudentExame/findFileDataMetaTempVoByFastdfsId.htm", {
            fastDFSId: attach.fsAttachId
        }).success(function (data) {
            var  attchFile = {};
            // 文件实际url
            if (type == "3") {
                attchFile.url = "/" + data.fileURLMappingId;
            } else {
                attchFile.url = originBaseUrl + "/third/mobileStudentExame/download.htm?fastDFSId=" + data.fileURLMappingId;
            }
            // 文件名字
            attchFile.name = data.fileName;
            // 文件类型
            attchFile.type = type;
            attchFile.fileURLMappingId = data.fileURLMappingId;

            // 将单个附件信息存入附件集合
            questionScoreVo.ansAttInfoList.push(attchFile);
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });

        return null;
    }

    /**
     * 对附件进行处理
     * 分析文件种类 type: 是哪种 "1" 常规文件 "2" 图片文件需要预览"" "3" 音频文件(需要播放)
     * @param attach 附件对象
     */
    $scope.getAttachFile = function (attach,isAnswerFile,testType) {
        // 文件的类型
        var type;
        var data = {};
        // 获取扩展名
        $scope.attchFile = {};
        if (attach.name.split(".")[1] == "mp3"
            || attach.name.split(".")[1] == "mp4"
            || attach.name.split(".")[1] == "swf"
            || attach.name.split(".")[1] == "flv"
            || attach.name.split(".")[1] == "f4v"
            || attach.name.split(".")[1] == "rmvb"
            || attach.name.split(".")[1] == "mkv"
            || attach.name.split(".")[1] == "rm"
            || attach.name.split(".")[1] == "xv") {
            // 音频文件
            type = "3";
        } else if (attach.name.split(".")[1] == "jpg"
            || attach.name.split(".")[1] == "jpeg"
            || attach.name.split(".")[1] == "png"
            || attach.name.split(".")[1] == "bmp"
            || attach.name.split(".")[1] == "gif"
            || attach.name.split(".")[1] == "tif") {
            // 图片文件
            type = "2";
        } else {
            // 常规文件
            type = "1";
        }
        // 发送请求获得实际的名字和文件路径
        $http.post(originBaseUrl + "/third/mobileStudentExame/findFileDataMetaTempVoByFastdfsId.htm", {
            fastDFSId: attach.fsAttachId
        }).success(function (data) {
            $scope.attchFile = {};
            // 文件实际url
            if (type == "3") {
                $scope.attchFile.url = "/" + data.fileURLMappingId;
            } else {
                $scope.attchFile.url = originBaseUrl + "/third/mobileStudentExame/download.htm?fastDFSId=" + data.fileURLMappingId;
            }
            // 文件名字
            $scope.attchFile.name = data.fileName;
            // 文件类型
            $scope.attchFile.type = type;
            $scope.attchFile.fileURLMappingId = data.fileURLMappingId;
            // 将单个附件信息存入附件集合
            if (isAnswerFile) {
                if (testType == 6) {
                    $scope.subAnswerAttachFile.push($scope.attchFile);
                } else {
                    $scope.answerAttachListFile.push($scope.attchFile);
                }
            } else {
                if (testType == 6) {
                    $scope.attachcomAttachFile.push($scope.attchFile);
                } else {
                    $scope.attachListFile.push($scope.attchFile);
                }
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }
    $scope.previewPhoto = function (photo) {
        if ($scope.loading) {
            return;
        }
        $scope.loading = $ionicLoading.show({
            template: '正在载入中...'
        });
        var cordovaFileOpen = cordova.plugins.disusered.open;
        $scope.attachmentUrl = cordovaFileOpen(originBaseUrl+"/file/downloadStream.htm?fastDFSId="+photo, cordovaFileOpenSuccess, cordovaFileOpenError);
        function cordovaFileOpenSuccess() {
            // 从已安装程序中打开文件完成
            $ionicLoading.hide();
            $scope.loading = "";
        }
        function cordovaFileOpenError(code) {
            if (code === 1) {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '未能在手机已安装APP中找到可预览此文件的程序'
                });
            } else {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '预览时发生了未知错误 #' + code
                });
            }
            $ionicLoading.hide();
            $scope.loading = "";
        }
    };
    $scope.isShowAnalysis = false;
    $scope.showAnalysis = function () {
        if ($scope.isShowAnalysis) {
            $scope.isShowAnalysis = false;
        } else {
            $scope.isShowAnalysis = true;
        }
    }
}
function doAttachmentHomeworkController($scope,$ionicModal,$http,$location,$ionicPopup,$ionicLoading){
    $scope.title = $location.search().title;
    $scope.courseName = $location.search().courseName;
    $scope.completeType = $location.search().completeType;
    $scope.description = $location.search().description;
    $scope.way = $location.search().way;
    $scope.submitEndTime = $location.search().submitEndTime;
    $scope.homeworkRedoReason = $location.search().homeworkRedoReason;
    $scope.file = {
        uploadFiles : []
    }
    if ($scope.completeType == 1) {
        $http.post(originBaseUrl + '/third/mobileStudentExame/findGroupMemberByStudyGroupIdAndHomeworkId.htm',{
            studyGroupId:$location.search().studyStuGroupId,
            studyHomeworkId: $location.search().studyHomeworkId
        }).success(function (data) {
            if (data.status == 1) {
                $scope.groupMemberList = data.result;
                $scope.groupName = $scope.groupMemberList[0].groupName;
                $scope.groupMemberNumber = $scope.groupMemberList.length;
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }
    $scope.homeworkAttachmentScoreVo = {
        id:"",
        studyStuGroupId: $location.search().studyStuGroupId,
        studyHomeworkId:$location.search().studyHomeworkId,
        answer:""
    }

    $http.post(originBaseUrl + "/third/mobileStudentExame/findByStudyStuGroupIdAndStudyHomeworkId.htm", {
        studyStuGroupId: $location.search().studyStuGroupId,
        studyHomeworkId:$location.search().studyHomeworkId
    }).success(function (data) {
        if (data.status == 1) {
            if (data.result) {
                $scope.homeworkAttachmentScoreVo = data.result;
                if ($scope.homeworkAttachmentScoreVo && $scope.homeworkAttachmentScoreVo.attachmentVoList && $scope.homeworkAttachmentScoreVo.attachmentVoList.length > 0) {
                    $scope.file.uploadFiles = [];
                    $scope.uploadFiles = [];
                    angular.forEach($scope.homeworkAttachmentScoreVo.attachmentVoList,function (attachmentVo) {
                        $scope.file.uploadFiles.push(attachmentVo.fsAttachId);
                        $scope.uploadFiles.push({fsId:attachmentVo.fsAttachId,name:attachmentVo.name});
                    })
                }
                if ($scope.homeworkAttachmentScoreVo && $scope.homeworkAttachmentScoreVo.attachmentRedoVoList && $scope.homeworkAttachmentScoreVo.attachmentRedoVoList.length > 0) {
                    $scope.redoListFile = [];
                    angular.forEach($scope.homeworkAttachmentScoreVo.attachmentRedoVoList,function (attachmentVo) {
                        $scope.redoListFile.push({fsId:attachmentVo.fsAttachId,name:attachmentVo.name});
                    })
                }
            }
        } else {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function (res) {
            });
            return false;
        }
    }).error(function (data) {
        var alertPopup = $ionicPopup.alert({
            title: '',
            template: data.message,
            okText: '关闭'
        });
        alertPopup.then(function(res) {
        });
    });
    $scope.changeCallback = function (photos){
        $scope.uploadFiles = angular.copy(photos);
    }
    $scope.subPaper = function() {
        $scope.homeworkAttachmentScoreVo.attachmentRedoVoList = null;
        if ($scope.way == 2) {
            if ((!$scope.uploadFiles || $scope.uploadFiles.length == 0) && !$scope.homeworkAttachmentScoreVo.answer) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: '提交失败，需要输入文本或上传附件!',
                    okText: '关闭'
                });
                alertPopup.then(function (res) {
                });
                return;
            }
        } else {
            if (!$scope.uploadFiles || $scope.uploadFiles.length == 0) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: '提交失败，需要上传附件!',
                    okText: '关闭'
                });
                alertPopup.then(function (res) {
                });
                return;
            }
        }
        if ($scope.uploadFiles && $scope.uploadFiles.length > 10) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: '最多只能上传10个文件!',
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
            return;
        }
        $scope.attachId = [];
        $scope.attachName = [];
        if ($scope.uploadFiles) {
            angular.forEach($scope.uploadFiles,function (file) {
                $scope.attachId.push(file.fsId);
                $scope.attachName.push(file.name)
            })
        }
        $scope.homeworkAttachmentScoreVo.attachId = $scope.attachId;
        $scope.homeworkAttachmentScoreVo.attachName = $scope.attachName;
        $scope.homeworkAttachmentScoreVo.attachmentVoList = [];
        $http.post(originBaseUrl + "/third/mobileStudentExame/submitAttachmentHomework.htm", $scope.homeworkAttachmentScoreVo).success(function (data) {
            if (data.status == 1) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: "提交成功!",
                    okText: '关闭'
                });
                alertPopup.then(function (res) {
                    $location.path("/assignment_list");
                });
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function (res) {
                });
                return false;
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }

    $scope.previewPhoto = function (photo) {
        if ($scope.loading) {
            return;
        }
        $scope.loading = $ionicLoading.show({
            template: '正在载入中...'
        });
        var cordovaFileOpen = cordova.plugins.disusered.open;
        $scope.attachmentUrl = cordovaFileOpen(originBaseUrl+"/file/downloadStream.htm?fastDFSId="+photo, cordovaFileOpenSuccess, cordovaFileOpenError);
        function cordovaFileOpenSuccess() {
            // 从已安装程序中打开文件完成
            $ionicLoading.hide();
            $scope.loading = "";
        }
        function cordovaFileOpenError(code) {
            if (code === 1) {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '未能在手机已安装APP中找到可预览此文件的程序'
                });
            } else {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '预览时发生了未知错误 #' + code
                });
            }
            $ionicLoading.hide();
            $scope.loading = "";
        }
    };
}
function lookAttachmentHomeworkController($scope,$ionicModal,$http,$location,$ionicPopup,$ionicLoading){
    $scope.title = $location.search().title;
    $scope.courseName = $location.search().courseName;
    $scope.completeType = $location.search().completeType;
    $scope.description = $location.search().description;
    $scope.submitEndTime = $location.search().submitEndTime;
    if ($scope.completeType == 1) {
        $http.post(originBaseUrl + '/third/mobileStudentExame/findGroupMemberByStudyGroupIdAndHomeworkId.htm',{
            studyGroupId:$location.search().studyStuGroupId,
            studyHomeworkId: $location.search().studyHomeworkId
        }).success(function (data) {
            if (data.status == 1) {
                $scope.groupMemberList = data.result;
                $scope.groupName = $scope.groupMemberList[0].groupName;
                $scope.groupMemberNumber = $scope.groupMemberList.length;
            } else {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: data.message,
                    okText: '关闭'
                });
                alertPopup.then(function(res) {
                });
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }
    $scope.homeworkAttachmentScoreVo = {
        id:"",
        studyStuGroupId: $location.search().studyStuGroupId,
        studyHomeworkId:$location.search().studyHomeworkId,
        answer:""
    }
    $http.post(originBaseUrl + "/third/mobileStudentExame/findByStudyStuGroupIdAndStudyHomeworkId.htm", {
        studyStuGroupId: $location.search().studyStuGroupId,
        studyHomeworkId:$location.search().studyHomeworkId
    }).success(function (data) {
        if (data.status == 1) {
            if (data.result) {
                $scope.homeworkAttachmentScoreVo = data.result;
                $scope.attachListFile = [];
                if ($scope.homeworkAttachmentScoreVo.attachmentVoList && $scope.homeworkAttachmentScoreVo.attachmentVoList.length > 0) {
                    angular.forEach($scope.homeworkAttachmentScoreVo.attachmentVoList,function (attachmentVo) {
                        $scope.getAttachFile(attachmentVo,1);
                    })
                }
            }
        } else {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function (res) {
            });
            return false;
        }
    }).error(function (data) {
        var alertPopup = $ionicPopup.alert({
            title: '',
            template: data.message,
            okText: '关闭'
        });
        alertPopup.then(function(res) {
        });
    });
    $http.post(originBaseUrl + "/third/mobileStudentExame/queryHomeworkAttachReviewByStudyStuGroupMiddleId.htm", {
        studyStuGroupMiddleId: $location.search().studyStuGroupMiddleId
    }).success(function (data) {
        if (data.status == 1) {
            $scope.studyStuGroupMiddleVo = data.result;
            $scope.reviewAttachListFile = [];
            if ($scope.studyStuGroupMiddleVo.attachmentVoList && $scope.studyStuGroupMiddleVo.attachmentVoList.length > 0) {
                angular.forEach($scope.studyStuGroupMiddleVo.attachmentVoList,function (attachmentVo) {
                    $scope.getAttachFile(attachmentVo,2);
                })
            }
        }
    }).error(function (data) {
        var alertPopup = $ionicPopup.alert({
            title: '',
            template: data.message,
            okText: '关闭'
        });
        alertPopup.then(function(res) {
        });
    });
    /**
     * 对附件进行处理
     * 分析文件种类 type: 是哪种 "1" 常规文件 "2" 图片文件需要预览"" "3" 音频文件(需要播放)
     * @param attach 附件对象
     */
    $scope.getAttachFile = function (attach,testType) {
        // 文件的类型
        var type;
        var data = {};
        // 获取扩展名
        $scope.attchFile = {};
        if (attach.name.split(".")[1] == "mp3"
            || attach.name.split(".")[1] == "mp4"
            || attach.name.split(".")[1] == "swf"
            || attach.name.split(".")[1] == "flv"
            || attach.name.split(".")[1] == "f4v"
            || attach.name.split(".")[1] == "rmvb"
            || attach.name.split(".")[1] == "mkv"
            || attach.name.split(".")[1] == "rm"
            || attach.name.split(".")[1] == "xv") {
            // 音频文件
            type = "3";
        } else if (attach.name.split(".")[1] == "jpg"
            || attach.name.split(".")[1] == "jpeg"
            || attach.name.split(".")[1] == "png"
            || attach.name.split(".")[1] == "bmp"
            || attach.name.split(".")[1] == "gif"
            || attach.name.split(".")[1] == "tif") {
            // 图片文件
            type = "2";
        } else {
            // 常规文件
            type = "1";
        }
        // 发送请求获得实际的名字和文件路径
        $http.post(originBaseUrl + "/third/mobileStudentExame/findFileDataMetaTempVoByFastdfsId.htm", {
            fastDFSId: attach.fsAttachId
        }).success(function (data) {
            $scope.attchFile = {};
            // 文件实际url
            if (type == "3") {
                $scope.attchFile.url = "/" + data.fileURLMappingId;
            } else {
                $scope.attchFile.url = originBaseUrl + "/third/mobileStudentExame/download.htm?fastDFSId=" + data.fileURLMappingId;
            }
            // 文件名字
            $scope.attchFile.name = data.fileName;
            // 文件类型
            $scope.attchFile.type = type;
            $scope.attchFile.fileURLMappingId = data.fileURLMappingId;
            // 将单个附件信息存入附件集合
            if (testType == 1) {
                $scope.attachListFile.push($scope.attchFile);
            } else {
                $scope.reviewAttachListFile.push($scope.attchFile);
            }
        }).error(function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: data.message,
                okText: '关闭'
            });
            alertPopup.then(function(res) {
            });
        });
    }
    $scope.previewPhoto = function (photo) {
        if ($scope.loading) {
            return;
        }
        $scope.loading = $ionicLoading.show({
            template: '正在载入中...'
        });
        var cordovaFileOpen = cordova.plugins.disusered.open;
        $scope.attachmentUrl = cordovaFileOpen(originBaseUrl+"/file/downloadStream.htm?fastDFSId="+photo, cordovaFileOpenSuccess, cordovaFileOpenError);
        function cordovaFileOpenSuccess() {
            // 从已安装程序中打开文件完成
            $ionicLoading.hide();
            $scope.loading = "";
        }
        function cordovaFileOpenError(code) {
            if (code === 1) {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '未能在手机已安装APP中找到可预览此文件的程序'
                });
            } else {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '预览时发生了未知错误 #' + code
                });
            }
            $ionicLoading.hide();
            $scope.loading = "";
        }
    };
}
