/**
 * 课程免修
 * @author qiucheng Lu
 * @Date 2021年11月30日16:48:26
 */
(function () {
    'use strict';

    angular.module('starter')
        .config(stateConfig)
        .controller('courseexemptCtrl', courseexemptCtrl)
        .controller('courseselectedCtrl', courseselectedCtrl)
        .controller('applyexemptCtrl', applyexemptCtrl)
        .controller('approvalexemptCtrl', approvalexemptCtrl);

    stateConfig.$inject = ['$stateProvider'];

    function stateConfig($stateProvider) {
        $stateProvider
            //课程免修
            .state('courseexempt', {
                url: '/courseexempt',
                templateUrl: 'templates/courseexempt/courseexempt.html',
                data: {
                    prev: 'achievementworkspace',
                    title: '申请免修'
                }
            })
            // 选课程
            .state('courseselect', {
                url: '/courseselect',
                templateUrl: 'templates/courseexempt/courseselected.html',
                data: {
                    title: '申请免修',
                    prev: 'courseexempt'
                }
            })
            // 课程申请
            .state('applyexempt', {
                url: '/applyexempt',
                templateUrl: 'templates/courseexempt/applyexempt.html',
                data: {
                    title: '申请免修',
                    prev: 'courseselect'
                }
            })
    }

    courseexemptCtrl.$inject = ['$location', '$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', '$ionicPopup', '$ionicModal', '$window', 'ynuiNotification'];
    courseselectedCtrl.$inject = ['$location', '$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification'];
    applyexemptCtrl.$inject = ['$location', '$scope', '$http', '$ionicModal', 'ynNavigator', '$window', 'ynuiNotification', '$ionicPopup'];
    approvalexemptCtrl.$inject = ['$location', '$scope', '$http', '$ionicModal', '$ionicPopup'];

    // 课程免修
    function courseexemptCtrl($location, $scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, $ionicPopup, $ionicModal, $window, ynuiNotification) {
        $scope.dataLoading = true;
        ($scope.getTerm = function () {
            $http.post(originBaseUrl + "/third/appAcvmt/getTerm.htm").success(function (data) {
                $scope.loadError = false;
                var result = data.result;
                if (result && result.termList) {
                    $scope.termList = result.termList;
                    //初始化选中
                    $scope.curTerm = result.curTerm ? result.curTerm : result.termList[0];
                    $scope.clickTerm($scope.curTerm);
                } else {
                    $scope.dataLoading = false;
                    $scope.loadError = true;
                    $scope.loadErrorMsg = '您没有学期信息，无法查看成绩！';
                }
            }).error(function () {
                $scope.dataLoading = false;
                $scope.loadError = true;
                $scope.loadErrorMsg = '加载失败，请重试！';

            });
        })();
        /**
         * @Description 切换学期
         * @param item
         */
        $scope.clickTerm = function (item) {
            angular.forEach($scope.termList, function (term) {
                term.active = false;
                if (item.id == term.id) {
                    term.active = true;
                    $scope.curTerm = term;
                    find();
                }
            })
        };
        //进重新请求
        $scope.reloadData = function () {
            find();
        };

        //修改按钮
        $scope.editClick = function (item) {
            $location.path("/applyexempt").search({id: item.cjExemptionManagerId});
            setTimeout(function () {
                $scope.$apply();
            });
        };
        //删除按钮
        $scope.deleteClick = function (item) {
            // 删除数组中的数据，然后保存，再重新查询
            $ionicPopup.confirm({
                title: '提示',
                template: "确认进行删除？删除后不可撤销，流程需重新发起！",
                buttons: [
                    {text: '取消'},
                    {
                        text: '确定',
                        type: 'button-positive',
                        onTap: function () {
                            $http.get(originBaseUrl + "/third/cjgl/courseexempt/delete.htm?version=V1.0&id=" + item.id).success(function (data) {
                                if (data.status == 0) {
                                    ynuiNotification.success({msg: "删除成功！"});
                                    find();
                                } else {
                                    ynuiNotification.error({msg: data.message});
                                }
                            });
                        }
                    }
                ]
            });
        };
        //查看流程
        $scope.viewVerify = function (item) {
            if(!item.lcBusinessId){
                ynuiNotification.error({msg:  "管理员添加的申请暂无流程处理过程明细！"});
                return;
            }
            $location.path("/askforleave").search({"fromType": 0, "procInstId": item.lcBusinessId, "fromBusiness": 1,state:"courseexempt"});
        }

        //申请按钮
        $scope.applyClick = function () {
            //清理缓存[选中的课程]
            var cacheSelected = window.localStorage.getItem("courseexemptCtrl_selectItems");
            if (cacheSelected) {
                window.localStorage.removeItem("courseexemptCtrl_selectItems");
            }
            $location.path("/courseselect");
        };

        $scope.viewAttachment = function (item) {
            $scope.achievementDom = item;
            $scope.attachmentModel.show();
        };
        $scope.viewAppraisalExplain = function (item) {
            $scope.achievementDom = item;
            $scope.appraisalExplainModel.show();
        };
        $ionicModal.fromTemplateUrl('attachment.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.attachmentModel = modal;
        });

        $ionicModal.fromTemplateUrl('appraisalExplain.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.appraisalExplainModel = modal;
        });
        //下载附件
        $scope.downLoad = function (item) {
            var cordovaFileOpen = cordova.plugins.disusered.open;
            cordovaFileOpen(originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.attachmentId, function () {}, function (code) {
                if (code === 1) {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '未能在手机已安装APP中找到可预览此文件的程序'
                    });
                } else {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '预览时发生了未知错误 #' + code
                    });
                }
            });
        };

        /**
         * 转换文件大小
         * @param size
         * @param num 保留小数点位数
         * @returns {*}
         */
        $scope.formatFileSize = function (size, num) {
            if (Number(size)) {
                return WebUploader.formatSize(size, num, ['B', 'KB', 'MB', 'G']);
            } else {
                return size;
            }
        };

        //查询方法
        function find() {
            $ionicLoading.show({
                template: '正在刷新...'
            });
            $scope.items = [];
            $http.post(originBaseUrl + "/third/cjgl/courseexempt/find.htm", {
                termId: $scope.curTerm.id,
                version: "V1.0"
            }).success(function (data) {
                $scope.loadError = false;
                if (data.status) {
                    $scope.loadError = true;
                    $scope.loadErrorMsg = '加载失败，请重试！';
                    return false;
                }
                if (data.result.length < 1) {
                    $scope.loadError = true;
                    $scope.loadErrorMsg = '无课程免修申请！';
                    return false;
                }
                $scope.items = data.result;
            }).error(function () {
                $scope.loadError = true;
                $scope.loadErrorMsg = '加载失败，请重试！';
            }).then(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        }
    }

    // 选课程
    function courseselectedCtrl($location, $scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification) {
        $scope.dataLoading = true;
        $scope.curTerm = {};
        $scope.curElective = {};
        $scope.conditions = {
            searchType:"1",
            courseValue:""
        };
        $scope.curElectiveTypeDoms = [
            {id: "1", name: "必修课"},
            {id: "2", name: "指定选修课"},
            {id: "3", name: "任意选修课"}
        ];
        //已选信息
        $scope.selectItems = [];
        //缓存
        var cacheSelected = window.localStorage.getItem("courseexemptCtrl_selectItems");
        if (cacheSelected) {
            $scope.selectItems = JSON.parse(cacheSelected);
        }
        ($scope.getTerm = function () {
            $http.post(originBaseUrl + "/third/cjgl/courseexempt/term/find.htm?version=V1.0").success(function (data) {
                $scope.loadError = false;
                var result = data.result;
                if (result) {
                    //赋值初始化
                    $scope.termList = [{id: "", termName: "全部", active: true}];
                    //追加
                    $scope.termList = $scope.termList.concat(result);

                } else {
                    $scope.dataLoading = false;
                    $scope.loadError = true;
                    $scope.loadErrorMsg = '您没有学期信息，无法申请免修！';
                }
            }).error(function () {
                $scope.dataLoading = false;
                $scope.loadError = true;
                $scope.loadErrorMsg = '加载失败，请重试！';

            });
        })();
        /**
         * @Description 切换学期
         * @param item
         */
        $scope.clickTerm = function (item) {
            $scope.curTerm = {};
            angular.forEach($scope.termList, function (term) {
                term.active = false;
                if (item.id == term.id) {
                    term.active = true;
                    $scope.curTerm = term;
                }
            })
            find();
        };
        /**
         * @Description 切换课程性质
         * @param item
         */
        $scope.clickElectiveType = function (item) {
            $scope.curElective = {};
            var ids = [], names = [];
            angular.forEach($scope.curElectiveTypeDoms, function (dom) {
                if (item.id === dom.id) {
                    dom.active = !dom.active;
                }
                if (dom.active) {
                    ids.push(dom.id);
                    names.push(dom.name);
                }
            });
            $scope.curElective = {
                id: ids,
                name: names.length === $scope.curElectiveTypeDoms.length ? "全部" : names.join(",")
            }
            find();
        };
        //点查询
        $scope.search = function () {
            find();
        };
        //进重新请求
        $scope.reloadData = function () {
            find();
        };
        //选中列表
        $scope.clickItem = function () {
            $scope.selectItems = $scope.items.filter(function (value) {
                return value.active;
            });
        };
        //完成选择
        $scope.selectedNext = function () {
            if (!$scope.selectItems.length) {
                ynuiNotification.error({'msg': "请至少选择一项！"});
                return false;
            }
            //缓存信息
            window.localStorage.setItem("courseexemptCtrl_selectItems", JSON.stringify($scope.selectItems));
            //去申请页面
            $location.path("/applyexempt");
        };
        //初始化调用
        find();

        //查询方法
        function find() {
            $ionicLoading.show({
                template: '正在查询...'
            });
            //参数
            var param = {
                termId: $scope.curTerm.id,
                electiveTypes: $scope.curElective.id,
                courseValue:$scope.conditions.courseValue
            };
            $scope.items = [];
            $http.post(originBaseUrl + "/third/cjgl/courseexempt/course/find.htm?version=V1.0", param).success(function (data) {
                $scope.loadError = false;
                if (data.status) {
                    $scope.loadError = true;
                    $scope.loadErrorMsg = '加载失败，请重试！';
                    return false;
                }
                if (data.result.length < 1) {
                    $scope.loadError = true;
                    $scope.loadErrorMsg = '没有相关数据！';
                    return false;
                }
                $scope.items = data.result;
                //初始化回填选中效果
                initActive();
            }).error(function () {
                $scope.loadError = true;
                $scope.loadErrorMsg = '加载失败，请重试！';
            }).then(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        }

        //回填选中效果
        function initActive() {
            var ids = [];
            $scope.selectItems.forEach(function (item) {
                ids.push(item.id);
            });
            $scope.items.forEach(function (item) {
                if (ids.indexOf(item.id) !== -1) {
                    item.active = true;
                }
            });
        }
    }

    // 课程申请
    function applyexemptCtrl($location, $scope, $http, $ionicModal, ynNavigator, $window, ynuiNotification, $ionicPopup) {
        $scope.id = $location.search().id;
        if ($scope.id) {
            //修改获取数据
            $http.post(originBaseUrl + "/third/cjgl/courseexempt/find/id.htm?version=V1.0&id=" + $scope.id).success(function (data) {
                if (!data.status) {
                    $scope.courseItems = data.result.exemptionCourseList;
                    $scope.managerVO = $scope.courseItems[0];
                }
            }).then(function () {
                //免修原因
                findAchievement($scope.changeStuAchievementDom);
            });
        } else {
            //取课程
            $scope.courseItems = JSON.parse(window.localStorage.getItem("courseexemptCtrl_selectItems"));
            //封装数据
            $scope.managerVO = {
                exemptionType: 0,
                exemptionReason: null,
                studentAchievementId: null
            };
            //免修原因
            findAchievement();
        }
        //免修原因
        $scope.exemptionReasonDoms = [
            {id: 0, name: "转学"},
            {id: 1, name: "转专业"},
            {id: 2, name: "休学复学"},
            {id: 3, name: "降级"},
            {id: 4, name: "取得成果"}
        ];
        //取得成果选中
        $scope.changeStuAchievementDom = function () {
            $scope.achievementDom = {};
            $scope.achievementDoms.forEach(function (dom) {
                if (dom.id == $scope.managerVO.studentAchievementId) {
                    $scope.achievementDom = dom;
                }
            });
        };
        //拦截
        ynNavigator.registerBackAction(function () {
            if(!$scope.id){
                //添加->回到上一步
                $scope.lastStep();
                return false;
            }
            //修改->回到主页
            $location.path("/courseexempt");
            setTimeout(function () {
                $scope.$apply();
            })
        },101);
        //上一步
        $scope.lastStep = function () {
            //强制返回上一级
            ynNavigator.pop(true);
        };
        //保存
        $scope.submit = function () {
            if($scope.managerVO.exemptionType===0){
                if (!$scope.managerVO.exemptionReason && $scope.managerVO.exemptionReason !== 0) {
                    ynuiNotification.error({'msg': "免修原因不能为空！"});
                    return false;
                }
                if ($scope.managerVO.exemptionReason === 4 && !$scope.managerVO.studentAchievementId) {
                    ynuiNotification.error({'msg': "取得成果不能为空！"});
                    return false;
                }
            }
            var config = {
                url: originBaseUrl + "/third/cjgl/courseexempt/save.htm?version=V1.0",
                method: "POST",
                headers: {'content-Type': 'application/json'},
                data: JSON.stringify({
                    //CJExemptionManager.id
                    id: $scope.id,
                    exemptionCourseList: getExemptionCourseList(),
                })
            };
            $http(config).then(function (response) {
                if(response.data.status == 0){
                    setTimeout(function () {
                        //回首页
                        $location.path("/courseexempt");
                        $scope.$apply();
                    },500);
                }else {
                    ynuiNotification.error({'msg': response.data.message});
                }
            });
        };

        $scope.viewAttachment = function () {
            $scope.attachmentModel.show();
        };
        $scope.viewAppraisalExplain = function () {
            $scope.appraisalExplainModel.show();
        };
        $ionicModal.fromTemplateUrl('attachment.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.attachmentModel = modal;
        });

        $ionicModal.fromTemplateUrl('appraisalExplain.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.appraisalExplainModel = modal;
        });
        //下载附件
        $scope.downLoad = function (item) {
            var cordovaFileOpen = cordova.plugins.disusered.open;
            cordovaFileOpen(originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.attachmentId, function () {}, function (code) {
                if (code === 1) {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '未能在手机已安装APP中找到可预览此文件的程序'
                    });
                } else {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '预览时发生了未知错误 #' + code
                    });
                }
            });
        };

        /**
         * 转换文件大小
         * @param size
         * @param num 保留小数点位数
         * @returns {*}
         */
        $scope.formatFileSize = function (size, num) {
            if (Number(size)) {
                return WebUploader.formatSize(size, num, ['B', 'KB', 'MB', 'G']);
            } else {
                return size;
            }
        };
        //免修原因
        function findAchievement(fun) {
            $scope.achievementDoms = [];
            $scope.achievementDom = {};
            $http.post(originBaseUrl + "/third/cjgl/courseexempt/achievement/find.htm?version=V1.0").success(function (data) {
                if (!data.status) {
                    $scope.achievementDoms = data.result;
                }
            }).then(function () {
                //回调方法
                if(fun){
                    fun();
                }
            });
        }
        //组装课程信息
        function getExemptionCourseList() {
            var exemptionCourseList = [];
            angular.forEach($scope.courseItems, function (item) {
                exemptionCourseList.push({
                    //修改时赋值【CJDetailFinalExemption.id】
                    id: $scope.id ? item.id : null,
                    exemptionType: $scope.managerVO.exemptionType,
                    exemptionReason: $scope.managerVO.exemptionReason,
                    studentAchievementId: $scope.managerVO.studentAchievementId,
                    studentAchievementName: $scope.managerVO.studentAchievementName,
                    termId: item.termId,
                    courseId: item.courseId,
                    teachType: item.teachType,
                    executeTerm: item.executeTerm,
                    courseCredit: item.courseCredit,
                    electiveType: item.electiveType
                });
            });
            return exemptionCourseList;
        }
    }


    // 免修流程明细
    function approvalexemptCtrl($location, $scope, $http, $ionicModal, $ionicPopup) {
        //查询免修内容
        $http.post(originBaseUrl + "/third/cjgl/courseexempt/find/id.htm?version=V1.0&id=" + $scope.lcFormInfoVO.businessKey).success(function (data) {
            $scope.exemptionManager = data.result;
            $scope.exemptionCourse = $scope.exemptionManager.exemptionCourseList[0];
        });


        $scope.viewAttachment = function () {
            $scope.attachmentModel.show();
        };
        $scope.viewAppraisalExplain = function () {
            $scope.appraisalExplainModel.show();
        };
        $ionicModal.fromTemplateUrl('attachment.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.attachmentModel = modal;
        });

        $ionicModal.fromTemplateUrl('appraisalExplain.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.appraisalExplainModel = modal;
        });
        //下载附件
        $scope.downLoad = function (item) {
            var cordovaFileOpen = cordova.plugins.disusered.open;
            cordovaFileOpen(originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.attachmentId, function () {}, function (code) {
                if (code === 1) {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '未能在手机已安装APP中找到可预览此文件的程序'
                    });
                } else {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '预览时发生了未知错误 #' + code
                    });
                }
            });
        };

        /**
         * 转换文件大小
         * @param size
         * @param num 保留小数点位数
         * @returns {*}
         */
        $scope.formatFileSize = function (size, num) {
            if (Number(size)) {
                return WebUploader.formatSize(size, num, ['B', 'KB', 'MB', 'G']);
            } else {
                return size;
            }
        };
    }
})();
