/**
 * Created by hejiao on 2016/12/9.
 */
angular.module('starter')
    .config(docConfig)
    .controller('docStyleController',docStyleController)
    .controller('miniAppController',miniAppController);

    docConfig.$inject = ["$stateProvider", "$urlRouterProvider"];
    function docConfig($stateProvider, $urlRouterProvider) {
    $stateProvider
        //ynedutApp 公共样式模板
        .state('doc', {
            url: '/doc',
            templateUrl: 'templates/doc/doc.html',
            controller: 'docStyleController'
        })
        /*列表*/
        .state('list', {
            url: '/list',
            templateUrl: 'templates/doc/template/list.html',
            controller: 'docStyleController'
        })
        /*下拉选择*/
        .state('select', {
            url: '/select',
            templateUrl: 'templates/doc/template/select.html',
            controller: 'docStyleController'
        })
        /*表单内容*/
        .state('form', {
            url: '/form',
            templateUrl: 'templates/doc/template/form.html',
            controller: 'docStyleController'
        })
        /*模态*/
        .state('modal', {
            url: '/modal',
            templateUrl: 'templates/doc/template/modal.html',
            controller: 'docStyleController'
        })
        /*其它*/
        .state('header-sty', {
            url: '/header-sty',
            templateUrl: 'templates/doc/template/header-sty.html',
            controller: 'docStyleController'
        })
        /*没有数据*/
        .state('noData', {
            url: '/noData',
            templateUrl: 'templates/doc/template/noData.html',
            controller: 'docStyleController'
        })
        /*试题*/
        .state('examination', {
            url: '/examination',
            templateUrl: 'templates/doc/template/examination.html',
            controller: 'docStyleController'
        })
        /*按钮*/
        .state('button', {
            url: '/button',
            templateUrl: 'templates/doc/template/button.html'
        })
        /*滑动标签*/
        .state('page-tabs', {
            url: '/page-tabs',
            templateUrl: 'templates/doc/template/page-tabs.html'
        })
        /*微应用相关*/
        .state('miniApp', {
            url: '/miniApp',
            templateUrl: 'templates/doc/template/miniApp.html',
            controller: 'miniAppController'
        });

        $urlRouterProvider.otherwise('/doc');
    }

    docStyleController.$inject = ['$scope','$http','$location','$state','$ionicModal'];
    function docStyleController($scope,$http,$location,$state,$ionicModal){
        $scope.modalBoxClick = function(){
            $scope.isShowMore = !$scope.isShowMore;
        };
        /*跳转到列表页面*/
        $scope.miniAppClick = function(){
            $state.go('miniApp')
        };
        $scope.listClick = function(){
            $state.go('list')
        };
        $scope.noDataClick = function(){
            $state.go('noData')
        };
        $scope.selectClick = function(){
            $state.go('select')
        };
        $scope.formClick = function(){
            $state.go('form')
        };
        $scope.modalClick = function(){
            $state.go('modal')
        };
        $scope.mixtureClick = function(){
            $state.go('header-sty')
        };
        $scope.examinationClick = function(){
            $state.go('examination')
        };
        $scope.examinationListClick = function(){
            $state.go('examination_list')
        };
        /*返回首页*/
        $scope.backClick = function(){
            $state.go('doc')
        };
        /*模态*/
        $ionicModal.fromTemplateUrl('student.html',{
            scope:$scope,
            animation:'slide-in-left'
        }).then(function(modal){
            $scope.modal = modal;
        });
        $scope.rightModalClick = function() {
            $scope.modal.show();
        };
        $scope.closeName = function() {
            $scope.modal.hide();
        };
        $ionicModal.fromTemplateUrl('template.html',{
            scope:$scope,
            animation:'slide-in-up'
        }).then(function(modal){
            $scope.modal1 = modal;
        });
        $scope.bottomModalClick = function() {
            $scope.modal1.show();
        };
        $scope.closeModal = function() {
            $scope.modal1.hide();
        };
        $ionicModal.fromTemplateUrl('template1.html',{
            scope:$scope,
            animation:'slide-in-up'
        }).then(function(modal){
            $scope.modal2 = modal;
        });
        $scope.bottom1ModalClick = function() {
            $scope.modal2.show();
        };
        /*radio选择*/
        $scope.radioList = [
            {'msg':'很好','status':'1'},
            {'msg':'好','status':'2'  }
        ];
        $scope.itemRadioClick = function(radioItem){
            $scope.isRadioStatus = radioItem.status;
        };
        /*checkbox选择*/
        $scope.accomplishChoose=0;
        $scope.itemCheckboxClick = function(item){
            item.isClickIcon = !item.isClickIcon;
            if(item.isClickIcon == true){
                $scope.accomplishChoose+=1;
            }else{
                $scope.accomplishChoose-=1
            }
        };
        $scope.checkboxList  = [
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项1'},
            {'name':'选项2'}
        ];
        $scope.checkboxClick = function(itemCheck){
            angular.forEach(itemCheck,function(ic){
                console.log(ic);
                $scope.isStatus =true;
            });
        }
    }

    miniAppController.$inject = ['$scope','$state','microNav'];
    function miniAppController($scope,$state,microNav) {
        /*返回首页*/
        $scope.backClick = function(){
            $state.go('doc');
        };
        microNav.init()
    }