/**
 * 流程处理页面
 * @Date 2021年4月7日15:57:19
 */
(function () {
    'use strict';

    angular.module('starter')
        .config(stateConfig)
        .controller('dormitoryApplyDealCtrl', dormitoryApplyDealCtrl)

    stateConfig.$inject = ['$stateProvider'];

    function stateConfig($stateProvider) {
        $stateProvider
            //流程审核
            .state('dormitoryApplyDeal', {
                url: '/dormitoryApplyDeal',
                templateUrl: 'templates/dormitory_apply/dormitoryApplyDeal.html',
                data: {
                    prev: 'dormitory_apply',
                    title: '调寝审批',
                },
                controller: 'dormitoryApplyDealCtrl',
            })
    }
  
    dormitoryApplyDealCtrl.$inject = ['$rootScope', "$window", "$scope", "$http", "$ionicPopup", "$ionicModal", "$location","$sce","ynNavigator", "ynuiNotification"];

    function dormitoryApplyDealCtrl($rootScope, $window, $scope, $http, $ionicPopup, $ionicModal, $location, $sce,ynNavigator,ynuiNotification) {
        //从url获取请求所需参数
        var localUrl = decodeURI($window.location.href);
        var params = localUrl.split(/[?&]/);
        var fromType = params[1];
        var classId = "";
        fromType = fromType.replace("fromType=", "");
        var id = params[2];
        id = id.replace("procInstId=", "");
        if(id.indexOf("fromType=") > -1){
            var fromType = params[2];
            fromType = fromType.replace("fromType=", "");
            var id = params[3];
            id = id.replace("procInstId=", "");
        }
        angular.forEach(params, function(url){
            if(url.indexOf("classId=" > -1)){
                classId = url.replace("classId=", "");
            }
        });

        //删除调寝流程
        $scope.deleteAdjust = function(){
            var confirmPopup = $ionicPopup.confirm({
                title: "提示",
                templateUrl: 'templates/dormitory_apply/template/deleteAdjustConfirm.html',
                scope: $scope,
                cancelText: "取消",
                okText: "确认"
            });
            confirmPopup.then(function (res) {
                if (res) {
                    //删除调寝申请
                    $http.post(originBaseUrl + '/third/ssap/deleteByBatchNumber.htm?batchNumber=' + $scope.lcFormInfoVO.businessKey).then(function (response) {
                        //返回
                        ynuiNotification.success({msg: '删除成功！'});
                        $location.path("dormitory_apply").search({classId : classId});
                    });
                }
            });
        };

        //操作权限控制
        $scope.prcOperInfo = {
            fromBusiness: false,//是否从业务过来
            canCancel: false,//是否能够进行撤销操作
            canBack: false,//是否能够进行追回操作
            canSubmit: false,//是否能够进行提交操作
            canForm: false,//是否能够进行修改表单
            canMsg: false,//是否能够进行修改表单
            inSubmit: false//是否在提交中
        }
        if ($location.search().fromBusiness) {
            $scope.prcOperInfo.fromBusiness = true;
        }
        //注册父路由
        if ($location.search().state) {
            ynNavigator.registerBackAction(function () {
                $location.path($location.search().state);
                setTimeout(function () {
                    $scope.$apply();
                });
            },101);
        }
        $scope.doBack = function () {
            history.back(-1);
        };
        //提交信息初始化
        $scope.lcProcTaskDoVO = {
            id: id,                  //业务流程实例ID
            taskId: "",              //任务ID
            approvalOpinion: "",     //审批意见
            isEndTask: false,        //是否是结束任务
            approvalType: 0,         //0:同意 1:驳回到发起人 2:驳回到上一步
            approvalStatus: true     //审核结果 true:通过 false：不通过
        };
        var token = JSON.parse(window.localStorage.getItem("authorizationStr")).access_token;
        var reqUrl = originBaseUrl + "/third/mobileProc/queryTaskInfoByProcinstId.htm?fromType=" + fromType + "&procInstId=" + id+"&access_token="+token;
        $scope.fristInfo = true;
        $scope.loadProcInfo = function () {
            $http.post(reqUrl).success(function (data) {
                if (data.status == 0) {
                    $scope.prcOperInfo.canCancel = data.result.canCancel;
                    $scope.prcOperInfo.canBack = data.result.canBack;
                    $scope.prcOperInfo.canSubmit = !data.result.taskHadDone;
                    $scope.prcOperInfo.canForm = data.result.canForm;
                    $scope.prcOperInfo.canMsg = data.result.canMsg;
                    $scope.lcProcTaskDoVO.isEndTask = data.result.isEndTask;
                    $scope.lcProcTaskDoVO.taskId = data.result.taskId;
                    $scope.lcFormInfoVO = data.result;
                    $http.get(originBaseUrl + '/third/ssap/queryLcDetailById.htm', {
                        params: {
                            batchNumber: $scope.lcFormInfoVO.businessKey,
                        }
                    }).then(function (response) {
                        $scope.roomApplyLcDetail = response.data.result;
                    });
                }
            });
        }
        $scope.loadProcInfo();

        //封装  处理流程节点提交
        var doProcTask = function () {
            var sendWay = [];
            if ($scope.popup && $scope.popup.sendWayList) {
                angular.forEach($scope.popup.sendWayList, function (item) {
                    if (item.enable && item.checked) {
                        sendWay.push(item.code);
                    }
                });
            }
            var submit = {
                id: $scope.lcProcTaskDoVO.id,
                taskId: $scope.lcProcTaskDoVO.taskId,
                approvalOpinion: $scope.lcProcTaskDoVO.approvalOpinion,
                isEndTask: $scope.lcProcTaskDoVO.isEndTask,
                approvalType: $scope.lcProcTaskDoVO.approvalType,
                approvalStatus: $scope.lcProcTaskDoVO.approvalStatus,
                sendWay: sendWay.join(",")
            };
            if ($scope.prcOperInfo.inSubmit) {
                return;
            }
            $scope.prcOperInfo.inSubmit = true;
            $http.post(originBaseUrl + "/third/mobileProc/doProcTask.htm", submit).success(function (data) {
                setTimeout(function () {
                    $scope.prcOperInfo.inSubmit = false;
                    $scope.$apply();
                }, 2000);
                if (data.status == 0) {
                    $ionicPopup.alert({title: '提示', template: "操作成功", okText: '确定'});
                    $scope.lcProcTaskDoVO.approvalOpinion = null;
                    $scope.loadProcInfo();
                } else {
                    $ionicPopup.alert({title: '提示', template: data.message, okText: '确定'});
                    return false;
                }
            }).error(function (data) {
                setTimeout(function () {
                    $scope.prcOperInfo.inSubmit = false;
                    $scope.$apply();
                }, 2000);
            });
        };

        var submitPopupConfig = {
            templateUrl: 'templates/leave/askforleave/selectADTResult.html',
            title: '选择审核结果',
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>提交</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        doProcTask();
                    }
                }
            ]
        };


        var cancelPopupConfig = {
            templateUrl: 'templates/leave/askforleave/selectBackAndCancel.html',
            title: '流程撤销',
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>撤销</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        if (!$scope.popup.approvalOpinion) {
                            $scope.errorInfo = "请输入撤销原因!";
                            e.preventDefault();
                            return false;
                        } else {
                            $scope.lcProcTaskDoVO.approvalOpinion = $scope.popup.approvalOpinion;
                            doProcTask();
                        }
                    }
                }
            ]
        };
        var backPopupConfig = {
            templateUrl: 'templates/leave/askforleave/selectBackAndCancel.html',
            title: '流程追回',
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>追回</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        if (!$scope.popup.approvalOpinion) {
                            $scope.errorInfo = "请输入追回原因!";
                            e.preventDefault();
                            return false;
                        } else {
                            $scope.lcProcTaskDoVO.approvalOpinion = $scope.popup.approvalOpinion;
                            doProcTask();
                        }

                    }
                }
            ]
        };
        $scope.errorInfo = "";
        var urgeMsgConfig = {
            templateUrl: 'templates/leave/askforleave/selectUrgeMsg.html',
            title: "流程催办",
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>催办</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        var urgeSendWay = [];
                        angular.forEach($scope.lcFormInfoVO.msgTwoList, function (item) {
                            if (item.enable && item.checked) {
                                urgeSendWay.push(item.code);
                            }
                        });
                        if (urgeSendWay.length <= 0) {
                            $scope.errorInfo = "请选择发送方式!";
                            e.preventDefault();
                            return false;
                        } else {
                            $http.post(originBaseUrl + "/third/mobileProc/urgeActivityTask.htm", {
                                lcProcInstId: $scope.lcProcTaskDoVO.id,
                                sendWay: urgeSendWay.join(",")
                            }).success(function (data) {
                                if (data.status == 0) {
                                    $ionicPopup.alert({title: '提示', template: '操作成功!'});
                                    return true;
                                } else {
                                    $ionicPopup.alert({title: '提示', template: data.message});
                                    return false;
                                }
                            });
                        }
                    }
                }
            ]
        };

        $scope.urgeMsg = function () {
            $scope.errorInfo = "";
            $ionicPopup.show(urgeMsgConfig);
        }

        //提交/驳回发起人/驳回上一步
        $scope.submit = function (operType) {
            $scope.lcProcTaskDoVO.approvalType = operType;
            if (operType == 0) {
                $scope.lcProcTaskDoVO.approvalType = 0;
                if ($scope.lcProcTaskDoVO.isEndTask) {//是结束节点
                    $ionicPopup.show(submitPopupConfig);
                } else {
                    doProcTask();
                }
            } else if (operType == 4 || operType == 5) {//撤销 或者 追回
                $scope.errorInfo = "";
                $scope.popup = {approvalOpinion: null};
                $scope.popup.sendWayList = $scope.lcFormInfoVO.msgOneList;
                $scope.popup.operReason = "撤销原因";
                if (operType == 5) {
                    $scope.popup.operReason = "追回原因";
                }
                if (operType == 4) {
                    $ionicPopup.show(cancelPopupConfig);
                } else {
                    $ionicPopup.show(backPopupConfig);
                }
            } else {
                doProcTask();
            }
        };
        //材料证明
        var MaterialsProve;
        $ionicModal.fromTemplateUrl('materials_prove.html', {
            scope: $scope,
            animation: 'slide-in-right'
        }).then(function (modal) {
            MaterialsProve = modal;
        });

        //判断文件是否支持预览
        $scope.previewFileOrDownload = function (fastId) {
            var isSupported = false;
            var type = fastId.substring(fastId.lastIndexOf(".") + 1).toLowerCase();
            type = type.toLowerCase();
            if (type == 'doc' || type == 'docx' || type == 'xls' || type == 'xlsx' || type == 'ppt' || type == 'pptx' || type == 'txt' || type == 'pdf') {
                //符合条件的文件格式，跳转到预览
                isSupported = true;
            }
            return isSupported;
        }
        $scope.previewFileOrDownloadImg = function (fastId) {
            var isSupported = false;
            var type = fastId.substring(fastId.lastIndexOf(".") + 1).toLowerCase();
            type = type.toLowerCase();
            if (type == 'gif' || type == 'jpg' || type == 'jpeg' || type == 'png' || type == 'bmp') {
                //符合条件的文件格式，跳转到预览
                isSupported = true;
            }
            return isSupported;
        }
        $scope.previewPhoto = function (photo) {
            var cordovaFileOpen = cordova.plugins.disusered.open;
            $scope.attachmentUrl = cordovaFileOpen(originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + photo, cordovaFileOpenSuccess, cordovaFileOpenError);

            function cordovaFileOpenSuccess() {
                // 从已安装程序中打开文件完成
            }

            function cordovaFileOpenError(code) {
                if (code === 1) {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '未能在手机已安装APP中找到可预览此文件的程序'
                    });
                } else {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '预览时发生了未知错误 #' + code
                    });
                }
            }
        };
        //下载
        $scope.downLoadAndpreView = function (item) {
            if ($scope.previewFileOrDownload(item.attachmentId)) {
                $scope.attachmentUrl = $sce.trustAsResourceUrl(originBaseUrl + "/static/yineng/components/22-ynuiPdfViewer/web/viewer.html?fastDFSId=" + item.attachmentId)
                MaterialsProve.show();
            } else if ($scope.previewFileOrDownloadImg(item.attachmentId)) {
                $scope.previewPhoto(item.attachmentId);
            } else {
                $ionicPopup.alert({title: '提示', template: '该文件格式不支持预览!'});
            }
        };

        var flowChartModal;
        $ionicModal.fromTemplateUrl('flowChart.html', {
            scope: $scope,
            animation: 'slide-in-right'
        }).then(function (modal) {
            flowChartModal = modal;
        });
        $scope.act = {actId: null, checker: null};
        $scope.showActUserInfo = function () {
            $http.post(originBaseUrl + "/third/mobileProc/queryLCActUserInfoByProcInstId.htm?procInstId=" + id).success(function (data) {
                if (data.status == 0) {
                    $scope.actList = data.result.actList;
                    $scope.act.actId = data.result.curActId;
                    $scope.act.checker = data.result.checker;
                    $scope.act.lcProcDefId = data.result.lcProcDefId;
                    $scope.act.version = data.result.version;
                }
            });
        }
        $scope.changeActId = function () {
            $http.post(originBaseUrl + "/third/mobileProc/queryLCActUserInfoByProcInstIdAndActId.htm?procInstId=" + id + "&actId=" + $scope.act.actId).success(function (data) {
                if (data.status == 0) {
                    $scope.act.checker = data.result;
                }
            });
        }

        //查看流程图
        $scope.flowChart = function () {
            //获取流程图 流
            $scope.imgUrl = originBaseUrl + "/third/mobileProc/viewProcImage.htm?id=" + id + "&timePlate=" + (new Date()).getTime() + '&access_token=' + $rootScope.authorizationStr.access_token +
                '&userId=' + $rootScope.authorizationStr.userId +
                '&userType=' + $rootScope.authorizationStr.userType;
            $scope.showActUserInfo();
            flowChartModal.show();
        };
        var historyModal;
        $ionicModal.fromTemplateUrl('history.html', {
            scope: $scope,
            animation: 'slide-in-right'
        }).then(function (modal) {
            historyModal = modal;
        });

        //关闭弹窗
        $scope.closeFlowChartModal = function () {
            flowChartModal.hide();
        };
        $scope.closeHistoryModal = function () {
            historyModal.hide();
        };
        $scope.closeMaterialsProve = function () {
            MaterialsProve.hide();
        };

        //查看审批历史
        $scope.accraditationHistory = function () {
            //获取审批历史
            $http.post(originBaseUrl + "/third/mobileProc/queryLCActOperTrack.htm?procInstId=" + id + "&timePlate=" + (new Date()).getTime()).success(function (data) {
                if (data.status == 0) {
                    $scope.trackInfo = data.result;
                    historyModal.show();
                }
            });
        };
    }


})();
