/**
 * 申请调寝添加
 * @author Wu Juncheng
 */
(function () {
    'use strict';

    angular.module('starter')
        .config(stateConfig)
        .controller('dormitoryApplyAddCtrl', dormitoryApplyAddCtrl)
    stateConfig.$inject = ['$stateProvider'];

    function stateConfig($stateProvider) {
        $stateProvider
             //申请调寝
            .state('dormitory_apply_add', {
                url: '/dormitory_apply_add',
                templateUrl: 'templates/dormitory_apply_add/dormitory_apply_add.html',
                data: {
                    prev: 'dormitory_apply',
                    title: '申请调寝'
                },
                controller: 'dormitoryApplyAddCtrl'
            })
    }

    dormitoryApplyAddCtrl.$inject = ['$scope', '$http', '$ionicModal', 'ynuiNotification', '$window', '$location', '$ionicScrollDelegate'];

    function dormitoryApplyAddCtrl ($scope, $http, $ionicModal, ynuiNotification, $window, $location, $ionicScrollDelegate) {

        $scope.stuId;
        var localUrl = decodeURI($window.location.href);
        var params = localUrl.split(/[?&]/);
        $scope.backClassId = null;
        angular.forEach(params, function(url){
            if(url.indexOf("stuId=") > -1){
                $scope.stuId = url.replace("stuId=", "");
            }
            if(url.indexOf("classId=") > -1){
                $scope.backClassId = url.replace("classId=", "");
            }
        });

        if($scope.stuId){
            $http.get(originBaseUrl + "/third/ssap/queryClassStuInfoByStuId.htm?stuId=" + $scope.stuId).success(function(data){
                if(data.status === 0){
                    $scope.selectedStu = data.result;
                    //查询对应的楼栋信息
                    $http.get(originBaseUrl + "/third/ssap/getBuildListByClassIdAndSex.htm?isSearchAll=true&sex=" + $scope.selectedStu.sex + "&classId=" + $scope.selectedStu.classId).success(function(data){
                        if(data.status === 0){
                            $scope.buildingList = data.result;
                            if($scope.buildingList.length > 0 && $scope.buildingList[0].chooseRoomVOList.length > 0){
                                $scope.chooseTargetBuild($scope.buildingList[0]);
                            }
                        }
                    });
                }
            })
        }


        //查询下拉原因
        $http.get(originBaseUrl + "/third/ssap/getMoveReasonList.htm").success(function(data){
            if(data.status === 0){
                $scope.reasonList = data.result;
                $scope.selectedReason = {
                    dictCode : data.result[0].dictCode
                };
            }
        });

        //下拉
        $scope.sexList = [
            {name: '全部', id: '', showName: '性别'},
            {name: '男', id: 1, showName: '男'},
            {name: '女', id: 2, showName: '女'}
        ];

        $scope.selectSex = $scope.sexList[0];

        $ionicModal.fromTemplateUrl('dormitory_choose_apply_stu.html',{
            scope:$scope,
            animation:'slide-in-left'
        }).then(function(modal){
            $scope.modal_choose_apply_stu = modal;
        });

        $ionicModal.fromTemplateUrl('searchRoom.html',{
            scope:$scope,
            animation:'slide-in-left'
        }).then(function(modal){
            $scope.searchRoomModel = modal;
        });

        //弹出寝室筛选
        $scope.showSearchRoom = function(){
            $scope.fetchVO = {
                fetchName : ""
            };
            $scope.searchRoomModel.show();
        };

        //进行筛选
        $scope.fetch = function(){
            if(!$scope.fetchVO.fetchName){
                $scope.selectedBuild.chooseRoomVOList = angular.copy($scope.cacheRoomList);
            }else{
                var fetchList = [];
                angular.forEach($scope.cacheRoomList, function(room){
                    if(room.roomName.indexOf($scope.fetchVO.fetchName) > -1){
                        fetchList.push(room);
                    }
                });
                $scope.selectedBuild.chooseRoomVOList = fetchList;
            }
            if(!$scope.selectedBuild.chooseRoomVOList || $scope.selectedBuild.chooseRoomVOList.length === 0){
                ynuiNotification.error({msg: '没有匹配到相关寝室，请重新搜索!'});
                return false;
            }
            $scope.chooseTargetRoom($scope.selectedBuild.chooseRoomVOList[0]);
            $ionicScrollDelegate.scrollTop();
            $scope.searchRoomModel.hide();
        };

        //选择学生
        $scope.chooseApplyStu = function(){
            //单个调寝就不能回填
            if($scope.backClassId){
                return false;
            }
            //查询管理班级
            $http.get(originBaseUrl + "/third/ssap/queryTeacherClassList.htm").success(function(data){
                if(data.status === 0){
                    $scope.modal_choose_apply_stu.show();
                    $scope.classStuList = [];
                    $scope.classList = data.result;
                    var i = 0;
                    angular.forEach($scope.classList, function(item){
                        item.index = i;
                        i++;
                    });
                    $scope.curryClass = $scope.classList[0];
                    //初始化为选择班级学生
                    $scope.changeChooseType(1);
                }
            });
        };

        //选前一个班
        $scope.beforeClass = function(index){
            if(index === 0){
                $scope.curryClass = $scope.classList[$scope.classList.length - 1];
            }else{
                $scope.curryClass = $scope.classList[index - 1];
            }
            if($scope.chooseType === 1){
                $scope.queryClassStu();
            }else{
                $scope.queryClassRoomList();
            }
        };

        //选后一个班
        $scope.afterClass = function(index){
            if(index === $scope.classList.length - 1){
                $scope.curryClass = $scope.classList[0];
            }else{
                $scope.curryClass = $scope.classList[index + 1];
            }
            if($scope.chooseType === 1){
                $scope.queryClassStu();
            }else{
                $scope.queryClassRoomList();
            }
        };

        //选择性别
        $scope.selectSexFun = function(item){
            $scope.selectSex = item;
            $scope.queryClassStu();
        };

        //查询班级学生
        $scope.queryClassStu = function(){
            $http.get(originBaseUrl + "/third/ssap/getStuByClassIdAndSexAndIsInRoom.htm?classId=" + $scope.curryClass.id + "&sex=" + $scope.selectSex.id).success(function(data){
                if(data.status === 0){
                    $scope.classStuList = data.result;
                }
            });
        };

        //选择学生
        $scope.selectStu = function(item){
            $scope.selectedStu = item;
            $scope.selectedStu.classId = $scope.curryClass.id;
            angular.forEach($scope.classStuList, function(classStu){
                if(item.stuId === classStu.stuId){
                    classStu.selected = true;
                }else{
                    classStu.selected = false;
                }
            });
        };

        //查询班级下的寝室
        $scope.queryClassRoomList = function(){
            //获取班级下的寝室信息
            $http.get(originBaseUrl + "/third/ssap/getBedRoomInfoListByClassId.htm?classId=" + $scope.curryClass.id).success(function(data){
                if(data.status === 0){
                    $scope.roomList = data.result;
                    $scope.classStuList = [];
                    if($scope.roomList.length > 0){
                        $scope.chooseInRoom($scope.roomList[0]);
                    }
                }
            });
        };

        //选择寝室
        $scope.chooseInRoom = function(item){
            angular.forEach($scope.roomList, function(room){
                if(room.bedRoomId !== item.bedRoomId){
                    room.selected = false;
                }else{
                    room.selected = true;
                }
            });
            $scope.selectedRoom = item;
            $http.get(originBaseUrl + "/third/ssap/getBedRoomInfoByRoomIdAndClassIdAndSex.htm?classId=" + $scope.curryClass.id + "&roomId=" + item.bedRoomId + "&sex=" + item.sex).success(function(data){
                if(data.status === 0){
                    $scope.selectedRoomDetailVO = data.result;
                    console.log($scope.selectedRoomDetailVO);
                }
            });
            $scope.queryInRoomStu($scope.selectedRoom.bedRoomId);
        };

        //查询宿舍下的入住学生
        $scope.queryInRoomStu = function(roomId){
            $http.get(originBaseUrl + "/third/ssap/getStuByClassIdAndRoomId.htm?classId=" + $scope.curryClass.id + "&roomId=" + roomId).success(function(data){
                if(data.status === 0){
                    $scope.classStuList = data.result;
                }
            });
        };


        //选择学生的方式
        $scope.changeChooseType = function(type){
            $scope.chooseType = type;
            if($scope.chooseType === 1){
                $scope.queryClassStu();
            }else{
                $scope.queryClassRoomList();
            }
        };

        //确认选择学生
        $scope.commitStu = function(){
            if(!$scope.selectedStu || !$scope.selectedStu.stuId){
                ynuiNotification.error({msg: '请选择学生!'});
                return false;
            }
            $scope.modal_choose_apply_stu.hide();
            //查询对应的楼栋信息
            $http.get(originBaseUrl + "/third/ssap/getBuildListByClassIdAndSex.htm?isSearchAll=true&sex=" + $scope.selectedStu.sex + "&classId=" + $scope.selectedStu.classId).success(function(data){
                if(data.status === 0){
                    $scope.buildingList = data.result;
                    if($scope.buildingList.length > 0 && $scope.buildingList[0].chooseRoomVOList.length > 0){
                        $scope.chooseTargetBuild($scope.buildingList[0]);
                    }
                }
            });
        };

        //选择楼栋
        $scope.chooseTargetBuild = function(build){
            $scope.selectedBuild = build;
            //缓存目标楼栋的备选房间
            $scope.cacheRoomList = angular.copy(build.chooseRoomVOList);
            angular.forEach($scope.buildingList, function(data){
                if(build.id === data.id){
                    build.selected = true;
                }else{
                    build.selected = false;
                }
            });
            $scope.chooseTargetRoom($scope.selectedBuild.chooseRoomVOList[0]);
        };

        //查询目标寝室信息
        $scope.chooseTargetRoom = function(item){
            $scope.setectBedInfo = null;
            angular.forEach($scope.buildingList, function(build){
                angular.forEach(build.chooseRoomVOList, function(room){
                    if(item.bedRoomId === room.bedRoomId){
                        room.selected = true;
                    }else{
                        room.selected = false;
                    }
                });
            });
            $http.get(originBaseUrl + "/third/ssap/getBedRoomInfoByRoomIdAndClassIdAndSex.htm?classId=" + $scope.selectedStu.classId + "&roomId=" + item.bedRoomId + "&sex=" + item.sex).success(function(data){
                if(data.status === 0){
                    $scope.targetRoom = data.result;
                    $scope.clickBedInfo($scope.targetRoom.bedInfoVOList[0]);
                }
            });
        };

        //选择目标床位
        $scope.clickBedInfo = function (item, canEmpty) {
            if (item.stuName || canEmpty ) {
                $scope.setectBedInfo = item;
            }
        };

        //提交申请
        $scope.submitApply = function(){
            if(!$scope.selectedReason || !$scope.selectedReason.dictCode){
                ynuiNotification.error({msg: '请选择调寝原因!'});
                return false;
            }
            if($scope.selectedStu.stuId === $scope.setectBedInfo.stuId){
                ynuiNotification.error({msg: '不能选择学生本人!'});
                return false;
            }
            $http.post(originBaseUrl + "/third/ssap/commitChangeStuRoomApply.htm", {
                stuId : $scope.selectedStu.stuId,
                beforeRoomBedId : $scope.selectedStu.roomBedId,
                afterRoomBedId : $scope.setectBedInfo.id,
                targetStuId : $scope.setectBedInfo.stuId,
                reasonCode : $scope.selectedReason.dictCode
            }).success(function(data){
                if(data.status === 0){
                    ynuiNotification.success({msg: '提交成功!'});
                    $scope.selectedStu = null;
                    $scope.buildingList = [];
                    if(!$scope.backClassId){
                        $location.path('dormitory_apply');
                    }else{
                        $location.path('/teacher/workspace/dormitory_list').search({backClassId : $scope.backClassId});
                    }
                }else{
                    ynuiNotification.error({msg : data.message});
                    return false;
                }
            });
        }


    }


})();
