/**
 * 寝室安排/床位调整
 * @author Wu Juncheng
 * @Date 2021年4月8日16:27:51
 */
(function () {
    'use strict';

    angular.module('starter')
        .config(stateConfig)
        .controller('dormitoryBookCtrl', dormitoryBookCtrl)
    stateConfig.$inject = ['$stateProvider'];

    function stateConfig($stateProvider) {
        $stateProvider
             //安排寝室
            .state('dormitory_book', {
                url: '/dormitory_book',
                templateUrl: 'templates/dormitory_book/dormitory_book.html',
                data: {
                    micro: true,
                    title: '预订寝室'
                },
                controller: 'dormitoryBookCtrl'
            })
    }

    dormitoryBookCtrl.$inject = ['$scope', '$http', '$ionicModal', 'ynuiNotification'];

    function dormitoryBookCtrl ($scope, $http, $ionicModal, ynuiNotification) {

        //查询配置和异常信息
        $scope.searchBookInfo = function(){
            //是否为修改预订
            $scope.isUpdate = false;
            $http.get(originBaseUrl + "/third/ssap/getStuBookInfo.htm").success(function(data){
                if(data.status === 0){
                    $scope.stuBookInfo = data.result;
                    if($scope.stuBookInfo.ssMobileBuildBedRoomVOList && $scope.stuBookInfo.ssMobileBuildBedRoomVOList.length > 0){
                        $scope.selectBuild($scope.stuBookInfo.ssMobileBuildBedRoomVOList[0]);
                    }
                }else{
                    $scope.errorInfo = data.message;
                }
            });
        };
        $scope.searchBookInfo();


        //选择楼栋
        $scope.selectBuild = function(build){
            $scope.selectedBuild = build;
            $scope.selectBookRoom($scope.selectedBuild.chooseRoomVOList[0]);
        };


        //选中目标寝室
        $scope.selectBookRoom = function(item){
            if(item.classSurplus > 0) {
                $scope.bookRoom = item;
            }
        };

        //确认预订
        $scope.submitBook = function(){
            if(!$scope.bookRoom || !$scope.bookRoom.bedRoomId){
                ynuiNotification.error({msg: '请选择预订寝室!'});
            }
            $http.post(originBaseUrl + "/third/ssap/bookRoom.htm", {bedRoomId :  $scope.bookRoom.bedRoomId}).success(function(data){
                if(data.status === 0){
                    ynuiNotification.success({msg: '预订成功!'});
                    $scope.searchBookInfo();
                }else{
                    ynuiNotification.error({msg: data.message});
                }
            })
        };

        //修改预订
        $scope.updateBook = function(){
            $scope.selectBuild($scope.stuBookInfo.ssMobileBuildBedRoomVOList[0]);
            $scope.isUpdate = true;
        }

    }


})();
