/**
 * 我的评教
 *
 * @author qiucheng Lu
 * @date 2021年4月13日11:04:29
 */
(function () {
    'use strict';
    angular.module('starter')
        .config(config)
        .controller('evaluationManageCtrl', evaluationManageCtrl)
        .directive('wjAttendStudent', ['$http', '$ionicModal', '$interval', '$location', 'ynuiNotification','ynSendWay',"$ionicPopup","$ionicScrollDelegate",
            function ($http, $ionicModal, $interval, $location, ynuiNotification,ynSendWay,$ionicPopup,$ionicScrollDelegate) {
            return {
                restrict: 'A',
                replace: true,
                scope: {
                    isBatch:"@"
                },
                templateUrl: 'templates/evaluation/template/evaluationStudent.html',
                controller: function ($scope) {
                    var params = angular.fromJson($location.search().params);
                    console.log(params);
                    var vm = $scope.vm = {
                        //评教计划
                        evaluationList: [],
                        //行政班
                        adminClassList: [],
                        allClassIds:[],
                        condition: {
                            planVo: "",
                            classNames: "全部班级",
                            classIds:[],
                            //0未开始，1进行中，2已结束
                            type:"1",
                            evaluatedName:'',
                        },
                        tabIndex:0,
                        personList:{
                            notCount:0,
                            count:0,
                        },
                        isBatch:$scope.isBatch=='true',
                        //错误信息提示
                        errorInfo:"",
                        /**
                         * 获取老师的行政班 在根据行政班获取评教计划
                         */
                        getPlanOrClassByUserId: function () {
                            vm.errorInfo="";
                            $http.get(originBaseUrl + "/third/myEvaluation/getPlanOrClassByUserId.htm").success(function (data) {
                                if (data.status == 0) {
                                    //班级
                                    vm.adminClassList=[{id:"",name:"全部班级",checked:vm.condition.classIds.length==0}];
                                    if(data.result.classList){
                                        angular.forEach(data.result.classList,function(item){
                                            if(vm.condition.classIds.length>0 ){
                                                item.checked=vm.condition.classIds.indexOf(item.id)>-1;
                                            }else{
                                                item.checked=true;
                                            }
                                            vm.adminClassList.push(item);
                                            vm.allClassIds.push(item.id);
                                        })
                                    }

                                    //评教计划
                                    if(data.result.planList){
                                        vm.evaluationList = data.result.planList;
                                        if(!params){
                                            vm.condition.planVo=vm.evaluationList[0];
                                        }else{
                                            vm.tabIndex=params.tabIndex;
                                            vm.condition=params.condition;
                                        }
                                        vm.getClassStudentAttendByClassId();
                                    }else{
                                        vm.errorInfo="班级未安排评教任务！";
                                    }
                                }else{
                                    vm.errorInfo=data.message;
                                }
                            });
                        },
                        /**
                         * 获取老师的行政班下的参评学生
                         */
                        getClassStudentAttendByClassId: function () {
                            if(!vm.condition.planVo.id){
                                return;
                            }
                            $http.post(originBaseUrl + "/third/myEvaluation/getClassStudentAttendByClassId.htm",
                                {
                                    planId: vm.condition.planVo.id,
                                    classIds: vm.getClassIds()
                                }).success(function (data) {
                                if (data.status == 0) {
                                    if(!data.result || data.result.length==0){
                                        vm.errorInfo="班级未安排评教任务！";
                                    }
                                    vm.classStudentList = data.result;
                                    vm.condition.type=data.message;
                                    vm.checkTab(vm.tabIndex);
                                } else {
                                    ynuiNotification.error({msg: "服务器错误，请稍后再试！"});
                                }
                            });
                        },
                        /**
                         * 获取班级ID
                         * @returns {[]}
                         */
                        getClassIds:function(){
                            var classIds=[];
                            if(vm.condition.classIds.length>0){
                                classIds=vm.condition.classIds;
                            }else{
                                classIds=vm.allClassIds;
                            }
                            return classIds;
                        },
                        /**
                         * 切换tab
                         */
                        checkTab:function(tabIndex){
                            vm.tabIndex=tabIndex;
                            vm.showStusentList=[];
                            vm.personList.notCount=0;
                            vm.personList.count=0;
                            vm.initPersonInfo(tabIndex);
                            $ionicScrollDelegate.$getByHandle('listScroll').scrollTo(0, 1, true);
                        },
                        /**
                         * vm.condition.type==0 统计未开始的参评和不参评人数
                         * vm.condition.type>0统计进行中和已结束的 已评和未评人数
                         * 计算人数
                         * @param tabIndex 0全部，1要参评/未完成 ，2不参评/已完成
                         */
                        initPersonInfo:function(tabIndex){
                            //完成状态
                            var type=vm.condition.type;
                            angular.forEach(vm.classStudentList,function(item){
                                var notCount=0,count=0;
                                angular.forEach(item.evaluatedList,function(evaluated){
                                    if((evaluated.isAttend==true && type>0)
                                        ||(evaluated.needAttend==true && type==0)){
                                        count++;
                                    }else{
                                        notCount++;
                                    }
                                });
                                item.needCount=count;
                                item.notNeedCount=notCount;
                                item.isShow=false;
                                var isCount=(type==0 && count>0) || (type>0&& notCount>0);
                                if(isCount){
                                    vm.personList.count++;
                                }else{
                                    vm.personList.notCount++;
                                }
                                if (tabIndex == 0) {
                                    vm.showStusentList.push(item);
                                }else if (tabIndex == 1 && isCount) {
                                    vm.showStusentList.push(item);
                                } else if (tabIndex == 2 && ((type==0&& count==0) ||(type>0&& notCount==0))) {
                                    vm.showStusentList.push(item);
                                }
                            });
                            if(type>0){
                                vm.showStusentList.sort(function(a, b) {
                                    if(b.needCount-a.needCount!=0){
                                        return b.needCount-a.needCount;
                                    }
                                    return a.userName.localeCompare(b.userName);
                                })
                            }
                        },
                        /**
                         * 切换班级
                         * @param item
                         */
                        checkClass: function (item) {
                            var classIds=[],classNames="";
                            if(item.id==""){
                                //全选
                                if(!item.checked){
                                    angular.forEach(vm.adminClassList,function(item){
                                        item.checked=true;
                                        if (item.id!="") {
                                            classIds.push(item.id);
                                            classNames+=item.name+"、";
                                        }
                                    })
                                }else{
                                    angular.forEach(vm.adminClassList,function(item){
                                        item.checked=false;
                                    })
                                }
                            }else{
                                item.checked=!item.checked;
                                angular.forEach(vm.adminClassList,function(item) {
                                    if (item.checked && item.id!="") {
                                        classIds.push(item.id);
                                        classNames+=item.name+"、";
                                    }
                                })
                            }
                            if(classIds.length==0 ||classIds.length==vm.adminClassList.length-1){
                                classNames="全部班级";
                                if(classIds.length==vm.adminClassList.length-1){
                                    vm.adminClassList[0].checked=true;
                                }
                            }else{
                                vm.adminClassList[0].checked=false;
                            }
                            if(classNames.length>0){
                                vm.condition.classNames=classNames.substring(0,classNames.length-1);
                            }else{
                                vm.condition.classNames="";
                            }
                            vm.condition.classIds=classIds;
                            vm.getClassStudentAttendByClassId();
                        },
                        /**
                         * 设置参评或不参评
                         * @param personMiddleIds
                         * @param needAttend
                         */
                        updPersonMiddleNeedAttend:function(evaluated,needAttend,classStudent){
                            var personMiddleIds=[];
                            if(!evaluated){
                                angular.forEach(vm.classStudentList,function(item){
                                    if(item.isClick){
                                        angular.forEach(item.evaluatedList,function(evaluated){
                                            if(item.needAttend!=needAttend){
                                                personMiddleIds.push(evaluated.personMiddleId);
                                            }
                                        });
                                    }
                                });
                            }else{
                                personMiddleIds.push(evaluated.personMiddleId);
                            }
                            if(personMiddleIds.length==0){
                                ynuiNotification.error({msg: "请至少勾选一项！"});
                                return;
                            }
                            var param = {
                                needAttend: needAttend,
                                ids: personMiddleIds,
                                planId: vm.condition.planVo.id
                            }
                            $http.post(originBaseUrl + "/third/myEvaluation/updPersonMiddleNeedAttend.htm", param).success(function (data) {
                                if (data.status == 0) {
                                    ynuiNotification.success({msg: "操作成功！"});
                                    vm.updateNeedAttend(evaluated,needAttend,classStudent);
                                }
                            });
                        },
                        /**
                         * 修改是否参评状态，不刷新后端
                         * @param evaluated
                         */
                        updateNeedAttend:function(evaluated,needAttend,classStudent){
                            if(!evaluated){
                                angular.forEach(vm.classStudentList,function(classStudents){
                                    if(classStudents.isClick){
                                        var total=classStudents.evaluatedList.length;
                                        classStudents.needCount=needAttend?total:0;
                                        classStudents.notNeedCount=!needAttend?total:0;
                                        classStudents.isClick=false;
                                        angular.forEach(classStudents.evaluatedList,function(item){
                                            item.needAttend=needAttend;
                                        })
                                    }
                                });
                                vm.checkTab(vm.tabIndex);
                            }else{
                                evaluated.needAttend=needAttend;
                                if(needAttend){
                                    classStudent.needCount++;
                                    classStudent.notNeedCount--;
                                }else{
                                    classStudent.needCount--;
                                    classStudent.notNeedCount++;
                                }
                            }
                        },
                        /**
                         * 发送消息提醒学生
                         */
                        showSendWay:function(){
                            if(vm.condition.type!='1'){
                                //0未开始，1进行中，2已结束
                                ynuiNotification.error({msg: "评教计划"+(vm.condition.type==0?"未开始":"已结束")+"，不能发送消息提醒！"});
                                return;
                            }
                            ynSendWay.listMessageSendWay('wj_student','2').then(function(data){
                                vm.sendList=data;
                                if(vm.sendList.length>0){
                                    $ionicPopup.show({
                                        title: '消息提醒方式',
                                        templateUrl: "ynSendMessage.html",
                                        scope: $scope,
                                        buttons: [{ text: '取消' }, {text: '确认', type: 'button-positive',
                                            onTap:function(e){
                                                var sendWay=[];
                                                angular.forEach(vm.sendList,function(item){
                                                    if(item.checked && item.enable){
                                                        sendWay.push(item.code);
                                                    }
                                                });
                                                if (sendWay.length==0) {
                                                    ynuiNotification.error({msg: "请至少勾选一项！"});
                                                    e.preventDefault();
                                                } else {
                                                    $http.post(originBaseUrl + "/third/myEvaluation/sendMessageStudent.htm",{
                                                        planId:vm.condition.planVo.id,
                                                        classIds:vm.getClassIds(),
                                                        sendWay:sendWay
                                                    }).success(function (data) {
                                                        if (data.status == 0) {
                                                            ynuiNotification.success({msg: "操作成功！"});
                                                        }
                                                    });
                                                }
                                            }
                                        }]
                                    });
                                }else{
                                    ynuiNotification.error({msg: "不允许发送消息！"});
                                }
                            });
                        },
                        goBatchPage:function(){
                            if(vm.condition.type!='0'){
                                //0未开始，1进行中，2已结束
                                ynuiNotification.error({msg: "评教计划"+(vm.condition.type==1?"进行中":"已结束")+"，不能设置是否参评！"});
                                return;
                            }
                            $location.path("/batchEvaluationMange").search({params:angular.toJson({condition:vm.condition,tabIndex:vm.tabIndex})});
                        },
                        //显示或隐藏搜索
                        search:function(){
                            vm.showSeach=!vm.showSeach;
                            vm.checkTab(0);
                            if(!vm.showSeach){
                                vm.condition.evaluatedName="";
                            }
                        },
                        changeSearch:function(){
                            vm.checkTab(0);
                            if(vm.condition.evaluatedName){
                                var showStudentList=[];
                                angular.forEach(vm.showStusentList,function(item){
                                    if(item.userName.indexOf(vm.condition.evaluatedName)>-1
                                        || (item.userNumber && item.userNumber.indexOf(vm.condition.evaluatedName)>-1)){
                                        showStudentList.push(item);
                                    }
                                });
                                vm.showStusentList=showStudentList;
                            }
                        },
                    }
                    vm.getPlanOrClassByUserId();
                }
            };
        }])
    config.$inject = ['$stateProvider'];

    function config($stateProvider) {
        $stateProvider
            .state('evaluationManage', {
                url: '/evaluationManage',
                template: '<label wj-attend-student is-batch="false"></label>',
                controller: 'evaluationManageCtrl',
                cache: false,
                data: {
                    micro: true,
                    title: '评教管理'
                }
            }).state('batchEvaluationMange', {
                url: '/batchEvaluationMange',
                template: '<label wj-attend-student is-batch="true"></label>',
                controller: 'evaluationManageCtrl',
                cache: false,
                data: {
                    micro: true,
                    title: '评教管理',
                    prev:"evaluationManage",
                }
            })

    }

    function evaluationManageCtrl() {

    }
})();