var debugAPIValue = !1, infoAPIValue = !1, errorAPIValue = !1, debugAPI = function (e) {
    debugAPIValue && console.log("scormApi_V1.3.js debugAPI debug :   " + e)
}, infoAPI = function (e) {
    infoAPIValue && console.log("scormApi_V1.3.js infoAPI info :   " + e)
}, errorAPI = function (e) {
    errorAPIValue && console.log("scormApi_V1.3.js errorAPI info :   " + e)
}, scorm_data_model = function () {
    this.name = "", this.defaultvalue = "", this.format = "", this.model = "r"
}, user_data_model = function () {
    this.name = "", this.value = "", this.model = "RW"
}, scorm_model_init = function (e, t, n, r) {
    var i = new scorm_data_model;
    return i.name = e, i.defaultvalue = t, i.format = n, i.model = r, i
};
String.prototype.trim = function () {
    return this.replace(/^\s+|\s+$/, "")
};
var study_process_id = null;
var scormCourseId,userId,teachClassId,knowleageId,sourceTableId,teachingPlanId,sourceType;
var last_knowleageId = null;
var init_knowleageId = null;
var last_session_time = null;


/**
 * 对Date的扩展，将 Date 转化为指定格式的String
 * 月(M)、日(d)、12小时(h)、24小时(H)、分(m)、秒(s)、周(E)、季度(q) 可以用 1-2 个占位符
 * 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)
 * eg:
 * (new Date()).pattern("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423
 * (new Date()).pattern("yyyy-MM-dd E HH:mm:ss") ==> 2009-03-10 二 20:09:04
 * (new Date()).pattern("yyyy-MM-dd EE hh:mm:ss") ==> 2009-03-10 周二 08:09:04
 * (new Date()).pattern("yyyy-MM-dd EEE hh:mm:ss") ==> 2009-03-10 星期二 08:09:04
 * (new Date()).pattern("yyyy-M-d h:m:s.S") ==> 2006-7-2 8:9:4.18
 */
Date.prototype.pattern=function(fmt) {
    var o = {
        "M+" : this.getMonth()+1, //月份
        "d+" : this.getDate(), //日
        "h+" : this.getHours()%12 == 0 ? 12 : this.getHours()%12, //小时
        "H+" : this.getHours(), //小时
        "m+" : this.getMinutes(), //分
        "s+" : this.getSeconds(), //秒
        "q+" : Math.floor((this.getMonth()+3)/3), //季度
        "S" : this.getMilliseconds() //毫秒
    };
    var week = {
        "0" : "/u65e5",
        "1" : "/u4e00",
        "2" : "/u4e8c",
        "3" : "/u4e09",
        "4" : "/u56db",
        "5" : "/u4e94",
        "6" : "/u516d"
    };
    if(/(y+)/.test(fmt)){
        fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));
    }
    if(/(E+)/.test(fmt)){
        fmt=fmt.replace(RegExp.$1, ((RegExp.$1.length>1) ? (RegExp.$1.length>2 ? "/u661f/u671f" : "/u5468") : "")+week[this.getDay()+""]);
    }
    for(var k in o){
        if(new RegExp("("+ k +")").test(fmt)){
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));
        }
    }
    return fmt;
}

var lastChapterId;//最后学习章节
//获取scorm所需参数
var getVariable=function (userId,knowleageId,scormCourseId,teachingPlanId,sourceTableId,sourceType,teachClassId,lastChapterId){
    scormCourseId=scormCourseId;// scorm课程id
    userId=userId;//用户id
    init_knowleageId = knowleageId;
    teachClassId=teachClassId;//教学班id
    sourceTableId=sourceTableId;//主键id
    teachingPlanId=teachingPlanId;//教案id
    sourceType=sourceType;//0 教案章节 1 课后学习资源
    lastChapterId = lastChapterId;//最后学习章节
}

//记录暂停计时时间
var pauseTime = 0;
var pauseSecond = 0;
function pauseTimer (type){
	if (type == "start") {
	    pauseTime = 0;
        pauseSecond = 0;
        if (jumpIframe.window.g_varInterval != "") {
            startTimer = setInterval(function () {
                pauseSecond++;
            }, 1000);
        } else {
            clearInterval(startTimer);
        }
	} else {
		clearInterval(startTimer);
	}
};


var scorm_2004 = function () {
    debugAPI("link success!"),
        this.PostDataUrl = "",
        // this.PostDataUrl = "/ynedut/lmsportal/scormzz/studentTranceInfo.htm?userId="+userId+"&teachClassId="+teachClassId+"&scormCourseId="+(scormCourseId?scormCourseId:"")+"&sourceTableId="+sourceTableId+"&teachingPlanId="+teachingPlanId+"&sourceType="+sourceType,
        this.InitDataModelUrl = "",
        // this.InitDataModelUrl = "/ynedut/lmsportal/scormzz/studentTranceInfoInit.htm?userId="+userId+"&teachClassId="+teachClassId+"&scormCourseId="+(scormCourseId?scormCourseId:"")+"&sourceTableId="+sourceTableId+"&sourceType="+sourceType+"&teachingPlanId="+teachingPlanId,
        this.IntervalTime = 3e3, this.IntervalObject = null;
    var scorm_object_interval = this;
    this.CMIString200 = "^.{0,200}$", this.CMIString250 = "^.{0,250}$", this.CMIString1000 = "^.{0,1000}$", this.CMIString4000 = "^.{0,4000}$", this.CMIString64000 = "^.{0,64000}$", this.CMIFeedback = this.CMIString200, this.CMILangString250 = "^({lang=([a-zA-Z]{2,3}|i|x)(-[a-zA-Z0-9-]{2,8})?})?([^{].{0,250}$)?", this.CMIInteger = "^\\d+$", this.CMISInteger = "^-?([0-9]+)$", this.CMIDecimal = "^-?([0-9]{1,4})(.[0-9]{1,18})?$", this.CMIDotNumber = "^0$|^1$|^0.[0-9]{0,7}[1-9]$", this.CMIDotNumbersub = "^-1$|^1$|^-?0.[0-9]{0,7}[1-9]$|^0$", this.CMILongIdentifier = "^\\S{0,4000}[a-zA-Z0-9]$", this.CMITime = "^(19[7-9]{1}[0-9]{1}|20[0-2]{1}[0-9]{1}|203[0-8]{1})((-(0[1-9]{1}|1[0-2]{1}))((-(0[1-9]{1}|[1-2]{1}[0-9]{1}|3[0-1]{1}))(s([0-1]{1}[0-9]{1}|2[0-3]{1})((:[0-5]{1}[0-9]{1})((:[0-5]{1}[0-9]{1})((\\.[0-9]{1,2})((Z|([+|-]([0-1]{1}[0-9]{1}|2[0-3]{1})))(:[0-5]{1}[0-9]{1})?)?)?)?)?)?)?)?$", this.CMICaption = "^1$|^0$|^-1$", this.CMISessionTime = "^PT\\d+H\\d+M\\d+S$", this.CMIExit = "^timeout$|^suspend$|^logout$|^normal$|^$", this.CMICStudyTatus = "^completed$|^incomplete$|^not attempted$|^unknown$", this.CMISStatus = "^passed$|^failed$|^unknown$", this.CMIResult = "^correct$|^incorrect$|^unanticipated$|^neutral$|^-?([0-9]{1,4})(.[0-9]{1,18})?$", this.CMIType = "^true-false$|^multiple_choice|^fill_in$|^long_fill_in$|^matching$|^performance$|^sequencing$|^likert$|^numeric$|^other$", this.NAVEvent = "^previous$|^continue$|^exit$|^exitAll$|^abandon$|^abandonAll$|^_none_$", this.CMICredit = "^credit$|^no_credit$", this.CMIEntry = "^ab_initio$|^resume$|^$", this.CMIMode = "^browse$|^normal$|^review$", this.CMITimeLimit = "^exit$|^message$|^continue$|^no message$", this.CMIRequest = "^true$|^false$|^unknow$", this.CFLEA_children = new Array("comment", "location", "timestamp"), this.CMICFLReg_one = "^cmi.comments_from_learner.(.{1,20}).(comment|location|timestamp)$", this.CMICFLReg_two = "^cmi.comments_from_lms.(.{1,20}).(comment|location|timestamp)$", this.CMIInter_children = new Array("id", "type", "objectives", "timestamp", "correct_responses", "weighting", "learner_resposne", "result", "latency", "description"), this.CMIINTERReg = "^cmi.interactions.(.{1,20}).(id|type|objectives|timestamp|correct_responses|weighting|learner_resposne|result|latency|description)$", this.CMIPrefer_children = new Array("", "language", "delivery_speed", "audio_captioning"), this.CMIObject_children = new Array("id", "score", "success_status", "completion_status", "progress_measure", "description"), this.CMIObjectReg = "^cmi.objectives.(.{1,20}).(id|success_status|score.(scaled|raw|min|max)|completion_status|progress_measure|description)$", this.CMIScore_children = new Array("scaled", "raw", "min", "max"), this.errorCode = "0", this.Initialized = !1, this.Terminated = !1, this.server_array = new Array, this.dataModeName_array = new Array, this.saveUserSetData = new Array;
    var dataModel = scorm_model_init("cmi._version", "scorm 2004 3rd", this.CMIString200, "R");
    this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.comments_from_learner._count", "", this.CMIInteger, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.comments_from_learner._children", this.CFLEA_children, "", "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.comments_from_learner.n.comment", "", this.CMIString4000, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.comments_from_learner.n.location", "", this.CMIString250, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.comments_from_learner.n.timestamp", "", this.CMITime, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.comments_from_lms._count", "", this.CMIInteger, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.comments_from_lms._children", this.CFLEA_children, "", "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.comments_from_lms.n.comment", "", this.CMIString4000, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.comments_from_lms.n.location", "", this.CMIString250, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.comments_from_lms.n.timestamp", "", this.CMITime, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.completion_status", "", this.CMICStudyTatus, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.completion_threshold", "", this.CMIDotNumber, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.credit", "", this.CMICredit, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.entry", "", this.CMIEntry, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.exit", "", this.CMIExit, "W"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions._count", "", this.CMIInteger, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions._children", this.CMIInter_children, "", "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.id", "", this.CMIString4000, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.type", "", this.CMIType, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.objectives._count", "", this.CMIInteger, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.objectives.n.id", "", this.CMIString4000, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.timestamp", "", this.CMITime, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.correct_responses._count", "", this.CMIInteger, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.correct_responses.n.pattern", "", "", "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.weighting", "", this.CMIDecimal, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.learner_response", "", "", "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.result", "", this.CMIResult, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.latency", "", "", "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.interactions.n.description", "", this.CMIString250, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.launch_data", "", this.CMIString4000, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.learner_id", "", this.CMIString4000, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.learner_name", "", this.CMIString4000, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.learner_preference._children", this.CMIPrefer_children, "", "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.learner_preference.audio_level", "", this.CMIDecimal, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.learner_preference.language", "", this.CMILangString250, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.learner_preference.delivery_speed", "", this.CMIDecimal, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.learner_preference.audio_captioning", "", this.CMICaption, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.location", "", this.CMIString1000, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.location_next", "", this.CMIString1000, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.max_time_allowed", "", "", "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.mode", "", this.CMIMode, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.objectives._children", this.CMIObject_children, "", "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.objectives._count", "", this.CMIInteger, "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.objectives.n.id", "", this.CMIString4000, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.objectives.n.score._children", this.CMIScore_children, "", "R"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.objectives.n.score.scaled", "", "", "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.objectives.n.score.raw", "", this.CMIDecimal, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.objectives.n.score.min", "", this.CMIDecimal, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.objectives.n.score.max", "", this.CMIDecimal, "RW"), this.dataModeName_array.push(dataModel), dataModel = scorm_model_init("cmi.objectives.n.success_status", "", this.CMISStatus, "RW"), this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.objectives.n.completion_status", "", this.CMICStudyTatus, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.objectives.n.progress_measure", "", this.CMIDotNumber, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.objectives.n.description", "", this.CMIString250, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.progress_measure", "", this.CMIDotNumber, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.scaled_passing_score", "", this.CMIDotNumbersub, "R"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.score._children", "", this.CMIScore_children, "R"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.score.scaled", "", this.CMIDotNumbersub, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.score.raw", "", this.CMIDecimal, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.score.min", "", this.CMIInteger, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.score.max", "", this.CMIInteger, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.session_time", "", this.CMISessionTime, "W"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.success_status", "", this.CMISStatus, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.suspend_data", "", this.CMIString64000, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.time_limit_action", "", this.CMITimeLimit, "R"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("cmi.total_time", "", this.CMIInteger, "R"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("adl.nav.request", "", this.NAVEvent, "RW"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("adl.nav.request_valid.continue", "", this.CMIRequest, "R"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("adl.nav.request_valid.previous", "", this.CMIRequest, "R"),this.dataModeName_array.push(dataModel),dataModel = scorm_model_init("adl.nav.request_valid.choice", "", this.CMIRequest, "R"),this.dataModeName_array.push(dataModel),this.scorm_timer = function () {
        var e = scorm_object_interval.Commit("");
        e == "false" && scorm_object_interval.IntervalObject && clearInterval(scorm_object_interval.IntervalObject)
    },this.init_function = function (data) {
        data = eval(data);
        last_session_time = null;

        //if (data.length <= 2) {
        //    data = eval(data);
        //    for (var one in data)
        //        for (var key in data[one]) errorAPI("var key in data[one]" + key + "=" + data[one][key]), scorm_object_interval.SetValue(key, data[one][key])
        //}
        if (data.length == 1) {
            data = eval(data);
            for (var one in data)
            {
                for (var key in data[one])
                {
                    errorAPI("var key in data[one]" + key + "=" + data[one][key]), study_process_id =  data[one][key] ;
                }
            }
        }
        else{

            data = eval(data);
            for (var one in data)
            {
                for (var key in data[one])
                {
                    if (key == "study_process_id") {
                        errorAPI("var key in data[one]" + key + "=" + data[one][key]), study_process_id =  data[one][key] ;
                    }
                    else {
                        errorAPI("var key in data[one]" + key + "=" + data[one][key]), scorm_object_interval.SetValue(key, data[one][key]);
                    }
                }
            }
            // for (var one in data)for (var key in data[one])errorAPI("var key in data[one]" + key + "=" + data[one][key]), scorm_object_interval.SetValue(key, data[one][key])
        }
    },this.Initialize = function (e) {
        debugAPI("start sending!"), errorAPI("Initialize param" + e), this.errorCode = "0";
        knowleageId = init_knowleageId;
        if (e == "") {
            errorAPI("uuuuuuuuuuuuuuuuuuu====" + !this.Initialized + "    " + this.Terminated),
                errorAPI("this.Initialized " + this.Initialized),
                this.Initialized = !0;
            if (this.Initialized) {
                var t = this.GetValue("cmi.location_next");
                debugAPI("yyyyyyyyyyyyyyyyyyyddddyyyyyyycmiLocation==" + t);
                var n = null;
                // 有URL才发送请求
                if (this.InitDataModelUrl) {
                    this.CommitAjaxMethod(this.InitDataModelUrl, t, this.init_function);
                }
                return errorAPI("-----------------------cmiLocation: " + t)
                    , this.errorCode = "0", "true"
            }
            this.Initialized ? this.errorCode = "104" : this.errorCode = "103"
        } else this.errorCode = "201";
        return "false"
    },this.Terminate = function (e) {
        this.errorCode = "0", this.Terminated = !0, errorAPI("this.Terminate param" + e), errorAPI("over-------------------  " + this.Initialized && this.Terminated);
        if (e == "") {
            if (this.Initialized && this.Terminated)return errorAPI("terminate is run!!!"), errorAPI("cmi.location " + this.GetValue("cmi.location") + " : " + "cmi.session_time: " + this.GetValue("cmi.session_time")), this.Commit(""), this.Initialized = !1, this.Terminated = !1, "true";
            this.Terminated ? this.errorCode = "113" : this.errorCode = "112"
        } else this.errorCode = "201";
        return "false"
    },this._validateDataElementExistSub = function (e) {
        var t = this.dataModeName_array;
        for (var n = 0; n < t.length; n++) {
            var r = t[n];
            if (r.name == e)return r
        }
        return null
    },this._validateDataElementExist = function (element) {
        var element_obj = this._validateDataElementExistSub(element);
        if (element_obj != null)return element_obj;
        var child_array = new Array(this.CMICFLReg_one, this.CMICFLReg_two, this.CMIINTERReg, this.CMIObjectReg);
        for (var i = 0; i < child_array.length; i++) {
            var CFL_Reg = new RegExp(child_array[i], "gi"), name = element.match(CFL_Reg);
            if (name != null) {
                element = name;
                var replaceReg = "/" + RegExp.$1 + "/gi";
                replaceReg = eval(replaceReg), name = name.toString().replace(replaceReg, "n");
                var exist_obj = this._validateDataElementExistSub(name);
                if (exist_obj != null) {
                    var format_reg = exist_obj.format, model = exist_obj.model;
                    return scorm_model_init(element, "", format_reg, model)
                }
            }
        }
        return null
    },this.GetValue = function (e) {
        errorAPI("this.Terminated " + this.Terminated);
        var t = this.saveUserSetData;
        for (var n = 0; n < t.length; n++)if (t[n].name == e)return t[n].value;
        var r = this._validateDataElementExist(e);
        if (r != null)return r.defaultvalue
    },this._validateDataModelElement = function (e, t) {
        var n = this._validateDataElementExist(e);
        if (n != null) {
            var r = n.format;
            if (n.name == e) {
                if (r != "") {
                    var i = new RegExp(r, "gi");
                    t = new String(t);
                    var s = i.test(t);
                    return s ? n.model.indexOf("W") != -1 ? "success" : "ReadOnly" : "formatError"
                }
                return "noFormat"
            }
        }
        return "elementNotFound"
    },this.detectionSaveUserSetData = function (e, t) {
        debugAPI("state:　" + t), debugAPI("element:　" + e);
        var n = new Array;
        for (var r = 0; r < this.saveUserSetData.length; r++) {
            var i = this.saveUserSetData[r];
            i.name != e && t && n.push(i)
        }
        this.saveUserSetData.length = 0, this.saveUserSetData = n
    },this.SetValue = function (e, t) {
        errorAPI("this.GetValue sessionTime: ===" + this.GetValue("cmi.session_time")), errorAPI("this.SetValue: ===" + e + " " + t + " !this.Terminated =" + !this.Terminated), e = e.toString().trim();
        var n = this._validateDataModelElement(e, t);
        errorAPI("this.SetValue : state: " + n);
        switch (n) {
            case"success":
                this.detectionSaveUserSetData(e, !0);
                var r = new user_data_model;
                r.name = e, r.value = t, r.model = "RW", errorAPI("this.saveUserSetData.push(user_data): " + e + "  " + t), this.saveUserSetData.push(r);
                break;
            case"ReadOnly":
                debugAPI(this.GetErrorString("404"));
                break;
            case"formatError":
                debugAPI(e), debugAPI(this.GetErrorString("406"));
                break;
            case"noFormat":
                debugAPI("noFormat");
                break;
            case"elementNotFound":
                debugAPI(this.GetErrorString("402"))
        }
        return n == "success" ? "true" : "false"
    },this.GetDiagnostic = function (e) {
        debugAPI("api is have!!")
    },this.PackagPostData = function () {
        var e = "{", t = this.saveUserSetData;
        for (var n = 0; n < t.length; n++) {
            var r = new RegExp("^RW$|^W$", "gi");
            r.test(t[n].model) && (e += "'" + t[n].name + "':'" + t[n].value + "'", n < t.length - 1 && (e += ","))
        }
        return e += "}", debugAPI("param_str: " + e), e
    },this.CommitAjaxMethod = function (e, t, n) {
        errorAPI("CommitAjaxMethod:　" + t + "  url=     " + e);
        var r = this.GetValue("cmi.location_next");
        var session_time = this.GetValue("cmi.session_time");
        if (pauseSecond%60 > 50) {
            pauseTime = pauseSecond/60 + 1;
        } else {
            pauseTime = pauseSecond/60
        }
        r != undefined && (this.SetValue("cmi.location", r), errorAPI("location_next: " + r)), $.ajax({
            type: "get",
            url: e,
            //dataType: "jsonp",
            //jsonp: "jsonpcallback",
            data: {data: t,studyProcessId:study_process_id,knowleageId:knowleageId,lastChapterId:lastChapterId,lastSessionTime:last_session_time,beginDate:new Date().pattern("yyyy-MM-dd HH:mm:ss"),endDate:new Date().pattern("yyyy-MM-dd HH:mm:ss"),pauseTime:pauseTime},
            beforeSend: function (e) {
            },
            success: function (e, t) {
                last_knowleageId = knowleageId;
                last_session_time = session_time;
                $.ajax({
                    type: "POST",
                    url:"/ynedut/lmsportal/scormzz/getInterStudyDetail.htm?teachingPlanId="+teachingPlanId+
                    "&resourceId="+(scormCourseId?scormCourseId:"")+"&platformUserId="+userId+"&knowledgeId="+knowleageId+"&teachClassId="+teachClassId+"&sourceType="+sourceType,
                    // 4 fileType 需要设置
                    dataType: "json",
                    contentType: "application/json",
                    success: function (data) {
                        if(!data.result.alreadyStudyNumber){
                            data.result.alreadyStudyNumber=0;
                        }
                        document.getElementById("study").innerHTML=data.result.alreadyStudyNumber+"分钟";
                    }
                });
                debugAPI("=========" + e), responseText = e, n != undefined && n(e)
            },
            complete: function (e, t) {
            },
            error: function (e) {
                log.error(e)
            }
        })
    },this.Commit = function (e) {
        this.Terminated = !0, this.errorCode = "0";
        if (e == "") {
            if (this.Initialized && this.Terminated) {
                var t = this.PackagPostData();
                knowleageId = last_knowleageId;
                // 如果有URL，才发送请求
                if (this.PostDataUrl) {
                    this.CommitAjaxMethod(this.PostDataUrl, t)
                }
                return "true";
            }
            this.Terminated ? this.errorCode = "143" : this.errorCode = "142"
        } else this.errorCode = "201";
        return "false"
    },this.GetLastError = function () {
        return this.GetErrorString(this.errorCode)
    },this.GetErrorString = function (e) {
        var t = "";
        if (e != "") {
            switch (e) {
                case"0":
                    t = "No error";
                    break;
                case"101":
                    t = "General exception";
                    break;
                case"102":
                    t = "General Inizialization Failure";
                    break;
                case"103":
                    t = "Already this.Initialized";
                    break;
                case"104":
                    t = "Content Instance this.Terminated";
                    break;
                case"111":
                    t = "General Termination Failure";
                    break;
                case"112":
                    t = "Termination Before Inizialization";
                    break;
                case"113":
                    t = "Termination After Termination";
                    break;
                case"122":
                    t = "Retrieve Data Before Initialization";
                    break;
                case"123":
                    t = "Retrieve Data After Termination";
                    break;
                case"132":
                    t = "Store Data Before Inizialization";
                    break;
                case"133":
                    t = "Store Data After Termination";
                    break;
                case"142":
                    t = "Commit Before Inizialization";
                    break;
                case"143":
                    t = "Commit After Termination";
                    break;
                case"201":
                    t = "General Argument Error";
                    break;
                case"301":
                    t = "General Get Failure";
                    break;
                case"351":
                    t = "General Set Failure";
                    break;
                case"391":
                    t = "General Commit Failure";
                    break;
                case"401":
                    t = "Undefinited Data Model";
                    break;
                case"402":
                    t = "Unimplemented Data Model Element";
                    break;
                case"403":
                    t = "Data Model Element Value Not this.Initialized";
                    break;
                case"404":
                    t = "Data Model Element Is Read Only";
                    break;
                case"405":
                    t = "Data Model Element Is Write Only";
                    break;
                case"406":
                    t = "Data Model Element Type Mismatch";
                    break;
                case"407":
                    t = "Data Model Element Value Out Of Range";
                    break;
                case"408":
                    t = "Data Model Dependency Not Established"
            }
            return t
        }
        return "unexpected exceptions"
    }
}