/**
 * Created by hejiao on 2018/11/2.
 */
(function () {
    'use strict';

    angular
      .module('starter')
      .config(config)
      .directive(directive)
      .directive("selectUserByNameLike", selectUserByNameLike)
      .controller("taskListController", taskListController)
      .controller("taskUnderwayController", taskUnderwayController)
      .controller("taskOverController", taskOverController)
      .controller("taskNotBeginningController", taskNotBeginningController)
      .controller("missingExaminationController", missingExaminationController)
      .controller("registerCheatController", registerCheatController)
      .controller("registerPhotoController", registerPhotoController)
      .controller("examinationConditionController", examinationConditionController)
      .controller("retestStudentConfirmController", retestStudentConfirmController)
      .controller("invigilateOnLineController", invigilateOnLineController)
      .controller("registerNotTaskCtrl", registerNotTaskCtrl)
    ;

    var  myInterval="";

    config.$inject = ['$stateProvider', '$urlRouterProvider'];

    function config($stateProvider, $urlRouterProvider) {
        $stateProvider
          //监考任务列表
          .state('task_list', {
              url: '/task_list',
              templateUrl: 'templates/invigilateTask/task_list.html',
              data: {
                  micro: true,
                  title: '监考任务'
              },
              cache:false
          })
          //进行中的任务
          .state('task_underway', {
              url: '/task_underway',
              templateUrl: 'templates/invigilateTask/task_underway.html',
              cache:false,
              data: {
                  title: '校内监考任务',
                  prev: 'task_list'
              }
          })
          //未开始的任务
          .state('task_notBeginning', {
              url: '/task_notBeginning',
              templateUrl: 'templates/invigilateTask/task_notBeginning.html',
              cache:false,
              data: {
                  title: '校内监考任务',
                  prev: 'task_list'
              }
          })
          //已结束的任务
          .state('task_over', {
              url: '/task_over',
              templateUrl: 'templates/invigilateTask/task_over.html',
              // controller: 'taskListController',
              cache:false,
              data: {
                  title: '校内监考任务',
                  prev: 'task_list'
              }
          })
          //登记缺考
          .state('missing_examination', {
              url: '/missing_examination',
              templateUrl: 'templates/invigilateTask/missing_examination.html',
              cache:false,
              data: {
                  title: '校内监考任务',
                  prev: 'task_underway'
              }
          })
          //考试情况
          .state('examination_condition', {
              url: '/examination_condition',
              templateUrl: 'templates/invigilateTask/examination_condition.html',
              cache:false,
              data: {
                  title: '校内监考任务',
                  prev: 'task_underway'
              }
          })
          //登记作弊学生
          .state('register_cheat', {
              url: '/register_cheat',
              templateUrl: 'templates/invigilateTask/register_cheat.html',
              cache:false,
              data: {
                  title: '校内监考任务',
                  prev: 'task_underway'
              }
          })
          //登记作弊学生 照片
          .state('register_photo', {
              url: '/register_photo',
              templateUrl: 'templates/invigilateTask/register_photo.html',
              cache:false,
              data: {
                  title: '校内监考任务',
                  prev: 'task_underway'
              }
          })
          //进入在线监考页面
          .state('invigilate_onLine', {
              url: '/invigilate_onLine',
              templateUrl: 'templates/invigilateTask/invigilate_onLine.html',
              data: {
                  title: '校内监考任务',
                  prev: 'task_list'
              },
              cache:false
          })
          //社会考试监考任务列表
          .state('socialExamTask', {
              url: '/socialExamTask',
              templateUrl: 'templates/invigilateTask/socialExamTask.html',
              data: {
                  micro: true,
                  title: '监考任务'
              },
              cache: false
          })
          // 没有监考任务的登记
          .state('registerNotTask', {
              url: '/registerNotTask',
              templateUrl: 'templates/invigilateTask/register_not_task.html',
              data: {
                  title: '无监考任务登记',
                  prev: 'task_list'
              },
              controller: 'registerNotTaskCtrl',
              controllerAs: 'vm'
          });
        $urlRouterProvider.otherwise('/task_list');
    }

    function directive() {
        return {
            restrict: "AE",

            // 设置模板路径
            templateUrl: function (tElement, tAttrs) {
                return "templates/invigilateTask/selectedStuViewer.html";
            },
            controller: ["$scope", "$http", "$filter", "storageService", function ($scope, $http, $filter, storageService) {
                /**
                 * 移除已选中的学生
                 * @param id
                 */
                $scope.removeStu = function (stu) {
                    angular.forEach($scope.studentList,function (info) {
                        if(stu.stuId === info.stuId){
                            info.selected = false;
                        }
                    });

                    // 移除已选中学生
                    angular.forEach($scope.seleectArr,function (value,index) {
                        if(stu.stuId === value.stuId){
                            $scope.seleectArr.splice(index, 1);
                        }
                    });

                    // 及时放入缓存
                    storageService.setItem("selectedStuList", $scope.seleectArr);

                };
            }]
        };
    }

    /**
     * 监考任务列表
     */
    taskListController.$inject = ['$scope','$http','$location','ynuiNotification','storageService',"$ionicScrollDelegate","$interval","$timeout"];
    function taskListController($scope,$http,$location,ynuiNotification,storageService,$ionicScrollDelegate,$interval,$timeout){
        //待办直接跳转
        var upComingGoId = $location.search().upComingGoId;
        // 路由信息
        var basePath = originBaseUrl + "/third/kwglTeacherInvigilate";
        var isBack = $location.search().isBack;
        $scope.getActive = getActive;
        $scope.getTaskList = getTaskList;
        $scope.findPlanTerm = findPlanTerm;
        $scope.changeTable = changeTable;
        $scope.choosePlan = choosePlan;
        $scope.goToDetail = goToDetail;
        $scope.getLableClass = getLableClass;
        $scope.getdivClass = getdivClass;
        $scope.getShowCourse = getShowCourse;
        $scope.getShowStuTotal = getShowStuTotal;
        if(myInterval){
            $interval.cancel(myInterval);
        }
        function getShowStuTotal(info) {
            // 获取总的参考人数
            var total = 0 ;
            if(info.kwglpKcourseVOS && info.kwglpKcourseVOS.length > 0){
                angular.forEach(info.kwglpKcourseVOS,function (info) {
                    total += Number(info.confirmNum);
                });
            }
            return total;
        }

        function getShowCourse(info) {
            var list = [];
            if(info.kwglpKcourseVOS && info.kwglpKcourseVOS.length > 0){
                angular.forEach(info.kwglpKcourseVOS,function (data) {
                    var str = data.pkCourseName;
                    if(data.kwglExamWayStr){
                        str+= "（"+data.kwglExamWayStr+"）";
                    }
                    list.push(str);
                });
            }
            return list.join("、")
        }

        // table显示
        var oldPlanShowInfo = storageService.getItem("planShowInfo");
        if(oldPlanShowInfo){
            $scope.planShowInfo = oldPlanShowInfo;
        }else{
            $scope.planShowInfo = {
                name:"",
                tableOneNumber:0,
                tableTwoNumber:0,
                tableThreeNumber:0,
                tableFourNumber:0
            };
        }
        // 任务列表
        $scope.taskList = [];
        // 默认没有数据
        $scope.showFlag = false;

        var oldActiveObj = storageService.getItem("activeObj");
        if(oldActiveObj){
            $scope.active = oldActiveObj.active;
        }else {
            $scope.active = 'two';
        }
        var taskMapListIds=[];
        if($scope.active=='four'){
            taskMapListIds=storageService.getItem("taskMapListIds");
        }
        // 查询条件
        var oldSearchInfo = storageService.getItem("searchInfo");
        if(oldSearchInfo){
            $scope.searchInfo = oldSearchInfo;
            getTaskList($scope.searchInfo.id);
        }else {
            $scope.searchInfo = {
                id:""
            };
            // 获取初始数据
            findPlanTerm();
        }

        // 获取计划考试学期
        function findPlanTerm() {
            $scope.planTermList="";
            $http.post(basePath+"/findPlanTerm.htm").success(function (data) {
                if(data.status == 0){
                    if(data.result.currentTerm){
                        $scope.planTermList=data.result.currentTerm;
                    }else if(data.result.preTerm){
                        $scope.planTermList=data.result.preTerm;
                    }else if(data.result.nextTerm){
                        $scope.planTermList=data.result.nextTerm;
                    }
                    if(!$scope.planTermList){
                        return;
                    }
                    $scope.searchInfo.id=$scope.planTermList.id;
                    $scope.planShowInfo.name=$scope.planTermList.name;
                    getTaskList($scope.searchInfo.id);
                }
            });
        }

        // 监考登记信息
        function getTaskList(id) {
            $scope.loading=false;
            $http.post(basePath+"/findKWGLRegistrationInfo.htm",{planId:id}).success(function (data) {
                if(data.status == 0){
                    $scope.loading=true;
                    $scope.today = angular.copy(data.result.today);
                    $scope.planShowInfo.tableTwoNumber = $scope.today.length;
                    $scope.tomorrow = angular.copy(data.result.tomorrow);
                    $scope.planShowInfo.tableThreeNumber = $scope.tomorrow.length;
                    $scope.all = angular.copy(data.result.all);
                    $scope.planShowInfo.tableOneNumber = $scope.all.length;
                    if($scope.planShowInfo.tableOneNumber > 0){
                        $scope.showFlag = true;
                    }
                    // 默认数据显示处理
                    if(isBack){
                        if($scope.active=='one'){
                            $scope.taskList = $scope.all;
                        }else if($scope.active=='two'){
                            $scope.taskList = $scope.today;
                        }else if($scope.active=='three'){
                            $scope.taskList = $scope.tomorrow;
                        }
                    }else if($scope.today && $scope.today.length > 0){
                        $scope.taskList = $scope.today;
                        $scope.active = 'two';
                    }else if($scope.tomorrow && $scope.tomorrow.length > 0){
                        $scope.taskList = $scope.tomorrow;
                        $scope.active = 'three';
                    }else {
                        $scope.taskList = $scope.all;
                        $scope.active = 'one';
                    }
                    var map=new Map();
                    $scope.all.forEach(function(item){
                        // var forDate=new Date(item.startTime);
                        var forDate = moment(item.startTime);
                        var key=forDate.format('YYYY-MM-DD');
                        key+=" "+weekday[forDate.day()];
                        var taskList=map.get(key);
                        if(!taskList){
                            taskList=[];
                            map.put(key,taskList);
                        }
                        taskList.push(item);
                    });
                    $scope.taskMapList=[];
                    $scope.taskMap=map;
                    angular.forEach(map.keySet(),function(key){
                        $scope.taskMapList.push({id:key,isCurrent:key==$scope.serverTime,total:map.get(key).length,isChecked:taskMapListIds.indexOf(key)>-1});
                    })
                    $scope.taskMapList.sort(function(a1,a2){
                        return a2.id.localeCompare(a1.id);
                    })
                    if(taskMapListIds.length>0){
                        $scope.searchDay();
                    }
                    if(upComingGoId){
                        for (var i = 0; i < $scope.all.length; i++) {
                            var info  =$scope.all[i];
                            if(info.upComingGoId==upComingGoId){
                                goToDetail(info.termState,info);
                                upComingGoId =null;
                            }
                        }
                    }
                }
            });
        }

        // 详情操作页面
        function goToDetail(status,info) {
            if($scope.active=='four'){
                taskMapListIds=[];
                $scope.taskMapList.forEach(function(item){
                    if(item.isChecked){
                        taskMapListIds.push(item.id);
                    }
                })
                storageService.setItem("taskMapListIds",taskMapListIds);
            }
            storageService.setItem("activeObj",{active:$scope.active});
            if(info.examInfoId){
                //跳转到在线监考页面
                if(info.examType==4){
                    yn.plugin.yncordova.nativeStart({
                        target: '105',
                        params:{url:'/wjs/app/#/redirect?wjs_page_code=wjs_invigilation_index&planId='+ info.examInfoId}
                    });
                } else {
                    $location.path("/invigilate_onLine").search({examInfoId:info.examInfoId,id:info.planId,examType:info.examType,courseAdminClassIds:info.classAllIds,kwglPlanClassRoomId:info.kwglPlanClassRoomId});
                }

            }else{
                storageService.setItem("searchInfo",$scope.searchInfo);
                storageService.setItem("planShowInfo",$scope.planShowInfo);
                storageService.setItem("mainInfo",info);
                //未登记且不能登记时
                if('未开始' == status || ('未登记' == info.isRegistrationStr && !info.canRegister)){
                    //未登记且不能登记
                    $location.path("/task_notBeginning").search({});
                }else if('已登记' == info.isRegistrationStr){
                    $location.path("/task_over").search({});
                }else{
                    //未登记且可以登记
                    storageService.setItem("task_underway_type",1);
                    //是否是补考数据
                    storageService.setItem("isRetest",info.termTypeStr=='补考'?'1':'0');
                    $location.path("/task_underway").search({});
                }
            }
            setTimeout(function () {
               $scope.$apply();
            });
        }


        // 计划学期选择
        function choosePlan(info) {
            $scope.searchInfo.id = angular.copy(info.id);
            $scope.planShowInfo.name = info.name;
            // 重新获取 登记信息
            getTaskList(info.id);
        }
        var weekday=["星期日","星期一","星期二","星期三","星期四","星期五","星期六"];
        // table 切换
        function changeTable(type) {
            $ionicScrollDelegate.$getByHandle('listScroll').scrollTo(0,1,true);
            if(type!='four'){
                angular.forEach($scope.taskMapList,function(item){
                    item.isChecked=false;
                })
            }
            switch (type){
                case 'one':
                    $scope.taskList = $scope.all;
                    break;
                case 'two':
                    $scope.taskList = $scope.today;
                    break;
                case 'three':
                    $scope.taskList = $scope.tomorrow;
                    break;
                case 'four':
                    break;
                default:break;
            }
            $scope.active = type;
        }
        $scope.searchDay=function(info){
            if(info){
                info.isChecked=!info.isChecked;
            }
            $timeout(function(){
                $scope.taskList=[];
                angular.forEach($scope.taskMapList,function(item){
                    if(item.isChecked){
                        angular.forEach($scope.taskMap.get(item.id),function(task){
                            $scope.taskList.push(task);
                        })
                    }
                })
                $scope.taskList.sort(function(s1,s2){
                    if(s1.orderValue==s2.orderValue){
                        return s1.examTime.localeCompare(s2.examTime);
                    }
                    return s1.orderValue.toString().localeCompare(s2.orderValue.toString());
                })
            },50);
        }
        /**
         * 获取系统时间
         */
        function findCurrentTime() {
            $http.get(originBaseUrl + "/third/kwglTeacherInvigilate/findCurrentTimeAndUser.htm?patterns=yyyy-MM-dd HH:mm&loading=disabled&date="+new Date())
              .success(function (data) {
                  var forDate = moment(data.result.currentTime);
                  $scope.serverTime = forDate.format('YYYY-MM-DD');
                  $scope.serverTime+=" "+weekday[forDate.day()];
              });
        }
        findCurrentTime();
        //选中样式
        function getActive(info) {
            if(info.id === $scope.searchInfo.id){
                return 'active';
            }
        }

        //登记样式
        function getLableClass(style) {
            switch (style){
                case '未登记':return 'help-inline text-danger';
                default:return 'help-inline green-c';
            }
        }

        //登记状态样式
        function getdivClass(style) {
            switch (style){
                case '进行中':return 'label-orange';
                case '未开始':return 'label-green';
                default:return 'label-gray';
            }
        }
        /**
         * 返回
         */
        $scope.goBack = function() {
            yn.plugin.yncordova.close();
        }

        $scope.toSocialExamTask = toSocialExamTask;

        /**
         * 跳转到社会考试监考页面
         */
        function toSocialExamTask() {
            $location.path("/socialExamTask");
        }

        /**
         * 跳转无监考任务的登记页面
         */
        $scope.toRegisterNotTaskPage = toRegisterNotTaskPage;
        function toRegisterNotTaskPage() {
            $location.path("/registerNotTask");
        }
    }

    /**
     * 进行中的任务
     */
    taskUnderwayController.$inject = ['$scope','$http','$location','ynuiNotification','storageService','$ionicScrollDelegate'];
    function taskUnderwayController($scope,$http,$location,ynuiNotification,storageService,$ionicScrollDelegate){
        // 路由信息
        var basePath = originBaseUrl + "/third/kwglTeacherInvigilate";

        var taskUnderwayType = storageService.getItemNoDel("task_underway_type");
        //是不是补考数据
        $scope.isRetest = storageService.getItemNoDel("isRetest")==1?true:false;

        $scope.backList = backList;
        $scope.updateStu = updateStu;
        $scope.updateList = updateList;
        $scope.goToPhoto = goToPhoto;
        $scope.changeTable = changeTable;
        $scope.changeShowOrHide = changeShowOrHide;
        $scope.getdivClass = getdivClass;
        $scope.getExaminationSituation = getExaminationSituation;
        $scope.findKWGLRegistrationInfoDetail = findKWGLRegistrationInfoDetail;

        // 主列表信息
        var mainInfo = storageService.getItemNoDel("mainInfo");
        $scope.showInfo = angular.copy(mainInfo);
        // 获取总的参考人数
        var total = 0 , courseNameList = [];
        angular.forEach($scope.showInfo.kwglpKcourseVOS,function (info) {
            total += Number(info.confirmNum);
            courseNameList.push(info.pkCourseName);
        });
        $scope.showInfo.total = total;
        $scope.showInfo.courseNameShow = courseNameList.join("、");


        // table 切换
        function changeTable(type) {
            $scope.showCoursename='';
            $ionicScrollDelegate.scrollTop();
            switch (type){
                case 1:
                    $scope.activeOne = true;
                    $scope.activeTwo = false;
                    break;
                case 2:
                    $scope.activeOne = false;
                    $scope.activeTwo = true;
                    break;
                default:break;
            }
        }
        $scope.showCoursename='';
        function changeShowOrHide(name) {
            if(name== $scope.showCoursename){
                $scope.showCoursename='';
            }else{
                $scope.showCoursename=name;
            }
            //延后是用来生成滚动条的。
            if($scope.showCoursename){
                $ionicLoading.show();
                $timeout(function () {
                    $ionicLoading.hide();
                },1000)
            }
        }

        function findKWGLRegistrationInfoDetail() {
            var searchInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: mainInfo})};
            $http.post(basePath+"/findKWGLRegistrationInfoDetail.htm",searchInfo).success(function (data) {
                if(data.status == 0){
                    $scope.showDetailInfo = angular.copy(data.result);
                    $scope.activeOne = true;
                    $scope.activeTwo = false;
                }else {
                    ynuiNotification.error({msg: "获取数据失败！"});
                }
            });
        }

        // 考试情况
        function getExaminationSituation() {
            $location.path("/examination_condition").search({});
        }

        // 异常登记
        function updateStu(type) {
            if(type === 1){
                var oldSelect = [];
                if($scope.showDetailInfo.absentStudentList && $scope.showDetailInfo.absentStudentList.length > 0){
                    angular.forEach($scope.showDetailInfo.absentStudentList,function (info) {
                        oldSelect.push(info.id);
                    });
                }
                // 登记缺考
                $location.path("/missing_examination").search({oldSelect:oldSelect});
            }else {
                // 登记作弊
                $location.path("/register_cheat").search({});
            }
        }

        function goToPhoto(info) {
            storageService.setItem("register_cheat",info);
            $location.path("/register_photo").search({type:1});
        }

        // 提交
        function updateList() {
            if(mainInfo.registrationId){
                $location.path("/task_list").search({isBack:true});
            }else {
                // 保存登记状态
                mainInfo.examRemark = $scope.showInfo.examRemark;
                var saveInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: mainInfo})};
                $http.post(basePath+"/addRegistrationInfo.htm",saveInfo).success(function (data) {
                    if(data.status == 0){
                        mainInfo.registrationId = data.result.failedId;
                        storageService.setItem("mainInfo",mainInfo);
                        $location.path("/task_list").search({isBack:true});
                    }else {
                        ynuiNotification.error({msg: "保存失败！"});
                    }
                });
            }


        }

        // 返回
        function backList() {
            var backPath = "task_over";
            if(taskUnderwayType && taskUnderwayType == 1){
                backPath = "task_list";
            }
            $location.path("/"+backPath).search({isBack:true});
        }

        //登记状态样式
        function getdivClass(style) {
            switch (style){
                case '进行中':return 'right-badge';
                case '未开始':return 'right-badge proceed';
                default:return 'right-badge over';
            }
        }


        findKWGLRegistrationInfoDetail();

    }

    /**
     * 已结束的任务
     */
    taskOverController.$inject = ['$scope','$http','$location','ynuiNotification','$ionicPopup','storageService'];
    function taskOverController($scope,$http,$location,ynuiNotification,$ionicPopup,storageService){
        // 路由信息
        var basePath = originBaseUrl + "/third/kwglTeacherInvigilate";

        $scope.backList = backList;
        $scope.deleteList = deleteList;
        $scope.updateList = updateList;
        $scope.getdivClass = getdivClass;
        $scope.findKWGLRegistrationInfoDetail = findKWGLRegistrationInfoDetail;
        // 主列表信息
        var mainInfo = storageService.getItemNoDel("mainInfo");
        $scope.showInfo = angular.copy(mainInfo);
        // 获取总的参考人数
        var total = 0 , courseNameList = [];
        angular.forEach($scope.showInfo.kwglpKcourseVOS,function (info) {
            total += Number(info.confirmNum);
            courseNameList.push(info.pkCourseName);
        });
        $scope.showInfo.total = total;
        $scope.showInfo.courseNameShow = courseNameList.join("、");

        function findKWGLRegistrationInfoDetail() {
            var searchInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: mainInfo})};
            $http.post(basePath+"/findKWGLRegistrationInfoDetail.htm",searchInfo).success(function (data) {
                if(data.status == 0){
                    $scope.showDetailInfo = angular.copy(data.result);
                    if($scope.showDetailInfo.cheatStudent && $scope.showDetailInfo.cheatStudent.length > 0){
                        angular.forEach($scope.showDetailInfo.cheatStudent,function (item) {
                            if(item.fsid && item.fsid.length > 0){
                                var fsList = [];
                                angular.forEach(item.fsid,function (val) {
                                    val = (originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + val);
                                    fsList.push(val);
                                });
                                item.fsid = fsList;
                            }
                        });
                    }

                }else {
                    ynuiNotification.error({msg: "获取数据失败！"});
                }
            });
        }

        //登记状态样式
        function getdivClass(style) {
            switch (style){
                case '进行中':return 'right-badge';
                case '未开始':return 'right-badge proceed';
                default:return 'right-badge over';
            }
        }


        function deleteList() {
            var confirmPopup =  $ionicPopup.confirm({
                title: "提示",
                template: "确定要删除该登记的监考信息吗？",
                cancelText: "取消",
                okText: "确定"
            });
            confirmPopup.then(function(flag){
                if(flag){
                    // 删除监考登记信息级联删除作弊学生学生图片文件
                    var saveInfo = {
                        registrationId : mainInfo.registrationId
                    };
                    var searchInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: saveInfo})};
                    $http.post(basePath+"/deleteKWGLRegistrationInfo.htm",searchInfo).success(function (data) {
                        if(data.status == 0){
                            backList();
                        }else {
                            ynuiNotification.error({msg: "删除该登记的监考信息失败！"});
                        }
                    });
                }
            });
        }

        // 修改
        function updateList() {
            // 跳转到 登记监考信息（进行中）
            storageService.setItem("task_underway_type",2);
            $location.path("/task_underway").search({});
        }

        // 返回
        function backList() {
            $location.path("/task_list").search({isBack:true});
        }


        // 获取初始数据
        findKWGLRegistrationInfoDetail();

    }

    /**
     * 未开始的任务
     */
    taskNotBeginningController.$inject = ['$scope','$http','$location','ynuiNotification','storageService'];
    function taskNotBeginningController($scope,$http,$location,ynuiNotification,storageService){
        // 路由信息
        var basePath = originBaseUrl + "/third/kwglTeacherInvigilate";

        $scope.backList = backList;
        $scope.getdivClass = getdivClass;
        $scope.findKWGLRegistrationInfoDetail = findKWGLRegistrationInfoDetail;

        // 主列表信息
        var mainInfo = storageService.getItemNoDel("mainInfo");
        $scope.showInfo = angular.copy(mainInfo);
        // 获取总的参考人数
        var total = 0 , courseNameList = [];
        angular.forEach($scope.showInfo.kwglpKcourseVOS,function (info) {
            total += Number(info.confirmNum);
            courseNameList.push(info.pkCourseName);
        });
        $scope.showInfo.total = total;
        $scope.showInfo.courseNameShow = courseNameList.join("、");

        function backList() {
            $location.path("/task_list").search({isBack:true});
        }

        function findKWGLRegistrationInfoDetail() {
            var searchInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: mainInfo})};
            $http.post(basePath+"/findKWGLRegistrationInfoDetail.htm",searchInfo).success(function (data) {
                if(data.status == 0){
                    $scope.showDetailInfo = angular.copy(data.result);
                }else {
                    ynuiNotification.error({msg: "获取数据失败！"});
                }
            });
        }

        //登记状态样式
        function getdivClass(style) {
            switch (style){
                case '进行中':return 'right-badge';
                case '未开始':return 'right-badge proceed';
                default:return 'right-badge over';
            }
        }

        findKWGLRegistrationInfoDetail();

    };

    /**
     * 登记缺考
     */
    missingExaminationController.$inject = ['$scope','$http','$location','storageService','ynuiNotification'];
    function missingExaminationController($scope,$http,$location,storageService,ynuiNotification){
        // 路由信息
        var basePath = originBaseUrl + "/third/kwglTeacherInvigilate";
        var oldSelect = $location.search().oldSelect;
        $scope.studentList = [];
        $scope.seleectArr = [];
        $scope.showSelectedStu = false;
        $scope.backList = backList;
        $scope.clearName = clearName;
        $scope.submitStudent = submitStudent;
        $scope.chooseStudent = chooseStudent;
        $scope.deleteSelectStu = deleteSelectStu;
        $scope.findMissingStudent = findMissingStudent;

        $scope.removeStu = function (stu) {
            angular.forEach($scope.studentList,function (info) {
                if(stu.stuId === info.stuId){
                    info.selected = false;
                }
            });

            // 移除已选中学生
            angular.forEach($scope.seleectArr,function (value,index) {
                if(stu.stuId === value.stuId){
                    $scope.seleectArr.splice(index, 1);
                }
            });

            // 及时放入缓存
            storageService.setItem("selectedStuList", $scope.seleectArr);

        };

        // 主列表信息
        var mainInfo = storageService.getItemNoDel("mainInfo");
        // 获取缺考学生
        function findMissingStudent(name) {
            if(name){
                mainInfo.nameOrNumber = name;
            }else {
                mainInfo.nameOrNumber = null;
            }
            mainInfo.type = 0;
            var searchInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: mainInfo})};
            $http.post(basePath+"/findAllStudent.htm",searchInfo).success(function (data) {
                if(data.status == 0){
                    $scope.studentList = data.result.content;
                    if($scope.studentList && $scope.studentList.length > 0){
                        angular.forEach($scope.studentList,function (student) {
                            if(student.headUrl){
                                student.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + student.headUrl;
                            }
                        });
                        // 默认选中
                        if(oldSelect && oldSelect.length > 0){
                            angular.forEach($scope.studentList,function (stu) {
                                angular.forEach(oldSelect,function (stuId) {
                                    if(stu.stuId == stuId){
                                        stu.selected = true;
                                    }
                                });
                            });
                        }
                        getViewList();
                    }
                }else {
                    $scope.studentList = [];
                }
            });
        }

        function chooseStudent(info) {
            if(info.selected){
                info.selected = false;
            }else {
                info.selected = true;
            }
            getViewList();
        }

        function getViewList() {
            var list = [];
            angular.forEach($scope.studentList,function (info) {
                if(info.selected){
                    list.push(info);
                }
            });
            $scope.seleectArr = list;
            storageService.setItem("selectedStuList",list);
        }


        function submitStudent() {
            var stuList = [];
            if($scope.seleectArr && $scope.seleectArr.length > 0){
                angular.forEach($scope.seleectArr,function (data) {
                    var item = {type:0,stuId:data.stuId};
                    stuList.push(item);
                });
            }
            // 保存缺考学生
            mainInfo.kwglCheatStudentsVOS = stuList;
            mainInfo.type = 0;
            var saveInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: mainInfo})};
            $http.post(basePath+"/addAbsentStudents.htm",saveInfo).success(function (data) {
                if(data.status == 0){
                    mainInfo.registrationId = data.result.failedId;
                    delete mainInfo.kwglCheatStudentsVOS ;
                    delete mainInfo.type;
                    storageService.setItem("mainInfo",mainInfo);
                    backList();
                }else {
                    ynuiNotification.error({msg: "保存失败！"});
                }
            });
        }

        function backList() {
            storageService.clearKey("selectedStuList");
            $location.path("/task_underway").search({});
        }


        function deleteSelectStu(info) {
            $scope.seleectArr.splice(info,1);
        }

        function clearName() {
            $scope.searchInfo.name = "";
        }


        findMissingStudent();

    }

    /**
     * 登记作弊学生
     */
    registerCheatController.$inject = ['$scope','$http','$location','storageService'];
    function registerCheatController($scope,$http,$location,storageService){
        // 路由信息
        var basePath = originBaseUrl + "/third/kwglTeacherInvigilate";

        $scope.cheatList = [];
        $scope.searchInfo = {name:""};
        $scope.selectStu = selectStu;
        $scope.findStudent = findStudent;
        $scope.backList = backList;
        $scope.clearName = clearName;
        // 主列表信息
        var mainInfo = storageService.getItemNoDel("mainInfo");

        /**
         * 获取作弊学生
         * @param name 学生名称、学号
         */
        function findStudent(name) {
            if(name){
                mainInfo.nameOrNumber = name;
            }else {
                mainInfo.nameOrNumber = null;
            }
            mainInfo.type = 1;
            var searchInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: mainInfo})};
            $http.post(basePath+"/findAllStudent.htm",searchInfo).success(function (data) {
                if(data.status == 0){
                    $scope.cheatList = data.result.content;
                    if($scope.cheatList && $scope.cheatList.length){
                        angular.forEach($scope.cheatList,function (student) {
                            if(student.headUrl){
                                student.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + student.headUrl;
                            }
                        });
                    }
                }else {
                    $scope.cheatList = [];
                }
            });
        }

        /**
         * 选择作弊学生
         * @param info 作弊学生
         */
        function selectStu(info) {
            storageService.setItem("register_cheat",info);
            $location.path("/register_photo").search({type:2});
        }

        function backList() {
            $location.path("/task_underway").search({});
        }

        function clearName() {
            $scope.searchInfo.name = "";
        }

        findStudent();

    }

    /**
     * 登记作弊学生 照片
     */
    registerPhotoController.$inject = ['$scope','$http','$location','$ionicPopup','ynuiNotification','storageService'
        , 'stringsConstant', '$cordovaFileTransfer', '$cordovaFile', '$timeout', '$filter','$ionicModal'];
    function registerPhotoController($scope,$http,$location,$ionicPopup,ynuiNotification,storageService, stringsConstant, $cordovaFileTransfer,
             $cordovaFile, $timeout,$filter,$ionicModal){
        // 路由信息
        var basePath = originBaseUrl + "/third/kwglTeacherInvigilate";
        // 主列表信息
        var mainInfo = storageService.getItemNoDel("mainInfo");

        $scope.showInfo = {
            remark:"",
            attachmentIds:[]
        };

        $scope.originBaseUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=";
        var type = $location.search().type;
        if(type && type == 1){
            var old = storageService.getItemNoDel("register_cheat");
            //班级显示处理
            var oldClassName = "";
            if(old.className){
                oldClassName = old.className.replace("【","").replace("】","");
            }
            if(old.headUrl){
                old.headUrl = ($scope.originBaseUrl + old.headUrl);
            }

            $scope.registerCheat = {
                headUrl:old.headUrl,
                nameAndNumber:old.name,
                className:oldClassName,
                courseName:"",
                attachmentIds:old.fsid,
                stuId:old.stuId
            };
            $scope.showInfo.remark = old.remark;
            $scope.showInfo.attachmentIds = old.fsid;

        }else {
            $scope.registerCheat = storageService.getItemNoDel("register_cheat");
        }

        if($scope.registerCheat.className){
            // 课程处理
            if(mainInfo.kwglpKcourseVOS && mainInfo.kwglpKcourseVOS.length > 0){
                angular.forEach(mainInfo.kwglpKcourseVOS,function (course) {
                    if(course.coursePlanTeachingAdminclassName == $scope.registerCheat.className){
                        $scope.registerCheat.courseName = course.pkCourseName;
                    }
                });
            }
        }


        $scope.deleteStu = deleteStu;
        $scope.submitStu = submitStu;
        $scope.submitCheat = submitCheat;
        $scope.goBack = goBack;
        $scope.findCurrentTimeAndUser = findCurrentTimeAndUser;

        /**
         *  删除学生作弊信息
         */
        function deleteStu() {
            var confirmPopup =  $ionicPopup.confirm({
                title: "提示",
                template: "确定要删除该学生登记的作弊信息吗？",
                cancelText: "取消",
                okText: "确定"
            });
            confirmPopup.then(function(result){
                if(result){
                    // 删除作弊学生级联删除图片文件
                    var saveData = {
                        registerId:mainInfo.registrationId,
                        stuId:$scope.registerCheat.stuId,
                        type:1
                    };
                    var saveInfo = {jsonData: angular.toJson({kwglCheatStudentsVO: saveData})};
                    $http.post(basePath+"/delCheatStudent.htm",saveInfo).success(function (data) {
                        if(data.status == 0){
                            $location.path("/task_underway").search({isBack:true});
                        }else {
                            ynuiNotification.error({msg: "删除失败！"});
                        }
                    });
                }
            });
        }

        /**
         * 提交
         */
        function submitStu() {
            // 判断新增
            if(mainInfo.registrationId){
                submitCheat();
            }else {
                var stuList = [{type:1,stuId:$scope.registerCheat.stuId}];
                // 保存作弊学生
                mainInfo.kwglCheatStudentsVOS = stuList;
                mainInfo.type = 1;
                var saveInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: mainInfo})};
                $http.post(basePath+"/addAbsentStudents.htm",saveInfo).success(function (data) {
                    if(data.status == 0){
                        mainInfo.registrationId = data.result.failedId;
                        delete mainInfo.kwglCheatStudentsVOS ;
                        delete mainInfo.type;
                        storageService.setItem("mainInfo",mainInfo);
                        submitCheat(data.result.failedReason);
                    }else {
                        ynuiNotification.error({msg: "保存失败！"});
                    }
                });
            }

        }

        // 提交照片等信息
        function submitCheat(id) {
            var saveData = {
                id:id,
                registerId:mainInfo.registrationId,
                stuId:$scope.registerCheat.stuId,
                type:1,
                remark:$scope.showInfo.remark,
                attachmentIds:$scope.showInfo.attachmentIds
            };

            var saveInfo = {jsonData: angular.toJson({kwglCheatStudentsVO: saveData})};
            $http.post(basePath+"/updateCheatStudent.htm",saveInfo).success(function (data) {
                if(data.status == 0){
                    $location.path("/task_underway").search({isBack:true});
                }else {
                    ynuiNotification.error({msg: "保存失败！"});
                }
            });
        }

        /**
         * 返回
         */
        function goBack() {
            storageService.clearKey("register_cheat");
            var backPath = "task_underway";
            if(type && type == 2){
                backPath = "register_cheat";
            }
            $location.path("/" +backPath).search({isBack:true});
        }

        /**
         * 获取系统时间和当前的登陆人员
         */
        function findCurrentTimeAndUser() {
            return $http.get(basePath + '/findCurrentTimeAndUser.htm').then(function (response) {
                return response;
            });
        }

        findCurrentTimeAndUser().then(function (response) {
            $scope.currentTime = new Date(response.data.result.currentTime);
        });

        // ====================拍照====================
        /*
         * 照片对象
         * {
         *   uri: ''  // 本地全路径
         *   path: ''    // 本地路径
         *   name: ''    // 文件名
         *   fsId: ''    // 文件服务器id
         *   status: 0  // 状态
         *   progress: 0    // 上传进度
         * }
         * */
        $scope.photos = [];    //照片
        if($scope.registerCheat.attachmentIds && $scope.registerCheat.attachmentIds.length > 0){
            angular.forEach($scope.registerCheat.attachmentIds,function(item){
                var data = originBaseUrl + '/file/downloadStream.htm?fastDFSId=' + item;
                if(!(/\.(?:jpg|png|bmp|gif|jpeg)$/i).test(item)){
                    data = 'img/file.png'
                }
                var photo = {
                    uri: data,
                    path: data.substr(0, data.lastIndexOf('/') + 1),
                    name: data.substr(data.lastIndexOf('/') + 1),
                    fsId: item,
                    status: 1,
                    progress: '100%'
                };
                $scope.photos.push(photo);
            });
        }

        // 得到照片字符串
        $scope.getFsIds = function () {
            var photosFsIds = [];
            for (var i = 0; i < $scope.photos.length; i++) {
                if ($scope.photos[i].fsId) {
                    photosFsIds.push($scope.photos[i].fsId);
                }
            }
            $scope.showInfo.attachmentIds = photosFsIds;
            console.log(JSON.stringify($scope.showInfo.attachmentIds));
        };

        // 拍照上传
        $scope.takePhoto = function () {
            if ($scope.photos.length >= 5) {
                ynuiNotification.error({msg: '只能上传5张照片！'});
                return;
            }
            $scope.choosePictureModal.hide();
            //成功拍照 组装photo对象 push到 photos
            var customcamera = yn.plugin.customcamera;
            var opts = [{
                // name: vm.pageData.userName,
                address: mainInfo.roomAndBuildName,
                time: $filter('date')($scope.currentTime, 'yyyy/MM/dd 星期' +
                  ['日', '一', '二', '三', '四', '五', '六'][$scope.currentTime.getDay()] + ' HH:mm:ss')
            }];
            customcamera.startCamera(opts, takeSuccess, takeError);
        };

        // 拍照完成
        function takeSuccess(data) {
            var photo = {
                uri: data,
                path: data.substr(0, data.lastIndexOf('/') + 1),
                name: data.substr(data.lastIndexOf('/') + 1),
                fsId: '',
                status: 0,
                progress: 0
            };
            // 拍照完成
            $scope.photos.push(photo);
            // 执行上传
            $scope.upload(photo);
        }

        // 拍照失败
        function takeError(data) {
            console.error('拍照失败');
            console.error(JSON.stringify(data));
        }

        // 删除照片
        $scope.deletePhoto = function (photo) {
            $ionicPopup.confirm({
                title: '删除确认',
                template: '确认要删除照片吗?',
                cancelText: '取消',
                okText: '删除'
            }).then(function (res) {
                if (res) {
                    if (photo.fsId) {
                        // 删除服务端文件
                        $http({
                            method: 'GET',
                            url: stringsConstant.file.deleteServer() + photo.fsId
                        })
                          .success(function (deletePhotoRes) {
                              console.log(JSON.stringify(deletePhotoRes));
                              if (deletePhotoRes.status == 0) {
                                  // 已从文件服务器删除文件，执行本地删除
                                  $scope.deleteLocalPhoto(photo);
                              }
                          })
                          .error(function (deletePhotoErr) {
                              console.error('从文件服务器删除文件失败');
                              console.error(JSON.stringify(deletePhotoErr));
                          });
                    } else {
                        // 删除本地文件
                        $scope.deleteLocalPhoto(photo);
                    }
                }
            });

        };
        // 删除本地照片
        $scope.deleteLocalPhoto = function (photo) {
            $cordovaFile
              .removeFile(photo.path, photo.name)
              .then(function (removeFileSuccess) {
                  console.error(JSON.stringify(removeFileSuccess));
              }, function (removeFileError) {
                  // error
                  console.error('从本地删除文件失败');
                  console.error(JSON.stringify(removeFileError));
              });

            // 删除显示列表文件
            for (var i = 0; i < $scope.photos.length; i++) {
                if ($scope.photos[i].uri == photo.uri) {
                    $scope.photos.splice(i, 1);
                    $scope.getFsIds();
                }
            }
        };
        // 预览照片
        $scope.previewPhoto = function (photo) {
            var cordovaFileOpen = cordova.plugins.disusered.open;
            cordovaFileOpen(photo.uri, cordovaFileOpenSuccess, cordovaFileOpenError);

            function cordovaFileOpenSuccess() {
                // 从已安装程序中打开文件完成
            }

            function cordovaFileOpenError(code) {
                if (code === 1) {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '未能在手机已安装APP中找到可预览此文件的程序'
                    });
                } else {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '预览时发生了未知错误 #' + code
                    });
                }
            }
        };
        // 单个照片失败重试
        $scope.retry = function (photo) {
            console.log('失败文件重试: ' + photo.uri);
            if (photo.status == '-1') {
                $scope.upload(photo);
            }
        };
        // 单个上传
        $scope.upload = function (photo) {
            photo.status = '0';
            // 参数
            var mac = stringsConstant.utils.uuid();
            var userId = JSON.parse(window.localStorage.getItem('authorizationStr')).userId;
            var options = new FileUploadOptions();
            options.params = {
                name: photo.name,
                userId: userId,
                mac: mac
            };
            options.headers = {
                authorization: JSON.parse(window.localStorage.getItem("authorizationStr")).access_token
            };
            $cordovaFileTransfer.upload(stringsConstant.file.uploadServer(), photo.uri, options)
              .then(function (uploadSuccessData) {
                  console.log(JSON.stringify(uploadSuccessData.response));
                  // 上传完成
                  photo.fsId = JSON.parse(uploadSuccessData.response).result.fileId;
                  if (photo.fsId) {
                      photo.status = '1';
                      // 允许继续拍照
                      $scope.getFsIds();
                  } else {
                      console.error('上传失败,fsId为空');
                      photo.status = '-1';
                  }
              }, function (uploadError) {
                  console.error('上传失败');
                  console.error(JSON.stringify(uploadError));
                  photo.status = '-1';
              }, function (progress) {
                  $timeout(function () {
                      photo.progress = parseInt((progress.loaded / progress.total) * 100) + '%';
                      console.log('上传进度: ' + photo.progress);
                  });
              });
        }


        // 选择图片
        $scope.choosePicture = function(){
            if ($scope.photos.length >= 5) {
                ynuiNotification.error({msg: '只能上传5张照片！'});
                return;
            }
            $ionicModal.fromTemplateUrl('choosePicture.html',{
                scope:$scope,
                animation:'slide-in-up'
            }).then(function(modal){
                modal.show();
                $scope.choosePictureModal = modal;
            });
        };

        // 选择照片
        $scope.takePicture = function(){
            if ($scope.photos.length >= 5) {
                ynuiNotification.error({msg: '只能上传5张照片！'});
                return;
            }
            $scope.choosePictureModal.hide();
            navigator.camera.getPicture(function (data) {
                console.log(JSON.stringify(data));
                var photo = {
                    uri: data,
                    path: data.substr(0, data.lastIndexOf('/') + 1),
                    name: data.substr(data.lastIndexOf('/') + 1),
                    fsId: '',
                    status: 0,
                    progress: 0
                };
                $scope.photos.push(photo);
                // 执行上传
                $scope.upload(photo);
            },function (error) {
                console.log(JSON.stringify(error))
            },{
                sourceType: Camera.PictureSourceType.PHOTOLIBRARY
            })
        };

        /*选择图片或拍照 结束*/


    }

    /**
     *考试情况
     */
    examinationConditionController.$inject = ['$scope','$http','$location','storageService','ynuiNotification'];
    function examinationConditionController($scope,$http,$location,storageService,ynuiNotification){
        // 路由信息
        var basePath = originBaseUrl + "/third/kwglTeacherInvigilate";

        $scope.saveInfo = {remake:""};
        $scope.submit = submit;
        $scope.back = back;
        // 主列表信息
        var mainInfo = storageService.getItemNoDel("mainInfo");
        if(mainInfo){
            $scope.saveInfo.remake = mainInfo.examRemark;
        }

        function submit() {
            mainInfo.examRemark = $scope.saveInfo.remake;
            var saveInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: mainInfo})};
            $http.post(basePath+"/addRegistrationInfo.htm",saveInfo).success(function (data) {
                if(data.status == 0){
                    mainInfo.registrationId = data.result.failedId;
                    storageService.setItem("mainInfo",mainInfo);
                    back();
                }else {
                    ynuiNotification.error({msg: "保存失败！"});
                }
            });
        }

        function back() {
            $location.path("/task_underway").search({});
        }

    }

    /**
     *补考名单确认
     */
    retestStudentConfirmController.$inject = ['$scope','$http','$location','storageService','ynuiNotification'];
    function retestStudentConfirmController($scope,$http,$location,storageService,ynuiNotification){
        // 路由信息
        var basePath = originBaseUrl + "/third/kwglTeacherInvigilate";

        $scope.saveInfo = {remake:""};
        $scope.submit = submit;
        $scope.back = back;
        // 主列表信息
        var mainInfo = storageService.getItemNoDel("mainInfo");
        if(mainInfo){
            $scope.saveInfo.remake = mainInfo.examRemark;
        }

        function submit() {
            mainInfo.examRemark = $scope.saveInfo.remake;
            var saveInfo = {jsonData: angular.toJson({kwglRegistrationInfoVO: mainInfo})};
            $http.post(basePath+"/addRegistrationInfo.htm",saveInfo).success(function (data) {
                if(data.status == 0){
                    mainInfo.registrationId = data.result.failedId;
                    storageService.setItem("mainInfo",mainInfo);
                    back();
                }else {
                    ynuiNotification.error({msg: "保存失败！"});
                }
            });
        }

        function back() {
            $location.path("/task_underway").search({});
        }

    }

    /**
     *  invigilate_onLine
     *  在线监考
     */
    invigilateOnLineController.$inject = ['$scope','$http','$location','storageService','ynuiNotification',"$ionicScrollDelegate",
        "$interval","$ionicPopup","$ionicModal","$ionicLoading","$timeout","$injector"];
    function invigilateOnLineController($scope,$http,$location,storageService,ynuiNotification,$ionicScrollDelegate,$interval,$ionicPopup,$ionicModal,$ionicLoading,$timeout,$injector){
        var vm = $scope.vm ={
            studentList:[],
            tab:'1',
            showTitle:'',
            follwoMore:true,
            updTitle:updTitle,
            switchTab:switchTab,
            showStudentHeader:showStudentHeader,
            clearStudentHeader:clearStudentHeader,
            initStudentInfo:initStudentInfo,
            searchStudentInfo:searchStudentInfo,
            initExamInfo:initExamInfo,
            updatePassWord:updatePassWord,
            showSeachInfo:showSeachInfo,
            clearSearch:clearSearch,
            initClassInfo:initClassInfo,
            initStudentTotal:initStudentTotal,
            showButton:showButton,
            showUpdateStatus:showUpdateStatus,
            updateExamStuOnlineStatus:updateExamStuOnlineStatus,
            searchAdminClass:searchAdminClass,
            endExam:endExam,
            onClickCome:onClickCome,
            searchInfo:{
                examInfoId:$location.search().examInfoId,
                id:$location.search().id,
                examType:$location.search().examType,
                kwglPlanClassRoomId:$location.search().kwglPlanClassRoomId,//考场ID
                adminClassIds:[],
                courseAdminClassIds:$location.search().courseAdminClassIds,
                adminClassNames:[],
                stuName:"",
                searchStatus:false,
                loading:false,
                pageNumber:0,
                pageSize:10,
            },
            modelPaper:{
                examRoomPassword:"",//重置密码
                flag:false,
                examInfoId:$location.search().examInfoId,
                message:"",//错误提示
                cheatReason:"",//作弊原因
                noCome:true,//标记缺考状态
            },
            classListInfo:[],
            showPassWordModel:"",
            examInfo:{},
        }
        function initExamInfo(){
            $http.post(originBaseUrl + "/third/kwglTeacherInvigilate/findSimpleExamInfo.htm",{
                examInfoId:vm.searchInfo.examInfoId
            }).success(function (data) {
                if(data.status == 0){
                    vm.examInfo=data.result;
                    vm.examInfo.serverTime=vm.examInfo.serverTime.substr(0, vm.examInfo.serverTime.lastIndexOf(":"));
                    initTime(true);
                }else {
                    ynuiNotification.error({msg: "获取失败！"});
                }
            });
        }
        function initClassInfo(){
            vm.classListInfo=[{id:"",name:"全部班级",isChecked:false}];
            $http.post(originBaseUrl + "/third/kwglTeacherInvigilate/queryAdminClassByKeyId.htm",{
                examInfoId:vm.searchInfo.examInfoId,
                examType:vm.searchInfo.examType,
                examRoomId:vm.searchInfo.kwglPlanClassRoomId,
                id:vm.searchInfo.id,
                courseAdminClassIds:vm.searchInfo.courseAdminClassIds
            }).success(function (data) {
                if(data.status == 0){
                    data.result.forEach(function(item){
                        vm.classListInfo.push(item);
                    })
                }else {
                    ynuiNotification.error({msg: "获取失败！"});
                }
            });
        }
        /**
         * 初始化查询学生信息
         */
        $scope.studentTotal=[0,0,0,0,0,0,0];
        function initStudentTotal(){
            $http.post(originBaseUrl + "/third/kwglTeacherInvigilate/findStudOnlineStatusCount.htm?loading=disabled&date="+new Date(),{
                examInfoId:vm.searchInfo.examInfoId,
                id:vm.searchInfo.id,
                onlineStatus:vm.tab,
                examType:vm.searchInfo.examType,
                adminClassId:vm.searchInfo.adminClassIds,
                courseAdminClassIds:vm.searchInfo.courseAdminClassIds,
                stuName:vm.searchInfo.stuName,
            }).success(function (data) {
                if(data.status == 0){
                    //0未进入，1已交卷考试，2在线考试  考试状态： 3总数, 4正常，5缺考，6作弊
                    for(var i=0;i<data.result.length;i++){
                        if($scope.studentTotal[i]!=data.result[i]){
                            $scope.studentTotal=data.result;
                            vm.follwoMore=false;
                            vm.studentList=[];
                            $ionicScrollDelegate.$getByHandle('listScroll').scrollTo(0,1,true);
                            vm.initStudentInfo();
                        }
                    }
                }else {
                    ynuiNotification.error({msg: "保存失败！"});
                }
            });
        }
        /**
         * 初始化查询学生信息
         */
        function searchStudentInfo(){
            if(!vm.searchInfo.stuName){
                return;
            }
            vm.searchInfo.loading=true;
            $http.post(originBaseUrl + "/third/kwglTeacherInvigilate/findStudByExamType.htm?loading=disabled",{
                examInfoId:vm.searchInfo.examInfoId,
                id:vm.searchInfo.id,
                examType:vm.searchInfo.examType,
                stuName:vm.searchInfo.stuName,
                pageNumber:0,
                pageSize:99999,
            }).success(function (data) {
                if(data.status == 0){
                    vm.studentList = data.result.content;
                    initShowTime();
                }else {
                    ynuiNotification.error({msg: "操作失败！"});
                }
            });
        }
        /**
         * 初始化查询学生信息
         * @param type loading 表示加载更多
         */
        function initStudentInfo(type){
            if(type=='loading'){
                vm.searchInfo.pageNumber++;
            }else{
                vm.searchInfo.pageNumber=0;
            }
            $http.post(originBaseUrl + "/third/kwglTeacherInvigilate/findStudByExamType.htm?loading=disabled",{
                examInfoId:vm.searchInfo.examInfoId,
                id:vm.searchInfo.id,
                onlineStatus:vm.tab,
                examType:vm.searchInfo.examType,
                adminClassId:vm.searchInfo.adminClassIds,
                courseAdminClassIds:vm.searchInfo.courseAdminClassIds,
                pageNumber:vm.searchInfo.pageNumber,
                pageSize:vm.searchInfo.pageSize,
            }).success(function (data) {
                if(data.status == 0){
                    if(type=='loading'){
                        vm.studentList.push.apply(vm.studentList, data.result.content);
                    }else{
                        vm.studentList = data.result.content;
                    }
                    //是否显示加载跟多
                    vm.follwoMore=!data.result.lastPage;
                    initShowTime();
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }else {
                    ynuiNotification.error({msg: "操作失败！"});
                }
            });
        }

        /**
         * 初始化显示时间格式
         */
        function initShowTime(){
            angular.forEach(vm.studentList,function(item){
                // var tempTime=new Date(item.assignmentTime);
                // item.assignmentTimeStr=(tempTime.getHours() + 100 + "").substr(1, 2) + ":" + (tempTime.getMinutes() + 100 + "").substr(1, 2);
                // var entryTime=new Date(item.entryTime);
                // item.entryTimeStr=(entryTime.getHours() + 100 + "").substr(1, 2) + ":" + (entryTime.getMinutes() + 100 + "").substr(1, 2);
                var tempTime = moment(item.assignmentTime);
                item.assignmentTimeStr = tempTime.format("HH:mm");
                var entryTime = moment(item.entryTime);
                item.entryTimeStr = entryTime.format('HH:mm');
            });
        }
        /**
         * 标记学生作弊或者缺考
         * @param info
         * @param status 1缺考 2作弊
         */
        function showUpdateStatus(info,status){
            //如果学生状态为正常
            vm.modelPaper.message="";
            vm.modelPaper.cheatReason="";
            vm.modelPaper.forceHandPaper=false;
            if(status==2){
                if(info.status==2){
                    $ionicPopup.confirm({
                        title:"提示",
                        template: '您确定要取消作弊吗？',
                        cancelText:"取消",
                        okText:"确认"
                    }).then(function(res) {
                        if(res) {
                            updateExamStuStatus(info,0);
                        }
                    });
                }else{
                    $ionicPopup.show({
                        title: '您确定要把该考生设置为作弊吗？',
                        cssClass:'new-confirm',
                        scope: $scope,
                        templateUrl: 'addCheatReason.html',
                        buttons: [{text:"取消"},
                            {
                                text:"确认",
                                type: 'button-positive',
                                onTap:function(e){
                                    if(!vm.modelPaper.cheatReason){
                                        vm.modelPaper.message="作弊原因不能为空！";
                                        e.preventDefault();
                                        return;
                                    }
                                    updateExamStuStatus(info,2);
                                }},
                        ]
                    })
                }
            }else{
                updateExamStuStatus(info,info.status==1?0:1);
            }

        }
        function updateExamStuStatus(info,flag){
            $http.post(originBaseUrl + "/third/kwglTeacherInvigilate/updateExamStuStatus.htm",{
                examInfoId:vm.searchInfo.examInfoId,
                studentId:info.stuId,
                flag:flag,
                cheatReason:vm.modelPaper.cheatReason,
                forceHandPaper:vm.modelPaper.forceHandPaper
            }).success(function (data) {
                vm.modelPaper.message="";
                if(data.status == 0){
                    ynuiNotification.success({msg: "操作成功！"});
                    if(vm.searchInfo.searchStatus){
                        searchStudentInfo();
                    }else{
                        initStudentTotal();
                    }
                }else {
                    ynuiNotification.error({msg: "操作失败！"});
                }
            });
        }
        /**
         * 允许学生重新进入
         */
        function updateExamStuOnlineStatus(studentId){
            $http.post(originBaseUrl + "/third/kwglTeacherInvigilate/updateExamStuOnlineStatus.htm",{
                examInfoId:vm.searchInfo.examInfoId,
                studentId:studentId,
                flag:3
            }).success(function (data) {
                if(data.status == 0){
                    if(data.result.length <= 0){
                        ynuiNotification.success({msg: "操作成功！"});
                        if(vm.searchInfo.searchStatus){
                            searchStudentInfo();
                        }else{
                            initStudentTotal();
                        }
                    }else{
                        ynuiNotification.error({msg: data.result[0].failedReason});
                    }
                }else {
                    ynuiNotification.error({msg: "操作失败！"});
                }
            });
        }
        //修改密码
        function updatePassWord(isUpdate){
            vm.modelPaper.examRoomPassword="";
            vm.modelPaper.message="";
            vm.modelPaper.flag=false;
            vm.modelPaper.isUpdate=isUpdate;
            $ionicPopup.show({
                cssClass:'new-pass-confirm popup-head-none',
                scope: $scope,
                templateUrl: 'updatePassword.html',
                buttons: [{text:"取消"},
                    {
                        text:"确认",
                        type: 'button-positive',
                        onTap:function(e){
                            if (!vm.modelPaper.examRoomPassword) {
                                vm.modelPaper.message="考场密码不能为空！";
                                e.preventDefault();
                                return;
                            }
                            if (!/^[0-9]+$/.test(vm.modelPaper.examRoomPassword)) {
                                vm.modelPaper.message="请输入1-8位正整数！";
                                e.preventDefault();
                                return;
                            }
                            if (vm.modelPaper.examRoomPassword==vm.examInfo.examRoomPassword) {
                                vm.modelPaper.message="新旧考场密码不能一致！";
                                e.preventDefault();
                                return;
                            }
                            $http.post(originBaseUrl + "/third/kwglTeacherInvigilate/updateExamRoomPassword.htm",vm.modelPaper).success(function (data) {
                                if(data.status == 0){
                                    vm.examInfo.examRoomPassword=angular.copy(vm.modelPaper.examRoomPassword);
                                }else {
                                    ynuiNotification.error({msg: "保存失败！"});
                                }
                            });
                        }}

                ]
            });


        }
        /**
         * 结束考试
         */
        function endExam(){
            if($scope.studentTotal[1]==0 && $scope.studentTotal[0]==0){
                $ionicPopup.show({
                    title: '强制交卷',
                    cssClass:"new-poput-not-confirm",
                    scope: $scope,
                    templateUrl: 'endExam.html',
                    buttons: [{text:"关闭",type: 'button-positive'}]
                });
                return;
            }

            if($scope.studentTotal[8]==0){
                vm.modelPaper.noCome=false;
                $ionicPopup.show({
                    title: '您确定强制交卷吗？',
                    scope: $scope,
                    buttons: [{text:"关闭"},buttons]
                });
                return;
            }
            vm.modelPaper.noCome=true;
            $ionicPopup.show({
                title: '强制交卷',
                cssClass:"new-poput-confirm",
                scope: $scope,
                templateUrl: 'endExam.html',
                buttons: [{text:"取消"},buttons]
            });
        }
        var buttons={
            text:"确认",
            type: 'button-positive',
            onTap:function(e){
                // if(!vm.modelPaper.noCome && $scope.studentTotal[7]>0){
                //     e.preventDefault();
                //     ynuiNotification.error({msg: "请先选择处理方式！"});
                //     return;
                // }
                $ionicLoading.show({
                    template: '强制交卷中...'
                });
                $http.post(originBaseUrl + "/third/kwglTeacherInvigilate/updateExamStuByAdminClassIds.htm?loading=disabled",{
                    examInfoId:vm.searchInfo.examInfoId,
                    noCome:(vm.modelPaper.noCome==1),
                    adminClassIds:vm.searchInfo.adminClassIds
                }).success(function (data) {
                    if(data.status == 0){
                        ynuiNotification.success({msg: "操作成功！"});
                        $ionicLoading.hide();
                        if(vm.searchInfo.searchStatus){
                            searchStudentInfo();
                        }else{
                            initStudentTotal();
                        }
                    }else {
                        ynuiNotification.error({msg: "操作失败！"});
                    }
                });

            }};
        /**
         * 切换结束考试学生状态处理
         */
        function onClickCome(){
            vm.modelPaper.noCome=!vm.modelPaper.noCome;
        }
        /**
         * 切换班级
         */
        $scope.ulOpen=false;
        function searchAdminClass(item){
            if(item.id==""){
                //全选
                vm.searchInfo.adminClassIds=[];
                vm.searchInfo.adminClassNames=[];
                if(!item.isChecked){
                    vm.classListInfo.forEach(function(classInfo){
                        classInfo.isChecked=true;
                        if(classInfo.id){
                            vm.searchInfo.adminClassIds.push(classInfo.id);
                            vm.searchInfo.adminClassNames.push(classInfo.name);
                        }
                    })
                }else{
                    vm.classListInfo.forEach(function(classInfo){
                        classInfo.isChecked=false;
                    })
                }
            }else{
                //正选 和 反选
                if(!item.isChecked){
                    item.isChecked=true;
                    vm.searchInfo.adminClassIds.push(item.id);
                    vm.searchInfo.adminClassNames.push(item.name);
                }else{
                    item.isChecked=false;
                    vm.searchInfo.adminClassIds.splice(vm.searchInfo.adminClassIds.indexOf(item.id),1);
                    vm.searchInfo.adminClassNames.splice(vm.searchInfo.adminClassNames.indexOf(item.name),1);
                }
            }
            if(vm.searchInfo.adminClassIds.length==0 ||vm.searchInfo.adminClassIds.length>=vm.classListInfo.length-1){
                vm.searchInfo.adminClassNames.unshift("全部班级");

                if(vm.searchInfo.adminClassIds.length>=vm.classListInfo.length-1){
                    vm.classListInfo[0].isChecked=true;
                }
            }else{
                var delIndex=vm.searchInfo.adminClassNames.indexOf("全部班级");
                if(delIndex>-1){
                    vm.searchInfo.adminClassNames.splice(delIndex,1);
                }
                vm.classListInfo[0].isChecked=false;
            }

            vm.initStudentInfo();
            vm.initStudentTotal();
            $scope.ulOpen=true;
        }
        /**
         * 收起和展开
         */
        function showButton(info){
            if(info.stuId==$scope.showStudentId){
                $scope.showStudentId="";
                return;
            }
            $scope.showStudentId=info.stuId;
        }

        /**
         * 收起和展开查询条件
         */
        function showSeachInfo(){
            vm.searchInfo.searchStatus=!vm.searchInfo.searchStatus;
            if(myInterval){
                $interval.cancel(myInterval);
            }
            if(!vm.searchInfo.searchStatus){
                vm.initStudentTotal();
                myInterval=$interval(function () {
                    vm.initStudentTotal();
                }, 5000);
            }
            vm.clearSearch();
        }
        /**
         * 清理查询条件
         */
        function clearSearch(){
            vm.searchInfo.adminClassIds=[],
              vm.searchInfo.stuName="",
              vm.searchInfo.adminClassNames=["全部班级"];
            $scope.studentTotal=[0,0,0,0,0,0,0];
            vm.studentList=[];
            vm.searchInfo.loading=false;
        }
        /**
         * 获得剩余时间
         *
         * @param nowTime 现在的时间
         * @param time    要相减的时间
         */
        var getSurplusTime = function (nowTime, time) {
            //转换当前日期
            var now = nowTime.replace(/-/g,"/");
            var end = time.replace(/-/g,"/");
            var nowDate = new Date(now);
            var endDate = new Date(end);

            //获得剩余的进入时间
            var days = Math.floor((endDate - nowDate) / 1000 / 60 / 60 / 24);
            var hours = Math.floor((endDate - nowDate) / 1000 / 60 / 60 - (24 * days));
            var minutes = Math.floor((endDate - nowDate) / 1000 / 60 - (60 * (hours + (24 * days))));

            if (days > 0) {
                //如果大于1天显示 x天,x小时,x分钟
                return days + "天" + hours + "小时" + minutes + "分钟";
            } else if (days < 0) {
                //如果天数为负数, 显示进入时间已过
                return true;
            } else {
                if (hours > 0) {
                    //如果小时大于0 显示 x小时,x分钟
                    return hours + "小时" + minutes + "分钟";
                } else if (hours < 0) {
                    //如果小时为负数, 显示进入时间已过
                    return true;
                } else {
                    if (minutes > 0) {
                        //如果分钟大于0 显示 x分钟
                        return minutes + "分钟";
                    } else {
                        //不满足以上条件 显示进入时间已过
                        return true;
                    }
                }
            }
        };
        /**
         * 初始化时间
         */
        function initTime(isDefault){
            //转换当前日期
            var end = vm.examInfo.entryEndTime.replace(/-/g,"/");
            var now = vm.examInfo.serverTime.replace(/-/g,"/");
            var begin = vm.examInfo.entryBeginTime.replace(/-/g,"/");
            var serverTime=new Date(now).getTime()-new Date(begin).getTime();
            //0未开始 1进行中
            vm.examInfo.status=0;
            //密码配置状态 false时间未到
            vm.examInfo.passwdLimitStatus=false;
            if(serverTime>=0){
                //考试状态
                vm.examInfo.status=1;
                vm.examInfo.passwdLimitStatus=true;
            }
            if(Math.abs(serverTime/1000)<=vm.examInfo.passwdLimit*60){
                vm.examInfo.passwdLimitStatus=true;
            }

            //获取剩余时间
            if(vm.examInfo.status==0){
                vm.examInfo.endTime = getSurplusTime(now, begin);
            }else{
                vm.examInfo.endTime = getSurplusTime(now,end);
            }
            //已结束
            if(vm.examInfo.endTime==true){
                vm.examInfo.status=2;
            }
            //获得最迟交卷时间
            var tempTime = new Date(new Date(end).getTime() + vm.examInfo.duration * 60 * 1000);
            //格式化最迟交卷时间
            vm.examInfo.latestFinishingTime = tempTime.getFullYear() + "-" + (tempTime.getMonth() + 101 + "").substr(1, 2) + "-" + (tempTime.getDate() + 100 + "").substr(1, 2) + " " +
              (tempTime.getHours() + 100 + "").substr(1, 2) + ":" + (tempTime.getMinutes() + 100 + "").substr(1, 2);

            //B0089104
            if(isDefault){
                updTitle((vm.examInfo.status==1)?2:1);
            }
        }
        /**
         * 切换查询列表
         * @param tab
         */
        function switchTab (tab) {
            vm.tab = tab;
            vm.initStudentInfo();
            vm.studentList=[];
            $ionicScrollDelegate.$getByHandle('listScroll').scrollTo(0,1,true);
        }
        /**
         * 获取系统时间
         */
        function findCurrentTime() {
            $http.get(originBaseUrl + "/third/kwglTeacherInvigilate/findCurrentTimeAndUser.htm?patterns=yyyy-MM-dd HH:mm&loading=disabled&date="+new Date())
              .success(function (data) {
                  vm.examInfo.serverTime=data.result.currentTime;
                  initTime(false);
              });
        }
        $scope.studentHeader={};
        $ionicModal.fromTemplateUrl('studentHeader.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.studentHeader.modal = modal;
        });
        function showStudentHeader(info){
            $scope.studentHeader.modal.show();
            $scope.studentHeader.studentInfo=info;
        }
        function clearStudentHeader(){
            $scope.studentHeader.modal.hide();
            $scope.studentHeader.studentInfo={};
        }
        /**
         * 切换title
         * @param showTitle
         */
        function updTitle (showTitle) {
            //判断监考任务是否开始
            if(showTitle==2 && vm.examInfo.status==0){
                ynuiNotification.error({msg: "考试还未开始，不能监考学生！"});
                return;
            }
            vm.showTitle = showTitle;
            vm.searchInfo.searchStatus=false;
            vm.tab='1';
            vm.clearSearch();
            vm.initStudentTotal();
            if(myInterval){
                $interval.cancel(myInterval);
            }
            if(showTitle==1){
                myInterval=$interval(function () {
                    findCurrentTime();
                }, 5000);
            }else{
                vm.switchTab('1');
                vm.initClassInfo();
                myInterval=$interval(function () {
                    vm.initStudentTotal();
                }, 5000);
            }
        }
        /**
         * 返回
         */
        $scope.goBack = function() {
            $location.path("/task_list").search({isBack:true});
        }
        /**
         * 假刷新，统一样式
         */
        var $ionicLoading = $injector.get('$ionicLoading');
        $scope.refreshTable = function() {
            $ionicLoading.show({
                noBackdrop: true,
                hideOnStateChange: true
            })
            $timeout(function () {
                $ionicLoading.hide();
            },200);
        }
        vm.initExamInfo();
    }

    registerNotTaskCtrl.$inject = ['$scope', '$http', '$state', '$ionicModal', '$ionicLoading', '$ionicPopup',
        'stringsConstant', '$cordovaFileTransfer'];

    /**
     * 无监考任务添加页面
     */
    function registerNotTaskCtrl(
      $scope, $http, $state, $ionicModal, $ionicLoading, $ionicPopup, stringsConstant, $cordovaFileTransfer
    ) {
        var vm = this;

        vm.selectTerm = selectTerm;
        vm.selectStu = selectStu;
        vm.selectedStuFun = selectedStuFun;
        vm.selectCourse = selectCourse;
        vm.selectExamType = selectExamType;
        vm.selectTeacher = selectTeacher;
        vm.selectedTeacherFun = selectedTeacherFun;
        vm.selectFiles = selectFiles;
        vm.takePhoto = takePhoto;
        vm.takePicture = takePicture;
        vm.previewPhoto = previewPhoto;
        vm.doDeleteFile = doDeleteFile;
        vm.doSave = doSave;

        vm.originBaseUrl = originBaseUrl;

        vm.obj = {
            examDate: null,
            type: '4',
            examRemark: null,
            fileList: []
        };

        vm.termList = [];
        vm.selectedTerm = null;

        vm.single = true;
        vm.selectedStu = null;
        vm.selectedStuList = [];

        vm.selectedCourse = null;
        vm.courseList = [];

        vm.selectedExamType = null;
        vm.examTypeList = [];

        vm.selectedTeachers = [];
        vm.selectedTeacherNames = null;

        vm.clickSaveButton = false;

        init();

        function init() {
            getTermList();
            queryExamType();
        }

        function getTermList() {
            return $http.get(originBaseUrl + '/third/term/list.htm', {
                params: {asc: false}
            }).success(function (data) {
                if (data.status === 0) {
                    vm.termList = data.result.termList;
                    vm.selectedTerm = data.result.termList[0];
                }
            });
        }

        function selectTerm(term) {
            vm.selectedTerm = term;
            if (null != vm.selectedStu) {
                queryCourse(vm.selectedStu.id, term.id);
            }
        }

        function selectStu() {
            if (null == vm.selectStuModal) {
                $ionicModal.fromTemplateUrl('select_stu_by_name_like.html', {
                    scope: $scope,
                    animation: 'slide-in-left'
                }).then(function (modal) {
                    vm.selectStuModal = modal;
                    vm.selectStuModal.show();
                });
            } else {
                vm.selectStuModal.show();
            }
        }

        function selectedStuFun(stu) {
            vm.selectedStu = stu;
            vm.selectedStuList = [stu];
            vm.selectStuModal.hide().then(function () {
                vm.selectStuModal.remove();
                vm.selectStuModal = null;
            });
            queryCourse(stu.id, vm.selectedTerm.id);
        }

        function queryCourse(stuId, termId) {
            return $http.get(originBaseUrl + '/third/course/list.htm', {
                params: {
                    stuId: stuId,
                    termId: termId
                }
            }).success(function (data) {
                if (data.status === 0) {
                    vm.courseList = data.result;
                    vm.selectedCourse = vm.courseList[0];
                }
                return data;
            })
        }

        function selectCourse(course) {
            vm.selectedCourse = course;
        }

        function queryExamType() {
            return $http.get(originBaseUrl + '/third/dictionary/list.htm', {
                params: {key: 'EXAM_TYPE_CODE'}
            }).success(function (data) {
                if (data.status === 0) {
                    vm.examTypeList = data.result;
                    vm.selectedExamType = vm.examTypeList[0];
                }
                return data;
            });
        }

        function selectExamType(type) {
            vm.selectedExamType = type;
        }

        function selectTeacher() {
            if (null == vm.selectTeacherModal) {
                $ionicModal.fromTemplateUrl('select_teacher_by_name_like.html', {
                    scope: $scope,
                    animation: 'slide-in-left'
                }).then(function (modal) {
                    vm.selectTeacherModal = modal;
                    vm.selectTeacherModal.show();
                });
            } else {
                vm.selectTeacherModal.show();
            }
        }

        function selectedTeacherFun(teachers) {
            vm.selectedTeachers = teachers;
            vm.selectTeacherModal.hide().then(function () {
                vm.selectTeacherModal.remove();
                vm.selectTeacherModal = null;
            });
            var names = [];
            angular.forEach(vm.selectedTeachers, function (value) {
                names.push(value.name);
            });
            vm.selectedTeacherNames = names.join('、');
        }

        function selectFiles() {
            if (null == vm.selectFilesModal) {
                $ionicModal.fromTemplateUrl('file_sources.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.selectFilesModal = modal;
                    vm.selectFilesModal.show();
                });
            } else {
                vm.selectFilesModal.show();
            }
        }

        function takePhoto() {
            getPicture(Camera.PictureSourceType.CAMERA);
        }

        function takePicture() {
            getPicture(Camera.PictureSourceType.PHOTOLIBRARY);
        }

        /**
         * 选择并上传文件
         * @param type Camera.PictureSourceType
         */
        function getPicture(type) {
            /**
             * 成功回调
             * @param data 文件路径
             * "file:///storage/emulated/0/截屏/截屏_20211015_095650.jpg"
             */
            function success(data) {
                $ionicLoading.show();
                upload(data.substr(data.lastIndexOf('/') + 1), data);
                vm.selectFilesModal.hide().then(function () {
                    vm.selectFilesModal.remove();
                    vm.selectFilesModal = null;
                });
            }
            // 失败回调
            function error(error) {
                console.log(JSON.stringify(error))
                vm.selectFilesModal.hide().then(function () {
                    vm.selectFilesModal.remove();
                    vm.selectFilesModal = null;
                });
            }
            // 选择并上传
            navigator.camera.getPicture(success, error, {sourceType: type});
        }

        function upload(name, uri) {
            // 参数
            var mac = stringsConstant.utils.uuid();
            var userId = JSON.parse(window.localStorage.getItem('authorizationStr')).userId;
            var options = new FileUploadOptions();
            options.fileName = name;
            options.params = {
                name: name,
                userId: userId,
                mac: mac
            };
            options.headers = {
                authorization: JSON.parse(window.localStorage.getItem("authorizationStr")).access_token
            };
            $cordovaFileTransfer
              .upload(stringsConstant.file.uploadServer(), uri, options)
              .then(function (uploadSuccessData) {
                  $ionicLoading.hide();
                  console.log(JSON.stringify(uploadSuccessData.response));
                  // 上传完成
                  var result = JSON.parse(uploadSuccessData.response).result;
                  vm.obj.fileList.push({
                      attachmentId: result.fileId,
                      attachmentName: result.fileName,
                      size: result.size
                  });
              });
        }

        function previewPhoto(fsId) {
            var url = originBaseUrl + '/third/file/download.htm?fileId=' + fsId;
            var cordovaFileOpen = cordova.plugins.disusered.open;
            cordovaFileOpen(url, cordovaFileOpenSuccess, cordovaFileOpenError);
            function cordovaFileOpenSuccess() {
                // 从已安装程序中打开文件完成
            }
            function cordovaFileOpenError(code) {
                if (1 === code) {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '未能在手机已安装APP中找到可预览此文件的程序',
                        okText: '确定'
                    });
                } else {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '预览时发生了未知错误 #' + code,
                        okText: '确定'
                    });
                }
            }
        }

        function deleteFile(fsId) {
            // 删除服务端文件
            return $http.get(stringsConstant.file.deleteServer() + fsId).success(function (data) {
                return data;
            });
        }

        function doDeleteFile(file, index) {
            var confirm = $ionicPopup.confirm({
                title: '删除确认',
                template: '确认要删除当前照片吗?',
                cancelText: '取消',
                okText: '删除'
            });
            confirm.then(function (data) {
                if (data && file.id) {
                    vm.obj.fileList.splice(index, 1);
                    // vm.deleteFsIds(file.attachmentId);
                } else if (data) {
                    vm.obj.fileList.splice(index, 1);
                    deleteFile(file.attachmentId);
                }
            });
        }

        function save(obj) {
            var config = {
                url: originBaseUrl + '/third/plan/register/save.htm',
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json'
                },
                dataType: 'JSON',
                data: angular.toJson(obj)
            };
            return $http(config).success(function (data) {
                return data;
            });
        }

        function alertMsg(msg) {
            $ionicPopup.alert({
                title: '提示',
                template: msg,
                okText: '确定'
            });
        }

        function validForm() {
            if (null == vm.selectedTerm) {
                alertMsg('请选择学期！');
                return false;
            }
            if (null == vm.selectedStu) {
                alertMsg('请选择学生！');
                return false;
            }
            if (null == vm.selectedCourse) {
                alertMsg('请选择课程！');
                return false;
            }
            if (null == vm.selectedExamType) {
                alertMsg('请选择考试类型！');
                return false;
            }
            return true;
        }

        function getObj() {
            // 构造参数
            var obj = angular.copy(vm.obj);
            obj.termId = vm.selectedTerm.id;
            obj.stuId = vm.selectedStu.id;
            obj.pkTeachClassId = vm.selectedCourse.pkTeachClassId;
            obj.courseId = vm.selectedCourse.courseId;
            obj.teachType = vm.selectedCourse.teachType;
            obj.executeTerm = vm.selectedCourse.executeTerm;
            obj.examTypeCode = vm.selectedExamType.dictCode;
            // 监考教师
            if (vm.selectedTeachers.length > 0) {
                var ids = [];
                angular.forEach(vm.selectedTeachers, function (value) {
                    ids.push(value.id);
                });
                obj.teacherIds = ids.join(',');
            }
            return obj;
        }

        function doSave() {
            if (vm.clickSaveButton) {
                return;
            }
            vm.clickSaveButton = true;
            var valid = validForm();
            if (!valid) {
                vm.clickSaveButton = false;
                return;
            }
            var obj = getObj();
            save(obj).success(function (data) {
                if (data.status === 0 && null == data.result) {
                    alertMsg('提交成功！');
                    $state.go('task_list');
                } else {
                    vm.clickSaveButton = false;
                    alertMsg(data.result.failedReason);
                }
            });
        }
    }

    /**
     * 人员选择器
     */
    function selectUserByNameLike() {
        return {
            restrict: 'E',
            templateUrl: 'templates/invigilateTask/selectUserByNameLike.html',
            scope: {
                selectedUserList: '=',
                // 是否单选
                single: '=',
                callBackFun: '=',
                // 1教职工，2学生
                userType: '='
            },
            link: link,
            controller: ctrl,
            controllerAs: 'vm',
            bindToController: true
        };

        function link() {

        }

        function ctrl($scope, $http, $ionicPopup) {
            var vm = this;

            vm.doSearch = doSearch;
            vm.selectUser = selectUser;
            vm.confirm = confirm;

            vm.searchVal = null;
            vm.userList = [];
            vm.selectedUserIds = [];
            vm.selectedUsers = [];

            init();

            function init() {
                // 默认查询
                if (null != vm.selectedUserList && vm.selectedUserList.length > 0) {
                    var ids = [];
                    angular.forEach(vm.selectedUserList, function (value) {
                        ids.push(value.id);
                    });
                    queryUser(ids).success(function () {
                        angular.forEach(vm.userList, function (value) {
                            if (ids.indexOf(value.id) >= 0) {
                                vm.selectedUserIds.push(value.id);
                                vm.selectedUsers.push(value);
                            }
                        });
                    });
                }
            }

            function getUserTypeName() {
                return vm.userType + '' === '1' ? '教师' : '学生';
            }

            function doSearch() {
                if (vm.searchVal) {
                    queryUser();
                } else {
                    $ionicPopup.alert({
                        title: "提示",
                        template: "请输入" + getUserTypeName() + "姓名查询",
                        okText: "确定"
                    });
                }
            }

            function queryUser(ids) {
                var user = vm.userType + '' === '1' ? 'teacher' : 'stu';
                return $http.get(originBaseUrl + '/third/' + user + '/list.htm', {
                    params: ids && ids.length > 0 ? {ids: ids} : {nameLike: vm.searchVal}
                }).success(function (data) {
                    if (data.status === 0) {
                        vm.userList = data.result;
                        handleUserInfo(vm.userList);
                    }
                    return data;
                });
            }

            function handleUserInfo(userList) {
                angular.forEach(userList, function (stu) {
                    var array = [];
                    if (stu.gender) {
                        array.push(stu.gender === 1 ? '男' : '女');
                    }
                    if (stu.number) {
                        array.push(stu.number);
                    }
                    stu.info = stu.displayName;
                    if (array.length > 0) {
                        stu.info += "(" + array.join("，") + ")";
                    }
                });
            }

            function selectUser(item) {
                var index = null;
                angular.forEach(vm.selectedUserIds, function (id, key) {
                    if (item.id === id) {
                        index = key;
                    }
                });
                if (null != index && !vm.single) {
                    vm.selectedUserIds.splice(index, 1);
                    vm.selectedUsers.splice(index, 1);
                } else {
                    // 单选
                    if (vm.single) {
                        vm.selectedUserIds = [item.id];
                        vm.selectedUsers = [item];
                    } else {
                        vm.selectedUserIds.push(item.id);
                        vm.selectedUsers.push(item);
                    }
                }
            }

            function confirm() {
                if (vm.selectedUserIds.length === 0) {
                    $ionicPopup.alert({
                        title: "提示",
                        template: "请选择" + getUserTypeName(),
                        okText: "确定"
                    });
                    return;
                }
                if (vm.callBackFun && angular.isFunction(vm.callBackFun)) {
                    vm.callBackFun(vm.single ? vm.selectedUsers[0] : vm.selectedUsers);
                }
            }
        }
    }

})();

