/**
 * 选择课次信息
 */
angular.module('starter').controller("jxrzAddHourCourseController",
['$scope', '$http', '$ionicModal', '$ionicLoading', 'nameFormatStr', '$location',"ynuiNotification","$filter","storageService",
    function ($scope, $http, $ionicModal, $ionicLoading, nameFormatStr, $location,ynuiNotification,$filter,storageService) {
        var baseUrl = originBaseUrl + "/third/kqkt/mobile";
        var knobInfo = angular.fromJson($location.search().knobInfo);
        var termId = $location.search().termId;
        var isTimeTable = $location.search().isTimeTable;
        var storageKey = $location.search().storageKey;
        if(!storageKey){
            storageKey="courseInfo_"+(((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        }
        var vm=$scope.vm={
            termId:termId,
            isTimeTable:isTimeTable?isTimeTable:false,//是否来自课表页面
            modal:"",
            currentTime:{
                today:"",
                week:"",
                day:"",
                weekDayList:"",//星期
            },//当前时间
            courseInfo:{
                userId:"",//当前用户
                dateValidError:"",//日期验证错误提示
                date:"",
                dateStr:"",//上课时间
                week:"",
                day:"",
                selectedKnobList:[],//选择的节次
                knobList:[],//总节次
                courseName:"",
                pkTeachClassId:"",
                adminClassVo:[],
                adminClassNames:"",
                roomVo:[],
                buildingClassRoomNames:"",
                teacherNames:"",
                teacherVo:[],
                hourUnit:1,//学时
            },
            findMobilaWeek:function(){
                $http.get(baseUrl + "/findKqktMobilaWeek.htm").success(function(data){
                    if(data.status==0){
                        vm.currentTime=data.result;
                        vm.termId=data.result.termId;
                        vm.courseInfo.week=data.result.week;
                        vm.courseInfo.day=data.result.day;
                        vm.courseInfo.date=data.result.today;
                        vm.courseInfo.dateStr=vm.getTodayStr(vm.currentTime.today);
                        vm.findTimeTableKnobNum(false);
                    }
                });
            },
            getTodayStr:function(today){
                var dateStr="";
                if (today === $filter('date')(new Date(), 'yyyy-MM-dd')) {
                    dateStr= "[今天]"+today;
                } else {
                    dateStr = today;
                }
                vm.convertWeekStr();
                return dateStr;
            },
            convertWeekStr:function(){
                vm.courseInfo.weekInfoStr=" 第"+vm.courseInfo.week+"周"+vm.getWeekDayStr(vm.courseInfo.day);
            },
            getWeekDayStr:function(weekDay){
                var weekDayList = vm.currentTime.weekDayList;
                for(var i=0;i<weekDayList.length;i++){
                    if(weekDay == (i+1)){
                        return weekDayList[i];
                    }
                }
                return "";
            },
            //比较选择的时间和当前时间差距
            datedifference:function(){
                var dateSpan = Date.parse(vm.courseInfo.date)-Date.parse(vm.currentTime.today);
                var selDay= Math.floor(Math.abs(dateSpan) / (24 * 3600 * 1000));

                var week = parseInt(vm.currentTime.week);
                var day = parseInt(vm.currentTime.day);
                var weekLength=vm.currentTime.weekDayList.length;
                if(dateSpan<0){
                    for(var i=0;i<selDay;i++){
                        if((day - 1) == 0){
                            day = weekLength;
                            week = week - 1;
                        }else{
                            day = day - 1;
                        }
                    }
                }else{
                    for(var i=0;i<selDay;i++){
                        if((day+1) > weekLength){
                            day = 1;
                            week = week +1;
                        }else{
                            day = day +1;
                        }
                    }
                }
                vm.courseInfo.week=week;
                vm.courseInfo.day=day;
                vm.courseInfo.dateStr=vm.getTodayStr(vm.courseInfo.date);
            },
            findCurrentUserName:function(){
                $http.post(originBaseUrl + "/third/jxrzResultKnob/getUserNameById.htm").success(function(data){
                    if(data.status==0 && data.result){
                        vm.courseInfo.teacherVo.push({id:data.result.id,name:data.result.name});
                        vm.courseInfo.teacherNames=data.result.name;
                        vm.courseInfo.userId=data.result.id;
                    }else if(data.status==-1){
                        ynuiNotification.error({msg: "获取数据失败！"});
                    }
                });
            },
            // 重新选择巡课日期
            selectDateTime: function (dateTime) {
                vm.datedifference();
                vm.vailJxrzItemByDateTime(false,dateTime);
            },
            vailJxrzItemByDateTime:function(isUpdate,dateTime){
                vm.dateValidError="";
                $http.post(originBaseUrl + "/third/jxrzResultKnob/vailJxrzItemByDateTime.htm",
                    {
                        isUpdate:isUpdate,
                        dateTime:dateTime,
                        termId:vm.termId,
                    }).success(function(data){
                        if(data.status==0 && data.result){
                            ynuiNotification.error({msg:data.result});
                            vm.dateValidError=data.result;
                        }else if(data.status==-1){
                            ynuiNotification.error({msg: "获取数据失败！"});
                        }
                })
            },
            goDetailedGrid:function(item){
                $location.path("/jxrz_resultDetailed").search({teachClassId:item.teachClassId,courseName:item.courseName});
            },
            //获取学期的节次
            findTimeTableKnobNum:function(isUpdate){
                $http.post(originBaseUrl + "/third/tkTaskRegisterApp/getTKKnobList.htm?termId="+vm.termId).success(function(data){
                    if(data.status==0 && data.result){
                        angular.forEach(data.result, function (item,_index) {
                            item.sequence = _index+1;
                        });
                        if(isUpdate){
                            vm.getPKTeachClassKnob(data.result);
                        }else{
                            vm.courseInfo.knobList=data.result;
                        }
                    }else if(data.status==-1){
                        ynuiNotification.error({msg: "获取数据失败！"});
                    }
                });
            },
            //选择节次
            checkedKnob:function(item){
                item.selected=!item.selected;
                var selectedKnobList=[];
                angular.forEach(vm.courseInfo.knobList,function(item){
                    if(item.selected){
                        selectedKnobList.push(item.id);
                    }
                });
                var knobInfo=vm.validKnobInfo();
                var timeType=knobInfo.timeType;
                if(timeType.length>1){
                    item.selected=!item.selected;
                    ynuiNotification.error({msg:knobInfo.timeTypeNames.substring(0,knobInfo.timeTypeNames.length-1)+"的节次不能同时登记！"});
                    return;
                }
                vm.courseInfo.selectedKnobList=selectedKnobList;
                if(vm.isTimeTable && vm.courseInfo.selectedKnobList.length==0){
                    vm.checkedKnob(item);
                    ynuiNotification.error({msg: "至少保留一个节次！"});
                }
            },
            //获取当前老师当前时间的节次
            getPKTeachClassKnob:function(knobList){
                var postData = {
                    teachClassId:knobInfo.pkTeachClassId,
                    week:knobInfo.week,
                    day:knobInfo.day,
                    timeType:knobInfo.timeType,
                    knob:knobInfo.knob,
                    termId:vm.termId
                };
                $http.post(originBaseUrl + "/third/jxrzResultKnob/getTeacherKnobInfo.htm",postData).success(function(data){
                    if(data.status==0 && data.result){
                        vm.courseInfo=data.result;
                        angular.forEach(vm.courseInfo.knobList, function (item) {
                            if(knobInfo.timeType==item.timeType && knobInfo.knob.indexOf(item.knob)>-1){
                                vm.checkedKnob(item);
                            }
                        });
                        angular.forEach(knobList,function(item,_index){
                            angular.forEach(vm.courseInfo.knobList, function (knob) {
                                if(knob.timeType==item.timeType && knob.knob==item.knob){
                                    knob.sequence=_index+1;
                                }
                            });
                        })
                        console.log(vm.courseInfo.knobList);
                        vm.courseInfo.week=knobInfo.week;
                        vm.courseInfo.date=knobInfo.date;
                        vm.courseInfo.dateStr=knobInfo.dateStr;
                        vm.courseInfo.weekInfoStr=knobInfo.weekInfoStr;
                        vm.courseInfo.day=knobInfo.day;
                        vm.courseInfo.hourUnit=1;
                        console.log(vm.courseInfo);
                    }else if(data.status==-1){
                        ynuiNotification.error({msg: "获取数据失败！"});
                    }
                });
            },
            //选课课程
            getCourseList:function(){
                if(vm.courseInfo.selectedKnobList.length==0){
                    ynuiNotification.error({msg: "请选择上课节次！"});
                    return;
                }
                // 回填
                $scope.$on("update_hour_course",function (event, data) {
                    vm.courseInfo.courseName=data.courseName;
                    vm.courseInfo.pkTeachClassId=data.pkTeachClassId;
                    vm.courseInfo.adminClassVo=[];
                    vm.courseInfo.adminClassNames=data.adminClassNames;
                    if(data.adminClassIds.length>0){
                        var adminClassName=data.adminClassNames.split(",");
                        angular.forEach(data.adminClassIds,function(adminClassId,_index){
                            vm.courseInfo.adminClassVo.push({id:adminClassId,name:adminClassName[_index]});
                        })
                    }
                    vm.modal.hide();
                });
                $ionicModal.fromTemplateUrl('templates/jxrz/hourunit/selectCourse.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.modal=modal;
                    vm.modal.show();
                });
            },
            //选择班级
            getClassList:function(){
                if(vm.courseInfo.selectedKnobList.length==0){
                    ynuiNotification.error({msg: "请选择上课节次！"});
                    return;
                }
                // 回填
                $scope.$on("update_hour_class",function (event, data) {
                    vm.courseInfo.adminClassNames=nameFormatStr.getName(data);
                    vm.courseInfo.adminClassVo=data;
                    vm.modal.hide();
                });
                $ionicModal.fromTemplateUrl('templates/jxrz/hourunit/searchClassList.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.modal=modal;
                    vm.modal.show();
                });
            },
            //选择教室
            getRoomList:function(){
                if(vm.courseInfo.selectedKnobList.length==0){
                    ynuiNotification.error({msg: "请选择上课节次！"});
                    return;
                }
                // 回填
                $scope.$on("update_hour_room",function (event, data) {
                    vm.courseInfo.roomVo=data;
                    vm.courseInfo.buildingClassRoomNames=nameFormatStr.getName(data);
                    vm.modal.hide();
                });
                $ionicModal.fromTemplateUrl('templates/jxrz/hourunit/searchRoomList.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.modal=modal;
                    vm.modal.show();
                });
            },
            //选择教师
            getTeacherList:function(){
                if(vm.courseInfo.selectedKnobList.length==0){
                    ynuiNotification.error({msg: "请选择上课节次！"});
                    return;
                }
                // 回填
                $scope.$on("update_hour_teacher",function (event, data) {
                    vm.courseInfo.teacherVo=data;
                    vm.courseInfo.teacherNames=nameFormatStr.getName(data);
                    vm.modal.hide();
                });
                $ionicModal.fromTemplateUrl('templates/jxrz/hourunit/searchTeacherList.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.modal=modal;
                    vm.modal.show();
                });
            },
            getName:function(data){
                var name="";
                if(data && data.length>0){
                    angular.forEach(data,function(item){
                        name+=item.name+",";
                    })
                }
                if(name.length>0){
                    return name.substring(0,name.length-1);
                }
                return name;
            },
            //格式化ID
            getId:function(itemList){
                var ids=[];
                angular.forEach(itemList,function(item){
                    ids.push(item.id);
                })
                return ids;
            },
            //验证周次是否跨时段
            validKnobInfo:function(){
                var knobs = [], timeType = [], timeTypeNames = "";
                angular.forEach(vm.courseInfo.knobList, function (knobVo) {
                    if (knobVo.selected) {
                        knobs.push(knobVo.knob);
                        if (timeType.indexOf(knobVo.timeType) == -1) {
                            timeType.push(knobVo.timeType);
                            if (knobVo.timeType == 1) {
                                timeTypeNames += "上午和";
                            } else if (knobVo.timeType == 2) {
                                timeTypeNames += "下午和";
                            } else {
                                timeTypeNames += "晚上和";
                            }
                        }
                    }
                });
                return {knobs: knobs, timeType: timeType, timeTypeNames: timeTypeNames};
            },
            //继续登记
            submitHourCourseInfo:function(){
                console.log(vm.courseInfo);
                if(vm.dateValidError){
                    ynuiNotification.error({msg: vm.dateValidError});
                    return;
                }
                var knobInfo=vm.validKnobInfo();
                var timeType=knobInfo.timeType;
                if(timeType.length>1){
                    ynuiNotification.error({msg:knobInfo.timeTypeNames.substring(0,knobInfo.timeTypeNames.length-1)+"的节次不能同时登记！"});
                    return;
                }
                if(!knobInfo.knobs || knobInfo.knobs.length==0){
                    ynuiNotification.error({msg: "请选择上课节次！"});
                    return;
                }
                if(!vm.courseInfo.dateStr){
                    ynuiNotification.error({msg: "请选择上课时间！"});
                    return;
                }
                if(!vm.courseInfo.pkTeachClassId){
                    ynuiNotification.error({msg: "请选择上课课程！"});
                    return;
                }
                if(!vm.courseInfo.teacherNames){
                    ynuiNotification.error({msg: "请选择上课教师！"});
                    return;
                }

                var item={
                    week: vm.courseInfo.week,
                    day: vm.courseInfo.day,
                    knob: knobInfo.knobs,
                    timeType: knobInfo.timeType[0],
                    knobStr: "第"+nameFormatStr.getKnobs(knobInfo.knobs)+"节",
                    teacherIds: nameFormatStr.getId(vm.courseInfo.teacherVo),
                    teacherNames: vm.courseInfo.teacherNames,
                    roomIds: nameFormatStr.getId(vm.courseInfo.roomVo),
                    buildingClassRoomNames: vm.courseInfo.buildingClassRoomNames,
                    courseName : vm.courseInfo.courseName,
                    pkTeachClassId : vm.courseInfo.pkTeachClassId,
                    adminClassIds : nameFormatStr.getId(vm.courseInfo.adminClassVo),
                    adminClassNames: vm.courseInfo.adminClassNames,
                    dateStr : vm.courseInfo.dateStr,
                    weekInfoStr : vm.courseInfo.weekInfoStr,
                    status:-1,
                }
                var postData = {
                    teachClassId:item.pkTeachClassId,
                    week:item.week,
                    day:item.day,
                    knob:item.knob,
                    timeType:item.timeType,
                    termId:vm.termId,
                    dateTime:vm.courseInfo.date
                };
                console.log(item);
                //判断教学日志表是否存在项目
                $http.post(originBaseUrl + "/third/jxrzResultKnob/vailJxrzItem.htm",postData).success(function(data){
                    if(data.status==0){
                        storageService.setItem(storageKey,vm.courseInfo);
                        $location.path("/jxrz_submitHourCourse").search({
                            "knobInfo":angular.toJson(item),
                            "termId":postData.termId,
                            "jxrzTableId":data.result,
                            "storageKey":storageKey,
                            "isTimeTable":vm.isTimeTable,
                            "goBack":"jxrz_resultKnob",

                    });
                    }else{
                        ynuiNotification.error({msg: data.message});
                    }
                });
            }
        };
        if(!knobInfo){
            vm.findMobilaWeek();
            vm.findCurrentUserName();
        }else{
            var courseInfo=storageService.getItem(storageKey);
            if(!courseInfo){
                vm.findTimeTableKnobNum(true);
            }else{
                storageService.clearKey(storageKey);
                vm.courseInfo=courseInfo;
            }
        }
}])
//随机选择周次登记日志
.controller("jxrzAddWeekCourseController", ['$scope', '$http', '$ionicModal', '$ionicLoading', 'nameFormatStr', '$location',"ynuiNotification","$ionicPopup",
    function ($scope, $http, $ionicModal, $ionicLoading, nameFormatStr, $location,ynuiNotification,$ionicPopup) {
        var knobInfo = angular.fromJson($location.search().knobInfo);
        var termId = $location.search().termId;
        var vm=$scope.vm={
            termId:termId,
            userId:"",
            modal:"",
            courseInfo:{
                userId:"",//当前用户
                week:[],
                weekList:[],//总周次
                courseName:"",
                pkTeachClassId:"",
                adminClassVo:[],
                adminClassNames:"",
                roomVo:[],
                buildingClassRoomNames:"",
                teacherNames:"",
                teacherVo:[],
                hourUnit:2//2周
            },
            findCurrentUserName:function(){
                $http.post(originBaseUrl + "/third/jxrzResultKnob/getUserNameById.htm").success(function(data){
                    if(data.status==0 && data.result){
                        vm.courseInfo.teacherVo.push({id:data.result.id,name:data.result.name});
                        vm.courseInfo.userId=data.result.id;
                        vm.courseInfo.teacherNames=data.result.name;
                    }else if(data.status==-1){
                        ynuiNotification.error({msg: "获取数据失败！"});
                    }
                });
            },
            //选课课程
            getCourseList:function(){
                // 回填
                $scope.$on("update_hour_course",function (event, data) {
                    vm.courseInfo.courseName=data.courseName;
                    vm.courseInfo.pkTeachClassId=data.pkTeachClassId;
                    vm.courseInfo.adminClassVo=[];
                    vm.courseInfo.adminClassNames=data.adminClassNames;
                    if(data.adminClassIds.length>0){
                        var adminClassName=data.adminClassNames.split(",");
                        angular.forEach(data.adminClassIds,function(adminClassId,_index){
                            vm.courseInfo.adminClassVo.push({id:adminClassId,name:adminClassName[_index]});
                        })
                    }
                    vm.courseInfo.week=[];
                    vm.courseInfo.weekStr=[];
                    vm.modal.hide();
                });
                $ionicModal.fromTemplateUrl('templates/jxrz/hourunit/selectCourse.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.modal=modal;
                    vm.modal.show();
                });
            },
            /*周次弹出框*/
            initWeekListModel:function(){
                $ionicModal.fromTemplateUrl('studyPlan.html',{
                    scope:$scope,
                    animation:'slide-in-left'
                }).then(function(modal){
                    vm.modal = modal;
                    vm.modal.show();
                });

            },
            changeDay:function(week){
                if(vm.courseInfo.week.indexOf(week)>-1){
                    vm.courseInfo.week.splice(vm.courseInfo.week.indexOf(week),1);
                }else{
                    vm.courseInfo.week.push(week);
                }
                vm.courseInfo.weekStr=nameFormatStr.getKnobs(vm.courseInfo.week);
                vm.getPKTeachClassInfoById();
            },
            //获取老师和教师
            getPKTeachClassInfoById:function(){
                $http.post(originBaseUrl + "/third/jxrzResultKnob/getPKTeachClassInfoById.htm?teachClassId="+vm.courseInfo.pkTeachClassId
                +"&weeks="+vm.courseInfo.week).success(function(data){
                    if(data.status==0){
                        var vo=data.result;
                        vm.courseInfo.roomVo=vo.room;
                        vm.courseInfo.buildingClassRoomNames=nameFormatStr.getName(vo.room);
                        vm.courseInfo.teacherVo=vo.teacher;
                        vm.courseInfo.teacherNames=nameFormatStr.getName(vo.teacher);
                    }else if(data.status==-1){
                        ynuiNotification.error({msg: "获取数据失败！"});
                    }
                });
            },
            //获取教学班的总周次
            showWeekListModel:function(){
                $http.post(originBaseUrl + "/third/jxrzResultKnob/getPKTeachClassWeek.htm?teachClassId="+vm.courseInfo.pkTeachClassId).success(function(data){
                    if(data.status==0 && data.result){
                        $scope.addWeekList=[];
                        vm.courseInfo.weekList=data.result;
                        if(!vm.courseInfo.weekList || vm.courseInfo.weekList.length==0){
                            ynuiNotification.error({msg: "没有获取到教学班的周次！"});
                        }
                        var weekLength=3-vm.courseInfo.weekList.length%3;
                        if(weekLength<3){
                            for(var i=0;i<weekLength;i++){
                                $scope.addWeekList.push(i);
                            };
                        }
                        vm.initWeekListModel();
                    }else if(data.status==-1){
                        ynuiNotification.error({msg: "获取数据失败！"});
                    }
                });
            },
            //选择班级
            getClassList:function(){
                // 回填
                $scope.$on("update_hour_class",function (event, data) {
                    vm.courseInfo.adminClassNames=nameFormatStr.getName(data);
                    vm.courseInfo.adminClassVo=data;
                    vm.modal.hide();
                });
                $ionicModal.fromTemplateUrl('templates/jxrz/hourunit/searchClassList.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.modal=modal;
                    vm.modal.show();
                });
            },
            //选择教室
            getRoomList:function(){
                // 回填
                $scope.$on("update_hour_room",function (event, data) {
                    vm.courseInfo.roomVo=data;
                    vm.courseInfo.buildingClassRoomNames=nameFormatStr.getName(data);
                    vm.modal.hide();
                });
                $ionicModal.fromTemplateUrl('templates/jxrz/hourunit/searchRoomList.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.modal=modal;
                    vm.modal.show();
                });
            },
            //选择教师
            getTeacherList:function(){
                if(!vm.courseInfo.pkTeachClassId){
                    ynuiNotification.error({msg: "请选择上课课程！"});
                    return;
                }
                // 回填
                $scope.$on("update_hour_teacher",function (event, data) {
                    vm.courseInfo.teacherVo=data;
                    vm.courseInfo.teacherNames=nameFormatStr.getName(data);
                    vm.modal.hide();
                });
                $ionicModal.fromTemplateUrl('templates/jxrz/hourunit/searchTeacherList.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.modal=modal;
                    vm.modal.show();
                });
            },
            //继续登记
            submitHourCourseInfo:function(){
                if(!vm.courseInfo.pkTeachClassId){
                    ynuiNotification.error({msg: "请选择上课课程！"});
                    return;
                }
                if(vm.courseInfo.week.length==0){
                    ynuiNotification.error({msg: "请选择上课周次！"});
                    return;
                }
                if(!vm.courseInfo.teacherNames){
                    ynuiNotification.error({msg: "请选择上课教师！"});
                    return;
                }
                var item={
                    week: vm.courseInfo.week,
                    termId: vm.termId,
                    teacherIds: nameFormatStr.getId(vm.courseInfo.teacherVo),
                    teacherNames: vm.courseInfo.teacherNames,
                    roomIds: nameFormatStr.getId(vm.courseInfo.roomVo),
                    buildingClassRoomNames: vm.courseInfo.buildingClassRoomNames,
                    courseName : vm.courseInfo.courseName,
                    pkTeachClassId : vm.courseInfo.pkTeachClassId,
                    adminClassIds : nameFormatStr.getId(vm.courseInfo.adminClassVo),
                    adminClassNames: vm.courseInfo.adminClassNames,
                    status:0,//草稿状态
                }
                console.log(item);
                $http.post(originBaseUrl + "/third/jxrzResultKnob/vailJxrzResultByWeekList.htm?weeks="+item.week+"&teachClassId="+item.pkTeachClassId).success(function(data){
                    if(data.status==0){
                        var week="";
                        angular.forEach(data.result,function(wk){
                            week+=wk+",";
                        })
                        if(week){
                            $ionicPopup.confirm({
                                title: '添加提示',
                                template: "第"+week.substring(0,week.length-1)+"周已经添加日志，是否继续添加？",
                                cancelText: '取消',
                                okText: '确认'
                            }).then(function (data) {
                                if(data==true){
                                    vm.goWeekCourse(item);
                                }
                            });
                        }else{
                            vm.goWeekCourse(item);
                        }
                    }else if(data.status==-1){
                        ynuiNotification.error({msg: "获取数据失败！"});
                    }
                });
            },
            goWeekCourse:function(item){
                $location.path("/submitWeekCourse").search({"weekCourseInfo":angular.toJson(item),isLook:false,goBack:"jxrz_resultKnob"});
            }
        };
        if(!knobInfo || !knobInfo.id){
            vm.findCurrentUserName();
        }
}])
//选择课程
.controller("searchCourseController", ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', '$location',"ynuiNotification",
    function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location,ynuiNotification) {
        var oldVm = angular.copy($scope.vm.courseInfo);
        var termId = angular.copy($scope.vm.termId);
        var vm=$scope.vm={
            courseInfo:{
                courseName:"",
                courseId:"",
                isSelectAll:false,
                isDefault:false,
            },
            initPageInfo:function(){
                $scope.pageInfo = {
                    totalPage: 0,
                    pageSize: 20,
                    pageNumber: 0,
                    itemSize: 0
                };
            },
            /**
             * 切换tab
             * @param isSelectAll 是否查询所有
             * @param isDefault 默认是否查询数据
             */
            checkTab:function(isSelectAll,isDefault){
                vm.initPageInfo();
                vm.resultCoureList =[];
                vm.courseInfo.isSelectAll=isSelectAll;
                vm.courseInfo.isDefault=isDefault;
                if(isDefault) {
                    vm.getTeacherTimeTableListByCondition();
                }
            },
            getTeacherTimeTableListByCondition:function(){
                var url=originBaseUrl + "/third/jxrzResultKnob/getTeacherTimeTableListByCondition.htm";
                if(oldVm.hourUnit==2){
                    url=originBaseUrl + "/third/jxrzResultKnob/getTeachClassListByCondition.htm";
                }
                $http.post(url,{
                    isAll:vm.courseInfo.isSelectAll,
                    courseName:vm.courseInfo.courseName,
                    termId:termId,
                    hourUnit:oldVm.hourUnit,
                    pageNumber:$scope.pageInfo.pageNumber,
                    pageSize:$scope.pageInfo.pageSize
                }).success(function(data){
                    if(data.status!=-1){
                        angular.forEach(data.result.content,function(item){
                            vm.resultCoureList.push(item);
                        })
                        $scope.pageInfo = {
                            totalPage: data.result.totalPages,
                            pageSize: data.result.size,
                            pageNumber: data.result.number,
                            itemSize: data.result.totalElements
                        };
                        if (data.result.totalPages > 0) {
                            $scope.pageInfo.pageNumber = data.result.number + 1;
                        }
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        vm.checkedCourse(oldVm.pkTeachClassId);
                    }else{
                        ynuiNotification.error({msg: "获取数据失败！"});
                    }
                });
            },
            loadMore:function () {
                if ($scope.pageInfo.itemSize > vm.resultCoureList.length) {
                    vm.getTeacherTimeTableListByCondition();
                }
            },
            //回填数据
            checkedCourse:function(pkTeachClassId){
                angular.forEach(vm.resultCoureList,function(item){
                    if(pkTeachClassId==item.pkTeachClassId){
                        item.selected=true;
                    }else{
                        item.selected=false;
                    }
                })
            },
            //完成选择
            selectedCourse:function(){
                var courseInfo="";
                angular.forEach(vm.resultCoureList,function(item){
                    if(item.selected){
                        courseInfo=item;
                    }
                })
                if(!courseInfo){
                    ynuiNotification.error({msg: "请选择课程！"});
                    return;
                }
                $scope.$emit("update_hour_course",courseInfo);
            }
        };
        vm.checkTab(false,true);

}])
//查询班级
.controller("searchClassListController", [ '$scope', '$http','$ionicScrollDelegate',
        function ($scope, $http,$ionicScrollDelegate) {
            var oldVm = angular.copy($scope.vm.courseInfo);
            var vm=$scope.vm={
                search:false,
                className:"",
                classList:[],
                selectedClassList:[],
                initPageInfo:function(){
                    $scope.pageInfo = {
                        totalPage: 0,
                        pageSize: 20,
                        pageNumber: 0,
                        itemSize: 0
                    };
                },
                getAllClassList:function(isNull){
                    vm.search=true;
                    if(isNull){
                        vm.classList=[];
                        vm.initPageInfo();
                        $ionicScrollDelegate.scrollTop();
                    }
                    $http.get(originBaseUrl + "/third/jxrzResultKnob/findCourseTeachingClass.htm?className="+vm.className
                        +"&pageNumber="+$scope.pageInfo.pageNumber+"&pageSize="+$scope.pageInfo.pageSize).success(function (data) {
                        if(data.status == 0){
                            var ids=[];
                            angular.forEach(vm.selectedClassList,function(item){
                                ids.push(item.id);
                            })
                            angular.forEach(data.result.content,function(item){
                                var selected=false;
                                if(ids.indexOf(item.id)>-1){
                                    item.selected=true;
                                }
                                vm.classList.push({id:item.id,name:item.adminClassName,selected:selected});
                            })
                            $scope.pageInfo = {
                                totalPage: data.result.totalPages,
                                pageSize: data.result.size,
                                pageNumber: data.result.number,
                                itemSize: data.result.totalElements
                            };
                            if (data.result.totalPages > 0) {
                                $scope.pageInfo.pageNumber = data.result.number + 1;
                            }
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        }
                    });
                },
                loadMore:function () {
                    if ($scope.pageInfo.itemSize > vm.classList.length) {
                        vm.getAllClassList(false);
                    }
                },
                //回填数据
                checkedList:function(){
                    vm.selectedClassList=oldVm.adminClassVo;
                },
                //完成选择
                selectedClass:function(){
                    var infoVo=[];
                    angular.forEach(vm.selectedClassList,function(item){
                        infoVo.push({id:item.id,name:item.name});
                    })
                    $scope.$emit("update_hour_class",infoVo);
                },
                showClassListModal:function () {
                    $scope.classListShow = !$scope.classListShow;
                },
                //选中班级
                selectItemed :function (item) {
                    item.selected = !item.selected;
                    if(item.selected){
                        vm.selectedClassList.push(angular.copy(item));
                    }else{
                        var _index=-1;
                        angular.forEach(vm.selectedClassList,function(tea,index){
                            if(item.id=tea.id){
                                _index=index;
                            }
                        })
                        vm.selectedClassList.splice(_index,1);
                    }
                },
                //删除选中的数据
                unSelectedItem: function (index) {
                    vm.selectedClassList.splice(index,1);
                    angular.forEach(vm.classList,function(c){
                        c.selected = vm.selectedClassList.some(function (t) {
                            return t.id == c.id;
                        });
                    })
                }
            };
            vm.checkedList();
            $scope.$watch(function () {
                return vm.className;
            },function (newVal) {
                var timeout = window.setTimeout(function () {
                    if(vm.className){
                        vm.getAllClassList(true);
                    }else{
                        $scope.$apply(function () {
                            vm.classList = [];
                        })
                    }
                    window.clearTimeout(timeout);
                })
            });
            vm.initPageInfo();
    }])
//查询教室
.controller("searchRoomListController", [ '$scope', '$http',
    function ( $scope, $http) {
        var oldVm = angular.copy($scope.vm.courseInfo);
        var vm=$scope.vm={
            search:false,
            roomName:"",
            buildId:"",
            selectedClassList:[],
            allBuilding:[],
            allClassRoom:[],
            //完成选择
            selectedRoom:function(){
                var infoVo=[];
                angular.forEach(vm.selectedClassList,function(item){
                    infoVo.push({id:item.id,name:item.name});
                })
                $scope.$emit("update_hour_room",infoVo);
            },
            //回填数据
            checkedList:function(){
                vm.selectedClassList=oldVm.roomVo;
            },
            showClassListModal:function () {
                $scope.classListShow = !$scope.classListShow;
            },
            //选中教室
            selectItemed :function (item) {
                item.selected = !item.selected;
                if(item.selected){
                    vm.selectedClassList.push(angular.copy(item));
                }else{
                    var _index=-1;
                    angular.forEach(vm.selectedClassList,function(tea,index){
                        if(item.id=tea.id){
                            _index=index;
                        }
                    })
                    vm.selectedClassList.splice(_index,1);
                }
            },
            //删除选中的数据
            unSelectedItem: function (index,selectItem) {
                angular.forEach(vm.allClassRoom,function(item){
                    if(item.id==selectItem.id){
                        item.selected=false;
                    }
                })
                vm.selectedClassList.splice(index,1);
            },
            findAllBuilding:function(){
                $http.get(originBaseUrl + '/third/tkMobile/findAllBuilding.htm').success(function(data){
                    vm.allBuilding = data.result.content;
                    vm.selectedBuilding = {id: null, name: '楼栋'};
                })
            },
            selectBuilding:function(b){
                if (null != vm.selectedBuilding && vm.selectedBuilding.id === b.id) {
                    vm.selectedBuilding = {id: null, name: '楼栋'};
                } else {
                    vm.selectedBuilding = b;
                }
            },
            findClassRoomByConditions:function(){
                vm.search=true;
                vm.allClassRoom=[];
                var params = {
                    buildId: vm.selectedBuilding ? vm.selectedBuilding.id: null,
                    termId: vm.termId,
                    name: vm.classRoomName
                };
                $http.get(originBaseUrl + '/third/tkMobile/queryClassRoomByName.htm',{params: params}).success(function(data){
                    vm.allClassRoom= data.result;
                    var ids=[];
                    angular.forEach(vm.selectedClassList,function(item){
                        ids.push(item.id);
                    })
                    angular.forEach(vm.allClassRoom,function(item){
                        if(ids.indexOf(item.id)>-1){
                            item.selected=true;
                        }
                    })
                })
            }
        };
        $scope.$watch(function () {
            return vm.className;
        },function (newVal) {
            var timeout = window.setTimeout(function () {
                if(vm.className){
                    vm.getAllClassList();
                }else{
                    $scope.$apply(function () {
                        vm.allClassRoom = [];
                    })
                }
                window.clearTimeout(timeout);
            })
        });
        vm.findAllBuilding();
        vm.checkedList();
    }])
//查询教师
.controller("searchTeacherListController", [ '$scope', '$http', '$ionicModal', 'ynuiNotification',
        function ($scope, $http, $ionicModal, ynuiNotification) {
            var oldVm = angular.copy($scope.vm.courseInfo);
            var userId = oldVm.userId;
            var vm=$scope.vm={
                userId:userId,
                search:false,
                teacherName:"",
                teacherList:[],
                selectedClassList:[],
                getAllClassList:function(){
                    vm.search=true;
                    vm.teacherList=[];
                    $http.get(originBaseUrl + '/third/tkMobile/findTeacherByNameLike.htm?name='+vm.teacherName).success(function (data) {
                        if(data.status == 0){
                            vm.teacherList = data.result;
                            var ids=[];
                            angular.forEach(vm.selectedClassList,function(item){
                                ids.push(item.id);
                            })
                            angular.forEach(vm.teacherList,function(item){
                                if(ids.indexOf(item.id)>-1){
                                    item.selected=true;
                                }
                            })
                        }
                    });
                },
                //回填数据
                checkedList:function(){
                    vm.selectedClassList=oldVm.teacherVo;
                },
                //完成选择
                selectedTeacher:function(){
                    var infoVo=[];
                    angular.forEach(vm.selectedClassList,function(item){
                        infoVo.push({id:item.id,name:item.name});
                    })
                    if(infoVo.length==0){
                        ynuiNotification.error({msg: "请选择老师！"});
                        return;
                    }
                    $scope.$emit("update_hour_teacher",infoVo);
                },
                showModal:function () {
                    $scope.classListShow = !$scope.classListShow;
                },
                //选中
                selectItemed :function (item) {
                    item.selected = !item.selected;
                    if(item.selected){
                        vm.selectedClassList.push(angular.copy(item));
                    }else{
                        var _index=-1;
                        angular.forEach(vm.selectedClassList,function(tea,index){
                            if(item.id=tea.id){
                                _index=index;
                            }
                        })
                        vm.selectedClassList.splice(_index,1);
                    }
                },
                //删除选中的数据
                unSelectedItem: function (index,item) {
                    if(item.id==userId){
                        ynuiNotification.error({msg: "不能删除自己！"});
                        return;
                    }
                    if(item.id==oldVm.userId){
                        ynuiNotification.error({msg: "该教学日志记录是"+item.name+"老师登记，您不能删除他！"});
                        return;
                    }
                    vm.selectedClassList.splice(index,1);
                    angular.forEach(vm.teacherList,function(c){
                        c.selected = vm.selectedClassList.some(function (t) {
                            return t.id == c.id;
                        });
                    })
                }
            };
            $scope.$watch(function () {
                return vm.teacherName;
            },function (newVal) {
                var timeout = window.setTimeout(function () {
                    if(vm.teacherName){
                        vm.getAllClassList();
                    }else{
                        $scope.$apply(function () {
                            vm.teacherList = [];
                        })
                    }
                    window.clearTimeout(timeout);
                })
            });
            vm.checkedList();
        }])
