/**
 * 添加教学日志页面
 */
angular.module('starter').controller("jxrzAddInfoController",
    ['$scope', '$http', '$ionicModal', '$location', '$ionicScrollDelegate', "ynuiNotification", "$timeout","ynNavigator","$ionicPopup",
        function ($scope, $http, $ionicModal, $location, $ionicScrollDelegate, ynuiNotification, $timeout,ynNavigator,$ionicPopup) {
            var knobInfo = angular.fromJson($location.search().knobInfo);
            var termId = $location.search().termId;
            var jxrzTableId = $location.search().jxrzTableId;
            //是否是通过课表页面过来
            var isTimeTable = $location.search().isTimeTable;
            var vm = $scope.vm = {
                knobInfo: knobInfo,
                moreMsgStatus: true,
                initDate: {
                    weekList: [],//总周数
                    currentWeek: "",//当前周
                    selWeek: "",//选中的周
                    selContent: "",
                    termStudyPlan: [],//学期授课计划,
                    //考勤数据
                    attendAnceVO:{},
                    isValidAttendAnce: true,//是否验证考勤
                    attendAnceShow:false,//是否显示考勤
                },
                //授课计划
                studyPlan: {

                },
                //获取考勤数据
                getAttendAnceVo: function (isUpdate) {
                    $http.post(originBaseUrl + "/third/jxrzResultKnob/getAttendAnceVo.htm", vm.getData()).success(function (data) {
                        if (data.status == 0 ) {
                            vm.setAttendAnceVO(data.result);
                            if(isUpdate){
                                ynuiNotification.success({msg: "获取成功！"});
                            }
                        }
                    });
                },
                //判断教学日志表是否存在项目
                findTableItemList: function () {
                    $http.post(originBaseUrl + "/third/jxrzResultKnob/findTableItemList.htm", vm.getData()).success(function (data) {
                        if (data.status == 0 && data.result) {
                            vm.initJxrzParam(data.result);
                            //如果需要显示考勤 则查询考勤数据
                            if(vm.initDate.attendAnceShow){
                                vm.getAttendAnceVo();
                            }
                            //编辑回填数据
                            var resultVo = data.result.resultVO;
                            //回填计划情况
                            vm.getStudyPlan(resultVo);
                        } else {
                            ynuiNotification.error({msg: data.message});
                        }
                    });
                },
                //初始化数据
                initJxrzParam: function (result) {
                    //调课信息
                    var tkInfo = result.commonEntryVO;
                    var tableItem = [];
                    angular.forEach(result.tableItem, function (parent) {
                        angular.forEach(parent.jxrzItemVO, function (custom) {
                            //初始化数字类型的验证
                            if (custom.itemType == 1 && custom.inputLimit == 1) {
                                $scope.verifyNumberInit(custom);
                            }
                            //多选是否换行
                            custom.rowSpan=true;
                            if (custom.optionList) {
                                angular.forEach(custom.optionList, function (option) {
                                    if (option.optionName.length >6) {
                                        custom.rowSpan=false;
                                    }
                                    if (custom.code == 'changing-course-situation' && tkInfo) {
                                        if (option.optionName == tkInfo.key) {
                                            $scope.selectOption(custom, option);
                                            custom.value=tkInfo.value;
                                        }
                                    }
                                })
                            }
                            //是否存在考勤
                            if (custom.code && custom.code.indexOf("kq_") > -1) {
                                parent.isAttendance = true;
                                vm.initDate.attendAnceShow=true;
                            }

                        })
                        tableItem.push(parent);
                    })
                    /***初始化周次信息**/
                    angular.forEach(result.weekInfoList, function (week) {
                        vm.initDate.weekList.push(week);
                    });

                    //当前周
                    vm.initDate.currentWeek = result.currentWeek;
                    $scope.jxrzParam = {
                        //自定义字段
                        tableItem: tableItem,
                        realityKnob: result.resultTotal,//实际上课次数
                        planKnob: "",//计划课次
                        planWeek: "",//计划周次
                        teachContent:"",//计划内容
                        realityValue:"",//实际授课内容,
                        progressType: -1,//上课进度0:正常 1:滞后 2:超前',
                        progressDes:"",//上课进度说明,
                        progressWeek: "0",//计划周和实际周差距,
                        status:0,
                    }
                    console.log($scope.jxrzParam);
                },
                planKnobModel: function () {
                    if(vm.initDate.weekList.length>0){
                        $scope.studyPlanModel();
                        var week=1;
                        if(!vm.studyPlan.planWeek){
                            week=vm.initDate.currentWeek
                        }else{
                            week=vm.studyPlan.planWeek;
                        }
                        vm.selectWeek(week);
                    }else{
                        ynuiNotification.error({msg: "该课程未做学期授课计划，不能选择！"});
                    }
                },
                planKnobModelHide: function (isUpdate) {
                    if ($scope.modal) {
                        $scope.modal.hide();
                    }
                    if (isUpdate && vm.studyPlan) {
                        $scope.jxrzParam.planKnob = vm.studyPlan.planKnob;
                        $scope.jxrzParam.planWeek = vm.studyPlan.planWeek;
                        $scope.jxrzParam.teachContent = vm.studyPlan.teachContent;
                        $scope.jxrzParam.realityKnob=vm.studyPlan.planKnob;
                        $scope.jxrzParam.realityValue = vm.studyPlan.teachContent;
                        if($scope.jxrzParam.planWeek){
                            $scope.jxrzParam.progressWeek = vm.knobInfo.week - $scope.jxrzParam.planWeek;
                        }
                        if ($scope.jxrzParam.progressWeek == 0) {
                            $scope.jxrzParam.progressType = '0';
                        } else if ($scope.jxrzParam.progressWeek > 0) {
                            $scope.jxrzParam.progressType = '1';
                        } else {
                            $scope.jxrzParam.progressType = '2';
                        }
                        //作业回填
                        angular.forEach($scope.jxrzParam.tableItem, function (parent) {
                            angular.forEach(parent.jxrzItemVO, function (custom) {
                                if (custom.code == 'arrangement-task' && !custom.value) {
                                    custom.value = vm.studyPlan.homeWork;
                                }
                            })
                        })

                    }
                },
                clearContent: function () {
                    vm.initDate.selContent = "";
                },
                selectWeek: function (week) {
                    vm.initDate.selWeek = week;
                    vm.getTermStuyPlan();
                },
                checkedStudyPlan: function (item) {
                    vm.studyPlan = item;
                },
                //查询学期授课计划
                getTermStuyPlan: function () {
                    var param = {
                        teachClassId: vm.knobInfo.pkTeachClassId,
                        week: vm.initDate.selWeek,
                        teachContent: vm.initDate.selContent,
                    }
                    $http.post(originBaseUrl + "/third/jxrzResultKnob/getSKClassTimeDetails.htm", param).success(function (data) {
                        if (data.status == 0) {
                            vm.initDate.termStudyPlan = data.result;
                        }
                    });
                },
                //处理考勤数据
                setAttendAnceVO: function (attendAnceVO) {
                    if(!attendAnceVO || attendAnceVO.shouldTimes== 0){
                        $ionicPopup.confirm({
                            title: "<div class='font-12'>提示</div>",
                            template: "<div class='font-12 margin-top-5 margin-bottom-5'><label class='font-12 text-danger'>未登记课堂考勤</label>，不能登记日志！</div>",
                            buttons: [
                                {text: '返回', type: 'button-default',onTap:function(e){
                                        $scope.goBack();
                                }},
                                {text: '登记考勤', type: 'button-positive',onTap:function(e){
                                    var nowDate=knobInfo.dateStr.split("[今天]");
                                    nowDate=nowDate[nowDate.length-1];
                                    if(isTimeTable==true){
                                        var knobIndex=knobInfo.timeType+""+knobInfo.knob[knobInfo.knob.length-1];
                                        $location.path("/add_attendance").search({knob:knobIndex,nowDate:nowDate});
                                    }else{
                                        $location.path("/attendance").search({nowDate:nowDate,week:knobInfo.week,day:knobInfo.day});
                                    }
                                }}
                            ]
                        })
                        vm.initDate.isValidAttendAnce = true;
                    } else {
                        vm.initDate.isValidAttendAnce = false;
                    }
                    vm.initDate.attendAnceVO=attendAnceVO;
                    angular.forEach($scope.jxrzParam.tableItem, function (parent) {
                        angular.forEach(parent.jxrzItemVO, function (custom) {
                            if (custom.code && custom.code.indexOf("kq_") > -1) {
                                parent.isAttendance = true;
                                custom.value = eval('attendAnceVO.' + custom.code.replace("kq_", ""));
                            }
                        })
                        if (parent.isAttendance) {
                            parent.absentNames = attendAnceVO.absentNames;
                        }
                    })
                },
                //修改上课信息
                updResultInfo:function(){
                    knobInfo.dataStr=vm.knobInfo.dateStr;
                    knobInfo.weekInfoStr=vm.knobInfo.weekInfoStr;
                    var storageKey = $location.search().storageKey;
                    $location.path("/jxrz_addHourCourse").search({"knobInfo":angular.toJson(knobInfo),"jxrzTableId":jxrzTableId,termId:termId,"storageKey":storageKey,isTimeTable:isTimeTable});;
                },
                getData:function(){
                    var postData = {
                        teachClassId: knobInfo.pkTeachClassId,
                        week: knobInfo.week,
                        day: knobInfo.day,
                        knob: knobInfo.knob,
                        termId: termId,
                        timeType: knobInfo.timeType,
                        jxrzTableId: jxrzTableId
                    };
                    return postData;
                },
                //计划情况
                getStudyPlan:function(resultVo){
                    vm.studyPlan = {
                        planKnob: resultVo.planKnob,
                        planWeek: resultVo.planWeek,
                        teachContent: resultVo.teachContent,
                        homeWork: resultVo.homeWork,
                    }
                    if(resultVo.planWeek>0){
                        vm.planKnobModelHide(true);
                    }
                },
                findJxrzResult:function(){
                    $http.post(originBaseUrl + "/third/jxrzResultKnob/findJxrzResult.htm?jxrzResultId=" + knobInfo.id + "&teachClassId=" + knobInfo.pkTeachClassId).success(function (data) {
                        if (data.status == 0) {
                            vm.initJxrzParam(data.result);
                            //编辑回填数据
                            var resultVo = data.result.resultVO;
                            //是否需要显示考勤
                            if(vm.initDate.attendAnceShow){
                                if(resultVo.attendAnceVO.shouldTimes>0){
                                    vm.setAttendAnceVO(resultVo.attendAnceVO);
                                }else{
                                    vm.getAttendAnceVo();
                                }
                            }
                            //计划情况
                            vm.getStudyPlan(resultVo);
                            $scope.jxrzParam.status = resultVo.status;//0:待提交 1:已提交待检查 2:已检查
                            $scope.jxrzParam.progressType = resultVo.progressType;//上课进度
                            $scope.jxrzParam.progressDes = resultVo.progressDes;//上课进度内容
                            $scope.jxrzParam.realityValue = resultVo.realityValue;
                            var itemMap = new Map();
                            angular.forEach(resultVo.itemListVo, function (item) {
                                if (item.optionList && item.optionList.length > 0) {
                                    var optionValues = [];
                                    angular.forEach(item.optionList, function (value) {
                                        optionValues.push(value);
                                    })
                                }
                                itemMap.put(item.jxrzTableItemId, {value: item.inputValue, optionList: optionValues});
                            })
                            //自定义字段回填
                            angular.forEach($scope.jxrzParam.tableItem, function (parent) {
                                angular.forEach(parent.jxrzItemVO, function (custom) {
                                    //调课
                                    if (custom.code == 'changing-course-situation') {
                                        angular.forEach(custom.optionList, function (option) {
                                            option.checked = false;
                                            if (resultVo.adjustType == option.optionValue) {
                                                option.checked = true;
                                            }
                                        })
                                        custom.value = resultVo.adjustDesc;
                                    } else if (custom.code == 'arrangement-task') {
                                        //作业
                                        custom.value = resultVo.homework;
                                    }
                                    var itemValue = itemMap.get(custom.id);
                                    if (itemValue && itemValue.value) {
                                        if(custom.itemType==1 && custom.inputLimit ==1){
                                            custom.value = parseFloat(itemValue.value);
                                        }else{
                                            custom.value = itemValue.value;
                                        }
                                    }
                                    if (itemValue && custom.optionList) {
                                        angular.forEach(custom.optionList, function (option) {
                                            option.checked = false;
                                            if (itemValue.optionList&&itemValue.optionList.indexOf(option.id) > -1) {
                                                option.checked = true;
                                            }
                                        })
                                    }
                                })
                            })
                            console.log($scope.jxrzParam);
                        } else {
                            ynuiNotification.error({msg: "系统错误，请联系管理员！"});
                        }
                    });
                },
                // 错误提示定位
                goErrorIndex:function (id) {
                    // 定位处理
                    if ($("#" + id).position()) {
                        var selectedTop = $("#" + id).position().top; // 相对父级（list）的位置
                        if (selectedTop) {
                            $ionicScrollDelegate.$getByHandle('listScroll').scrollTo(0, selectedTop, true);
                        }
                    }
                }
            }
            if (!knobInfo.id) {
                vm.findTableItemList();
            } else {
                vm.findJxrzResult();
            }


            /*课次弹出框*/
            $scope.studyPlanModel=function(){
                $ionicModal.fromTemplateUrl('studyPlan.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    $scope.modal = modal;
                    $scope.modal.show();
                });
            }

            // 当选选项
            $scope.selectOption = function (custom, option) {
                angular.forEach(custom.optionList, function (item) {
                    item.checked = false;
                })
                option.checked = true;
            }
            /**
             * 提交保存日志
             * @param status 0草稿，1正式提交
             */
            $scope.isSumbit = false;
            $scope.submitResultInfo = function (status) {
                $scope.isSumbit = true;
                //渲染完后在执行
                $timeout(function () {
                    if(status==1 ) {
                        //显示考勤，且考勤数据为空
                        if (vm.initDate.isValidAttendAnce && vm.initDate.attendAnceShow) {
                            ynuiNotification.error({msg: "还未登记课堂考勤，请先登记后重新获取！"});
                            return;
                        }
                        //上课进度
                        if ($scope.jxrzParam.progressType==-1) {
                            ynuiNotification.error({msg: "请选择上课进度！"});
                            vm.goErrorIndex('studyPlan');
                            return;
                        }
                        if ($scope.jxrzParam.realityValue=='' ||$scope.jxrzParam.realityValue==null) {
                            console.log("授课内容必填！");
                            vm.goErrorIndex("studyPlan");
                            return;
                        }
                    }
                    var param = {
                        id: vm.knobInfo.id,
                        status: status,
                        jxrzTableId: jxrzTableId,
                        termId: termId,
                        pkTeachClassId: vm.knobInfo.pkTeachClassId,
                        adminClassIds: vm.knobInfo.adminClassIds,
                        roomIds: vm.knobInfo.roomIds,
                        teacherIds: vm.knobInfo.teacherIds,
                        planWeek: $scope.jxrzParam.planWeek,//计划周
                        planKnob: $scope.jxrzParam.planKnob,//计划课次
                        teachContent: $scope.jxrzParam.teachContent,//计划上课内容
                        realityKnob: $scope.jxrzParam.realityKnob,//实际上课次数
                        realityValue: $scope.jxrzParam.realityValue,//实际上课内容
                        progressType: $scope.jxrzParam.progressType,//上课进度0:正常 1:滞后 2:超前'
                        progressDes: $scope.jxrzParam.progressDes,//上课进度内容
                        adjustType: $scope.jxrzParam.adjustType,//调课类型
                        adjustDesc: $scope.jxrzParam.adjustDesc,//调课备注
                        homework: $scope.jxrzParam.homework,//作业
                        itemListVo: [],
                        attendAnceVO:vm.initDate.attendAnceVO,//考勤数据
                    }
                    var customId = '';
                    angular.forEach($scope.jxrzParam.tableItem, function (parent) {
                        if(!parent.isAttendance){
                            angular.forEach(parent.jxrzItemVO, function (custom) {
                                $scope.validRequired(custom);
                                $scope.verifyNumber(custom);
                                //1:文本输入 2:日期时间型 3:单选  4:单选+文本输入 5:多选 6:多选+文本输入
                                if (custom.borderRed && custom.itemType<=2 && !customId) {
                                    console.log(custom.name + "项目必填！");
                                    customId = custom.id;
                                    return;
                                }
                                //自定义字段
                                var itemVo = {
                                    jxrzTableItemId: custom.id,
                                    itemType: custom.itemType,
                                    inputLimit: custom.inputLimit,
                                    optionList: [],
                                    code: custom.code ? custom.code : null
                                };
                                if (custom.optionList) {
                                    //选择主键
                                    angular.forEach(custom.optionList, function (option) {
                                        if (option.checked) {
                                            itemVo.optionList.push(option.id);
                                        }
                                    })
                                }
                                if (custom.value!=='' && custom.value!=null) {
                                    itemVo.inputValue = custom.value;
                                }
                                if(status==1){
                                    //输入框必填项未必填
                                    var isRequired=false,inputValue=!itemVo.inputValue&& itemVo.inputValue!="";
                                    if(custom.itemType>2){
                                        //输入框必填项未必填
                                        if(custom.isRequired&& itemVo.optionList.length==0 && !customId){
                                            ynuiNotification.error({msg: custom.name + "必选！"});
                                            customId = custom.id;
                                            return;
                                        }
                                        if (custom.itemType == 4 || custom.itemType == 6) {
                                            if (custom.choiceRequiredType == 1 &&inputValue) {
                                                isRequired = true;
                                            } else if(custom.choiceRequiredType == 2 &&inputValue) {
                                                //异常情况必填
                                                angular.forEach(custom.optionList, function (option) {
                                                    if (option.checked == true && option.status == 2) {
                                                        isRequired = true;
                                                    }
                                                })
                                            }
                                        }
                                    }else{
                                        isRequired = custom.isRequired&& inputValue;
                                    }
                                    if (isRequired && !customId) {
                                        ynuiNotification.error({msg: custom.name + "必填！"});
                                        customId = custom.id;
                                        return;
                                    }
                                    //数字类型填写错误不允许提交
                                    if(custom.valueError && !customId){
                                        customId = custom.id;
                                        return;
                                    }
                                }
                                param.itemListVo.push(itemVo);
                            })
                        }
                    })
                    if (status==1 && customId!='') {
                        vm.goErrorIndex('custom_'+customId);
                        return;
                    }
                    //登记节次
                    param.resultKnob = {
                        week: vm.knobInfo.week,
                        day: vm.knobInfo.day,
                        timeType: vm.knobInfo.timeType,
                        knob: vm.knobInfo.knob
                    }
                    $http.post(originBaseUrl + "/third/jxrzResultKnob/saveJxrzResult.htm", {json: angular.toJson(param)}).success(function (data) {
                        if (data.status == 0) {
                            ynuiNotification.success({msg: "保存成功！"});
                            $scope.goBack();
                        } else {
                            ynuiNotification.error({msg: "保存失败，请联系管理员！"});
                        }
                    });
                });
            }
            // 返回
            $scope.goBack = function () {
                $location.path("/jxrz_resultKnob").search({isBack: true});
            }
            /**
             * 必填验证框
             * @param custom
             * @returns {string}
             */
            $scope.validRequired = function (custom) {
                //下拉+文本是否必填判断
                if (!custom) {
                    return 'input-border';
                }
                custom.borderRed = false;
                if ($scope.isSumbit && (custom.value == '' || custom.value == null)) {
                    if (custom.itemType == 4 || custom.itemType == 6) {
                        if (custom.choiceRequiredType == 1) {
                            custom.borderRed = true;
                        } else if(custom.choiceRequiredType == 2) {
                            //异常情况必填
                            angular.forEach(custom.optionList, function (option) {
                                if (option.checked == true && option.status == 2) {
                                    custom.borderRed = true;
                                }
                            })
                        }
                    } else if (custom.isRequired) {
                        custom.borderRed = true;
                    }
                }
                if (custom.borderRed) {
                    // custom.valueError=custom.name+"不能为空！";
                    return 'input-border-red';
                }
                return 'input-border';
            }
            /**
             * 固定项目值发送变化自动指定给对应变量
             */
            $scope.updFixedItem = function (custom) {
                if (custom.code == 'changing-course-situation') {
                    //调课
                    var adjustType = 0;
                    angular.forEach(custom.optionList, function (option) {
                        if (option.checked) {
                            adjustType = option.optionValue;
                        }
                    })
                    $scope.jxrzParam.adjustType = adjustType;
                    $scope.jxrzParam.adjustDesc = custom.value;
                } else if (custom.code == 'arrangement-task') {
                    //作业
                    $scope.jxrzParam.homework = custom.value;
                }
                return $scope.validRequired(custom);
            }
            //验证自定义无文本输入数字的范围
            $scope.verifyNumber = function (custom) {
                if(!(custom.itemType==1 && custom.inputLimit ==1)){
                    return;
                }
                custom.valueError = "";
                if (!custom.value && custom.value!='0') {
                    return;
                }
                angular.forEach(custom.fixedItemLimitList, function (item) {
                    if (item.beginValue > custom.value || item.endValue < custom.value) {
                        custom.valueError = custom.fixedItemLimit;
                    }
                })
                var checkRule = null, errorMsg = null;
                if (custom.decimalMaxLength) {
                    eval("checkRule = \/^-?\\d{1," + custom.maxLength + "}(\\.\\d{1," + custom.decimalMaxLength + "})?$\/");
                    errorMsg = "请输入整数位不大于" + custom.maxLength + "位,小数位不大于" + custom.decimalMaxLength + "位的数字。";
                } else if (1 == custom.inputLimit) {
                    eval("checkRule=\/^-?\\d{1," + custom.maxLength + "}$\/");
                    errorMsg = "请输入不大于" + custom.maxLength + "位的整数。";
                }
                if (custom.value && checkRule && !checkRule.test(custom.value)) {
                    custom.valueError = errorMsg;
                }
            }
            //初始化验证数字类型
            $scope.verifyNumberInit = function (custom) {
                //整数和小数
                var fixedItemLimitVo = null;
                if (custom.maxLength && !custom.decimalMaxLength) {
                    if (custom.digitalRange[0] && !custom.digitalRange[2]) {
                        fixedItemLimitVo = (!custom.digitalRange[1] ? "1" : "0") + "~" + $scope.getNumber(custom, 1, 9);
                    } else if (!custom.digitalRange[0] && custom.digitalRange[2]) {
                        fixedItemLimitVo = "-" + $scope.getNumber(custom, 1, 9) + "~" + (!custom.digitalRange[1] ? "-1" : "0");
                    } else if (custom.digitalRange[0] && !custom.digitalRange[1] && custom.digitalRange[2]) {
                        fixedItemLimitVo = "1~" + $scope.getNumber(custom, 1, 9) + "或-" + $scope.getNumber(custom, 1, 9) + "~-1";
                    } else if (custom.digitalRange[0] && custom.digitalRange[1] && custom.digitalRange[2]) {
                        fixedItemLimitVo = "-" + $scope.getNumber(custom, 1, 9) + "~" + $scope.getNumber(custom, 1, 9);
                    }
                } else if (!custom.maxLength && custom.decimalMaxLength) {
                    if (custom.digitalRange[0] && !custom.digitalRange[2]) {
                        fixedItemLimitVo = (!custom.digitalRange[1] ? $scope.getNumber(custom, 2, 1) : "0") + "~" + $scope.getNumber(custom, 2, 9);
                    } else if (!custom.digitalRange[0] && custom.digitalRange[2]) {
                        fixedItemLimitVo = "-" + $scope.getNumber(custom, 2, 9) + "~" + (!custom.digitalRange[1] ? $scope.getNumber(custom, 2, 1) : "0");
                    } else if (custom.digitalRange[0] && !custom.digitalRange[1] && custom.digitalRange[2]) {
                        fixedItemLimitVo = $scope.getNumber(custom, 2, 1) + "~" + $scope.getNumber(custom, 2, 9) + "或-" + $scope.getNumber(custom, 2, 9) + "~-" + $scope.getNumber(custom, 2, 1);
                    } else if (custom.digitalRange[0] && custom.digitalRange[1] && custom.digitalRange[2]) {
                        fixedItemLimitVo = "-" + $scope.getNumber(custom, 2, 9) + "~" + $scope.getNumber(custom, 2, 9);
                    }
                } else if (custom.maxLength && custom.decimalMaxLength) {
                    if (custom.digitalRange[0] && !custom.digitalRange[2]) {
                        fixedItemLimitVo = (!custom.digitalRange[1] ? $scope.getNumber(custom, 2, 1) : "0") + "~" + $scope.getNumber(custom, 1, 9) + "." + $scope.getNumber(custom, 3, 9);
                    } else if (!custom.digitalRange[0] && custom.digitalRange[2]) {
                        fixedItemLimitVo = "-" + $scope.getNumber(custom, 1, 9) + "." + $scope.getNumber(custom, 3, 9) + "~-" + (!custom.digitalRange[1] ? $scope.getNumber(custom, 2, 1) : "0");
                    } else if (custom.digitalRange[0] && !custom.digitalRange[1] && custom.digitalRange[2]) {
                        fixedItemLimitVo = "-" + $scope.getNumber(custom, 1, 9) + "." + $scope.getNumber(custom, 3, 9) + "~-" + $scope.getNumber(custom, 2, 1) + "或" + $scope.getNumber(custom, 2, 1) + "~" + $scope.getNumber(custom, 1, 9) + "." + $scope.getNumber(custom, 3, 9);
                    } else if (custom.digitalRange[0] && custom.digitalRange[1] && custom.digitalRange[2]) {
                        fixedItemLimitVo = "-" + $scope.getNumber(custom, 1, 9) + "." + $scope.getNumber(custom, 3, 9) + "~" + $scope.getNumber(custom, 1, 9) + "." + $scope.getNumber(custom, 3, 9);
                    }
                }
                custom.fixedItemLimitList = [];
                if (fixedItemLimitVo) {
                    angular.forEach(fixedItemLimitVo.split("或"), function (item) {
                        var values = item.split("~");
                        custom.fixedItemLimitList.push({
                            beginValue: parseFloat(values[0]),
                            endValue: parseFloat(values[1])
                        });
                    })
                }
            };
            $scope.getNumber = function (custom, type, num) {
                if (type == 1) {
                    switch (parseInt(custom.maxLength)) {
                        case 1:
                            return 9;
                        case 2:
                            return 99;
                        case 3:
                            return 999;
                        case 4:
                            return 9999;
                    }
                } else if (type == 2) {
                    if (num == 1) {
                        switch (parseInt(custom.decimalMaxLength)) {
                            case 1:
                                return 0.1;
                            case 2:
                                return 0.01;
                            case 3:
                                return 0.001;
                        }
                    } else if (num == 9) {
                        switch (custom.decimalMaxLength) {
                            case 1:
                                return 0.9;
                            case 2:
                                return 0.99;
                            case 3:
                                return 0.999;
                        }
                    }
                } else if (type == 3) {
                    switch (parseInt(custom.decimalMaxLength)) {
                        case 1:
                            return 9;
                        case 2:
                            return 99;
                        case 3:
                            return 999;
                    }
                }
            }
            var goBack =$location.search().goBack;
            // 默认关闭微应用
            ynNavigator.registerBackAction(function () {
                var confirmPopup = $ionicPopup.confirm({
                    title: "提示",
                    template: '确定要放弃当前编辑内容吗？',
                    cancelText: "继续编辑",
                    okText: "放弃"
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        if(goBack){
                            ynNavigator.pop(true);
                        }else{
                            ynNavigator.finish();
                        }
                    }
                });
            }, 101)
        }])
//查看学时教学日志信息
.controller("jxrzScanInfoController",
    ['$scope', '$http', '$ionicModal', '$location', 'modalManager', "ynuiNotification", "ynNavigator",
        function ($scope, $http, $ionicModal, $location, modalManager, ynuiNotification, ynNavigator) {
            var knobInfo = angular.fromJson($location.search().knobInfo);
            $scope.moreMsgStatus = true;
            $http.post(originBaseUrl + "/third/jxrzResultKnob/findJxrzResult.htm?jxrzResultId=" + knobInfo.id + "&teachClassId=" + knobInfo.pkTeachClassId).success(function (data) {
                if (data.status == 0) {
                    $scope.knobInfo = data.result.knobInfo;
                    $scope.knobInfo.weekInfoStr=data.result.weekInfoStr;
                    //编辑回填数据
                    var resultVo = data.result.resultVO;
                    $scope.jxrzParam=resultVo;
                    $scope.jxrzParam.tableItem=initJxrzParam(data.result, resultVo.attendAnceVO);
                    $scope.jxrzParam.progressWeek = $scope.knobInfo.week - $scope.jxrzParam.planWeek;
                    var itemMap = new Map();
                    angular.forEach(resultVo.itemListVo, function (item) {
                        if (item.optionList && item.optionList.length > 0) {
                            var optionValues = [];
                            angular.forEach(item.optionList, function (value) {
                                optionValues.push(value);
                            })
                        }
                        itemMap.put(item.jxrzTableItemId, {value: item.inputValue, optionList: optionValues});
                    })
                    //自定义字段回填
                    angular.forEach($scope.jxrzParam.tableItem, function (parent) {
                        angular.forEach(parent.jxrzItemVO, function (custom) {
                            //调课
                            if (custom.code == 'changing-course-situation') {
                                angular.forEach(custom.optionList, function (option) {
                                    option.checked = false;
                                    if (resultVo.adjustType == option.optionValue) {
                                        option.checked = true;
                                    }
                                })
                                custom.value = resultVo.adjustDesc;
                            } else if (custom.code == 'arrangement-task') {
                                //作业
                                custom.value = resultVo.homework;
                            }
                            var itemValue = itemMap.get(custom.id);
                            if (itemValue && itemValue.value) {
                                custom.value = itemValue.value;
                            }
                            if (itemValue && custom.optionList) {
                                angular.forEach(custom.optionList, function (option) {
                                    option.checked = false;
                                    if (itemValue.optionList &&itemValue.optionList.indexOf(option.id)>-1) {
                                        option.checked = true;
                                    }
                                })
                            }
                        })
                    })
                    // console.log($scope.jxrzParam);
                } else {
                    ynuiNotification.error({msg: "系统错误，请联系管理员！"});
                }
            });

            /**
             * 初始化数据
             * @param result
             * @param attendAnceVO 考勤数据
             */
            function initJxrzParam(result, attendAnceVO) {
                //调课信息
                var tkInfo = result.commonEntryVO;
                var tableItem = [];
                angular.forEach(result.tableItem, function (parent) {
                    //处理考勤数据
                    angular.forEach(parent.jxrzItemVO, function (custom) {
                        if (custom.code && custom.code.indexOf("kq_") > -1) {
                            parent.isAttendance = true;
                            custom.value = eval('attendAnceVO.' + custom.code.replace("kq_", ""));
                        }
                        //调课
                        if (custom.code == 'changing-course-situation' && tkInfo) {
                            angular.forEach(custom.optionList, function (option) {
                                if (option.optionName == tkInfo.key) {
                                    $scope.selectOption(custom, option);
                                    custom.value=tkInfo.value;
                                }
                            })
                        }
                    })
                    if (parent.isAttendance) {
                        parent.absentNames = attendAnceVO.absentNames;
                    }
                    tableItem.push(parent);
                })
                return tableItem;
            }
            var goBack =$location.search().goBack;
            if(goBack){
                ynNavigator.registerPrev(goBack);
            }else{
                // 默认关闭微应用
                ynNavigator.registerBackAction(function () {
                    ynNavigator.finish();
                }, 101)
            }
        }])
