/**
 * 添加教学日志页面 周课
 */
angular.module('starter').controller("submitWeekCourseController",
    ['$scope', '$http', '$location', "ynuiNotification", "$ionicPopup","stringsConstant","nameFormatStr","ynNavigator",
        function ($scope, $http,$location,  ynuiNotification, $ionicPopup,stringsConstant,nameFormatStr,ynNavigator) {
            var weekCourseInfo = angular.fromJson($location.search().weekCourseInfo);
            var isLook = angular.fromJson($location.search().isLook);
            if(isLook){
                ynNavigator.setNavTitle('查看教学日志详情');
            }
            console.log(weekCourseInfo);
            var vm=$scope.vm={
                weekCourseInfo:weekCourseInfo,
                isLook:isLook,//是否查看
                photos:[],//照片信息
                findWeekCourseInfo:function(){
                    $http.post(originBaseUrl + "/third/jxrzResultKnob/findJxrzWeekResult.htm?jxrzResultId=" +weekCourseInfo.id).success(function (data) {
                        if (data.status == 0) {
                            vm.weekCourseInfo=data.result;
                            // data.result.fsId=["123456.jpg","fsferer.MP4"];
                            if (data.result.fsId && data.result.fsId.length > 0) {
                                angular.forEach(data.result.fsId, function (fsId) {
                                    vm.photos.push({
                                        uri: stringsConstant.file.downloadServer() + fsId,
                                        fsId: fsId,
                                    });
                                });
                            }
                            if(!isLook){
                                vm.isLook=vm.weekCourseInfo.status==2;
                            }
                            vm.weekCourseInfo.weekStr=nameFormatStr.getKnobs(vm.weekCourseInfo.week);
                        } else {
                            ynuiNotification.error({msg: "系统错误，请联系管理员！"});
                        }
                    });
                },
                goBack:function() {
                    $location.path("/jxrz_resultKnob").search({isBack: true});
                },
                submitResultInfo:function(status){
                    if (vm.weekCourseInfo.fsId) {
                        if (vm.weekCourseInfo.fsId.length > 10) {
                            var alertPopup = $ionicPopup.alert({
                                title: '',
                                template: '最多只能上传10个文件!',
                                okText: '关闭'
                            });
                            alertPopup.then(function(res) {
                            });
                            return;
                        }
                    }
                    if(status==1){
                        if(!vm.weekCourseInfo.projectName){
                            ynuiNotification.error({msg: "请输入实训/实践项目名称"});
                            return;
                        }
                        if(vm.weekCourseInfo.fsId&& vm.weekCourseInfo.fsId.length==0){
                            ynuiNotification.error({msg: "请上传附件！"});
                            return;
                        }
                    }
                    vm.weekCourseInfo.status=status;
                    $http.post(originBaseUrl + "/third/jxrzResultKnob/saveJxrzWeekResult.htm",vm.weekCourseInfo).success(function (data) {
                        if (data.status == 0) {ynuiNotification.success({msg: "保存成功！"});
                            vm.goBack();
                        } else {
                            ynuiNotification.error({msg: "系统错误，请联系管理员！"});
                        }
                    });
                },    // 预览照片
                previewPhoto:function (photo) {
                    var cordovaFileOpen = cordova.plugins.disusered.open;
                    cordovaFileOpen(photo.uri, cordovaFileOpenSuccess, cordovaFileOpenError);
                    function cordovaFileOpenSuccess() {
                        // 从已安装程序中打开文件完成
                    }
                    function cordovaFileOpenError(code) {
                        if (code === 1) {
                            $ionicPopup.alert({
                                title: '文件预览提示',
                                template: '未能在手机已安装APP中找到可预览此文件的程序'
                            });
                        } else {
                            $ionicPopup.alert({
                                title: '文件预览提示',
                                template: '预览时发生了未知错误 #' + code
                            });
                        }
                    }
                }
            }
            //ID不为空，且为查看
            if(weekCourseInfo.id){
                vm.findWeekCourseInfo(weekCourseInfo.id);
            }else{
                vm.weekCourseInfo.weekStr=nameFormatStr.getKnobs(vm.weekCourseInfo.week);
            }
            var goBack =$location.search().goBack;
            ynNavigator.registerPrev(goBack);
            // 默认关闭微应用
            ynNavigator.registerBackAction(function () {
                if(!isLook){
                    var confirmPopup = $ionicPopup.confirm({
                        title: "提示",
                        template: '确定要放弃当前编辑内容吗？',
                        cancelText: "继续编辑",
                        okText: "放弃"
                    });
                    confirmPopup.then(function (res) {
                        if (res) {
                            ynNavigatorBack();
                        }
                    });
                }else{
                    ynNavigatorBack();
                }
            }, 101);
            function ynNavigatorBack(){
                if(goBack){
                    ynNavigator.pop(true);
                }else{
                    ynNavigator.finish();
                }
            }
        }])
