(function () {
    'use strict';

    angular
        .module('starter')
        .config(stateConfig)
        .controller('jxrzResultKnobController', jxrzResultKnobController)
        .controller('jxrzCheckPathController', jxrzCheckPathController);

    stateConfig.$inject = ['$stateProvider'];
    function stateConfig($stateProvider) {
        $stateProvider
            //查询老师的上课课表信息
            .state('jxrz_resultKnob', {
                firstPage: true,
                url: '/jxrz_resultKnob',
                templateUrl: 'templates/jxrz/jxrz_resultKnob.html',
                controller: 'jxrzResultKnobController',
                data:{
                    micro: true, // 是否启用选项卡
                    title: '登记教学日志',
                    prev: null//静态注册上级路由
                }
            })
            //添加教学日志页面
            .state('jxrz_submitHourCourse', {
                firstPage: true,
                url: '/jxrz_submitHourCourse',
                templateUrl: 'templates/jxrz/hourunit/jxrz_submitHourCourse.html',
                controller: 'jxrzAddInfoController',
                data:{
                    micro: false,
                    title: '登记教学日志',
                    prev: "jxrz_resultKnob"
                }
            })
            //查看教学日志
            .state('jxrz_scanInfo', {
                firstPage: true,
                url: '/jxrz_scanInfo',
                templateUrl: 'templates/jxrz/jxrz_scanInfo.html',
                controller: 'jxrzScanInfoController',
                data:{
                    micro: false,
                    title: '查看教学日志详情',
                    prev: "jxrz_resultKnob"
                }
            })
            //随机选择节次登记日志
            .state('jxrz_addHourCourse', {
                firstPage: true,
                url: '/jxrz_addHourCourse',
                templateUrl: 'templates/jxrz/hourunit/jxrz_addHourCourse.html',
                controller: 'jxrzAddHourCourseController',
                data:{
                    micro: false,
                    title: '登记教学日志',
                    prev: "jxrz_resultKnob"
                }
            })
            //随机选择周次登记日志
            .state('jxrz_addWeekCourse', {
                firstPage: true,
                url: '/jxrz_addWeekCourse',
                templateUrl: 'templates/jxrz/hourunit/jxrz_addWeekCourse.html',
                controller: 'jxrzAddWeekCourseController',
                data:{
                    micro: false,
                    title: '登记教学日志',
                    prev: "jxrz_resultKnob"
                }
            })
            //添加教学日志 周课
            .state('submitWeekCourse', {
                firstPage: true,
                url: '/submitWeekCourse',
                templateUrl: 'templates/jxrz/hourunit/jxrz_submitWeekCourse.html',
                controller: 'submitWeekCourseController',
                data:{
                    micro: false,
                    title: '登记教学日志',
                    prev: "jxrz_resultKnob"
                }
            })//根据课程和节次信息判断页面跳转路径
            .state('jxrz_check_path', {
                firstPage: true,
                url: '/jxrz_check_path',
                templateUrl: 'templates/jxrz/jxrzCheckPath.html',
                controller: 'jxrzCheckPathController'
            })
    }
    jxrzResultKnobController.$inject = ['$scope', '$http', '$sce', '$location', '$filter','$ionicPopup','ynuiNotification','storageService'];
    function jxrzResultKnobController($scope, $http, $sce, $location, $filter,$ionicPopup,ynuiNotification,storageService) {
        var baseUrl = originBaseUrl + "/third/kqkt/mobile";
        var searchObj = $location.search();
        $scope.changeWeek = changeWeek;
        $scope.changeDay  = changeDay;
        $scope.changeDayPrevAndNext = changeDayPrevAndNext;
        $scope.teacherData = {
            userId:searchObj.userId,
            dateStr:"",
            date:"",
            weekInfoStr:"",
            weekInfoCode:"",
            weekDayObjList:[],
            week:"",
            day:"",
            weekInfo:{},
            resultKnobList:[],
        };
        function findMobilaWeek(){
            $http.get(baseUrl + "/findKqktMobilaWeek.htm").success(function(data){
                if(data.status==0){
                    $scope.teacherData.weekInfo = data.result;
                    if($scope.teacherData.weekInfo){
                        $scope.teacherData.weekInfoCode = data.result.week+"_"+data.result.day;
                        $scope.teacherData.week = data.result.week;
                        $scope.teacherData.weekInfoStr = convertWeekStr($scope.teacherData.weekInfoCode);
                        getTodayStr(data.result.today);
                        var dataTime=storageService.getItem("dataTime");
                        if(dataTime){
                            $scope.teacherData.week=dataTime.week;
                            changeDay(dataTime.day);;
                            storageService.clearKey("dataTime");
                        }
                        setWeekDayObjList();
                        findTeacherTimeTableList();
                    }
                }
            });
        }
        function getTodayStr(today){
            var nowDate = $filter('date')(new Date(), 'yyyy-MM-dd');
            if (today === nowDate) {
                $scope.teacherData.dateStr = "[今天]"+today;
            } else {
                $scope.teacherData.dateStr = today;
            }
        }
        findMobilaWeek();
        function findTeacherTimeTableList() {
            var weekObj = getWeekInfoCodeObj();
            var week    = weekObj.week;
            var day     = weekObj.day;
            var termId  = $scope.teacherData.weekInfo.termId;
            var postData = {week:week,day:day,termId:termId};
            $http.post(originBaseUrl + "/third/jxrzResultKnob/findTeacherTimeTableList.htm",postData).success(function(data){
                if(data.status==0){
                    if(data.result && data.result.length > 0){
                        $scope.teacherData.resultKnobList = data.result;
                    }else{
                        $scope.teacherData.resultKnobList = [];
                    }
                }else{
                    ynuiNotification.error({msg: "获取数据失败！"});
                }
            });
        }
        function changeDay(weekCode) {
            $scope.teacherData.weekInfoStr = convertWeekStr(weekCode);
            $scope.teacherData.weekInfoCode = weekCode;
            var weekObj = getWeekInfoCodeObj();
            var week    = weekObj.week;
            var day     = weekObj.day;
            getDayStr(week,day);
            $scope.teacherData.week = week;
        }
        function getDayStr(week,day) {
            var getData = {week:week,day:day,termId:$scope.teacherData.weekInfo.termId};
            $http.get(baseUrl + "/queryDayStrByTermIdAndWeekAndDay.htm",{params:getData}).success(function(data){
                if(data.status==0){
                    getTodayStr(data.result);
                    //切换了日期刷新列表
                    findTeacherTimeTableList();
                }
            });
        }
        function changeWeek(op) {
            var totalWeek = $scope.teacherData.weekInfo.totalWeek;
            if(op == "next"){
                var result = parseInt($scope.teacherData.week) + 1;
                if(result <= totalWeek){
                    $scope.teacherData.week = result;
                    setWeekDayObjList();
                }
            }else if(op=="prev"){
                var result = parseInt($scope.teacherData.week) - 1;
                if(result > 0){
                    $scope.teacherData.week = result;
                    setWeekDayObjList();
                }
            }
        }
        function setWeekDayObjList() {
            var weekDayObjList = [];
            var weekDayList = $scope.teacherData.weekInfo.weekDayList;
            var week = $scope.teacherData.week;
            for(var i=0;i<weekDayList.length;i++){
                weekDayObjList.push({id:week+"_"+(i+1),name:weekDayList[i]});
            }
            $scope.teacherData.weekDayObjList = weekDayObjList;
        }

        function convertWeekStr(week){
            var w  = week.split("_");
            return  "第"+w[0]+"周"+getWeekDayStr(w[1]);
        }

        function getWeekDayStr(weekDay){
            var weekDayList = $scope.teacherData.weekInfo.weekDayList;
            for(var i=0;i<weekDayList.length;i++){
                if(weekDay == (i+1)){
                    return weekDayList[i];
                }
            }
            return "";
        }
        function getWeekInfoCodeObj() {
            var weekInfoCodeArr = $scope.teacherData.weekInfoCode.split("_");
            return {week:weekInfoCodeArr[0],day:weekInfoCodeArr[1]}
        }
        function changeDayPrevAndNext(f){
            var weekCode = getWeekInfoCodeObj();
            var week = parseInt(weekCode.week);
            var day = parseInt(weekCode.day);
            var weekLength = $scope.teacherData.weekInfo.weekDayList.length;
            var totalWeek = $scope.teacherData.weekInfo.totalWeek;
            if(f == "prev"){
                if((day - 1) == 0 && (week - 1) == 0){
                    ynuiNotification.error({msg: "已经是第一天了！"});
                    return;
                }else if((day - 1) == 0){
                    day = weekLength;
                    week = week - 1;
                }else{
                    day = day - 1;
                }
            }else{
                if( (day+1) > weekLength && (week+1) > totalWeek){
                    ynuiNotification.error({msg: "已经是最后一天了！"});
                    return;
                }else if((day+1) > weekLength){
                    day = 1;
                    week = week +1;
                }else{
                    day = day +1;
                }
            }
            changeDay(week+"_"+day);
        }
        $scope.changeStatus=function(status){
            switch (status) {
                case -3:
                    return "还未上课";
                case -2:
                    return "上课中";
                case -1:
                    return "未登记";
                case 0:
                    return "待提交";
                case 1:
                    return "待检查";
                case 2:
                    return "已检查";
            }
        }
        $scope.modalBoxClick = function(){
            $scope.isShowMore = !$scope.isShowMore;
        };
        /**
         * 进入添加页面
         */
        $scope.toAddInfo=function(item){
            if(item.status==-3){
                ynuiNotification.error({msg: "上课还未开始，不能提前登记日志！"});
                return;
            }
            storageService.setItem("dataTime",{
                week:$scope.teacherData.week,
                day:$scope.teacherData.weekInfoCode
            });
            item.dateStr=$scope.teacherData.dateStr;
            item.weekInfoStr=$scope.teacherData.weekInfoStr;
            var postData = {
                teachClassId:item.pkTeachClassId,
                week:item.week,
                day:item.day,
                knob:item.knob,
                timeType:item.timeType,
                jxrzResultId:item.id,
                termId:$scope.teacherData.weekInfo.termId
            };
            if(item.status==2){
                var data={status:2};
                toAddInfoPage(item,data);
                return;
            }
            //判断教学日志表是否存在项目
            $http.post(originBaseUrl + "/third/jxrzResultKnob/vailJxrzItem.htm",postData).success(function(data){
                toAddInfoPage(item,data);
            });
        }
        function toAddInfoPage(item,data){
            var goBack="jxrz_resultKnob";
            if(data.status==0 && data.result){
                if(item.knob && item.knob.length>0){
                    $location.path("/jxrz_submitHourCourse").search({
                        "knobInfo":angular.toJson(item),
                        "termId":$scope.teacherData.weekInfo.termId,
                        "jxrzTableId":data.result,
                        "isTimeTable":true,
                        "goBack":goBack
                    });
                }else{
                    $location.path("/submitWeekCourse").search({"weekCourseInfo":angular.toJson({id:item.id}),isLook:false,"goBack":goBack});
                }
            }else if(data.status==2){
                if(item.knob && item.knob.length>0){
                    $location.path("/jxrz_scanInfo").search({
                        "knobInfo":angular.toJson(item),
                        "termId":$scope.teacherData.weekInfo.termId,
                        "goBack":goBack
                    });
                }else{
                    $location.path("/submitWeekCourse").search({"weekCourseInfo":angular.toJson({id:item.id}),isLook:true,"goBack":goBack});
                }
            }else{
                ynuiNotification.error({msg: data.message});
            }
        }
        /**
         * 跳转选节次页面
         * @param hourUnit 1学时，2周
         */
        $scope.goAddCourseInfo=function(hourUnit){
            $location.path("/"+(hourUnit==1?"jxrz_addHourCourse":"jxrz_addWeekCourse")).search({termId:$scope.teacherData.weekInfo.termId});
        }
        /**
         * 删除教学日志
         * @param item
         */
        $scope.deleteJxrzResult=function(item){
            $ionicPopup.confirm({
                title: '提示',
                template: '确认要删除吗?',
                cancelText: '取消',
                okText: '确认'
            }).then(function (res) {
                if (res) {
                    $http.get(originBaseUrl + "/third/jxrzResultKnob/deleteJxrzResult.htm?teachClassId="+item.pkTeachClassId+"&jxrzResultId="+item.id).success(function(data){
                        if(data.status==0){
                            findTeacherTimeTableList();
                            ynuiNotification.success({msg: "删除成功！"});
                        }else{
                            ynuiNotification.error({msg: data.message});
                        }
                    });
                }
            });
        }
        $scope.$watch("teacherData.week", function () {
            if(!$scope.teacherData.week && !$scope.teacherData.weekInfo.termId){
                return;
            }
            $http.get(originBaseUrl + "/third/jxrzResultKnob/findWeekResultCount.htm?week="+$scope.teacherData.week+"&termId="+$scope.teacherData.weekInfo.termId).success(function(data){
                if(data.status==0){
                    var result=data.result;
                    angular.forEach($scope.teacherData.weekDayObjList,function(item){
                        var week_day=item.id.split("_");
                        item.total=result[week_day[1]];
                    })
                    console.log(data);
                }else{
                    ynuiNotification.error({msg: data.message});
                }
            });
        });
    }

    jxrzCheckPathController.$inject = ['$scope', '$http', '$sce', '$location'];
    function jxrzCheckPathController($scope, $http, $sce, $location) {
        var classId = $location.search().classId;
        var timeTypeKnob = $location.search().knob;
        /**
         * 进入添加页面
         */
        $scope.toAddInfo=function(){
            var knob=timeTypeKnob%10;
            var timeType=(timeTypeKnob-knob)/10;
            //判断教学日志表是否存在项目
            $http.get(originBaseUrl + "/third/jxrzResultKnob/vailThirdJxrzItemByKnob.htm?teachClassId="+classId+"&knob="+knob+"&timeType="+timeType).success(function(data){
                toAddInfoPage(data);
            });
        }
        function toAddInfoPage(data){
            var item=data.result;
            if(data.status==0 && data.result){
                $location.path("/jxrz_submitHourCourse").search({
                    "knobInfo":angular.toJson(item),
                    "termId":item.termId,
                    "jxrzTableId":item.jxrzTableId,
                    "isTimeTable":true
                });
            }else if(data.status==2){
                $location.path("/jxrz_resultKnob");
            }else{
                $scope.errorMessage=data.message;
            }
        }
        $scope.errorMessage="";
        $scope.toAddInfo();
    }
})();
