/**
 * 学生请假
 * @author qiucheng Lu
 * @Date 2021年4月7日15:57:19
 */
(function () {
    'use strict';

    angular.module('starter')
        .config(stateConfig)
        .controller('leaveViewCtrl', leaveViewCtrl)
        .controller('leaveRecordCtrl', leaveRecordCtrl)
        .controller('leaveModifyCtrl', leaveModifyCtrl)
        .controller('leaveDeleteCtrl', leaveDeleteCtrl)
        .controller('askforLeaveCtrl', askforLeaveCtrl)
        .controller('leaveRecordViewCtrl', leaveRecordViewCtrl)

    stateConfig.$inject = ['$stateProvider'];

    function stateConfig($stateProvider) {
        $stateProvider
        // 学生请假
            .state('leave_view', {
                url: '/leave_view',
                templateUrl: 'templates/leave/leave_view.html',
                data: {
                    micro: true,
                    title: '请假'
                },
                controller: 'leaveViewCtrl',
            })
            //流程审核
            .state('askforleave', {
                url: '/askforleave',
                templateUrl: 'templates/leave/askforleave/leave.html',
                data: {
                    title: '审批',
                    prev: 'leave_record'
                },
                controller: 'askforLeaveCtrl',
            })
            //学生作废
            .state('leave_delete', {

                url: '/leave_delete',
                templateUrl: 'templates/leave/leave_delete.html',
                data: {
                    title: '请假记录',
                    prev: 'leave_record'
                },
                controller: 'leaveDeleteCtrl',
            })
            //创建或修改请假
            .state('leave_createOrModify', {
                cache:false,
                url: '/leave_createOrModify',
                templateUrl: 'templates/leave/leave_createOrModify.html',
                data: {
                    micro: true,
                    title: '发起请假'
                },
                controller: 'leaveModifyCtrl',
            })
            //作废记录
            .state('leave_no', {
                url: '/leave_no',
                templateUrl: 'templates/leave/leave_no.html',
                data: {
                    title: '请假记录',
                    prev: 'leave_record'
                },
            })
            //请假记录
            .state('leave_record', {
                url: '/leave_record',
                templateUrl: 'templates/leave/leave_record.html',
                data: {
                    micro: true,
                    title: '请假记录'
                },
                controller: 'leaveRecordCtrl'
            })
            // 请假记录详情
            .state('leave_record_view', {
                url: '/leave_record_view',
                templateUrl: 'templates/leave/leave_record_view.html',
                data: {
                    title: '请假记录',
                    prev: 'leave_record'
                },
                controller: 'leaveRecordViewCtrl'
            })
        ;
    }

    leaveRecordCtrl.$inject = ['$location', '$scope', '$http', 'ynuiNotification', '$ionicScrollDelegate', "$ionicModal", "$ionicPopup"];
    function leaveRecordCtrl($location, $scope, $http, ynuiNotification, $ionicScrollDelegate, $ionicModal,$ionicPopup) {

        var basePath = originBaseUrl + "/third/leaveAndRelease/";

        $scope.getStatusName = getStatusName;
        $scope.searchRecord = searchRecord;
        $scope.moreRecord = moreRecord;
        $scope.toAnother = toAnother;
        $scope.showOperate = showOperate;
        $scope.goOperate = goOperate;

        var vm = $scope.vm = {
            searchInfo:{
                pageNumber:0,
                pageSize:20,
                status:""
            },
            lastPage:false,
            activeStatus:$location.search().backFlag?$location.search().activeStatus:"",
            statusList:[],
            recordList:[],
            selectItem:null

        };


        function getLeaveRecordStatus(activeStatus) {
            $http.post(basePath+"getLeaveRecordStatus.htm").success(function (data) {
                if (data.status === 0){
                    var total = 0;
                    vm.statusList = angular.copy(data.result);
                    if ($location.search().backFlag){
                        angular.forEach(vm.statusList,function (item) {
                            total += Number(item.name);
                            if (item.id == $location.search().activeStatus){
                                vm.searchInfo.status = item.id;
                                vm.activeStatus = item.id;
                            }
                        });
                    }else {
                        // 默认通过
                        angular.forEach(vm.statusList,function (item) {
                            total += Number(item.name);
                            if (item.id === "1"){
                                vm.searchInfo.status = item.id;
                                vm.activeStatus = item.id;
                            }
                        });
                    }
                    vm.statusList = [{id:"",name:total+""}].concat(vm.statusList);
                    if (vm.statusList && vm.statusList.length > 0){
                        // 默认全部
                        if (angular.isDefined(activeStatus) && vm.statusList.some(function (t) {t.id === activeStatus})){
                            vm.activeStatus = activeStatus;
                        }else {
                            vm.activeStatus = "";
                        }
                        getLeaveRecordPage();
                    }
                }else if (data.status === 10){

                }else{
                    ynuiNotification.error({msg: '获取数据失败！'});
                }
            });
        }

        function getLeaveRecordPage(flag) {
            $http.post(basePath+"getLeaveRecordPage.htm",vm.searchInfo).success(function (data) {
                if (data.status === 0){
                    if (flag){
                        vm.recordList = vm.recordList.concat(angular.copy(data.result.content));
                    }else {
                        vm.recordList = angular.copy(data.result.content);
                    }
                    vm.lastPage = data.result.lastPage;
                }else {
                    ynuiNotification.error({msg: '获取数据失败！'});
                }
            });
        }

        function searchRecord(status) {
            vm.searchInfo.pageNumber = 0;
            vm.searchInfo.status = status;
            vm.activeStatus = status;
            getLeaveRecordPage();
        }

        function moreRecord() {
            vm.searchInfo.pageNumber += 1;
            getLeaveRecordPage(true);
            scrollToTop();
        }

        //删除请假条
        function deleteLeaveInfoByStu() {
            $ionicPopup.confirm({
                title: '提示',
                template: '您确定要删除请假条?',
                cancelText: '取消',
                okText: '确定'
            }).then(function (flag) {
                if (flag) {
                    $http.post(basePath + "deleteLeaveInfoByStu.htm",{LeaveId:vm.selectItem.id}).success(function (data) {
                        if (data.status == 0) {
                            vm.searchInfo.pageNumber = 0;
                            getLeaveRecordStatus(vm.activeStatus);
                            ynuiNotification.success({msg: '操作成功'});
                            $scope.closeModal();
                        }else {
                            ynuiNotification.error({msg: '操作失败'});
                        }
                    });
                }
            });

        }

        function sellOff() {
            $scope.sellOffData = {
                cancellationReason:""
            };
            var sellOffConfig = {
                templateUrl: 'templates/leave/leave_sell_off.html',
                title: "您确定要将该请假条作废吗？",
                cssClass:'leave-popup',
                scope: $scope,
                buttons: [
                    {text: '取消'},
                    {
                        text: '<b>确认</b>',
                        type: 'button-positive',
                        onTap: function (e) {
                            if (!$scope.sellOffData.cancellationReason) {
                                e.preventDefault();
                                $ionicPopup.show({title: '提示', template: '请输入作废原因!', buttons: [{text: '确定', type: 'button-positive'}]});
                                return false;
                            }
                            $http.post(basePath + "leaveCancellation.htm", {
                                leavePassId: vm.selectItem.id,
                                cancellationReason: $scope.sellOffData.cancellationReason
                            }).success(function (data) {
                                if (data.status === 0) {
                                    $ionicPopup.show({
                                        title: '提示', template: '操作成功!',
                                        buttons: [{
                                            text: '确定', type: 'button-positive', onTap: function (e) {
                                                vm.searchInfo.pageNumber = 0;
                                                getLeaveRecordStatus(vm.activeStatus);
                                                $scope.closeModal();
                                            }
                                        }]
                                    });
                                } else {
                                    $ionicPopup.show({title: '提示', template: data.message, buttons: [{text: '确定', type: 'button-positive'}]});
                                }
                            });
                        }
                    }
                ]
            };
            $ionicPopup.show(sellOffConfig);
        }

        function goProcess() {
            $scope.closeModal();
            $location.path("/askforleave").search({"fromType": 0, "procInstId": vm.selectItem.procInstId, "fromBusiness": 1,state:"leave_view",activeStatus:vm.activeStatus});
        }

        function goDetail() {
            $scope.closeModal();
            $location.path("/leave_record_view").search({ "id": vm.selectItem.id,"status": vm.selectItem.status+"",activeStatus:vm.activeStatus});
        }

        function goModify() {
            $scope.closeModal();
            $location.path("/leave_createOrModify").search({"isModify": true, "leavePassId": vm.selectItem.id,isShow:vm.selectItem.status!="4"});
        }

        function scrollToTop() {
            $ionicScrollDelegate.$getByHandle('leaveRecordScroll').scrollTop();
        }

        function getStatusName(status) {
            var name = "";
            switch (status) {
                case '0':name="未提交";break;
                case '1':name="已通过";break;
                case '2':name="不通过";break;
                case '3':name="审核中";break;
                case '4':name="返回修改";break;
                default:name="全部";break;
            }

            return name;
        }

        function showOperate(type) {
            var flag = false;
            if (vm.selectItem){
                switch (type) {
                    // 补传证明
                    case 6: flag = vm.selectItem.status == '1' ||  vm.selectItem.status == '3';break;
                    // 查看
                    case 1:flag = vm.selectItem.status == '1' || vm.selectItem.status == '2' ||  vm.selectItem.status == '3';break;
                    // 修改
                    case 2:flag = vm.selectItem.status == '0' ||  vm.selectItem.status == '4';break;
                    // 删除
                    case 3:flag = vm.selectItem.status == '0' || vm.selectItem.status == '2' || vm.selectItem.status == '4';break;
                    // 作废
                    case 4:flag = vm.selectItem.canSellOff;break;
                    // 续假
                    case 5:flag = vm.selectItem.status == '1';break;
                    // 审批情况
                    case 7:flag = vm.selectItem.status == '1' || vm.selectItem.status == '2' || vm.selectItem.status == '3' || vm.selectItem.status == '4';break;
                    default:break;
                }
            }
            return flag;
        }

        function goOperate(type) {
            switch (type) {
                // 查看
                case 1:goDetail();break;
                // 修改
                case 2:goModify();break;
                // 删除
                case 3:deleteLeaveInfoByStu();break;
                // 作废
                case 4:sellOff();break;
                // 续假
                case 5:break;
                // 补传证明
                case 6:uploadEvidence();$scope.closeModal();break;
                // 审批情况
                case 7:goProcess();break;
                default:break;
            }
        }

        function toAnother() {
            $location.path("/leave_createOrModify").search({"isModify": false, "leavePassId": "",isShow:true});
        }

        function init() {
            getLeaveRecordStatus();
        }

        init();

        $ionicModal.fromTemplateUrl('operateButton.html',{
            scope:$scope,
            animation:'slide-in-left'
        }).then(function(modal){
            $scope.operateModal = modal;
        });
        $scope.bottomModalClick = function(item) {
            vm.selectItem = item;
            $scope.operateModal.show();
        };
        $scope.closeModal = function() {
            $scope.operateModal.hide();
        };

/***********************************************补传证明start********************************************************/
        /**
         * 补传证明弹框
         */
        function uploadEvidence() {
            //为学生补传证明材料组件配置
            $scope.evidenceConfig = {
                initFiles: vm.selectItem.fsIdList,//附件数组
                cameraOption:{
                    waterMark: moment().format("YYYY-MM-DD HH:mm:ss")//时间水印
                }
            };
            //上传材料
            var uploadEvidenceConfig = {
                templateUrl: 'templates/workspaceforteacher/stu_leave/leave_record_evidence.html',
                title: "补传证明材料",
                cssClass:'leave-evidence',
                scope: $scope,
                buttons: [
                    {text: '取消'},
                    {
                        text: '<b>确认</b>',
                        type: 'button-positive',
                        onTap: function (e) {

                            if ($scope.evidenceConfig.initFiles && $scope.evidenceConfig.initFiles.length > 0){
                                var params = {
                                    leaveNoteId: vm.selectItem.id,
                                    fsIdList: $scope.evidenceConfig.initFiles
                                }
                                $http.post(basePath+'uploadLeaveEvidence.htm',params).success(function (data){
                                    if (data.status == 0){
                                        ynuiNotification.success({msg: "上传成功！"});
                                        searchRecord(vm.activeStatus);
                                    }else {
                                        ynuiNotification.error({msg: "上传失败！"});
                                        e.preventDefault();
                                    }
                                })
                            }else {
                                ynuiNotification.error({msg: "请上传图片！"});
                                e.preventDefault();
                            }
                        }
                    }
                ]
            };
            $ionicPopup.show(uploadEvidenceConfig);
        }
/**************************************补传证明end******************************************************************/
    }

    leaveViewCtrl.$inject = ['$location', '$scope', '$http', 'ynuiNotification', '$ionicLoading', '$ionicScrollDelegate', "$timeout"];
    function leaveViewCtrl($location, $scope, $http, ynuiNotification, $ionicLoading, $ionicScrollDelegate, $timeout) {
        $scope.loadingError = false;
        $scope.loadingErrorInfo = "";
        $scope.queryUserInfo = function () {
            $http.get(originBaseUrl + "/third/leaveAndRelease/queryUserInfo.htm?needClass=true&time=" + (new Date()).getTime()).success(function (data) {
                if (data.status == 0) {
                    $scope.userInfo = data.result;
                    if ($scope.userInfo && $scope.userInfo.fsId) {
                        $scope.userInfo.fsId = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.userInfo.fsId;
                        $scope.userInfo.smallFsId = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.userInfo.smallFsId;
                    } else if ($scope.userInfo) {
                        if ($scope.userInfo.gender == '女') {
                            $scope.userInfo.fsId = originBaseUrl + "/mobile/img/userface_2.png";
                            $scope.userInfo.smallFsId = originBaseUrl + "/mobile/img/userface_2.png";
                        } else {
                            $scope.userInfo.fsId = originBaseUrl + "/mobile/img/userface_1.png";
                            $scope.userInfo.smallFsId = originBaseUrl + "/mobile/img/userface_1.png";
                        }
                    }
                }
            }).error(function () {
                $scope.loadingError = true;
                $scope.loadingErrorInfo = '加载失败，请重试！';
            });
        }
        //请假信息查询
        $scope.queryLeaveInfo = function () {
            $http.get(originBaseUrl + "/third/leaveAndRelease/queryLeaveInfoOfStu.htm?time=" + (new Date()).getTime()).success(function (data) {
                if (data.status == 0) {
                    $scope.leaveInfo = data.result;
                    angular.forEach($scope.leaveInfo, function (item) {
                        switch (item.status) {
                            case 0:
                                item.checkContent = "未提交";
                                break;
                            case 1:
                                item.checkContent = "通过";
                                break;
                            case 2:
                                item.checkContent = "不通过";
                                break;
                            case 3:
                                item.checkContent = "审核中";
                                break;
                            case 4:
                                item.checkContent = "返回修改";
                                break;
                        }
                    });
                    $scope.loadingError = false;
                }
            }).error(function () {
                $scope.loadingError = true;
                $scope.loadingErrorInfo = '加载失败，请重试！';
            });
        };
        $scope.queryUserInfo();
        $scope.queryLeaveInfo();
        $scope.queryLeaveInfoRefresh = function () {
            $scope.queryLeaveInfo();
            $ionicLoading.show({
                template: '正在刷新...'
            });
            $timeout(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            }, 500);
        };
        $scope.showProcInst = function (procInstId) {
            $location.path("/askforleave").search({"fromType": 0, "procInstId": procInstId, "fromBusiness": 1,state:"leave_view"});
        }

        //获取请假类型
        $scope.getLeaveType = function (dictCode) {
            $scope.leaveTypeCode = "";
            $http.get(originBaseUrl + "/third/leaveAndRelease/leaveType.htm?time=" + (new Date()).getTime()).success(function (data) {
                if (data.status == 0) {
                    $scope.leaveTypeList = data.result;
                    angular.forEach($scope.leaveTypeList, function (item) {
                        if (item.dictName == dictCode) {
                            $scope.leaveTypeCode = item.dictCode;
                        }
                    });
                    return $scope.leaveTypeCode;
                }
            });
        };
        //创建请假条
        $scope.createLeave = function () {
            $location.path("/leave_createOrModify").search({"isModify": false, "leavePassId": "",isShow:true});
        };
        //修改请假条
        $scope.showModifyLeave = function (no) {
            var i = 1;
            $scope.leaveInfo[no].moreType = false;
            angular.forEach($scope.leaveTypeList, function (item) {
                item.selected = false;
                if ($scope.leaveInfo[no].leaveTypeCode == item.dictCode) {
                    item.selected = true;
                    if (i > 5) {
                        $scope.leaveInfo[no].moreType = true;
                    }
                }
                i++;
            });
            $scope.leaveInfo[no].leaveTypeList = $scope.leaveTypeList;
            $location.path("/leave_createOrModify").search({"isModify": true, "leavePassId": $scope.leaveInfo[no].id,isShow:$scope.leaveInfo[no].status!="4"});
        };

        //删除请假条
        $scope.del = function (LeaveId) {
            $http.post(originBaseUrl + "/third/leaveAndRelease/deleteLeaveInfoByStu.htm?LeaveId=" + LeaveId).success(function (data) {
                if (data.status == 0) {
                    $scope.queryLeaveInfo();
                    ynuiNotification.success({msg: '删除成功'});
                }
            });
        };

        // 跳转请假记录
        $scope.toAnother = function () {
            $location.path("/leave_record");
        }

    }

    leaveModifyCtrl.$inject = ['stringsConstant', '$cordovaFileTransfer', '$cordovaFile', '$location', '$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', '$ionicPopup'];

    function leaveModifyCtrl(stringsConstant, $cordovaFileTransfer, $cordovaFile, $location, $scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $ionicPopup) {
        //参数初始化
        $scope.initData = false;
        $scope.initFile = false;
        $scope.wordNumber = 0;
        $scope.leaveParam = {
            id: "",
            leaveReason: "",
            leaveStartTime: null,
            leaveEndTime: null,
            passStartTime: null,
            passEndTime: null,
            isOutSchool: true,
            leaveDays: "1",
            isBackSleep: false,
            isTakeByParent: false
        };
        /*选择图片或拍照*/
        $scope.vm = {
            cameraPtion:{
                waterMark: moment().format("YYYY-MM-DD HH:mm:ss")
            },
            initFiles:[],
            initFile:false
        }

        $scope.showInfo = {
            isShow:angular.isDefined($location.search().isShow) ? $location.search().isShow : true
        }
        $scope.moreType = false;
        if ($location.search().isModify && $location.search().leavePassId) {//修改时
            $scope.leaveParam.id = $location.search().leavePassId;
            //查询请假信息
            $http.get(originBaseUrl + "/third/leaveAndRelease/queryMoraleduLeavePassShowById.htm?leavePassId=" + $scope.leaveParam.id).success(function (data) {
                if (data.status == 0) {
                    $scope.item = data.result;
                    if ($scope.item) {
                        //初始化添加（修改）信息
                        $scope.leaveParam = {
                            id: $scope.item.id,//ID
                            leaveStartTime: $scope.item.leaveStartTime,//请假开始时间
                            leaveEndTime: $scope.item.leaveEndTime,//请假结束时间
                            dictCode: $scope.item.leaveTypeCode,//请假类型
                            isOutSchool: $scope.item.outSchoolCode,//是否出校（默认否）
                            leaveReason: $scope.item.leaveReason,//请假原因
                            leaveDays: $scope.item.leaveDays,
                            isBackSleep: $scope.item.backSleepCode,//是否归寝（默认否）
                            isTakeByParent: $scope.item.takeByParentCode,
                            status: $scope.item.status
                        };
                        angular.forEach($scope.fourLeaveType, function (item) {
                            if ($scope.leaveParam.dictCode == item.dictCode) {
                                item.selected = true;
                            }
                        });
                        angular.forEach($scope.lastLeaveType, function (item) {
                            if ($scope.leaveParam.dictCode == item.dictCode) {
                                item.selected = true;
                            }
                        });
                        if ($scope.leaveParam.isOutSchool) {
                            $scope.leaveParam.passStartTime = $scope.item.passStartTime;
                            $scope.leaveParam.passEndTime = $scope.item.passEndTime;
                        }
                        if ($scope.item.attachmentList && $scope.item.attachmentList.length > 0) {
                            //赋值保存老的附件list信息
                            angular.forEach($scope.item.attachmentList, function (item) {
                                $scope.vm.initFiles.push(item.attachmentId);
                            });
                        }

                        $scope.initData = true;
                        $scope.initFile = true;
                    }
                }
            });
        }else {
            $scope.initFile = true;
        }
        //更多请假类型
        $scope.moreLeaveType = function () {
            $scope.moreType = !$scope.moreType;
        };
        //请假类型赋值
        $scope.selectLeaveType = function (code, no, num) {
            $scope.leaveParam.dictCode = code;
            var index = parseInt(no) + parseInt(num);
            angular.forEach($scope.fourLeaveType, function (item) {
                item.selected = false;
            });
            if (index < 5) {
                angular.forEach($scope.lastLeaveType, function (item) {
                    item.selected = false;
                });
                $scope.fourLeaveType[no].selected = true;
            } else {
                angular.forEach($scope.lastLeaveType, function (item) {
                    item.selected = false;
                });
                $scope.lastLeaveType[no].selected = true;
            }
        };
        //请假类型
        $scope.fourLeaveType = [];
        $scope.lastLeaveType = [];
        $scope.$watch(function () {
            return $scope.fourLeaveType.length + $scope.lastLeaveType.length;
        }, function () {
            if ($scope.fourLeaveType.length + $scope.lastLeaveType.length <= 5) {
                $scope.moreType = false;
            } else {
                $scope.moreType = true;
            }
        });
        $scope.queryUserInfo = function () {
            $http.get(originBaseUrl + "/third/leaveAndRelease/queryUserInfo.htm?needClass=false&time=" + (new Date()).getTime()).success(function (data) {
                if (data.status == 0) {
                    $scope.userInfo = data.result;
                    if ($scope.userInfo && $scope.userInfo.fsId) {
                        $scope.userInfo.fsId = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.userInfo.fsId;
                        $scope.userInfo.smallFsId = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.userInfo.smallFsId;
                    } else if ($scope.userInfo) {
                        if ($scope.userInfo.gender == '女') {
                            $scope.userInfo.fsId = originBaseUrl + "/mobile/img/userface_2.png";
                            $scope.userInfo.smallFsId = originBaseUrl + "/mobile/img/userface_2.png";
                        } else {
                            $scope.userInfo.fsId = originBaseUrl + "/mobile/img/userface_1.png";
                            $scope.userInfo.smallFsId = originBaseUrl + "/mobile/img/userface_1.png";
                        }
                    }
                }
            }).error(function () {
                $scope.loadingError = true;
                $scope.loadingErrorInfo = '加载失败，请重试！';
            });
        }
        //请假类型 -----后期还需修改
        var getLeaveType = function () {
            $http.get(originBaseUrl + "/third/leaveAndRelease/leaveType.htm?time=" + (new Date()).getTime()).success(function (data) {
                if (data.status == 0) {
                    var typeList = data.result;
                    if (!$location.search().isModify) {
                        $scope.leaveParam.dictCode = typeList[0].dictCode;
                        typeList[0].selected = true;
                    }
                    if (typeList.length >= 5) {
                        $scope.moreType = true;
                        $scope.fourLeaveType = typeList.splice(0, 5);
                        $scope.lastLeaveType = typeList;
                    } else {
                        $scope.fourLeaveType = typeList;
                    }
                }
            });
        };
        $scope.queryUserInfo();
        getLeaveType();

        //请假原因
        $scope.leaveReasonList = [];
        var getLeaveReason = function () {
            $http.get(originBaseUrl + "/third/leaveAndRelease/leaveReason.htm?time=" + (new Date()).getTime()).success(function (data) {
                if (data.status == 0) {
                    $scope.leaveReasonList = data.result;
                }
            });
        };
        getLeaveReason();
        //选择请假模板
        $scope.chooseTem = function (dictName) {
            $scope.leaveParam.leaveReason = dictName;
        };
        //两个时间相差天数 兼容firefox chrome
        $scope.getDays = function (sDate1, sDate2) {    //sDate1和sDate2是2006-12-18格式
            var dateSpan,
                iDays;
            sDate1 = Date.parse(sDate1);
            sDate2 = Date.parse(sDate2);
            dateSpan = sDate2 - sDate1;
            dateSpan = Math.abs(dateSpan);
            iDays = Math.floor(dateSpan / (24 * 3600 * 1000));
            return iDays + 1;
        };

        $scope.changeStartTime = function(){
            $scope.leaveParam.passStartTime = $scope.leaveParam.leaveStartTime;
            if($scope.leaveParam.leaveEndTime && $scope.leaveParam.leaveEndTime<$scope.leaveParam.leaveStartTime){
                $scope.leaveParam.leaveEndTime = $scope.leaveParam.leaveStartTime;
            }
            $scope.leaveParam.passStartTime = $scope.leaveParam.leaveStartTime;
            $scope.changeTimeLeave();
        }

        $scope.changeEndTime = function(){
            $scope.leaveParam.passEndTime = $scope.leaveParam.leaveEndTime;
            $scope.changeTimeLeave();
        }


        $scope.changePassStartTime = function () {
            if($scope.leaveParam.passEndTime && $scope.leaveParam.passEndTime<$scope.leaveParam.passStartTime){
                $scope.leaveParam.passEndTime = $scope.leaveParam.passStartTime;
            }
        };

        //出校时间随着请假时间变化
        $scope.changeTimeLeave = function () {
            if ($scope.leaveParam.leaveStartTime && $scope.leaveParam.leaveEndTime) {
                var beginDay = $scope.leaveParam.leaveStartTime.split(" ")[0];
                var endDay = $scope.leaveParam.leaveEndTime.split(" ")[0];
                var leaveDays = $scope.getDays(beginDay, endDay);
                var maxDays = $scope.leaveConfig && $scope.leaveConfig.maxDays ? $scope.leaveConfig.maxDays : 999;
                if (parseFloat(leaveDays) > maxDays) {
                    ynuiNotification.error({msg: '请假天数最多为' + maxDays + '天！'});
                }
                $scope.initData = true;
            }
        };

        function getDay(){
            var day = 0;
            if ($scope.leaveParam.leaveStartTime && $scope.leaveParam.leaveEndTime) {
                var beginDay = new Date($scope.leaveParam.leaveStartTime).getTime();
                var endDay = new Date($scope.leaveParam.leaveEndTime).getTime();
                if (endDay > beginDay){
                    // 天
                    day = Math.floor((endDay - beginDay) / 3600000 / 24);
                }
            }
            return day;
        }

        $scope.getShowHeight = function(){
            if ($scope.getShowDifferent()){
                return '70px';
            }else {
                return '50px';
            }
        }

        $scope.getShowDifferent = function(){
            var str = "";
            var day = getDay();
            if ($scope.initData && $scope.leaveParam && $scope.leaveParam.leaveDays != day && ($scope.leaveParam.leaveDays >= 1 || day >= 1)){
                str = "该天数与系统计算天数不一致，请核对";
            }
            return str;
        }

        $scope.showDayAndHour = function(){
            var str = "";
            if ($scope.leaveParam.leaveStartTime && $scope.leaveParam.leaveEndTime) {
                var beginDay = new Date($scope.leaveParam.leaveStartTime).getTime();
                var endDay = new Date($scope.leaveParam.leaveEndTime).getTime();
                if (endDay > beginDay){
                    // 天
                    var day = Math.floor((endDay - beginDay) / 3600000 / 24);
                    // 小时
                    var hour = Math.floor(((endDay - beginDay) / 3600000) % 24);
                    if (day){
                        str = day+"天";
                    }
                    if (hour){
                        str += hour+"小时";
                    }
                    if (str){
                        str = "共"+str;
                    }

                }
            }
            return str;
        }

        $scope.initLeaveday = function () {
            if (!$scope.leaveParam.leaveDays){
                $scope.leaveParam.leaveDays = "0";
            }
        };
        //校验天数
        $scope.tureDay = true;
        $scope.verifyLeaveDay = function () {
            var maxDays = $scope.leaveConfig && $scope.leaveConfig.maxDays ? $scope.leaveConfig.maxDays : 999;
            var a = $scope.leaveParam.leaveDays + "";
            var n = a.indexOf(".") + 1;//12.34
            if (((n > 0 && a.length - n >= 2) || (n == 5 && a.length == 5) || isNaN(a) || a < 0) || (n == 0 && a.length >= 4)) {
                $scope.tureDay = false;
                $scope.leaveParam.leaveDays = "";
            } else if (a == "") {
                $scope.tureDay = false;
                $scope.leaveParam.leaveDays = "";
            } else if (parseFloat($scope.leaveParam.leaveDays) > maxDays) {
                $scope.tureDay = false;
                ynuiNotification.error({msg: '请假天数最多为' + maxDays + '天！'});
                $scope.leaveParam.leaveDays = maxDays;
            } else {
                $scope.tureDay = true;
            }
        };
        //天数增减
        $scope.changeDays = function (num) {
            var maxDays = $scope.leaveConfig && $scope.leaveConfig.maxDays ? $scope.leaveConfig.maxDays : 999;
            if (num < 0 && parseFloat($scope.leaveParam.leaveDays) <= 0) {
                return false;
            } else if (parseFloat($scope.leaveParam.leaveDays) + num > maxDays) {
                ynuiNotification.error({msg: '请假天数最多为' + maxDays + '天！'});
                $scope.leaveParam.leaveDays = maxDays;
                return false;
            }
            var leaveDays = accAdd($scope.leaveParam.leaveDays,num);
            if (!isNaN(leaveDays) && leaveDays > 0) {
                $scope.leaveParam.leaveDays = leaveDays;
            }else {
                $scope.leaveParam.leaveDays = 0;
            }
        };
        //加法
        function accAdd(arg1,arg2){
            var r1,r2,m,precision;
            try{r1=arg1.toString().split(".")[1].length}catch(e){r1=0}
            try{r2=arg2.toString().split(".")[1].length}catch(e){r2=0}
            m=Math.pow(10,Math.max(r1,r2));
            precision = (r1 >= r2) ? r1:r2;
            return ((arg1*m+arg2*m)/m).toFixed(precision);
        }
        //字数
        $scope.changeNumber = function (num) {
            $scope.wordNumber = num.length;
        };
        $scope.$watch(function () {
            return $scope.leaveParam.leaveReason
        }, function () {
            if($scope.leaveParam.leaveReason){
                $scope.wordNumber = $scope.leaveParam.leaveReason.length;
            }else {
                $scope.wordNumber = 0;
            }
        });
        $scope.changeValue = function (type, value) {
            if (type == 0) {
                $scope.leaveParam.isOutSchool = value;
            } else if (type == 1) {
                $scope.leaveParam.isBackSleep = value;
            } else if (type == 2) {
                $scope.leaveParam.isTakeByParent = value;
            }
        };
        $scope.subInfo = {inSubmit: false};


        //请假信息提交
        $scope.commitLeave = function (isDraft) {
            var leaveInfo = {
                id: $scope.leaveParam.id,
                dictCode: $scope.leaveParam.dictCode,
                isOutSchool: $scope.leaveParam.isOutSchool,
                leaveReason: $scope.leaveParam.leaveReason,
                leaveEndTime: $scope.leaveParam.leaveEndTime,
                leaveStartTime: $scope.leaveParam.leaveStartTime,
                passStartTime: $scope.leaveParam.passStartTime,
                passEndTime: $scope.leaveParam.passEndTime
            };
            if (!$scope.leaveParam.leaveStartTime || !$scope.leaveParam.leaveEndTime) {
                ynuiNotification.error({msg: '请选择请假起止时间!'});
                return;
            }
            if ($scope.leaveParam.leaveReason == "") {
                ynuiNotification.error({msg: '请填写请假原因!'});
                return;
            }
            if (!$scope.leaveParam.leaveDays || $scope.leaveParam.leaveDays == "") {
                ynuiNotification.error({msg: '请填写请假天数！'});
                return;
            }
            if (!$scope.tureDay) {
                var maxDays = $scope.leaveConfig && $scope.leaveConfig.maxDays ? $scope.leaveConfig.maxDays : 999;
                ynuiNotification.error({msg: '请假天数最多为' + maxDays + '天！'});
                return;
            }
            if (leaveInfo.isOutSchool) {
                if (!$scope.leaveParam.passStartTime || !$scope.leaveParam.passEndTime) {
                    ynuiNotification.error({msg: '请选择申请出校时间!'});
                    return;
                }
                // 判断放行开始时间
                var leaveStart = new Date($scope.leaveParam.leaveStartTime).getTime();
                var passStart = new Date($scope.leaveParam.passStartTime).getTime();
                if ($scope.leaveConfig && $scope.leaveConfig.before) {
                    // 放行时间允许早于请假开始时间
                    if (passStart > leaveStart && (passStart - leaveStart) / 1000 / 60 > $scope.leaveConfig.beforeMinutes) {
                        ynuiNotification.error({
                            msg: '“申请出校开始时间”最多只能比“请假开始时间”提前' +
                            $scope.leaveConfig.beforeMinutes + '分钟！'
                        });
                        return;
                    }
                } else {
                    // 放行时间不允许早于请假开始时间
                    if (passStart < leaveStart) {
                        ynuiNotification.error({msg: '“申请出校开始时间”不能早于“请假开始时间”！'});
                        return;
                    }
                }
                // 判断放行结束时间
                var leaveEnd = new Date($scope.leaveParam.leaveEndTime).getTime();
                var passEnd = new Date($scope.leaveParam.passEndTime).getTime();
                if ($scope.leaveConfig && $scope.leaveConfig.after) {
                    // 放行结束时间允许晚于请假结束时间
                    if (passEnd > leaveEnd && (passEnd - leaveEnd) / 1000 / 60 > $scope.leaveConfig.afterMinutes) {
                        ynuiNotification.error({
                            msg: '“申请出校结束时间”最多只能比“请假结束时间”超出' +
                            $scope.leaveConfig.afterMinutes + '分钟！'
                        });
                        return;
                    }
                } else {
                    if (passEnd > leaveEnd) {
                        ynuiNotification.error({msg: '“申请出校结束时间”不能晚于“请假结束时间”！'});
                        return;
                    }
                }
            }
            // 允许出校时间判断
            if (passStart > passEnd){
                ynuiNotification.error({msg: '“申请出校开始时间”不能晚于“申请出校结束时间”！'});
                return;
            }
            leaveInfo.isDraft = isDraft;
            leaveInfo.leaveDays = $scope.leaveParam.leaveDays;
            leaveInfo.isBackSleep = $scope.leaveParam.isBackSleep;
            leaveInfo.isTakeByParent = $scope.leaveParam.isTakeByParent;
            if (!leaveInfo.isOutSchool) {
                //如果已经出校需要放行时间
                leaveInfo.passStartTime = "";//允许放行开始时间
                leaveInfo.passEndTime = "";//允许放行结束时间
                leaveInfo.isBackSleep = true;
                leaveInfo.isTakeByParent = false;
            }
            leaveInfo.fsIdList = $scope.vm.initFiles;
            if ($scope.subInfo.inSubmit) {
                return;
            }
            $scope.subInfo.inSubmit = true;
            $http.post(originBaseUrl + '/third/leaveAndRelease/applyLeave.htm', leaveInfo).success(function (data) {
                setTimeout(function () {
                    $scope.subInfo.inSubmit = false;
                    $scope.$apply();
                }, 2000);
                if (data.status == 0) {
                    if (data.result && data.result.length > 0) {
                        $scope.errorMsgArr = [];
                        angular.forEach(data.result, function (item) {
                            $scope.errorMsgArr.push(item.failedReason);
                        });
                        ynuiNotification.error({msg: $scope.errorMsgArr.join(" ")});
                    } else {
                        if (isDraft) {
                            ynuiNotification.success({msg: '保存草稿成功!'});
                            // 草稿跳转未提交
                            $location.path("/leave_record").search({backFlag:true,activeStatus:"0"});
                        } else {
                            ynuiNotification.success({msg: '保存成功!'});
                            // 提交跳转审核中
                            $location.path("/leave_record").search({backFlag:true,activeStatus:"3"});
                        }

                    }
                } else {
                    if (isDraft) {
                        ynuiNotification.error({msg: '保存草稿失败！'});
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                }
            }).error(function (data) {
                setTimeout(function () {
                    $scope.subInfo.inSubmit = false;
                    $scope.$apply();
                }, 2000);
            });
        };

        $scope.leaveConfig = null;

        getLeaveConfig();

        // 获取配置
        function getLeaveConfig() {
            return $http.get(originBaseUrl + '/third/leaveAndRelease/leave/config.htm')
                .success(function (data) {
                    $scope.leaveConfig = data.result;
                    return data;
                });
        }


    }

    leaveDeleteCtrl.$inject = ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', '$filter', "$ionicPopup", "$state","$location"];

    function leaveDeleteCtrl($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, $filter, $ionicPopup, $state,$location) {
        $scope.dataError = false;//错误信息
        $scope.searchBar = false;  //搜索框
        $scope.emptyInfo = false;  //数据为空
        var pageNumber = 0;
        var pageSize = 20;
        //查询
        $scope.searchlength = 0;      //即时搜索初始化
        $scope.scrollTop = function () {
            $ionicScrollDelegate.scrollTop();
            $ionicLoading.hide();
        }
        $scope.changeShowType = function (showType) {
            $scope.showType = showType;
            pageNumber = 0;
            $scope.lastPage = true;
            $scope.getData(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }
        //默认加载待确认
        $scope.showType = 1;
        $scope.lastPage = false;
        $scope.getData = function (func) {
            $scope.delStatus = '';
            if ($scope.showType == 1) {
                $scope.delStatus = false;
            } else if ($scope.showType == 2) {
                $scope.delStatus = true;
            }
            var params = {
                pageNumber:pageNumber,
                pageSize:pageSize,
                delStatus:$scope.delStatus,
                queryValue:$scope.search && $scope.search.searchContent,
                from:"app",
            };
            if (pageNumber === 0){
                $scope.leaveData = [];
            }
            $http.post(originBaseUrl + '/third/leaveAndRelease/queryReturnStu.htm',params).success(function (data) {
                if (data.status == 0) {
                    $scope.leaveData = $scope.leaveData.concat(data.result.content);
                    $scope.lastPage = data.result.lastPage;
                    angular.forEach($scope.leaveData, function (item) {
                        if (item.headUrl != "" && item.headUrl != null) {
                            item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
                        }
                        //item.delStatus = false;//作废状态，点击置灰使用
                        item.searchContent = item.name;
                        if (item.alias) {
                            item.searchContent = item.searchContent + item.number + item.alias
                        }
                    });
                    if ($scope.leaveData.length > 0) {
                        $scope.leaveData[0].showDetail = true;//第一条默认展开
                        $scope.emptyInfo = false;
                    } else {
                        if (pageNumber < 1) {
                            $scope.emptyInfo = true;              //展示空数据提示
                        }
                        $scope.dataErrorMsg = "没有需要作废的记录！";
                    }

                    if (func) {
                        func();
                    }
                }
            }).error(function () {
                if (func) {
                    func();
                }
                $scope.emptyInfo = true;
                $scope.dataErrorMsg = '加载失败，请重试！';
            });
        };
        $scope.getData();

        //取消搜索
        $scope.cancelBack = function () {
            $scope.searchBar = !$scope.searchBar;
            if ($scope.search != undefined && $scope.search.searchContent != undefined) {
                $scope.search.searchContent = "";
            }
            $scope.getData(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        };

        //清空搜索框
        $scope.cleanSearchContent = function () {
            $scope.search.searchContent = "";
        };

        //光标焦点的定位
        $scope.changeSearchStatus = function () {
            $scope.searchBar = !$scope.searchBar;
            document.getElementById("searchIt").autofocus = true;
        };

        $scope.param = {
            item: {},
            leaveId: "",
            backSchoolTime: "",
            leaveStartTime: "",
        };
        var selectBackTimeConfig = {
            templateUrl: 'templates/leave/selectBackTime.html',
            title: "确认返校",
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>确认</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        if (!$scope.param.backSchoolTime) {
                            e.preventDefault();
                            $ionicPopup.show({title: '提示', template: '请选择返校时间!', buttons: [{text: '确定', type: 'button-positive'}]});
                            return false;
                        }
                        if ($scope.param.backSchoolTime < $scope.param.leaveStartTime || new Date($scope.param.backSchoolTime).getTime() > new Date().getTime()) {
                            e.preventDefault();
                            $ionicPopup.show({title: '提示', template: '返校时间必须大于请假开始时间，同时不超过当前时间！', buttons: [{text: '确定', type: 'button-positive'}]});
                            return false;
                        }
                        if ($scope.param.leaveDays){
                            var reg = new RegExp('^[0-9]{1,3}(\\.[0-9])?$');
                            if (!(reg.test($scope.param.leaveDays) && Number($scope.param.leaveDays) <= $scope.param.planLeaveDays)){
                                e.preventDefault();
                                $ionicPopup.show({title: '提示', template: '实际请假天数必须小于等于计划请假天数且只支持一位小数！', buttons: [{text: '确定', type: 'button-positive'}]});
                                return false;
                            }
                        }else {
                            e.preventDefault();
                            $ionicPopup.show({title: '提示', template: '请输入实际请假天数!', buttons: [{text: '确定', type: 'button-positive'}]});
                            return false;
                        }
                        $http.post(originBaseUrl + "/third/leaveAndRelease/returnConfirm.htm", {
                            ids: [$scope.param.leaveId],
                            backTime: $scope.param.backSchoolTime,
                            backSchoolStatus: $scope.param.backSchoolStatus,
                            leaveDays: $scope.param.leaveDays
                        }).success(function (data) {
                            if (data.status == 0) {
                                $scope.param.item.backSchoolTimeShow = $scope.param.backSchoolTime.substr(5);
                                $scope.param.item.backSchoolTime = $scope.param.backSchoolTime;
                                $scope.param.item.delStatus = true;
                                $ionicPopup.show({
                                    title: '提示', template: '操作成功!',
                                    buttons: [{
                                        text: '确定', type: 'button-positive', onTap: function (e) {
                                            $scope.changeShowType($scope.showType);
                                        }
                                    }]
                                });
                            } else {
                                $ionicPopup.show({title: '提示', template: data.message, buttons: [{text: '确定', type: 'button-positive'}]});
                            }
                        });
                    }
                }
            ]
        };

        //作废
        $scope.delLeave = function (item) {
            $scope.param.item = item;
            $scope.param.leaveStartTime = item.leaveStartTime;
            $scope.param.leaveId = item.id;
            // 默认已返校
            $scope.param.backSchoolStatus = "1";
            // 默认请假天数
            $scope.param.leaveDays = item.leaveDays;
            $scope.param.planLeaveDays = item.leaveDays;
            // 默认：设备返校时间=返校时间，如果没有设备返校时间，且当前服务器时间小于计划请假结束时间
            // 则显示当前服务器时间，否则显示计划请假结束时间
            if (item.backSchoolTime) {
                $scope.param.backSchoolTime = item.backSchoolTime;
            } else if (new Date().getTime() > new Date(item.leaveEndTime).getTime()) {
                $scope.param.backSchoolTime = item.leaveEndTime;
            } else {
                var currentTime = new Date();
                var month = (currentTime.getMonth() + 1) > 9 ? (currentTime.getMonth() + 1) : '0' + (currentTime.getMonth() + 1);
                var day = currentTime.getDate() > 9 ? currentTime.getDate() : '0' + currentTime.getDate();
                var hour = currentTime.getHours() > 9 ? currentTime.getHours() : '0' + currentTime.getHours();
                var minute = currentTime.getMinutes() > 9 ? currentTime.getMinutes() : '0' + currentTime.getMinutes();
                $scope.param.backSchoolTime = currentTime.getFullYear() + "-" + month + "-" + day + " " + hour + ":" +
                    minute;
            }
            $ionicPopup.show(selectBackTimeConfig);
        };
        //刷新
        $scope.doRefresh = function () {
            $ionicLoading.show({
                template: '正在刷新...'
            });
            //置空数据，在获取时候叠加数据
            $scope.leaveData = null;
            pageNumber = 0;
            $scope.getData(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };

        //下拉获取更多数据
        $scope.loadMore = function () {
            //请求数据
            pageNumber += 1;
            $scope.getData(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        };

        $scope.searchListInfo = function(){
            pageNumber = 0;
            $scope.getData(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        $scope.toAnother = toAnother;

        function toAnother(type) {
            if (type){
                $location.path("/leave_record_to_teacher");
            }else {
                $state.go('class_leaveStudent');
            }
        }
    }

    askforLeaveCtrl.$inject = ['$rootScope', "$window", "$scope", "$http", "$ionicPopup", "$ionicModal", "$location","$sce","ynNavigator"];

    function askforLeaveCtrl($rootScope, $window, $scope, $http, $ionicPopup, $ionicModal, $location, $sce,ynNavigator) {

        //从url获取请求所需参数
        var localUrl = decodeURI($window.location.href);
        var params = localUrl.split(/[?&]/);
        var fromType = params[1];
        fromType = fromType.replace("fromType=", "");
        var id = params[2];
        id = id.replace("procInstId=", "");
        if(id.indexOf("fromType=") > -1){
            var fromType = params[2];
            fromType = fromType.replace("fromType=", "");
            var id = params[3];
            id = id.replace("procInstId=", "");
        }
        //操作权限控制
        $scope.prcOperInfo = {
            fromBusiness: false,//是否从业务过来
            canCancel: false,//是否能够进行撤销操作
            canBack: false,//是否能够进行追回操作
            canSubmit: false,//是否能够进行提交操作
            canForm: false,//是否能够进行修改表单
            canMsg: false,//是否能够进行修改表单
            inSubmit: false//是否在提交中
        }
        if ($location.search().fromBusiness) {
            $scope.prcOperInfo.fromBusiness = true;
        }
        //注册父路由
        ynNavigator.registerBackAction(function () {
            if ($location.search().backUrl || $location.search().state){
                // 返回指定路由
                if ($location.search().backUrl){
                    $location.path($location.search().backUrl).search({backFlag:true,backConditions:$location.search().searchInfo});
                }else if ($location.search().state && $location.search().state === 'leave_view') {
                    $location.path("/leave_record").search({backFlag:true,activeStatus:$location.search().activeStatus});
                }else {
                    $location.path($location.search().state);
                }
            }else {
                //强制返回上一级
                ynNavigator.finish();
            }

            setTimeout(function () {
                $scope.$apply();
            });
        },101);


        $scope.doBack = function () {
            history.back(-1);
        };

        //提交信息初始化
        $scope.lcProcTaskDoVO = {
            id: id,                  //业务流程实例ID
            taskId: "",              //任务ID
            approvalOpinion: "",     //审批意见
            isEndTask: false,        //是否是结束任务
            approvalType: 0,         //0:同意 1:驳回到发起人 2:驳回到上一步
            approvalStatus: true     //审核结果 true:通过 false：不通过
        };
        var token = JSON.parse(window.localStorage.getItem("authorizationStr")).access_token;
        var reqUrl = originBaseUrl + "/third/mobileProc/queryTaskInfoByProcinstId.htm?fromType=" + fromType + "&procInstId=" + id+"&access_token="+token;
        $scope.fristInfo = true;
        $scope.loadProcInfo = function () {
            $http.post(reqUrl).success(function (data) {
                if (data.status == 0) {
                    $scope.prcOperInfo.canCancel = data.result.canCancel;
                    $scope.prcOperInfo.canBack = data.result.canBack;
                    $scope.prcOperInfo.canSubmit = !data.result.taskHadDone;
                    $scope.prcOperInfo.canForm = data.result.canForm;
                    $scope.prcOperInfo.canMsg = data.result.canMsg;
                    $scope.lcProcTaskDoVO.isEndTask = data.result.isEndTask;
                    $scope.lcProcTaskDoVO.taskId = data.result.taskId;
                    $scope.lcFormInfoVO = data.result;
                    if ($scope.fristInfo) {
                        $scope.fristInfo = false;
                        if ($scope.lcFormInfoVO && $scope.lcFormInfoVO.formCode == "leaveForm") {
                            //获取学生请假流程信息
                            $http.get(originBaseUrl + "/third/mobileProc/queryMoraleduLeavePassShowById.htm?id=" + $scope.lcFormInfoVO.businessKey).success(function (data1) {
                                if (data1.status == 0) {
                                    $scope.moraleduLeavePassShowVO = data1.result;
                                }
                            });
                        }
                        if ($scope.lcFormInfoVO && ($scope.lcFormInfoVO.formCode === 'singleTkglForm' || $scope.lcFormInfoVO.formCode === 'batchTkglForm' || $scope.lcFormInfoVO.formCode === 'ssArrangeForm')) {
                            // 调课流程1
                            if ($scope.lcFormInfoVO && $scope.lcFormInfoVO.formCode === 'singleTkglForm') {
                                $http.get(originBaseUrl + '/third/mobileProc/findAuditInfoByProcess.htm', {
                                    params: {
                                        key: $scope.lcFormInfoVO.businessKey,
                                        type: 1
                                    }
                                }).then(function (response) {
                                    $scope.auditInfo = response.data.result;
                                });
                            }
                            // 调课流程2
                            if ($scope.lcFormInfoVO && $scope.lcFormInfoVO.formCode === 'batchTkglForm') {
                                $http.get(originBaseUrl + '/third/mobileProc/findAuditInfoByProcess.htm', {
                                    params: {
                                        key: $scope.lcFormInfoVO.businessKey,
                                        type: 2
                                    }
                                }).then(function (response) {
                                    $scope.auditInfo = response.data.result;
                                });
                            }
                            //申请调寝
                            if($scope.lcFormInfoVO && $scope.lcFormInfoVO.formCode === 'ssArrangeForm') {
                                $http.get(originBaseUrl + '/third/ssap/queryLcDetailById.htm', {
                                    params: {
                                        batchNumber: $scope.lcFormInfoVO.businessKey,
                                    }
                                }).then(function (response) {
                                    $scope.roomApplyLcDetail = response.data.result;
                                });
                            }
                        }
                    }
                }
            });
        }
        $scope.loadProcInfo();

        //封装  处理流程节点提交
        var doProcTask = function () {
            var sendWay = [];
            if ($scope.popup && $scope.popup.sendWayList) {
                angular.forEach($scope.popup.sendWayList, function (item) {
                    if (item.enable && item.checked) {
                        sendWay.push(item.code);
                    }
                });
            }
            var submit = {
                id: $scope.lcProcTaskDoVO.id,
                taskId: $scope.lcProcTaskDoVO.taskId,
                approvalOpinion: $scope.lcProcTaskDoVO.approvalOpinion,
                isEndTask: $scope.lcProcTaskDoVO.isEndTask,
                approvalType: $scope.lcProcTaskDoVO.approvalType,
                approvalStatus: $scope.lcProcTaskDoVO.approvalStatus,
                sendWay: sendWay.join(",")
            };
            if ($scope.prcOperInfo.inSubmit) {
                return;
            }
            $scope.prcOperInfo.inSubmit = true;
            $http.post(originBaseUrl + "/third/mobileProc/doProcTask.htm", submit).success(function (data) {
                setTimeout(function () {
                    $scope.prcOperInfo.inSubmit = false;
                    $scope.$apply();
                }, 2000);
                if (data.status == 0) {
                    $ionicPopup.alert({title: '提示', template: "操作成功", okText: '确定'});
                    $scope.lcProcTaskDoVO.approvalOpinion = null;
                    $scope.loadProcInfo();
                } else {
                    $ionicPopup.alert({title: '提示', template: data.message, okText: '确定'});
                    return false;
                }
            }).error(function (data) {
                setTimeout(function () {
                    $scope.prcOperInfo.inSubmit = false;
                    $scope.$apply();
                }, 2000);
            });
        };

        var submitPopupConfig = {
            templateUrl: 'templates/leave/askforleave/selectADTResult.html',
            title: '选择审核结果',
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>提交</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        doProcTask();
                    }
                }
            ]
        };


        var cancelPopupConfig = {
            templateUrl: 'templates/leave/askforleave/selectBackAndCancel.html',
            title: '流程撤销',
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>撤销</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        if (!$scope.popup.approvalOpinion) {
                            $scope.errorInfo = "请输入撤销原因!";
                            e.preventDefault();
                            return false;
                        } else {
                            $scope.lcProcTaskDoVO.approvalOpinion = $scope.popup.approvalOpinion;
                            doProcTask();
                        }
                    }
                }
            ]
        };
        var backPopupConfig = {
            templateUrl: 'templates/leave/askforleave/selectBackAndCancel.html',
            title: '流程追回',
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>追回</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        if (!$scope.popup.approvalOpinion) {
                            $scope.errorInfo = "请输入追回原因!";
                            e.preventDefault();
                            return false;
                        } else {
                            $scope.lcProcTaskDoVO.approvalOpinion = $scope.popup.approvalOpinion;
                            doProcTask();
                        }

                    }
                }
            ]
        };
        $scope.errorInfo = "";
        var urgeMsgConfig = {
            templateUrl: 'templates/leave/askforleave/selectUrgeMsg.html',
            title: "流程催办",
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>催办</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        var urgeSendWay = [];
                        angular.forEach($scope.lcFormInfoVO.msgTwoList, function (item) {
                            if (item.enable && item.checked) {
                                urgeSendWay.push(item.code);
                            }
                        });
                        if (urgeSendWay.length <= 0) {
                            $scope.errorInfo = "请选择发送方式!";
                            e.preventDefault();
                            return false;
                        } else {
                            $http.post(originBaseUrl + "/third/mobileProc/urgeActivityTask.htm", {
                                lcProcInstId: $scope.lcProcTaskDoVO.id,
                                sendWay: urgeSendWay.join(",")
                            }).success(function (data) {
                                if (data.status == 0) {
                                    $ionicPopup.alert({title: '提示', template: '操作成功!'});
                                    return true;
                                } else {
                                    $ionicPopup.alert({title: '提示', template: data.message});
                                    return false;
                                }
                            });
                        }
                    }
                }
            ]
        };

        $scope.urgeMsg = function () {
            $scope.errorInfo = "";
            $ionicPopup.show(urgeMsgConfig);
        }

        //提交/驳回发起人/驳回上一步
        $scope.submit = function (operType) {
            $scope.lcProcTaskDoVO.approvalType = operType;
            if (operType == 0) {
                $scope.lcProcTaskDoVO.approvalType = 0;
                if ($scope.lcProcTaskDoVO.isEndTask) {//是结束节点
                    $ionicPopup.show(submitPopupConfig);
                } else {
                    doProcTask();
                }
            } else if (operType == 4 || operType == 5) {//撤销 或者 追回
                $scope.errorInfo = "";
                $scope.popup = {approvalOpinion: null};
                $scope.popup.sendWayList = $scope.lcFormInfoVO.msgOneList;
                $scope.popup.operReason = "撤销原因";
                if (operType == 5) {
                    $scope.popup.operReason = "追回原因";
                }
                if (operType == 4) {
                    $ionicPopup.show(cancelPopupConfig);
                } else {
                    $ionicPopup.show(backPopupConfig);
                }
            } else {
                doProcTask();
            }
        };
        //材料证明
        var MaterialsProve;
        $ionicModal.fromTemplateUrl('materials_prove.html', {
            scope: $scope,
            animation: 'slide-in-right'
        }).then(function (modal) {
            MaterialsProve = modal;
        });

        //判断文件是否支持预览
        $scope.previewFileOrDownload = function (fastId) {
            var isSupported = false;
            var type = fastId.substring(fastId.lastIndexOf(".") + 1).toLowerCase();
            type = type.toLowerCase();
            if (type == 'doc' || type == 'docx' || type == 'xls' || type == 'xlsx' || type == 'ppt' || type == 'pptx' || type == 'txt' || type == 'pdf') {
                //符合条件的文件格式，跳转到预览
                isSupported = true;
            }
            return isSupported;
        }
        $scope.previewFileOrDownloadImg = function (fastId) {
            var isSupported = false;
            var type = fastId.substring(fastId.lastIndexOf(".") + 1).toLowerCase();
            type = type.toLowerCase();
            if (type == 'gif' || type == 'jpg' || type == 'jpeg' || type == 'png' || type == 'bmp') {
                //符合条件的文件格式，跳转到预览
                isSupported = true;
            }
            return isSupported;
        }
        $scope.previewPhoto = function (photo) {
            var cordovaFileOpen = cordova.plugins.disusered.open;
            $scope.attachmentUrl = cordovaFileOpen(originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + photo, cordovaFileOpenSuccess, cordovaFileOpenError);

            function cordovaFileOpenSuccess() {
                // 从已安装程序中打开文件完成
            }

            function cordovaFileOpenError(code) {
                if (code === 1) {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '未能在手机已安装APP中找到可预览此文件的程序'
                    });
                } else {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '预览时发生了未知错误 #' + code
                    });
                }
            }
        };
        //下载
        $scope.downLoadAndpreView = function (item) {
            if ($scope.previewFileOrDownload(item.attachmentId)) {
                $scope.attachmentUrl = $sce.trustAsResourceUrl(originBaseUrl + "/static/yineng/components/22-ynuiPdfViewer/web/viewer.html?fastDFSId=" + item.attachmentId)
                MaterialsProve.show();
            } else if ($scope.previewFileOrDownloadImg(item.attachmentId)) {
                $scope.previewPhoto(item.attachmentId);
            } else {
                $ionicPopup.alert({title: '提示', template: '该文件格式不支持预览!'});
            }
        };

        var flowChartModal;
        $ionicModal.fromTemplateUrl('flowChart.html', {
            scope: $scope,
            animation: 'slide-in-right'
        }).then(function (modal) {
            flowChartModal = modal;
        });
        $scope.act = {actId: null, checker: null};
        $scope.showActUserInfo = function () {
            $http.post(originBaseUrl + "/third/mobileProc/queryLCActUserInfoByProcInstId.htm?procInstId=" + id).success(function (data) {
                if (data.status == 0) {
                    $scope.actList = data.result.actList;
                    $scope.act.actId = data.result.curActId;
                    $scope.act.checker = data.result.checker;
                    $scope.act.lcProcDefId = data.result.lcProcDefId;
                    $scope.act.version = data.result.version;
                }
            });
        }
        $scope.changeActId = function () {
            $http.post(originBaseUrl + "/third/mobileProc/queryLCActUserInfoByProcInstIdAndActId.htm?procInstId=" + id + "&actId=" + $scope.act.actId).success(function (data) {
                if (data.status == 0) {
                    $scope.act.checker = data.result;
                }
            });
        }

        //查看流程图
        $scope.flowChart = function () {
            //获取流程图 流
            $scope.imgUrl = originBaseUrl + "/third/mobileProc/viewProcImage.htm?id=" + id + "&timePlate=" + (new Date()).getTime() + '&access_token=' + $rootScope.authorizationStr.access_token +
                '&userId=' + $rootScope.authorizationStr.userId +
                '&userType=' + $rootScope.authorizationStr.userType;
            $scope.showActUserInfo();
            flowChartModal.show();
        };
        var historyModal;
        $ionicModal.fromTemplateUrl('history.html', {
            scope: $scope,
            animation: 'slide-in-right'
        }).then(function (modal) {
            historyModal = modal;
        });

        //关闭弹窗
        $scope.closeFlowChartModal = function () {
            flowChartModal.hide();
        };
        $scope.closeHistoryModal = function () {
            historyModal.hide();
        };
        $scope.closeMaterialsProve = function () {
            MaterialsProve.hide();
        };

        //查看审批历史
        $scope.accraditationHistory = function () {
            //获取审批历史
            $http.post(originBaseUrl + "/third/mobileProc/queryLCActOperTrack.htm?procInstId=" + id + "&timePlate=" + (new Date()).getTime()).success(function (data) {
                if (data.status == 0) {
                    $scope.trackInfo = data.result;
                    historyModal.show();
                }
            });
        };
    }

    /******查看请假条start**********/
    leaveRecordViewCtrl.$inject = ['$rootScope', "$scope", "$http", "$ionicPopup", "$ionicModal", "$location","ynNavigator"];


    function leaveRecordViewCtrl($rootScope, $scope, $http, $ionicPopup, $ionicModal, $location,ynNavigator) {
        $scope.id = $location.search().id;
        $scope.status = $location.search().status;
        $scope.statusName = "";
        switch ($scope.status) {
            case "0":
                $scope.statusName = "未提交";
                break;
            case "1":
                $scope.statusName = "通过";
                break;
            case "2":
                $scope.statusName = "不通过";
                break;
            case "3":
                $scope.statusName = "审核中";
                break;
            case "4":
                $scope.statusName = "返回修改";
                break;
        }
        $scope.loadingError = false;
        $scope.loadingErrorInfo = "";
        //学生
        $scope.queryUserInfo = function () {
            $http.get(originBaseUrl + "/third/leaveAndRelease/queryUserInfo.htm?needClass=true&time=" + (new Date()).getTime()).success(function (data) {
                if (data.status == 0) {
                    $scope.userInfo = data.result;
                    if ($scope.userInfo && $scope.userInfo.fsId) {
                        $scope.userInfo.fsId = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.userInfo.fsId;
                        $scope.userInfo.smallFsId = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.userInfo.smallFsId;
                    } else if ($scope.userInfo) {
                        if ($scope.userInfo.gender == '女') {
                            $scope.userInfo.fsId = originBaseUrl + "/mobile/img/userface_2.png";
                            $scope.userInfo.smallFsId = originBaseUrl + "/mobile/img/userface_2.png";
                        } else {
                            $scope.userInfo.fsId = originBaseUrl + "/mobile/img/userface_1.png";
                            $scope.userInfo.smallFsId = originBaseUrl + "/mobile/img/userface_1.png";
                        }
                    }
                }
            }).error(function () {
                $scope.loadingError = true;
                $scope.loadingErrorInfo = '加载失败，请重试！';
            });
        }

        //请假信息查询
        $scope.queryLeaveInfo = function () {
            $http.get(originBaseUrl + "/third/leaveAndRelease/queryStuLeaveNote.htm?time=" + (new Date()).getTime()+"&leavePassId="+$scope.id).success(function (data) {
                if (data.status == 0) {
                    $scope.leaveInfo =  data.result;
                }
            }).error(function () {

            });
        };


        $scope.queryUserInfo();
        $scope.queryLeaveInfo();

        // 返回处理
        ynNavigator.registerBackAction(function () {
            $location.path("/leave_record").search({backFlag:true,activeStatus:$location.search().activeStatus});
            setTimeout(function () {
                $scope.$apply();
            });
        },101);

        //材料证明
        var MaterialsProve;
        $ionicModal.fromTemplateUrl('materials_prove.html', {
            scope: $scope,
            animation: 'slide-in-right'
        }).then(function (modal) {
            MaterialsProve = modal;
        });

        //判断文件是否支持预览
        $scope.previewFileOrDownload = function (fastId) {
            var isSupported = false;
            var type = fastId.substring(fastId.lastIndexOf(".") + 1).toLowerCase();
            type = type.toLowerCase();
            if (type == 'doc' || type == 'docx' || type == 'xls' || type == 'xlsx' || type == 'ppt' || type == 'pptx' || type == 'txt' || type == 'pdf') {
                //符合条件的文件格式，跳转到预览
                isSupported = true;
            }
            return isSupported;
        }
        $scope.previewFileOrDownloadImg = function (fastId) {
            var isSupported = false;
            var type = fastId.substring(fastId.lastIndexOf(".") + 1).toLowerCase();
            type = type.toLowerCase();
            if (type == 'gif' || type == 'jpg' || type == 'jpeg' || type == 'png' || type == 'bmp') {
                //符合条件的文件格式，跳转到预览
                isSupported = true;
            }
            return isSupported;
        }
        $scope.previewPhoto = function (photo) {
            var cordovaFileOpen = cordova.plugins.disusered.open;
            $scope.attachmentUrl = cordovaFileOpen(originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + photo, cordovaFileOpenSuccess, cordovaFileOpenError);

            function cordovaFileOpenSuccess() {
                // 从已安装程序中打开文件完成
            }

            function cordovaFileOpenError(code) {
                if (code === 1) {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '未能在手机已安装APP中找到可预览此文件的程序'
                    });
                } else {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '预览时发生了未知错误 #' + code
                    });
                }
            }
        };
        //下载
        $scope.downLoadAndpreView = function (item) {
            if ($scope.previewFileOrDownload(item.attachmentId)) {
                $scope.attachmentUrl = $sce.trustAsResourceUrl(originBaseUrl + "/static/yineng/components/22-ynuiPdfViewer/web/viewer.html?fastDFSId=" + item.attachmentId)
                MaterialsProve.show();
            } else if ($scope.previewFileOrDownloadImg(item.attachmentId)) {
                $scope.previewPhoto(item.attachmentId);
            } else {
                $ionicPopup.alert({title: '提示', template: '该文件格式不支持预览!'});
            }
        };

    }
    /********查看请假条end*************/


})();
