/**
 * 操行分考核首页控制器
 * Created by wangl on 2017/08/09 10:33
 *
 */
(function () {
    'use strict';

    angular.module('starter')
        .config(stateConfig)
        //操行分考核
        .controller('creditIndexController', creditIndexController)
        //按学号、姓名搜索学生
        .controller('searchByConditionCtlr', searchByConditionCtlr)
        //从班级中选择
        .controller('searchStuByClassCtrl', searchStuByClassCtrl)
        //选择考核项目
        .controller('selectCheckItemCtrl', selectCheckItemCtrl)
        //填写考核信息
        .controller('fillInCheckInfoCtrl', fillInCheckInfoCtrl)

    stateConfig.$inject = ['$stateProvider', '$urlRouterProvider'];

    function stateConfig($stateProvider, $urlRouterProvider) {
        $stateProvider
        //搜索学生
            .state('search_student', {
                url: '/search_student',
                templateUrl: 'templates/moralityMeasurement/index.html',
                data: {
                    micro: true,  // 是否启用选项卡
                    title: '干部工作'
                },
                controller: 'creditIndexController',
            })
            //按学号、姓名搜索学生
            .state('searchStuByCondition', {
                url: '/searchStuByCondition',
                templateUrl: 'templates/moralityMeasurement/searchStuByCondition.html',
                data: {
                    prev: 'search_student',
                    title: '操行分考核'
                },
                controller: 'searchByConditionCtlr',
            })
            //从班级中选择
            .state('searchStuByClass', {
                url: '/searchStuByClass',
                templateUrl: 'templates/moralityMeasurement/searchStuByClass.html',
                data: {
                    prev: 'search_student',
                    title: '操行分考核'
                },
                controller: 'searchStuByClassCtrl',
            })
            //选择考核项目
            .state('selectCheckItem', {
                url: '/selectCheckItem',
                templateUrl: 'templates/moralityMeasurement/selectCheckItem.html',
                data: {
                    prev: 'search_student',
                    title: '操行分考核'
                },
                controller: 'selectCheckItemCtrl',
            })
            //填写考核信息
            .state('fillInCheckInfo', {
                url: '/fillInCheckInfo',
                templateUrl: 'templates/moralityMeasurement/fillInCheckInfo.html',
                data: {
                    prev: 'selectCheckItem',
                    title: '操行分考核'
                },
                controller: 'fillInCheckInfoCtrl',
            })
          // 教师端
          .state('search_student_by_teacher', {
              url: '/search_student_by_teacher',
              templateUrl: 'templates/moralityMeasurement/index.html',
              data: {
                  title: '学生考核',
                  micro: true
              },
              controller: 'creditIndexController',
          })
          //按学号、姓名搜索学生
          .state('searchStuByCondition_by_teacher', {
              url: '/searchStuByCondition_by_teacher',
              templateUrl: 'templates/moralityMeasurement/searchStuByCondition.html',
              data: {
                  prev: 'search_student_by_teacher',
                  title: '操行分考核'
              },
              controller: 'searchByConditionCtlr',
          })
          //从班级中选择
          .state('searchStuByClass_by_teacher', {
              url: '/searchStuByClass_by_teacher',
              templateUrl: 'templates/moralityMeasurement/searchStuByClass.html',
              data: {
                  prev: 'search_student_by_teacher',
                  title: '操行分考核'
              },
              controller: 'searchStuByClassCtrl',
          })
          //选择考核项目
          .state('selectCheckItem_by_teacher', {
              url: '/selectCheckItem_by_teacher',
              templateUrl: 'templates/moralityMeasurement/selectCheckItem.html',
              data: {
                  prev: 'search_student_by_teacher',
                  title: '操行分考核'
              },
              controller: 'selectCheckItemCtrl',
          })
          //填写考核信息
          .state('fillInCheckInfo_by_teacher', {
              url: '/fillInCheckInfo_by_teacher',
              templateUrl: 'templates/moralityMeasurement/fillInCheckInfo.html',
              data: {
                  prev: 'selectCheckItem_by_teacher',
                  title: '操行分考核'
              },
              controller: 'fillInCheckInfoCtrl',
          });

        $urlRouterProvider.otherwise('/search_student');
    }

    creditIndexController.$inject = ['$scope', '$http', '$location', '$state', '$ionicModal', "$filter", "$timeout", "ynuiNotification", "creditStorageService", "$ionicLoading", "$ionicScrollDelegate", "$cordovaBarcodeScanner", "$ionicPopup"];

    // 操行分考核
    function creditIndexController($scope, $http, $location, $state, $ionicModal, $filter, $timeout, ynuiNotification, creditStorageService, $ionicLoading, $ionicScrollDelegate, $cordovaBarcodeScanner, $ionicPopup) {
        /**
         * 路由信息
         * @type {string}
         */
        $scope.basePath = originBaseUrl;
        // 是否显示已选中学生
        $scope.showSelectedStu = false;
        $scope.conditions = {
            numberOrName: null // 学号或姓名
        };
        $scope.locationStr = "left";
        $scope.selectedStuList = [];
        // 如果从菜单进入页面，则清空缓存
        if (!$location.search().fromInternal) {
            creditStorageService.clearKey("credit_selectedStuList");
            creditStorageService.clearKey("credit_checkInfo");
            creditStorageService.clearKey("credit_checkItem");
            creditStorageService.clearKey("credit_selectedItemType");
            creditStorageService.clearKey("credit_filterInfo");
            // 及时放入缓存
            creditStorageService.setItem("credit_selectedStuList", $scope.selectedStuList);
        }
        // 否则查询缓存
        else {
            $scope.selectedStuList = creditStorageService.getItemNoDel("credit_selectedStuList");
        }

        /**
         * 按学号或姓名查询
         * @param numberOrName
         */
        $scope.query = function (stuInfo) {
            $ionicLoading.show({
                template: "正在查询学生..."
            });

            var userId = stuInfo["userId"];

            if (!userId) {
                userId = stuInfo["USERID"];
            }

            $http.post(originBaseUrl + '/third/behavioRassess/searchStuByStuId.htm', {stuId: userId}).success(function (data) {
                $ionicLoading.hide();
                if (data.status == 0) {
                    if (!data.result) {
                        ynuiNotification.error({msg: "没有找到对应学生，请重新扫学生校牌！"});
                    } else {
                        var item = data.result;
                        item.isSelected = false;
                        if (item.headUrl) {
                            // var tempArr = item.headUrl.split(".");
                            //
                            // var artworkUrl = tempArr[0].substring(0, tempArr[0].length - 2);
                            // item.artworkUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + artworkUrl + "." + tempArr[1];
                            item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
                            item.artworkUrl = item.headUrl;

                        } else {
                            if (item.gender != 2) {
                                item.headUrl = "img/userface_1.png";
                            } else {
                                item.headUrl = "img/userface_0.png";
                            }
                        }
                        var isExists = false;
                        angular.forEach($scope.selectedStuList, function (stu) {
                            if (stu.platformSysUserId == item.platformSysUserId) {
                                isExists = true;
                            }
                        });
                        if (!isExists) {
                            $scope.selectedStuList.unshift(item);
                            // 及时放入缓存
                            creditStorageService.setItem("credit_selectedStuList", $scope.selectedStuList);
                            $scope.showSelectedStu = true;
                        }
                    }
                } else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: '未查询到学生信息',
                        okText: '确定'
                    });
                }
            }).error(function () {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: '提示',
                    template: '未查询到学生信息',
                    okText: '确定'
                });
            });
        };

        //扫描二维码
        $scope.scanCode = function () {
            $cordovaBarcodeScanner.scan().then(function (data) {
                var userId = null;
                // 1|5 是 QRCODE_KEY 表存放的key
                if (0 === data.text.indexOf('1|5:')) {
                    // 新的写法 1|5:aaf37624-09b9-42ad-a25d-77c910ac4266
                    userId = data.text.split(':')[1];
                } else if (0 <= data.text.indexOf('userId') || 0 <= data.text.indexOf('USERID')) {
                    // 旧的写法
                    userId = angular.fromJson(data.text)['userId'] || angular.fromJson(data.text)['USERID'];
                }
                if (null == userId) {
                    $ionicPopup.alert({
                        title: '提示',
                        template: '请扫描学生二维码校牌',
                        okText: '确定'
                    });
                } else {
                    $scope.query({userId: userId});
                }
            }, function (error) {
                ynuiNotification.error({msg: "扫描失败！"});
            });
        };

        /**
         * 按条件查找
         */
        $scope.searchByCondition = function () {
            if ($state.$current.name === 'search_student_by_teacher') {
                $location.path("/searchStuByCondition_by_teacher");
            } else {
                $location.path("/searchStuByCondition");
            }
        };
        /**
         * 从班级中查找学生
         */
        $scope.searchStuByClass = function () {
            if ($state.$current.name === 'search_student_by_teacher') {
                $location.path("/searchStuByClass_by_teacher");
            } else {
                $location.path("/searchStuByClass");
            }
        };

        /**
         * 开始考核
         */
        $scope.startCheck = function () {
            if ($scope.selectedStuList.length == 0) {
                ynuiNotification.error({msg: "请先添加学生！"});
                return;
            }
            if ($state.$current.name === 'search_student_by_teacher') {
                $location.path("/selectCheckItem_by_teacher").search({"fromSrc": null});
            } else {
                $location.path("/selectCheckItem").search({"fromSrc": null});
            }
        };


    }

    searchByConditionCtlr.$inject = ['$scope', '$http', '$location', '$state', '$ionicModal', "$filter", "$timeout", "ynuiNotification", "creditStorageService", "ynNavigator"];

    //按学号、姓名搜索学生
    function searchByConditionCtlr($scope, $http, $location, $state, $ionicModal, $filter, $timeout, ynuiNotification, creditStorageService, ynNavigator) {
        $scope.numberOrName = null;
        // 已选中的学生
        $scope.selectedStuList = creditStorageService.getItemNoDel("credit_selectedStuList");
        // 是否查询完成
        $scope.loadFinished = true;
        // 是否显示已选中学生
        $scope.showSelectedStu = false;
        $scope.locationStr = "left";
        var initTips = function () {
            return {
                isError: false,
                isNoData: false
            };
        };

        /**
         * 初始化已选中学生标识
         * @param selectedStuList
         * @param searchStuList
         */
        var initSelectedFlag = function (selectedStuList, searchStuList) {
            angular.forEach(selectedStuList, function (selectedStu) {
                angular.forEach(searchStuList, function (stu) {
                    if (selectedStu.platformSysUserId == stu.platformSysUserId) {
                        stu.isSelected = true;
                    }
                });
            });
        };


        $scope.tips = initTips();
        $scope.searchStuList = [];
        $scope.query = function () {
            if (!$scope.loadFinished) {
                return;
            }
            $scope.tips = initTips();
            $scope.loadFinished = false;
            $http.post(originBaseUrl + '/third/behavioRassess/searchStuByNumberOrName.htm', {numberOrName: $scope.numberOrName}).success(function (data) {
                $scope.loadFinished = true;
                if (data.status == 0) {
                    if (!(data.result && data.result.length > 0)) {
                        $scope.tips.isNoData = true;
                    } else {
                        angular.forEach(data.result, function (item) {
                            item.isSelected = false;
                            if (item.headUrl) {
                                // var tempArr = item.headUrl.split(".");

                                // var artworkUrl = tempArr[0].substring(0, tempArr[0].length - 2);
                                // item.artworkUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + artworkUrl + "." + tempArr[1];
                                item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
                                item.artworkUrl = item.headUrl;

                            } else {
                                if (item.gender != 2) {
                                    item.headUrl = "img/userface_1.png";
                                } else {
                                    item.headUrl = "img/userface_0.png";
                                }
                            }
                        });
                    }
                    $scope.searchStuList = data.result;
                    initSelectedFlag($scope.selectedStuList, $scope.searchStuList);
                } else {
                    $scope.tips.isError = true;
                }
            }).error(function () {
                $scope.loadFinished = true;
                $scope.tips.isError = true;
            });
        };

        /**
         * 选中学生
         * @param item
         */
        $scope.selectStu = function (item) {
            if (item.isSelected) {
                item.isSelected = false;
                var index = 0, delIndex = 0;

                angular.forEach($scope.selectedStuList, function (stu) {
                    if (stu.platformSysUserId == item.platformSysUserId) {
                        delIndex = index;
                    }
                    index++;
                });
                $scope.selectedStuList.splice(delIndex, 1);
            } else {
                item.isSelected = true;
                $scope.selectedStuList.unshift(item);
            }

            // 及时放入缓存
            creditStorageService.setItem("credit_selectedStuList", $scope.selectedStuList);
        };


        /**
         * 返回到首页
         */
        $scope.back = function () {
            if ($state.$current.name === 'searchStuByCondition_by_teacher') {
                $location.path("/search_student_by_teacher").search({"fromInternal": true});
            } else {
                $location.path("/search_student").search({"fromInternal": true});
            }
            setTimeout(function () {
                $scope.$apply();
            })
        };

        //返回事件拦截器
        ynNavigator.registerBackAction(function () {
            $scope.back();
        },101);

        /**
         * 开始考核
         */
        $scope.startCheck = function () {
            if ($scope.selectedStuList.length == 0) {
                ynuiNotification.error({msg: "请先添加学生！"});
                return;
            }
            if ($state.$current.name === 'searchStuByCondition_by_teacher') {
                $location.path("/selectCheckItem_by_teacher")
                  .search({"fromSrc": "byCondition", "numberOrName": $scope.numberOrName});
            } else {
                $location.path("/selectCheckItem")
                  .search({"fromSrc": "byCondition", "numberOrName": $scope.numberOrName});
            }
        };
    }

    searchStuByClassCtrl.$inject = ['$scope', '$http', '$location', '$state', '$ionicModal', "$filter", "$timeout", "ynuiNotification", "creditStorageService", "ynNavigator"];

    //从班级中选择
    function searchStuByClassCtrl($scope, $http, $location, $state, $ionicModal, $filter, $timeout, ynuiNotification, creditStorageService, ynNavigator) {
        // 已选中的学生
        $scope.selectedStuList = creditStorageService.getItemNoDel("credit_selectedStuList");
        // 之前的过滤条件
        var oldParam;
        // 如果从考核项目页面跳转至此页面
        var isFromItemPage = $location.search().isFromItemPage;
        if (isFromItemPage) {
            oldParam = creditStorageService.getItemNoDel("credit_oldSearchByClassParam");
        }

        $scope.locationStr = "left";
        // 模态框控制
        $ionicModal.fromTemplateUrl('select_grade.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal = modal;
        });
        $scope.selectGradeClick = function () {
            $scope.modal.show();
        };
        $scope.closeSelectGrade = function () {
            $scope.modal.hide();
        };


        // 近5年年级
        $scope.gradeList = [];

        // 机构集
        $scope.orgList = [];

        // 是否为第一次加载
        var isFirstLoad = true;

        // 选中的年级
        $scope.selectedGrade = {};
        $scope.selectedGradeTemp = null;

        // 选中的机构
        $scope.selectedOrg = {};

        // 行政班集
        $scope.adminClassList = [];

        // 选中的行政班
        $scope.selectedAdminClass = null;

        // 行政班下的学生集
        $scope.searchStuList = [];

        $scope.page = {};

        var param = {
            gradeId: null,
            orgNo: null,
            pageNumber: 0,
            pageSize: 20
        };

        /**
         *  获取年级、机构下的行政班
         */
        var getAdminClassUnderGradeAndOrg = function () {
            $scope.page = {};
            param.gradeId = $scope.selectedGrade.id;
            param.orgNo = $scope.selectedOrg.id;
            $scope.selectedAdminClass = null;
            $scope.searchStuList = [];
            $http.post(originBaseUrl + '/third/behavioRassess/getAdminClassUnderGradeAndOrg.htm', param).success(function (data) {
                $scope.page = null;
                if (data.status == 0) {
                    $scope.page = data.result;
                    // 缓存的有滚动之前的内容
                    if ($scope.adminClassList.length > 0) {
                        angular.forEach($scope.page.content, function (item) {
                            $scope.adminClassList.push(item);
                        });
                    } else {
                        angular.forEach($scope.page.content, function (item) {
                            $scope.adminClassList.push(item);
                        });
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }).error(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        };

        /**
         * 选中机构
         * @param grade
         */
        $scope.selectOrg = function (org) {
            $scope.selectedOrg = org;
            $scope.selectedGrade = angular.copy($scope.selectedGradeTemp);
            $scope.adminClassList = [];
            param.pageNumber = 0;
            getAdminClassUnderGradeAndOrg();
            $scope.closeSelectGrade();
        };

        /**
         * 汇总年级下在读班级的机构
         */
        var getAdminClassOrgs = function () {
            $http.post(originBaseUrl + '/third/behavioRassess/getAdminClassOrgs.htm', {gradeId: $scope.selectedGradeTemp.id}).success(function (data) {
                if (data.status == 0) {
                    $scope.orgList = data.result;
                    if (!isFromItemPage) {
                        if (data.result && data.result.length > 0) {
                            if (isFirstLoad) {
                                // 默认选中第一个
                                $scope.selectOrg(data.result[0]);
                            }
                        } else {
                            $scope.selectOrg({});
                        }
                    } else {
                        $scope.selectOrg(oldParam.selectedOrg);

                    }
                    isFromItemPage = false;
                }
                isFirstLoad = false;
            });
        };

        /**
         * 选中年级
         * @param grade
         */
        $scope.selectGrade = function (grade) {
            $scope.selectedGradeTemp = grade;
            getAdminClassOrgs();
        };

        /**
         * 获得近5年有效的年级
         */
        var getNearlyFiveYearsGrades = function () {
            $http.get(originBaseUrl + '/third/behavioRassess/getNearlyFiveYearsGrades.htm').success(function (data) {
                if (data.status == 0) {
                    $scope.gradeList = data.result;
                    if (data.result && data.result.length > 0) {
                        // 如果有缓存
                        if (isFromItemPage) {
                            $scope.selectGrade(oldParam.selectedGrade);
                        } else {
                            // 默认选中第一个
                            $scope.selectGrade(data.result[0]);
                        }
                    }
                }
            });
        };
        getNearlyFiveYearsGrades();

        /**
         * 初始化已选中学生标识
         * @param selectedStuList
         * @param searchStuList
         */
        var initSelectedFlag = function (selectedStuList, searchStuList) {
            angular.forEach(selectedStuList, function (selectedStu) {
                angular.forEach(searchStuList, function (stu) {
                    if (selectedStu.platformSysUserId == stu.platformSysUserId) {
                        stu.isSelected = true;
                    }
                });
            });
        };

        /**
         * 获取行政班下的学生
         */
        var getStuUnderAminClass = function () {
            $http.post(originBaseUrl + '/third/behavioRassess/getStuUnderAminClass.htm', {adminClassId: $scope.selectedAdminClass.id}).success(function (data) {
                if (data.status == 0) {
                    angular.forEach(data.result, function (item) {
                        item.isSelected = false;
                        if (item.headUrl) {
                            // var tempArr = item.headUrl.split(".");
                            //
                            // var artworkUrl = tempArr[0].substring(0, tempArr[0].length - 2);
                            // item.artworkUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + artworkUrl + "." + tempArr[1];
                            item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
                            item.artworkUrl = item.headUrl;

                        } else {
                            if (item.gender != 2) {
                                item.headUrl = "img/userface_1.png";
                            } else {
                                item.headUrl = "img/userface_0.png";
                            }
                        }
                    });
                    $scope.searchStuList = data.result;
                    initSelectedFlag($scope.selectedStuList, $scope.searchStuList);
                }
            });
        };

        /**
         * 选中行政班
         * @param adminClass
         */
        $scope.selectAdminClass = function (adminClass) {
            $scope.selectedAdminClass = adminClass;
            getStuUnderAminClass();
        };

        // 是否显示已选中学生
        $scope.showSelectedStu = false;
        var initTips = function () {
            return {
                isError: false,
                isNoData: false
            };
        };
        $scope.tips = initTips();

        /**
         * 加载更多
         */
        $scope.loadMore = function () {
            param.pageNumber++;
            if (param.pageNumber >= $scope.page.totalPages) {
                return false;
            }
            getAdminClassUnderGradeAndOrg();
        };


        /**
         * 选中学生
         * @param item
         */
        $scope.selectStu = function (item) {
            if (item.isSelected) {
                item.isSelected = false;
                var index = 0, delIndex = 0;
                angular.forEach($scope.selectedStuList, function (stu) {
                    if (stu.platformSysUserId == item.platformSysUserId) {
                        delIndex = index;
                    }
                    index++;
                });
                $scope.selectedStuList.splice(delIndex, 1);
            } else {
                item.isSelected = true;
                $scope.selectedStuList.unshift(item);
            }
            // 及时放入缓存
            creditStorageService.setItem("credit_selectedStuList", $scope.selectedStuList);
        };


        /**
         * 返回到首页
         */
        $scope.back = function () {
            $location.search("isFromItemPage", false);
            creditStorageService.clearKey("credit_oldSearchByClassParam");
            if ($state.$current.name === 'searchStuByClass_by_teacher') {
                $location.path("/search_student_by_teacher").search({"fromInternal": true});
            } else {
                $location.path("/search_student").search({"fromInternal": true});
            }
            setTimeout(function () {
                $scope.$apply();
            });
        };
        //返回事件拦截器
        ynNavigator.registerBackAction(function () {
            $scope.back();
        },101);
        /**
         * 开始考核
         */
        $scope.startCheck = function () {
            if ($scope.selectedStuList.length == 0) {
                ynuiNotification.error({msg: "请先添加学生！"});
                return;
            }
            if ($state.$current.name === 'searchStuByClass_by_teacher') {
                $location.path("/selectCheckItem_by_teacher").search({"fromSrc": "byClass"});
            } else {
                $location.path("/selectCheckItem").search({"fromSrc": "byClass"});
            }
            oldParam = {};
            oldParam.selectedGrade = $scope.selectedGrade;
            oldParam.selectedOrg = $scope.selectedOrg;
            creditStorageService.setItem("credit_oldSearchByClassParam", oldParam);
        };
    }

    selectCheckItemCtrl.$inject = ['$scope', '$http', '$location', '$state', '$ionicModal', "$filter", "$timeout", "ynuiNotification", "creditStorageService", "ynNavigator"];

    //选择考核项目
    function selectCheckItemCtrl($scope, $http, $location, $state, $ionicModal, $filter, $timeout, ynuiNotification, creditStorageService, ynNavigator) {
        // 已选中的学生
        $scope.selectedStuList = creditStorageService.getItemNoDel("credit_selectedStuList");

        $scope.locationStr = "right";
        // 考核项目类别和项目集
        $scope.checkTypeAndItemList = [];
        //  查询值
        $scope.queryValue = null;
        // 项目类别集
        $scope.itemTypeList = [];
        // 考核项目
        $scope.itemList = [];
        // 临时展示的考核项目（用于展示筛选结果）
        $scope.itemListTemp = [];
        // 已选中的考核项
        var ckeckItem = creditStorageService.getItemNoDel("credit_checkItem");

        // 选中的考核类别
        $scope.selectedItemType = creditStorageService.getItemNoDel("credit_selectedItemType");

        var filterInfo = creditStorageService.getItemNoDel("credit_filterInfo");
        // 过滤条件
        $scope.filterInfo = {
            selectedCreditType: filterInfo ? filterInfo.selectedCreditType : 0, // 选中的过滤条件
            selectedCreditTypeCache: null // 选中的过滤条件缓存
        };

        /**
         * 过滤
         * @param type null 全部，0 扣分项，1 加分项
         */
        $scope.filter = function (type) {
            $scope.filterInfo.selectedCreditType = type;
            if (type != null) {
                $scope.itemListTemp = $filter('filter')($scope.itemList, {"creditType": type});
            } else {
                $scope.itemListTemp = angular.copy($scope.itemList);
            }
            var param = null;
            if(ckeckItem){
                //初始化回填选中的效果【只选中一次】
                param = angular.copy(ckeckItem);
                //完了清空
                ckeckItem = null;
            }
            $scope.selectCheckItem(param);
        };

        /**
         * 选中考核类别
         * @param item
         */
        $scope.selectItemType = function (item) {
            $scope.selectedItemType = item;
            $scope.itemList = [];
            // 如果选中某个类别，则展示该类别下的项目
            if (item) {
                $scope.itemList = $scope.itemList.concat($scope.selectedItemType.creditExamineItemVOs);
            }
            // 如果选中全部，展示所有项目
            else {
                angular.forEach($scope.itemTypeList, function (itemType) {
                    $scope.itemList = $scope.itemList.concat(itemType.creditExamineItemVOs);
                });
            }
            $scope.filter($scope.filterInfo.selectedCreditType);
        };

        var initTips = function () {
            return {
                isError: false,
                isNoData: false
            };
        };
        $scope.tips = initTips();
        /**
         *  获取考核项目类别和项目
         */
        var searchExamineItem = function () {
            $http.post(originBaseUrl + '/third/behavioRassess/searchExamineItem.htm', {
                creditType: null,
                queryValue: $scope.queryValue
            }).success(function (data) {
                $scope.tips = initTips();
                $scope.itemTypeList = [];
                if (data.status == 0) {
                    if (!(data.result && data.result.length > 0)) {
                        $scope.tips.isNoData = true;
                    } else {
                        $scope.itemTypeList = data.result;
                    }
                    $scope.selectItemType($scope.selectedItemType);
                } else {
                    $scope.tips.isError = true;
                }
            }).error(function () {
                $scope.tips = initTips();
                $scope.itemTypeList = [];
                $scope.tips.isError = true;
            });
        };

        searchExamineItem();


        var timer = null;
        $scope.$watch('queryValue', function (newVal, oldVal) {
            if (newVal !== oldVal) {
                if (timer) {
                    $timeout.cancel(timer);
                }
                timer = $timeout(function () {
                    if (newVal == null) {
                        $scope.filterInfo.selectedCreditType = $scope.filterInfo.selectedCreditTypeCache;
                    } else {
                        $scope.filterInfo.selectedCreditTypeCache = angular.copy($scope.filterInfo.selectedCreditType);
                        $scope.filterInfo.selectedCreditType = null;
                    }
                    searchExamineItem();
                }, 700);
            }
        });

        /**
         * 清空查询条件
         */
        $scope.cleanVal = function () {
            $scope.queryValue = null;
        };

        /**
         * 重试
         */
        $scope.retry = function () {
            searchExamineItem();
        };

        /**
         * 选中考核项
         * @param item
         */
        $scope.selectCheckItem = function (item) {
            $scope.ckeckItem = null;
            // 放入缓存
            if (item && item.convertClassScore) {
                item.convertClassScore = Math.abs(item.convertClassScore);
            }
            angular.forEach($scope.itemListTemp, function (value) {
                value.active = false;
                if (item && value.id == item.id) {
                    value.active = true;
                    $scope.ckeckItem = item;
                }
            });
        };
        /**
         * 下一步
         */
        $scope.nextStep = function () {
            if (!$scope.ckeckItem) {
                ynuiNotification.error({msg: "请选择考核项目！"});
                return false;
            }
            creditStorageService.setItem("credit_checkItem", $scope.ckeckItem);
            creditStorageService.clearKey("credit_selectedItemType");
            if($scope.selectedItemType){
                creditStorageService.setItem("credit_selectedItemType", $scope.selectedItemType);
            }
            creditStorageService.setItem("credit_filterInfo", $scope.filterInfo);
            if ($state.$current.name === 'selectCheckItem_by_teacher') {
                $location.path("/fillInCheckInfo_by_teacher");
            } else {
                $location.path("/fillInCheckInfo");
            }
        };
        /**
         * 上一步
         */
        $scope.previousStep = function () {
            var fromSrc = $location.search().fromSrc;
            if (fromSrc) {
                // 来源班级学生选择页面
                if (fromSrc == "byClass") {
                    if ($state.$current.name === 'selectCheckItem_by_teacher') {
                        $location.path("/searchStuByClass_by_teacher").search("isFromItemPage", true);
                    } else {
                        $location.path("/searchStuByClass").search("isFromItemPage", true);
                    }
                } else if (fromSrc == "byCondition") {
                    if ($state.$current.name === 'selectCheckItem_by_teacher') {
                        $location.path("/searchStuByCondition_by_teacher");
                    } else {
                        $location.path("/searchStuByCondition");
                    }
                }
            } else {
                if ($state.$current.name === 'selectCheckItem_by_teacher') {
                    $location.path("/search_student_by_teacher");
                } else {
                    $location.path("/search_student");
                }
            }
            setTimeout(function () {
                $scope.$apply();
            })
        };
        ynNavigator.registerBackAction(function () {
            $scope.previousStep();
        },101);
    }

    fillInCheckInfoCtrl.$inject = ['stringsConstant', '$cordovaFileTransfer', '$cordovaFile', '$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location", "creditStorageService", "$ionicPopup", "$ionicSlideBoxDelegate", "$ionicModal","$state"];

    //填写考核信息
    function fillInCheckInfoCtrl(stringsConstant, $cordovaFileTransfer, $cordovaFile, $scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location, creditStorageService, $ionicPopup, $ionicSlideBoxDelegate, $ionicModal,$state) {
        // 已选中的学生
        $scope.selectedStuList = creditStorageService.getItemNoDel("credit_selectedStuList");
        // 已选中的考核项目
        $scope.ckeckItem = creditStorageService.getItemNoDel("credit_checkItem");
        // 已缓存的已填写的考核信息
        var checkInfoCache = creditStorageService.getItemNoDel("credit_checkInfo");

        $scope.locationStr = "center";
        // $scope.ckeckItem.isAllowAdjust = false;
        // 是否展开显示考核项目描述详情
        $scope.showAllRemark = false;
        // 考核是否成功标志
        $scope.checkSuccess = false;
        $scope.getCurrentTime = function () {
            var currentTime = new Date();
            var month = (currentTime.getMonth() + 1) > 9 ? (currentTime.getMonth() + 1) : '0' + (currentTime.getMonth() + 1);
            var day = currentTime.getDate() > 9 ? currentTime.getDate() : '0' + currentTime.getDate();
            var hour = currentTime.getHours() > 9 ? currentTime.getHours() : '0' + currentTime.getHours();
            var minute = currentTime.getMinutes() > 9 ? currentTime.getMinutes() : '0' + currentTime.getMinutes();
            var currentTimeStr = currentTime.getFullYear() + "-" + month + "-" + day + " " + hour + ":" +
                minute;
            return currentTimeStr;
        };
        $scope.initFiles = [];
        $scope.getDfsIds = function (data) {
            $scope.checkInfo.fastDfsIds = data.data;
        };

        // 考核信息
        $scope.checkInfo = null;

        // 如果有缓存就从缓存中读取
        if (checkInfoCache) {
            $scope.checkInfo = checkInfoCache;
            // 如果考核项目已改变
            if ($scope.checkInfo.examineItemId != $scope.ckeckItem.id) {
                $scope.checkInfo.examineItemId = $scope.ckeckItem.id;
                $scope.checkInfo.score = $scope.ckeckItem.creditScore;
                $scope.checkInfo.scoreNumber = 1;
                $scope.checkInfo.creditType = $scope.ckeckItem.creditType;
                $scope.checkInfo.isEffectAdminClassExamine = $scope.ckeckItem.isAffectClassCheck;
                $scope.checkInfo.convertClassCheckWay = $scope.ckeckItem.convertClassCheckWay;
                $scope.checkInfo.datetime = $scope.getCurrentTime();
            }
            $scope.initFiles = angular.copy($scope.checkInfo.fastDfsIds);
            // 初始化照片列表
            if ($scope.initFiles && $scope.initFiles.length) {
                angular.for($scope.initFiles, function (v, k) {
                    var data = originBaseUrl + '/file/downloadStream.htm?fastDFSId=' + v;
                    if (!(/\.(?:jpg|png|bmp|gif|jpeg)$/i).test(v)) {
                        data = 'img/file.png'
                    }
                    var photo = {
                        uri: data,
                        path: data.substr(0, data.lastIndexOf('/') + 1),
                        name: data.substr(data.lastIndexOf('/') + 1),
                        fsId: v,
                        status: 1,
                        progress: '100%'
                    };
                    $scope.photos.push(photo);
                })
            }
        } else {
            $scope.checkInfo = {
                examineItemId: $scope.ckeckItem.id,
                score: $scope.ckeckItem.creditScore,
                scoreNumber: 1,
                //0 减分 1 加分
                creditType: $scope.ckeckItem.creditType,
                totalSocre: "",
                isEffectAdminClassExamine: $scope.ckeckItem.isAffectClassCheck,
                convertClassCheckWay: $scope.ckeckItem.convertClassCheckWay,
                stuIdList: [],
                fastDfsIds: [],
                recordSource: 1,
                examineDate: "",
                examineTime: "",
                remark: "",
                examineAddress: "",
                datetime: $scope.getCurrentTime()
            };
        }


        var reg = /^\d{1,4}(\.\d{1,1})?$/;

        $scope.validateScore = function (score) {
            if (!$scope.ckeckItem.isAllowAdjust) {
                return true;
            }
            if (!score && score != 0) {
                ynuiNotification.error({msg: '请填写' + ($scope.ckeckItem.creditType == 0 ? '扣分' : '加分') + "分值"});
                return false;
            }
            if (!reg.test(score)) {
                ynuiNotification.error({msg: "单次分值只能是" + $scope.ckeckItem.creditBeginScore + "~" + $scope.ckeckItem.creditEndScore + "以内的数字，且只能保留一位小数！"});
                return false;
            }
            if (parseFloat($scope.checkInfo.score) > parseFloat($scope.ckeckItem.creditEndScore)) {
                ynuiNotification.error({msg: "不能大于" + $scope.ckeckItem.creditEndScore + "分"});
                $timeout(function () {
                    $scope.checkInfo.score = $scope.ckeckItem.creditEndScore;
                }, 500);
                return false;
            }
            if (parseFloat($scope.checkInfo.score) < parseFloat($scope.ckeckItem.creditBeginScore)) {
                ynuiNotification.error({msg: "不能小于" + $scope.ckeckItem.creditBeginScore + "分"});
                $timeout(function () {
                    $scope.checkInfo.score = $scope.ckeckItem.creditBeginScore;
                }, 500);
                return false;
            }
            return true;
        };

        /**
         * 监听项目打分值变化
         */
        $scope.$watch("checkInfo.score", function (newVal, oldVal) {
            if (newVal !== oldVal) {
                $scope.validateScore(newVal);
            }
        });


        //获取常用考核备注
        $scope.getRemarkList = function (item, isShowModal) {
            $scope.remarkList = [];
            $ionicLoading.show({
                template: "正在加载..."
            });
            $http.post(originBaseUrl + "/third/behavioRassess/queryCommonRemarkList.htm?itemId=" + item.id).success(function (data) {
                $ionicLoading.hide();
                if (data.status == 0) {
                    $scope.remarkList = data.result;
                    if (isShowModal) {
                        $scope.remarkModal.show();
                    }

                }
            }).error(function () {
                $ionicLoading.hide();
            });

        };
        $scope.selectedRemark = null;
        $scope.closeModal = function () {
            $scope.remarkModal.hide();
        };
        //选择常用备注
        $scope.selectRemarkFun = function (item) {
            $scope.checkInfo.remark = item.name;
            $scope.selectedRemark = item;
            $scope.closeModal();
        };

        $scope.addAndSubNumber = function (isAdd) {

            if (isAdd) {
                if (parseFloat($scope.checkInfo.scoreNumber) >= 999) {
                    return false;
                }
                $scope.checkInfo.scoreNumber = parseFloat($scope.checkInfo.scoreNumber) + 1;
            } else {
                if (parseFloat($scope.checkInfo.scoreNumber) <= 1) {
                    return false;
                }
                $scope.checkInfo.scoreNumber = parseFloat($scope.checkInfo.scoreNumber) - 1;
            }
        }
        $scope.$watch("checkInfo.scoreNumber", function () {
            if (parseFloat($scope.checkInfo.scoreNumber) <= 0) {
                $scope.checkInfo.scoreNumber = 1;
            }
            $scope.verifyNumber();
        });
        $scope.verifyNumber = function () {
            var reg = /^\+?[1-9][0-9]{0,5}$/;
            if (reg.test($scope.checkInfo.scoreNumber)) {
                if (parseFloat($scope.checkInfo.scoreNumber) <= 0) {
                    return false;
                }
                return true;
            } else {
                ynuiNotification.error({msg: "次数只能是正整数!"});
                return false;
            }

        }

        $scope.addAndSubScore = function (isAdd) {

            if (isAdd) {
                if (parseFloat($scope.checkInfo.score) < parseFloat($scope.ckeckItem.creditEndScore)) {
                    $scope.checkInfo.score = accAdd(parseFloat($scope.checkInfo.score), parseFloat(0.1));
                    if (parseFloat($scope.checkInfo.score) >= parseFloat($scope.ckeckItem.creditEndScore)) {
                        ynuiNotification.error({msg: "不能大于" + $scope.ckeckItem.creditEndScore + "分"});
                        return;
                    }
                    if (parseFloat($scope.checkInfo.score) <= parseFloat($scope.ckeckItem.creditBeginScore)) {
                        ynuiNotification.error({msg: "不能小于" + $scope.ckeckItem.creditBeginScore + "分"});
                        return;
                    }
                }

            } else {
                if (parseFloat($scope.checkInfo.score) > parseFloat($scope.ckeckItem.creditBeginScore)) {
                    $scope.checkInfo.score = accSub(parseFloat($scope.checkInfo.score), parseFloat(0.1));
                    if (parseFloat($scope.checkInfo.score) >= parseFloat($scope.ckeckItem.creditEndScore)) {
                        ynuiNotification.error({msg: "不能大于" + $scope.ckeckItem.creditEndScore + "分"});
                        return false;
                    }
                    if (parseFloat($scope.checkInfo.score) <= parseFloat($scope.ckeckItem.creditBeginScore)) {
                        ynuiNotification.error({msg: "不能小于" + $scope.ckeckItem.creditBeginScore + "分"});
                        return false;
                    }
                }
            }
        };

        /*选择图片或拍照*/
        $scope.photos = [];

        // 选择图片
        $scope.choosePicture = function () {
            $ionicModal.fromTemplateUrl('choosePicture.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                modal.show();
                $scope.choosePictureModal = modal;
            });
        };
        // 拍照
        $scope.takePhoto = function () {
            $scope.choosePictureModal.hide();
            navigator.camera.getPicture(function (data) {
                console.log(JSON.stringify(data));
                var photo = {
                    uri: data,
                    path: data.substr(0, data.lastIndexOf('/') + 1),
                    name: data.substr(data.lastIndexOf('/') + 1),
                    fsId: '',
                    status: 0,
                    progress: 0
                };
                $scope.photos.push(photo);
                // 执行上传
                $scope.upload(photo);
            }, function (error) {
                console.log(JSON.stringify(error))
            }, {
                sourceType: Camera.PictureSourceType.CAMERA
            })
        };
        // 选择照片
        $scope.takePicture = function () {
            $scope.choosePictureModal.hide();
            navigator.camera.getPicture(function (data) {
                console.log(JSON.stringify(data));
                var photo = {
                    uri: data,
                    path: data.substr(0, data.lastIndexOf('/') + 1),
                    name: data.substr(data.lastIndexOf('/') + 1),
                    fsId: '',
                    status: 0,
                    progress: 0
                };
                $scope.photos.push(photo);
                // 执行上传
                $scope.upload(photo);
            }, function (error) {
                console.log(JSON.stringify(error))
            }, {
                sourceType: Camera.PictureSourceType.PHOTOLIBRARY
            })
        };
        // 得到照片字符串
        $scope.getFsIds = function () {
            var photosFsIds = [];
            for (var i = 0; i < $scope.photos.length; i++) {
                if ($scope.photos[i].fsId) {
                    photosFsIds.push($scope.photos[i].fsId);
                }
            }
            $scope.checkInfo.fastDfsIds = photosFsIds;
            console.log(JSON.stringify(photosFsIds));
        };
        // 单个上传
        $scope.upload = function (photo) {
            photo.status = '0';
            // 参数
            var mac = stringsConstant.utils.uuid();
            var userId = JSON.parse(window.localStorage.getItem('authorizationStr')).userId;
            var options = new FileUploadOptions();
            options.fileName = photo.name;
            options.params = {
                name: photo.name,
                userId: userId,
                mac: mac
            };
            options.headers = {
                authorization: JSON.parse(window.localStorage.getItem("authorizationStr")).access_token
            };
            $cordovaFileTransfer.upload(stringsConstant.file.uploadServer(), photo.uri, options)
                .then(function (uploadSuccessData) {
                    console.log(JSON.stringify(uploadSuccessData.response));
                    // 上传完成
                    photo.fsId = JSON.parse(uploadSuccessData.response).result.fileId;
                    if (photo.fsId) {
                        photo.status = '1';

                        $scope.getFsIds();
                    } else {
                        console.error('上传失败,fsId为空');
                        photo.status = '-1';
                    }
                }, function (uploadError) {
                    console.error('上传失败');
                    console.error(JSON.stringify(uploadError));
                    photo.status = '-1';
                }, function (progress) {
                    $timeout(function () {
                        photo.progress = parseInt((progress.loaded / progress.total) * 100) + '%';
                        console.log('上传进度: ' + photo.progress);
                    });
                });
        };
        // 单个照片失败重试
        $scope.retry = function (photo) {
            console.log('失败文件重试: ' + photo.uri);
            if (photo.status === '-1') {
                $scope.upload(photo);
            }
        };
        // 预览照片
        $scope.previewPhoto = function (photo) {
            var cordovaFileOpen = cordova.plugins.disusered.open;
            cordovaFileOpen(photo.uri, cordovaFileOpenSuccess, cordovaFileOpenError);

            function cordovaFileOpenSuccess() {
                // 从已安装程序中打开文件完成
            }

            function cordovaFileOpenError(code) {
                if (code === 1) {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '未能在手机已安装APP中找到可预览此文件的程序'
                    });
                } else {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '预览时发生了未知错误 #' + code
                    });
                }
            }
        };
        // 删除照片
        $scope.deletePhoto = function (photo) {
            $ionicPopup.confirm({
                title: '删除确认',
                template: '确认要删除当前照片吗?',
                cancelText: '取消',
                okText: '删除'
            }).then(function (res) {
                if (res) {
                    if (photo.fsId) {
                        // 删除服务端文件
                        $http({
                            method: 'GET',
                            url: stringsConstant.file.deleteServer() + photo.fsId
                        })
                            .success(function (deletePhotoRes) {
                                console.log(JSON.stringify(deletePhotoRes));
                                if (deletePhotoRes.status === 0) {
                                    // 已从文件服务器删除文件，执行本地删除
                                    $scope.deleteLocalPhoto(photo);
                                }
                            })
                            .error(function (deletePhotoErr) {
                                console.error('从文件服务器删除文件失败');
                                console.error(JSON.stringify(deletePhotoErr));
                            });
                    } else {
                        // 删除本地文件
                        $scope.deleteLocalPhoto(photo);
                    }
                }
            });
        };
        // 删除本地照片
        $scope.deleteLocalPhoto = function (photo) {
            for (var i = 0; i < $scope.photos.length; i++) {
                if ($scope.photos[i].uri === photo.uri) {
                    $scope.photos.splice(i, 1);
                    $scope.getFsIds();
                }
            }
        };
        /*选择图片或拍照 结束*/


        /**
         * 确认考核信息对话框参数信息
         *
         */
        $scope.confirmPopParam = {
            stuNameStr: null,
            checkItemName: null,
            scoreStr: null
        };

        var openConfirmPopParam = function () {
            var stuNameStr = "";
            angular.forEach($scope.selectedStuList, function (stu) {
                if (stuNameStr.length > 0) {
                    stuNameStr += "、";
                }
                stuNameStr += stu.stuName;
            });
            $scope.confirmPopParam.stuNameStr = stuNameStr;
            $scope.confirmPopParam.checkItemName = $scope.ckeckItem.name;
            $scope.confirmPopParam.scoreStr = ($scope.ckeckItem.creditType == '0' ? '扣' : '加') + mul($scope.checkInfo.score, $scope.checkInfo.scoreNumber) + "分";
            var confirmPopup = $ionicPopup.confirm({
                title: "请确认考核信息",
                templateUrl: 'templates/moralityMeasurement/templates/confirmCheckInfoPop.html',
                scope: $scope,
                cancelText: "取消",
                okText: "确认提交"
            });
            confirmPopup.then(function (res) {
                $ionicLoading.hide();
                if (res) {
                    submitCheckInfo();
                }
            });
        };

        $scope.submit = function () {
            if (!$scope.validateScore($scope.checkInfo.score)) {
                $ionicScrollDelegate.scrollTop();
                return;
            }
            if (!$scope.verifyNumber()) {
                $ionicScrollDelegate.scrollTop();
                return;
            }
            // 验证是否选了学生
            if ($scope.selectedStuList.length == 0) {
                ynuiNotification.error({msg: "请添加学生！"});
                return;
            }
            if ($scope.checkInfo.datetime) {
                var dateAndTime = $scope.checkInfo.datetime.split(" ");
                if (!dateAndTime || dateAndTime.length != 2) {
                    return false;
                }
                $scope.checkInfo.examineDate = dateAndTime[0];
                $scope.checkInfo.examineTime = dateAndTime[1];
            }
            // 验证考核日期是否被锁定
            $http.post(originBaseUrl + "/third/behavioRassess/isLockDate.htm", {date: $scope.checkInfo.examineDate}).success(function (data) {
                if (data.status == 0) {
                    if (data.result) {
                        ynuiNotification.error({msg: "考核日期" + $scope.checkInfo.examineDate + "已被锁定，请重新选择！"});
                        return;
                    } else {
                        $scope.checkInfo.stuIdList = [];
                        angular.forEach($scope.selectedStuList, function (item) {
                            $scope.checkInfo.stuIdList.push(item.platformSysUserId);
                        });
                        $scope.checkInfo.totalSocre = mul(parseFloat($scope.checkInfo.score), parseFloat($scope.checkInfo.scoreNumber));
                        openConfirmPopParam()
                    }
                }
            });
        };

        /**
         * 向后台提交数据
         */
        var submitCheckInfo = function () {
            $ionicLoading.show({
                template: '正在提交...'
            });
            $http.post(originBaseUrl + '/third/behavioRassess/batchSaveStuCredit.htm?', $scope.checkInfo).success(function (data) {
                $ionicLoading.hide();
                $ionicScrollDelegate.scrollTop();
                if (data.status == 0) {
                    $scope.checkSuccess = true;
                } else {
                    ynuiNotification.error({msg: data.message});
                }
            }).error(function () {
                $ionicLoading.hide();
                $ionicScrollDelegate.scrollTop();
                ynuiNotification.error({msg: "提交失败！"});
            });
        };

        //输入原因浮层
        $ionicModal.fromTemplateUrl('show_cause.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.remarkModal = modal;
        });

        /**
         * 上一步
         */
        $scope.previousStep = function () {
            // 将填写的考核信息放入缓存
            creditStorageService.setItem("credit_checkInfo", $scope.checkInfo);
            if ($state.$current.name === 'fillInCheckInfo_by_teacher') {
                $location.path("/selectCheckItem_by_teacher");
            } else {
                $location.path("/selectCheckItem");
            }
        };

        /**
         * 考核其他学生
         */
        $scope.checkOtherStu = function () {
            $scope.selectedStuList = [];
            creditStorageService.setItem("credit_selectedStuList", $scope.selectedStuList);
            if ($state.$current.name === 'fillInCheckInfo_by_teacher') {
                $location.path("/search_student_by_teacher").search("fromInternal", true);
            } else {
                $location.path("/search_student").search("fromInternal", true);
            }
        };

        /**
         * 获取定位
         */
        var gpsTimer;
        $scope.getGPSData = function () {
            $scope.dataStatus = '1'; // 1:定位中，2:定位成功，3:定位失败
            // 获取当前定位
            navigator.geolocation.getCurrentPosition(function (data) {
                if(data.status === 1 && data.result.address){
                    $scope.dataStatus = '2';
                    var result = data.result;
                    $timeout(function () {
                        $scope.checkInfo.examineAddress = result.address;
                    });
                } else {
                    $scope.dataStatus = '0';
                    console.log('errorCode: ' + data.errorCode + ', errorInfo: ' + data.errorInfo);
                }
            }, function (error) {
                $scope.dataStatus = '0';
                console.log('定位失败:' + JSON.stringify(error));
            });
        };

        //js浮点数计算不准确计算解决
        function mul(a, b) {
            var c = 0,
                d = a.toString(),
                e = b.toString();
            try {
                c += d.split(".")[1].length;
            } catch (f) {
            }
            try {
                c += e.split(".")[1].length;
            } catch (f) {
            }
            return Number(d.replace(".", "")) * Number(e.replace(".", "")) / Math.pow(10, c);
        }

        function div(a, b) {
            var c, d, e = 0,
                f = 0;
            try {
                e = a.toString().split(".")[1].length;
            } catch (g) {
            }
            try {
                f = b.toString().split(".")[1].length;
            } catch (g) {
            }
            return c = Number(a.toString().replace(".", "")), d = Number(b.toString().replace(".", "")), mul(c / d, Math.pow(10, f - e));
        }

        function accAdd(a, b) {
            var c, d, e;
            try {
                c = a.toString().split(".")[1].length;
            } catch (f) {
                c = 0;
            }
            try {
                d = b.toString().split(".")[1].length;
            } catch (f) {
                d = 0;
            }
            return e = Math.pow(10, Math.max(c, d)), (mul(a, e) + mul(b, e)) / e;
        }

        function accSub(a, b) {
            var c, d, e;
            try {
                c = a.toString().split(".")[1].length;
            } catch (f) {
                c = 0;
            }
            try {
                d = b.toString().split(".")[1].length;
            } catch (f) {
                d = 0;
            }
            return e = Math.pow(10, Math.max(c, d)), (mul(a, e) - mul(b, e)) / e;
        }
    }

})();



