/**
 * 考试-在线考试、考试任务、申请补考
 * @author qiucheng Lu
 * @Date 2021年4月10日16:27:51
 */
(function () {
    'use strict';

    angular.module('starter')
        .config(stateConfig)
        .controller('onLineExaminationController', onLineExaminationController)
        .controller('examPaperController', examPaperController)
        .filter('to_trustedExamination', ['$sce', to_trustedExamination])
        .controller('retestStudentController', retestStudentController)
        .controller('retestApplyController', retestApplyController)
        .service('onLineExamService', onLineExamService)
        .directive('judgmentQuestionAnser', judgmentQuestionAnser)
        .directive('choiceQuestionAnswer', choiceQuestionAnswer)
        .directive('fillInBlanksAnswer', fillInBlanksAnswer)
        .directive('shortAnswerQuestionAnswer', shortAnswerQuestionAnswer);

    stateConfig.$inject = ['$stateProvider', '$urlRouterProvider'];

    function stateConfig($stateProvider, $urlRouterProvider) {
        $stateProvider
        //在线考试-学生考试列表
            .state('onLine_examination', {
                url: '/onLine_examination',
                templateUrl: 'templates/onLine_examination/onLine_examination.html',
                data: {
                    prev: 'achievementworkspace',
                    title: '在线考试'
                },
                controller: 'onLineExaminationController'
            })
            //在线考试-用户首次进入该考试计划时，界面效果
            .state('examination_model', {
                url: '/examination_model',
                templateUrl: 'templates/onLine_examination/examination_model.html',
                data: {
                    title: '在线考试',
                    prev: 'onLine_examination'
                },
            })
            // 在线考试-考试试卷页面
            .state('exam_paper', {
                url: '/exam_paper',
                templateUrl: 'templates/onLine_examination/exam_paper.html',
                data: {
                    title: '在线考试',
                    prev: 'onLine_examination'
                },
                controller: 'examPaperController'
            })
            // 考试任务-考试安排
            .state('exam_arrange', {
                url: '/exam_arrange',
                templateUrl: 'templates/supplement_exam/studentExamInfo/exam_arrange.html',
                data: {
                    prev: 'achievementworkspace',
                    title: '考试任务'
                },
                controller: 'retestStudentController'
            })
            // 考试任务-申请补考
            .state('apply_bk', {
                url: '/apply_bk',
                templateUrl: 'templates/supplement_exam/studentExamInfo/apply_bk.html',
                data: {
                    prev: 'achievementworkspace',
                    title: '申请补考'
                },
                controller: 'retestApplyController'
            })
    }

    onLineExaminationController.$inject = ['$scope', '$ionicModal', '$http', '$location', '$ionicPopup', '$ionicScrollDelegate', '$rootScope'];

    //在线考试-学生考试列表
    function onLineExaminationController($scope, $ionicModal, $http, $location, $ionicPopup, $ionicScrollDelegate, $rootScope) {


        var backData = $location.search();
        var currentUserId = angular.copy($rootScope.authorizationStr.userId);

        //0正常 1学期不存在 3考试不存在
        $scope.tips = "0";
        $scope.nowMessage = "";
        $scope.examTable = "";
        $scope.content = {
            pageNumber: 1,
            pageSize: 10,
        }
        $scope.courseName = "全部";
        $scope.examTypeName = "全部";
        $scope.statusName = "全部";
        $scope.examAllConditions = {
            examFutureNum: "0",
            examNowNum: "0",
            examEndNum: "0",
        }

        $scope.examInfoSearch = {
            userId: currentUserId,
            termId: "",
            examStatus: "",
            type: "",
            status: "",
            courseId: ""
        }

        $scope.moreData = 0;

        //获取考试列表
        $scope.findOnlineExam = function (item, isAdd) {
            $scope.examAllConditions = null;
            $scope.tips = "0";
            var infoSearch = {
                type: $scope.examInfoSearch.type,
                status: $scope.examInfoSearch.status,
                courseId: $scope.examInfoSearch.courseId,
                examStatus: item,
                pageNumber: $scope.content.pageNumber,
                pageSize: $scope.content.pageSize
            }

            $http.post(originBaseUrl + '/third/mobileStudentExame/examInfos.htm', infoSearch).success(function (data) {
                if (data.status == 0) {

                    if (data.result.termId == null || data.result.termId == "") {
                        $scope.tips = "1";
                        $scope.nowMessage = "当前学期不存在，无法在线考试和查看考试结果！";
                    } else {
                        if (null == data.result.stuExamInfoVOS || data.result.stuExamInfoVOS.length < 1) {
                            $scope.tips = "2";
                            $scope.nowMessage = "没有找到相关内容！";
                        }
                        $scope.examInfoSearch.termId = data.result.termId;
                        $scope.term = {
                            id: data.result.termId,
                            name: data.result.termName,
                        }
                        if (data.result.examType == "0") {
                            $scope.moreData = data.result.examNowNum;
                        }
                        if (data.result.examType == "1") {
                            $scope.moreData = data.result.examFutureNum;
                        }
                        if (data.result.examType == "2") {
                            $scope.moreData = data.result.examEndNum;
                        }
                        var now = angular.copy(data.result.stuExamInfoVOS);
                        $scope.examAllConditions = angular.copy(data.result);
                        if ($scope.allExaminfo && $scope.allExaminfo.length > 0 && isAdd == true) {
                            $scope.examAllConditions.stuExamInfoVOS = $scope.allExaminfo;
                            angular.forEach(now, function (item) {
                                $scope.examAllConditions.stuExamInfoVOS.push(item);
                            });
                        }
                        $scope.examEnd = $scope.examAllConditions.examType;
                        $("[id^='type']").filter(".active").attr("class", "tab-item");
                        $("#type_" + data.result.examType).attr("class", "tab-item active");
                        if (data.result.examType == 2) {
                            $("#contentSet").attr("style", "top: 105px;");
                        } else {
                            $("#contentSet").attr("style", "top: 75px;");

                        }
                    }

                    if (isAdd == true || isAdd == "0") {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    }
                } else {
                    $scope.tips = "2";
                    $scope.nowMessage = "没有找到相关内容！";
                }

            }).error(function (data) {
                var alertPopup = $ionicPopup.alert({
                    title: '错误提示',
                    template: data.message,
                    okText: '确定'
                });
                alertPopup.then(function (res) {
                });
            });
        }

        //当前学期
        $scope.termRefresh = function (item) {

            $scope.examInfoSearch.type = "";
            $scope.examInfoSearch.status = "";
            $scope.examInfoSearch.courseId = "";

            $scope.courseName = "全部";
            $scope.examTypeName = "全部";
            $scope.statusName = "全部"
            if (item) {
                $scope.examEnd = item;
            }
            $scope.findOnlineExam($scope.examEnd);
        }

        if (backData && backData.examStatus) {
            $scope.examInfoSearch.examStatus = backData.examStatus;
            $scope.termRefresh($scope.examInfoSearch.examStatus);
        } else {
            $scope.examInfoSearch.examStatus = "";
            $scope.termRefresh();
        }

        $scope.findAllConditions = function () {
            //查询考试类型
            $http.post(originBaseUrl + "/third/mobileStudentExame/getExamTypeAll.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.examType = data.result.content;
                }
            });
            //查询课程
            $http.post(originBaseUrl + "/third/mobileStudentExame/getExamCourseAll.htm", $scope.examInfoSearch).success(function (data) {
                if (data.status == 0) {
                    $scope.courseList = data.result;
                }
            });
        }

        $scope.changeType = function (item, num) {
            $scope.moreData = num;
            $scope.content.pageNumber = 1;
            $scope.content.pageSize = 10;

            $scope.examInfoSearch.type = "";
            $scope.examInfoSearch.status = "";
            $scope.examInfoSearch.courseId = "";

            $scope.courseName = "全部";
            $scope.examTypeName = "全部";
            $scope.statusName = "全部";

            $scope.examEnd = item;
            $("[id^='type']").filter(".active").attr("class", "tab-item");
            $("#type_" + item).attr("class", "tab-item active");
            $scope.examInfoSearch.examStatus = item;
            window.sessionStorage.setItem("examStatus", $scope.examInfoSearch.examStatus);
            $scope.findOnlineExam(item, "0");
            if (item == 2) {
                $scope.findAllConditions();
            }
            $ionicScrollDelegate.scrollTop();
        }

        $scope.checkState = function (item) {
            if (item != null) {
                $scope.examInfoSearch.status = item;
                if (item == "1") {
                    $scope.statusName = "未批阅";
                    $("[id^='status']").filter(".active").attr("class", "");
                    $("#status_3").attr("class", " active");
                }
                if (item == "2") {
                    $scope.statusName = "已批阅";
                    $("[id^='status']").filter(".active").attr("class", "");
                    $("#status_4").attr("class", " active");
                }

            } else {

                $("[id^='status']").filter(".active").attr("class", "");
                $("#status_0").attr("class", "active");
                $scope.examInfoSearch.status = null;
                $scope.statusName = "全部"
            }
            $scope.findOnlineExam(2);
        }

        $scope.findByType = function (item) {
            if (item != null) {
                $scope.examInfoSearch.type = item.id;
                $scope.examTypeName = item.examTypeName;
                $("[id^='dataType']").filter(".active").attr("class", "");
                $("#dataType_" + item.id).attr("class", " active");
            } else {

                $("[id^='dataType']").filter(".active").attr("class", "");
                $("#dataType").attr("class", " active");
                $scope.examInfoSearch.type = null;
                $scope.examTypeName = "全部";
            }

            $scope.findOnlineExam(2);
        }

        $scope.changeSelectCourse = function (item) {
            if (item != null) {
                $scope.examInfoSearch.courseId = item.id;
                $scope.courseName = item.name;

                $("[id^='course']").filter(".active").attr("class", "");
                $("#course_" + item.id).attr("class", " active");
            } else {
                $("[id^='course']").filter(".active").attr("class", "");
                $("#course_all").attr("class", " active");
                $scope.examInfoSearch.courseId = null;
                $scope.courseName = "全部";
            }
            $scope.findOnlineExam(2);
        }

        /**
         * 判断是否能进入考试
         * @param item 考试信息
         */
        $scope.enter = function (item) {
            if (item.examTerminal == 1) {
                var alertCptPopup = $ionicPopup.alert({
                    title: '提示',
                    template: '<div class="text-left">&nbsp&nbsp&nbsp&nbsp本次考试只允许在电脑端考试，请在电脑端的浏览器中登录智慧校园平台进行考试！</div>',
                    okText: '确定'
                });
                alertCptPopup.then(function (res) {
                    $scope.showOwnRecommend = false;
                    $scope.submitVO = {
                        taskId: "",
                        adminClassId: "",
                        ownRecommendDesc: ""
                    };
                });
                return;
            }

            var getValid = {
                examInfoId: item.examInfoId,
                stuPlatformSysUserId: currentUserId
            };
            $scope.examPWD = "";

            $scope.searchData = {
                examRoomPassword: "",
                examInfoId: item.examInfoId,
            }
            $scope.examMessage = null;
            $http.post(originBaseUrl + "/third/mobileStudentExame/getExamStuByCheckIsEntry.htm", getValid).success(function (data) {
                var message = "";
                if (data.status == 0) {
                    if (item.password != null && item.password != "") {
                        checkExamPwd(item);
                    } else {
                        //打开新页面进行考试
                        $scope.goExam(item);
                    }
                } else {
                    message = data.message;
                }
                if (message != "") {
                    var alertGoExamPopup = $ionicPopup.alert({
                        title: '提示',
                        template: '<div class="text-left">&nbsp&nbsp&nbsp&nbsp' + message + '</div>',
                        okText: '确定'
                    });
                    alertGoExamPopup.then(function (res) {
                    });
                }
                ;
            });
        }
        var checkExamPwd = function (item) {
            var myPopup = $ionicPopup.show({
                title: '请输入考场密码',
                template: '<input class="form-control input-border"  type="\password\" ng-model="searchData.examRoomPassword"/>' + '<span ng-if="examMessage" style="color: #ef750e" class="help-block text-left">{{examMessage}}</span>',
                scope: $scope,
                buttons: [
                    {text: '取消', type: 'button-default'},
                    {
                        text: "确定", type: 'button-positive',
                        onTap: function (e) {
                            e.preventDefault();
                            if ($scope.searchData.examRoomPassword == "") {
                                $scope.examMessage = "密码不能为空！";
                            } else {
                                $http.post(originBaseUrl + "/third/mobileStudentExame/getExamStuByExamInfoId.htm", $scope.searchData).success(function (data) {
                                    if (data.status == 0) {
                                        //打开新页面进行考试
                                        $scope.goExam(item);
                                        myPopup.close();
                                    } else {
                                        $scope.examMessage = data.message;
                                    }
                                });
                            }


                        }
                    }
                ]
            });
        }


        //进入
        $scope.goExam = function (checkExam) {
            $location.path("/exam_paper").search({
                "title": checkExam.examName,
                "paperCopyId": checkExam.paperCopyId,
                "examInfoId": checkExam.examInfoId,
                "examStuId": checkExam.examStuId,
                "completeType": 0,
                "examType": 1,
                "onlineStatus": checkExam.onlineStatus,
                "fromEntry": 1
            });
        };

        //复卷
        $scope.checkExam = function (checkExam) {
            var searchData = {
                examStuId: checkExam.examStuId,
                examInfoId: checkExam.examInfoId
            };
            $http.post(originBaseUrl + "/third/mobileStudentExame/validExam.htm", searchData).success(function (data) {
                if (data.status == 0) {
                    $location.path("/preview_answer").search({
                        "title": checkExam.examName,
                        "testPapaerCopyId": checkExam.paperCopyId,
                        "studyHomeworkId": checkExam.examInfoId,
                        "studyStuGroupId": checkExam.examStuId,
                        "completeType": 0,
                        "examType": 1,
                        "backData": {state: "onLine_examination", info: $scope.examInfoSearch}
                    });
                } else {
                    if (data.message != "") {
                        var checkExamStuPopup = $ionicPopup.alert({
                            title: '提示',
                            template: '<div class="text-left">' + data.message + '</div>',
                            okText: '确定'
                        });
                        checkExamStuPopup.then(function (res) {

                        });
                    }
                }
            });


        }

        /**
         * 返回
         */
        $scope.goBack = function () {
            yn.plugin.yncordova.close();
        }

        /**
         * 加载更多
         */
        $scope.loadMore = function () {
            if (!$scope.examAllConditions) {
                return
            }
            if ($scope.examAllConditions.examType == 0) {
                if (($scope.content.pageSize * $scope.content.pageNumber) >= $scope.examAllConditions.examNowNum) {
                    return false;
                }
            }
            if ($scope.examAllConditions.examType == 1) {

                if (($scope.content.pageSize * $scope.content.pageNumber) >= $scope.examAllConditions.examFutureNum) {
                    return false;
                }
            }
            if ($scope.examAllConditions.examType == 2) {

                if (($scope.content.pageSize * $scope.content.pageNumber) >= $scope.examAllConditions.examEndNum) {
                    return false;
                }
            }
            $scope.content.pageNumber++;
            $scope.allExaminfo = $scope.examAllConditions.stuExamInfoVOS;
            $scope.findOnlineExam($scope.examAllConditions.examType, true);
        };


        $scope.refresh = function () {
            $scope.content = {
                pageNumber: 1,
                pageSize: 10,
            }
            $scope.termRefresh();
            $ionicScrollDelegate.scrollTop();
        }


        $scope.$watch("content.pageNumber", function () {
            $scope.nowPage = $scope.content.pageSize * $scope.content.pageNumber;
        })
        $scope.$watch("moreData", function () {
            $scope.nowPage = $scope.content.pageSize * $scope.content.pageNumber;
        })

    }

    examPaperController.$inject = ['$scope', '$ionicModal', '$http', '$location', '$ionicPopup', '$ionicLoading', '$ionicScrollDelegate', '$ionicPlatform', 'popup', 'onLineExamService', '$interval', 'storageService', 'ynNavigator'];

    //在线考试-考试试卷页面
    function examPaperController($scope, $ionicModal, $http, $location, $ionicPopup, $ionicLoading, $ionicScrollDelegate, $ionicPlatform, popup, onLineExamService, $interval, storageService, ynNavigator) {
        $scope.answerCardModal = null;
        $scope.modalHeight = '0%';
        $ionicModal.fromTemplateUrl('examinationModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.answerCardModal = modal;
        });
        $scope.subQuestionCardModal = null;
        $ionicModal.fromTemplateUrl('chooseSubQuestion.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.subQuestionCardModal = modal;
        });


        $scope.slideHasChanged = function (type) {
            onLineExamService.switchToPrevOrNextQuestion($scope.currentQuestion, type, function (prevOrNextQuestion) {
                saveAnswerAndLoadQuestion(prevOrNextQuestion.id);
            });
        };

        // 阿拉伯数字与中文数字映射map
        var CHINESE_NUMBER_MAP = {
            1: "一",
            2: "二",
            3: "三",
            4: "四",
            5: "五",
            6: "六",
            7: "七",
            8: "八",
            9: "九",
            10: "十",
            11: "十一",
            12: "十二",
            13: "十三",
            14: "十四",
            15: "十五",
            16: "十六",
            17: "十七",
            18: "十八",
            19: "十九",
            20: "二十"
        };

        // 处理试卷中的富文本有图片的问题
        // 默认倒计时时长
        var countdownTime = 0 * 60;
        var vm = $scope.vm = {
            examTitle: $location.search().title,
            // 是否显示答题操作引导
            isShowGuide: false,
            examInfoId: $location.search().examInfoId,
            // 是否不再提示
            isNoPromptAgain: true,
            duration: 0,
            formatToChineseNum: function (sequence) {
                var chineseNum = CHINESE_NUMBER_MAP[sequence];
                if (chineseNum) {
                    return chineseNum;
                }
                return sequence;
            },
            hideGuide: function () {
                this.isShowGuide = false;
                if (this.isNoPromptAgain) {
                    onLineExamService.hideGuide();
                }
                $scope.getAllQuestype();
            },
            buttonCountdownTime: 4,
            examCountdownTime: countdownTime,
            examCountdownTimeStr: formatSeconds(countdownTime),
            /**
             * 开始答题
             */
            beginExam: function () {
                if (vm.buttonCountdownTime > 0) {
                    return;
                }
                countDownPopup.close();
            },
            /**
             * 是否是选择题
             * @param question
             * @returns {boolean}
             */
            choiceQuestion: function (question) {
                return question.type == 1 || question.type == 2;
            },
            /**
             * 是否为判断题
             * @param question
             */
            judgmentQuestion: function (question) {
                return question.type == 4;
            },
            /**
             * 是否为简答题
             * @param question
             */
            shortAnswerQuestion: function (question) {
                return question.type == 5;
            },
            /**
             * 是否为填空题
             * @param question
             */
            fillInBlanksQuestion: function (question) {
                return question.type == 3;
            },
            /**
             * 处理试题完成状态（是否已做）
             * @param question 试题
             * @param parentQuestion 组合题的所属父题
             */
            dealQuestionDoneStatus: function (question, parentQuestion) {
                if (parentQuestion) {
                    // 有答案子题的统计数量
                    var hasAnswerChildQuestionCount = 0;
                    angular.forEach(parentQuestion.childrens, function (childQuestion) {
                        if (hasAnswer(childQuestion)) {
                            hasAnswerChildQuestionCount++;
                            childQuestion.isUnDone = false;
                        } else {
                            childQuestion.isUnDone = true;
                        }
                    });
                    if (hasAnswerChildQuestionCount === parentQuestion.childrens.length) {
                        parentQuestion.isUnDone = false;
                    } else {
                        parentQuestion.isUnDone = true;
                    }
                } else {
                    if (hasAnswer(question)) {
                        question.isUnDone = false;
                    } else {
                        question.isUnDone = true;
                    }
                }
            },
            /**
             * 获取已做试题数量
             * @returns {number}
             */
            getDoneQuestionNumber: function (questions) {
                if (questions) {
                    return questions.filter(function (question) {
                        return !question.isUnDone;
                    }).length;
                }
                return 0;
            },
            /**
             * 保存试题答案
             */
            saveQuestionAnswer: function (questionId) {
                var question = questionMap[questionId];
                var questionAnswerResult;
                // 如果是组合题下的子题
                if (question.parent) {
                    questionAnswerResult = dealResultDetail(question, question.parent.id);
                } else {
                    questionAnswerResult = dealResultDetail(question);
                }
                // 保存当前题的答案
                onLineExamService.saveQuestionAnswer(
                    parseParamForSpringMVC(questionAnswerResult),
                    function (data) {
                        if (data.status == 0) {
                            // 2.作弊强制交卷
                            if (data.result === 2) {
                                dealCheatTips();
                            } else if (data.result === 3) {
                                //3:管理员强制交卷
                                dealForceHandPaperTips();
                            }
                        }
                    }
                );
            },
            /**
             * 交卷
             */
            handExamPaper: function () {
                // 检查是否做完试题
                var unDoneQuestionNumber = countUnDoneQuestionNumber();
                countUnDoneQuestionNumber();
                var tipsMsg = "";
                if (unDoneQuestionNumber > 0) {
                    tipsMsg = "您还有<span style='color: red'>" + unDoneQuestionNumber + "</span>个题未做，确定交卷吗？<br/><span style='color: red'>一旦交卷后就不能再进入考试！</span>";
                } else {
                    tipsMsg = "您确定要交卷吗？<br/><span style='color: red'>一旦交卷后就不能再进入考试！</span>";
                }
                $ionicPopup.confirm({
                    title: '',
                    template: tipsMsg,
                    cancelText: "取消",
                    okText: '提交'
                }).then(function (res) {
                    if (res) {
                        saveQuestionAnswerAndHandExamPaper();
                    }
                })
            },
            upOrDownWindow: function (direction) {
                if (direction == 'top') {
                    if ($scope.windowStatus != 1) {
                        $scope.windowStatus = 1;
                        $scope.heightInfo.mainQuestionHeight = $scope.headAndFootHeight * 0.1;
                        $scope.heightInfo.subQuestionHeight = $scope.headAndFootHeight * 0.9;
                    }
                } else {
                    if ($scope.windowStatus != 3) {
                        $scope.windowStatus = 3;
                        $scope.heightInfo.mainQuestionHeight = $scope.headAndFootHeight * 0.9;
                        $scope.heightInfo.subQuestionHeight = $scope.headAndFootHeight * 0.1;
                    }
                }
            }
        };

        /**
         * 试题是否有答案（是否已答题）
         * @param question
         * @returns {boolean}
         */
        function hasAnswer(question) {
            if (vm.choiceQuestion(question)
                || vm.judgmentQuestion(question)) {
                if (question.answer) {
                    return true;
                }
            }
            // 如果是填空题，要所有的填空题都作答了才算作已作答
            if (vm.fillInBlanksQuestion(question)) {
                if (question.answer) {
                    var realAnswers = question.answer.split("◆");
                    var doneNumber = 0;
                    angular.forEach(realAnswers, function (answer) {
                        if (answer) {
                            doneNumber++;
                        }
                    });
                    return doneNumber == question.answerNumer;
                }
            }
            // 如果是简答题
            if (vm.shortAnswerQuestion(question)) {
                if (question.shortAnswerQuestionAnswer.textAreaAnswer) {
                    var realAnswer = question.shortAnswerQuestionAnswer.textAreaAnswer.replace(/◆/ig, '');
                    // console.log("realAnswer:", realAnswer);
                    return realAnswer.length > 0;
                }
                // 如果学生答案要求状态 0 在线作答+附件 1在线作答
                if (question.answerState == 0 && question.shortAnswerQuestionAnswer.attachmentVoList) {
                    return question.shortAnswerQuestionAnswer.attachmentVoList.length > 0;
                }
            }
            return false;
        }

        function saveQuestionAnswerAndHandExamPaper() {
            onLineExamService.saveQuestionAnswerAndHandExamPaper(parseParamForSpringMVC(getAnswerResult()), function (data) {
                if (data.status === 0) {
                    //2:作弊强制交卷
                    if (data.result === 2) {
                        dealCheatTips();
                    } else if (data.result === 3) {
                        //2:管理员强制交卷
                        dealForceHandPaperTips();
                    } else {
                        popup.alert('提示', "交卷成功！", '关闭');
                        goBack();
                    }
                } else {
                    popup.alert('提示', data.message, '关闭');
                    goBack();
                }
            });
        }

        function goBack() {
            // 如果是从在线考试应用的列表进入
            if ($location.search().fromEntry == 1) {
                $location.path("/onLine_examination");
            }
            // 如果是从登录的考试任务列表进入
            else {
                $location.path("/home_exam_tasks");
            }
        }

        var examCountdownTimer;

        function startExamCountdownTimer() {
            /**
             * 考试倒计时-计时器
             */
            examCountdownTimer = $interval(function () {
                vm.examCountdownTime--;
                vm.examCountdownTimeStr = formatSeconds(vm.examCountdownTime);
                if (vm.examCountdownTime === 0) {
                    $interval.cancel(examCountdownTimer);
                    saveQuestionAnswerAndHandExamPaper();
                    popup.alert(
                        '提示',
                        '<span style=\'color: red\'>考试时间已结束，系统已自动为你提交试卷！</span>',
                        '关闭'
                    ).then(function () {
                    })
                }
            }, 1000);
        }

        /**
         * 格式化倒计时秒数
         * @param seconds
         * @returns {number|string}
         */
        function formatSeconds(seconds) {
            var result = "";
            if (seconds <= 0) {
                return "00:00";
            }

            var minute = Math.floor(seconds / 60);
            if (minute < 10) {
                result = "0" + minute;
            } else {
                result = minute;
            }
            result += ":";
            var second = seconds % 60;
            if (second < 10) {
                result += "0" + second;
            } else {
                result += second;
            }
            return result;
        }

        $scope.$on('$destroy', function () {
            if (examCountdownTimer) {
                $interval.cancel(examCountdownTimer);
            }
        });
        $scope.headAndFootHeight = window.innerHeight - 125;
        $scope.initWindowSize = function (questionId) {
            var localData = storageService.getItemNoDel("exam:" + questionId);
            if (!localData) {
                $scope.windowStatus = 3;
                $scope.childQuestionIndex = 1;
            } else {
                $scope.windowStatus = localData.windowStatus;
                $scope.childQuestionIndex = localData.childQuestionIndex;
            }
            $scope.setWindowSize();
        }
        $scope.heightInfo = {mainQuestionHeight: '500px', subQuestionHeight: '500px'};
        $scope.getAllQuestype = function () {
            // 获取所有题目信息
            onLineExamService.entryAndGetStuExamPaperQuestionInfo(
                {
                    paperCopyId: $location.search().paperCopyId,
                    stuId: $location.search().examStuId,
                    examInfoId: $location.search().examInfoId,
                    lastTimeOperateType: "do"
                },
                function (data) {
                    if (data.status == 0) {
                        // console.log("data.result:", data.result);
                        var result = data.result;
                        // 如果已用完考试时长，这默认初始化10秒钟来做假的剩余时间来做展示
                        if (result.duration <= 0) {
                            vm.examCountdownTime = 10;
                        } else {
                            vm.examCountdownTime = result.duration * 60;
                        }
                        vm.duration = result.duration;
                        dealExamTips();
                        $scope.questionTypes = [];
                        $scope.questions = [];
                        angular.forEach(result.questionTypeVoList, function (questionType, index) {
                            // 未做的试题ID集合
                            var unDoQuestionIds = questionType.notCommitId;
                            questionType.name = dealQuestionTitle(questionType.name);
                            // 题型
                            var _questionType = new QuestionType(questionType.questionTypeId, questionType.name, questionType.eachScore, index + 1);
                            angular.forEach(questionType.ids, function (questionId, index) {
                                // 是否为未做试题
                                var isUnDoneQuestion = unDoQuestionIds.indexOf(questionId) != -1;
                                // 试题
                                var question = new Question(index + 1, questionId, _questionType);
                                question.isUnDone = isUnDoneQuestion;
                                _questionType.questions.push(question);
                                $scope.questions.push(question);
                                questionMap[questionId] = question;
                            });
                            $scope.questionTypes.push(_questionType);
                        });
                        // console.log("questionTypes:", $scope.questionTypes);
                        // 为试题建立链式关系，为后面处理上一题、下一题提供方便
                        if ($scope.questions.length > 1) {
                            var i = 0;
                            for (; i < $scope.questions.length; i++) {
                                // 如果为第一道题，则只有后一题
                                if (i === 0) {
                                    var nextQuestion = $scope.questions[i + 1];
                                    if (nextQuestion) {
                                        $scope.questions[i].next = nextQuestion;
                                    }
                                    continue;
                                }
                                // 如果为最后一道题，则只有前一题
                                if (i === $scope.questions.length - 1) {
                                    var preQuestion = $scope.questions[i - 1];
                                    if (preQuestion) {
                                        $scope.questions[i].prev = preQuestion;
                                    }
                                    continue;
                                }
                                // 否则该题必定有上一题、下一题
                                $scope.questions[i].prev = $scope.questions[i - 1];
                                $scope.questions[i].next = $scope.questions[i + 1];
                            }
                        }
                        // 查询出第一道题
                        // 根据id查询出试卷信息
                        queryQuestionDetail($scope.questions[0].id);
                        dynamicSetModalHeight();

                    } else {
                        popup.alert('提示', data.message, '关闭');
                    }
                }
            );
        };


        $scope.setWindowSize = function () {
            if ($scope.windowStatus == 1) {
                $scope.heightInfo.mainQuestionHeight = $scope.headAndFootHeight * 0.1;
                $scope.heightInfo.subQuestionHeight = $scope.headAndFootHeight * 0.9;
            } else if ($scope.windowStatus == 2) {
                $scope.heightInfo.mainQuestionHeight = ($scope.headAndFootHeight / 2);
                $scope.heightInfo.subQuestionHeight = $scope.heightInfo.mainQuestionHeight;
            } else {
                $scope.heightInfo.mainQuestionHeight = $scope.headAndFootHeight * 0.9;
                $scope.heightInfo.subQuestionHeight = $scope.headAndFootHeight * 0.1;
            }
        }

        $scope.changeWindowSize = function (direction) {
            if (direction == 'up') {
                $scope.windowStatus = $scope.windowStatus - 1;
            } else {
                $scope.windowStatus = $scope.windowStatus + 1;
            }
            $scope.setWindowSize();
        }


        var ionHeaderBarHeight = 44;
        var ionFooterBarHeight = 50;

        /**
         * 通过答题卡的题目数量动态计算模态框高度
         */
        function dynamicSetModalHeight() {
            // var viewWidth = $element.width();
            // var viewHeight = $element.height();
            var dom = document.getElementById("examPaper");
            var viewWidth = dom.offsetWidth;
            var viewHeight = dom.offsetHeight;
            var ionContentHeight = 0;
            angular.forEach($scope.questionTypes, function (questionType) {
                // 每行能展示的题目数量
                var questionNumInRow = Math.floor((viewWidth - 30) / 48);
                // console.log("每行能展示的题目数量:", questionNumInRow);
                // 每种题型能展示几行
                var rowNum = Math.ceil(questionType.questions.length / questionNumInRow);
                // console.log("能展示几行题:", rowNum);
                ionContentHeight += (rowNum * 40 + 48);
                // console.log("展示每种题型需要的高度:", rowNum * 40 + 48);
            });
            var modalHeight = ionHeaderBarHeight + ionContentHeight + ionFooterBarHeight + 27;
            // 模态框高度占整个视图高度的占比
            var modalHeightRatio = ((modalHeight) / viewHeight) * 100;
            // 如果占比超过80%，则只显示模态框80%高度
            if (modalHeightRatio >= 80) {
                $scope.modalHeight = '80%';
            }
            // 如果小于80%高度占比，则以占比高度显示模态框
            else {
                $scope.modalHeight = ((modalHeight) / viewHeight) * 100 + "%";
            }
        }


        function init() {
            onLineExamService.showGuide(function (data) {
                if (data.status === 0) {
                    vm.isShowGuide = data.result;
                    // 如果不显示答题操作提示
                    if (!vm.isShowGuide) {
                        $scope.getAllQuestype();
                    }

                }
            });
        }

        init();

        // 当前页面试题id
        $scope.currentQuestionId = "";

        function QuestionType(id, name, score, sequence) {
            this.id = id;
            this.name = name;
            this.score = score;
            this.sequence = sequence;
            // 题型下的试题集
            this.questions = [];
        }

        // 所有题型
        $scope.questionTypes = [];
        // 所有试题
        $scope.questions = [];
        // 所有试题map key: 试题ID，value: 试题信息对象
        var questionMap = {};


        $scope.currentQuestion = null;
        $scope.currentQuestios = [];

        /**
         * 答题卡-切换试题
         */
        $scope.switchQuestion = function (id) {
            // 关闭答题卡模态框
            $scope.answerCardModal.hide();
            // 如果当前页面试题ID 与 答题卡所点击的试题ID相同，则不做任何处理
            if ($scope.currentQuestionId == id) {
                return;
            }
            // 保存当前题的答案
            saveAnswerAndLoadQuestion(id);
        };
        /**
         * 答题卡-切换子试题
         */
        $scope.switchSubQuestion = function (childQuestionId) {
            // 关闭答题卡模态框
            angular.forEach($scope.currentQuestion.childrens, function (childQuestion, index) {
                if (childQuestion.id === childQuestionId) {
                    $scope.childQuestionIndex = index + 1;
                }
            });
            $scope.subQuestionCardModal.hide();
            $ionicScrollDelegate.scrollTop();
        };

        // 倒计时弹框
        var countDownPopup;

        /**
         * 处理考试提示展示
         */
        function dealExamTips() {
            // 如果从未进入过该考试
            if ($location.search().onlineStatus == 0) {
                /**
                 * 开始答题按钮倒计时器
                 */
                var buttonCountdownTimer = $interval(function () {
                    vm.buttonCountdownTime--;
                    if (vm.buttonCountdownTime === 0) {
                        $interval.cancel(buttonCountdownTimer);
                    }
                }, 1000);

                countDownPopup = $ionicPopup.alert({
                    title: '考试说明',
                    scope: $scope,
                    templateUrl: 'countDownPopup.html',
                    buttons: []
                });
            }
            // 开启倒计时计时器
            startExamCountdownTimer();
        }

        /**
         * 保存当前题的答案和加载指定试题详情
         * @param id
         */
        function saveAnswerAndLoadQuestion(targetQuestionId) {
            // 保存当前题的答案
            onLineExamService.saveQuestionAnswerAndGetQuestion(
                parseParamForSpringMVC(getAnswerResult()),
                targetQuestionId,
                function (data) {
                    if (data.status == 0) {
                        // 2:作弊强制交卷
                        if (data.result.paperStatus === 2) {
                            dealCheatTips();
                        } else if (data.result.paperStatus === 3) {
                            //3:管理员强制交卷
                            dealForceHandPaperTips();
                        } else {
                            dealCurrentQuestion(data);
                        }
                    }
                }
            );
        }

        /**
         * 处理作弊提示
         */
        function dealCheatTips() {
            popup.alert(
                '提示',
                "本场考试你已被监考老师<span class='text-danger'>设置为作弊，并强制交卷！</span>",
                '关闭'
            ).then(function (rs) {
                goBack();
            });
        }

        /**
         * 处理强制交卷提示
         */
        function dealForceHandPaperTips() {
            popup.alert(
                '提示',
                "本场考试你已被监考老师<span class='text-danger'>强制交卷！</span>",
                '关闭'
            ).then(function (rs) {
                goBack();
            });
        }

        /**
         * 获取答案结果
         */
        function getAnswerResult() {
            var result = null;
            // 如果当前试题为组合题（有子题）
            if ($scope.currentQuestion.childrens && $scope.currentQuestion.childrens.length > 0) {
                storageService.setItem("exam:" + $scope.currentQuestion.id, {
                    windowStatus: $scope.windowStatus,
                    childQuestionIndex: $scope.childQuestionIndex
                });
                result = {
                    testPaperQuestionCopyId: $scope.currentQuestion.id,
                    examStuId: $location.search().examStuId,
                    examHomeWorkId: $location.search().examInfoId,
                    type: 0,
                    children: []
                };
                angular.forEach($scope.currentQuestion.childrens, function (childQuestion) {
                    result.children.push(dealResultDetail(childQuestion, $scope.currentQuestion.id));
                });
            }
            // 如果不为为组合题（无子题）
            else {
                result = dealResultDetail($scope.currentQuestion);
            }
            return result;
        }

        /**
         * 处理答案详情信息
         * @param question 试题
         * @param parentId 父题ID
         */
        function dealResultDetail(question, parentId) {
            var result = {
                testPaperQuestionCopyId: question.id,
                answer: null,
                examStuId: $location.search().examStuId,
                attachmentVoList: [],
                examHomeWorkId: $location.search().examInfoId,
                type: 0,
                questionTypeId: question.type,
                parentId: parentId
            };
            // 如果为简答题
            if (vm.shortAnswerQuestion(question)) {
                result.answer = question.shortAnswerQuestionAnswer.textAreaAnswer;
                result.attachmentVoList = question.shortAnswerQuestionAnswer.attachmentVoList;
            } else {
                result.answer = question.answer;
            }
            return result;
        }

        /**
         * 查询试题详情
         * @param targetQuestionId 指定试题ID
         */
        function queryQuestionDetail(targetQuestionId) {
            var param = {
                id: targetQuestionId,
                examStuId: $location.search().examStuId,
                examInfoId: $location.search().examInfoId,
                type: 0
            };
            onLineExamService.queryQuestionDetail(param, function (data) {
                dealCurrentQuestion(data);
            });
        }

        /**
         * 处理当前试题信息
         * @param data
         */
        function dealCurrentQuestion(data) {
            if (data.status == 0) {
                $scope.currentQuestions = [];
                var _question = data.result;
                $scope.currentQuestion = questionMap[_question.id];
                setQuestionField($scope.currentQuestion, _question);
                // console.log($scope.currentQuestion);
                $scope.currentQuestions.push($scope.currentQuestion);
                // 如果为组合题，则有子题
                if (_question.children && _question.children.length > 0) {
                    $scope.currentQuestion.childrens = [];
                    angular.forEach(_question.children, function (childQuestion, index) {
                        // 试题
                        var question = new Question(index + 1, childQuestion.id, null);
                        setQuestionField(question, childQuestion, $scope.currentQuestion);
                        // 放入缓存
                        questionMap[question.id] = question;
                        if (hasAnswer(question)) {
                            question.isUnDone = false;
                        } else {
                            question.isUnDone = true;
                        }
                        $scope.currentQuestion.childrens.push(question);
                    });

                    $scope.initWindowSize($scope.currentQuestion.id);
                }
                $ionicScrollDelegate.scrollTop();
            } else {
                popup.alert('提示', data.message, '关闭');
            }
        }

        function setQuestionField(targetQuestion, srcQuestion, parent) {
            targetQuestion.title = dealQuestionTitle(srcQuestion.title);
            targetQuestion.answerNumer = srcQuestion.optionNumber;
            targetQuestion.type = srcQuestion.testPaperTypeCopyId;
            targetQuestion.attachVoList = srcQuestion.attachVoList;
            targetQuestion.answerState = srcQuestion.answerState;
            targetQuestion.parent = parent;
            // 如果是简答题，需要特殊处理简单题的答案
            if (vm.shortAnswerQuestion(targetQuestion)) {
                // 文本域中的答案
                targetQuestion.shortAnswerQuestionAnswer.textAreaAnswer = srcQuestion.reson;
                // 学生提交的附件答案
                targetQuestion.shortAnswerQuestionAnswer.attachmentVoList = srcQuestion.ansAttList;
            } else {
                targetQuestion.answer = srcQuestion.reson;
            }
        }

        /**
         * 处理试题标题
         * @param title
         * @returns {*}
         */
        function dealQuestionTitle(title) {
            var replaceStr = window.location.protocol + "//" + window.location.host;
            if (window.location.port) {
                replaceStr = replaceStr + ":" + window.location.port;
            }
            if (title.indexOf(replaceStr) > -1) {
                title = title.replace(new RegExp(replaceStr, 'g'), "");
            }
            return title.replace(new RegExp('\\/fs\\/preview\\/preview.htm\\?', 'g'), originBaseUrl.replace("/ynedut", "") + '/fs/preview/preview.htm?');
            // return title
            //     .replace(/<\/?[^>]*>/g, '') //去除HTML tag
            //     .replace(/[ | ]*\n/g, '\n') //去除行尾空白
            //     .replace(/&nbsp;/ig, ''); //去掉&nbsp;
        }

        function parseParamForSpringMVC(obj) {
            //最终组合成功的对象
            var resultObj = {};
            //递归方法，用于深度转换每一个参数
            //key 对象时，是属性名
            //value 属性值
            //prefix（关键），和key进行组合相组合成想要的格式类型如name.age（对象）或name[0].age（数组）
            var deepParseParams = function (key, value, prefix) {
                //先判断是否是数组
                if (value instanceof Array) {
                    for (var i in value) {
                        deepParseParams("", value[i], prefix + key + "[" + i + "]");
                    }
                }
                //再判断是否是对象
                else if (value instanceof Object) {
                    for (var i in value) {
                        deepParseParams("." + i, value[i], prefix + key);
                    }
                }
                //如果不是数组或对象，到了此次递归的最后一次，将完成组合的这条最终数据放在最终组合对象中
                else {
                    resultObj[prefix + key] = value;
                }

            };
            //因为传入的转换参数必须是对象,而且第一次传入和第二次开始组合“.”号是很特殊的地方，所有
            //第一次单独循环
            for (var i in obj) {
                deepParseParams("", obj[i], i);
            }

            //返回转换成功的对象集合
            return resultObj;
        }

        /**
         * 统计未作答的试题数量
         * @returns {number}
         */
        function countUnDoneQuestionNumber() {
            return $scope.questions.filter(function (question) {
                return question.isUnDone;
            }).length;
        }


        $scope.previewPhoto = function (photo) {
            if ($scope.loading) {
                return;
            }
            $scope.loading = $ionicLoading.show({
                template: '正在载入中...'
            });
            var cordovaFileOpen = cordova.plugins.disusered.open;
            $scope.attachmentUrl = cordovaFileOpen(originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + photo, cordovaFileOpenSuccess, cordovaFileOpenError);

            function cordovaFileOpenSuccess() {
                // 从已安装程序中打开文件完成
                $ionicLoading.hide();
                $scope.loading = "";
            }

            function cordovaFileOpenError(code) {
                if (code === 1) {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '未能在手机已安装APP中找到可预览此文件的程序'
                    });
                } else {
                    $ionicPopup.alert({
                        title: '文件预览提示',
                        template: '预览时发生了未知错误 #' + code
                    });
                }
                $ionicLoading.hide();
                $scope.loading = "";
            }
        };

        /**
         * 上一步
         */
        ynNavigator.registerBackAction(function () {
            var confirmPopup = $ionicPopup.confirm({
                title: "提示",
                template: '您确定要退出考试答题页面吗？退出后可能无法再次进入考试 。',
                cancelText: "取消",
                okText: "确定"
            });
            confirmPopup.then(function (res) {
                if (res) {
                    //强制返回上一级
                    ynNavigator.pop(true);
                }
            });
        },101);
    }

    function to_trustedExamination($sce) {
        return function (text) {
            return $sce.trustAsHtml(text);
        }
    }

    function Question(sequence, id, questionType) {
        // 题号
        this.sequence = sequence;
        this.id = id;
        // 试题所属题型
        this.questionType = questionType;
        // 父试题
        this.parent = null;
        // 试题title
        this.title = null;
        // 试题类型
        this.type = null;
        // 是否未做该试题
        this.isUnDone = false;
        // 上一题
        this.prev = null;
        // 下一题
        this.next = null;
        // 试题答案(非简答题类型试题的答案)
        this.answer = null;
        // 简答题答案，仅仅当试题类型为简答题时，用于处理简答题的答案信息（包括文本域的内容和附件内容）
        this.shortAnswerQuestionAnswer = {
            textAreaAnswer: null,
            attachmentVoList: []
        };
        // 试题需要作答的答案数量
        this.answerNumer = null;
        // 学生答案要求状态 0 在线作答+附件 1在线作答
        this.answerState = 1;
        // 试题附件
        this.attachVoList = [];
        /**
         * 子题
         * @type {*[]}
         */
        this.childrens = [];
    }

    retestStudentController.$inject = ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification', '$ionicScrollDelegate', "$timeout"];

    //考试任务-考试安排
    function retestStudentController($scope, $ionicModal, $http, $location, ynuiNotification, $ionicScrollDelegate, $timeout) {
        var basePath = originBaseUrl + "/third/CJRetestController";

        //选计划
        // $scope.selectPlanFun = selectPlanFun;
        //选中天
        $scope.selectedDayFun = selectedDayFun;
        $scope.selectTermInfo = selectTermInfo;
        //微讲师进入验证
        $scope.enterExamFun = enterExam;

        $scope.searchData = {};
        $scope.selectedPlan = {};
        $scope.selectedDay = 1;
        $scope.message = '';
        //作弊次数
        $scope.cheatNum = 0;
        //缺考
        $scope.absentNum = 0;

        function selectTermInfo() {
            //查询考试计划
            $http.post(originBaseUrl + "/third/kwglTeacherInvigilate/findPlanTerm.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.termPlan = data.result.currentTerm;
                    if($scope.termPlan && $scope.termPlan.name){
                        $scope.termPlan.name = $scope.termPlan.name.replace("(当前学期)","");
                    }
                    findStudentList();
                    $scope.searchData.termId = $scope.termPlan.id;
                }
            });
        }

        selectTermInfo();

        //微讲师跳转
        function enterExam(stu) {
            //微讲师进行跳转
            if(stu.examType==4&&stu.examStatus==1){
                // 学生进入考试校验
                $http.get(basePath + "/enterCheck.htm?examTaskId="+stu.examInfoId+"&clientType=app").then(function success(info){
                    if(info.data.status == 1){
                        // 跳转人脸照片采集
                        yn.plugin.yncordova.nativeStart({
                            target: '105',
                            params:{url:'/wjs/app/#/redirect?wjs_page_code=wjs_exam_answer_index&taskId='+stu.examInfoId}
                        });
                    }else if(info.data.status == -1) {
                        ynuiNotification.error({msg: "学生进入微讲师失败！"});
                    }else {
                        ynuiNotification.error({msg:info.data.message});
                    }
                },function error(){
                    ynuiNotification.error({msg: "学生进入微讲师失败！"});
                });
            }
        }
        // //选中计划
        // function selectPlanFun(plan) {
        //     if (plan.id != $scope.searchData.planId) {
        //         $scope.searchData.planId = plan.id;
        //         $scope.searchData.type = plan.planType;
        //         $scope.selectedPlan = plan;
        //         findStudentList();
        //     }
        // }
        /**
         * 获取系统时间
         */
        function findCurrentTime() {
            $http.get(originBaseUrl + "/third/kwglTeacherInvigilate/findCurrentTimeAndUser.htm?patterns=yyyy-MM-dd HH:mm&loading=disabled&date=" + new Date())
                .success(function (data) {
                    var forDate = new Date(data.result.currentTime.replace(/-/g, "/"));
                    $scope.serverTime= moment(data.result.currentTime).format('YYYY-MM-DD');
                    $scope.serverTime += " " + weekday[forDate.getDay()];
                });
        }

        findCurrentTime();
        //查找数据
        var weekday = ["星期日", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六"];

        function findStudentList() {
            $scope.message = '';
            $scope.student = [];
            $scope.studentList = [];
            $scope.selectedDay = 1;
            $http.post(basePath + "/findMyExamArrange.htm", $scope.searchData).success(function (data) {
                if (data.status == 0) {
                    $scope.student = data.result;
                    if (!$scope.student['all'] || $scope.student['all'].length == 0) {
                        $scope.message = "近期没有需要参加的考试！";
                        return;
                    }
                    if ($scope.student['tomorrow'].length > 0) {
                        $scope.selectedDay = 3;
                    }
                    if ($scope.student['today'].length > 0) {
                        $scope.selectedDay = 2;
                    }
                    var map = new Map();
                    $scope.student['all'].forEach(function (item) {
                        var forDate = new Date(item.starTime.replace(/-/g, "/"));
                        var key=moment(item.starTime).format('YYYY-MM-DD');
                        key += " " + weekday[forDate.getDay()];
                        var taskList = map.get(key);
                        if (!taskList) {
                            taskList = [];
                            map.put(key, taskList);
                        }
                        taskList.push(item);
                    });
                    $scope.taskMapList = [];
                    $scope.taskMap = map;
                    angular.forEach(map.keySet(), function (key) {
                        $scope.taskMapList.push({
                            id: key,
                            isCurrent: key == $scope.serverTime,
                            total: map.get(key).length,
                            isChecked: false
                        });
                    })
                    $scope.taskMapList.sort(function (a1, a2) {
                        return a2.id.localeCompare(a1.id);
                    })
                    selectedDayFun($scope.selectedDay);
                }
            });
        }

        $scope.searchDay = function (info) {
            info.isChecked = !info.isChecked;
            $timeout(function () {
                $scope.studentList = [];
                angular.forEach($scope.taskMapList, function (item) {
                    if (item.isChecked) {
                        angular.forEach($scope.taskMap.get(item.id), function (task) {
                            $scope.studentList.push(task);
                        })
                    }
                })
                $scope.studentList.sort(function (s1, s2) {
                    return s1.starTime.localeCompare(s2.starTime);
                })
                cheatOrAbsentNum();
                console.log($scope.studentList);
            }, 50);
        }

        function selectedDayFun(day) {
            $scope.selectedDay = day;
            if (day == 1) {
                $scope.studentList = $scope.student['all'];
            }
            if (day == 2) {
                $scope.studentList = $scope.student['today'];
            }
            if (day == 3) {
                $scope.studentList = $scope.student['tomorrow'];
            }
            cheatOrAbsentNum();
            $ionicScrollDelegate.$getByHandle('listScroll').scrollTo(0, 1, true);

        }

        function cheatOrAbsentNum() {
            //作弊次数
            $scope.cheatNum = 0;
            //缺考
            $scope.absentNum = 0;
            angular.forEach($scope.studentList, function (data) {
                if (data.type == 0) {
                    $scope.absentNum++;
                }
                if (data.type == 1) {
                    $scope.cheatNum++;
                }
            });
        }

        /**
         * 返回
         */
        $scope.goBack = function () {
            yn.plugin.yncordova.close();
        }
    }

    retestApplyController.$inject = ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification', '$ionicPopover'];
    // 考试任务-申请补考
    function retestApplyController ($scope, $ionicModal, $http, $location, ynuiNotification, $ionicPopover) {
        var basePath = originBaseUrl + "/third/CJRetestController";

        //选计划
        $scope.selectPlanFun = selectPlanFun;
        //申请补考
        $scope.applyFun = applyFun;
        //取消不参加弹框
        $scope.cancelNotAttend = cancelNotAttend;
        //提交不参加补考
        $scope.applyIsAttend = applyIsAttend;

        $scope.searchData={};
        $scope.selectedPlan={};
        $scope.selectedData={};
        $scope.message='';
        $scope.message1='';
        //作弊次数
        $scope.cheatNum=0;
        //缺考
        $scope.absentNum=0;


        $http.post(basePath + "/queryDictionarys.htm",{"key":"ATTEND_STATUS","status":true}).success(function (data) {
            if (data.status == 0) {
                $scope.allReasonList = data.result.reverse();
            }
        });

        //获取学期计划
        $http.get(basePath + "/findCjRetestPlanList.htm").success(function (data) {
            if (data.status == 0) {
                $scope.planList = data.result.cjRetestPlanVOList?data.result.cjRetestPlanVOList:[];
                if($scope.planList.length==0){
                    $scope.message="未安排补考计划！";
                    return;
                }
                $scope.searchData.planId = data.result.planId;
                selectPlan();
            }

        });

        function selectPlan() {
            $scope.message1="";
            for (var i = 0; i < $scope.planList.length; i++) {
                var data1 = $scope.planList[i];
                if (data1.id == $scope.searchData.planId) {
                    $scope.selectedPlan = data1;
                    hasPreExamApplyFun();
                }
            }
        }

        function selectPlanFun(plan) {
            $scope.message1="";
            $scope.selectedPlan = plan;
            $scope.searchData.planId = plan.id;
            $scope.applyStudent ={};
            hasPreExamApplyFun();
        }

        //查找补考信息
        function searchMyRetest() {
            $scope.applyStudent =[];
            $http.post(basePath + "/findMyRetestData.htm",$scope.searchData).success(function (data) {
                if (data.status == 0) {
                    $scope.applyStudent =data.result;
                    if(!$scope.applyStudent||$scope.applyStudent.length==0){
                        $scope.message1 ="您没有被安排补考！";
                    }
                }
            });
        }

        function applyFun(type) {
            $scope.conditions={};
            //参加补考
            if(type==1){
                $scope.conditions ={ids:[$scope.selectedData.id],status:type};
                applyIsAttend();
                return;
            }
            //不参加补考
            if(type==0){
                $scope.conditions ={ids:[$scope.selectedData.id],status:type};
                testMyRetest();
                return;
            }
            //撤销
            $scope.conditions ={id:$scope.selectedData.applyId};
            cancelApply();
            cancelApplyModal();
        }

        //验证
        function testMyRetest() {
            $http.post(basePath + "/testMyRetest.htm",$scope.conditions).success(function (data) {
                if(data&&data.length>0){
                    ynuiNotification.error({msg: data[0]});
                }else {
                    showNotAttend();
                    cancelApplyModal();
                }
            });
        }
        function applyIsAttend() {
            // 申请不参加
            if($scope.conditions.status==0
                &&($scope.conditions.cancelReasonType==undefined||($scope.conditions.cancelReasonType=="5"&&!$scope.conditions.reason))){

                ynuiNotification.error({msg: "不参加补考原因必填！"});
                return;
            }
            $http.post(basePath + "/applyMyRetest.htm",$scope.conditions).success(function (data) {
                if (data.status == 0) {
                    if(data.result&&data.result.length>0){
                        ynuiNotification.error({msg: data.result[0]});
                        return;
                    }
                    ynuiNotification.success({msg: "操作成功！"});
                }else {
                    ynuiNotification.error({msg: "操作失败！"});
                }
                cancelNotAttend();
                cancelApplyModal();
                searchMyRetest();
            });
        }

        function cancelApply() {
            $http.post(basePath + "/cancelApply.htm",$scope.conditions).success(function (data) {
                if (data.status == 0) {
                    ynuiNotification.success({msg: "操作成功！"});
                }else {
                    ynuiNotification.error({msg: "操作失败！"});
                }
                searchMyRetest();
            });
        }

        //系部是否到申请时间
        function hasPreExamApplyFun() {
            $http.post(basePath + "/hasPreExamApplyByUser.htm", {planId: $scope.searchData.planId}).success( function (data) {
                if(data){
                    $scope.message1= data;
                }else {
                    searchMyRetest();
                }
            });
        }

        /*申请模态*/
        $ionicModal.fromTemplateUrl('applyBkBtn.html',{
            scope:$scope,
            animation:'slide-in-up'
        }).then(function(modal){
            $scope.modal1 = modal;
        });
        $scope.applyBkBtnClick = function(student) {
            $scope.selectedData = student;
            $scope.modal1.show();
        };
        function cancelApplyModal() {
            $scope.modal1.hide();
        }
        //不参加弹框
        $ionicModal.fromTemplateUrl('notAttendExam.html',{
            scope:$scope,
            animation:'slide-in-up',
            backdropClickToClose:false
        }).then(function(modal){
            $scope.modal2 = modal;
        });
        function showNotAttend() {
            $scope.modal2.show();
        }
        function cancelNotAttend() {
            $scope.modal2.hide();
        }
    }

    function onLineExamService ($rootScope, ynHttp, popup) {
        return {
            /**
             * 是否不再提示答题提示
             * @param examInfoId 考试任务ID
             * @returns {string|boolean}
             */
            showGuide: function (successCallback) {
                ynHttp.postWithCallBack("/third/onlineExam/showExamAnswerOperateTipsAgain.htm", {examStuId: $rootScope.authorizationStr.userId}, successCallback)
            },
            /**
             * 不再提示答题提示
             * @returns {string|boolean}
             */
            hideGuide: function () {
                ynHttp.postWithCallBack("/third/onlineExam/dotShowExamAnswerOperateTipsAgain.htm", {examStuId: $rootScope.authorizationStr.userId})
            },
            /**
             * 保存试题答案并且交卷
             * @param param
             * @param successCallback
             * @returns {string|boolean}
             */
            saveQuestionAnswerAndHandExamPaper: function (param, successCallback) {
                ynHttp.postWithCallBack("/third/onlineExam/saveQuestionAnswerAndHandExamPaper.htm", param, successCallback)
            },
            /**
             * 保存试题答案
             * @param param
             * @param successCallback
             * @returns {string|boolean}
             */
            saveQuestionAnswer: function (param, successCallback) {
                ynHttp.postWithCallBack("/third/onlineExam/saveQuestionAnswer.htm", param, successCallback)
            },
            /**
             * 获取试卷的所有题型信息
             */
            entryAndGetStuExamPaperQuestionInfo: function (param, successCallback) {
                ynHttp.postWithCallBack("/third/onlineExam/stuExamPaperQuestionInfo.htm", param, successCallback)
            },
            /**
             * 获取试题详情信息
             * @param param
             * @param successCallback
             */
            queryQuestionDetail: function (param, successCallback) {
                ynHttp.postWithCallBack("/third/onlineExam/questionDetail.htm", param, successCallback)
            },
            /**
             * 保存试题答案并且返回指定试题内容信息
             * @param param
             * @param successCallback
             */
            saveQuestionAnswerAndGetQuestion: function (param, targetTestPaperQuestionCopyId, successCallback) {
                ynHttp.postWithCallBack("/third/onlineExam/saveQuestionAnswerAndGetQuestion.htm?targetTestPaperQuestionCopyId=" + targetTestPaperQuestionCopyId, param, successCallback)
            },
            /**
             * 切换到当前试题的上一题或下一题
             * @param question | Question 试题对象
             * @param type     "prev" 上一题 "next" 下一题*
             */
            switchToPrevOrNextQuestion: function (question, type, callbackFun) {
                var prevOrNextQuestion = question[type];
                if (prevOrNextQuestion) {
                    if (angular.isFunction(callbackFun)) {
                        callbackFun(prevOrNextQuestion);
                    }
                } else {
                    if (type == "prev") {
                        popup.alert('提示', '已经是第一题', '关闭');
                    }
                    if (type == "next") {
                        popup.alert('提示', '已经是最后一题!', '关闭');
                    }
                }
            }
        };
    }
    /**
     * 判断题答案
     */
    function judgmentQuestionAnser () {
        var RIGHT_ANSWER = "正确", WRONG_ANSWER = "错误";
        return {
            restrict: "AE",
            replace: true,
            scope: {},
            require: "?ngModel",
            // 设置模板路径
            templateUrl: function (tElement, tAttrs) {
                return "templates/course_assignment/judgmentQuestion.html";
            },
            link: function (scope, element, attrs, ctrl) {
                if (!ctrl) {
                    return; // do nothing if no ng-model
                }
                var vm = scope.vm = {
                    /**
                     * 答案： true 正确， false 错误
                     */
                    answer: null,
                    /**
                     * 选择答案
                     * @param answer | Boolean 答案： true 正确， false 错误
                     */
                    selectAnswer: function (answer) {
                        this.answer = answer;
                        setModelVal();
                    }
                };

                ctrl.$render = function () {
                    render();
                };

                // view->model
                function setModelVal() {
                    ctrl.$setViewValue(vm.answer ? RIGHT_ANSWER : WRONG_ANSWER);
                }

                /**
                 * 指令自定渲染，处理model数据改变时，选中数据项
                 */
                function render() {
                    if (ctrl.$viewValue) {
                        if (ctrl.$viewValue == RIGHT_ANSWER) {
                            vm.answer = true;
                        }
                        if (ctrl.$viewValue == WRONG_ANSWER) {
                            vm.answer = false;
                        }
                    } else {
                        vm.answer = null;
                    }
                }
            }
        };
    }
    /**
     * 选择题答案
     */
    function choiceQuestionAnswer () {
        // 选择题答案
        var CHOICE_QUESTION_ANSWERS = ["A", "B", "C", "D", "E", "F", "G", "H", "I"];
        return {
            restrict: "AE",
            replace: true,
            scope: {
                /**
                 * 答案个数
                 */
                answerNumber: "@",
                /**
                 * 选择题题型： 1 单选题， 2 多选题
                 */
                questionType: "@"
            },
            require: "?ngModel",
            // 设置模板路径
            templateUrl: function (tElement, tAttrs) {
                return "templates/course_assignment/choiceQuestionAnswer.html";
            },
            link: function (scope, element, attrs, ctrl) {
                if (!ctrl) {
                    return; // do nothing if no ng-model
                }
                var vm = scope.vm = {
                    /**
                     * 选择题题型： 1 单选题， 2 多选题
                     */
                    questionType: scope.questionType,
                    // 是否为单选题
                    isSingleChoiceQuestion: scope.questionType == 1,
                    /**
                     * 答案
                     */
                    answers: [],

                    /**
                     * 选择答案
                     * @param answer | Boolean 答案： true 正确， false 错误
                     */
                    selectAnswer: function (answer) {
                        if (this.isSingleChoiceQuestion) {
                            angular.forEach(this.answers, function (_answer) {
                                if (_answer == answer) {
                                    _answer.selected = !answer.selected;
                                } else {
                                    _answer.selected = false;
                                }
                            })
                        } else {
                            answer.selected = !answer.selected;
                        }
                        setModelVal();
                    }
                };


                ctrl.$render = function () {
                    render();
                };

                // view->model
                function setModelVal() {
                    var selectedAnswers = [];
                    angular.forEach(vm.answers, function (answer) {
                        if (answer.selected) {
                            selectedAnswers.push(answer.name);
                        }
                    });

                    if (selectedAnswers.length > 0) {
                        ctrl.$setViewValue(selectedAnswers.join(","));
                    } else {
                        ctrl.$setViewValue(null);
                    }
                }

                /**
                 * 指令自定渲染，处理model数据改变时，选中数据项
                 */
                function render() {
                    if (ctrl.$viewValue) {
                        angular.forEach(vm.answers, function (answer) {
                            if (ctrl.$viewValue.indexOf(answer.name) != -1) {
                                answer.selected = true;
                            }
                        });
                    } else {
                        vm.answer = null;
                    }
                }

                init();

                function init() {
                    var i = 0;
                    for (; i < scope.answerNumber; i++) {
                        var answerName = CHOICE_QUESTION_ANSWERS[i];
                        vm.answers.push({name: answerName, selectd: false});
                    }
                }
            }
        };
    }
    /**
     * 填空题答案
     */
    function fillInBlanksAnswer() {
        var ANSWER_SEPARATOR = "◆";
        return {
            restrict: "AE",
            replace: true,
            scope: {
                /**
                 * 答案个数
                 */
                answerNumber: "@",
                /**
                 * 试题ID
                 */
                questionId: "@",
                /**
                 * 小题保存答案时触发父容器的回调
                 */
                saveQuestionAnswer: "&",
                /***
                 * 窗口变动大小
                 */
                upOrDownWindow: "&"
            },
            require: "?ngModel",
            // 设置模板路径
            templateUrl: function (tElement, tAttrs) {
                return "templates/course_assignment/fillInBlanksAnswer.html";
            },
            link: function (scope, element, attrs, ctrl) {
                if (!ctrl) {
                    return; // do nothing if no ng-model
                }
                var vm = scope.vm = {
                    /**
                     * 填空题的答题空白框
                     */
                    blanks: [],
                    /**
                     * 改变答案
                     */
                    changeAnswer: function () {
                        setModelVal();
                    },
                    /**
                     * 保存答案
                     */
                    saveAnswer: function () {
                        scope.saveQuestionAnswer({questionId: scope.questionId});
                    },
                    /**调整窗口大小**/
                    upOrDownWindow: function (direction) {
                        scope.upOrDownWindow(direction);
                    }
                };


                ctrl.$render = function () {
                    render();
                };

                // view->model
                function setModelVal() {
                    var answers = [];
                    angular.forEach(vm.blanks, function (blank, index) {
                        answers.push(blank.answer);
                    });
                    ctrl.$setViewValue(answers.join(ANSWER_SEPARATOR));
                }

                /**
                 * 指令自定义渲染，处理model数据改变时，选中数据项
                 */
                function render() {
                    if (ctrl.$viewValue) {
                        var answers = ctrl.$viewValue.split(ANSWER_SEPARATOR);
                        var answerMap = {};
                        angular.forEach(answers, function (answer, index) {
                            answerMap[index] = answer;
                        });
                        // console.log("answers:", answers);
                        angular.forEach(vm.blanks, function (blank, index) {
                            // 如果有已填写的答案
                            var answer = answerMap[index];
                            if (answer) {
                                blank.answer = answer;
                            }
                        });
                    }
                }

                init();

                function init() {
                    var i = 0;
                    for (; i < scope.answerNumber; i++) {
                        vm.blanks.push({answer: null});
                    }
                }
            }
        };
    }
    /**
     * 简答题答案
     */
    function shortAnswerQuestionAnswer() {
        return {
            restrict: "AE",
            replace: true,
            scope: {
                /**
                 * 学生答案要求状态 0 在线作答+附件 1在线作答
                 */
                answerState: "@",
                /**
                 * 试题ID
                 */
                questionId: "@",
                /**
                 * 小题保存答案时触发父容器的回调
                 */
                saveQuestionAnswer: "&",
                /***
                 * 窗口变动大小
                 */
                upOrDownWindow: "&"
            },
            require: "?ngModel",
            // 设置模板路径
            templateUrl: function (tElement, tAttrs) {
                return "templates/course_assignment/shortAnswerQuestionAnswer.html";
            },
            link: function (scope, element, attrs, ctrl) {
                if (!ctrl) {
                    return; // do nothing if no ng-model
                }
                var vm = scope.vm = {
                    isNeedAttach: scope.answerState == 0,
                    attachmentIds: [],
                    /**
                     * 文本域答案
                     */
                    textAreaAnswer: null,
                    /**
                     * 附件答案
                     */
                    attachmentVoList: [],
                    /**
                     * 改变答案
                     */
                    changeAnswer: function () {
                        setModelVal();
                    },
                    /**
                     * 保存答案
                     */
                    saveAnswer: function () {
                        scope.saveQuestionAnswer({questionId: scope.questionId});
                    },
                    /**
                     * 处理附件上传完毕修改外部变量数据
                     * @param photos
                     */
                    changeCallback: function (photos) {
                        var that = this;
                        that.attachmentVoList = [];
                        if (photos) {
                            angular.forEach(photos, function (photo) {
                                that.attachmentVoList.push({fsAttachId: photo.fsId, name: photo.name});
                            })
                        }
                        setModelVal();
                    },
                    /**调整窗口大小**/
                    upOrDownWindow: function (direction) {
                        scope.upOrDownWindow(direction);
                    }
                };

                ctrl.$render = function () {
                    render();
                };

                // view->model
                function setModelVal() {
                    var shortAnswerQuestionAnswer = {
                        textAreaAnswer: vm.textAreaAnswer,
                        attachmentVoList: []
                    };
                    if (vm.attachmentVoList) {
                        shortAnswerQuestionAnswer.attachmentVoList = vm.attachmentVoList;
                    }
                    ctrl.$setViewValue(shortAnswerQuestionAnswer);
                }

                /**
                 * 指令自定义渲染，处理model数据改变时，选中数据项
                 */
                function render() {
                    if (ctrl.$viewValue) {
                        vm.textAreaAnswer = ctrl.$viewValue.textAreaAnswer;
                        vm.attachmentVoList = ctrl.$viewValue.attachmentVoList;
                        if (vm.attachmentVoList) {
                            angular.forEach(vm.attachmentVoList, function (attach) {
                                vm.attachmentIds.push(attach.fsAttachId);
                            });
                        }
                    }
                }
            }
        };
    }
})();
