(function () {
  'use strict';

  angular
    .module('starter')
    .factory('selectScheduleService', selectScheduleService);

  function selectScheduleService($ionicModal, $rootScope,$http,$ionicScrollDelegate,ynuiNotification,$filter) {

    var $scope = $rootScope.$new();

    var basePathTk = originBaseUrl + "/third/tkTaskRegisterApp";

    $scope.curentTerm ={};
    $scope.selectDateObj = {
      startDate:"",
      endDate:"",
      showStr:""
    };

    $scope.weekDayList = [];
    $scope.scheduleList = [];

    $scope.teacherOrCourseList = [];



    $scope.selectDateObjTemp ={
      startDate:"",
      endDate:""
    };

    function initSelectObj() {
      $scope.selectTocObj = {
        type:0,
        id:"",
        name:"请选择老师/课程查询"
      };
      $scope.scheduleList = [];
      $scope.weekDayList = [];
      initSchedule([],[],[]);
      $ionicScrollDelegate.$getByHandle('selectScheduleScroll').scrollTo(0);
    }

    initSelectObj();

    function select(callBack) {
      initSelectObj();
      init();
      showDialog();
      $scope.finishSelect = function () {
        if($scope.selectKnobArr.length < 1){
          ynuiNotification.error({msg: "请选择一节课！"});
          return;
        }else if($scope.selectKnobArr.length > 1){
          $scope.selectKnobArr = $filter('orderBy')($scope.selectKnobArr, 'knob');
          if(!checkKnob()){
            ynuiNotification.error({msg: "只能选择连堂课！"});
            return;
          }
        }

        var firstItem  = $scope.scheduleList[0];
        var amLength = firstItem.amArr.length;
        var pmLength = firstItem.pmArr.length;
        angular.forEach($scope.selectKnobArr,function (item) {
          if(item.timeType == 2){
            item.knobIndex = amLength+parseInt(item.knob);
          }else if(item.timeType == 3){
            item.knobIndex = amLength+pmLength+parseInt(item.knob);
          }else{
            item.knobIndex = item.knob;
          }
          item.knobIndex = item.knobIndex-1;
        });
        callBack($scope.selectKnobArr);
        hideDialog();
      };
    }

    function checkKnob() {
      for(var i=1;i<$scope.selectKnobArr.length;i++){
        var flag = compareKnob($scope.selectKnobArr[i-1],$scope.selectKnobArr[i]);
        if(!flag){
          return false;
        }
      }
      return true;
    }

    function compareKnobBase(one, two) {
      if(one.dateStr   != two.dateStr ||
        one.timeType != two.timeType ||
        one.courseId != two.courseId ||
        one.teacherNameStr != two.teacherNameStr ||
        one.teachClassId != two.teachClassId ||
        one.buildAndClassRoomNameStr != two.buildAndClassRoomNameStr ){
        return false;
      }else{
        return true;
      }
    }

    function compareKnob(one, two) {
      return compareKnobBase(one, two) && parseInt(one.knob) + 1 == two.knob;
    }

    function initSchedule(amKnobList,pmKnobList,ngKnobList) {
      var elme = angular.element;
      /*设置一天课表，节次高度*/
      var amKnob = amKnobList,
        pmKnob = pmKnobList,
        ngKnob = ngKnobList,
        wrapHeight = elme(".schedule-times-right").height(),
        itemNumber = amKnob + pmKnob + ngKnob,
        numberHeight = wrapHeight / itemNumber,
        weekWidth = 68 * $scope.weekDayList.length;
      $scope.itemHeight = {
        "height":numberHeight+'px',
        "line-height":numberHeight/2+'px'
      };
      $scope.amKnobHeight =  {
        "height":amKnob*(numberHeight)+'px',
        "width": weekWidth + 'px'
      };
      $scope.pmKnobHeight =  {
        "height":pmKnob*(numberHeight)+'px',
        "width": weekWidth + 'px'
      };
      $scope.ngKnobHeight =  {
        "height":ngKnob*(numberHeight)+'px',
        "width": weekWidth + 'px'
      };
    }

    //获取课表数据
    function findScheduleList() {

      var postData = {};
      postData.reqType = $scope.selectTocObj.type;
      postData.downOptionVals = $scope.selectTocObj.id;
      postData.dateType = 1;
      postData.sourseType = 1;
      postData.termId = $scope.curentTerm.id;
      postData.tkDate = $scope.selectDateObj.startDate;
      postData.tkEndDate  = $scope.selectDateObj.endDate;

      if(!postData.tkDate || !postData.tkEndDate || !postData.downOptionVals){
        return;
      }

      $http.post(basePathTk + "/findScheduleList.htm",postData).success(function(data){
        if(data.status == 0){

          $scope.scheduleList = data.result;
          $scope.weekDayList = [];
          var amLength = 0,pmLength = 0,ngLength = 0;

          angular.forEach($scope.scheduleList,function (item,index) {
            item.amArr = [];
            item.pmArr = [];
            item.ngArr = [];
            angular.forEach(item.resultKnobs,function (knob) {
              if(knob.knobStr.indexOf("1_") != -1){
                if(knob.schedules && knob.schedules.length > 0){
                  var sche = knob.schedules[0];
                  sche.selected = false;
                  item.amArr.push(sche);
                }else{
                  item.amArr.push({});
                }
              }else if(knob.knobStr.indexOf("2_") != -1){
                if(knob.schedules && knob.schedules.length > 0){
                  var sche = knob.schedules[0];
                  sche.selected = false;
                  item.pmArr.push(knob.schedules[0]);
                }else{
                  item.pmArr.push({});
                }
              }else if(knob.knobStr.indexOf("3_") != -1){
                if(knob.schedules && knob.schedules.length > 0){
                  var sche = knob.schedules[0];
                  sche.selected = false;
                  item.ngArr.push(knob.schedules[0]);
                }else{
                  item.ngArr.push({});
                }
              }
            });
            if(index == 0){
              amLength = item.amArr.length;
              pmLength = item.pmArr.length;
              ngLength = item.ngArr.length;
            }
            $scope.weekDayList.push(item.dayStr);
          });
          initSchedule(amLength,pmLength,ngLength);
        }
      });
    }

    function findTeacherOrCourseList(reqType) {
      $ionicScrollDelegate.$getByHandle('dashboard').scrollTop(false);
      var postData = {reqType:reqType,termId:$scope.curentTerm.id,tkDate:$scope.selectDateObj.startDate,tkEndDate:$scope.selectDateObj.endDate};
      $http.post(basePathTk + "/getDropDownOptionList.htm",postData).success(function(data){
        if(data.status == 0){
          $scope.teacherOrCourseList = data.result;
        }
      });
      $scope.selectTocObj.type = reqType;
    }

    function getCurentTerm() {
      $http.get(basePathTk + "/getCurrentTerm.htm").success(function(data){
        if(data.status == 0){
          $scope.curentTerm = data.result;
          findScheduleList();
        }
      })
    }


    function setSelectDate(startDate, endDate) {
      $scope.selectDateObj.startDate = startDate;
      $scope.selectDateObj.endDate = endDate;
      $scope.selectDateObj.showStr = $scope.selectDateObj.startDate.substring(5,10)+"至"+$scope.selectDateObj.endDate.substring(5,10);
    }

    function init() {
      getCurentTerm();
      //清空选中的节次
      $scope.selectKnobArr = [];
      var nowDate = new Date();
      $scope.selectDateObj.startDate = moment(nowDate).format('YYYY-MM-DD');
      var endDate = moment(nowDate).add(5,'d')._d;
      $scope.selectDateObj.endDate = moment(endDate).format('YYYY-MM-DD');
      $scope.selectDateObj.showStr = $scope.selectDateObj.startDate.substring(5,10)+"至"+$scope.selectDateObj.endDate.substring(5,10);
    }



    function initTeamplate() {
      $ionicModal.fromTemplateUrl('templates/register/common/kb/select_schedule_service.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function (modal) {
        $scope.scheduleDialog = modal;
      });
      $ionicModal.fromTemplateUrl('templates/register/common/kb/select_date_template.html',{
        scope:$scope,
        animation:'slide-in-up'
      }).then(function(modal){
        $scope.selectDateTemplate = modal;
      });
      $ionicModal.fromTemplateUrl('templates/register/common/kb/select_teacher_or_course_template.html',{
        scope:$scope,
        animation:'slide-in-up'
      }).then(function(modal){
        $scope.selectTocTemplate = modal;
      });
    }

    function showSelectDate() {
      if($scope.selectDateTemplate){
        $scope.selectDateTemplate.show();
      }
    }
    function hideSelectDate() {
      if($scope.selectDateTemplate){
        $scope.selectDateTemplate.hide();
      }
    }

    function showDialog() {
      if ($scope.scheduleDialog) {
        $scope.scheduleDialog.show();
      }
    }
    function hideDialog() {
      if ($scope.scheduleDialog) {
        $scope.scheduleDialog.hide();
      }
    }
    initTeamplate();

    function selectDate() {

      var startDate = $scope.selectDateObjTemp.startDate;
      var endDate = $scope.selectDateObjTemp.endDate;

      if(!startDate){
        ynuiNotification.error({msg: "请选择开始日期！"});
        return;
      }
      if(!endDate){
        ynuiNotification.error({msg: "请选择结束日期！"});
        return;
      }
      if(moment(endDate).isBefore(startDate)){
        ynuiNotification.error({msg: "结束日期不能小于开始日期！"});
        return;
      }
      //学期开始日期
      var termBeginDate =$scope.curentTerm.termBeginDateString;
      //学期结束日期
      var termEndDate =$scope.curentTerm.termEndDateString;
      if(moment(startDate).isBefore(termBeginDate) || moment(endDate).isAfter(termEndDate)){
        ynuiNotification.error({msg: "日期必须在学期时间范围内！"});
        return;
      }
      var add7Obj = moment(startDate).add(7,'d')._d;

      if(moment(add7Obj).isBefore(endDate)){
        ynuiNotification.error({msg: "只能选择相差7天内的日期！"});
        return;
      }
      setSelectDate(startDate,endDate);
      $scope.scheduleList = [];
      initSelectObj();
      hideSelectDate();
    }

    function showSelectToc(){
      findTeacherOrCourseList($scope.selectTocObj.type);
      $scope.selectTocTemplate.show();
    }

    function selectToc(item){
      $scope.selectTocObj.id = item.id;
      $scope.selectTocObj.name = item.name;

      findScheduleList();
      $scope.selectTocTemplate.hide();
    }

    $scope.selectKnobArr = [];

    function addKnob(item) {
      if($scope.selectKnobArr.length < 1){
        knobPush(item);
      }else{
        var konbArr = $scope.selectKnobArr;

        for(var i=0;i<konbArr.length;i++){
          var knob = konbArr[i];
          if(!compareKnobBase(knob,item)){
            ynuiNotification.error({msg: "只能选择连堂课！"});
            return;
          }
        }
        knobPush(item);
      }
    }


    function removeKnob(item) {
      var index = $scope.selectKnobArr.indexOf(item);
      if (index > -1) {
        $scope.selectKnobArr.splice(index, 1);
        item.selected = false;
      }
    }

    function knobPush(item) {
      $scope.selectKnobArr.push(item);
      item.selected = true;
    }

    function selectKnob(item){
      if(item.courseId){
        if(item.selected){
          removeKnob(item);
        }else{
          addKnob(item);
        }
      }
    }

    $scope.selectKnob  = selectKnob;
    $scope.findTeacherOrCourseList = findTeacherOrCourseList;
    $scope.showSelectToc = showSelectToc;
    $scope.selectDate = selectDate;
    $scope.showSelectDate = showSelectDate;
    $scope.hideSelectDate = hideSelectDate;
    $scope.selectToc = selectToc;
    return {select: select}
  }
})();
