(function () {
  'use strict';

  angular
    .module('starter')
    .factory('selectOrgService', selectOrgService);

  function selectOrgService($ionicModal, $rootScope,$http,$ionicScrollDelegate,ynuiNotification) {
    var $scope = $rootScope.$new();
    //行政线值
    var ADM_VALUE = "1";
    //教学线值
    var TEACHING  = "2";
    var COMMON_DIMENSIONS_ARR = [{name: "行政线维度", id: ADM_VALUE}, {name: "教学线维度", id: TEACHING}];
    var zTreeObj;
    $scope.selectDimensionObj = {id:"",name:""};
    $scope.selectObjName = "";

    var basePath = originBaseUrl + "/third/platformSysOrg";
    function initTeamplate() {
      return $ionicModal.fromTemplateUrl('templates/register/common/select_org_service.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function (modal) {
        return $scope.selectOrgDialog = modal;
      });
    }

    function showDialog() {
      if ($scope.selectOrgDialog) {
        $scope.selectOrgDialog.show();
      } else {
        initTeamplate().then(function (modal) {
          modal.show();
        });
      }
    }
    function hideDialog() {
      if ($scope.selectOrgDialog) {
        $scope.selectOrgDialog.remove().then(function () {
          $scope.selectOrgDialog = null;
        });
      }
    }
    initTeamplate();

    var setting = {
      view: {
        dblClickExpand: false,//双击节点时，是否自动展开父节点的标识
        showLine: false,//是否显示节点之间的连线
        showIcon:false,
        selectedMulti: true //设置是否允许同时选中多个节点
      },
      check:{
        chkboxType: { "Y": "", "N": "" },
        chkStyle: "checkbox",//复选框类型
        enable: false //每个节点上是否显示 CheckBox
      },
      data: {simpleData: {
          enable: true,
          idKey:  "id",
          pIdKey: "parentId"
        }
      },callback: {
        onClick: singleCheckEvent
      }
    };

    function singleCheckEvent(event, treeId, treeNode) {
      $scope.selectObjName = treeNode.name;
      $scope.$apply("selectObjName");
    }

    function initTree(treeData) {
      zTreeObj = $.fn.zTree.init($("#treeDemo"), setting,treeData);
      //默认展开
      zTreeObj.expandAll(true);
    }

    function findOrgDate(dimensionId) {
      if(!dimensionId){
        dimensionId = ADM_VALUE;
        $scope.selectDimensionObj = COMMON_DIMENSIONS_ARR[0];
      }
      $http.post(basePath + "/findOrgByDimensionId.htm?dimensionId="+dimensionId).success(function(data){
        if(data.status == 0){
          initTree(data.result);
        }
      })
    }

    function initSingleDate() {
      $scope.selectObjName = "";
      $scope.dimensionsArr = COMMON_DIMENSIONS_ARR;
    }

    function select(callBack) {
      initSingleDate();
      findOrgDate();
      showDialog();
      $scope.finishSelect = function () {
        var selectedNodes = zTreeObj.getSelectedNodes();
        if(selectedNodes.length < 1){
          ynuiNotification.error({msg: "您还没有选择组织机构！"});
          return;
        }
        var item = {id:selectedNodes[0].id,name:selectedNodes[0].name};
        callBack(item);
        hideDialog();
      };
    }

    function selectDimension(item){
      $scope.selectDimensionObj = item;
      findOrgDate(item.id);
    }

    $scope.hideDialog      = hideDialog;
    $scope.selectDimension      = selectDimension;
    return {singleSelect: select}
  }
})();
