(function () {
  'use strict';

  angular
    .module('starter')
    .factory('selectPlaceService', selectPlaceService);

  function selectPlaceService($ionicModal, $rootScope,$http,$ionicScrollDelegate,ynuiNotification) {
    var $scope = $rootScope.$new();

    $scope.selectDimensionObj = {id:"",name:""};
    $scope.selectObjName = "";
    var basePath = originBaseUrl + "/third/tkPatrolListenUserDuty";

    $scope.type = 1;

    function initTeamplate() {
      $ionicModal.fromTemplateUrl('templates/register/common/select_place_service.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function (modal) {
        $scope.selectOrgDialog = modal;
      });
    }

    function showDialog() {
      if ($scope.selectOrgDialog) {
        $scope.selectOrgDialog.show();
      }
    }
    function hideDialog() {
      if ($scope.selectOrgDialog) {
        $scope.selectOrgDialog.hide();
      }
    }
    initTeamplate();
    $scope.showObj = null;
    $scope.allResult = null;

    $scope.queryObj= {classRoomValue:""};
    $scope.classRoomList = [];
    function findClassRoomList(data) {
      if($scope.selectBuild.id){
        data.buildId = $scope.selectBuild.id;
      }else{
        data.buildId =  "";
      }
      var knobList = [];
      for(var key in $scope.selectBuild.knobs) {
        knobList.push($scope.selectBuild.knobs[key]);
      }
      if(knobList.length > 0){
        data.floors = knobList;
      }else{
        data.floors = [];
      }
      $http.post(basePath + "/findClassRoomList.htm",data).success(function (data) {
        if (data.status == 0) {
          $scope.classRoomList = data.result;
        }
      });
    }

    function findBuildList(data) {
      $http.post(basePath + "/findBuildList.htm",data).success(function (data) {
        if (data.status == 0) {
          if(data.result && data.result.length > 0){
            $scope.allResult = data.result;
            $scope.showObj = data.result[0];
            initShowObjData();
            $scope.schoolList = [];
            angular.forEach(data.result,function (item) {
              $scope.schoolList.push({id:item.schoolArea.id,name:item.schoolArea.name});
            });
          }
        }
      });
    }

    function initShowObjData() {
      angular.forEach($scope.showObj.buildList,function (item) {
        var knobs = [];
        for(var i=1;i<=parseInt(item.userNumber);i++){
          knobs.push({value:i,selected:false});
        }
        item.up  = false;
        item.knobs = knobs;
      })
    }

    function clearKnobSelect() {
      angular.forEach($scope.showObj.buildList,function (item) {
        angular.forEach(item.knobs,function (jtem) {
          jtem.selected = false;
        });
      })
    }
    $scope.queryData = null;
    function select(data,callBack) {
      showDialog();
      findBuildList(data);
      $scope.queryData = data;
      $scope.classRoomSelect = function(item){
        var obj = {type:2,value:item};
        callBack(obj);
        hideDialog();
      };
      $scope.finishSelect = function () {
        var count = [];
        for(var key in $scope.selectBuild.knobs) {
          count.push($scope.selectBuild.knobs[key]);
        }
        if(count.length  < 1){
          ynuiNotification.error({msg: "请选择楼层！"});
          return;
        }
        var obj = {type:1,value:$scope.selectBuild};
        callBack(obj);
        hideDialog();
      };
    }

    function selectDimension(item){
      $scope.selectDimensionObj = item;
    }

    function toggleBuild(item){
      angular.forEach($scope.showObj.buildList,function (jtem) {
        jtem.up = false;
      });
      item.up = !item.up;
      initSelectBuild();
      clearKnobSelect()
    }

    function initSelectBuild(){
      $scope.selectBuild = {
        id:"",
        name:"",
        knobs:{}
      };
    }
    initSelectBuild();

    function selectKnob(item,jtem){
      if($scope.selectBuild.id == ""){
        $scope.selectBuild.id = item.id;
        $scope.selectBuild.name = item.name;
        $scope.selectBuild.knobs[jtem.value] = jtem.value;
        jtem.selected = true;
      }else if($scope.selectBuild.id == item.id){
        if(jtem.selected){
          delete  $scope.selectBuild.knobs[jtem.value];
          jtem.selected = false;
        }else{
          $scope.selectBuild.knobs[jtem.value] = jtem.value;
          jtem.selected = true;
        }
      }else{
        $scope.selectBuild.id = item.id;
        $scope.selectBuild.name = item.name;
        $scope.selectBuild.knobs = {};
        $scope.selectBuild.knobs[jtem.value] = jtem.value;
        jtem.selected = true;
      }
    }

    //选择校区
    function selectSchoolArea(j){
      for(var i=0;i<$scope.allResult.length;i++){
        var obj = $scope.allResult[i];
        if(obj.schoolArea.id == j.id){
          $scope.showObj = obj;
          initShowObjData();
          break;
        }
      }
    }

    function selectType(type){
      $scope.type = type;
      if(type == 2){
        findClassRoomList($scope.queryData);
      }
    }

    function clearQueryValue(){
      $scope.queryObj.classRoomValue = "";
    }

    $scope.clearQueryValue = clearQueryValue;
    $scope.selectType = selectType;
    $scope.selectSchoolArea = selectSchoolArea;
    $scope.selectKnob = selectKnob;
    $scope.hideDialog      = hideDialog;
    $scope.selectDimension      = selectDimension;
    $scope.toggleBuild = toggleBuild;
    return {select: select}
  }
})();
