/**
 * 登记任务外的听课结果的基本信息
 * Created by yineng on 2017/1/5 10:33
 *
 */
(function () {
    'use strict';

    angular
      .module('starter')
      .controller('basicMsgController', basicMsgController);

    basicMsgController.$inject = ['$scope', '$http', '$location', '$state', '$ionicModal', "$filter", "ynuiNotification", "tkStorageService", "$q", "$ionicPopup", "ynNavigator"];
    function basicMsgController($scope, $http, $location, $state, $ionicModal, $filter, ynuiNotification, tkStorageService, $q, $ionicPopup, ynNavigator) {
        /**
         * 路由信息
         * @type {string}
         */
        var basePath = originBaseUrl;

        var isFromChooseTeacher = $location.search().isChooseTeacher;
        var isChangeTeacher = $location.search().isChangeTeacher;
        var isFromChooseClassRoom = $location.search().isFromChooseClassRoom;

        var updateId = $location.search().updateId;
        if(!updateId){
            updateId = "";
        }

        $scope.changeOutFlag = changeOutFlag;

        $scope.outFlag = {
            teacher:false,
            course:false,
            place:false
        };

        function changeOutFlag(type) {
            if(type ==1){
                $scope.outFlag.teacher = !$scope.outFlag.teacher;

                $scope.tkBasicInfo.outTeacherName = "";
                $scope.tkBasicInfo.teacherId = "";
                $scope.tkBasicInfo.teacherName = "";

            }else if(type ==2){
                $scope.outFlag.course = !$scope.outFlag.course;

                $scope.tkBasicInfo.outCourseName = "";
                $scope.tkBasicInfo.courseId = "";
                $scope.tkBasicInfo.courseName = "";
            }else if(type == 3){
                $scope.outFlag.place = !$scope.outFlag.place;

                $scope.tkBasicInfo.outPlaceName = "";
                $scope.tkBasicInfo.selectedClassRoomName = "";
                $scope.tkBasicInfo.selectedClassRoomId = "";
            }
        }

        function initTemplate(){

            $ionicModal.fromTemplateUrl('template.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.modal = modal;
            });
            $scope.bottomModalClick = function () {
                $scope.modal.show();
            };
            $scope.closeModal = function () {
                $scope.modal.hide();
            };
        }
        function init(){
            initTemplate();
        }

        init();

        $scope.tkBasicInfo = {
            termId: null, // 学期
            selectedTKDate: null, //听课日期
            week: null, //第几周
            day: null, //星期几,
            timeType: null, //时段类型,
            knob: null, //节次,
            endKnob: null,
            selectedKnobIndex: [],
            classRoomList: [],
            teacherId: null, // 授课教师ID
            selectedClassRoomName: null, //
            selectedClassRoomId: null, //
            selectedTableId: null, // 听课记录表ID
            selectedTableName: null,  // 听课记录表ID
            teachClassId: null,
            scheduleResultsId: null,
            courseName: null,
            courseId: null,
            tkDateDesc: null,
            teachingAdminClassNameStr: null,
            teachingAdminClassIdStr: null,
            teacherName: null,
            termIndex: null,
            weekAndDayDesc: null,

            outTeacherName:null,
            outCourseName:null,
            outPlaceName:null
        };

        var isHaveCache = false;
        var oldConditon = tkStorageService.getItem("tkBasicInfo");
        if (oldConditon) {
            isHaveCache = true;
            $scope.tkBasicInfo = oldConditon;
            $scope.outFlag = tkStorageService.getItem("outFlag");
        }

        // 当前日期
        $scope.currentDate = new Date();
        $scope.currentDate = $filter('date')($scope.currentDate, 'yyyy-MM-dd'); // 格式化

        /**根据日期获取周次*/
        var getWeekAndDay = function (termId, date) {
            $http.post(basePath + "/third/tkTaskRegisterApp/queryWeekAddDate.htm?termId=" + termId + "&queryDate=" + date).success(function (data) {
                if (data.status == 0) {
                    $scope.tkBasicInfo.tkDateDesc = "";
                    if (data.result) {
                        $scope.tkBasicInfo.weekAndDayDesc = data.result.weekDateStr;
                        $scope.tkBasicInfo.week = data.result.week;
                        $scope.tkBasicInfo.day = data.result.date;
                        var weekDateStr = data.result.weekDateStr;
                        var splitIndex = weekDateStr.indexOf("周");
                        var weekStr = weekDateStr.substring(0, splitIndex + 1);
                        var dayStr = weekDateStr.substring(splitIndex + 1);
                        if ($scope.currentDate == $scope.date.tempDate) {
                            $scope.tkBasicInfo.tkDateDesc += "[今天]";
                        }
                        $scope.tkBasicInfo.tkDateDesc += $scope.date.tempDate;
                        $scope.tkBasicInfo.tkDateDesc += " " + weekStr;
                        $scope.tkBasicInfo.tkDateDesc += " " + dayStr;
                    }
                }
            })
        };


        $scope.knobList = [];
        /**获取教学周历下的节次*/
        var getTKKnobList = function (termId) {
            var deferred = $q.defer();
            var promise = deferred.promise;
            $http.post(basePath + "/third/tkTaskRegisterApp/getTKKnobList.htm", {
                termId: termId
            }).success(function (data) {
                $scope.knobList = [];
                if (data.status == 0) {
                    if (data.result) {
                        $scope.knobList = data.result;
                        var i = 1;
                        angular.forEach($scope.knobList, function (item) {
                            item.sequence = i;
                            i++;
                        });
                        // 如果没有缓存，则查询当前时间节点的节次
                        if (!isHaveCache) {
                            getCurrentTimeKnob(termId);
                        }
                    }
                }
                deferred.resolve($scope.knobList);
            });
            return promise;
        };

        /**获取当前时间节点的节次*/
        var getCurrentTimeKnob = function (termId) {
            $scope.tkBasicInfo.timeType = null;
            $scope.tkBasicInfo.knob = null;
            $http.post(basePath + "/third/tkOutsideTaskRegisterApp/getCurrentTimeKnob.htm", {
                termId: termId
            }).success(function (data) {
                if (data.status == 0) {
                    if (data.result) {
                        var index = 0;
                        angular.forEach($scope.knobList, function (item) {
                            if (item.timeType == data.result.timeType && item.knob == data.result.knob) {
                                $scope.tkBasicInfo.timeType = item.timeType;
                                $scope.tkBasicInfo.knob = item.knob;
                                $scope.tkBasicInfo.endKnob = item.knob;
                                $scope.tkBasicInfo.selectedKnobIndex.push(index);
                            }
                            index++;
                        });
                    } else {
                        $scope.tkBasicInfo.selectedKnobIndex.push(0);
                        $scope.tkBasicInfo.timeType = $scope.knobList[0].timeType;
                        $scope.tkBasicInfo.knob = $scope.knobList[0].knob;
                        $scope.tkBasicInfo.endKnob = $scope.knobList[0].knob;
                    }
                }
            });
        };


        $scope.isExist = null; // 是否存在教学周历
        // 学期
        $scope.term = null;
        $scope.termList = [];
        $http.post(basePath + "/third/tkOutsideTaskRegisterApp/getPreviousAndCurrentTermList.htm").success(function (data) {
            $scope.termList = [];
            $scope.term = null;
            if (data.status == 0) {
                $scope.termList = data.result;
                if ($scope.termList.length > 0) {
                    if (!isHaveCache) {
                        if ($scope.termList[0].currenTerm) {
                            $scope.term = $scope.termList[0];
                            $scope.tkBasicInfo.termIndex = 0;
                        }
                    } else {
                        angular.forEach($scope.termList, function (item) {
                            if (item.termId == $scope.tkBasicInfo.termId) {
                                $scope.term = item;

                            }
                        });
                    }
                    $scope.isExist = $scope.term.existWeekCalendar;
                }
            }
        });

        /**切换学期*/
        $scope.changeTerm = function () {
            //初始化选中节次
            $scope.tkBasicInfo.selectedKnobIndex = [];
            if ($scope.tkBasicInfo.termIndex < $scope.termList.length - 1) {
                $scope.tkBasicInfo.termIndex++;
                $scope.term = $scope.termList[$scope.tkBasicInfo.termIndex];
            } else {
                $scope.tkBasicInfo.termIndex = 0;
                $scope.term = $scope.termList[$scope.tkBasicInfo.termIndex];
            }
            $scope.isExist = $scope.term.existWeekCalendar;
            isHaveCache = false;
            cleanData();
        };

        $scope.date = {tempDate:""};
        /**监听学期改变，初始化听课日期*/
        $scope.$watch("term", function (newTerm, oldTerm) {
            if (newTerm !== oldTerm) {
                if (newTerm) {
                    $scope.tkBasicInfo.termId = newTerm.termId;
                    getTKKnobList(newTerm.termId).then(function () {
                        if (!isHaveCache) {
                            // 如果当前日期在学期范围内则显示当前日期
                            if (newTerm.startDate <= $scope.currentDate && $scope.currentDate <= newTerm.endDate) {
                                $scope.date.tempDate = $scope.currentDate;
                            } else {
                                // 如果当前日期没在学期日期范围内，则默认显示请选择
                                $scope.tkBasicInfo.tkDateDesc = "";
                                $scope.date.tempDate = null;
                            }
                        } else {
                            $scope.date.tempDate = $scope.tkBasicInfo.selectedTKDate;
                        }
                    });
                }
            }
        }, true);

        /**验证所选日期是否在所选学期日期范围内*/
        var validateDateScope = function (selectedDate) {
            if (!($scope.term.startDate <= selectedDate && selectedDate <= $scope.term.endDate)) {
                $scope.tkBasicInfo.tkDateDesc = null;
                $scope.date.tempDate = null;
                ynuiNotification.error({msg: "只能选择在" + $scope.term.startDate + "~" + $scope.term.endDate + "之间的日期!"});
                return false;
            }
            return true;
        };

        /**监听听课日期，查询教学周历信息*/
        $scope.$watch("date.tempDate", function (newDate, oldDate) {
            if (newDate !== oldDate) {
                if (newDate) {
                    if (validateDateScope(newDate)) {
                        $scope.tkBasicInfo.selectedTKDate = newDate;
                        getWeekAndDay($scope.term.termId, $scope.tkBasicInfo.selectedTKDate);
                    }
                } else {
                    $scope.tkBasicInfo.selectedTKDate = null;
                }
            }
        });

        /**改变日期*/
        $scope.selectedDate = function (data) {
            if (validateDateScope(data)) {
                $scope.date.tempDate = data;
                //$scope.tkBasicInfo.selectedTKDate = data;
                getWeekAndDay($scope.term.termId, $scope.date.tempDate);
            } else {
                $scope.date.tempDate = "";
            }
            cleanData();
            $scope.$apply();
        };

        var cleanData = function () {
            $scope.tkBasicInfo.courseName = null;
            $scope.tkBasicInfo.courseId = null;
            $scope.tkBasicInfo.teachClassId = null;
            $scope.tkBasicInfo.scheduleResultsId = null;
            $scope.tkBasicInfo.teachingAdminClassNameStr = null;
            $scope.tkBasicInfo.teachingAdminClassIdStr = null;
            $scope.tkBasicInfo.buildAndClassRoomNameStr = null;
            $scope.tkBasicInfo.classRoomList = [];
            $scope.tkBasicInfo.selectedClassRoomName = null;
            $scope.tkBasicInfo.selectedClassRoomId = null;
            $scope.tkBasicInfo.teacherId = null;
            $scope.tkBasicInfo.teacherName = null;
        };

        $scope.selectKnob = function (index) {
            var obj = $scope.knobList[index];
            var selected = $scope.tkBasicInfo.selectedKnobIndex.indexOf(index);
            if (selected >= 0) {
                $scope.tkBasicInfo.selectedKnobIndex.splice(selected, 1);
            } else {
                if ($scope.tkBasicInfo.selectedKnobIndex.length > 0) {
                    var continuous = $scope.tkBasicInfo.knob + 1 === obj.knob || $scope.tkBasicInfo.knob - 1 === obj.knob
                      || $scope.tkBasicInfo.endKnob + 1 === obj.knob || $scope.tkBasicInfo.endKnob - 1 === obj.knob;
                    if ((null != $scope.tkBasicInfo.timeType && $scope.tkBasicInfo.timeType)
                      !== obj.timeType || !continuous) {
                        ynuiNotification.error({msg: "只能对上午/下午/晚上同段相邻节次进行多选！"});
                        return;
                    }
                }
                $scope.tkBasicInfo.selectedKnobIndex.push(index);
            }
            if ($scope.tkBasicInfo.selectedKnobIndex.length === 0) {
                $scope.tkBasicInfo.timeType = null;
                $scope.tkBasicInfo.knob = null;
                $scope.tkBasicInfo.endKnob = null;
                cleanData();
            } else {
                var order = $filter('orderBy')($scope.tkBasicInfo.selectedKnobIndex, '');
                $scope.tkBasicInfo.timeType = $scope.knobList[index].timeType;
                $scope.tkBasicInfo.knob = $scope.knobList[order[0]].knob;
                $scope.tkBasicInfo.endKnob = $scope.knobList[order[order.length - 1]].knob;
            }
            if($scope.tkBasicInfo.selectedKnobIndex.length > 0){
                if(!checkNumberLianxu($scope.tkBasicInfo.selectedKnobIndex)){
                    ynuiNotification.error({msg: "只能对上午/下午/晚上同段相邻节次进行多选！"});
                }else{
                    var postData = {
                        termId:$scope.term.termId,
                        date:$scope.date.tempDate,
                        timeType:$scope.tkBasicInfo.timeType,
                        knob:$scope.tkBasicInfo.knob,
                        endKnob:$scope.tkBasicInfo.endKnob
                    };
                    validateReport(postData);
                }
            }
        };
        function checkNumberLianxu(array){
            if(array.length <=1){
                return true;
            }
            array.sort();
            var flag=true;
            var temp=0;
            for(var i=0;i<array.length-1;i++){
                temp=array[i];
                if(parseInt(temp)+1!=parseInt(array[i+1])){
                    flag=false;
                }
            }
            return flag;
        }
        function validateReport(postData){
            $http.post(originBaseUrl + "/third/tkTaskRegisterApp/validateTeacherIsRegistTkResult.htm?", postData).success(function (data) {
                if(data.status == 0){
                    //do nothing
                }else{
                    ynuiNotification.error({msg: data.message});
                }
            });
        }

        /**选择教师*/
        $scope.chooseTeacher = function () {
            if($scope.tkBasicInfo.selectedKnobIndex.length < 1){
                ynuiNotification.error({msg: "请选择听课节次！"});
                return;
            }
            tkStorageService.setItem("tkBasicInfo", $scope.tkBasicInfo);
            tkStorageService.setItem("outFlag", $scope.outFlag);
            $location.path("/chooseTeacher").search({"type": 1});
        };

        /**获取教师课表中的课程信息*/
        var getScheduleDetailByTeacher = function () {
            $http.post(basePath + "/third/tkOutsideTaskRegisterApp/getScheduleDetailByTeacher.htm",
              $scope.tkBasicInfo
            ).success(function (data) {
                if (data.status == 0) {
                    var result = data.result;
                    if (result) {
                        $scope.tkBasicInfo.courseName = result.courseName;
                        $scope.tkBasicInfo.courseId = result.courseId;
                        $scope.tkBasicInfo.teachClassId = result.teachClassId;
                        $scope.tkBasicInfo.scheduleResultsId = result.scheduleResultsId;
                        $scope.tkBasicInfo.teachingAdminClassNameStr = result.teachingAdminClassNameStr;
                        $scope.tkBasicInfo.teachingAdminClassIdStr = result.teachingAdminClassIdStr;
                        $scope.tkBasicInfo.buildAndClassRoomNameStr = result.buildAndClassRoomNameStr;
                        $scope.tkBasicInfo.classRoomList = result.classRoomList;
                    }
                    // 如果有教室
                    if ($scope.tkBasicInfo.classRoomList.length > 0) {
                        $scope.tkBasicInfo.selectedClassRoomName = $scope.tkBasicInfo.classRoomList[0].name;
                        $scope.tkBasicInfo.selectedClassRoomId = $scope.tkBasicInfo.classRoomList[0].id;
                        $scope.tkBasicInfo.selectedClassRoomIndex = 0;
                    } else {
                        $scope.tkBasicInfo.selectedClassRoomName = null;
                        $scope.tkBasicInfo.selectedClassRoomId = null;
                    }
                }
            });
        };

        // 如果从选择授课教师页面跳转回来，则按授课教师查询课表信息
        if (isFromChooseTeacher) {
            if (isChangeTeacher) {
                getScheduleDetailByTeacher();
            }
        }


        /**切换教室*/
        $scope.changeClassRoom = function () {

            var listLength = $scope.tkBasicInfo.classRoomList.length;
            var index = $scope.tkBasicInfo.selectedClassRoomIndex;
            // 如果不是最后一个，则选中下一个
            if (index != listLength - 1) {
                index += 1;
                $scope.tkBasicInfo.selectedClassRoomName = $scope.tkBasicInfo.classRoomList[index].name;
                $scope.tkBasicInfo.selectedClassRoomId = $scope.tkBasicInfo.classRoomList[index].id;
                $scope.tkBasicInfo.selectedClassRoomIndex = index;
            } else {
                // 如果是最后一个，则选中第一个
                $scope.tkBasicInfo.selectedClassRoomName = $scope.tkBasicInfo.classRoomList[0].name;
                $scope.tkBasicInfo.selectedClassRoomId = $scope.tkBasicInfo.classRoomList[0].id;
                $scope.tkBasicInfo.selectedClassRoomIndex = 0;
            }
        };
        $scope.canChooseRoom = false;
        if (isFromChooseClassRoom) {
            $scope.canChooseRoom = true;
        }

        /**选择教室*/
        $scope.chooseClassRoom = function () {
            // 如果未先选择授课教师，则提示
            if (!$scope.tkBasicInfo.teacherName) {
                ynuiNotification.error({msg: "请先选择授课教师！"});
                return;
            }
            tkStorageService.setItem("tkBasicInfo", $scope.tkBasicInfo);
            tkStorageService.setItem("outFlag", $scope.outFlag);
            $location.path("/classroomSearch");
        };

        /**
         * 选择课程
         */
        $scope.chooseCourses = chooseCourses;
        function chooseCourses() {
            if (!$scope.tkBasicInfo.teacherName) {
                ynuiNotification.error({msg: "请先选择授课教师！"});
                return;
            }
            tkStorageService.setItem("tkBasicInfo", $scope.tkBasicInfo);
            tkStorageService.setItem("outFlag", $scope.outFlag);
            $location.path("/tkChooseCourses");
        }

        /**
         * 选择班级
         */
        $scope.chooseClass = chooseClass;
        function chooseClass() {
            if (!$scope.tkBasicInfo.teacherName) {
                ynuiNotification.error({msg: "请先选择授课教师！"});
                return;
            }
            tkStorageService.setItem("tkBasicInfo", $scope.tkBasicInfo);
            tkStorageService.setItem("outFlag", $scope.outFlag);
            $location.path("/tkChooseClass");
        }

        var initTips = function () {
            return {
                isError: false,
                isNoData: false
            };
        };
        $scope.tips = initTips();

        $scope.tableList = [];
        var getTable = function () {
            $http.post(basePath + "/third/tkTaskRegisterApp/getTKTableDown.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.tableList = data.result;
                    if ($scope.tableList.length > 0) {
                        if (!isHaveCache) {
                            $scope.tkBasicInfo.selectedTableId = $scope.tableList[0].id;
                            $scope.tkBasicInfo.selectedTableName = $scope.tableList[0].name;
                        }
                    } else {
                        $scope.tips.isNoData = true;
                    }
                } else {
                    $scope.tips.isError = true;
                }
            })
              .error(function () {
                  $scope.tips.isError = true;
              });
        };
        getTable();


        /**选中记录表*/
        $scope.selectTable = function (item) {
            $scope.tkBasicInfo.selectedTableId = item.id;
            $scope.tkBasicInfo.selectedTableName = item.name;
            $scope.closeModal();
        };

        /**取消*/
        $scope.cancle = function () {
            if (!$scope.isExist) {
                $location.path("/register_task");
            } else {
                var confirmPopup = $ionicPopup.confirm({
                    title: "提示",
                    template: '确定要放弃当前编辑内容吗？',
                    cancelText: "继续编辑",
                    okText: "放弃"
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        tkStorageService.clearKey("tkBasicInfo");
                        tkStorageService.clearKey("allItemVOList");
                        tkStorageService.clearKey("teachClass");
                        tkStorageService.clearKey("outFlag");
                        $location.path("/register_task");
                        $scope.$apply();
                    }
                });
            }

        };

        ynNavigator.registerBackAction(function () {
            console.log(123);
            $scope.cancle();
        }, 201);

        function checkScheduleExist(vo) {
            return $http.post(basePath + '/third/tkOutsideTaskRegisterApp/checkScheduleExist.htm',
              vo
            ).then(function (response) {
                return response;
            });
        }

        function submit() {
            tkStorageService.setItem("tkBasicInfo", $scope.tkBasicInfo);
            tkStorageService.setItem("outFlag", $scope.outFlag);
            var tkRegisterData = tkStorageService.getItemNoDel("tkRegisterData");
            if (tkRegisterData && (tkRegisterData.saveTKResultRegisterVO.tkglTableId != $scope.tkBasicInfo.selectedTableId)) {
                var confirmPopup = $ionicPopup.confirm({
                    title: "提示",
                    template: '切换听课打分表，会清空个别打分项信息，确定要切换吗？',
                    cancelText: "取消",
                    okText: "确定"
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        // $location.path("/register").search({updateId:updateId});
                        $state.go('register', {updateId:updateId, prev: 'basic_msg'});
                    }
                });
            } else {
                // $location.path("/register").search({updateId:updateId});
                $state.go('register', {updateId:updateId, prev: 'basic_msg'});
            }
        }

        //登记或修改
        $scope.toRegister = function(queryId,queryType){

            tkStorageService.clearKey("tkRegisterData");
            tkStorageService.clearKey("tkBasicInfo");
            //    * 1：听课任务ID（通过任务，登记听课结果）
            //    * 3：听课登记结果ID（查询登记结果修改）
            tkStorageService.setItem("queryType",queryType);
            tkStorageService.setItem("queryId",queryId);
            tkStorageService.setItem("topTermId",$scope.tkBasicInfo.termId);
            // $location.path("/register");
            $state.go('register', {prev: 'basic_msg'});
        };

        /**下一步*/
        $scope.nextStep = function () {
            //1.必传参数验证
            if (!$scope.tkBasicInfo.termId) {
                ynuiNotification.error({msg: "请选择学期！"});
                return;
            }
            if (!$scope.tkBasicInfo.selectedTKDate) {
                ynuiNotification.error({msg: "请选择听课日期！"});
                return;
            }
            if (!$scope.tkBasicInfo.knob) {
                ynuiNotification.error({msg: "请选择听课节次！"});
                return;
            }
            if (!$scope.tkBasicInfo.teacherName) {
                ynuiNotification.error({msg: "请选择授课教师！"});
                return;
            }
            if (!$scope.tkBasicInfo.courseName) {
                ynuiNotification.error({msg: "请选择课程！"});
                return;
            }
            if (!$scope.tkBasicInfo.selectedClassRoomName) {
                ynuiNotification.error({msg: "请选择授课地点！"});
                return;
            }

            if (!$scope.tkBasicInfo.selectedTableId) {
                ynuiNotification.error({msg: "请选择听课记录表！"});
                return;
            }

            var postData = {
                termId:$scope.tkBasicInfo.termId,
                date:$scope.tkBasicInfo.selectedTKDate,
                timeType:$scope.tkBasicInfo.timeType,
                knob:$scope.tkBasicInfo.knob,
                endKnob:$scope.tkBasicInfo.endKnob
            };


            $http.post(originBaseUrl + "/third/tkTaskRegisterApp/validateTeacherIsRegistTkResult.htm?", postData).success(function (data) {
                if(data.status == 0){
                    var verifyData = postData;
                    verifyData.tkglTableId = $scope.tkBasicInfo.selectedTableId;
                    verifyData.skUserId    = $scope.tkBasicInfo.teacherId;
                    verifyData.skUserName  = $scope.tkBasicInfo.teacherName;

                    verifyData.courseId    = $scope.tkBasicInfo.courseId;
                    verifyData.courseName  = $scope.tkBasicInfo.courseName;
                    verifyData.roomName    = $scope.tkBasicInfo.selectedClassRoomName;
                    verifyData.roomId      = $scope.tkBasicInfo.selectedClassRoomId;
                    verifyData.teachingAdminClassIdStr     = $scope.tkBasicInfo.teachingAdminClassIdStr;

                    $http.post(originBaseUrl + "/third/tkTaskRegisterApp/verifyDraftResultSame.htm",verifyData).success(function(data){
                        if(data.status == 0){
                            if(data.result){
                                var draftId = data.result;
                                $scope.toRegister(draftId,3);
                            }else{

                                ////////////////////////////////////////////////////////////////////
                                //如果选了上课班级，则验证
                                if($scope.tkBasicInfo.teachingAdminClassIdStr){
                                    // 判断选择的信息在课表存不存在
                                    checkScheduleExist($scope.tkBasicInfo).then(function (response) {
                                        if (response.data.result === 0) {
                                            $ionicPopup.confirm({
                                                title: "提示",
                                                template: '您登记信息中的教师、课程、地点、班级与课表安排不一致，是否继续登记？',
                                                cancelText: "取消",
                                                okText: "确定"
                                            }).then(function (res) {
                                                if (res) {
                                                    submit();
                                                }
                                            });
                                        } else {
                                            submit();
                                        }
                                    });
                                }else{
                                    submit();
                                }
                                ////////////////////////////////////////////////////////////////////
                            }
                        }else{
                            ynuiNotification.error({msg: data.message});
                        }
                    });

                }else{
                    ynuiNotification.error({msg: data.message});
                }
            });
        };
    }

})();
