/**
 * 按分类查看选择教室
 * Created by wangl on 2017/1/9 16:12
 *
 */
(function () {
    'use strict';

    angular
      .module('starter')
      .controller('classroomSearchController', classroomSearchController);

    classroomSearchController.$inject = ['$scope', '$http', '$location', '$state', '$ionicModal', "$filter", "$timeout", "ynuiNotification", "tkStorageService","$ionicScrollDelegate"];

    function classroomSearchController($scope, $http, $location, $state, $ionicModal, $filter, $timeout, ynuiNotification, tkStorageService, $ionicScrollDelegate) {
        /**
         * 路由信息
         * @type {string}
         */
        $scope.basePath = originBaseUrl;

        var tkBasicInfo = tkStorageService.getItemNoDel("tkBasicInfo");
        var targetRoute = $location.search().targetRoute;

        $scope.conditions = {
            className: null
        };

        var initTips = function () {
            return {
                isError: false,
                isNoData: false
            };
        };

        $scope.tips = initTips();
        /**
         * 教室集
         * @type {Array}
         */
        $scope.classRoomList = [];

        $scope.isLoading = false;

        // 获取教室集
        var getClassRoom = function (isInstant) {
            if (isInstant) {
                $scope.isLoading = true;
            }
            $scope.tips = initTips();
            $scope.classRoomList = [];
            $http.post($scope.basePath + "/third/tkOutsideTaskRegisterApp/queryAvailableClassRoom.htm", {
                name: $scope.conditions.className,
                codes: $scope.selectedRoomType ? $scope.selectedRoomType.dictCode : null
            }).success(function (data) {
                if (isInstant) {
                    $scope.isLoading = false;
                }
                if (data.status == 0) {
                    $scope.classRoomList = data.result;
                    if (!(data.result && data.result.length > 0)) {
                        $scope.tips.isNoData = true;
                    }
                } else {
                    $scope.tips.isError = true;
                }
            }).error(function () {
                if (isInstant) {
                    $scope.isLoading = false;
                }
                $scope.classRoomList = [];
                $scope.tips.isError = true;
            });
        };
        getClassRoom(false);

        /**刷新试试*/
        $scope.refreshAndRetry = function () {
            getClassRoom(false);
        };

        /**取消*/
        $scope.cancle = function () {
            $location.path("/classroomClassify");
        };

        /**选中教室*/
        $scope.selectClassRoom = function(item){
            tkBasicInfo.selectedClassRoomName = item.name;
            tkBasicInfo.selectedClassRoomId = item.id;
            tkBasicInfo.classRoomList = [];
            tkBasicInfo.classRoomList.push(item);
            tkStorageService.setItem("tkBasicInfo", tkBasicInfo);
            if(targetRoute){
                $location.path("/"+targetRoute).search({"isChooseTeacher":false});
                $location.path("/"+targetRoute).search({"isFromChooseClassRoom":true});
            }else{
                $location.path("/basic_msg").search({"isChooseTeacher":false});
                $location.path("/basic_msg").search({"isFromChooseClassRoom":true});
            }

        };

        var timeout;
        /**即时搜索值改变*/
        $scope.changeQueryVal = function (val) {
            $ionicScrollDelegate.$getByHandle('dashboardBc').scrollTop(false);
            if (val) {
                if (timeout) {
                    $timeout.cancel(timeout);
                }
                timeout = $timeout(function () {
                    getClassRoom(true);
                }, 700);
            } else {
                getClassRoom(true);
            }
        };

        /**清除即时搜索值*/
        $scope.cleanQueryVal = function () {
            $scope.conditions.className = null;
            getClassRoom(true);
            // if(targetRoute){
            //     $location.path("/classroomClassify").search({"targetRoute":targetRoute});
            // }else{
            //     $location.path("/classroomClassify")
            // }
        };

        findAllRoomType();

        $scope.roomTypes = null;
        $scope.selectedRoomType = {dictCode: null, dictName: '全部类型'};

        function findAllRoomType() {
            return $http.get(originBaseUrl + '/third/tkTaskRegisterApp/findAllClassRoomType.htm')
              .success(function (data) {
                  if (data.status === 0) {
                      $scope.roomTypes = data.result;
                  }
              });
        }

        $scope.clickRoomType = clickRoomType;

        function clickRoomType(t) {
            $scope.selectedRoomType = t;
            getClassRoom(true);
        }

    }

})();
