/**
 * Created by YN on 2017/1/10.
 */
/**
 * Created by xionghongsong on 2017/1/9.
 * 打分项目
 */
(function () {
    'use strict';

    angular
      .module('starter')
      .controller('fillRemarkCtrl', fillRemarkCtrl);

    fillRemarkCtrl.$inject = ['$scope', '$location',"tkStorageService","ynuiNotification", 'ynNavigator', '$state'];

    function fillRemarkCtrl($scope, $location,tkStorageService,ynuiNotification,ynNavigator, $state) {
        $scope.tkRegisterData = tkStorageService.getItemNoDel("tkRegisterData");
        $scope.tkRegisterContentType = tkStorageService.getItemNoDel("tkRegisterContentType");

        $scope.placeholder = "";
        $scope.item = {};
        $scope.type = null;
        if($scope.tkRegisterContentType == "suggestion"){
            $scope.placeholder = " 请填写意见或建议";
            $scope.item = $scope.tkRegisterData.suggestionItem;
            $scope.type = 1;
        }else if($scope.tkRegisterContentType == "actContent"){
            $scope.placeholder = " 请填写实际讲解内容";
            $scope.item = $scope.tkRegisterData.actContentItem;
            $scope.type = 1;
        } else {
            $scope.placeholder = " 请输入";
            for (var i = 0; i < $scope.tkRegisterData.registerItemList.length; i++) {
                var item = $scope.tkRegisterData.registerItemList[i];
                if ($scope.tkRegisterContentType === item.id) {
                    $scope.item = item;
                    break;
                }
            }
            $scope.type = 2;
        }
        $scope.saveTKResultRegisterVO =  $scope.tkRegisterData.saveTKResultRegisterVO;
        $scope.clickSub = function(){
            if($scope.verifyNumber($scope.item,true)){
                $scope.tkRegisterData.saveTKResultRegisterVO = $scope.saveTKResultRegisterVO;
                tkStorageService.setItem("tkRegisterData",$scope.tkRegisterData);
                $location.path("/register").search('updateId', $location.search().updateId);
                // $state.go('register');
            }
        };

        // 初始化长度
        if ($scope.type === 1 && $scope.saveTKResultRegisterVO[$scope.item.code]) {
            $scope.inputWordLenth = $scope.saveTKResultRegisterVO[$scope.item.code].length;
        } else if ($scope.type === 2 && $scope.saveTKResultRegisterVO.customItemMap[$scope.item.id]) {
            $scope.inputWordLenth = $scope.saveTKResultRegisterVO.customItemMap[$scope.item.id].length;
        } else {
            $scope.inputWordLenth = 0;
        }

        $scope.showWordLenth = function(word){
            if(word){
                $scope.inputWordLenth = word.length;
            }else{
                $scope.inputWordLenth = 0;
            }
        };
        $scope.cancel = function(){
            $state.go('register');
        };


        //验证自定义无文本输入数字的范围
        $scope.verifyNumber = function (item,isShowMsg) {
            //整数和小数
            if (item.itemType == 2 && (item.inputLimit == 2 || item.inputLimit == 1)) {
                var value = "";
                var checkRule = "";
                if (item.code) {
                    value = $scope.saveTKResultRegisterVO[item.code];
                } else {
                    value = $scope.saveTKResultRegisterVO.customItemMap[item.id];
                }
                if (!value) {
                    return true;
                }
                var errorMsg = item.name;
                if (1 == item.inputLimit) {
                    eval("checkRule=\/^-?\\d{1," + item.maxLength + "}$\/");
                    errorMsg += "请输入不大于" + item.maxLength + "位的整数.";
                } else if (2 == item.inputLimit) {
                    eval("checkRule = \/^-?\\d{1," + item.maxLength + "}(\\.\\d{1," + item.decimalMaxLength + "})?$\/");
                    errorMsg += "请输入整数位不大于" + item.maxLength + "位小数位不大于" + item.decimalMaxLength + "位的数字.";
                }
                if (value && !checkRule.test(value)) {
                    if (item.code) {
                        $scope.saveTKResultRegisterVO[item.code] = "";
                    } else {
                        $scope.saveTKResultRegisterVO.customItemMap[item.id] = "";
                    }
                    ynuiNotification.error({msg: errorMsg, opts: {timeOut: 3000}});
                    return false;
                }
                var typeRange = {};
                if (item.digitalRange) {
                    angular.forEach(item.digitalRange.split(","), function (i) {
                        typeRange[i] = i;
                    });
                }
                errorMsg = item.name;
                //只等于0
                if (typeRange[1] && !typeRange[0] && !typeRange[2]) {
                    errorMsg += "只能等于0!";
                } else if (!typeRange[1] && typeRange[0] && !typeRange[2]) {
                    //只大于0
                    errorMsg += "请输入大于0的数！";
                } else if (!typeRange[1] && !typeRange[0] && typeRange[2]) {
                    //只小于0
                    errorMsg += "请输入小于0的数！";
                } else if (typeRange[1] && typeRange[0] && typeRange[2]) {
                    //大于小于等于0
                } else if (typeRange[1] && !typeRange[0] && typeRange[2]) {
                    //小于等于0
                    errorMsg += "请输入小于等于0的数！";
                } else if (typeRange[1] && typeRange[0] && !typeRange[2]) {
                    //大于等于0
                    errorMsg += "请输入大于等于0的数！";
                } else if (!typeRange[1] && typeRange[0] && typeRange[2]) {
                    //不等于0
                    errorMsg += "请输入不等于0的数！";
                }
                //是否存在范围类
                var isRang = false;
                if (typeRange[0] && value > 0) {
                    isRang = true;
                }
                if (typeRange[1] && value == 0) {
                    isRang = true;
                }
                if (typeRange[2] && value < 0) {
                    isRang = true;
                }
                if (!isRang) {
                    if (item.code) {
                        $scope.saveTKResultRegisterVO[item.code] = "";
                    } else {
                        $scope.saveTKResultRegisterVO.customItemMap[item.id] = "";
                    }
                    if(isShowMsg){
                        ynuiNotification.error({msg: errorMsg});
                    }
                    return false;
                }
            }
            return true;
        };

    }

})();
