/**
 * 巡查听课
 */
(function () {
    'use strict';

    angular
      .module('starter')
      .controller('inspectionAttendanceController', inspectionAttendanceController);

    inspectionAttendanceController.$inject = ['$scope', '$http', '$location', '$state', '$ionicModal', "$filter", "ynuiNotification", "tkStorageService", "$q", "$ionicPopup","selectPlaceService","$cordovaBarcodeScanner","$ionicScrollDelegate"];

    function inspectionAttendanceController($scope, $http, $location, $state, $ionicModal, $filter, ynuiNotification, tkStorageService, $q, $ionicPopup,selectPlaceService,$cordovaBarcodeScanner,$ionicScrollDelegate) {

        $scope.selectPlace = selectPlace;
        $scope.filterStatus = filterStatus;
        $scope.saveUserDuty = saveUserDuty;
        $scope.confirmBatchSubmit = confirmBatchSubmit;
        $scope.saveScanUserDuty = saveScanUserDuty;
        $scope.cancelSaveUserDuty = cancelSaveUserDuty;
        $scope.sortList = sortList;
        $scope.doRefresh = doRefresh;

        var basePath = originBaseUrl;
        $scope.selectedKnob = null;
        $scope.tkBasicInfo = {
            termId: null, // 学期
            selectedTKDate: null, //听课日期
            week: null, //第几周
            day: null, //星期几,
            timeType: null, //时段类型,
            knob: null,
            tkDateDesc:null
        };
        //排序 1默认排序，2升序，3降序
        $scope.sortType = 1;

        $scope.hasTeacherTk = false;
        $scope.inTerm = true;

        function doRefresh() {
            // window.location.reload();
            findTermInfo();
        }

        function initSort() {
            if($scope.sortType == 1){
            }else if($scope.sortType == 2){
                $scope.teacherList = $filter('orderBy')($scope.teacherList, "buildName",false);
            }else{
                $scope.teacherList = $filter('orderBy')($scope.teacherList, "buildName",true);
            }
        }

        function sortList(){
            if($scope.sortType == 1){
                $scope.sortType = 2;
                $scope.teacherList = $filter('orderBy')($scope.teacherList, "buildName",false);
            }else if($scope.sortType == 2){
                $scope.sortType = 3;
                $scope.teacherList = $filter('orderBy')($scope.teacherList, "buildName",true);
            }else{
                $scope.sortType = 1;
            }
        }

        // 当前日期
        $scope.currentDate = "";

        function getNowDate() {
            return $http.get(basePath + "/third/tkTaskRegisterApp/getNowDate.htm")
              .success(function (data) {
                  if (data.status == 0) {
                      $scope.currentDate = data.result;
                      $scope.tkBasicInfo.selectedTKDate = data.result;
                  }
                  return data;
              });
        }

        /**根据日期获取周次*/
        var getWeekAndDay = function (termId, date) {
            getNowDate().success(function (data) {
                $http.post(basePath + "/third/tkTaskRegisterApp/queryWeekAddDate.htm?termId=" + termId + "&queryDate=" + $scope.currentDate).success(function (data) {
                    if (data.status == 0) {
                        $scope.tkBasicInfo.tkDateDesc = "";
                        if (data.result) {
                            $scope.tkBasicInfo.weekAndDayDesc = data.result.weekDateStr;
                            $scope.tkBasicInfo.week = data.result.week;
                            $scope.tkBasicInfo.day = data.result.date;
                            var weekDateStr = data.result.weekDateStr;
                            var splitIndex = weekDateStr.indexOf("周");
                            var weekStr = weekDateStr.substring(0, splitIndex + 1);
                            var dayStr = weekDateStr.substring(splitIndex + 1);
                            $scope.tkBasicInfo.tkDateDesc = "[今天]"+$scope.currentDate+" " + weekStr+" " + dayStr;
                            // initKnobData($scope.selectedKnob);
                        }else{
                            $scope.tkBasicInfo.tkDateDesc = "[今天]"+$scope.currentDate;
                        }
                    }else{
                        $scope.tkBasicInfo.tkDateDesc = "[今天]"+$scope.currentDate;
                    }
                })
            });
        };

        $scope.knobList = [];
        /**获取教学周历下的节次*/
        var getTKKnobList = function (termId) {
            var deferred = $q.defer();
            var promise = deferred.promise;
            $http.post(basePath + "/third/tkTaskRegisterApp/getTKKnobList.htm", {
                termId: termId
            }).success(function (data) {
                $scope.knobList = [];
                if (data.status == 0) {
                    if (data.result) {
                        $scope.knobList = data.result;
                        var i = 1;
                        angular.forEach($scope.knobList, function (item) {
                            item.sequence = i;
                            i++;
                        });
                        getCurrentTimeKnob(termId);
                    }
                }
                deferred.resolve($scope.knobList);
            });
            return promise;
        };

        /**获取当前时间节点的节次*/
        var getCurrentTimeKnob = function (termId) {
            $scope.tkBasicInfo.timeType = null;
            $scope.tkBasicInfo.knob = null;
            $http.post(basePath + "/third/tkOutsideTaskRegisterApp/getCurrentTimeKnob.htm", {
                termId: termId
            }).success(function (data) {
                if (data.status == 0) {
                    if (data.result) {
                        var index = 0;
                        angular.forEach($scope.knobList, function (item) {
                            if (item.timeType == data.result.timeType && item.knob == data.result.knob) {
                                $scope.selectedKnob = item;
                                initKnobData(item);
                            }
                            index++;
                        });
                    } else {
                        $scope.selectedKnob = $scope.knobList[0];
                        initKnobData($scope.selectedKnob);
                    }
                }
            });
        };

        $scope.isExist = null; // 是否存在教学周历
        // 学期
        $scope.term = null;
        $scope.termList = [];

        //获取学期信息
        function findTermInfo(){
            $http.post(basePath + "/third/tkOutsideTaskRegisterApp/getPreviousAndCurrentTermList.htm").success(function (data) {
                $scope.termList = [];
                $scope.term = null;
                if (data.status == 0) {
                    $scope.termList = data.result;
                    if ($scope.termList.length > 0) {
                        if ($scope.termList[0].currenTerm) {
                            $scope.term = $scope.termList[0];
                            $scope.tkBasicInfo.termIndex = 0;
                        }
                        $scope.isExist = $scope.term.existWeekCalendar;

                        getWeekAndDay($scope.term.termId, $scope.tkBasicInfo.selectedTKDate);
                    }
                }
            });
        }
        findTermInfo();



        $scope.date = {tempDate:""};
        /**监听学期改变，初始化听课日期*/
        $scope.$watch("term", function (newTerm, oldTerm) {
            if (newTerm !== oldTerm) {
                if (newTerm) {
                    $scope.tkBasicInfo.termId = newTerm.termId;
                    getNowDate().success(function () {
                        getTKKnobList(newTerm.termId).then(function () {
                            $scope.date.tempDate = $scope.currentDate;
                            if (newTerm.startDate <= $scope.currentDate && $scope.currentDate <= newTerm.endDate) {
                                $scope.inTerm = true;
                            } else {
                                $scope.inTerm = false;
                            }
                        });
                    })
                }
            }
        }, true);
        function initKnobData(obj){
            if(obj){
                $scope.tkBasicInfo.timeType = obj.timeType;
                $scope.tkBasicInfo.knob = obj.knob;
                findUserDuty();
                $scope.tkBasicInfo.selectedClassRoomName = null;
            }
        }

        $scope.selectKnob = function (index) {
            var obj = $scope.knobList[index];
            $scope.selectedKnob = obj;
            $scope.tkBasicInfo.timeType = obj.timeType;
            $scope.tkBasicInfo.knob = obj.knob;
            findUserDuty();
            $scope.tkBasicInfo.selectedClassRoomName = null;
        };

        $scope.canChooseRoom = false;

        var initTips = function () {
            return {
                isError: false,
                isNoData: false
            };
        };
        $scope.tips = initTips();

        $scope.selectClassRoomId  = "";
        $scope.selectBuildId = "";
        $scope.selectBuildKnobs = [];

        $scope.teacherList = [];
        $scope.teacherListTemp = [];

        $scope.numberObj = {
            all:0,
            daiQueren:0,
            notTk:0,
            tkEd:0
        };

        function findUserDutyByBuildFloor(buildId,floors) {
            var data = {date:$scope.tkBasicInfo.selectedTKDate,
                timeType:$scope.tkBasicInfo.timeType,
                knob:$scope.tkBasicInfo.knob,
                termId:$scope.tkBasicInfo.termId,
                systemId:"XT-S-004",
                menuId:"XT-S-004-M-024-006"};

            data.buildId = buildId;
            data.floors = floors;

            $http.post(basePath + "/third/tkPatrolListenUserDuty/findUserDutyByBuildFloor.htm",data).success(function (data) {
                if (data.status == 0) {
                    $scope.teacherList = data.result;
                    initTeacherStatusList($scope.teacherList);
                    $scope.teacherListTemp = angular.copy($scope.teacherList);
                    initNumberObj();
                    hasTeacherTk();
                    filterStatus($scope.filterType);
                }
            });
        }

        function findUserDutyByClassRoom(classRoomId) {
            var data = {date:$scope.tkBasicInfo.selectedTKDate,
                timeType:$scope.tkBasicInfo.timeType,
                knob:$scope.tkBasicInfo.knob,
                termId:$scope.tkBasicInfo.termId,
                systemId:"XT-S-004",
                menuId:"XT-S-004-M-024-006"};
            data.classRoomId = classRoomId;
            $http.post(basePath + "/third/tkPatrolListenUserDuty/findUserDutyByClassRoom.htm",data).success(function (data) {
                if (data.status == 0) {
                    $scope.teacherList = data.result;
                    initTeacherStatusList($scope.teacherList);
                    $scope.teacherListTemp = angular.copy($scope.teacherList);
                    initNumberObj();
                    hasTeacherTk();
                    filterStatus($scope.filterType);
                }
            });
        }

        function initTeacherStatusList(teacherList) {
            angular.forEach(teacherList,function (item) {
                if(item.listenStatus == null){
                    item.status = -1;
                }else{
                    item.status = item.listenStatus;
                }
            });
        }

        function findUserDuty() {
            var data = {date:$scope.tkBasicInfo.selectedTKDate,
                timeType:$scope.tkBasicInfo.timeType,
                knob:$scope.tkBasicInfo.knob,
                termId:$scope.tkBasicInfo.termId,
                systemId:"XT-S-004",
                menuId:"XT-S-004-M-024-006"
            };
            $http.post(basePath + "/third/tkPatrolListenUserDuty/findUserDuty.htm",data).success(function (data) {
                if (data.status == 0) {
                    $scope.teacherList = data.result;
                    initTeacherStatusList($scope.teacherList);
                    $scope.teacherListTemp = angular.copy($scope.teacherList);
                    initNumberObj();
                    initFilterType();
                    initSort();
                    hasTeacherTk();
                }
            });
        }

        function hasTeacherTk() {
            if($scope.teacherListTemp.length < 1){
                $scope.hasTeacherTk = false;
            }else{
                $scope.hasTeacherTk = true;
            }
        }

        function initFilterType() {
            if($scope.numberObj.daiQueren > 0){
                $scope.filterType = -1;
            }else{
                $scope.filterType = -2;
            }
            filterStatus($scope.filterType);
        }

        function initNumberObj() {
            $scope.numberObj.all = $scope.teacherListTemp.length;
            var daiQueren  = 0,notTk = 0,tkEd = 0;
            angular.forEach($scope.teacherListTemp,function (item) {
                if(item.listenStatus == null){
                    daiQueren++;
                }else if(item.listenStatus == 0){
                    notTk++;
                }else if(item.listenStatus == 1){
                    tkEd++;
                }
            });
            $scope.numberObj.daiQueren = daiQueren;
            $scope.numberObj.notTk = notTk;
            $scope.numberObj.tkEd = tkEd;
        }

        $scope.filterType = -2;
        function filterStatus(status) {
            $ionicScrollDelegate.$getByHandle('dashboardContent').scrollTop(false);
            if(status == -2){
                $scope.teacherList = angular.copy($scope.teacherListTemp);
            }else{
                var list = [];
                angular.forEach($scope.teacherListTemp,function (item) {
                    if(item.status == status){
                        list.push(item);
                    }
                });
                $scope.teacherList = angular.copy(list);
            }
            $scope.filterType = status;
            initSort();
        }

        function selectPlace(){
            var data = {date:$scope.tkBasicInfo.selectedTKDate,
                timeType:$scope.tkBasicInfo.timeType,
                knob:$scope.tkBasicInfo.knob,
                termId:$scope.tkBasicInfo.termId,
                systemId:"XT-S-004",
                menuId:"XT-S-004-M-024-006"};
            selectPlaceService.select(data,function (d) {
                if(d.type == 1){
                    $scope.selectBuildId = d.value.id;
                    $scope.selectBuildKnobs = d.value.knobs;
                    var arr = [];
                    for(var key in $scope.selectBuildKnobs) {
                        arr.push($scope.selectBuildKnobs[key]);
                    }
                    var order = $filter('orderBy')(arr, '');
                    $scope.tkBasicInfo.selectedClassRoomName =d.value.name+" "+buildStrByOrder(order)+"层";

                    findUserDutyByBuildFloor($scope.selectBuildId,arr);
                }else if(d.type == 2){
                    $scope.tkBasicInfo.selectedClassRoomName = d.value.name;
                    $scope.selectClassRoomId = d.value.id;
                    findUserDutyByClassRoom($scope.selectClassRoomId);
                }
            });
        }

        function buildStrByOrder(order) {
            var str = "";
            for(var i=0;i<order.length;i++){
                if(i == 0){
                    str += order[i];
                }else{
                    str= str+","+order[i];
                }
            }
            return str;
        }

        function templateInit() {
            $ionicModal.fromTemplateUrl('templates/register/common/saveUserDutyTemplate.html',{
                scope:$scope,
                animation:'slide-in-up'
            }).then(function(modal){
                $scope.saveUserDutyModal = modal;
            });

            $scope.showSaveUserDutyDialog = function (item) {

                $scope.saveUserDutyModalData = {
                    teacherName:item.teacherName,
                    mainOrgName:item.mainOrgName,
                    buildName:item.buildName,
                    courseName:item.courseName,
                    skUserNmae:item.skUserNmae,
                    listenStatus:item.listenStatus,
                    remarks:item.remarks,
                    id:item.id
                };
                $scope.saveUserDutyModal.show();
            };
            $scope.hideSaveUserDutyDialog = function () {
                $scope.saveUserDutyModal.hide();
            };
        }
        templateInit();

        function setItemInfo(data) {
            for(var i=0;i<$scope.teacherListTemp.length;i++){
                if($scope.teacherListTemp[i].id == data.id){
                    $scope.teacherListTemp[i].listenStatus = data.listenStatus;
                    $scope.teacherListTemp[i].status  = data.listenStatus;
                    $scope.teacherListTemp[i].remarks = data.remarks;
                    break;
                }
            }
        }

        function confirmBatchSubmit() {
            $ionicPopup.confirm({
                title: "提示",
                template: "选择节次查询结果所有未手动确认听课老师到岗情况的都按“<span style='color:green'>在听课</span>”进行提交！",
                cancelText: "取消",
                okText: "确定"
            }).then(function (res) {
                if (res) {
                    batchSubmitUserDuty();
                }
            });
        }

        function batchSubmitUserDuty() {
            var dataList = [];
            angular.forEach($scope.teacherListTemp,function (item) {
                if(item.listenStatus == null){
                    dataList.push({id:item.id,listenStatus:1,remarks:item.remarks});
                }
            });
            var d = {jsonStr:angular.toJson(dataList)};
            $http.post(basePath + "/third/tkPatrolListenUserDuty/saveMobileUserDuty.htm",d).success(function (data) {
                if (data.status == 0) {
                    findUserDuty();
                    ynuiNotification.success({msg: "操作成功！"});
                }
            });
        }

        function saveUserDuty() {
            var saveData = {id:$scope.saveUserDutyModalData.id,
                listenStatus:$scope.saveUserDutyModalData.listenStatus,
                remarks:$scope.saveUserDutyModalData.remarks};
            if(saveData.listenStatus == null){
                ynuiNotification.error({msg: "请选择听课老师到岗情况！"});
                return;
            }

            var d = {jsonStr:angular.toJson([saveData])};
            $http.post(basePath + "/third/tkPatrolListenUserDuty/saveMobileUserDuty.htm",d).success(function (data) {
                if (data.status == 0) {
                    setItemInfo(saveData);
                    filterStatus($scope.filterType);
                    initNumberObj();
                    ynuiNotification.success({msg: "操作成功！"});
                    $scope.hideSaveUserDutyDialog();
                }
            });
        }

        function initTeamplate() {
            $ionicModal.fromTemplateUrl('templates/register/code_teacher_list.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.codeTeacherListModal = modal;
            });
            $scope.showCodeTeacherListModal = function () {
                $scope.codeTeacherListModal.show();
            };

            $scope.hideCodeTeacherListModal = function () {
                $scope.codeTeacherListModal.hide();
            };
        }
        initTeamplate();

        $scope.scanObj = {
            date:"",
            knobName:"",
            buildName:"",
            teacherList:[],
            teacherListTemp:[]
        };

        function compareTeacherList(teacherList,teacherListTemp){
            for(var i=0;i<teacherList.length;i++){
                var iv = teacherList[i];
                for(var j=0;j<teacherListTemp.length;j++){
                    var jv = teacherListTemp[j];
                    if(iv.id == jv.id){
                        if(iv.listenStatus != jv.listenStatus || iv.remarks != jv.remarks){
                            return false;
                        }
                    }
                }
            }
            return true;
        }

        $scope.queryCode = function (){

            if(!$scope.tkBasicInfo.selectedTKDate || !$scope.tkBasicInfo.timeType || !$scope.tkBasicInfo.knob){
                ynuiNotification.error({msg: "请先选择节次！"});
                return;
            }
            $cordovaBarcodeScanner.scan().then(function (barcodeData) {

                if(!barcodeData || !barcodeData.text){
                    ynuiNotification.error({msg: "没有找到对应教室，请重新扫描教室二维码！"});
                    return;
                }
                var classRoom = JSON.parse(barcodeData.text);
                if(classRoom && classRoom.classRoomId){

                    var data = {date:$scope.tkBasicInfo.selectedTKDate,
                        timeType:$scope.tkBasicInfo.timeType,
                        knob:$scope.tkBasicInfo.knob,
                        termId:$scope.tkBasicInfo.termId,
                        systemId:"XT-S-004",
                        menuId:"XT-S-004-M-024-006"
                    };

                    data.classRoomId = classRoom.classRoomId;

                    $http.post(basePath + "/third/tkPatrolListenUserDuty/findUserDutyByClassRoomInfoScanCode.htm",data).success(function (data) {
                        if (data.status == 0) {

                            $scope.showCodeTeacherListModal();

                            var d = data.result;
                            $scope.scanObj.buildName  = d.buildName;
                            $scope.scanObj.courseName  = d.courseName;
                            $scope.scanObj.skTeacherName  = d.skTeacherName;

                            $scope.scanObj.teacherList = d.teacherList;
                            $scope.scanObj.teacherListTemp = angular.copy(d.teacherList);

                            $scope.scanObj.date  = $scope.tkBasicInfo.selectedTKDate;
                            $scope.scanObj.knobName  = $scope.selectedKnob.name;

                            angular.forEach($scope.scanObj.teacherList,function (item) {
                                item.up = false;
                            });
                        }else{
                            ynuiNotification.error({msg: data.message});
                        }
                    });
                }else {
                    ynuiNotification.error({msg: "没有找到对应教室，请重新扫描教室二维码！"});
                }
            }, function (error) {
                // ynuiNotification.error({msg: "扫描失败！"});
            });
        };

        function cancelSaveUserDuty() {
            var flag = compareTeacherList($scope.scanObj.teacherList,$scope.scanObj.teacherListTemp);
            if(!flag){
                $ionicPopup.confirm({
                    title: "提示",
                    template: "有数据未保存，是否放弃保存数据并返回？",
                    cancelText: "否",
                    okText: "是"
                }).then(function (res) {
                    if (res) {
                        $scope.hideCodeTeacherListModal();
                    }
                });
            }else{
                $scope.hideCodeTeacherListModal();
            }
        }

        function saveScanUserDuty(){
            var saveData = [];
            angular.forEach($scope.scanObj.teacherList,function (item) {
                saveData.push({id:item.id,listenStatus:item.listenStatus,remarks:item.remarks});
            });
            for(var i=0;i<saveData.length;i++){
                if(saveData[i].listenStatus == null){
                    ynuiNotification.error({msg: "请选择到岗情况！"});
                    return;
                }
            }
            var d = {jsonStr:angular.toJson(saveData)};
            $http.post(basePath + "/third/tkPatrolListenUserDuty/saveMobileUserDuty.htm",d).success(function (data) {
                if (data.status == 0) {
                    $scope.hideCodeTeacherListModal();
                    findUserDuty();
                    ynuiNotification.success({msg: "操作成功！"});
                }
            });
        }
    }

})();
