/**
 * 选择班级信息
 */
(function () {
    'use strict';

    angular
      .module('starter')
      .controller('tkChooseClassController', tkChooseClassController);

    tkChooseClassController.$inject = ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', '$location', "ynuiNotification",
        "tkStorageService"];

    function tkChooseClassController(
      $scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location, ynuiNotification, tkStorageService
    ) {

        // 登记方式
        var classType = $location.search().classType;
        var classRoom = angular.fromJson($location.search().classRoom);
        var classRoomId = null;
        if (classRoom) {
            classRoomId = classRoom.id;
        }
        var targetRoute = $location.search().targetRoute;

        /**
         * 路由信息
         * @type {string}
         */
        var basePath = originBaseUrl + "/third/xcMobileRecord";

        /**
         * 查询条件
         * @type {{gradeId: string, name: string}}
         */
        $scope.condition = {
            isQuery: false,
            pageNumber: 0,
            pageSize: 20,
            gradeId: "",
            name: "",
            selectedLength: 0,
            title: ""
        };

        $scope.gradeList = [];
        $scope.classList = [];
        $scope.selectClass = [];
        $scope.length = 0;
        $scope.seleectArr = [];

        /**
         * 查询年级
         */
        $scope.queryThreeGrade = function () {
            $scope.condition.isQuery = true;
            $scope.gradeList = [{
                id: "", name: "不限"
            }];
            $http.get(basePath + "/queryAllGrade.htm", {
                params: {
                    _timestamp: new Date().getTime()
                }
            }).success(function (data) {
                if (data.status == 0) {
                    $scope.condition.error = false;
                    var arr = data.result;
                    if (arr.length > 0) {
                        angular.forEach(arr, function (grade) {
                            $scope.gradeList.push(grade);
                        });
                        $scope.condition.gradeId = $scope.gradeList[0].id;
                        $scope.queryTeachClass(function () {
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                            $ionicScrollDelegate.scrollTop();
                            $ionicLoading.hide();
                        });
                    }
                } else {
                    $scope.condition.title = "获取班级失败";
                    $scope.condition.error = true;
                    $scope.condition.isQuery = false;
                }
            }).error(function () {
                $scope.condition.title = "获取班级失败";
                $scope.condition.error = true;
                $scope.condition.isQuery = false;
            })
        };

        /**
         * 查询班级
         */
          // var _items = tkStorageService.getItemNoDel("teachClass");
        var _items = [];
        var tkBasicInfo = tkStorageService.getItemNoDel("tkBasicInfo");

        $scope.queryTeachClass = function (fun) {
            $scope.condition.isQuery = true;
            $http.get(basePath + "/queryPKClassByPage.htm", {
                params: {
                    classType: classType,
                    classRoomId: classRoomId,
                    gradeId: $scope.condition.gradeId,
                    name: $scope.condition.name,
                    pageSize: $scope.condition.pageSize,
                    pageNumber: $scope.condition.pageNumber,
                    _timestamp: new Date().getTime()
                }
            }).success(function (data) {
                if (data.status == 0) {
                    var arr = data.result.content;
                    if (arr.length == 0) {
                        $scope.condition.title = "没有可选班级";
                        $scope.condition.error = false;
                    } else {
                        $scope.condition.error = false;
                        if (_items && _items.length > 0) {
                            angular.forEach(_items, function (clazz) {
                                clazz.selected = true;
                            });
                            $scope.seleectArr = _items;
                            $scope.length = $scope.seleectArr.length;
                            angular.forEach(arr, function (clazz) {
                                angular.forEach(_items, function (c) {
                                    if (c.id == clazz.id) {
                                        clazz.selected = true;
                                    }
                                });
                                $scope.classList.push(clazz);
                            });
                        } else {
                            angular.forEach(arr, function (cla) {
                                angular.forEach($scope.seleectArr, function (c) {
                                    if (c.id == cla.id) {
                                        cla.selected = true;
                                    }
                                });
                                $scope.classList.push(cla);
                            });
                        }
                        $scope.condition.pageSize = data.result.size;
                        $scope.condition.pageNumber = data.result.number;
                        $scope.condition.itemSize = data.result.totalElements;
                        $scope.condition.totalPage = data.result.totalPages;
                        $scope.classMore = $scope.condition && $scope.classList.length < $scope.condition.itemSize;
                    }
                } else {
                    $scope.condition.title = "获取班级失败";
                    $scope.condition.error = true;
                }
                $scope.condition.isQuery = false;
                if (fun) {
                    fun();
                }
            }).error(function () {
                $scope.condition.title = "获取班级失败";
                $scope.condition.error = true;
                $scope.condition.isQuery = false;
                if (fun) {
                    fun();
                }
            })
        };

        /**
         * 监控
         */
        $scope.$on('stateChangeSuccess', function () {
            $scope.loadMore();
        });

        /**
         * 加载更多
         */
        $scope.loadMore = function () {
            if ($scope.condition.pageNumber >= $scope.condition.totalPage) {
                return false;
            }
            $scope.condition.pageNumber = $scope.condition.pageNumber + 1;
            $scope.queryTeachClass(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                // $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };

        /**
         * 监控
         */
        $scope.initSelectClass = function () {
            $scope.classList = [];
            $scope.condition.pageNumber = 0;
            $scope.condition.pageSize = 20;
            $scope.queryTeachClass(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };

        /**
         * 选中年级
         */
        $scope.getSelectGrade = function (item) {
            $scope.condition.gradeId = item.id;
            $scope.condition.pageNumber = 0;
            $scope.condition.pageSize = 20;
            $scope.classList = [];
            $scope.queryTeachClass(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicScrollDelegate.scrollTop();
                $ionicLoading.hide();
            });
        };

        /**
         * 选择被选中的班级
         * @param item
         */
        $scope.getSelectClass = function (item) {
            item.selected = !item.selected;
            var count = 0;
            if (item.selected) {
                angular.forEach($scope.classList, function (_item) {
                    if (_item.selected && !$scope.seleectArr.some(function (obj) {
                        return obj.id == _item.id
                    })) {
                        $scope.seleectArr.push(item);
                        count++;
                    }
                });
            } else {
                $scope.deleteSelectClass(item);
            }
            $scope.length = $scope.seleectArr.length;
            $scope.condition.selectedLength = count;

        };

        /**
         * 删除选择的数据
         * @param index
         */
        $scope.deleteSelectClass = function (item) {
            item.selected = false;
            var index = -1;
            angular.forEach($scope.seleectArr, function (_item, _index) {
                if (item.id == _item.id) {
                    index = _index;
                }
            });
            if (index != -1) {
                var _item = $scope.seleectArr[index];
                angular.forEach($scope.classList, function (clazz) {
                    if (clazz.id == _item.id) {
                        clazz.selected = false;
                    }
                });
                $scope.seleectArr.splice(index, 1);
                $scope.length = $scope.seleectArr.length;
            } else {
                console.error("angular.forEach get the index error ,please check!")
            }
        };

        /**
         * 取消
         */
        $scope.cancel = function () {
            if(targetRoute){
                $location.path("/"+targetRoute).search({isChangeTeacher: false});
            }else{
                $location.path("/basic_msg").search({isChangeTeacher: false});
            }
        };

        /**
         * 完成选择
         */
        $scope.overSelectClass = function () {
            tkStorageService.setItem("teachClass", $scope.seleectArr);
            var classIds = [];
            var classNames = [];
            angular.forEach($scope.seleectArr, function (selected) {
                classIds.push(selected.id);
                classNames.push(selected.name);
            });
            tkBasicInfo.teachingAdminClassIdStr = classIds.join(',');
            tkBasicInfo.teachingAdminClassNameStr = classNames.join('，');
            tkStorageService.setItem("tkBasicInfo", tkBasicInfo);

            if(targetRoute){
                $location.path("/"+targetRoute).search({isChangeTeacher: false});
            }else{
                $location.path("/basic_msg").search({isChangeTeacher: false});
            }
        };

        /**
         * 清除输入的班级的名称
         */
        $scope.clearCondition = function () {
            $scope.condition.name = "";
        };

        $scope.queryThreeGrade(function () {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicScrollDelegate.scrollTop();
            $ionicLoading.hide();
        });

        /*查看已选班级浮动框*/
        $scope.isShowMoreCourse = false;
        $scope.selectClass_view = function () {
            $scope.isShowMoreCourse = !$scope.isShowMoreCourse;
        };
    }

})();
