/**
 * 登记任务外的听课结果的基本信息
 * Created by yineng on 2017/1/5 10:33
 *
 */
(function () {
    'use strict';

    angular
      .module('starter')
      .controller('tkReportController', tkReportController);

    tkReportController.$inject = ['$scope', '$http', '$location', '$state', '$ionicModal', "$filter", "ynuiNotification", "tkStorageService", "$q", "$ionicPopup","selectOrgService","selectScheduleService"];

    function tkReportController($scope, $http, $location, $state, $ionicModal, $filter, ynuiNotification, tkStorageService, $q, $ionicPopup,selectOrgService,selectScheduleService) {
        /**
         * 路由信息
         * @type {string}
         */
        var basePath = originBaseUrl;

        var isFromChooseTeacher = $location.search().isChooseTeacher;
        var isChangeTeacher = $location.search().isChangeTeacher;
        var isFromChooseClassRoom = $location.search().isFromChooseClassRoom;

        $scope.chooseWay = 1;
        $scope.selectTkType = selectTkType;
        $scope.changeOutFlag = changeOutFlag;


        $scope.outFlag = {
            teacher:false,
            course:false,
            place:false
        };

        function changeOutFlag(type) {
            if(type ==1){
                $scope.outFlag.teacher = !$scope.outFlag.teacher;

                $scope.tkBasicInfo.outTeacherName = "";
                $scope.tkBasicInfo.teacherId = "";
                $scope.tkBasicInfo.teacherName = "";

            }else if(type ==2){
                $scope.outFlag.course = !$scope.outFlag.course;

                $scope.tkBasicInfo.outCourseName = "";
                $scope.tkBasicInfo.courseId = "";
                $scope.tkBasicInfo.courseName = "";
            }else if(type == 3){
                $scope.outFlag.place = !$scope.outFlag.place;

                $scope.tkBasicInfo.outPlaceName = "";
                $scope.tkBasicInfo.selectedClassRoomName = "";
                $scope.tkBasicInfo.selectedClassRoomId = "";
            }
        }

        function initTemplate(){
            $ionicModal.fromTemplateUrl('template.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.modal = modal;
            });
            $scope.bottomModalClick = function () {
                $scope.modal.show();
            };
            $scope.closeModal = function () {
                $scope.modal.hide();
            };

            $ionicModal.fromTemplateUrl('tkTypeTemplate.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.tkTypeModel = modal;
            });

            $scope.closeTkTypeModal = function () {
                $scope.tkTypeModel.hide();
            };
            $scope.showTkTypeModal = function () {
                $scope.tkTypeModel.show();
            };
        }
        function selectTkType(item){
            $scope.tkBasicInfo.tkTypeCode = item.dictCode;
            $scope.tkBasicInfo.tkTypeCodeName = item.dictName;
            $scope.closeTkTypeModal();
        }


        $scope.tkBasicInfo = {
            termId: null, // 学期
            selectedTKDate: null, //听课日期
            week: null, //第几周
            day: null, //星期几,
            timeType: null, //时段类型,
            knob: null, //节次,
            endKnob: null,
            selectedKnobIndex: [],
            classRoomList: [],
            teacherId: null, // 授课教师ID
            selectedClassRoomName: null, //
            selectedClassRoomId: null, //
            selectedTableId: null, // 听课记录表ID
            selectedTableName: null,  // 听课记录表ID
            teachClassId: null,
            scheduleResultsId: null,
            courseName: null,
            courseId: null,
            tkDateDesc: null,
            teachingAdminClassNameStr: null,
            teachingAdminClassIdStr: null,
            sysOrgNameStr:null,
            sysOrgId:null,
            teacherName: null,
            termIndex: null,
            weekAndDayDesc: null,
            tkTypeCode:null,
            tkTypeCodeName:null,

            outTeacherName:null,
            outCourseName:null,
            outPlaceName:null
        };

        var isHaveCache = false;
        var oldConditon = tkStorageService.getItem("tkBasicInfo");
        if (oldConditon) {
            isHaveCache = true;
            $scope.tkBasicInfo = oldConditon;
            $scope.outFlag = tkStorageService.getItem("outFlag");
        }


        function initTeacherOrg(){
            $http.get(basePath + "/third/tkTaskRegisterApp/findMajorOrgByTeacherId.htm").success(function (data) {
                if (data.status == 0 && data.result != null) {
                    $scope.tkBasicInfo.sysOrgId = data.result.id;
                    $scope.tkBasicInfo.sysOrgNameStr = data.result.name;
                }
            });
        }
        $scope.tkTypeList = [];
        function initTkTypeCodeList(){
            $http.get(basePath + "/third/tkTaskRegisterApp/getTKTypeList.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.tkTypeList = data.result;
                }
            });
        }

        function init(){
            //初始化模板
            initTemplate();
            //初始化任务所属机构
            initTeacherOrg();
            //初始化听课类型
            initTkTypeCodeList();
        }
        init();

        // 当前日期
        $scope.currentDate = new Date();
        $scope.currentDate = $filter('date')($scope.currentDate, 'yyyy-MM-dd'); // 格式化

        function checkNumberLianxu(array){
            if(array.length <=1){
                return true;
            }
            array.sort();
            var flag=true;
            var temp=0;
            for(var i=0;i<array.length-1;i++){
                temp=array[i];
                if(parseInt(temp)+1!=parseInt(array[i+1])){
                    flag=false;
                }
            }
            return flag;
        }

        /**根据日期获取周次*/
        var getWeekAndDay = function (termId, date) {
            $http.post(basePath + "/third/tkTaskRegisterApp/queryWeekAddDate.htm?termId=" + termId + "&queryDate=" + date).success(function (data) {
                if (data.status == 0) {
                    $scope.tkBasicInfo.tkDateDesc = "";
                    if (data.result) {
                        $scope.tkBasicInfo.weekAndDayDesc = data.result.weekDateStr;
                        $scope.tkBasicInfo.week = data.result.week;
                        $scope.tkBasicInfo.day = data.result.date;
                        var weekDateStr = data.result.weekDateStr;
                        var splitIndex = weekDateStr.indexOf("周");
                        var weekStr = weekDateStr.substring(0, splitIndex + 1);
                        var dayStr = weekDateStr.substring(splitIndex + 1);
                        if ($scope.currentDate == $scope.date.tempDate) {
                            $scope.tkBasicInfo.tkDateDesc += "[今天]";
                        }
                        $scope.tkBasicInfo.tkDateDesc += $scope.date.tempDate;
                        $scope.tkBasicInfo.tkDateDesc += " " + weekStr;
                        $scope.tkBasicInfo.tkDateDesc += " " + dayStr;
                    }
                }
            })
        };


        $scope.knobList = [];
        /**获取教学周历下的节次*/
        var getTKKnobList = function (termId) {
            var deferred = $q.defer();
            var promise = deferred.promise;
            $http.post(basePath + "/third/tkTaskRegisterApp/getTKKnobList.htm", {
                termId: termId
            }).success(function (data) {
                $scope.knobList = [];
                if (data.status == 0) {
                    if (data.result) {
                        $scope.knobList = data.result;
                        var i = 1;
                        angular.forEach($scope.knobList, function (item) {
                            item.sequence = i;
                            i++;
                        });
                        // 如果没有缓存，则查询当前时间节点的节次
                        if (!isHaveCache) {
                            getCurrentTimeKnob(termId);
                        }
                    }
                }
                deferred.resolve($scope.knobList);
            });
            return promise;
        };

        /**获取当前时间节点的节次*/
        var getCurrentTimeKnob = function (termId) {
            $scope.tkBasicInfo.timeType = null;
            $scope.tkBasicInfo.knob = null;
            $http.post(basePath + "/third/tkOutsideTaskRegisterApp/getCurrentTimeKnob.htm", {
                termId: termId
            }).success(function (data) {
                if (data.status == 0) {
                    if (data.result) {
                        var index = 0;
                        angular.forEach($scope.knobList, function (item) {
                            if (item.timeType == data.result.timeType && item.knob == data.result.knob) {
                                $scope.tkBasicInfo.timeType = item.timeType;
                                $scope.tkBasicInfo.knob = item.knob;
                                $scope.tkBasicInfo.endKnob = item.knob;
                                $scope.tkBasicInfo.selectedKnobIndex.push(index);
                            }
                            index++;
                        });
                    } else {
                        $scope.tkBasicInfo.selectedKnobIndex.push(0);
                        $scope.tkBasicInfo.timeType = $scope.knobList[0].timeType;
                        $scope.tkBasicInfo.knob = $scope.knobList[0].knob;
                        $scope.tkBasicInfo.endKnob = $scope.knobList[0].knob;
                    }
                }
            });
        };


        $scope.isExist = null; // 是否存在教学周历
        // 学期
        $scope.term = null;
        $scope.termList = [];
        $http.post(basePath + "/third/tkOutsideTaskRegisterApp/getPreviousAndCurrentTermList.htm").success(function (data) {
            $scope.termList = [];
            $scope.term = null;
            if (data.status == 0) {
                $scope.termList = data.result;
                if ($scope.termList.length > 0) {
                    if (!isHaveCache) {
                        if ($scope.termList[0].currenTerm) {
                            $scope.term = $scope.termList[0];
                            $scope.tkBasicInfo.termIndex = 0;
                        }
                    } else {
                        angular.forEach($scope.termList, function (item) {
                            if (item.termId == $scope.tkBasicInfo.termId) {
                                $scope.term = item;

                            }
                        });
                    }
                    $scope.isExist = $scope.term.existWeekCalendar;
                }
            }
        });

        /**切换学期*/
        $scope.changeTerm = function () {
            if ($scope.tkBasicInfo.termIndex < $scope.termList.length - 1) {
                $scope.tkBasicInfo.termIndex++;
                $scope.term = $scope.termList[$scope.tkBasicInfo.termIndex];
            } else {
                $scope.tkBasicInfo.termIndex = 0;
                $scope.term = $scope.termList[$scope.tkBasicInfo.termIndex];
            }
            $scope.isExist = $scope.term.existWeekCalendar;
            isHaveCache = false;
            cleanData();
        };

        $scope.date = {tempDate:""};
        /**监听学期改变，初始化听课日期*/
        $scope.$watch("term", function (newTerm, oldTerm) {
            if (newTerm !== oldTerm) {
                if (newTerm) {
                    $scope.tkBasicInfo.termId = newTerm.termId;
                    getTKKnobList(newTerm.termId).then(function () {
                        if (!isHaveCache) {
                            // 如果当前日期在学期范围内则显示当前日期
                            if (newTerm.startDate <= $scope.currentDate && $scope.currentDate <= newTerm.endDate) {
                                $scope.date.tempDate = $scope.currentDate;
                            } else {
                                // 如果当前日期没在学期日期范围内，则默认显示请选择
                                $scope.tkBasicInfo.tkDateDesc = "";
                                $scope.date.tempDate = null;
                            }
                        } else {
                            $scope.date.tempDate = $scope.tkBasicInfo.selectedTKDate;
                        }
                    });
                }
            }
        }, true);

        /**验证所选日期是否在所选学期日期范围内*/
        var validateDateScope = function (selectedDate) {
            if (!($scope.term.startDate <= selectedDate && selectedDate <= $scope.term.endDate)) {
                $scope.tkBasicInfo.tkDateDesc = null;
                $scope.date.tempDate = null;
                ynuiNotification.error({msg: "只能选择在" + $scope.term.startDate + "~" + $scope.term.endDate + "之间的日期!"});
                return false;
            }
            return true;
        };

        /**监听听课日期，查询教学周历信息*/
        $scope.$watch("date.tempDate", function (newDate, oldDate) {
            if (newDate !== oldDate) {
                if (newDate) {
                    if (validateDateScope(newDate)) {
                        $scope.tkBasicInfo.selectedTKDate = newDate;
                        getWeekAndDay($scope.term.termId, $scope.tkBasicInfo.selectedTKDate);
                    }
                } else {
                    $scope.tkBasicInfo.selectedTKDate = null;
                }
            }
        });


        var cleanData = function () {
            $scope.tkBasicInfo.courseName = null;
            $scope.tkBasicInfo.courseId = null;
            $scope.tkBasicInfo.teachClassId = null;
            $scope.tkBasicInfo.scheduleResultsId = null;
            $scope.tkBasicInfo.teachingAdminClassNameStr = null;
            $scope.tkBasicInfo.teachingAdminClassIdStr = null;
            $scope.tkBasicInfo.buildAndClassRoomNameStr = null;
            $scope.tkBasicInfo.classRoomList = [];
            $scope.tkBasicInfo.selectedClassRoomName = null;
            $scope.tkBasicInfo.selectedClassRoomId = null;
            $scope.tkBasicInfo.teacherId = null;
            $scope.tkBasicInfo.teacherName = null;
        };

        $scope.selectKnob = function (index) {
            var obj = $scope.knobList[index];
            var selected = $scope.tkBasicInfo.selectedKnobIndex.indexOf(index);
            if (selected >= 0) {
                $scope.tkBasicInfo.selectedKnobIndex.splice(selected, 1);
            } else {
                if ($scope.tkBasicInfo.selectedKnobIndex.length > 0) {
                    var continuous = $scope.tkBasicInfo.knob + 1 === obj.knob || $scope.tkBasicInfo.knob - 1 === obj.knob
                      || $scope.tkBasicInfo.endKnob + 1 === obj.knob || $scope.tkBasicInfo.endKnob - 1 === obj.knob;
                    if ((null != $scope.tkBasicInfo.timeType && $scope.tkBasicInfo.timeType)
                      !== obj.timeType || !continuous) {
                        ynuiNotification.error({msg: "只能对上午/下午/晚上同段相邻节次进行多选！"});
                        return;
                    }
                }
                $scope.tkBasicInfo.selectedKnobIndex.push(index);
            }
            if ($scope.tkBasicInfo.selectedKnobIndex.length === 0) {
                $scope.tkBasicInfo.timeType = null;
                $scope.tkBasicInfo.knob = null;
                $scope.tkBasicInfo.endKnob = null;
                cleanData();
            } else {
                var order = $filter('orderBy')($scope.tkBasicInfo.selectedKnobIndex, '');
                $scope.tkBasicInfo.timeType = $scope.knobList[index].timeType;
                $scope.tkBasicInfo.knob = $scope.knobList[order[0]].knob;
                $scope.tkBasicInfo.endKnob = $scope.knobList[order[order.length - 1]].knob;
            }
            if($scope.tkBasicInfo.selectedKnobIndex.length > 0){
                if(!checkNumberLianxu($scope.tkBasicInfo.selectedKnobIndex)){
                    ynuiNotification.error({msg: "只能对上午/下午/晚上同段相邻节次进行多选！"});
                }else{
                    var postData = {
                        termId:$scope.term.termId,
                        date:$scope.date.tempDate,
                        timeType:$scope.tkBasicInfo.timeType,
                        knob:$scope.tkBasicInfo.knob,
                        endKnob:$scope.tkBasicInfo.endKnob
                    };
                    validateReport(postData);
                }
            }
        };
        function validateReport(postData){
            $http.post(originBaseUrl + "/third/tkTaskRegisterApp/validateTeacherReportDateTip.htm?", postData).success(function (data) {
                if(data.status == 0 && data.result != null){
                    ynuiNotification.error({msg: data.result});
                }else if(data.status == 0 &&  data.result == null){
                }
            });
        }


        /**选择教师*/
        $scope.chooseTeacher = function () {
            if($scope.tkBasicInfo.selectedKnobIndex.length < 1){
                ynuiNotification.error({msg: "请选择听课节次！"});
                return;
            }
            tkStorageService.setItem("tkBasicInfo", $scope.tkBasicInfo);
            tkStorageService.setItem("outFlag", $scope.outFlag);
            $location.path("/chooseTeacher").search({"type": 1,"targetRoute":"tk_report"});
        };

        /**获取教师课表中的课程信息*/
        var getScheduleDetailByTeacher = function () {
            $http.post(basePath + "/third/tkOutsideTaskRegisterApp/getScheduleDetailByTeacher.htm",
              $scope.tkBasicInfo
            ).success(function (data) {
                if (data.status == 0) {
                    var result = data.result;
                    if (result) {
                        $scope.tkBasicInfo.courseName = result.courseName;
                        $scope.tkBasicInfo.courseId = result.courseId;
                        $scope.tkBasicInfo.teachClassId = result.teachClassId;
                        $scope.tkBasicInfo.scheduleResultsId = result.scheduleResultsId;
                        $scope.tkBasicInfo.teachingAdminClassNameStr = result.teachingAdminClassNameStr;
                        $scope.tkBasicInfo.teachingAdminClassIdStr = result.teachingAdminClassIdStr;
                        $scope.tkBasicInfo.buildAndClassRoomNameStr = result.buildAndClassRoomNameStr;
                        $scope.tkBasicInfo.classRoomList = result.classRoomList;
                        if(result.courseId){
                            $scope.outFlag.course = false;
                        }
                    }
                    // 如果有教室
                    if ($scope.tkBasicInfo.classRoomList.length > 0) {
                        $scope.tkBasicInfo.selectedClassRoomName = $scope.tkBasicInfo.classRoomList[0].name;
                        $scope.tkBasicInfo.selectedClassRoomId = $scope.tkBasicInfo.classRoomList[0].id;
                        $scope.tkBasicInfo.selectedClassRoomIndex = 0;
                        if($scope.tkBasicInfo.selectedClassRoomId){
                            $scope.outFlag.place = false;
                        }
                    } else {
                        $scope.tkBasicInfo.selectedClassRoomName = null;
                        $scope.tkBasicInfo.selectedClassRoomId = null;
                    }
                }
            });
        };

        // 如果从选择授课教师页面跳转回来，则按授课教师查询课表信息
        if (isFromChooseTeacher) {
            if (isChangeTeacher) {
                getScheduleDetailByTeacher();
            }
        }


        /**切换教室*/
        $scope.changeClassRoom = function () {

            var listLength = $scope.tkBasicInfo.classRoomList.length;
            var index = $scope.tkBasicInfo.selectedClassRoomIndex;
            // 如果不是最后一个，则选中下一个
            if (index != listLength - 1) {
                index += 1;
                $scope.tkBasicInfo.selectedClassRoomName = $scope.tkBasicInfo.classRoomList[index].name;
                $scope.tkBasicInfo.selectedClassRoomId = $scope.tkBasicInfo.classRoomList[index].id;
                $scope.tkBasicInfo.selectedClassRoomIndex = index;
            } else {
                // 如果是最后一个，则选中第一个
                $scope.tkBasicInfo.selectedClassRoomName = $scope.tkBasicInfo.classRoomList[0].name;
                $scope.tkBasicInfo.selectedClassRoomId = $scope.tkBasicInfo.classRoomList[0].id;
                $scope.tkBasicInfo.selectedClassRoomIndex = 0;
            }
        };
        $scope.canChooseRoom = false;
        if (isFromChooseClassRoom) {
            $scope.canChooseRoom = true;
        }

        //选择任务所属机构
        $scope.chooseTaskOrg = function(){
            selectOrgService.singleSelect(function (item) {
                $scope.tkBasicInfo.sysOrgId = item.id;
                $scope.tkBasicInfo.sysOrgNameStr = item.name;
            });
        };

        /**改变日期*/
        $scope.selectedDate = function (data) {
            if (validateDateScope(data)) {
                $scope.date.tempDate = data;
                getWeekAndDay($scope.term.termId, $scope.date.tempDate);
            } else {
                $scope.date.tempDate = "";
            }
            cleanData();
        };

        $scope.chooseKb = function(){
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            }
            selectScheduleService.select(function (items) {

                console.log(items);
                var tkInfo = null;
                $scope.tkBasicInfo.selectedKnobIndex = [];
                for(var i=0;i<items.length;i++){
                    var item = items[i];
                    //节次
                    $scope.tkBasicInfo.selectedKnobIndex.push((item.knobIndex));
                    if(i == 0){
                        tkInfo = item;
                    }
                }
                $scope.tkBasicInfo.timeType = items[0].timeType;
                $scope.tkBasicInfo.knob = items[0].knob;
                $scope.tkBasicInfo.endKnob = items[items.length-1].knob;

                //日期
                $scope.selectedDate(tkInfo.dateStr);
                //教师
                var teacher = tkInfo.teacherList[0];
                $scope.tkBasicInfo.teacherId   = teacher.id;
                $scope.tkBasicInfo.teacherName = teacher.name;
                //课程
                $scope.tkBasicInfo.courseName = tkInfo.courseName;
                $scope.tkBasicInfo.courseId   = tkInfo.courseId;
                //授课地点
                if(tkInfo.classRoomList.length > 0){
                    var classRoom = tkInfo.classRoomList[0];
                    $scope.tkBasicInfo.selectedClassRoomName = classRoom.name;
                    $scope.tkBasicInfo.selectedClassRoomId = classRoom.id;
                }
                $scope.tkBasicInfo.teachingAdminClassNameStr = tkInfo.teachingAdminClassNameStr;
                $scope.tkBasicInfo.teachingAdminClassIdStr = tkInfo.teachingAdminClassIdStr;

                $scope.tkBasicInfo.teachClassId = tkInfo.teachClassId;

                $scope.chooseWay = 0;

                var postData = {
                    termId:$scope.term.termId,
                    date:$scope.date.tempDate,
                    timeType:$scope.tkBasicInfo.timeType,
                    knob:$scope.tkBasicInfo.knob,
                    endKnob:$scope.tkBasicInfo.endKnob
                };
                validateReport(postData);

            });
        };

        /**选择教室*/
        $scope.chooseClassRoom = function () {
            // 如果未先选择授课教师，则提示
            if (!$scope.tkBasicInfo.teacherName) {
                ynuiNotification.error({msg: "请先选择授课教师！"});
                return;
            }
            tkStorageService.setItem("tkBasicInfo", $scope.tkBasicInfo);
            tkStorageService.setItem("outFlag", $scope.outFlag);
            $location.path("/classroomClassify").search({"targetRoute":"tk_report"});
        };

        /**
         * 选择课程
         */
        $scope.chooseCourses = chooseCourses;
        function chooseCourses() {
            if (!$scope.tkBasicInfo.teacherName) {
                ynuiNotification.error({msg: "请先选择授课教师！"});
                return;
            }
            tkStorageService.setItem("tkBasicInfo", $scope.tkBasicInfo);
            tkStorageService.setItem("outFlag", $scope.outFlag);
            $location.path("/tkChooseCourses").search({"targetRoute":"tk_report"});
        }

        /**
         * 选择班级
         */
        $scope.chooseClass = chooseClass;
        function chooseClass() {
            if (!$scope.tkBasicInfo.teacherName) {
                ynuiNotification.error({msg: "请先选择授课教师！"});
                return;
            }
            tkStorageService.setItem("tkBasicInfo", $scope.tkBasicInfo);
            tkStorageService.setItem("outFlag", $scope.outFlag);
            $location.path("/tkChooseClass").search({"targetRoute":"tk_report"});
        }

        var initTips = function () {
            return {
                isError: false,
                isNoData: false
            };
        };
        $scope.tips = initTips();

        $scope.tableList = [];
        var getTable = function () {
            $http.post(basePath + "/third/tkTaskRegisterApp/getTKTableDown.htm")
              .success(function (data) {
                  if (data.status == 0) {
                      $scope.tableList = data.result;
                      if ($scope.tableList.length > 0) {
                          if (!isHaveCache) {
                              $scope.tkBasicInfo.selectedTableId = $scope.tableList[0].id;
                              $scope.tkBasicInfo.selectedTableName = $scope.tableList[0].name;
                          }
                      } else {
                          $scope.tips.isNoData = true;
                      }
                  } else {
                      $scope.tips.isError = true;
                  }
              })
              .error(function () {
                  $scope.tips.isError = true;
              });
        };
        getTable();


        /**选中记录表*/
        $scope.selectTable = function (item) {
            $scope.tkBasicInfo.selectedTableId = item.id;
            $scope.tkBasicInfo.selectedTableName = item.name;
            $scope.closeModal();
        };

        /**取消*/
        $scope.cancle = function () {
            if (!$scope.isExist) {
                $location.path("/register_task");
            } else {
                var confirmPopup = $ionicPopup.confirm({
                    title: "提示",
                    template: '确定要放弃当前编辑内容吗？',
                    cancelText: "继续编辑",
                    okText: "放弃"
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        tkStorageService.clearKey("tkBasicInfo");
                        tkStorageService.clearKey("allItemVOList");
                        tkStorageService.clearKey("teachClass");
                        $location.path("/register_task");
                    }
                });
            }

        };

        /**下一步*/
        $scope.nextStep = function () {
            //1.必传参数验证
            if (!$scope.tkBasicInfo.termId) {
                ynuiNotification.error({msg: "请选择学期！"});
                return;
            }
            if (!$scope.tkBasicInfo.selectedTKDate) {
                ynuiNotification.error({msg: "请选择听课日期！"});
                return;
            }
            if (!$scope.tkBasicInfo.knob) {
                ynuiNotification.error({msg: "请选择听课节次！"});
                return;
            }
            if(!checkNumberLianxu($scope.tkBasicInfo.selectedKnobIndex)){
                ynuiNotification.error({msg: "只能对上午/下午/晚上同段相邻节次进行多选！"});
                return;
            }
            if (!$scope.tkBasicInfo.teacherName) {
                ynuiNotification.error({msg: "请选择授课教师！"});
                return;
            }
            if (!$scope.tkBasicInfo.courseName) {
                ynuiNotification.error({msg: "请选择课程！"});
                return;
            }
            if (!$scope.tkBasicInfo.selectedClassRoomName) {
                ynuiNotification.error({msg: "请选择授课地点！"});
                return;
            }
            if(!$scope.tkBasicInfo.tkTypeCode){
                ynuiNotification.error({msg: "请选择听课类型！"});
                return;
            }
            if (!$scope.tkBasicInfo.selectedTableId) {
                ynuiNotification.error({msg: "请选择听课记录表！"});
                return;
            }
            if(!$scope.tkBasicInfo.sysOrgId){
                ynuiNotification.error({msg: "请选择任务所属机构！"});
                return;
            }

            var obj = {
                platformSysTermId:$scope.tkBasicInfo.termId,
                tkTypeCode:$scope.tkBasicInfo.tkTypeCode,
                tableId:$scope.tkBasicInfo.selectedTableId,
                chooseWay:$scope.chooseWay,
                skSysUserId:$scope.tkBasicInfo.teacherId,
                platformSysClassRoomId:$scope.tkBasicInfo.selectedClassRoomId,
                date:$scope.date.tempDate,
                week:$scope.tkBasicInfo.week,
                day:$scope.tkBasicInfo.day,
                dateWeekDay:$scope.tkBasicInfo.weekAndDayDesc,
                timeType:$scope.tkBasicInfo.timeType,
                knob:$scope.tkBasicInfo.knob,
                endKnob: $scope.tkBasicInfo.endKnob,
                kcCourseId:$scope.tkBasicInfo.courseId,
                teachingAdminClassIdStr:$scope.tkBasicInfo.teachingAdminClassIdStr,
                pkTeachClassId:$scope.tkBasicInfo.teachClassId,
                taskOrgNo: $scope.tkBasicInfo.sysOrgId,
                taskType:0
            };

            obj.outSchoolTeacherName = $scope.tkBasicInfo.teacherName;
            obj.courseName = $scope.tkBasicInfo.courseName;
            obj.platformSysClassRoomName = $scope.tkBasicInfo.selectedClassRoomName;

            $http.post(basePath + "/third/tkTaskRegisterApp/addTkTaskByTeacher.htm?",obj).success(function (data) {
                if (data.status == 0) {
                    $location.path("/register_task");
                }else{
                    ynuiNotification.error({msg: data.message});
                }
            })
        };
    }

})();
