/**
 * 迎新报到
 *
 * @author qiucheng Lu
 * @date 2021年4月15日13:41:41
 */
(function () {
    angular.module('starter')
        .config(config)
        .controller("reportHomeController", reportHomeController)
        .controller("singleStudentReportController", singleStudentReportController)
        .controller("classReportController", classReportController)
        .controller("majorReportController", majorReportController);

    config.$inject = ['$stateProvider'];

    function config($stateProvider) {
        $stateProvider
            /*按班级报到登记*/
            .state('class_report', {
                url: '/class_report',
                templateUrl: 'templates/report/report_home.html',
                cache: false,
                controller:'reportHomeController',
                data: {
                    prev: 'workspaceForTeacher',
                    title: "迎新报到"
                }
            });
    }

    reportHomeController.$inject = ['$scope', '$location'];

    function reportHomeController($scope, $location) {
        var classId = $location.search().classId;
        //初始化选项卡
        $scope.tabRepeat = [
            {id: "1", name: "单个学生登记", active: true},
            {id: "2", name: "按班级登记", active: false},
            {id: "3", name: "按专业登记", active: false}
        ];
        //点击选项卡
        $scope.clickTab = function (index) {
            $scope.activeKey = index;
            angular.forEach($scope.tabRepeat, function (value) {
                value.active = false;
                if (value.id == index) {
                    value.active = true;
                }
            })
        };
        //初始化选中效果
        var defActive = "1";
        $scope.clickTab(null != classId ? '2' : defActive);
    }

    singleStudentReportController.$inject = ['$scope', '$http', '$location', 'ynuiNotification', 'storageService', '$ionicModal', '$ionicPopup','ynNavigator'];

    function singleStudentReportController ($scope, $http, $location, ynuiNotification, storageService, $ionicModal, $ionicPopup,ynNavigator) {
        var vm = this;
        // 路由信息
        var basePath = originBaseUrl + "/third/bdglMobileReport";

        $scope.showFlagInfo = null;
        // 学生搜索条件
        $scope.stuSearch = {name: ""};
        //登记学生报到
        $scope.registerStudentReportFlag = false;

        // 登记学生报到
        $scope.goDetail = function (info, item) {
            storageService.clearKey("selectClassInfo");
            var param = {
                reportType: 0
            };
            if (item) {
                param.name = item.name;
                param.ticketNumber = item.ticketNumber;
                param.credentialNumber = item.credentialNumber;
            }else {
                if (!info && '0' !== 0) {
                    ynuiNotification.error({msg: "请输入姓名/证件号/准考证号！"});
                    return false;
                }
                param.nameOrNumber = info;
            }
            $http.post(basePath + "/queryRegistReportStudentWithHeadmaster.htm", param).success(function (data) {
                if (data.status == 0) {
                    if (data.result && data.result.length > 0) {
                        if (data.result.length == 1) {
                            $scope.studentDetailShow = angular.copy(data.result[0]);
                            if ($scope.studentDetailShow.adminClassName == '未分班') {
                                $scope.studentDetailShow.adminClassName = '请选择报到班级';
                                // 获取报到班级 默认
                                $http.post(basePath + "/findReportClassWithHeadmaster.htm").success(function (result) {
                                    if (result.status == 0 && result.result && result.result.length > 0) {
                                        // 录取专业不在班主任负责范围内不允许报到
                                        var flag = false;

                                        angular.forEach(result.result, function (value) {
                                            if (value.platformSysSpecialtyVOList &&
                                                value.platformSysSpecialtyVOList.length === 1 &&
                                                value.platformSysSpecialtyVOList[0].id == $scope.studentDetailShow.admSpecialtyId) {
                                                $scope.studentDetailShow.specialtyId = $scope.studentDetailShow.admSpecialtyId;
                                                $scope.studentDetailShow.reportAdminClassId = value.adminClassId;
                                                $scope.studentDetailShow.adminClassName = value.adminClassName;

                                                var selectClassInfo = {
                                                    reportClassId: $scope.studentDetailShow.reportAdminClassId,
                                                    specialtyId: $scope.studentDetailShow.specialtyId
                                                };
                                                storageService.setItem("selectClassInfo", selectClassInfo);
                                                flag = true;
                                            } else {
                                                angular.forEach(value.platformSysSpecialtyVOList, function (val) {
                                                    if (val.id == $scope.studentDetailShow.admSpecialtyId) {
                                                        flag = true;
                                                    }
                                                });
                                            }

                                        });

                                        if (!flag) {
                                            var confirmPopup = $ionicPopup.alert({
                                                title: "提示",
                                                template: "该学生的录取专业不在您负责的行政班对应的专业方向中，您不能为该学生做报到！",
                                                okText: "取消"
                                            });
                                            confirmPopup.then(function () {
                                                $scope.cancelDetail(true);
                                            });
                                        }

                                    }
                                });
                            } else {
                                // 获取报到班级 默认
                                $http.post(basePath + "/findReportClassWithHeadmaster.htm").success(function (result) {
                                    if (result.status == 0 && result.result && result.result.length > 0) {
                                        // 录取专业不在班主任负责范围内不允许报到
                                        var flag = false;

                                        angular.forEach(result.result, function (value) {
                                            angular.forEach(value.platformSysSpecialtyVOList, function (val) {
                                                if (val.id == $scope.studentDetailShow.admSpecialtyId) {
                                                    flag = true;
                                                }
                                            });

                                        });

                                        if (!flag) {
                                            $scope.studentDetailShow.reportAdminClass = '请选择报到班级';
                                            $scope.studentDetailShow.reportAdminClassId = null;
                                            storageService.clearKey("selectClassInfo");
                                        } else {
                                            if ($scope.studentDetailShow.dormitoryTypeName != null
                                                && $scope.studentDetailShow.dormitoryTypeName !== '不住宿') {
                                                getStuDefaultBed($scope.studentDetailShow.reportAdminClassId);
                                            }
                                        }

                                    }
                                });
                            }
                            // 报到班级
                            if ($scope.studentDetailShow.specialtyId && $scope.studentDetailShow.reportAdminClassId) {
                                var selectClassInfo = {
                                    reportClassId: $scope.studentDetailShow.reportAdminClassId,
                                    specialtyId: $scope.studentDetailShow.specialtyId
                                };
                                storageService.setItem("selectClassInfo", selectClassInfo);
                            }
                            $scope.registerStudentReportFlag = true;
                            ynNavigator.registerBackAction(function () {
                                $scope.cancelDetail();
                            },101);
                            $scope.studentDetailList = [];
                            if (item) {
                                $scope.studentDetailShow.showName = item.showName;
                            } else {
                                // 姓名显示
                                var showName = $scope.studentDetailShow.name;
                                if ($scope.studentDetailShow.gender) {
                                    if ($scope.studentDetailShow.nation) {
                                        showName += "(" + $scope.studentDetailShow.gender + "，" + $scope.studentDetailShow.nation + ")";
                                    } else {
                                        showName += "(" + $scope.studentDetailShow.gender + ")";
                                    }
                                } else {
                                    showName += "(" + $scope.studentDetailShow.nation + ")";
                                }
                                $scope.studentDetailShow.showName = showName;
                            }
                        } else {
                            $scope.registerStudentReportFlag = false;
                            $scope.studentDetailList = data.result;
                            angular.forEach($scope.studentDetailList, function (info) {
                                // 姓名显示
                                var showName = info.name;
                                if (info.gender) {
                                    if (info.nation) {
                                        showName += "(" + info.gender + "，" + info.nation + ")";
                                    } else {
                                        showName += "(" + info.gender + ")";
                                    }
                                } else {
                                    showName += "(" + info.nation + ")";
                                }
                                info.showName = showName;
                            });
                        }
                    } else {
                        $scope.studentDetailList = [];
                        $scope.studentDetailShow = {};
                    }
                } else {
                    ynuiNotification.error({msg: "获取学生信息失败！"});
                }
            });

        };

        // 住宿意向弹窗
        var studentAccommodationConfig = {
            templateUrl: 'templates/report/dialog/studentAccommodation.html',
            cssClass: 'popup-head-none',
            title: '',
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>确定</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        var saveInfo = {
                            stuId: storageService.getItem("stuId"),
                            flag: $scope.isStay,
                            isStay: $scope.dormitoryInfo.isStay,
                            dormitoryType: $scope.dormitoryInfo.dormitoryType
                        };
                        $http.post(basePath + "/updateStudentAccommodation.htm", saveInfo).success(function (data) {
                            if (data.status == 0) {
                                $scope.goDetail($scope.stuSearch.name, $scope.studentDetailShow);
                            } else {
                                e.preventDefault();
                                ynuiNotification.error({msg: "操作失败！"});
                                return false;
                            }
                        });
                    }
                }
            ]
        };

        // 调整住宿意向为不住宿时是否清空学生床位
        function findSystemPublicConfig() {
            return $http.post(basePath + "/findSystemPublicConfig.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.isStay = data.result.flag;
                    $scope.voList = angular.copy(data.result.voList);
                    if ($scope.voList && $scope.voList.length > 0) {
                        $scope.voList.unshift({name: "请选择住宿意向", id: ""});
                    } else {
                        $scope.voList = [{name: "请选择住宿意向", id: ""}];
                    }
                    return data;
                }
            });
        }

        // 修改住宿意向
        $scope.dormitoryChoose = function (info) {
            storageService.setItem("stuId", info.userId);
            $scope.dormitoryInfo = {
                isStay: false,
                stuId: info.userId,
                dormitoryType: "",
                dormitoryTypeName: "请选择住宿意向"
            };
            $scope.isStay = false;
            findSystemPublicConfig().then(function () {
                // 获取学生住宿意向
                $http.post(basePath + "/findStudentAccommodation.htm", {stuId: info.userId}).success(function (data) {
                    if (data.status == 0) {
                        $scope.dormitoryInfo.isStay = data.result.isStay;
                        if (data.result.id) {
                            $scope.dormitoryInfo.dormitoryType = data.result.id;
                            angular.forEach($scope.voList, function (val) {
                                if (val.id == $scope.dormitoryInfo.dormitoryType) {
                                    $scope.dormitoryInfo.dormitoryTypeName = val.name;
                                }
                            });
                        }
                        $scope.dormitoryInfo.showInfo = data.result.showInfo;
                        $scope.dormitoryInfo.showName = data.result.showName;
                    }
                });
            });
            $ionicPopup.show(studentAccommodationConfig);
        };


        // 确认为已报到
        $scope.report = function (info) {
            var old = storageService.getItemNoDel("selectClassInfo");
            if (!old) {
                ynuiNotification.error({msg: "请选择报到班级！"});
                return false;
            }
            var param = {
                appStuId: info.userId,
                thenClassId: info.adminClassId,
                specialtyId: old.specialtyId,
                reportClassId: old.reportClassId,
                roomId: info.dormitoryId,
                bedId: info.bedId
            };
            $http.post(basePath + "/registReportStudentWithHeadMaster.htm", param).success(function (data) {
                if (data.status == 0) {
                    storageService.clearKey("selectClassInfo");
                    $scope.isClassAffirmReport = false;
                    ynuiNotification.success({msg: "报到成功！"});
                    $scope.registerStudentReportFlag = false;
                    $scope.stuSearch = {name: ""};
                    $scope.studentDetailList = [];
                    // 刷新数据
                    vm.rooms = null;
                    vm.beds = null;
                    vm.selectRoomId = null;
                    vm.selectedBed = null;
                    $scope.studentDetailShow.dormitoryId = null;
                    $scope.studentDetailShow.dormitoryName = null;
                    $scope.studentDetailShow.bedId = null;
                    $scope.studentDetailShow.bedName = null;
                } else {
                    ynuiNotification.error({msg: data.message});
                }
            });

        };


        // 选中报到班级
        $scope.getSelectClass = function (item) {
            if (item.platformSysSpecialtyVOList && item.platformSysSpecialtyVOList.length == 1) {
                var selectClassInfo = {
                    reportClassId: item.adminClassId,
                    specialtyId: item.platformSysSpecialtyVOList[0].id
                };
                $scope.studentDetailShow.reportAdminClass = item.adminClassName;
                $scope.studentDetailShow.reportAdminClassId = selectClassInfo.reportClassId;
                $scope.studentDetailShow.specialtyId = selectClassInfo.specialtyId;
                storageService.setItem("selectClassInfo", selectClassInfo);
                $scope.closeSelectClassModal();
                // 重新获取宿舍
                if ($scope.studentDetailShow.dormitoryTypeName != null
                    && $scope.studentDetailShow.dormitoryTypeName !== '不住宿') {
                    getStuDefaultBed(item.adminClassId);
                } else {
                    vm.rooms = null;
                    vm.beds = null;
                    vm.selectRoomId = null;
                    vm.selectedBed = null;
                    $scope.studentDetailShow.dormitoryId = null;
                    $scope.studentDetailShow.dormitoryName = null;
                    $scope.studentDetailShow.bedId = null;
                    $scope.studentDetailShow.bedName = null;
                }
            }

        };

        // 选中报到班级、专业
        $scope.getSelectClassAndSpecialty = function (item, val) {
            var selectClassInfo = {
                reportClassId: item.adminClassId,
                specialtyId: val.id
            };
            $scope.studentDetailShow.reportAdminClass = item.adminClassName;
            $scope.studentDetailShow.reportAdminClassId = selectClassInfo.reportClassId;
            $scope.studentDetailShow.specialtyId = selectClassInfo.specialtyId;
            storageService.setItem("selectClassInfo", selectClassInfo);
            $scope.closeSelectClassModal();
            // 重新获取宿舍
            if ($scope.studentDetailShow.dormitoryTypeName != null
                && $scope.studentDetailShow.dormitoryTypeName !== '不住宿') {
                getStuDefaultBed(item.adminClassId);
            } else {
                vm.rooms = null;
                vm.beds = null;
                vm.selectRoomId = null;
                vm.selectedBed = null;
                $scope.studentDetailShow.dormitoryId = null;
                $scope.studentDetailShow.dormitoryName = null;
                $scope.studentDetailShow.bedId = null;
                $scope.studentDetailShow.bedName = null;
            }
        };


        // 登记学生报到 取消
        $scope.cancelDetail = function (f) {
            delete $scope.studentDetailShow;
            $scope.registerStudentReportFlag = false;
            if (!f) {
                $scope.stuSearch.name = "";
            }
            vm.rooms = null;
            vm.beds = null;
            vm.selectRoomId = null;
            vm.selectedBed = null;
            ynNavigator.cancelBackAction(101);
            setTimeout(function () {
               $scope.$apply();
            });
        };
        // 清除搜索条件
        $scope.clearSearch = function () {
            $scope.stuSearch = {name: ""};
            $scope.studentDetailList = [];
            $scope.studentDetailShow = {};
        };

        // 获取班主任负责的报到任务的状态
        $scope.getReportTaskStateWithHeadmaster = function () {
            $http.post(basePath + "/getReportTaskStateWithHeadmaster.htm", {reportType: 0}).success(function (data) {
                if (data.status == 0) {
                    $scope.showFlagInfo = angular.copy(data.result);
                } else {
                    ynuiNotification.error({msg: "获取班主任负责的报到任务的状态失败！"});
                }
            });
        };

        $scope.getStatusClass = function (status, flag) {
            if (flag) {
                if (status == '已报到') {
                    return 'button-label';
                } else if (status == '未报到') {
                    return 'label-orange button-label';
                } else if (status == '待确认报到状态') {
                    return 'label-yellow button-label';
                }
            } else {
                if (status == 0) {
                    return 'button-label margin-left-10';
                } else if (status == 1) {
                    return 'label-orange button-label margin-left-10';
                } else {
                    return 'label-yellow button-label margin-left-10';
                }
            }

        };

        $scope.getReportStrClass = function (status) {
            if (status && status.indexOf('已报到') > -1) {
                return 'button-label';
            } else if (status && status.indexOf('未报到') > -1) {
                return 'label-orange button-label';
            }
        };

        $scope.getReportTaskStateWithHeadmaster();

        $scope.parentActive = function (info) {
            var selectedClassid = storageService.getItemNoDel("selectedClassid");
            if (info.adminClassId == selectedClassid && info.platformSysSpecialtyVOList && info.platformSysSpecialtyVOList.length <= 1) {
                return 'calm';
            }
        };

        $scope.getChildActive = function (info) {
            var selectedClassid = storageService.getItemNoDel("selectedClassid");
            if (info.adminClassId == selectedClassid && info.platformSysSpecialtyVOList && info.platformSysSpecialtyVOList.length > 1) {
                return 'calm';
            }
        };

        $scope.getChildrenActive = function (info, item) {
            var selectedClassid = storageService.getItemNoDel("selectedClassid"),
                specialtyId = storageService.getItemNoDel("specialtyId");
            if (info.id == specialtyId && item.adminClassId == selectedClassid) {
                return 'calm';
            }
        };

        // 住宿类型样式选中处理
        $scope.getDormitoryInfoActive = function (info) {
            if (info.id == $scope.dormitoryInfo.dormitoryType) {
                return 'active';
            }
        };

        // 住宿类型选中处理
        $scope.getDormitoryInfoSelect = function (info) {
            $scope.dormitoryInfo.dormitoryType = info.id;
            $scope.dormitoryInfo.dormitoryTypeName = info.name;
        };


        $scope.informPatriarchClick = function () {
            $scope.isInformPatriarch = !$scope.isInformPatriarch;
        };
        $scope.affirmReportClick = function () {
            $scope.isAffirmReport = !$scope.isAffirmReport;
        };
        $scope.classAffirmReportClick = function () {
            $scope.isClassAffirmReport = !$scope.isClassAffirmReport;
        };
        $scope.majorAffirmReportClick = function () {
            $scope.isMajorAffirmReport = !$scope.isMajorAffirmReport;
        };
        $ionicModal.fromTemplateUrl('selectClass.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal1 = modal;
        });
        $scope.selectClassClick = function (info) {
            var selectedClassid = null, specialtyId = null;

            if (info.reportAdminClassId) {
                selectedClassid = info.reportAdminClassId;
                specialtyId = info.specialtyId;
            } else if (info.adminClassId) {
                selectedClassid = info.adminClassId;
                specialtyId = info.admSpecialtyId;
            }

            storageService.setItem("selectedClassid", selectedClassid);
            storageService.setItem("specialtyId", specialtyId);


            $http.post(basePath + "/findReportClassWithHeadmaster.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.classAndSpecialtyList = data.result;
                    // 默认选中
                    // if ($scope.classAndSpecialtyList && $scope.classAndSpecialtyList.length > 0) {
                    //   angular.forEach($scope.classAndSpecialtyList, function (cla) {
                    //     if (cla.adminClassId == selectedClassid) {
                    //
                    //     }
                    //   });
                    // }
                    $scope.modal1.show();
                }
            });

        };
        $scope.closeSelectClassModal = function () {
            $scope.modal1.hide();
        };

        function getStuDefaultBed(classId) {
            return $http.get(basePath + '/getStuDefaultBed.htm', {
                params: {
                    userId: $scope.studentDetailShow.userId,
                    gender: $scope.studentDetailShow.gender === "男" ? 1 : 2,
                    classId: classId,
                    typeId: $scope.studentDetailShow.dormitoryTypeId
                }
            }).success(function (data) {
                if (data.result) {
                    vm.selectRoomId = data.result.distributeId;
                    $scope.studentDetailShow.dormitoryId = data.result.distributeId;
                    $scope.studentDetailShow.dormitoryName = data.result.buildName + ' - ' + data.result.distributeName;
                    $scope.studentDetailShow.bedId = data.result.bedId;
                    $scope.studentDetailShow.bedName = data.result.bedName;
                }
                findDistributeBedByClassId($scope.studentDetailShow.reportAdminClassId).success(function (data) {
                    if (data.result && data.result.length > 0) {
                        if (null == vm.selectRoomId) {
                            vm.selectRoomId = data.result[0].distributeId;
                        }
                        changeRoom();
                    } else if (data.result && data.result.length === 0) {
                        vm.rooms = null;
                        vm.beds = null;
                        vm.selectRoomId = null;
                        vm.selectedBed = null;
                        $scope.studentDetailShow.dormitoryId = null;
                        $scope.studentDetailShow.dormitoryName = null;
                        $scope.studentDetailShow.bedId = null;
                        $scope.studentDetailShow.bedName = null;
                    }
                });
                return data;
            });
        }

        vm.showSelectRoomModal = showSelectRoomModal;
        vm.hideSelectRoomModal = hideSelectRoomModal;
        vm.confirm = confirm;
        vm.changeRoom = changeRoom;
        vm.selectBed = selectBed;

        vm.selectRoomModal = null;
        vm.rooms = null;
        vm.beds = null;
        vm.selectRoomId = null;
        vm.selectedBed = null;

        function showSelectRoomModal() {
            if (null == vm.selectRoomModal) {
                $ionicModal.fromTemplateUrl('select-room.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.selectRoomModal = modal;
                    vm.selectRoomModal.show();
                });
            } else {
                vm.selectRoomModal.show();
            }
        }

        function hideSelectRoomModal() {
            vm.selectRoomModal.remove().then(function () {
                vm.selectRoomModal = null;
            });
        }

        function confirm() {
            if (null != vm.selectedBed) {
                $scope.studentDetailShow.dormitoryId = vm.selectedBed.distributeId;
                $scope.studentDetailShow.dormitoryName = vm.selectedBed.buildName + ' - ' + vm.selectedBed.distributeName;
                $scope.studentDetailShow.bedId = vm.selectedBed.bedId;
                $scope.studentDetailShow.bedName = vm.selectedBed.bedName;
                hideSelectRoomModal();
            } else {
                ynuiNotification.error({msg: '请选择床位！'});
            }
        }

        function findDistributeBedByClassId(classId) {
            return $http.get(basePath + '/findDistributeBedByClassId.htm', {
                params: {
                    classId: classId,
                    gender: $scope.studentDetailShow.gender === "男" ? 1 : 2
                }
            }).success(function (data) {
                if (data.result) {
                    vm.rooms = data.result;
                }
                return data;
            });
        }

        function changeRoom() {
            angular.forEach(vm.rooms, function (room) {
                if (vm.selectRoomId === room.distributeId) {
                    vm.beds = [];
                    angular.forEach(room.bedList, function (bed, index) {
                        if (bed.bedId === $scope.studentDetailShow.bedId) {
                            vm.selectedBed = bed;
                        }
                        var beds;
                        if (index % 2 === 1) {
                            beds = vm.beds[vm.beds.length - 1];
                            beds.push(bed);
                            vm.beds.splice(vm.beds.length - 1, 1, beds);
                        } else {
                            beds = [];
                            beds.push(bed);
                            vm.beds.push(beds);
                        }
                    });
                }
            });
        }

        function selectBed(bed) {
            if ((bed.stuName == null && bed.className == null) || bed.stuId === $scope.studentDetailShow.userId) {
                var room = null;
                angular.forEach(vm.rooms, function (r) {
                    if (r.distributeId === vm.selectRoomId) {
                        room = r;
                    }
                });
                if (null != room.existCount && null != room.count && room.existCount >= room.count) {
                    ynuiNotification.error({msg: room.distributeName + '为报到班级预分的床位已满，请选择其他寝室！'});
                    return false;
                }
                vm.selectedBed = bed;
            }
        }

    }

    classReportController.$inject = ['$scope', '$http', '$location', 'ynuiNotification', 'storageService', '$ionicModal', '$ionicPopup', '$ionicScrollDelegate','ynNavigator'];

    function classReportController($scope, $http, $location, ynuiNotification, storageService, $ionicModal, $ionicPopup, $ionicScrollDelegate,ynNavigator) {
        var vm = this;
        // 路由信息
        var basePath = originBaseUrl + "/third/bdglMobileReport";
        var isBack = $location.search().isBack;
        var classId = $location.search().classId;

        $scope.showDetailInfo = null;
        $scope.showFlagInfo = null;
        // 默认选中全部
        $scope.tableView = null;
        // 班级搜索 默认否
        $scope.searchFlag = false;
        // 学生搜索条件
        $scope.stuSearch = {name: ""};
        //登记学生报到
        $scope.registerStudentReportFlag = false;
        // 默认不显示 您该学期没有需要报到班级
        $scope.classTipFlag = false;
        $scope.termTipFlag = false;

        $scope.sortList = [
            {name: 'A', selected: false}, {name: 'B', selected: false}, {name: 'C', selected: false},
            {name: 'D', selected: false}, {name: 'E', selected: false}, {name: 'F', selected: false},
            {name: 'G', selected: false}, {name: 'H', selected: false}, {name: 'I', selected: false},
            {name: 'J', selected: false}, {name: 'K', selected: false}, {name: 'L', selected: false},
            {name: 'M', selected: false}, {name: 'N', selected: false}, {name: 'O', selected: false},
            {name: 'P', selected: false}, {name: 'Q', selected: false}, {name: 'R', selected: false},
            {name: 'S', selected: false}, {name: 'T', selected: false}, {name: 'U', selected: false},
            {name: 'V', selected: false}, {name: 'W', selected: false}, {name: 'X', selected: false},
            {name: 'Y', selected: false}, {name: 'Z', selected: false}
        ];

        $scope.showAllSortList = [];

        // 首字母定位
        $scope.goSort = function (info) {
            // 选中
            angular.forEach($scope.showAllSortList, function (val) {
                if (val.name == info.name) {
                    val.selected = true;
                } else {
                    val.selected = false;
                }
            });


            // 获取定位id
            if ($scope.showDetailList && $scope.showDetailList.length > 0) {
                var id = info.name, flag = false;
                angular.forEach($scope.showDetailList, function (value, index) {
                    if (value.sortName == info.name) {
                        if (!flag) {
                            id += index;
                            flag = true;
                        }
                    }
                });
                // 定位处理
                if ($("#" + id).position()) {
                    var selectedTop = $("#" + id).position().top; // 相对父级（list）的位置
                    if (selectedTop) {
                        $ionicScrollDelegate.$getByHandle('listScroll').scrollTo(0, selectedTop, true);
                    }
                }

            }

        };

        $scope.toSearch = function () {
            $scope.searchFlag = true;
            $scope.showDetailInfo = null;
        };

        // 调整住宿意向为不住宿时是否清空学生床位
        function findSystemPublicConfig() {
            return $http.post(basePath + "/findSystemPublicConfig.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.isStay = data.result.flag;
                    $scope.voList = angular.copy(data.result.voList);
                    if ($scope.voList && $scope.voList.length > 0) {
                        $scope.voList.unshift({name: "请选择住宿意向", id: ""});
                    } else {
                        $scope.voList = [{name: "请选择住宿意向", id: ""}];
                    }
                    return data;
                }
            });
        }

        // 修改住宿意向
        $scope.dormitoryChoose = function (info) {
            storageService.setItem("stuId", info.userId);
            $scope.dormitoryInfo = {
                isStay: false,
                stuId: info.userId,
                dormitoryType: "",
                dormitoryTypeName: "请选择住宿意向"
            };
            $scope.isStay = false;

            findSystemPublicConfig().then(function () {
                // 获取学生住宿意向
                $http.post(basePath + "/findStudentAccommodation.htm", {stuId: info.userId}).success(function (data) {
                    if (data.status == 0) {
                        $scope.dormitoryInfo.isStay = data.result.isStay;
                        if (data.result.id) {
                            $scope.dormitoryInfo.dormitoryType = data.result.id;
                            angular.forEach($scope.voList, function (val) {
                                if (val.id == $scope.dormitoryInfo.dormitoryType) {
                                    $scope.dormitoryInfo.dormitoryTypeName = val.name;
                                }
                            });
                        }
                        $scope.dormitoryInfo.showInfo = data.result.showInfo;
                        $scope.dormitoryInfo.showName = data.result.showName;
                    }
                });
            });


            $ionicPopup.show(studentAccommodationConfig);
        };


        // 未报到弹窗
        var submitPopupConfig = {
            templateUrl: 'templates/report/dialog/noReportReasons.html',
            title: '未报到',
            cssClass: 'popup-head-none',
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>确定</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        $scope.noReport(e);
                    }
                }
            ]
        };

        // 住宿意向弹窗
        var studentAccommodationConfig = {
            templateUrl: 'templates/report/dialog/studentAccommodation.html',
            cssClass: 'popup-head-none',
            title: '',
            scope: $scope,
            buttons: [
                {text: '取消'},
                {
                    text: '<b>确定</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        var saveInfo = {
                            stuId: storageService.getItemNoDel("stuId"),
                            flag: $scope.isStay,
                            isStay: $scope.dormitoryInfo.isStay,
                            dormitoryType: $scope.dormitoryInfo.dormitoryType
                        };
                        $http.post(basePath + "/updateStudentAccommodation.htm", saveInfo).success(function (data) {
                            if (data.status == 0) {
                                $scope.goDetail($scope.studentDetailShow);
                            } else {
                                e.preventDefault();
                                ynuiNotification.error({msg: "操作失败！"});
                                return false;
                            }
                        });
                    }
                }
            ]
        };


        // 获取未报到原因
        $scope.getNoReportReasons = function (info) {
            $scope.reason = {
                customNoReportReason: "",
                noReportCode: "",
                noReportName: "请选择",
                remark: ""
            };
            // 批量则初始默认值：不来了
            var userIds = [];
            // 单个报到
            if (info) {
                userIds.push(info.userId);
                if (info.noReportCode) {
                    if ($scope.noReportReasonsList) {
                        angular.forEach($scope.noReportReasonsList, function (re) {
                            if (re.id == info.noReportCode) {
                                $scope.reason.noReportName = re.name;
                                $scope.reason.noReportCode = re.id;
                            }
                        });
                    }
                }
                $scope.reason.remark = info.remark;
            } else {
                // 只获取待确认的
                angular.forEach($scope.showDetailList, function (item) {
                    if (item.reportStatus == 2) {
                        userIds.push(item.platformSysUserId);
                    }
                });
            }
            storageService.setItem("userIds", userIds);
            $http.post(basePath + "/getNoReportReasons.htm").success(function (data) {
                if (data.status == 0) {
                    $ionicPopup.show(submitPopupConfig);
                    $scope.noReportReasonsList = angular.copy(data.result);
                }
            });
        };

        // 报到
        $scope.report = function (info) {

            if (info) {
                var userIds = [];
                // 单个报到
                if (info) {
                    userIds.push(info.userId);
                } else {
                    // 只获取待确认的
                    angular.forEach($scope.showDetailList, function (item) {
                        if (item.reportStatus == 2) {
                            userIds.push(item.platformSysUserId);
                        }
                    });

                    if (userIds.length == 0) {
                        ynuiNotification.success({msg: "报到成功！"});
                        $scope.registerStudentReportFlag = false;
                        $scope.isClassAffirmReport = false;
                    }
                }

                if (userIds.length > 0) {
                    var param = {
                        stuIds: userIds,
                        reportType: 0,
                        roomId: $scope.studentDetailShow.dormitoryId,
                        bedId: $scope.studentDetailShow.bedId
                    };
                    $http.post(basePath + "/dealReportRecord.htm", param).success(function (data) {
                        if (data.status == 0) {
                            if (!info) {
                                $scope.isClassAffirmReport = false;
                            }
                            ynuiNotification.success({msg: "报到成功！"});
                            $scope.registerStudentReportFlag = false;
                            // 刷新数据
                            $scope.getReportInfo($scope.tableView, $scope.showClass.id);
                        } else {
                            ynuiNotification.error({msg: "报到失败！"});
                        }
                    });
                }
            } else {
                var confirmPopup = $ionicPopup.confirm({
                    title: "提示",
                    template: "确定将所有待确认的学生设为已报到？",
                    cancelText: "取消",
                    okText: "确定"
                });
                confirmPopup.then(function (flag) {
                    if (flag) {
                        var userIds = [];
                        // 单个报到
                        if (info) {
                            userIds.push(info.userId);
                        } else {
                            // 只获取待确认的
                            angular.forEach($scope.showDetailList, function (item) {
                                if (item.reportStatus == 2) {
                                    userIds.push(item.platformSysUserId);
                                }
                            });

                            if (userIds.length == 0) {
                                ynuiNotification.success({msg: "报到成功！"});
                                $scope.registerStudentReportFlag = false;
                                $scope.isClassAffirmReport = false;
                            }
                        }

                        if (userIds.length > 0) {
                            var param = {
                                stuIds: userIds,
                                reportType: 0
                            };
                            $http.post(basePath + "/dealReportRecord.htm", param).success(function (data) {
                                if (data.status == 0) {
                                    if (!info) {
                                        $scope.isClassAffirmReport = false;
                                    }
                                    ynuiNotification.success({msg: "报到成功！"});
                                    $scope.registerStudentReportFlag = false;
                                    // 刷新数据
                                    $scope.getReportInfo($scope.tableView, $scope.showClass.id);
                                } else {
                                    ynuiNotification.error({msg: "报到失败！"});
                                }
                            });
                        }

                    }
                });
            }


        };

        // 未报到
        $scope.noReport = function (e) {
            var userIds = storageService.getItemNoDel("userIds");
            if (userIds && userIds.length > 0) {
                var param = {
                    stuIds: userIds,
                    customNoReportReason: $scope.reason.customNoReportReason,
                    noReportCode: $scope.reason.noReportCode,
                    remark: $scope.reason.remark,
                    reportType: 0
                };
                if (!param.noReportCode) {
                    e.preventDefault();
                    ynuiNotification.error({msg: "请选择未报到原因！"});
                    return false;
                }
                $http.post(basePath + "/dealNotReportRecord.htm", param).success(function (data) {
                    if (data.status == 0) {
                        $scope.isClassAffirmReport = false;
                        ynuiNotification.success({msg: "操作成功！"});
                        $scope.registerStudentReportFlag = false;
                        // 刷新数据
                        $scope.getReportInfo($scope.tableView, $scope.showClass.id);
                    } else {
                        e.preventDefault();
                        ynuiNotification.error({msg: "操作失败！"});
                        return false;
                    }
                });
            }

        };

        // 住宿类型样式选中处理
        $scope.getDormitoryInfoActive = function (info) {
            if (info.id == $scope.dormitoryInfo.dormitoryType) {
                return 'active';
            }
        };

        // 住宿类型选中处理
        $scope.getDormitoryInfoSelect = function (info) {
            $scope.dormitoryInfo.dormitoryType = info.id;
            $scope.dormitoryInfo.dormitoryTypeName = info.name;
        };


        // 未报到类型样式选中处理
        $scope.getNoReportReasonsActive = function (info) {
            if (info.id == $scope.reason.noReportCode) {
                return 'active';
            }
        };

        // 未报到类型选中处理
        $scope.getNoReportReasonsSelect = function (info) {
            $scope.reason.noReportCode = info.id;
            $scope.reason.noReportName = info.name;
        };

        // 登记学生报到
        $scope.goDetail = function (info) {
            if (info) {
                var param = {
                    reportType: 0,
                    name: info.stuName,//姓名
                    ticketNumber: info.ticketNumber,//准考证
                    userNumber: info.number,//学号
                    regNumber: info.regNumber,//报名号
                    credentialNumber: info.credentialNumber//证件号码
                };
                $http.post(basePath + "/queryRegistReportStudentWithHeadmaster.htm", param).success(function (data) {

                    if (data.status == 0) {
                        if (data.result && data.result.length > 0) {
                            if (data.result.length == 1) {
                                $scope.studentDetailShow = angular.copy(data.result[0]);
                                $scope.studentDetailShow.reportStatus = info.reportStatus;
                                if (2 == $scope.studentDetailShow.reportStatus) {
                                    $scope.studentDetailShow.reportStatusStr = '待确认报到状态';
                                } else if (info.reportStatusDesc) {
                                    $scope.studentDetailShow.reportStatusStr = info.reportStatusDesc;
                                } else if (info.reportStatusStr) {
                                    $scope.studentDetailShow.reportStatusStr = info.reportStatusStr;
                                }
                                if ($scope.studentDetailShow.headUrl) {
                                    $scope.studentDetailShow.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.studentDetailShow.headUrl;
                                }
                                $scope.studentDetailShow.showName = info.showName;
                                // 默认条件班级
                                if ($scope.showClass) {
                                    $scope.studentDetailShow.reportAdminClass = $scope.showClass.name.substring(0, $scope.showClass.name.lastIndexOf("("));
                                }
                            } else {
                                angular.forEach(data.result, function (val) {
                                    if (val.userId == info.platformSysUserId) {
                                        $scope.studentDetailShow = angular.copy(val);
                                        $scope.studentDetailShow.showName = info.showName;
                                    }
                                });
                            }
                            getStuDefaultBed($scope.studentDetailShow.adminClassId)
                        }

                        $scope.registerStudentReportFlag = true;
                        ynNavigator.registerBackAction(function () {
                            $scope.cancelDetail();
                        },101);
                    } else {
                        ynuiNotification.error({msg: "获取学生信息失败！"});
                    }
                });
            }

        };
        // 登记学生报到 取消
        $scope.cancelDetail = function () {
            delete $scope.studentDetailShow;
            $scope.registerStudentReportFlag = false;
            ynNavigator.cancelBackAction(101);
            setTimeout(function () {
                $scope.$apply();
            });
        };

        // 取消搜索
        $scope.cancelSearch = function (reportStatus, classId) {
            $scope.searchFlag = false;
            $scope.stuSearch = {name: ""};
            $scope.showAllSortList = [];
            $scope.getReportInfo(reportStatus, classId);
        };

        // 清除搜索条件
        $scope.clearSearch = function (reportStatus, classId) {
            $scope.stuSearch = {name: ""};
            $scope.getReportInfo(reportStatus, classId);
        };

        // 获取班主任负责的报到任务的状态
        $scope.getReportTaskStateWithHeadmaster = function () {
            $http.post(basePath + "/getReportTaskStateWithHeadmaster.htm", {reportType: 0}).success(function (data) {
                if (data.status == 0) {
                    $scope.showFlagInfo = angular.copy(data.result);
                    $scope.termTipFlag = true;
                } else {
                    ynuiNotification.error({msg: "获取班主任负责的报到任务的状态失败！"});
                }
            });
        };

        // 获取班级下拉值
        $scope.getDropDownOptions = function () {
            $http.post(basePath + "/getDropDownOptions.htm", {bdglReportType: 0}).success(function (data) {
                if (data.status == 0) {
                    $scope.showClassList = angular.copy(data.result.reportClass);
                    // 默认第一个班级
                    if ($scope.showClassList && $scope.showClassList.length > 0) {
                        angular.forEach($scope.showClassList, function (vo) {
                            vo.name = (vo.name + "(" + vo.studentNumber + "人)");
                        });
                        $scope.showDetailList = [];
                        if (null != classId) {
                          angular.forEach($scope.showClassList, function (vo) {
                              if (vo.id === classId) {
                                  $scope.showClass = vo;
                              }
                          });
                        } else {
                            $scope.showClass = $scope.showClassList[0];
                        }
                        $scope.getReportInfo(null, $scope.showClass.id);
                    }
                    window.setTimeout(function () {
                        $scope.classTipFlag = true;
                    }, 150);

                } else {
                    ynuiNotification.error({msg: "获取班级失败！"});
                }
            });
        };

        // 获取列表数据
        $scope.getReportInfo = function (reportStatus, classId, flag) {
            var searchInfo = {
                setType: 0,
                queryValueType: 5,
                queryValue: $scope.stuSearch.name,
                reportStatus: reportStatus,
                adminClassIds: [classId]
            };
            $http.post(basePath + "/getReportInfo.htm", searchInfo).success(function (data) {
                if (data.status == 0) {
                    $scope.showDetailInfo = angular.copy(data.result);
                    $scope.showDetailList = angular.copy(data.result.reportStuInfoVOList);
                    $scope.showDetailInfo.notReportNum = $scope.showDetailInfo.notReportNum - $scope.showDetailInfo.waitConfirmReportNum;
                    if ($scope.showDetailList && $scope.showDetailList.length > 0) {
                        var allSortList = [], allSort = [];
                        angular.forEach($scope.showDetailList, function (info) {
                            // 姓名显示
                            var showName = info.stuName;
                            if (info.gender) {
                                if (info.nation) {
                                    showName += "(" + info.gender + "，" + info.nation + ")";
                                } else {
                                    showName += "(" + info.gender + ")";
                                }
                            } else {
                                showName += "(" + info.nation + ")";
                            }
                            info.showName = showName;

                            if (info.reportStatus == 2) {
                                info.reportStatusDesc = '待确认';
                            }

                            if (allSort.indexOf(info.sortName) == -1) {
                                allSort.push(info.sortName);
                                allSortList.push({name: info.sortName, selected: false});
                            }

                            // 统计人数
                            if (info.reportStatus == 2) {
                                info.reportStatusDesc = '待确认';
                            }


                        });

                        if (allSortList.length > 0) {
                            $scope.showAllSortList = allSortList;
                            // 切换处理
                            if (flag) {
                                window.setTimeout(function () {
                                    $scope.goSort($scope.showAllSortList[0]);
                                }, 500);
                            }

                        } else {
                            $scope.showAllSortList = [];
                        }

                    } else {
                        $scope.showAllSortList = [];
                    }


                } else {
                    ynuiNotification.error({msg: "获取数据失败！"});
                }
            });
        };

        // 获取班级选中样式
        $scope.getActive = function (info) {
            if (info.id === $scope.showClass.id) {
                return 'active';
            }
        };

        // 获取选中班级
        $scope.getSelect = function (info) {
            $scope.showClass = info;
            $scope.getReportInfo($scope.tableView, $scope.showClass.id);
        };

        //table切换
        $scope.getActiveTable = function (type) {
            $scope.tableView = type;
            $scope.isClassAffirmReport = false;
            $scope.getReportInfo(type, $scope.showClass.id, true);
        };

        //获取table选中样式
        $scope.getClassTable = function (type) {
            if (type == $scope.tableView) {
                return 'tab-item active';
            } else {
                return 'tab-item'
            }
        };

        $scope.getStatusClass = function (status, flag) {
            if (flag) {
                if (status == '已报到') {
                    return 'button-label';
                } else if (status == '未报到') {
                    return 'label-orange button-label';
                } else if (status == '待确认报到状态') {
                    return 'label-yellow button-label';
                }
            } else {
                if (status == 0) {
                    return 'button-label margin-left-10';
                } else if (status == 1) {
                    return 'label-orange button-label margin-left-10';
                } else if (status == 2) {
                    return 'label-yellow button-label margin-left-10';
                }
            }

        };

        $scope.getReportStrClass = function (status) {
            if (status && status.indexOf('已报到') > -1) {
                return 'button-label';
            } else if (status && status.indexOf('未报到') > -1) {
                return 'label-orange button-label';
            }
        };


        // 初始化数据
        function initData() {
            $scope.getReportTaskStateWithHeadmaster();
            $scope.getDropDownOptions();
        }

        if (isBack) {

        } else {
            initData();
        }


        $scope.informPatriarchClick = function () {
            $scope.isInformPatriarch = !$scope.isInformPatriarch;
        };
        $scope.affirmReportClick = function () {
            $scope.isAffirmReport = !$scope.isAffirmReport;
        };
        $scope.classAffirmReportClick = function () {
            $scope.isClassAffirmReport = !$scope.isClassAffirmReport;
        };

        function getStuDefaultBed(classId) {
            return $http.get(basePath + '/getStuDefaultBed.htm', {
                params: {
                    userId: $scope.studentDetailShow.userId,
                    gender: $scope.studentDetailShow.gender === "男" ? 1 : 2,
                    classId: classId,
                    typeId: $scope.studentDetailShow.dormitoryTypeId
                }
            }).success(function (data) {
                if (data.result) {
                    vm.selectRoomId = data.result.distributeId;
                    $scope.studentDetailShow.dormitoryId = data.result.distributeId;
                    $scope.studentDetailShow.dormitoryName = data.result.buildName + ' - ' + data.result.distributeName;
                    $scope.studentDetailShow.bedId = data.result.bedId;
                    $scope.studentDetailShow.bedName = data.result.bedName;
                }
                findDistributeBedByClassId($scope.studentDetailShow.adminClassId).success(function (data) {
                    if (data.result && data.result.length > 0) {
                        if (null == vm.selectRoomId) {
                            vm.selectRoomId = data.result[0].distributeId;
                        }
                        changeRoom();
                    } else if (data.result && data.result.length === 0) {
                        vm.rooms = null;
                        vm.beds = null;
                        vm.selectRoomId = null;
                        vm.selectedBed = null;
                        $scope.studentDetailShow.dormitoryId = null;
                        $scope.studentDetailShow.dormitoryName = null;
                        $scope.studentDetailShow.bedId = null;
                        $scope.studentDetailShow.bedName = null;
                    }
                });
                return data;
            });
        }

        vm.showSelectRoomModal = showSelectRoomModal;
        vm.hideSelectRoomModal = hideSelectRoomModal;
        vm.confirm = confirm;
        vm.changeRoom = changeRoom;
        vm.selectBed = selectBed;

        vm.selectRoomModal = null;
        vm.rooms = null;
        vm.beds = null;
        vm.selectRoomId = null;
        vm.selectedBed = null;

        function showSelectRoomModal() {
            if (null == vm.selectRoomModal) {
                $ionicModal.fromTemplateUrl('select-room_class.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.selectRoomModal = modal;
                    vm.selectRoomModal.show();
                });
            } else {
                vm.selectRoomModal.show();
            }
        }

        function hideSelectRoomModal() {
            vm.selectRoomModal.remove().then(function () {
                vm.selectRoomModal = null;
            });
        }

        function confirm() {
            if (null != vm.selectedBed) {
                $scope.studentDetailShow.dormitoryId = vm.selectedBed.distributeId;
                $scope.studentDetailShow.dormitoryName = vm.selectedBed.buildName + ' - ' + vm.selectedBed.distributeName;
                $scope.studentDetailShow.bedId = vm.selectedBed.bedId;
                $scope.studentDetailShow.bedName = vm.selectedBed.bedName;
                hideSelectRoomModal();
            } else {
                ynuiNotification.error({msg: '请选择床位！'});
            }
        }

        function findDistributeBedByClassId(classId) {
            return $http.get(basePath + '/findDistributeBedByClassId.htm', {
                params: {
                    classId: classId,
                    gender: $scope.studentDetailShow.gender === "男" ? 1 : 2
                }
            }).success(function (data) {
                if (data.result) {
                    vm.rooms = data.result;
                }
                return data;
            });
        }

        function changeRoom() {
            angular.forEach(vm.rooms, function (room) {
                if (vm.selectRoomId === room.distributeId) {
                    vm.beds = [];
                    angular.forEach(room.bedList, function (bed, index) {
                        if (bed.bedId === $scope.studentDetailShow.bedId) {
                            vm.selectedBed = bed;
                        }
                        var beds;
                        if (index % 2 === 1) {
                            beds = vm.beds[vm.beds.length - 1];
                            beds.push(bed);
                            vm.beds.splice(vm.beds.length - 1, 1, beds);
                        } else {
                            beds = [];
                            beds.push(bed);
                            vm.beds.push(beds);
                        }
                    });
                }
            });
        }

        function selectBed(bed) {
            if ((bed.stuName == null && bed.className == null) || bed.stuId === $scope.studentDetailShow.userId) {
                var room = null;
                angular.forEach(vm.rooms, function (r) {
                    if (r.distributeId === vm.selectRoomId) {
                        room = r;
                    }
                });
                if (null != room.existCount && null != room.count && room.existCount >= room.count) {
                    ynuiNotification.error({msg: room.distributeName + '为报到班级预分的床位已满，请选择其他寝室！'});
                    return false;
                }
                vm.selectedBed = bed;
            }
        }
    }

    majorReportController.$inject = ['$scope','$http','$location','ynuiNotification','storageService','$ionicModal', '$ionicPopup','$ionicScrollDelegate','ynNavigator'];

    function majorReportController ($scope,$http,$location,ynuiNotification,storageService,$ionicModal,$ionicPopup,$ionicScrollDelegate,ynNavigator){
        // 路由信息
        var basePath = originBaseUrl + "/third/bdglMobileReport";

        $scope.showFlagInfo = null;
        // 学生搜索条件
        $scope.stuSearch = {name:""};
        //登记学生报到
        $scope.registerStudentReportFlag = false;
        // 默认不显示 您该学期没有需要报到班级
        $scope.classTipFlag = false;
        $scope.termTipFlag = false;

        $scope.sortList = [
            {name:'A', selected:false},{name:'B', selected:false},{name:'C', selected:false},
            {name:'D', selected:false},{name:'E', selected:false},{name:'F', selected:false},
            {name:'G', selected:false},{name:'H', selected:false},{name:'I', selected:false},
            {name:'J', selected:false},{name:'K', selected:false},{name:'L', selected:false},
            {name:'M', selected:false},{name:'N', selected:false},{name:'O', selected:false},
            {name:'P', selected:false},{name:'Q', selected:false},{name:'R', selected:false},
            {name:'S', selected:false},{name:'T', selected:false},{name:'U', selected:false},
            {name:'V', selected:false},{name:'W', selected:false},{name:'X', selected:false},
            {name:'Y', selected:false},{name:'Z', selected:false}
        ];

        $scope.showAllSortList = [];

        // 首字母定位
        $scope.goSort = function (info) {
            // 选中
            angular.forEach($scope.showAllSortList,function (val) {
                if(val.name == info.name){
                    val.selected = true;
                }else {
                    val.selected = false;
                }
            });

            // 获取定位id
            if($scope.showDetailList && $scope.showDetailList.length > 0){
                var id = info.name,flag = false;
                angular.forEach($scope.showDetailList,function (value,index) {
                    if(value.sortName == info.name){
                        if(!flag){
                            id += index;
                            flag = true;
                        }
                    }
                });
                // 定位处理
                var selectedTop = $("#"+id).position().top; // 相对父级（list）的位置
                if(selectedTop){
                    $ionicScrollDelegate.$getByHandle('listScroll').scrollTo(0,selectedTop,true);
                }
            }
        };
        // 住宿意向弹窗
        var studentAccommodationConfig = {
            templateUrl: 'templates/report/dialog/studentAccommodation.html',
            title: '住宿意向',
            cssClass: 'popup-head-none',
            scope: $scope,
            buttons: [
                { text: '取消' },
                {
                    text: '<b>确定</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                        var saveInfo = {
                            stuId:storageService.getItem("stuId"),
                            flag:$scope.isStay,
                            isStay:$scope.dormitoryInfo.isStay,
                            dormitoryType:$scope.dormitoryInfo.dormitoryType
                        };
                        $http.post(basePath+"/updateStudentAccommodation.htm",saveInfo).success(function (data) {
                            if(data.status == 0){
                                $scope.goDetail($scope.studentDetailShow);
                            }else {
                                e.preventDefault();
                                ynuiNotification.error({msg: "操作失败！"});
                                return false;
                            }
                        });
                    }
                }
            ]
        };

        // 调整住宿意向为不住宿时是否清空学生床位
        function findSystemPublicConfig() {
            return  $http.post(basePath+"/findSystemPublicConfig.htm").success(function (data) {
                if(data.status == 0){
                    $scope.isStay =  data.result.flag;
                    $scope.voList = angular.copy(data.result.voList);
                    if($scope.voList && $scope.voList.length > 0){
                        $scope.voList.unshift({name:"请选择住宿意向",id:""});
                    }else {
                        $scope.voList = [{name:"请选择住宿意向",id:""}];
                    }
                    return data;
                }
            });
        }

        // 修改住宿意向
        $scope.dormitoryChoose = function (info) {
            storageService.setItem("stuId",info.userId);
            $scope.dormitoryInfo = {
                isStay:false,
                stuId:info.userId,
                dormitoryType:"",
                dormitoryTypeName:"请选择住宿意向"
            };
            $scope.isStay = false;
            findSystemPublicConfig().then(function () {
                // 获取学生住宿意向
                $http.post(basePath+"/findStudentAccommodation.htm",{stuId:info.userId}).success(function (data) {
                    if(data.status == 0){
                        $scope.dormitoryInfo.isStay = data.result.isStay;
                        if(data.result.id){
                            $scope.dormitoryInfo.dormitoryType = data.result.id;
                            angular.forEach($scope.voList,function (val) {
                                if(val.id == $scope.dormitoryInfo.dormitoryType){
                                    $scope.dormitoryInfo.dormitoryTypeName = val.name;
                                }
                            });
                        }
                        $scope.dormitoryInfo.showInfo = data.result.showInfo;
                        $scope.dormitoryInfo.showName = data.result.showName;
                    }
                });
            });
            $ionicPopup.show(studentAccommodationConfig);
        };





        // 报到
        $scope.report = function (info) {
            var old = storageService.getItemNoDel("selectClassInfo");
            if(!old){
                ynuiNotification.error({msg: "请选择报到班级！"});
                return false;
            }
            if(!$scope.studentDetailShow.reportAdminClass){
                ynuiNotification.error({msg: "请选择报到班级！"});
                return false;
            }
            var param = {
                appStuId: info.userId,
                thenClassId: info.adminClassId,
                specialtyId: old.specialtyId,
                reportClassId: old.reportClassId
            };
            $http.post(basePath + "/registReportStudentWithHeadMaster.htm", param).success(function (data) {
                if (data.status == 0) {
                    storageService.clearKey("selectClassInfo");
                    $scope.isClassAffirmReport = false;
                    ynuiNotification.success({msg: "报到成功！"});
                    $scope.registerStudentReportFlag = false;
                    // 刷新数据
                    var info = storageService.getItemNoDel("info");
                    if($scope.stuSearch.enrollType == '秋季招生'){
                        // 查询学生
                        $scope.getReportInfo('02',info.adminClassId,info.id);
                    }else if($scope.stuSearch.enrollType == '春季招生'){
                        // 查询学生
                        $scope.getReportInfo('01',info.adminClassId,info.id);
                    }else {
                        // 查询学生
                        $scope.getReportInfo('',info.adminClassId,info.id);
                    }
                } else {
                    ynuiNotification.error({msg: data.message});
                }
            }).error(function () {
                ynuiNotification.error({msg: '报到失败！'});
            });

        };



        // 登记学生报到
        $scope.goDetail = function (info) {
            if(info){
                var param = {
                    reportType:0,
                    name:info.name,//姓名
                    ticketNumber:info.ticketNumber,//准考证
                    userNumber:info.userNumber,//学号
                    regNumber:info.regNumber,//报名号
                    credentialNumber:info.credentialNumber//证件号码
                };
                $http.post(basePath+"/queryRegistReportStudentWithHeadmaster.htm",param).success(function (data) {

                    if(data.status == 0){
                        if(data.result && data.result.length > 0){
                            if(data.result.length == 1){
                                $scope.studentDetailShow = angular.copy(data.result[0]);
                                if($scope.studentDetailShow.adminClassName == '未分班'){
                                    $scope.studentDetailShow.adminClassName = '请选择报到班级';
                                }
                                if($scope.studentDetailShow.headUrl){
                                    $scope.studentDetailShow.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.studentDetailShow.headUrl;
                                }
                                $scope.studentDetailShow.showName = info.showName;
                            }else {
                                angular.forEach(data.result,function (val) {
                                    if(val.userId == info.platformSysUserId){
                                        $scope.studentDetailShow = angular.copy(val);
                                        $scope.studentDetailShow.showName = info.showName;
                                    }
                                });
                            }
                        }
                        $scope.registerStudentReportFlag = true;
                        ynNavigator.registerBackAction(function () {
                            $scope.cancelDetail();
                        },101);
                    }else {
                        ynuiNotification.error({msg: "获取学生信息失败！"});
                    }
                });
            }

        };

        // 登记学生报到 取消
        $scope.cancelDetail = function () {
            delete $scope.studentDetailShow;
            $scope.registerStudentReportFlag = false;
            ynNavigator.cancelBackAction(101);
            setTimeout(function () {
                $scope.$apply();
            });
        };
        // 获取班主任负责的报到任务的状态
        $scope.getReportTaskStateWithHeadmaster = function () {
            $http.post(basePath+"/getReportTaskStateWithHeadmaster.htm",{reportType:0}).success(function (data) {
                if(data.status == 0){
                    $scope.showFlagInfo = angular.copy(data.result);
                    $scope.termTipFlag = true;
                }else {
                    ynuiNotification.error({msg: "获取班主任负责的报到任务的状态失败！"});
                }
            });
        };

        // 获取班级下拉值
        $scope.getDropDownOptions = function () {
            $http.post(basePath+"/findReportSpecialtyWithHeadmaster.htm").success(function (data) {
                if(data.status == 0){
                    $scope.showClassList = angular.copy(data.result);
                    // 默认第一个专业
                    if($scope.showClassList && $scope.showClassList.length > 0){
                        angular.forEach($scope.showClassList,function (vo) {
                            vo.name = ("("+vo.schoolLevelName+")"+vo.name);
                        });
                        $scope.stuSearch.name = $scope.showClassList[0].name;
                        $scope.stuSearch.enrollType = '秋季招生';
                        storageService.setItem("info",$scope.showClassList[0]);
                        $scope.showDetailList = [];
                        // 查询学生
                        $scope.getReportInfo('02',$scope.showClassList[0].adminClassId,$scope.showClassList[0].id);
                    }
                    window.setTimeout(function () {
                        $scope.classTipFlag = true;
                    },150);
                }else {
                    ynuiNotification.error({msg: "获取专业失败！"});
                }
            });
        };

        // 获取列表数据
        $scope.getReportInfo = function(enrollType,classId,specialtyId) {
            if(!(enrollType && classId && specialtyId)){
                var info = storageService.getItemNoDel("info");
                classId = info.adminClassId;
                specialtyId = info.id;
                enrollType = $scope.stuSearch.enrollType == '秋季招生'?'02':$scope.stuSearch.enrollType == '春季招生'?'01':'';
            }
            var searchInfo = {
                adminClassId : classId,
                specialtyIds : [specialtyId],
                enrollTypeApp : enrollType
            };
            $http.post(basePath+"/listNODividedClassStuInfosByPage.htm",searchInfo).success(function (data) {
                if(data.status == 0){
                    $scope.showDetailList = angular.copy(data.result);
                    if($scope.showDetailList && $scope.showDetailList.length > 0){
                        var allSortList = [],allSort = [];
                        angular.forEach($scope.showDetailList,function (info) {
                            // 姓名显示
                            var showName = info.name;
                            if(info.gender){
                                if(info.nation){
                                    showName += "("+info.gender+"，"+info.nation+")";
                                }else {
                                    showName += "("+info.gender+")";
                                }
                            }else {
                                showName += "("+info.nation+")";
                            }
                            info.showName = showName;

                            if(info.reportStatus == 2){
                                info.reportStatusDesc = '待确认';
                            }

                            if(allSort.indexOf(info.sortName) == -1){
                                allSort.push(info.sortName);
                                allSortList.push({name:info.sortName,selected:false});
                            }

                        });

                        if(allSortList.length > 0){
                            $scope.showAllSortList = allSortList;
                        }else {
                            $scope.showAllSortList = [];
                        }
                    }else {
                        $scope.showAllSortList = [];
                    }

                }else {
                    ynuiNotification.error({msg: "获取数据失败！"});
                }
            });
        };


        $scope.getActiveEnrollType = function (item, value) {
            if(item == value){
                return 'active';
            }
        };

        $scope.getEnrollType = function (item) {
            var info = storageService.getItemNoDel("info");
            if(item == '02'){
                $scope.stuSearch.enrollType = '秋季招生';
                // 查询学生
                $scope.getReportInfo('02',info.adminClassId,info.id);
            }else if (item == '01'){
                $scope.stuSearch.enrollType = '春季招生';
                // 查询学生
                $scope.getReportInfo('01',info.adminClassId,info.id);
            }else {
                $scope.stuSearch.enrollType = '全部';
                // 查询学生
                $scope.getReportInfo('',info.adminClassId,info.id);
            }
        };

        // 获取班级选中样式
        $scope.getActive = function(info,item) {
            if(info === item.name){
                return 'active';
            }
        };

        // 获取选中班级
        $scope.getSelect = function(info) {
            storageService.setItem("info",info);
            $scope.stuSearch.name = info.name;
            if($scope.stuSearch.enrollType == '秋季招生'){
                // 查询学生
                $scope.getReportInfo('02',info.adminClassId,info.id);
            }else if($scope.stuSearch.enrollType == '春季招生'){
                // 查询学生
                $scope.getReportInfo('01',info.adminClassId,info.id);
            }else {
                // 查询学生
                $scope.getReportInfo('',info.adminClassId,info.id);
            }
        };


        $scope.getStatusClass = function (status,flag) {
            if(flag){
                if(status == '已报到'){
                    return 'button-label';
                }else if(status == '未报到'){
                    return 'label-orange button-label';
                }else if(status == '待确认报到状态'){
                    return 'label-yellow button-label';
                }
            }else {
                if(status == 0){
                    return 'button-label margin-left-10';
                }else if(status == 1){
                    return 'label-orange button-label margin-left-10';
                }else if(status == 2){
                    return 'label-yellow button-label margin-left-10';
                }
            }

        };


        // 初始化数据
        function initData() {
            $scope.getReportTaskStateWithHeadmaster();
            $scope.getDropDownOptions();
        }


        initData();


        // 选中报到班级
        $scope.getSelectClass = function (item) {
            if(item.platformSysSpecialtyVOList && item.platformSysSpecialtyVOList.length == 1){
                var selectClassInfo = {
                    reportClassId : item.adminClassId,
                    specialtyId : item.platformSysSpecialtyVOList[0].id
                };
                $scope.studentDetailShow.reportAdminClass = item.adminClassName;
                $scope.studentDetailShow.reportAdminClassId = selectClassInfo.reportClassId;
                $scope.studentDetailShow.specialtyId = selectClassInfo.specialtyId;
                storageService.setItem("selectClassInfo",selectClassInfo);
                $scope.closeSelectClassModal();
            }

        };

        // 选中报到班级、专业
        $scope.getSelectClassAndSpecialty = function (item, val) {
            var selectClassInfo = {
                reportClassId : item.adminClassId,
                specialtyId : val.id
            };
            $scope.studentDetailShow.reportAdminClass = item.adminClassName;
            $scope.studentDetailShow.reportAdminClassId = selectClassInfo.reportClassId;
            $scope.studentDetailShow.specialtyId = selectClassInfo.specialtyId;
            storageService.setItem("selectClassInfo",selectClassInfo);
            $scope.closeSelectClassModal();
        };

        $scope.getReportStrClass = function (status) {
            if(status && status.indexOf('已报到') > -1){
                return 'label-orange button-label';
            }else if(status && status.indexOf( '未报到') > -1){
                return 'label-orange button-label';
            }
        };

        $scope.parentActive = function(info){
            var selectedClassid = storageService.getItemNoDel("selectedClassid");
            if(info.adminClassId == selectedClassid && info.platformSysSpecialtyVOList && info.platformSysSpecialtyVOList.length <= 1){
                return 'calm';
            }
        };

        $scope.getChildActive = function(info){
            var selectedClassid = storageService.getItemNoDel("selectedClassid");
            if(info.adminClassId == selectedClassid && info.platformSysSpecialtyVOList && info.platformSysSpecialtyVOList.length > 1){
                return 'calm';
            }
        };

        $scope.getChildrenActive = function(info,item){
            var selectedClassid = storageService.getItemNoDel("selectedClassid"),specialtyId = storageService.getItemNoDel("specialtyId");
            if(info.id == specialtyId && item.adminClassId == selectedClassid){
                return 'calm';
            }
        };

        // 住宿类型样式选中处理
        $scope.getDormitoryInfoActive = function (info) {
            if(info.id == $scope.dormitoryInfo.dormitoryType){
                return 'active';
            }
        };

        // 住宿类型选中处理
        $scope.getDormitoryInfoSelect = function (info) {
            $scope.dormitoryInfo.dormitoryType = info.id;
            $scope.dormitoryInfo.dormitoryTypeName = info.name;
        };


        $scope.informPatriarchClick = function(){
            $scope.isInformPatriarch = !$scope.isInformPatriarch;
        };
        $scope.affirmReportClick = function(){
            $scope.isAffirmReport = !$scope.isAffirmReport;
        };
        $scope.classAffirmReportClick = function(){
            $scope.isClassAffirmReport = !$scope.isClassAffirmReport;
        };
        $scope.majorAffirmReportClick = function(){
            $scope.isMajorAffirmReport = !$scope.isMajorAffirmReport;
        };
        $ionicModal.fromTemplateUrl('selectClass_major.html',{
            scope:$scope,
            animation:'slide-in-up'
        }).then(function(modal){
            $scope.modal1 = modal;
        });
        $scope.selectClassClick = function(info) {
            var selectedClassid = null,specialtyId = null;

            if(info.reportAdminClassId){
                selectedClassid = info.reportAdminClassId;
                specialtyId = info.specialtyId;
            }else if(info.adminClassId){
                selectedClassid = info.adminClassId;
                specialtyId = info.admSpecialtyId;
            }

            storageService.setItem("selectedClassid",selectedClassid);
            storageService.setItem("specialtyId",specialtyId);

            $http.post(basePath+"/findReportClassWithHeadmaster.htm").success(function (data) {
                if(data.status == 0){
                    $scope.classAndSpecialtyList = data.result;
                    $scope.modal1.show();
                }
            });
        };
        $scope.closeSelectClassModal = function() {
            $scope.modal1.hide();
        };
    }

})();








