/**
 * 节假日报到
 *
 * @author qiucheng Lu
 * @date 2021年4月15日13:41:41
 */

(function () {
    angular.module('starter')
        .config(config)
        .controller("reportCtrl", reportCtrl)
        .controller("addReportStu", addReportStu)
        .controller("confirmationStudentCtrl", confirmationStudentCtrl);

    config.$inject = ['$stateProvider'];

    function config($stateProvider) {
        $stateProvider
        /*节假日报到*/
            .state('report_detail', {
                url: '/report_detail',
                templateUrl: 'templates/report/report_detail.html',
                data: {
                    prev: 'workspaceForTeacher',
                    title: '节假日报到'
                }
            })
            //添加学生
            .state('add_report_stus', {
                url: '/add_report_stus',
                templateUrl: 'templates/report/addReportStu.html',
                data: {
                    prev: 'report_detail',
                    title: '节假日报到'
                }
            })
            // 确认留校生
            .state('confirmation_students', {
                url: '/confirmation_students',
                templateUrl: 'templates/report/confirmationStudents.html',
                controller:'confirmationStudentCtrl',
                data: {
                    micro: false,
                    prev: 'workspaceForTeacher',
                    title: '确认留校生'
                }
            })
        ;
    }

    reportCtrl.$inject = ['$scope', '$timeout', 'receivePromiseService', 'reportUtilService', 'dataService', '$location','$state'];

    /*节假日报到*/
    function reportCtrl($scope, $timeout, receivePromiseService, reportUtilService, dataService, $location,$state) {

        $scope.toAnother = function(){
            $state.go('confirmation_students');
        }

        $scope.report = {
            queryValue: '',
            table_serach: false,
            table_content: [],
            isAdjust: true,
            pageNumber: 0,
            totalElements: 0
        };

        function initAttr() {
            $scope.currentTask = dataService.getcurrentData('currentTask');
            $scope.currentClass = dataService.getcurrentData('currentClass');
            $scope.report.table_content = [];
            $scope.report.totalElements = 0;
            $scope.report.pageNumber = 0;
        }

        function init() {
            initAttr();
            receivePromiseService.queryTasks($scope.report, 'tasks', reportUtilService.init)
                .then(function () {
                    if ($scope.report.tasks != undefined && $scope.report.tasks.length > 0 && $scope.report.tasks[0].adminClassList.length > 0) {
                        receivePromiseService.queryStudents({
                            pageSize: 20,
                            pageNumber: 0,
                            reportTaskId: $scope.currentTask ? $scope.currentTask.id : $scope.report.tasks[0].id,
                            reportAdminClassId: $scope.currentClass ? $scope.currentClass.id : $scope.report.tasks[0].adminClassList[0].id
                        }).then(
                            function (data) {
                                $scope.report.totalElements = data.result.reportStudent.totalElements;
                                reportUtilService.initAttr(data.result.reportStudent.content, 'isChange', false);
                                $scope.report.table_content = _.union($scope.report.table_content, data.result.reportStudent.content);
                                $scope.report.statistic = data.result.statisticReport;
                                $timeout(function () {
                                    $scope.$broadcast('scroll.infiniteScrollComplete');
                                });
                            }
                        );
                        $scope.report.isAdjust = $scope.report.tasks[0].isAdjust;
                        $scope.currentTask = $scope.currentTask ? $scope.currentTask : $scope.report.tasks[0];
                        $scope.currentClass = $scope.currentClass ? $scope.currentClass : $scope.report.tasks[0].adminClassList[0];
                        dataService.setcurrentData('currentTask', $scope.currentTask);
                        dataService.setcurrentData('currentClass', $scope.currentClass);
                    }
                });
        };

        init();

        $scope.selectClass = function (t, c, aTask) {
            initAttr();
            if (Object.prototype.toString.apply(c) === "[object Object]") {
                dataService.setcurrentData('currentTask', t);
                dataService.setcurrentData('currentClass', c);
                reportUtilService.init(aTask);
                c.isSelect = true;
            }
            receivePromiseService.queryStudents({
                pageSize: 20,
                pageNumber: 0,
                reportTaskId: t.id,
                reportAdminClassId: c.id
            }).then(
                function (data) {
                    if (data.status === 0) {
                        $scope.currentTask = t;
                        $scope.currentClass = c;
                        $scope.report.table_content = [];
                        $scope.report.isAdjust = t.isAdjust;
                        $scope.report.totalElements = data.result.reportStudent.totalElements;
                        reportUtilService.initAttr(data.result.reportStudent.content, 'isChange', false);
                        $scope.report.table_content = _.union($scope.report.table_content, data.result.reportStudent.content);
                        statisticReport();
                        $timeout(function () {
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        });
                        $scope.$apply();
                    }
                }
            );
        };


        function refresh(number) {
            var reportTaskId = dataService.getcurrentData('currentTask').id,
                reportAdminClassId = dataService.getcurrentData('currentClass').id;
            return receivePromiseService.queryStudents({
                pageSize: 20,
                pageNumber: number ? number : 0,
                reportTaskId: reportTaskId,
                reportAdminClassId: reportAdminClassId,
                userInfo: $scope.report.queryValue
            });
        }

        function statisticReport() {
            var reportTaskId = dataService.getcurrentData('currentTask').id,
                reportAdminClassId = dataService.getcurrentData('currentClass').id;
            receivePromiseService.statisticReport({
                reportTaskId: reportTaskId,
                reportAdminClassId: reportAdminClassId
            }, $scope.report, 'statistic');
        }

        $scope._updateStatus = function (s, n) {
            if (n == 2) {
                receivePromiseService.updateStatus({
                    userIds: s.id,
                    status: n,
                    remark: ''
                })
                    .then(
                        function (data) {
                            if (data.status === 0) {
                                s.reportStatus = n;
                                s.isChange = !s.isChange;
                                statisticReport();
                            }
                        }
                    );
            }
            if (n == 3) {
                $scope.report.remark = s.remark ? s.remark : '';
                reportUtilService.showPopup($scope, function (remark) {
                    receivePromiseService.updateStatus({
                        userIds: s.id,
                        status: n,
                        remark: remark
                    })
                        .then(
                            function (data) {
                                if (data.status === 0) {
                                    s.reportStatus = n;
                                    s.isChange = !s.isChange;
                                    statisticReport();
                                }
                            }
                        )
                });

            }
        };

        $scope.updateAllStatus = function (arr) {
            var users = reportUtilService.filterArrByAttr(arr, 'reportStatus', '1');
            var userIds = reportUtilService.getValuesByAttr(users, 'id');

            receivePromiseService.updateStatus({
                userIds: userIds,
                status: 2,
                remark: ''
            })
                .then(
                    function (data) {
                        if (data.status === 0) {
                            refresh();
                            reportUtilService.initAttr(users, 'reportStatus', '2');
                            statisticReport();
                        }
                    }
                );

        }


        $scope.changePanel = function (s, arr) {
            reportUtilService.initAttr(arr, 'isChange', false);
            s.isChange = true;
        };


        $scope.to_serach = function () {
            $scope.report.table_serach = true;
            $scope.report.queryValue = '';
            initAttr();
        };

        $scope.to_add_stu = function () {
            $location.path("/add_report_stus");
        }

        $scope.serachByInfo = function () {
            initAttr();
            var promise = refresh();
            promise.then(
                function (data) {
                    $scope.report.totalElements = data.result.reportStudent.totalElements;
                    reportUtilService.initAttr(data.result.reportStudent.content, 'isChange', false);
                    $scope.report.table_content = _.union($scope.report.table_content, data.result.reportStudent.content);
                    $scope.report.statistic = data.result.statisticReport;
                    $timeout(function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    });
                }
            )
            return promise;
        };

        $scope.clearInfo = function (attr) {
            $scope.report[attr] = '';

        };

        $scope.cancel = function () {
            $scope.report.queryValue = '';
            $scope.report.table_serach = false;
            $scope.report.table_content = [];
            $scope.report.pageNumber = 0;
            $scope.report.totalElements = 0;
            init();
        };

        $scope.doFresh = function () {
            dataService.setcurrentData('currentTask', '');
            dataService.setcurrentData('currentClass', '');
            init();
        }


        $scope.loadMore = function () {
            if ($scope.report.totalElements && $scope.report.totalElements !== $scope.report.table_content.length) {
                $scope.report.pageNumber = $scope.report.pageNumber + 1;
                refresh($scope.report.pageNumber).then(
                    function (data) {
                        if (data.status === 0) {
                            $scope.report.totalElements = data.result.reportStudent.totalElements;
                            $scope.report.table_content = _.union($scope.report.table_content, data.result.reportStudent.content);
                            $timeout(function () {
                                $scope.$broadcast('scroll.infiniteScrollComplete');
                            });
                        }
                    }
                );
            }
        };

        $scope.$on('$stateChangeSuccess', function () {
            $scope.loadMore();
        })

    }

    addReportStu.$inject = ['$scope', '$location', '$state', '$timeout', 'receivePromiseService', 'reportUtilService', 'dataService'];


    //添加学生
    function addReportStu($scope, $location, $state, $timeout, receivePromiseService, reportUtilService, dataService) {

        $scope.report = {
            table_serach: false,
            table_content: [],
            selected: [],
            enrolls: [],
            pageNumber: 0,
            totalElements: 0,
            gradeId: '',
            enrollType: '',
            queryValue: ''
        };

        function initAttr() {
            $scope.report.table_content = [];
            $scope.report.selected = [];
            $scope.report.totalElements = 0;
            $scope.report.pageNumber = 0;
        }

        function getGrade() {
            receivePromiseService.getGrade($scope.report, 'grades')
                .then(
                    function () {
                        reportUtilService.initAttr($scope.report.grades, 'isClick', false);
                        dataService.getEnrolls($scope.report);
                        selectEnrolls('');
                    }
                );
        };

        getGrade();

        function queryNoClassStu(num) {
            initAttr();
            return receivePromiseService.queryNoClassStu({
                pageSize: 20,
                pageNumber: num ? num : 0,
                gradeId: $scope.report.gradeId,
                enrollType: $scope.report.enrollType,
                queryValue: $scope.report.queryValue
            }).then(
                function (data) {
                    if (data.status == 0) {
                        $scope.report.totalElements = data.result.totalElements;
                        $scope.report.table_content = _.union($scope.report.table_content, data.result.content);
                        reportUtilService.initAttr($scope.report.table_content, 'isClick', false);
                        $timeout(function () {
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        });
                    }
                }
            );
        };

        queryNoClassStu();

        function refresh(num) {
            return receivePromiseService.queryNoClassStu({
                pageSize: 20,
                pageNumber: num ? num : 0,
                gradeId: $scope.report.gradeId,
                enrollType: $scope.report.enrollType,
                queryValue: $scope.report.queryValue
            });
        };

        $scope.loadNoClassMore = function () {
            if ($scope.report.totalElements && $scope.report.totalElements !== $scope.report.table_content.length) {
                $scope.report.pageNumber = $scope.report.pageNumber + 1;
                refresh($scope.report.pageNumber).then(
                    function (data) {
                        if (data && data.status === 0) {
                            $scope.report.totalElements = data.result.totalElements;
                            $scope.report.table_content = _.union($scope.report.table_content, data.result.content);
                            $timeout(function () {
                                $scope.$broadcast('scroll.infiniteScrollComplete');
                            });
                        }
                    }
                );
            }
        };

        $scope.$on('$stateChangeSuccess', function () {
            $scope.loadNoClassMore();
        })

        /**
         * 选中下拉值【招生类型】
         * @param id
         */
        function selectEnrolls(id){
            angular.forEach($scope.report.enrolls,function (value) {
                value.isClick = false;
                if(id === value.id){
                    value.isClick = true;
                    $scope.report.enrollName = value.name;
                    $scope.report.enrollType = value.id;
                }
            })
        }
        $scope.changeEnroll = function (id) {
            selectEnrolls(id);
            queryNoClassStu();
        }

        $scope.changeGrade = function (g) {
            reportUtilService.initAttr($scope.report.grades, 'isClick', false);
            if (Object.prototype.toString.apply(g) === "[object Object]") {
                g.isClick = true;
                $scope.report.gradebar = g.name + '未分班学生';
                $scope.report.gradeId = g.id;
            } else {
                $scope.report.gradeId = '';
                $scope.report.gradebar = '所有未分班学生';
            }
            queryNoClassStu();
        };

        $scope.selectNoClassStu = function (s) {
            s.isClick = !s.isClick;
            $scope.report.selected = reportUtilService.filterArrByAttr($scope.report.table_content, 'isClick', true);
        }

        $scope.changeAll = function (b) {
            if (b) {
                reportUtilService.initAttr($scope.report.table_content, 'isClick', false);
            } else {
                reportUtilService.initAttr($scope.report.table_content, 'isClick', true);
            }
            $scope.report.selected = reportUtilService.filterArrByAttr($scope.report.table_content, 'isClick', true);
        };

        $scope.to_serach = function () {
            $scope.report.table_serach = true;
            $scope.report.queryValue = '';
            initAttr();
        };

        $scope.clearInfo = function (attr) {
            $scope.report[attr] = '';
        };

        $scope.doFresh = function () {
            getGrade();
            queryNoClassStu();
        }

        $scope.serachByInfo = function () {
            initAttr();
            var promise = refresh();
            promise.then(
                function (data) {
                    if (data.status === 0) {
                        $scope.report.totalElements = data.result.totalElements;
                        $scope.report.table_content = _.union($scope.report.table_content, data.result.content);
                        $timeout(function () {
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        });
                    }
                }
            )
            return promise;
        }

        $scope.cancel = function () {
            $scope.report.queryValue = '';
            $scope.report.table_serach = false;
            $scope.report.table_content = [];
            $scope.report.pageNumber = 0;
            $scope.report.totalElements = 0;
            queryNoClassStu();
        };


        $scope.to_last_page = function () {
            $state.go("report_detail", {}, {reload: true});
        }

        $scope.addStudent = function () {
            $scope.report.selected = reportUtilService.filterArrByAttr($scope.report.table_content, 'isClick', true);
            if ($scope.report.selected.length === 0) {
                $location.path("/report_detail");
            } else {
                var userIds = reportUtilService.getValuesByAttr($scope.report.selected, 'id');
                var reportTaskId = dataService.getcurrentData('currentTask').id,
                    reportAdminClassId = dataService.getcurrentData('currentClass').id;
                receivePromiseService.addStudent({
                    userIds: userIds,
                    moraleduReportAdminClassId: reportAdminClassId,
                    moraleduReportTaskId: reportTaskId
                }).then(
                    function (data) {
                        if (data.status == 0) {
                            reportUtilService.showMsg('添加成功！');
                            $timeout(function () {
                                $state.go("report_detail", {}, {reload: true});
                            }, 500);
                        } else {
                            reportUtilService.showMsg("添加失败！");
                        }
                    }
                );
            }
        };

    }


    confirmationStudentCtrl.$inject = ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$ionicModal","$state","$ionicPopup"];

    function confirmationStudentCtrl($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $ionicModal,$state,$ionicPopup) {

        var basePath = originBaseUrl + "/third/holiday/stu";

        $scope.getPage = getPage;
        $scope.clickClass = clickClass;
        $scope.clickTask = clickTask;
        $scope.removeStu = removeStu;
        $scope.getClassStudent = getClassStudent;
        $scope.itemCheckboxClick = itemCheckboxClick;
        $scope.getStuCount = getStuCount;
        $scope.clickAll = clickAll;
        $scope.submitStu = submitStu;
        $scope.checkGender = checkGender;
        $scope.updateReason = updateReason;
        $scope.checkReasonCode = checkReasonCode;
        $scope.getStayInSchoolReason = getStayInSchoolReason;
        $scope.copyClassStudent = copyClassStudent;
        $scope.reasonCodeHide = reasonCodeHide;
        $scope.cancelCopy = cancelCopy;
        $scope.submitCopy = submitCopy;
        $scope.clickReason = clickReason;
        $scope.showGenderButton = showGenderButton;
        $scope.selectCopyTask = selectCopyTask;

        $scope.toAnother = function(){
            $state.go('report_detail');
        }

        $scope.data = {
            pageSize:8,
            pageNumber:0,
            error:false,
            conditionFlag:true,
            lastPage:false,
            message:"暂未添加留校生！",
            adminClassList:[],
            reasonList:[],
            taskList:[],
            stuList:[],
            checkboxList:[],
            isAll:false,
            searchData:{
                classInfo:null,
                taskInfo:null,
                gender:null,
                stuInfo:null,
                reasonCode:{
                    code:"",
                    name:"请选择",
                    reason:""
                }
            }
        };

        function goTop() {
            $ionicScrollDelegate.$getByHandle('confirmationStudentsMsgScroll').scrollTop(true);
        }

        function clickClass(classInfo) {
            $scope.data.searchData.classInfo = classInfo;
            $scope.data.pageNumber = 0;
            getHolidayTask();
        }

        function clickTask(taskInfo) {
            $scope.data.searchData.taskInfo = taskInfo;
            $scope.data.pageNumber = 0;
            $scope.data.stuList = [];
            getHolidayStuPage();
        }

        function getPage(type) {
            if (type === 1){
                $scope.data.pageNumber++;
            }
            getHolidayStuPage(type);
        }

        function getHolidayStuPage(type) {
            var param = {
                pageNumber:$scope.data.pageNumber,
                pageSize:$scope.data.pageSize,
                taskId:$scope.data.searchData.taskInfo.id,
                classId:$scope.data.searchData.classInfo.id
            };
            $http.post(basePath + "/getHolidayStuPage.htm",param).success(function (data) {
                if (data.status == 0) {
                    $scope.data.error = false;
                    $scope.data.lastPage = angular.copy(data.result.lastPage);
                    if (type === 1){
                        $scope.data.stuList = $scope.data.stuList.concat(angular.copy(data.result.content));
                    }else {
                        $scope.data.stuList = angular.copy(data.result.content);
                        goTop();
                    }

                    if (!($scope.data.stuList && $scope.data.stuList.length > 0)){
                        $scope.data.error = true;
                        $scope.data.message = "暂未添加留校生！";
                    }
                } else {
                    $scope.data.message = data.message;
                    $scope.data.error = true;
                }

                $timeout(()=>{
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                },50)
            });
        }

        function getHolidayTask(){
            $http.post(basePath + "/getHolidayTask.htm",{classId:$scope.data.searchData.classInfo.id}).success(function (data) {
                if (data.status == 0) {
                    $scope.data.error = false;
                    $scope.data.conditionFlag = false;
                    $scope.data.taskList = angular.copy(data.result.tasks);
                    if (data.result.tasks && data.result.tasks.length > 0){
                        angular.forEach(data.result.tasks,function (task) {
                            if (data.result.currentTaskId === task.id){
                                $scope.data.searchData.taskInfo = task;
                            }
                        });
                        getHolidayStuPage();
                    }else {
                        $scope.data.error = true;
                        $scope.data.conditionFlag = true;
                        $scope.data.message = "无可留校节假日任务";
                        $scope.data.searchData.taskInfo = {
                            name:"无可留校节假日任务"
                        };
                    }
                } else {
                    $scope.data.message = data.message;
                    $scope.data.error = true;
                    $scope.data.conditionFlag = true;
                }
            });
        }

        function getTeacherClass(){
            $http.post(basePath + "/getTeacherClass.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.data.error = false;
                    $scope.data.conditionFlag = false;
                    $scope.data.adminClassList = angular.copy(data.result.adminClass);
                    if ($scope.data.adminClassList && $scope.data.adminClassList.length > 0){
                        $scope.data.searchData.classInfo = $scope.data.adminClassList[0];
                    }
                    getHolidayTask();

                } else {
                    $scope.data.message = data.message;
                    $scope.data.error = true;
                    $scope.data.conditionFlag = true;
                }
            });
        }

        function removeStu(item) {
            $http.post(basePath + "/delStu.htm",{id:item.id}).success(function (data) {
                if (data.status == 0) {
                    ynuiNotification.success({msg: '移除成功！'});
                    $scope.data.pageNumber = 0;
                    getHolidayStuPage();
                } else {
                    ynuiNotification.error({msg: '移除失败！'});
                }
            });
        }


        function getClassStudent(type) {
            $scope.data.searchData.stuInfo = null;
            if (!type){
                $scope.data.searchData.gender = null;
            }
            var param = {
                classId:$scope.data.searchData.classInfo.id,
                taskId:$scope.data.searchData.taskInfo.id,
                gender:$scope.data.searchData.gender
            };
            $http.post(basePath + "/getClassStudent.htm",param).success(function (data) {
                if (data.status == 0) {
                    $scope.data.checkboxList = angular.copy(data.result);
                    if ($scope.data.checkboxList && $scope.data.checkboxList.length > 0){
                        if (!type){
                            searchShow();
                        }
                    }else if ($scope.data.searchData.gender) {
                        ynuiNotification.error({msg: '没有相关数据！'});
                    }else {
                        ynuiNotification.error({msg: '住宿生已全部添加为留校生！'});
                    }

                } else if (data.status == 10) {
                    ynuiNotification.error({msg: data.message});
                }else {
                    ynuiNotification.error({msg: '获取学生失败！'});
                }
            });
        }

        function submitStu() {
            if (!$scope.data.searchData.reasonCode.code){
                ynuiNotification.error({msg: '请选择留校原因！'});
                return false;
            }
            // 单个修改
            if ($scope.data.searchData.stuInfo) {
                var param = {
                    id:$scope.data.searchData.stuInfo.id,
                    reasonCode:$scope.data.searchData.reasonCode.code,
                    reason:$scope.data.searchData.reasonCode.reason
                };
                $http.post(basePath + "/updateStu.htm",param).success(function (data) {
                    if (data.status == 0) {
                        ynuiNotification.success({msg: '操作成功！'});
                        reasonCodeHide();
                        searchHide();
                        $scope.data.pageNumber = 0;
                        getHolidayStuPage();
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                });
            }else {
                var stuIds =[];
                angular.forEach($scope.data.checkboxList,function (value) {
                    if (value.select){
                        stuIds.push(value.id);
                    }
                });
                if (stuIds.length === 0){
                    ynuiNotification.error({msg: '至少勾选一项！'});
                    return false;
                }

                var param = {
                    stuIds:stuIds,
                    taskId:$scope.data.searchData.taskInfo.id,
                    reasonCode:$scope.data.searchData.reasonCode.code,
                    reason:$scope.data.searchData.reasonCode.reason
                };
                $http.post(basePath + "/saveStu.htm",param).success(function (data) {
                    if (data.status == 0) {
                        ynuiNotification.success({msg: '操作成功！'});
                        reasonCodeHide();
                        searchHide();
                        $scope.data.pageNumber = 0;
                        getHolidayStuPage();
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                });
            }


        }

        function checkGender(type) {
            if (type === $scope.data.searchData.gender){
                $scope.data.searchData.gender = null;
            }else {
                $scope.data.searchData.gender = type;
            }
            getClassStudent(1);
        }

        function clickAll() {
            $scope.data.isAll = !$scope.data.isAll;
            angular.forEach($scope.data.checkboxList,function (value) {
                value.select = $scope.data.isAll;
            });
        }

        function getStuCount() {
            var count = 0;
            angular.forEach($scope.data.checkboxList,function (value) {
                if (value.select){
                    count++;
                }
            });
            $scope.data.isAll = count === $scope.data.checkboxList.length;
            return count;
        }
        function itemCheckboxClick(item) {
            item.select = !item.select;
        }

        function checkReasonCode(info) {
            $scope.data.searchData.reasonCode.code = info.dictCode;
            $scope.data.searchData.reasonCode.name = info.dictName;
        }

        function updateReason(item) {
            getStayInSchoolReason(item);
        }

        function clickReason(info) {
            $scope.data.searchData.reasonCode.code = info.dictCode;
            $scope.data.searchData.reasonCode.name = info.dictName;
        }

        // 是否显示按钮
        function showGenderButton(type) {
            var flag = false , str = type === 1?"男":"女";
            if ($scope.data.checkboxList){
                angular.forEach($scope.data.checkboxList,function (item) {
                    if (item.userNumber.indexOf(str) > -1){
                        flag = true;
                    }
                });
            }
            return flag;
        }

        function getStayInSchoolReason(item) {
            $scope.data.searchData.reasonCode.code = null;
            $scope.data.searchData.reasonCode.name = '请选择';
            $scope.data.searchData.reasonCode.reason = null;
            if (!item){
                var stuIds =[];
                angular.forEach($scope.data.checkboxList,function (value) {
                    if (value.select){
                        stuIds.push(value.id);
                    }
                });
                if (stuIds.length === 0){
                    ynuiNotification.error({msg: '至少勾选一项！'});
                    return false;
                }
            }else {
                $scope.data.searchData.stuInfo = item;
                $scope.data.searchData.reasonCode.reason = item.reason;
                $scope.data.searchData.reasonCode.code = item.reasonCode;
                $scope.data.searchData.reasonCode.name = item.reasonName;
            }

            $http.post(basePath + "/getStayInSchoolReason.htm").success(function (data) {
                if (data.status == 0) {
                    if (data.result && data.result.length > 0){
                        $scope.data.reasonList = angular.copy(data.result);
                        if (!item){
                            $scope.data.searchData.reasonCode.code = data.result[0].dictCode;
                            $scope.data.searchData.reasonCode.name = data.result[0].dictName;
                        }
                        reasonCodeShow();
                    }else {
                        ynuiNotification.error({msg: '无留校原因！'});
                    }
                }
            });
        }


        //提交复制
        function submitCopy() {
            $http.post(basePath+"/copyStuFromOther.htm",{holidayTaskId : $scope.data.searchData.taskInfo.id, sourceTaskId : $scope.copyTaskInfo.id, classId : $scope.data.searchData.classInfo.id}).success(function (data) {
                if (data.status === 0){
                    cancelCopy();
                    ynuiNotification.success({msg: '复制成功！'});
                    clickTask($scope.data.searchData.taskInfo);
                }else {
                    ynuiNotification.error({msg: '操作失败！'});
                }
            });
        }

        //复制留校生名单
        function copyClassStudent() {
            copyShow();
        }



        $ionicModal.fromTemplateUrl('copyFromOtherTask.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.copyFromOtherTaskModal = modal;
        });

        function selectCopyTask(info){
            $scope.copyTaskInfo = info;
        }

        function copyShow(){
            //处理下拉列表
            $scope.copyTaskList = [];
            $scope.copyTaskInfo = {id:"",name:"请选择节假日任务"};
            //查询可复制的节假日任务
            $http.get(basePath + "/getCanCopyList.htm?classId=" + $scope.data.searchData.classInfo.id).success(function(data){
                if(data.status === 0){
                    angular.forEach(data.result, function(task){
                        if($scope.data.searchData.taskInfo.id !== task.id){
                            $scope.copyTaskList.push(task);
                        }
                    });
                    if($scope.copyTaskList.length === 0){
                        ynuiNotification.error({msg: "没有可复制的节假日任务留校名单！"});
                        return false;
                    }
                    $scope.copyFromOtherTaskModal.show();
                }
            });
        }

        function cancelCopy(){
            $scope.copyFromOtherTaskModal.hide();
        }


        function init() {
            getTeacherClass();
        }

        init();


        $ionicModal.fromTemplateUrl('reasonCode.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.reasonCodeModal = modal;
            if (modal.el){
                $(modal.el).addClass('reason-z-index');
            }
        });

        function reasonCodeShow(){
            $scope.reasonCodeModal.show();
        }

        function reasonCodeHide(){
            $scope.reasonCodeModal.hide();
        }



        $ionicModal.fromTemplateUrl('studentList.html', {
            scope: $scope,
            animation: 'slide-in-left'
        }).then(function (modal) {
            $scope.searchModal = modal;
        });

        function searchShow(){
            $scope.data.searchData.gender = null;
            $scope.data.isAll = false;
            $scope.searchModal.show();
        }

        function searchHide(){
            $scope.searchModal.hide();
        }


        function cordovaFileOpenSuccess() {
            // 从已安装程序中打开文件完成
        }

        function cordovaFileOpenError(code) {
            if (code === 1) {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '未能在手机已安装APP中找到可预览此文件的程序'
                });
            } else {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '预览时发生了未知错误 #' + code
                });
            }
        }

        // 预览照片
        $scope.previewPhoto = function (photo) {
            if(photo.uri){
                var cordovaFileOpen = cordova.plugins.disusered.open;
                cordovaFileOpen(originBaseUrl+"/file/downloadStream.htm?fastDFSId="+photo.uri, cordovaFileOpenSuccess, cordovaFileOpenError);
            }

        };


    }



})();










