/**
 * 归寝宿管员端
 */
angular.module('starter')
    .controller('returnDormitoryAdminRoomController', ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification',
        '$timeout', '$ionicScrollDelegate', "$ionicLoading", '$state', '$ionicPopup',"$stateParams","storageService",
        function ($scope, $ionicModal, $http, $location, ynuiNotification, $timeout, $ionicScrollDelegate,
                  $ionicLoading, $state, $ionicPopup,$stateParams,storageService) {

        var basePath = originBaseUrl + "/third/newss/mobile";

        // 子页面返回参数
        var oldVm = null;
        var backSearchInfoOld = angular.fromJson($stateParams.backSearchInfo);
        if (backSearchInfoOld){
            oldVm = storageService.getItemNoDel($state.current.name);
        }

        $scope.searchShow = searchShow;
        $scope.searchHide = searchHide;
        $scope.filterStuList = filterStuList;
        $scope.selectRoom = selectRoom;
        $scope.getPage = getPage;
        $scope.clickAll = clickAll;
        $scope.showSubmit = showSubmit;
        $scope.hideSubmit = hideSubmit;
        $scope.getActiveClass = getActiveClass;
        $scope.clickActiveClass = clickActiveClass;
        $scope.realSaveAll = realSaveAll;
        $scope.clickAbnormal = clickAbnormal;
        $scope.roomStatusTotalShow = roomStatusTotalShow;
        $scope.roomStatusTotalShowCount = roomStatusTotalShowCount;
        $scope.opRoomDetailInfo = opRoomDetailInfo;
        $scope.totalDetail = totalDetail;

        $scope.data = {
            isError:false,
            errorMessage:"没有相关数据",
            isAll:false,
            isInit:true,
            lastPage:true,
            searchValue: {
                status:null,
                type:"",
                name:""
            },
            stuCountTotal:0,
            totalElements:0,
            statusActive:'',
            activeStatusClass:0,
            nowDate: {},
            roomStatusTotal:[],
            roomList:[],
            selectRoomCount:0,
            pageSize:6,
            pageNumber:0,
            msgStatus: {}
        };

        function totalDetail() {
            $http.get(basePath + "/totalDetail.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.showTotalDetail = angular.copy(data.result);
                    $ionicPopup.alert({
                        title: "您负责<strong>"+$scope.showTotalDetail.roomCount+"</strong>间寝室",
                        templateUrl: 'templates/return_dormitory/admin/total_detail.html',
                        scope: $scope
                    });
                }
            });

        }

        function filterStuList(status) {
            $scope.data.statusActive = status;
            $scope.data.pageNumber = 0;
            getBuildPage();
        }

        function findDateStr() {
            $http.get(basePath + "/checkStuData.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.data.nowDate = data.result;
                    $scope.data.isError = false;
                    $scope.data.errorMessage = "没有相关数据";
                    getBuildStatusTotal();
                }else if (data.status == 10){
                    $scope.data.isError = true;
                    $scope.data.nowDate = data.result;
                    $scope.data.errorMessage = data.message;
                }else {
                    $scope.data.isError = true;
                    $scope.data.errorMessage = "数据加载失败";
                }
            });
        }

        function getBuildStatusTotal(type) {
            var param = {
                roleType:2,
                type:$scope.data.searchValue.type,
                name:$scope.data.searchValue.name,
                date:$scope.data.nowDate.commonVO.id
            };
            $http.post(basePath + "/getBuildStatusTotal.htm",param).success(function (data) {
                if (data.status == 0) {
                    $scope.data.roomStatusTotal = angular.copy(data.result);
                    var total = 0 , isStatus = false , isActive = false;
                    angular.forEach($scope.data.roomStatusTotal,function (value) {
                        total += value.count;
                        if (value.status === 5){
                            isStatus = true;
                        }
                        if ($scope.data.statusActive === value.status){
                            isActive = true;
                        }
                    });
                    if ($scope.data.isInit && isStatus){
                        $scope.data.statusActive = 5;
                    }else if (!isActive){
                        // 默认全部
                        $scope.data.statusActive = '';
                    }
                    $scope.data.stuCountTotal = total;
                    getBuildPage(type);
                    $scope.data.isInit = false;
                }
            });
        }

        function getBuildPage(type) {
            var param = getSearchInfo();
            $http.post(basePath + "/getBuildPage.htm",param).success(function (data) {
                if (data.status == 0) {
                    $scope.data.lastPage = angular.copy(data.result.lastPage);
                    $scope.data.totalElements = angular.copy(data.result.totalElements);
                    if (type === 1){
                        if ($scope.data.statusActive === 5){
                            angular.forEach(data.result.content,function (value) {
                                value.select = true;
                            });
                        }
                        $scope.data.roomList = $scope.data.roomList.concat(angular.copy(data.result.content));
                        // 统计勾选
                        var count = 0,selectCount = 0;
                        angular.forEach($scope.data.roomList,function (selectValue) {
                            if (selectValue.select){
                                count += selectValue.count;
                                selectCount++;
                            }
                        });
                        $scope.data.selectRoomCount = count;
                        $scope.data.isAll = $scope.data.selectRoomCount === $scope.data.roomList.length;
                    }else {
                        $scope.data.roomList = angular.copy(data.result.content);
                        // 默认选中 待打卡寝室
                        if ($scope.data.statusActive === 5){
                            angular.forEach($scope.data.roomList,function (value) {
                                value.select = true;
                            });
                            $scope.data.isAll = true;
                            angular.forEach($scope.data.roomStatusTotal,function (value) {
                                if (value.status === $scope.data.statusActive){
                                    $scope.data.selectRoomCount = value.count;
                                }
                            });
                        }else {
                            $scope.data.isAll = false;
                            $scope.data.selectRoomCount = 0;
                        }
                        goTop();
                    }




                    // 返回处理 设置默认值
                    if (backSearchInfoOld && oldVm){
                        $scope.data.pageNumber = oldVm.pageNumber;
                        $scope.data.pageSize = 8;
                        // 跳转到指定位置
                        if (oldVm.roomId){
                            scroll(oldVm.roomId);
                        }
                        backSearchInfoOld = null;
                        oldVm = null;
                    }
                }
                $timeout(()=>{
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                },50)
            });
        }

        function scroll(id){
            $ionicScrollDelegate.$getByHandle('returnDormitoryAdminScroll').anchorScroll('#'+$location.hash(id));
        }

        function getSearchInfo(flag) {
            var param = {
                date:$scope.data.nowDate.commonVO.id,
                type:$scope.data.searchValue.type,
                name:$scope.data.searchValue.name,
                status:$scope.data.statusActive,
                pageNumber:$scope.data.pageNumber,
                pageSize:$scope.data.pageSize
            };
            if (flag){
                return angular.toJson(param);
            }else {
                return  param;
            }

        }

        function getPage(type) {
            if (type === 1){
                $scope.data.pageNumber++;
                getBuildPage(type);
            }else if (type === 2){
                $scope.data.pageNumber = 0;
                getBuildStatusTotal(type);
            }

        }

        function selectRoom(item) {
            item.select = !item.select;
            var count = 0;
            angular.forEach($scope.data.roomList,function (value) {
                if (value.select){
                    count += value.count;
                }
            });
            $scope.data.isAll = count === $scope.data.roomList.length;
            $scope.data.selectRoomCount = count;
        }

        function clickAll() {
            $scope.data.isAll = !$scope.data.isAll;
            if ($scope.data.isAll){
                angular.forEach($scope.data.roomList,function (value) {
                    value.select = true;
                });
                // 显示对应状态数量
                if ($scope.data.statusActive == ''){
                    $scope.data.selectRoomCount = $scope.data.stuCountTotal;
                }else {
                    angular.forEach($scope.data.roomStatusTotal,function (value) {
                        if (value.status === $scope.data.statusActive){
                            $scope.data.selectRoomCount = value.count;
                        }
                    });
                }

            }else {
                $scope.data.selectRoomCount = 0;
                angular.forEach($scope.data.roomList,function (value) {
                    value.select = false;
                });
            }
        }

        function goTop() {
            $ionicScrollDelegate.$getByHandle('returnDormitoryAdminScroll').scrollTop(true);
        }

        function getActiveClass(type) {
            return $scope.data.activeStatusClass === type;
        }

        function clickActiveClass(type) {
            $scope.data.activeStatusClass = type;
        }

        function roomStatusTotalShow(type,list) {
            var flag = false;
            angular.forEach(list,function (value) {
                if (value.status === type){
                    flag = true;
                }
            });
            return flag;
        }

        function roomStatusTotalShowCount(type,list) {
            var count = 0;
            angular.forEach(list,function (value) {
                if (value.status === type){
                    count = value.count;
                }
            });
            return count;
        }

        function realSaveAll() {
            // 全部提交
            var roomIds = [];
            if (!$scope.data.isAll){
                // 部分提交
                angular.forEach($scope.data.roomList,function (value) {
                    if (value.select){
                        roomIds.push(value.id);
                    }
                });
            }

            var param = {
                roomIds:roomIds,
                date:$scope.data.nowDate.commonVO.id,
                type:$scope.data.searchValue.type,
                name:$scope.data.searchValue.name,
                status:$scope.data.activeStatusClass,
                searchStatus:$scope.data.statusActive
            };
            $http.post(basePath + "/roomRegistraion.htm",param).success(function (data) {
                if (data.status == 0) {
                    $scope.data.pageNumber = 0;
                    findDateStr();
                    $scope.data.activeStatusClass = 0;
                    $scope.data.isAll = false;
                }else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: data.message
                    });
                }
                hideSubmit();
            });
        }

        function clickAbnormal() {
            var backSearchInfo = getSearchInfo();
            backSearchInfo.showDate = $scope.data.nowDate.commonVO.id;
            backSearchInfo.showWeek = $scope.data.nowDate.commonVO.userNumber;
            storageService.setItem($state.current.name,backSearchInfo);
            $state.go("dormitory_abnormal");
        }


        function opRoomDetailInfo(item) {
            var backSearchInfo = getSearchInfo();
            backSearchInfo.roomId = item.id;
            storageService.setItem($state.current.name,backSearchInfo);
            $state.go("admin_dormitory_msg_by_sub");

        }

        function initFun() {
            // 分页处理
            if (backSearchInfoOld && oldVm){
                $scope.data.pageSize =  (oldVm.pageNumber + 1)*8;
                $scope.data.pageNumber = 0;
                // 查询条件
                 $scope.data.searchValue.type = oldVm.type;
                 $scope.data.searchValue.name = oldVm.name;
                 $scope.data.statusActive = oldVm.status;
            }
            findDateStr();
        }

        initFun();


        $ionicModal.fromTemplateUrl('submitFlag.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.submitModal = modal;
        });

        function showSubmit(){
            if ($scope.data.selectRoomCount){
                $scope.submitModal.show();
            }else {
                $ionicPopup.alert({
                    title: '提示',
                    template: '至少勾选一项！'
                });
            }

        }

        function hideSubmit(){
            $scope.submitModal.hide();
            $scope.data.activeStatusClass = 0;
        }


        $ionicModal.fromTemplateUrl('search.html', {
            scope: $scope,
            animation: 'slide-in-left'
        }).then(function (modal) {
            $scope.searchModal = modal;
        });

        function searchShow(){
            $scope.searchModal.show();
        }

        function searchHide(){
            $scope.searchModal.hide();
        }




//单个寝室登记controller
    }])
    .controller('returnDormitoryAdminRoomOperatorController', ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification', '$filter',
        '$ionicScrollDelegate','$ionicPopup','$timeout', "ynNavigator","$state","$stateParams","storageService",
        function ($scope, $ionicModal, $http, $location, ynuiNotification, $filter, $ionicScrollDelegate,$ionicPopup,
                  $timeout, ynNavigator,$state,$stateParams,storageService) {

        // 寝室列表传入数据
        var oldVm = storageService.getItemNoDel($state.current.data.prev);
        var roomId = oldVm.roomId;
        var date = oldVm.date;
        // 子页面返回参数
        var backSearchInfoOld = angular.fromJson($stateParams.backSearchInfo);
        if (backSearchInfoOld){
            date = backSearchInfoOld.date;
            roomId = backSearchInfoOld.roomId;
        }

        if (!date || !roomId) {
            return;
        }
        $scope.callPhone = callPhone;
        $scope.filterStuList = filterStuList;
        $scope.saveByRoom = saveByRoom;
        $scope.initFun = initFun;
        $scope.getStatusCount = getStatusCount;
        $scope.clickAll = clickAll;
        $scope.selectRoom = selectRoom;
        $scope.goDetailInfo = goDetailInfo;
        $scope.updateStuStatus = updateStuStatus;
        $scope.opAllStu = opAllStu;
        $scope.opItem = opItem;
        $scope.getActiveClass = getActiveClass;
        $scope.clickActiveClass = clickActiveClass;
        $scope.hideSubmit = hideSubmit;
        $scope.realSaveAll = realSaveAll;
        $scope.getClassUsers = getClassUsers;

        var basePath = originBaseUrl + "/third/newss/mobile";
        $scope.data = {
            isAll: false,
            statusActive: "",
            updateStatusActive: 0,
            room: {},
            selectCount:0,
            stuToSaveIds:[],
            selectStu:null
        };


        function filterStuList(status) {
            // $state.go($state.current.data.prev, {backSearchInfo: angular.toJson(oldVm)});
            if (status === '') {
                $scope.data.room.showStuList = angular.copy($scope.data.room.stuItemInfoList);
            } else {
                $scope.data.room.showStuList = $filter('filter')($scope.data.room.stuItemInfoList, {status: status});
            }
            $scope.data.statusActive = status;
            $ionicScrollDelegate.$getByHandle('returnDormitoryAdminMsgScroll').scrollTop(true);
        }

        function getStatusCount(status) {
            var count = 0;
            if ($scope.data.room && $scope.data.room.stuItemInfoList && $scope.data.room.stuItemInfoList.length > 0){
                if (status === ''){
                    count = $scope.data.room.stuItemInfoList.length;
                }else {
                    // 列表显示
                    angular.forEach($scope.data.room.stuItemInfoList,function (value) {
                        if (status === value.status){
                            count++;
                        }
                    });
                }
            }
            return count;
        }


        function selectRoom(item) {
            item.select = !item.select;
            var count = 0;
            angular.forEach($scope.data.room.showStuList,function (value) {
                if (value.select){
                    count++;
                }
            });
            $scope.data.selectCount = count;
            $scope.data.isAll = count === $scope.data.room.showStuList.length;
        }

        function clickAll() {
            $scope.data.isAll = !$scope.data.isAll;
            angular.forEach($scope.data.room.showStuList,function (value) {
                value.select = $scope.data.isAll;
            });
            if ($scope.data.isAll){
                $scope.data.selectCount = $scope.data.room.showStuList.length;
            }else {
                $scope.data.selectCount = 0;
            }
        }

        function goDetailInfo(item,type) {
            $scope.data.selectStu = item;
            $scope.data.stuToSaveIds = [item.id];
            if (type){
                // 请假、实习
                opItem(type)
            }else {
                $scope.submitRoomFlagModalShow();
            }
        }

        function opItem(type) {
            if (type){
                $scope.submitRoomFlagModalHide();
            }
            $scope.opStatusModalHide();
            if (type){
                var backSearchInfo = {};
                backSearchInfo.stuId = $scope.data.selectStu.id;
                backSearchInfo.date = date;
                backSearchInfo.roomId = roomId;
                backSearchInfo.status = $scope.data.statusActive;
                if (type === 1){
                    // 请假
                    $location.path("/leave_info").search({backSearchInfo:angular.toJson(backSearchInfo),backUrl: $state.current.name,title:$state.current.data.title});
                }else {
                    // 实习
                    $location.path("/activity_info").search({backSearchInfo:angular.toJson(backSearchInfo),backUrl:$state.current.name,title:$state.current.data.title});
                }

            }else {
                $scope.submitRoomFlagModalShow();
            }
        }

        function opAllStu() {
            var ids = [];
            angular.forEach($scope.data.room.showStuList,function (value) {
                if (value.select){
                    ids.push(value.id);
                }
            });
            if (ids.length === 0){
                $ionicPopup.alert({
                    title: '提示',
                    template: '至少勾选一项！'
                });
            }else {
                $scope.data.stuToSaveIds = ids;
                showSubmit();
            }

        }

        function updateStuStatus(status) {
            var param = {
                date:date,
                id:roomId,
                stuIds:$scope.data.stuToSaveIds,
                status:status
            };
            $http.post(basePath + "/userRegistration.htm",param).success(function (data) {
                if (data.status === 0) {
                    ynuiNotification.success({msg: '保存成功'});
                    getStatusTotal();
                }else {
                    $scope.data.statusList = [];
                }
            });

            $scope.submitRoomFlagModalHide();
        }


        $scope.realRoomSave = function () {
            var saveList = [] ;
            angular.forEach($scope.data.stuList, function (item) {
                if (item.status == null){
                    item.status = 0;
                }
                saveList.push({stuId: item.stuId, roomId: roomId, status: item.status, sysStatus: item.sysStatus});
            });
            var data = {jsonStr: angular.toJson(saveList, true), date: date};
            $http.post(basePath + "/saveOrUpdateReturnSleep.htm", data).success(function (data) {
                if (data.status == 0) {
                    ynuiNotification.success({msg: '保存成功'});
                    $scope.submitRoomFlagModalHide();
                } else {
                    ynuiNotification.error({msg: data.message});
                }
            });
        }

        function saveByRoom() {
            var saveList = [] , flag = false;
            angular.forEach($scope.data.stuList, function (item) {
                if (item.status == null){
                    flag = true;
                }
                saveList.push({stuId: item.stuId, roomId: roomId, status: item.status, sysStatus: item.sysStatus});
            });
            if (flag){
                $scope.submitRoomFlagModalShow();
            }else {
                var data = {jsonStr: angular.toJson(saveList, true), date: date};
                $http.post(basePath + "/saveOrUpdateReturnSleep.htm", data).success(function (data) {
                    if (data.status == 0) {
                        ynuiNotification.success({msg: '保存成功'});
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }
                });
            }

        }

        function getStatusTotal() {
            var param = {
                roleType:2,
                date:date,
                showType:1,
                roomIds:[roomId]
            };
            $http.post(basePath + "/getSSRoomShowItemList.htm",param).success(function (data) {
                if (data.status === 0) {
                    var old = angular.copy(data.result);
                    // 总寝室人数
                    old.showStuList = old.stuItemInfoList;
                    $scope.data.room = angular.copy(old);
                    // 班主任
                    if (old.commonVOList && old.commonVOList.length > 1){
                        var list = [];
                        angular.forEach(old.commonVOList,function (value) {
                            list.push(value.name);
                        });
                        $scope.data.room.users = list.join(",");
                    }
                    $scope.data.selectCount = 0;
                    // 默认
                    if (backSearchInfoOld){
                        var flag = false;
                        angular.forEach(old.stuItemInfoList,function (newValue) {
                            if (newValue.status === backSearchInfoOld.status){
                                flag = true;
                            }
                        });
                        if (flag){
                            $scope.data.statusActive = backSearchInfoOld.status;
                        }else {
                            $scope.data.statusActive = '';
                        }
                        filterStuList($scope.data.statusActive);
                        backSearchInfoOld = null;
                    }else {
                        filterStuList($scope.data.statusActive);
                    }
                }else {
                    $scope.data.statusList = [];
                    $scope.data.room = {};
                }
            });
        }

        function getActiveClass(status) {
            return status == $scope.data.updateStatusActive;
        }

        function clickActiveClass(status) {
            $scope.data.updateStatusActive = status;
        }


        function getClassUsers(list) {
            var names = [];
            angular.forEach(list,function (value) {
                names.push(value.name);
            });
            return names.join(",");
        }

        function realSaveAll() {
            var param = {
                date:date,
                id:roomId,
                stuIds:$scope.data.stuToSaveIds,
                status:$scope.data.updateStatusActive
            };
            $http.post(basePath + "/userRegistration.htm",param).success(function (data) {
                if (data.status === 0) {
                    ynuiNotification.success({msg: '保存成功'});
                    getStatusTotal();
                    $scope.data.isAll = false;
                    $scope.data.updateStatusActive = 0;
                }else {
                    $scope.data.room = {};
                }
            });
            hideSubmit();

        }

        function initFun() {
            getStatusTotal();
        }

        initFun();


        $ionicModal.fromTemplateUrl('submitFlag.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.submitModal = modal;
        });

        function showSubmit(){
            $scope.submitModal.show();
        }

        function hideSubmit(){
            $scope.submitModal.hide();
            $scope.data.activeStatusClass = 0;
        }


        function callPhone(phoneList) {
            $scope.data.phoneList = phoneList;
            $scope.callPhoneModal.show();
        }


        $ionicModal.fromTemplateUrl('opStuStatus.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal2 = modal;
        });
        $scope.submitRoomFlagModalShow = function () {
            $scope.modal2.show();
        };
        $scope.submitRoomFlagModalHide = function () {
            $scope.modal2.hide();
        };


        $ionicModal.fromTemplateUrl('callPhone.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.callPhoneModal = modal;
        });
        $ionicModal.fromTemplateUrl('opStatus.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal1 = modal;
        });
        $scope.opStatusModalShow = function () {
            $scope.modal1.show();
        };
        $scope.opStatusModalHide = function () {
            $scope.modal1.hide();
        };
        $scope.callPhoneModalHide = function () {
            $scope.callPhoneModal.hide();
        };
        $scope.click = function (event) {
            event.stopPropagation();
        };



        // 物理返回键处理
        ynNavigator.registerBackAction(function () {
            $state.go($state.current.data.prev, {backSearchInfo: angular.toJson(oldVm)});
        },101);


        function cordovaFileOpenSuccess() {
            // 从已安装程序中打开文件完成
        }

        function cordovaFileOpenError(code) {
            if (code === 1) {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '未能在手机已安装APP中找到可预览此文件的程序'
                });
            } else {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '预览时发生了未知错误 #' + code
                });
            }
        }

        // 预览照片
        $scope.previewPhoto = function (photo) {
            if(photo.uri){
                var cordovaFileOpen = cordova.plugins.disusered.open;
                cordovaFileOpen(originBaseUrl+"/file/downloadStream.htm?fastDFSId="+photo.uri, cordovaFileOpenSuccess, cordovaFileOpenError);
            }

        };
    }])
    .controller('returnResultTeaController', ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification',
        '$ionicScrollDelegate', '$timeout',"$state","$stateParams","storageService",
        function ($scope, $ionicModal, $http, $location, ynuiNotification, $ionicScrollDelegate, $timeout,
                  $state,$stateParams,storageService) {


        var date = null;
        // 子页面返回参数
        var oldVm = null;
        var backSearchInfoOld = angular.fromJson($stateParams.backSearchInfo);
        if (backSearchInfoOld){
            oldVm = storageService.getItemNoDel($state.current.name);
            date = oldVm.date;
        }

        $scope.selectedOrg = selectedOrg;
        $scope.goRoomDetail = goRoomDetail;
        $scope.getPage = getPage;
        $scope.initFun = initFun;
        var basePath = originBaseUrl + "/third/newss/mobile";
        $scope.data = {
            // 是否有权限
            permissions:{
                flag:false,
                message:''
            },
            searchInfo:{
                selectDate:null,
                schoolOrgList:[],
                today:null,
                nowDate: {
                    date: "",
                    dateStr: "",
                    isToday: false
                },
                searchValue:{
                    showOrgName:'',
                    showOrgNo:''
                }
            },
            buildList: [],
            pageNumber:0,
            pageSize:8,
            lastPage:true
        };


        function getPage(type) {
            $scope.data.pageNumber++;
            getBuildRoomListPage(type);
        }

        function goTop() {
            $ionicScrollDelegate.$getByHandle('returnResultTeaScroll').scrollTop(true);
        }

        function getBuildRoomListPage(type) {
            var param = {
                roleType:1,
                orgNo:$scope.data.searchInfo.searchValue.showOrgNo,
                date:$scope.data.searchInfo.nowDate.date,
                pageNumber:$scope.data.pageNumber,
                pageSize:$scope.data.pageSize
            };
            $http.post(basePath + "/getBuildRoomListPage.htm",param).success(function (data) {
                if (data.status == 0) {
                    $scope.data.lastPage = angular.copy(data.result.lastPage);
                    $scope.data.totalElements = angular.copy(data.result.totalElements);
                    if (type === 1){
                        $scope.data.buildList = $scope.data.buildList.concat(angular.copy(data.result.content));
                    }else {
                        $scope.data.buildList = angular.copy(data.result.content);
                        goTop();
                    }
                    if ($scope.data.totalElements === 0){
                        $scope.data.permissions.message = "没有相关数据";
                    }
                }else if (data.status == 10){
                    $scope.data.permissions.message = data.message;
                    $scope.data.buildList = [];
                }else{
                    $scope.data.permissions.message = "数据加载失败";
                    $scope.data.buildList = [];
                }
                // 返回处理 设置默认值
                if (backSearchInfoOld && oldVm){
                    $scope.data.pageNumber = oldVm.pageNumber;
                    $scope.data.pageSize = 8;
                    // 跳转到指定位置
                    if (oldVm.buildId){
                        scroll(oldVm.buildId);
                    }
                    backSearchInfoOld = null;
                    oldVm = null;
                }
                $timeout(()=>{
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                },50)
            });
        }

        function scroll(id){
            $ionicScrollDelegate.$getByHandle('returnResultTeaScroll').anchorScroll('#'+$location.hash(id));
        }

        function rolePermissions() {
            var param = {
                type:1,
                id:date?date:null
            };
            $http.post(basePath + "/rolePermissions.htm",param).success(function (data) {
                if (data.status == 0) {
                    $scope.data.permissions.flag = true;
                    $scope.data.permissions.message = null;
                    $scope.data.searchInfo.schoolOrgList = data.result.schoolOrgList;
                    $scope.data.searchInfo.searchValue.showOrgName = data.result.schoolOrgList[0].name;
                    $scope.data.searchInfo.searchValue.showOrgNo = data.result.schoolOrgList[0].id;
                    $scope.data.searchInfo.nowDate.date = data.result.commonVO.id;
                    $scope.data.searchInfo.today = data.result.today;
                    $scope.data.searchInfo.nowDate.isToday = data.result.today === data.result.commonVO.id;
                    $scope.data.searchInfo.nowDate.dateStr = data.result.commonVO.name;
                    getBuildRoomListPage();
                }else {
                    $scope.data.permissions.flag = false;
                    $scope.data.permissions.message = data.message;
                }
            });
        }

        function selectedOrg(item) {
            $scope.data.searchInfo.searchValue.showOrgName = item.name;
            $scope.data.searchInfo.searchValue.showOrgNo = item.id;
            getBuildRoomListPage();
        }

        function findDateStr(date) {
            $http.post(basePath + "/findDateStr.htm",{date:date}).success(function (data) {
                if (data.status == 0) {
                    $scope.data.searchInfo.nowDate.isToday = data.result.isToday;
                    $scope.data.searchInfo.nowDate.dateStr = date+data.result.week;
                    getBuildRoomListPage();
                }
            });
        }

        function goRoomDetail(item) {
            if(item.statusList && item.statusList.length > 0){
                var param = {
                    orgNo:$scope.data.searchInfo.searchValue.showOrgNo,
                    date: $scope.data.searchInfo.nowDate.date,
                    pageNumber: $scope.data.pageNumber,
                    pageSize: $scope.data.pageSize,
                    buildId:item.id
                };
                storageService.setItem($state.current.name,param);
                $state.go("zbkq_in_bedStudent_tea_room");
            }
        }


        function initFun() {
            // 分页处理
            if (backSearchInfoOld && oldVm){
                $scope.data.pageSize =  (oldVm.pageNumber + 1)*8;
                $scope.data.pageNumber = 0;
                $scope.data.searchInfo.selectDate = date;
            }
            rolePermissions();
        }

        initFun();


        $scope.selectDateChange = function(){
            $scope.data.pageNumber = 0;
            $scope.data.searchInfo.nowDate.date = $scope.data.searchInfo.selectDate;
            $scope.data.searchInfo.nowDate.dateStr = findDateStr($scope.data.searchInfo.selectDate);
        }


        /**
         * 返回
         */
        $scope.goBack = function() {
            yn.plugin.yncordova.close();
        }



    }])
    .controller('returnResultTeaRoomController', ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification',
        '$ionicScrollDelegate', '$timeout','ynNavigator',"$state","$stateParams","storageService",
        function ($scope, $ionicModal, $http, $location, ynuiNotification, $ionicScrollDelegate, $timeout,
                  ynNavigator,$state,$stateParams,storageService) {

        var oldVtem = storageService.getItemNoDel($state.current.data.prev);

        var date = oldVtem.date;
        var buildId = oldVtem.buildId;
        // 子页面返回参数
        var backSearchInfoOld = angular.fromJson($stateParams.backSearchInfo);
        if (backSearchInfoOld){
            date = backSearchInfoOld.date;
            buildId = backSearchInfoOld.buildId;
        }

        $scope.findUserRecordPage = findUserRecordPage;
        $scope.getRoomListPage = getRoomListPage;
        $scope.filterStuList = filterStuList;
        $scope.goLeaveInfo = goLeaveInfo;
        $scope.callPhone = callPhone;
        $scope.callPhoneModalHide = callPhoneModalHide;
        $scope.initFun = initFun;
        $scope.getClassUsers = getClassUsers;
        $scope.leaveActiveView = leaveActiveView;

        var basePath = originBaseUrl + "/third/newss/mobile";
        $scope.data = {
            // 是否为最后一页 默认 需要加载更多
            lastPage:false,
            // 默认选中全部
            statusActive:'',
            // 默认第一页
            pageNumber:0,
            // 查询条件
            searchValue:{
                roomName:null,
                stuName:null
            },
            // 数据展示
            roomStuList: [],
            // 状态统计
            statusList : [],
            stuCountTotal:0
        };


        function findUserRecordPage(type) {
            var status = $scope.data.statusActive;
            if (type){
                goTop();
                $scope.data.pageNumber = 0;
            }else {
                $scope.data.pageNumber += 1;
            }
            getRoomListPage(status,type == 1);
        }

        function getRoomListPage(status,isTop,isStatus) {
            var param = getSearchInfo(status);
            if (!isStatus){
                getStatusTotal();
            }
            $http.post(basePath + "/getRoomUserTotal.htm",param).success(function (data) {
                $scope.data.lastPage = true;
                if (data.status === 0) {
                    $timeout(()=> {
                        if (isTop){
                            $scope.data.roomStuList = angular.copy(data.result.content);
                            goTop();
                        }else {
                            // 处理同寝室数据
                            var showList = angular.copy(data.result.content);
                            angular.forEach($scope.data.roomStuList,function (value) {
                                angular.forEach(data.result.content,function (t,index) {
                                    if (t.id === value.id){
                                        value.stuItemInfoList = value.stuItemInfoList.concat(t.stuItemInfoList);
                                        showList.splice(index,1);
                                    }
                                });
                            });
                            $scope.data.roomStuList = angular.copy($scope.data.roomStuList.concat(showList));
                        }
                        $scope.data.lastPage = data.result.lastPage;
                        // 处理班主任显示
                        angular.forEach($scope.data.roomStuList,function (val) {
                            var names = [];
                            angular.forEach(val.commonVOList,function (common) {
                                names.push(common.name);
                            });
                            val.users = names.join(",");
                        })
                    })
                }else {
                    $scope.data.roomStuList = [];
                }

                $timeout(()=>{
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                },50)

            });
        }


        function getStatusTotal() {
            var param = {
                date:date,
                buildId:buildId,
                name:$scope.data.searchValue.roomName,
                stuName:$scope.data.searchValue.stuName
            };
            $http.post(basePath + "/getStatusTotal.htm",param).success(function (data) {
                if (data.status === 0) {
                    $scope.data.statusList = angular.copy(data.result);
                    var stuCountTotal = 0;
                    angular.forEach($scope.data.statusList,function (value) {
                        stuCountTotal += value.count;
                    });
                    $scope.data.stuCountTotal = stuCountTotal;
                }else {
                    $scope.data.statusList = [];
                }
            });
        }

        function getSearchInfo(status) {
            var param = {
                date:date,
                buildId:buildId,
                status:status,
                name:$scope.data.searchValue.roomName,
                stuName:$scope.data.searchValue.stuName,
                pageNumber:$scope.data.pageNumber,
                pageSize:10
            };
            return param;
        }

        function filterStuList(status) {
            if (!status && status != 0){
                status = '';
            }
            $scope.data.statusActive = status;
            $scope.data.pageNumber = 0;
            getRoomListPage(status,true,true);
        }

        function goTop() {
            // 置顶
            $ionicScrollDelegate.$getByHandle('returnResultTeaRoomScroll').scrollTop(true);
        }


        function initFun() {
            if (backSearchInfoOld){
                date = backSearchInfoOld.date;
                buildId = backSearchInfoOld.buildId;
                $scope.data.statusActive = backSearchInfoOld.status;
                $scope.data.searchValue.roomName = backSearchInfoOld.roomName;
                $scope.data.searchValue.stuName = backSearchInfoOld.stuName;
                $scope.data.pageNumber = backSearchInfoOld.pageNumber;
            }
            getRoomListPage($scope.data.statusActive,true);
        }

        function getClassUsers(list) {
            var names = [];
            angular.forEach(list,function (value) {
                names.push(value.name);
            });
            return names.join(",");
        }

        initFun();

        function goLeaveInfo(item) {
            if (item.leaveTimeStr && item.activeTimeStr){
                $scope.data.leaveActiveInfo = item;
                leaveActiveShow();
            }else {
                if (item.leaveTimeStr){
                    goLeave(item);
                }else if (item.activeTimeStr){
                    goActive(item);
                }
            }
        }

        function leaveActiveView(type) {
            var item = $scope.data.leaveActiveInfo;
            if (type === 1){
                // 请假
                goLeave(item);
            }else {
                // 实习
                goActive(item);
            }
            leaveActiveHide();
        }

        function goLeave(item) {
            var backSearchInfo = getSearchInfo($scope.data.statusActive,item);
            backSearchInfo.stuId = item.id;
            $location.path("/leave_info").search({backSearchInfo:angular.toJson(backSearchInfo),backUrl: $state.current.name,title:$state.current.data.title});
        }

        function goActive(item) {
            var backSearchInfo = getSearchInfo($scope.data.statusActive,item);
            backSearchInfo.stuId = item.id;
            $location.path("/activity_info").search({backSearchInfo:angular.toJson(backSearchInfo),backUrl:$state.current.name,title:$state.current.data.title});
        }

        $ionicModal.fromTemplateUrl('leaveActiveOpt.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.leaveActiveOptModal = modal;
        });

        function leaveActiveShow(){
            $scope.leaveActiveOptModal.show();
        }

        function leaveActiveHide(){
            $scope.leaveActiveOptModal.hide();
        }

        $ionicModal.fromTemplateUrl('callPhone.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.callPhoneModal = modal;
        });

        function callPhoneModalHide(){
            $scope.callPhoneModal.hide();
        }


        function callPhone(list){
            $scope.callPhoneList = list;
            $scope.callPhoneModal.show();
        }

        // 左上角返回键
        ynNavigator.registerBackAction(function () {
            $state.go($state.current.data.prev, {backSearchInfo: angular.toJson(oldVtem)});
        },101);


        function cordovaFileOpenSuccess() {
            // 从已安装程序中打开文件完成
        }

        function cordovaFileOpenError(code) {
            if (code === 1) {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '未能在手机已安装APP中找到可预览此文件的程序'
                });
            } else {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '预览时发生了未知错误 #' + code
                });
            }
        }

        // 预览照片
        $scope.previewPhoto = function (photo) {
            if(photo.fsId){
                var cordovaFileOpen = cordova.plugins.disusered.open;
                cordovaFileOpen(originBaseUrl+"/file/downloadStream.htm?fastDFSId="+photo.fsId, cordovaFileOpenSuccess, cordovaFileOpenError);
            }

        };
    }])
    .controller('returnResultRoomDetailController', ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification',
        '$ionicScrollDelegate', '$timeout',"$state","$stateParams",
        function ($scope, $ionicModal, $http, $location, ynuiNotification, $ionicScrollDelegate, $timeout,
                  $state,$stateParams) {


        var date = $location.search().date;
        // 子页面返回参数
        var backSearchInfoOld = angular.fromJson($stateParams.backSearchInfo);
        if (backSearchInfoOld){
            date = backSearchInfoOld.date;
        }

        $scope.findUserRecordPage = findUserRecordPage;
        $scope.getRoomListPage = getRoomListPage;
        $scope.filterStuList = filterStuList;
        $scope.goLeaveInfo = goLeaveInfo;
        $scope.callPhone = callPhone;
        $scope.callPhoneModalHide = callPhoneModalHide;
        $scope.initFun = initFun;
        $scope.searchShow = searchShow;
        $scope.searchHide = searchHide;
        $scope.showTypeClick = showTypeClick;
        $scope.getClassUsers = getClassUsers;
        $scope.leaveActiveView = leaveActiveView;

        var basePath = originBaseUrl + "/third/newss/mobile";
        $scope.data = {
            // 是否为最后一页 默认 需要加载更多
            lastPage:false,
            // 默认选中全部
            statusActive:'',
            // 默认第一页
            pageNumber:0,
            pageSize:8,
            // 查询条件
            searchValue:{
                dateSelect:null,
                date:null,
                week:null,
                isToday:false,
                showType:1,
                roomName:null,
                stuName:null
            },
            // 数据展示
            roomStuList: [],
            // 状态统计
            statusList : [],
            roomCountTotal:{roomCount:0,userCount:0},
            isShowRoom:true
        };


        function findUserRecordPage(flag) {
            var status = $scope.data.statusActive;
            if (flag){
                goTop();
                $scope.data.pageNumber = 0;
            }else {
                $scope.data.pageNumber += 1;
            }
            getRoomListPage(status,flag,null,true);
            searchHide();
        }

        function getRoomListPage(status,isTop,isStatus,isSearch) {
            var param = getSearchInfo(status);
            if (!isStatus){
                getStatusTotal();
            }
            $http.post(basePath + "/getRoomUserTotal.htm",param).success(function (data) {
                $scope.data.lastPage = true;
                if (data.status === 0) {
                    if (isSearch){
                        $scope.data.isShowRoom = $scope.data.searchValue.showType === 1;
                    }
                    $timeout(()=> {
                        if (isTop){
                            $scope.data.roomStuList = angular.copy(data.result.content);
                        }else {
                            // 处理同寝室数据
                            var showList = angular.copy(data.result.content);
                            angular.forEach($scope.data.roomStuList,function (value) {
                                angular.forEach(data.result.content,function (t,index) {
                                    if (t.id === value.id){
                                        value.stuItemInfoList = value.stuItemInfoList.concat(t.stuItemInfoList);
                                        showList.splice(index,1);
                                    }
                                });
                            });
                            $scope.data.roomStuList = angular.copy($scope.data.roomStuList.concat(showList));
                        }
                        $scope.data.lastPage = data.result.lastPage;
                        // 处理班主任显示
                        angular.forEach($scope.data.roomStuList,function (val) {
                            var names = [];
                            angular.forEach(val.commonVOList,function (common) {
                                names.push(common.name);
                            });
                            val.users = names.join(",");
                        })
                    })
                    if (backSearchInfoOld){
                        $scope.data.pageNumber = backSearchInfoOld.pageNumber;
                    }
                    $scope.data.pageSize = 8;
                }else {
                    $scope.data.roomStuList = [];
                }

                $timeout(()=>{
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                },50)

            });
        }


        function getStatusTotal() {
            var param = {
                roleType:2,
                date:$scope.data.searchValue.date,
                showType:$scope.data.searchValue.showType,
                name:$scope.data.searchValue.roomName,
                stuName:$scope.data.searchValue.stuName
            };
            $http.post(basePath + "/getStatusTotal.htm",param).success(function (data) {
                if (data.status === 0) {
                    $scope.data.statusList = angular.copy(data.result);
                    var stuCountTotal = 0;
                    angular.forEach($scope.data.statusList,function (value) {
                        stuCountTotal += value.count;
                    });
                    $scope.data.stuCountTotal = stuCountTotal;
                }else {
                    $scope.data.statusList = [];
                }
            });
        }

        function getSearchInfo(status) {
            var param = {
                roleType:2,
                date:$scope.data.searchValue.date,
                showType:$scope.data.searchValue.showType,
                status:status,
                name:$scope.data.searchValue.roomName,
                stuName:$scope.data.searchValue.stuName,
                pageNumber:$scope.data.pageNumber,
                pageSize:$scope.data.pageSize
            };
            return param;
        }

        function goLeaveInfo(item) {
            if (item.leaveTimeStr && item.activeTimeStr){
                $scope.data.leaveActiveInfo = item;
                leaveActiveShow();
            }else {
                if (item.leaveTimeStr){
                    goLeave(item);
                }else if (item.activeTimeStr){
                    goActive(item);
                }
            }
        }

        function leaveActiveView(type) {
            var item = $scope.data.leaveActiveInfo;
            if (type === 1){
                // 请假
                goLeave(item);
            }else {
                // 实习
                goActive(item);
            }
            leaveActiveHide();
        }

        function goLeave(item) {
            var backSearchInfo = getSearchInfo($scope.data.statusActive,item);
            backSearchInfo.stuId = item.id;
            $location.path("/leave_info").search({backSearchInfo:angular.toJson(backSearchInfo),backUrl: $state.current.name,title:$state.current.data.title});
        }

        function goActive(item) {
            var backSearchInfo = getSearchInfo($scope.data.statusActive,item);
            backSearchInfo.stuId = item.id;
            $location.path("/activity_info").search({backSearchInfo:angular.toJson(backSearchInfo),backUrl:$state.current.name,title:$state.current.data.title});
        }

        function filterStuList(status) {
            if (!status && status != 0){
                status = '';
            }
            $scope.data.statusActive = status;
            $scope.data.pageNumber = 0;
            goTop();
            getRoomListPage(status,true,true);
        }

        function goTop() {
            // 置顶
            $ionicScrollDelegate.$getByHandle('returnResultRoomDetailScroll').scrollTop(true);
        }

        function findDateStr(date) {
            $http.post(basePath + "/findDateStr.htm",{date:date}).success(function (data) {
                if (data.status == 0) {
                    $scope.data.searchValue.isToday = data.result.isToday;
                    $scope.data.searchValue.date = date?date:data.result.date;
                    $scope.data.searchValue.week = data.result.week;
                    getRoomListPage($scope.data.statusActive,true);
                }
            });
        }

        function getRoomUserCount() {
            $http.post(basePath + "/getRoomUserCount.htm").success(function (data) {
                if (data.status == 0) {
                    $scope.data.roomCountTotal = data.result;
                }
            });
        }

        function showTypeClick(type) {
            $scope.data.searchValue.showType = type;
        }

        function getClassUsers(list) {
            var names = [];
            angular.forEach(list,function (value) {
                names.push(value.name);
            });
            return names.join(",");
        }

        function initFun() {
            if (backSearchInfoOld){
               $scope.data.searchValue.date = backSearchInfoOld.date;
               $scope.data.searchValue.showType = backSearchInfoOld.showType;
               $scope.data.statusActive = backSearchInfoOld.status;
               $scope.data.searchValue.roomName = backSearchInfoOld.name;
               $scope.data.searchValue.stuName = backSearchInfoOld.stuName;
               $scope.data.pageSize =  (backSearchInfoOld.pageNumber + 1)*8;
               $scope.data.pageNumber = 0;
            }
            getRoomUserCount();
            findDateStr();
        }

        initFun();

        $scope.$watch('data.searchValue.dateSelect',function(newValue,oldValue){
            if(newValue !== oldValue){
                $scope.data.searchValue.date = newValue;
                // 默认全部
                $scope.data.statusActive = '';
                $scope.data.pageNumber = 0;
                findDateStr(newValue);
            }
        });


        $ionicModal.fromTemplateUrl('leaveActiveOpt.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.leaveActiveOptModal = modal;
        });

        function leaveActiveShow(){
            $scope.leaveActiveOptModal.show();
        }

        function leaveActiveHide(){
            $scope.leaveActiveOptModal.hide();
        }



        $ionicModal.fromTemplateUrl('callPhone.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.callPhoneModal = modal;
        });

        function callPhoneModalHide(){
            $scope.callPhoneModal.hide();
        }



        $ionicModal.fromTemplateUrl('search.html', {
            scope: $scope,
            animation: 'slide-in-left'
        }).then(function (modal) {
            $scope.searchModal = modal;
        });

        function searchShow(){
            $scope.searchModal.show();
        }

        function searchHide(){
            $scope.searchModal.hide();
        }


        function callPhone(list){
            $scope.callPhoneList = list;
            $scope.callPhoneModal.show();
        }


        function cordovaFileOpenSuccess() {
            // 从已安装程序中打开文件完成
        }

        function cordovaFileOpenError(code) {
            if (code === 1) {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '未能在手机已安装APP中找到可预览此文件的程序'
                });
            } else {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '预览时发生了未知错误 #' + code
                });
            }
        }

        // 预览照片
        $scope.previewPhoto = function (photo) {
            if(photo.fsId){
                var cordovaFileOpen = cordova.plugins.disusered.open;
                cordovaFileOpen(originBaseUrl+"/file/downloadStream.htm?fastDFSId="+photo.fsId, cordovaFileOpenSuccess, cordovaFileOpenError);
            }

        };
    }])
    .controller('dormitoryAbnormalController', ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification',
        '$ionicScrollDelegate', '$timeout', 'ynNavigator','$ionicPopup',"$state","$stateParams","storageService",
        function ($scope, $ionicModal, $http, $location, ynuiNotification, $ionicScrollDelegate, $timeout,ynNavigator,
                  $ionicPopup,$state,$stateParams,storageService) {


        var oldVm = storageService.getItemNoDel($state.current.data.prev);

        var date = oldVm.date;
        var week = oldVm.showWeek;

        // 子页面返回参数
        var backSearchInfoOld = angular.fromJson($stateParams.backSearchInfo);
        if (backSearchInfoOld){
            date = backSearchInfoOld.date;
            week = backSearchInfoOld.week;
        }


        $scope.findUserRecordPage = findUserRecordPage;
        $scope.getRoomListPage = getRoomListPage;
        $scope.filterStuList = filterStuList;
        $scope.goLeaveInfo = goLeaveInfo;
        $scope.callPhone = callPhone;
        $scope.callPhoneModalHide = callPhoneModalHide;
        $scope.selectRoom = selectRoom;
        $scope.clickAll = clickAll;
        $scope.findMessageStatus = findMessageStatus;
        $scope.sendMessageHide = sendMessageHide;
        $scope.sendMessage = sendMessage;
        $scope.updateStuStatus = updateStuStatus;
        $scope.opItem = opItem;
        var basePath = originBaseUrl + "/third/newss/mobile";
        $scope.data = {
            // 是否为最后一页 默认 需要加载更多
            lastPage:false,
            // 默认选中全部
            statusActive:-1,
            // 默认第一页
            pageNumber:0,
            pageSize:8,
            // 查询条件
            searchValue:{
                date:date,
                week:week,
                stuName:backSearchInfoOld?backSearchInfoOld.stuName:null
            },
            // 数据展示
            roomStuList: [],
            // 状态统计
            statusList : [],
            roomCountTotal:{roomCount:0,userCount:0},
            isShowRoom:true,
            selectUserCount:0,
            allUserCount:0,
            isAll:false
        };


        function findUserRecordPage(flag) {
            var status = $scope.data.statusActive;
            if (flag){
                goTop();
                $scope.data.pageNumber = 0;
            }else {
                $scope.data.pageNumber += 1;
            }
            getRoomListPage(status,flag,null,true);
        }

        function getRoomListPage(status,isTop,isStatus,isSearch) {
            var param = getSearchInfo(status);
            if (!isStatus){
                getAbnormalStatusTotal();
            }
            $http.post(basePath + "/getAbnormalList.htm",param).success(function (data) {
                $scope.data.lastPage = true;
                if (data.status === 0) {
                    if (isSearch){
                        $scope.data.isShowRoom = $scope.data.searchValue.showType === 1;
                    }
                    $timeout(()=> {
                        if (isTop){
                            $scope.data.roomStuList = angular.copy(data.result.content);
                        }else {
                            // 处理同寝室数据
                            var showList = angular.copy(data.result.content);
                            angular.forEach($scope.data.roomStuList,function (value) {
                                angular.forEach(data.result.content,function (t,index) {
                                    if (t.id === value.id){
                                        value.stuItemInfoList = value.stuItemInfoList.concat(t.stuItemInfoList);
                                        showList.splice(index,1);
                                    }
                                });
                            });
                            $scope.data.roomStuList = angular.copy($scope.data.roomStuList.concat(showList));
                        }
                        $scope.data.lastPage = data.result.lastPage;
                        // 处理班主任显示
                        angular.forEach($scope.data.roomStuList,function (val) {
                            var names = [];
                            angular.forEach(val.commonVOList,function (common) {
                                names.push(common.name);
                            });
                            val.users = names.join(",");
                            // 默认处理
                            angular.forEach(val.stuItemInfoList,function (stuInfo) {
                                stuInfo.select = true;
                            });
                        })
                    });
                    $scope.data.pageSize = 8;
                    if (backSearchInfoOld){
                        $scope.data.pageNumber = backSearchInfoOld.pageNumber;
                        backSearchInfoOld = null;
                    }
                }else {
                    $scope.data.roomStuList = [];
                }

                $timeout(()=>{
                    var userCount = 0;
                    angular.forEach($scope.data.roomStuList,function (val) {
                        userCount += val.stuItemInfoList.length;
                    });
                    $scope.data.allUserCount = userCount;
                    $scope.data.selectUserCount = userCount;
                    $scope.data.isAll = true;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                },50)

            });
        }


        function getAbnormalStatusTotal(flag) {
            var param = {
                date:$scope.data.searchValue.date,
                stuName:$scope.data.searchValue.stuName
            };
            $http.post(basePath + "/getAbnormalStatusTotal.htm",param).success(function (data) {
                if (data.status === 0) {
                    $scope.data.statusList = angular.copy(data.result);
                    if (flag && $scope.data.statusList.length > 0){
                        getRoomListPage($scope.data.statusActive,true,true);
                    }
                }else {
                    $scope.data.statusList = [];
                }
            });
        }

        function getSearchInfo(status) {
            var param = {
                date:$scope.data.searchValue.date,
                status:status===-1?null:status,
                stuName:$scope.data.searchValue.stuName,
                pageNumber:$scope.data.pageNumber,
                pageSize:$scope.data.pageSize
            };
            return param;
        }

        function goLeaveInfo(item,type) {
            $scope.data.opStatusItem = angular.copy(item);
            if (type){
                if (type === 1){
                    goLeave(item);
                }else {
                    goActive(item);
                }
            } else {
                opStuStatusShow();
            }
        }

        function goLeave(item) {
            var backSearchInfo = getSearchInfo($scope.data.statusActive);
            backSearchInfo.stuId = item.id;
            backSearchInfo.date = $scope.data.searchValue.date;
            $location.path("/leave_info").search({backSearchInfo:angular.toJson(backSearchInfo),backUrl: $state.current.name,title:$state.current.data.title});
        }

        function goActive(item) {
            var backSearchInfo = getSearchInfo($scope.data.statusActive);
            backSearchInfo.stuId = item.id;
            backSearchInfo.date = $scope.data.searchValue.date;
            $location.path("/activity_info").search({backSearchInfo:angular.toJson(backSearchInfo),backUrl:$state.current.name,title:$state.current.data.title});
        }

        function filterStuList(status) {
            $scope.data.statusActive = status;
            $scope.data.pageNumber = 0;
            goTop();
            getRoomListPage(status,true,true);
        }

        function goTop() {
            // 置顶
            $ionicScrollDelegate.$getByHandle('returnResultRoomDetailScroll').scrollTop(true);
        }

        function selectRoom(item) {
            item.select = !item.select;
            var count = 0;
            angular.forEach($scope.data.roomStuList,function (value) {
                angular.forEach(value.stuItemInfoList,function (val) {
                    if (val.select){
                        count++;
                    }
                });
            });
            $scope.data.isAll = count === $scope.data.allUserCount;
            $scope.data.selectUserCount = count;
        }

        function clickAll() {
            $scope.data.isAll = !$scope.data.isAll;
            if ($scope.data.isAll){
                $scope.data.selectUserCount = $scope.data.allUserCount;
            }else {
                $scope.data.selectUserCount = 0;
            }
            angular.forEach($scope.data.roomStuList,function (value) {
                angular.forEach(value.stuItemInfoList,function (val) {
                    val.select = $scope.data.isAll;
                });
            });
        }

        function initFun() {
            if (backSearchInfoOld){
                $scope.data.pageSize =  (oldVm.pageNumber + 1)*8;
                $scope.data.pageNumber = 0;
                if (backSearchInfoOld.status || backSearchInfoOld.status === 0){
                    $scope.data.statusActive = backSearchInfoOld.status;
                }else {
                    $scope.data.statusActive = -1;
                }

                $scope.data.searchValue.stuName = backSearchInfoOld.stuName;
            }
            getAbnormalStatusTotal(true);
        }

        function findMessageStatus() {
            if ($scope.data.selectUserCount){
                $http.get(basePath + "/findMessageStatus.htm").success(function (data) {
                    if (data.status == 0) {
                        $scope.data.msgStatus = data.result;
                        if ($scope.data.msgStatus.openMsg){
                            angular.forEach($scope.data.msgStatus.msgList,function (value) {
                                value.select = true;
                            });
                            sendMessageShow();
                        }else {
                            $ionicPopup.alert({
                                title: '提示',
                                template: '未开启消息提醒！'
                            });
                        }
                    }
                });
            }else {
                $ionicPopup.alert({
                    title: '提示',
                    template: '至少勾选一项！'
                });
            }

        }

        function sendMessage() {
            // 发送方式
            var sendWay = [];
            angular.forEach($scope.data.msgStatus.msgList,function (value) {
                if (value.select){
                    sendWay.push(value.id);
                }
            });
            if (sendWay.length === 0){
                $ionicPopup.alert({
                    title: '提示',
                    template: '至少选中一项，消息发送方式！'
                });
            }else {
                var userIdList = [];
                // 需要发送学生
                angular.forEach($scope.data.roomStuList,function (value) {
                    angular.forEach(value.stuItemInfoList,function (val) {
                        if (val.select){
                            userIdList.push(val.id);
                        }
                    });
                });

                var params = {
                    date:date,
                    userIdList:userIdList,
                    sendWay:sendWay
                };
                $http.post(basePath + "/sendSleepMsgHeadMaster.htm",params).success(function (data) {
                    if (data.status == 0) {
                        sendMessageHide();
                        ynuiNotification.success({msg: '消息发送成功'});
                        findUserRecordPage(true);
                    } else {
                        ynuiNotification.error({msg: data.message});
                    }

                });
            }
        }

        function opItem(type) {

            if (type === 1){
                // 请假
                goLeave($scope.data.opStatusItem);
            }else if (type === 2){
                // 实习
                goActive($scope.data.opStatusItem);
            }else {
                opStuStatusShow();
            }
            opStatusHide();
        }

        function updateStuStatus(status) {
            var param = {
                date:$scope.data.searchValue.date,
                stuIds:[$scope.data.opStatusItem.id],
                status:status
            };
            $http.post(basePath + "/userRegistration.htm",param).success(function (data) {
                if (data.status === 0) {
                    ynuiNotification.success({msg: '保存成功'});
                    getRoomListPage($scope.data.statusActive,true);
                }else {
                    $scope.data.statusList = [];
                }
            });

            opStuStatusHide();
        }

        initFun();


        $ionicModal.fromTemplateUrl('opStatus.html', {
            scope: $scope,
            animation: 'slide-in-left'
        }).then(function (modal) {
            $scope.opStatusModal = modal;
        });

        function opStatusHide(){
            $scope.opStatusModal.hide();
        }

        function opStatusShow(){
            $scope.opStatusModal.show();
        }


        $ionicModal.fromTemplateUrl('opStuStatus.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.opStuStatusModal = modal;
        });

        function opStuStatusHide(){
            $scope.opStuStatusModal.hide();
        }

        function opStuStatusShow(){
            $scope.opStuStatusModal.show();
        }



        $ionicModal.fromTemplateUrl('callPhone.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.callPhoneModal = modal;
        });

        function callPhoneModalHide(){
            $scope.callPhoneModal.hide();
        }

        function callPhone(list){
            $scope.callPhoneList = list;
            $scope.callPhoneModal.show();
        }


        $ionicModal.fromTemplateUrl('sendMessage.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.sendMessageModal = modal;
        });

        function sendMessageHide(){
            $scope.sendMessageModal.hide();
        }

        function sendMessageShow(){
            $scope.sendMessageModal.show();
        }

        // 物理返回键处理
        ynNavigator.registerBackAction(function() {
            $state.go($state.current.data.prev, {backSearchInfo: angular.toJson(oldVm)});
        }, 101);

        function cordovaFileOpenSuccess() {
            // 从已安装程序中打开文件完成
        }

        function cordovaFileOpenError(code) {
            if (code === 1) {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '未能在手机已安装APP中找到可预览此文件的程序'
                });
            } else {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '预览时发生了未知错误 #' + code
                });
            }
        }

        // 预览照片
        $scope.previewPhoto = function (photo) {
            if(photo.fsId){
                var cordovaFileOpen = cordova.plugins.disusered.open;
                cordovaFileOpen(originBaseUrl+"/file/downloadStream.htm?fastDFSId="+photo.fsId, cordovaFileOpenSuccess, cordovaFileOpenError);
            }

        };
    }])




;
