angular.module('starter').controller('returnDormitoryHeadMasterController',['$scope','$ionicModal','$http','$location',
    'ynuiNotification','$ionicScrollDelegate','$filter', '$state',"$timeout","$ionicPopup","$stateParams",
    function($scope,$ionicModal,$http,$location,ynuiNotification,$ionicScrollDelegate,$filter, $state,$timeout,$ionicPopup,$stateParams){


    // 子页面返回参数
    var backSearchInfo = angular.fromJson($stateParams.backSearchInfo);

    var basePath = originBaseUrl + "/third/newss/mobile";
    $scope.filterStuList =  filterHeadMasterStuList;
    $scope.goLeaveInfo = goLeaveInfo;
    $scope.roomStatusTotalShow = roomStatusTotalShow;
    $scope.roomStatusTotalShowCount = roomStatusTotalShowCount;
    $scope.findUserRecordPage = findUserRecordPage;
    $scope.selectedAdminClass = selectedAdminClass;
    $scope.searchShow = searchShow;
    $scope.searchHide = searchHide;
    $scope.leaveActiveView = leaveActiveView;

    $scope.data = {
        opStatus:5,
        pageNumber:0,
        pageSize:8,
        lastPage:false,
        selectDate : backSearchInfo ? backSearchInfo.date : getNowFormatDate(),
        roomStuList:[],
        nowDate:{
            date:"",
            dateStr:"",
            isToday:false
        },
        backObj:{
            haskq:true,
            isOnTime:false,
            ssStuItemInfoList:[],
            ssStuItemInfoListTemp:[]
        },
        searchValue:{
            roomName:null,
            stuName:null,
            type:-1
        },
        roomCount:{
            dormitoryRoomCount:0,
            boy:0,
            girl:0,
            totalBedNumber:0
        }
    };

    $scope.$watch('data.selectDate',function(newValue,oldValue){
        if(newValue != oldValue){
            findDateStr(newValue);
            getBuildStatusTotal($scope.currentAdminClass.id);
        }
    });

    function roomStatusTotalShow(type,list) {
        var flag = false;
        angular.forEach(list,function (value) {
            if (value.status === type){
                flag = true;
            }
        });
        return flag;
    }

    function roomStatusTotalShowCount(type,list) {
        var count = 0;
        angular.forEach(list,function (value) {
            if (value.status === type){
                count = value.count;
            }
        });
        return count;
    }

    function findUserRecordPage(flag) {
        if (!flag){
            $scope.data.pageNumber += 1;
        }else {
            $scope.data.pageNumber = 0;
            searchHide();
        }
        getRoomListPage($scope.data.opStatus,flag);
    }

    function getBuildStatusTotal(classId,isInit) {
        var param = {
            roleType:3,
            date:$scope.data.selectDate,
            classId:classId
        };
        $http.post(basePath + "/getBuildStatusTotal.htm",param).success(function (data) {
            if (data.status == 0) {
                $scope.data.roomStatusTotal = angular.copy(data.result);
                var total = 0 , isStatus = false;
                angular.forEach($scope.data.roomStatusTotal,function (value) {
                    total += value.count;
                    if (value.status === 5){
                        isStatus = true;
                    }
                });
                if (isInit && backSearchInfo){
                    $scope.data.opStatus = backSearchInfo.status;
                }else {
                    if (isStatus){
                        // 存在 待打卡/待登记
                        $scope.data.opStatus = 5;
                    }else {
                        // 默认全部
                        $scope.data.opStatus = '';
                    }
                }

                $scope.data.stuCountTotal = total;
                getRoomListPage($scope.data.opStatus,true,isInit);
            }else {
                $scope.data.roomStatusTotal = [];
                $scope.data.roomStuList = [];
            }
        });
    }

    function init() {
        if (backSearchInfo){
            $scope.data.selectDate = backSearchInfo.date;
            $scope.data.searchValue.roomName = backSearchInfo.name;
            $scope.data.searchValue.stuName = backSearchInfo.stuName;
            $scope.data.searchValue.type = backSearchInfo.type;
            // 处理分页
            if (backSearchInfo.pageNumber){
                $scope.data.pageSize = (backSearchInfo.pageNumber+1)*$scope.data.pageSize;
                $scope.data.pageNumber = 0;
            }
        }
        findDateStr($scope.data.selectDate);
        getAdminClassesByUserId().success(function () {
            rolePermissions($scope.currentAdminClass.id);
        });

    }

    init();


    function scroll(id){
        var location = $location.hash(id);
        $ionicScrollDelegate.$getByHandle('dashboard').anchorScroll('#'+location);
    }

    function rolePermissions(classId) {
        $http.post(basePath + "/rolePermissions.htm", {classId: classId,type:3}).success(function(data){
            if(data.status==0){
                $scope.data.roomCount = data.result.headMaster;
                if ($scope.data.roomCount.dormitoryRoomCount && $scope.data.roomCount.totalBedNumber){
                    getBuildStatusTotal(classId,true);
                }else {
                    $scope.data.roomStatusTotal = [];
                    $scope.data.roomStuList = [];
                    $scope.data.stuCountTotal = 0;
                }
            }else {
                $scope.data.roomStatusTotal = [];
                $scope.data.roomStuList = [];
                $scope.data.stuCountTotal = 0;
            }
        });
    }

    function findDateStr(date) {
        if(!date){
            return;
        }
        $http.get(basePath + "/findDateStr.htm?date="+date).success(function(data){
            if(data.status==0){
                $scope.data.nowDate = data.result;
            }
        });
    }

    function goLeaveInfo(item) {
        if (item.leaveTimeStr && item.activeTimeStr){
            $scope.data.leaveActiveInfo = item;
            leaveActiveShow();
        }else {
            if (item.leaveTimeStr){
                goLeave(item);
            }else if (item.activeTimeStr){
                goActive(item);
            }
        }

    }

    function leaveActiveView(type) {
        var item = $scope.data.leaveActiveInfo;
        if (type === 1){
            // 请假
            goLeave(item);
        }else {
            // 实习
            goActive(item);
        }
        leaveActiveHide();
    }

    function goLeave(item) {
        $location.path("/leave_info").search({backSearchInfo:getSearchInfo($scope.data.opStatus,item),backUrl: $state.current.name,title:$state.current.data.title});
    }

    function goActive(item) {
        $location.path("/activity_info").search({backSearchInfo:getSearchInfo($scope.data.opStatus,item),backUrl:$state.current.name,title:$state.current.data.title});
    }

    function filterHeadMasterStuList(status) {
        $scope.data.opStatus = status;
        $scope.data.pageNumber = 0;
        getRoomListPage($scope.data.opStatus,true);
    }

    function toTop() {
        $ionicScrollDelegate.$getByHandle('dashboard').scrollTop(true);
    }

    function getSearchInfo(status,item) {
        var param = {
            date: $scope.data.selectDate,
            classId: $scope.currentAdminClass.id,
            status:status,
            roleType:3,
            name:$scope.data.searchValue.roomName,
            stuName:$scope.data.searchValue.stuName,
            type:$scope.data.searchValue.type,
            pageNumber:$scope.data.pageNumber,
            pageSize:$scope.data.pageSize
        };
        if (item){
            param.stuId = item.id;
            param.scrollId = item.id;
            return angular.toJson(param);
        }else {
            return param;
        }
    }

    function getRoomListPage(status,isTop,isInit) {
            var param = getSearchInfo(status);
            if (param.type === -1){
                param.type = null;
            }
            $http.post(basePath + "/getRoomUserTotal.htm",param).success(function (data) {
                $scope.data.lastPage = true;
                if (data.status === 0) {
                    $timeout(()=> {
                        if (isTop){
                            $scope.data.roomStuList = angular.copy(data.result.content);
                            toTop();
                        }else {
                            // 处理同寝室数据
                            var showList = angular.copy(data.result.content);
                            angular.forEach($scope.data.roomStuList,function (value) {
                                angular.forEach(data.result.content,function (t,index) {
                                    if (t.id === value.id){
                                        value.stuItemInfoList = value.stuItemInfoList.concat(t.stuItemInfoList);
                                        showList.splice(index,1);
                                    }
                                });
                            });
                            $scope.data.roomStuList = angular.copy($scope.data.roomStuList.concat(showList));
                        }
                        $scope.data.lastPage = data.result.lastPage;
                        // 处理班主任显示
                        angular.forEach($scope.data.roomStuList,function (val) {
                            var names = [];
                            angular.forEach(val.commonVOList,function (common) {
                                names.push(common.name);
                            });
                            val.users = names.join(",");
                        });
                    })
                }else {
                    $scope.data.roomStuList = [];
                }

                if (isInit && backSearchInfo && backSearchInfo.scrollId){
                    scroll(backSearchInfo.scrollId);
                }else {
                    $timeout(()=>{
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    },50)
                }

                // 默认每次获取条数
                $scope.data.pageSize = 8;

            });
        }

    function getNowFormatDate() {
        var date = new Date();
        var seperator1 = "-";
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var strDate = date.getDate();
        if (month >= 1 && month <= 9) {
            month = "0" + month;
        }
        if (strDate >= 0 && strDate <= 9) {
            strDate = "0" + strDate;
        }
        return year + seperator1 + month + seperator1 + strDate;
    }

    $scope.adminClasses = null;
    $scope.currentAdminClass = null;


    function getAdminClassesByUserId() {
        return $http.get(originBaseUrl + '/third/classStatistics/queryPlatformAdminClassNoGraduteByUserId.htm')
          .success(function (data) {
              if (data.status === 0) {
                  $scope.adminClasses = data.result;
                  if ($scope.adminClasses && $scope.adminClasses.length > 0) {
                      if (backSearchInfo && backSearchInfo.classId) {
                          angular.forEach($scope.adminClasses, function (c) {
                              if (c.id === backSearchInfo.classId) {
                                  $scope.currentAdminClass = c;
                              }
                          });
                      } else {
                          $scope.currentAdminClass = $scope.adminClasses[0];
                      }
                  }
              }
          });
    }

    function selectedAdminClass(c) {
        $scope.currentAdminClass = c;
        rolePermissions($scope.currentAdminClass.id);
    }


    $ionicModal.fromTemplateUrl('search.html', {
        scope: $scope,
        animation: 'slide-in-left'
    }).then(function (modal) {
        $scope.searchModal = modal;
    });

    function searchShow(){
        $scope.searchModal.show();
    }

    function searchHide(){
        $scope.searchModal.hide();
    }



    $ionicModal.fromTemplateUrl('leaveActiveOpt.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.leaveActiveOptModal = modal;
    });

    function leaveActiveShow(){
        $scope.leaveActiveOptModal.show();
    }

    function leaveActiveHide(){
        $scope.leaveActiveOptModal.hide();
    }


}]);
