angular.module('starter')
    .controller('roomAttendanceStudentController', ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification',
        '$ionicPlatform', "$state", '$timeout',"$stateParams",
        function ($scope, $ionicModal, $http, $location, ynuiNotification, $ionicPlatform, $state, $timeout,$stateParams) {

            var basePath = originBaseUrl + "/third/newss/mobile";

            $scope.clickTerm = clickTerm;
            $scope.findTermTotal = findTermTotal;
            $scope.getColorClass = getColorClass;
            $scope.termStatus = termStatus;
            $scope.goLeave = goLeave;
            $scope.showSignHistory = showSignHistory;

            // 子页面返回参数
            var backSearchInfoOld = angular.fromJson($stateParams.backSearchInfo);

            $scope.data = {
                termList:[],
                termStatusList:[],
                showInfo:{},
                currentTermId:null,
                term:null,
                termInfo:null
            };

            function showSignHistory(list) {
                var flag = false;
                if (list && list.length > 0){
                    flag = true;
                    var count = 0;
                    angular.forEach(list,function (value) {
                        if (value.down){
                            count++;
                        }
                    });
                    flag = list.length !== count;
                }
                return flag;
            }


            function getColorClass(status,type) {
                var flag = status == 1 || status == 2 || status == 5;
                if (type === 1){
                    return flag;
                }else {
                   return !flag ;
                }
            }

            function termStatus(item) {
                $scope.data.termInfo = item;
                $http.post(basePath + "/findTermAndStatus.htm",{id:$scope.data.term.id,status:item.status}).success(function (data) {
                    if (data.status == 0) {
                        var list = [];
                        angular.forEach(data.result,function (value) {
                            list = list.concat(value.dayVOList);
                        });
                        $scope.data.termStatusList = list;
                        $scope.submitFlagModalShow();
                    }
                });


            }
            function clickTerm(term) {
                $scope.data.term = term;
                findTermTotal();
            }


            function goLeave(item,type) {
                var backSearchInfo = angular.toJson({stuId: item.id, date: item.dateStr,termId:$scope.data.term.id});
                if (type === 1){
                    // 请假
                    $location.path("/leave_info").search({backSearchInfo:backSearchInfo,backUrl: $state.current.name,title:$state.current.data.title});
                }else {
                    // 实习
                    $location.path("/activity_info").search({backSearchInfo:backSearchInfo,backUrl:$state.current.name,title:$state.current.data.title});
                }
            }

            function getTermData(oldVm) {
                $http.get(basePath + "/getCurrentTermAndListSelect.htm").success(function (data) {
                    if (data.status == 0) {
                        $scope.data.termList = data.result.termList;
                        if (oldVm && oldVm.termId){
                            angular.forEach(data.result.termList,function (val) {
                                if (val.id === oldVm.termId){
                                    $scope.data.term = val;
                                    $scope.data.currentTermId = val.id;
                                }
                            });
                        }else if (data.result.isCurrentTerm){
                            $scope.data.term = data.result.currentTerm;
                            $scope.data.currentTermId = data.result.currentTerm.id;
                        }else {
                            $scope.data.term = data.result.termList[0];
                            $scope.data.currentTermId = data.result.termList[0].id;
                        }
                        findTermTotal();
                    }else if (data.status == 10){
                        ynuiNotification.error({msg:data.message});
                    }else {
                        ynuiNotification.error({msg:'学期加载失败'});
                    }
                });
            }

            function findTermTotal() {
                $http.post(basePath + "/findTermTotal.htm",{id:$scope.data.term.id}).success(function (data) {
                    if (data.status == 0) {
                        $scope.data.showInfo = data.result;
                    }
                });
            }

            getTermData(backSearchInfoOld);


            $ionicModal.fromTemplateUrl('termView.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.modal1 = modal;
            });
            $scope.submitFlagModalShow = function () {
                $scope.modal1.show();
            };
            $scope.submitFlagModalHide = function () {
                $scope.modal1.hide();
            };

            $ionicPlatform.registerBackButtonAction(function () {
                $timeout(function () {
                    yn.plugin.yncordova.close();
                }, 100);
            }, 101);
        }])
    .controller('roomAttendanceStudentDetailController', ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification', '$ionicPlatform', "$state", '$timeout',
        function ($scope, $ionicModal, $http, $location, ynuiNotification, $ionicPlatform, $state, $timeout) {

            var basePath = originBaseUrl + "/third/newss/mobile";

            var termId = $location.search().termId;
            var status = $location.search().status;


            $scope.data = {
                termList:[]
            };



            function termStatus() {
                $http.post(basePath + "/findTermAndStatus.htm",{id:termId,status:status}).success(function (data) {
                    if (data.status == 0) {
                        var list = [];
                        angular.forEach(data.result,function (value) {
                            list.push(value.dayVOList);
                        });
                        $scope.data.termList = list;
                    }
                });
            }

            termStatus();


        }]);
