/**
 * 我的班级
 * @author qiucheng Lu
 * @date 2021年4月13日11:04:29
 */
(function () {
    'use strict';
    angular.module('starter')
        .config(config)
        .controller('classExamineCtrl', classExamineCtrl);
    config.$inject = ['$stateProvider'];

    function config($stateProvider) {
        $stateProvider
            //我的班级
            .state('stu_my_adminclass', {
                url: '/stu_my_adminclass',
                templateUrl: 'templates/stuInfo/myclass/stu_my_adminclass.html',
                cache: false,
                data: {
                    micro: true,
                    title: '同班同学'
                }
            })
    }

    classExamineCtrl.$inject = ['$scope', '$http', '$ionicModal', "$ionicScrollDelegate"];

    function classExamineCtrl($scope, $http, $ionicModal, $ionicScrollDelegate) {
        var vm = $scope.vm = {
            tab: '1',
            myClassInfo: null,
            status: null,
            myClassStudentInfo: null,
            myClassStudentInfoList: null,
            stuName: "",
            woman: 0,
            man: 0,
            searchFlag: false,
            loading: false,
            originBaseUrl: originBaseUrl,
            getShowHead: {
                vo: {},
                modal: null
            },
            initMyClass: initMyClass,
            initMyClassStudent: initMyClassStudent,
            switchTab: switchTab,
            showHead: showHead,
            closeHead: closeHead,
        }

        function initMyClass() {
            $http.get(vm.originBaseUrl + "/third/studentInfo/getMyAdminClassInfo.htm?status=true" + "&_datatime=" + new Date().getTime()).success(function (data) {
                vm.myClassInfo = data.result;
                vm.status = data.status;
                vm.message = data.message;
            });
        }

        function initMyClassStudent() {
            vm.woman = 0;
            vm.man = 0;
            $http.get(vm.originBaseUrl + "/third/studentInfo/getAdminClassStudentByStudentId.htm?status=true" + "&_datatime=" + new Date().getTime()).success(function (data) {
                if (data.status == 0) {
                    vm.myClassStudentInfoList = data.result;
                    vm.myClassStudentInfo = vm.myClassStudentInfoList;
                    angular.forEach(vm.myClassStudentInfo, function (item) {
                        if (item.gender == 1) {
                            vm.man++;
                        } else {
                            vm.woman++;
                        }
                    })
                }
            });
        }

        function switchTab(tab) {
            vm.tab = tab;
            if (tab == 1) {
                vm.initMyClass();
            } else {
                vm.initMyClassStudent();
            }
            // 定位处理
            $ionicScrollDelegate.$getByHandle('listScroll').scrollTo(0, 1, true);
        }

        function showHead(item) {
            vm.getShowHead.vo = item;
            vm.getShowHead.modal.show();
        }

        function closeHead() {
            vm.getShowHead.modal.hide();
        }

        //展开搜索
        $scope.toSearch = function () {
            vm.searchFlag = true;
            $scope.clearSearch();
        };
        // 隐藏搜索
        $scope.cancelSearch = function () {
            vm.myClassStudentInfo = vm.myClassStudentInfoList;
            vm.searchFlag = false;
        };
        // 清除搜索条件
        $scope.clearSearch = function () {
            vm.stuName = "";
            vm.loading = false;
            vm.myClassStudentInfo = [];
        };
        //模糊匹配学生
        $scope.getReportInfo = function () {
            vm.myClassStudentInfo = [];
            if (!vm.stuName) {
                vm.loading = false;
                return;
            }
            angular.forEach(vm.myClassStudentInfoList, function (item) {
                if (item.name.indexOf(vm.stuName) > -1) {
                    vm.myClassStudentInfo.push(item);
                }
            })
            vm.loading = true;
        }
        $ionicModal.fromTemplateUrl('templates/stuInfo/template/studentHeaderUrl.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            vm.getShowHead.modal = modal;
        });
        vm.switchTab('1');
    }
})();
