/**
 * 我的寝室
 *
 * @author qiucheng Lu
 * @date 2021年4月13日11:04:29
 */

(function () {
    'use strict';
    angular.module('starter')
        .config(config)
        .controller('roomExamineCtrl', roomExamineCtrl);

    config.$inject = ['$stateProvider'];

    function config($stateProvider) {
        $stateProvider
        //我的寝室
            .state('my_dormitory', {
                url: '/my_dormitory',
                templateUrl: 'templates/stuInfo/myroom/my_dormitory.html',
                cache: false,
                data: {
                    micro: true,
                    title: '我的寝室'
                }
            })
    }

    roomExamineCtrl.$inject = ['$scope', '$http', '$ionicModal'];

    function roomExamineCtrl($scope, $http, $ionicModal) {
        var vm = $scope.vm = {
            tab: '1',
            myRoomInfo: null,
            status: null,
            message: null,
            originBaseUrl: originBaseUrl,
            getShowHead: {
                vo: {},
                modal: null
            },
            initMyRoom: initMyRoom,
            showHead: showHead,
            closeHead: closeHead,
        }

        function initMyRoom() {
            $http.get(vm.originBaseUrl + "/third/studentInfo/getMyRoomInfo.htm?status=true" + "&_datatime=" + new Date().getTime()).success(function (data) {
                vm.myRoomInfo = data.result;
                vm.status = data.status;
                vm.message = data.message;
            });
        }

        function showHead(item) {
            vm.getShowHead.vo = item;
            vm.getShowHead.modal.show();
        }

        function closeHead() {
            vm.getShowHead.modal.hide();
        }

        $ionicModal.fromTemplateUrl('templates/stuInfo/template/studentHeaderUrl.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            vm.getShowHead.modal = modal;
        });
        vm.initMyRoom();
    }
})();