
/**
 * 报到物资领用 APP
 */
(function () {
    'use strict';
    angular.module('starter')
        .config(stateConfig)
        .controller('stuMaterialPageController', stuMaterialPageController)
        .controller('stuMaterialQueryController', stuMaterialQueryController)
        .controller('stuMaterialListController', stuMaterialListController)
        .controller('stuMaterialDetailController', stuMaterialDetailController);
    stateConfig.$inject = ['$stateProvider','$urlRouterProvider'];
    function stateConfig($stateProvider,$urlRouterProvider){
        $stateProvider
            //物资领用  首页
            .state('stu_material_page', {
                url: '/stu_material_page',
                templateUrl: 'templates/stuMaterial/stuMaterialPage.html',
                data: {
                    micro: true,
                    title: '物资领用',
                    prev: null
                },
                cache:false
            })
            //查询页面
            .state('stu_material_query', {
                url: '/stu_material_query',
                templateUrl: 'templates/stuMaterial/stuMaterialQuery.html',
                data: {
                    micro: true,
                    title: '物资领用'
                },
                cache:false
            })
            //列表页面
            .state('stu_material_list', {
                url: '/stu_material_list',
                templateUrl: 'templates/stuMaterial/stuMaterialList.html',
                data: {
                    title: '物资领用',
                    prev: 'stu_material_query'
                },
                cache:false
            })
            //详情页面
            .state('stu_material_detail', {
                url: '/stu_material_detail',
                templateUrl: 'templates/stuMaterial/stuMaterialDetail.html',
                data: {
                    title: '物资领用',
                    prev: 'stu_material_list'
                },
                cache:false
            })
            .state('stu_material_detail1', {
                url: '/stu_material_detail1',
                templateUrl: 'templates/stuMaterial/stuMaterialDetail.html',
                data: {
                    title: '物资领用',
                    prev: 'stu_material_query'
                },
                cache:false
            });

       $urlRouterProvider.otherwise('/stu_material_page');
    }
    stuMaterialPageController.$inject=['$scope','$http','$location'];
    function stuMaterialPageController ($scope,$http,$location){
        $scope.validLoginAndTerm = validLoginAndTerm;//验证 登录人和学期，是否符合要求

        function validLoginAndTerm() {
            $http.post(originBaseUrl + "/third/bdgl/stuMaterial/validByloginUserId.htm").success(function(data){
                if(data.status==0){
                    $scope.validTip = data.result;
                    if(!$scope.validTip){//没有提示信息
                        $location.path("/stu_material_query");
                    }
                }else{
                    ynuiNotification.error({msg: data.message});
                }
            });
        }
        validLoginAndTerm();
    }
    stuMaterialQueryController.$inject=['$scope','$ionicModal','$http','$location','$filter','ynuiNotification','$ionicPopup','$cordovaBarcodeScanner','$ionicLoading'];
    function stuMaterialQueryController($scope,$ionicModal,$http,$location,$filter,ynuiNotification,$ionicPopup,$cordovaBarcodeScanner,$ionicLoading){
        var errorMsg = null;

        validLoginAndTerm();

        function validLoginAndTerm() {
            $http.post(originBaseUrl + "/third/bdgl/stuMaterial/validByloginUserId.htm").success(function(data){
                if(data.status==0){
                    if(data.result){
                        ynuiNotification.error({msg: data.result});
                        errorMsg = data.result;
                    }
                }else{
                    ynuiNotification.error({msg: data.message});
                    errorMsg = data.message;
                }
            });
        }

        var basePath = originBaseUrl + "/third/bdgl/stuMaterial";

        $scope.getGradeAndEnrollType = getGradeAndEnrollType;//获取 学期 、年级和招生类型
        $scope.toQuery = toQuery;//跳转查询列表
        $scope.scanCode = scanCode;//扫一扫
        $scope.query = query;//查询
        $scope.viewSchoolCard = viewSchoolCard;//校牌
        $scope.closeModel = closeModel;//关闭校牌

        var schoolCard;
        $ionicModal.fromTemplateUrl('schoolCard.html', {
            scope: $scope,
            animation: 'slide-in-right'
        }).then(function(modal) {
            schoolCard = modal;
        });

        function getGradeAndEnrollType() {
            $http.post(basePath + "/getTermAndGradeName.htm").success(function(data){
                if(data.status==0){
                    $scope.termAndGradeName = data.result;
                }else{
                    ynuiNotification.error({msg: data.message});
                }
            });
        }
        getGradeAndEnrollType();

        function toQuery() {
            if (errorMsg) {
                ynuiNotification.error({msg: errorMsg})
                return false;
            }
            $location.path("/stu_material_list");
        }

        function scanCode() {
            if (errorMsg) {
                ynuiNotification.error({msg: errorMsg})
                return false;
            }
            $cordovaBarcodeScanner.scan().then(function (barcodeData) {
                query(barcodeData.text);
            }, function (error) {
                ynuiNotification.error({msg: "扫描失败！"});
            });
        }

        function query(stuInfo) {
            $ionicLoading.show({
                template: "正在查询学生..."
            });

            var userId='';
            //扫码返回的用户json格式   以前：{"userid":""}   新：1|5:userId
            if(stuInfo.indexOf("userId")>-1||stuInfo.indexOf("USERID")>-1){
                userId=stuInfo.substring(11,stuInfo.length-2);
            }else if(stuInfo.indexOf("1|5")>-1){
                userId=stuInfo.substring(4,stuInfo.length);
            }else{
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title:"提示",
                    template:'请确认二维码校牌是否正确！',
                    okText:"关闭"
                });
                return;
            }

            $http.post(basePath + '/validByStuInfo.htm',{sysUserId: userId}).success(function (data) {
                $ionicLoading.hide();
                if (data.status == 0) {
                    $scope.commonInfo = data.result;
                    if($scope.commonInfo&&$scope.commonInfo.tip){
                        var validTip=$scope.commonInfo.tip;
                        if(validTip.indexOf("报到日期")>=0){
                            validTip= "<span class='text-danger'>报到时间还未开始，不能领用物资！</span>"+$scope.commonInfo.tip;
                        }else if(validTip.indexOf("同学")>=0){
                            var tipSplit=validTip.split("同学");
                            var tipSplit1=tipSplit[1].split('，');
                            validTip=tipSplit[0]+"同学<span class='text-danger'>"+tipSplit1[0]+"</span>，"+tipSplit1[1];
                        }
                        $ionicPopup.alert({
                            title:"提示",
                            template:validTip,
                            okText:"关闭"
                        });
                    }else{
                        //符合要求
                        $location.path("/stu_material_detail1").search({"sysUserId":userId,"type":2});
                    }
                } else {
                    ynuiNotification.error({msg: "查询学生失败！"});
                }
            }).error(function () {
                $ionicLoading.hide();
                ynuiNotification.error({msg: "查询学生失败！"});
            });
        }

        function viewSchoolCard() {
            schoolCard.show();
        }
        //关闭弹窗
        function closeModel() {
            schoolCard.hide();
        }
    }
    stuMaterialListController.$inject=['$scope','$ionicModal','$http','$location','$ionicPopup','ynuiNotification'];
    function stuMaterialListController($scope,$ionicModal,$http,$location,$ionicPopup,ynuiNotification){
        var basePath = originBaseUrl + "/third/bdgl/stuMaterial";

        $scope.getGradeAndEnrollType = getGradeAndEnrollType;//获取 学期 、年级和招生类型
        $scope.findStudent = findStudent;//查询
        $scope.goToDetail = goToDetail;//跳转明细
        $scope.clearName = clearName;//清空
        $scope.keypress = keypress;//鼠标事件
        $scope.tip = '';

        //鼠标事件
        function keypress(e) {
            var keycode = window.event?e.keyCode:e.which;
            if(keycode==13){
                findStudent();
            }
        }
        function getGradeAndEnrollType() {
            $http.post(basePath + "/getTermAndGradeName.htm").success(function(data){
                if(data.status==0){
                    $scope.termAndGradeName = data.result;
                }else{
                    ynuiNotification.error({msg: data.message});
                }
            });
        }
        getGradeAndEnrollType();

        function findStudent() {
            if(!$scope.searchInfo.name){
                ynuiNotification.error({msg: "请输入要查询的学生！"});
                return;
            }
            $http.post(basePath + "/findAllStuByCondition.htm",{otherInfo:$scope.searchInfo.name,type:1}).success(function (data) {
                if (data.status == 0) {
                    $scope.commonInfo = data.result;
                    if($scope.commonInfo.tip){
                        $scope.tip=$scope.commonInfo.tip;
                    }else{
                        $scope.tip = '';
                    }

                }
            });
        }

        function goToDetail(id) {
            $http.post(basePath + "/validByStuInfo.htm",{stuBaseInfoId:id}).success(function (data) {
                if (data.status == 0) {
                    $scope.stuInfo = data.result;
                    if($scope.stuInfo&&$scope.stuInfo.tip){
                        var validTip=$scope.stuInfo.tip;
                        if(validTip.indexOf("报到日期")>=0){
                            validTip= "<span class='text-danger'>报到时间还未开始，不能领用物资！</span>"+$scope.stuInfo.tip;
                        }else{
                            var tipSplit=validTip.split("同学");
                            var tipSplit1=tipSplit[1].split('，');
                            validTip=tipSplit[0]+"同学<span class='text-danger'>"+tipSplit1[0]+"</span>，"+tipSplit1[1];
                        }
                        var confirmPopup = $ionicPopup.alert({
                            title:"提示",
                            template: validTip,
                            okText:"关闭"
                        });

                    }else{
                        //符合要求
                        $location.path("/stu_material_detail").search({"sysUserId":$scope.stuInfo.stuId,"type":1});
                    }
                }
            });
        }
        function clearName() {
            $scope.searchInfo.name='';
        }
    }
    stuMaterialDetailController.$inject=['$scope','$ionicModal','$http','$location','ynuiNotification','$ionicPopup','$cordovaBarcodeScanner','$ionicLoading'];
    function stuMaterialDetailController($scope,$ionicModal,$http,$location,ynuiNotification,$ionicPopup,$cordovaBarcodeScanner,$ionicLoading){
        var basePath = originBaseUrl+"/third/bdgl/stuMaterial";
        $scope.stuId = $location.search().sysUserId;
        $scope.type = $location.search().type;//1 手动输入查询 2 扫一扫查询
        $scope.materialVOList=[];
        $scope.dataCount=0;//有几个可操作的数据，没有的话“提交”隐藏
        $scope.statusList =[{id:0,name:'本次全部领用'},{id:1,name:'本次仅领用部分'}];
        $scope.getUserInfo = getUserInfo;//获取用户详情
        $scope.saveData = saveData;//保存
        $scope.deleteData = deleteData;//删除
        $scope.changeChildBox = changeChildBox;//"本次把剩下的全部领用"复选框操作
        $scope.scanCode = scanCode;//扫一扫
        $scope.backQuery = backQuery;//返回
        $scope.query = query;


        function getUserInfo(userId) {
            $scope.dataCount=0;
            $scope.materialVOList=[];
            $scope.userAndMaterialInfo='';
            $http.get(basePath + "/findStuMaterialInfo.htm?stuId="+userId).success(function (data) {
                if (data.status == 0) {
                    $scope.userAndMaterialInfo= data.result;

                    angular.forEach($scope.userAndMaterialInfo.inCollectMaterialVOList,function (data) {
                        data.select=true;
                        data.childBox=true;
                        $scope.dataCount++;
                        $scope.materialVOList.push(angular.copy(data));
                    })
                    angular.forEach($scope.userAndMaterialInfo.collectedMaterialVOList,function (data) {
                        if(data.status==0){
                            $scope.materialVOList.push(angular.copy(data));
                        }
                    })
                }
            });
        }
        getUserInfo($scope.stuId);

        function saveData(type) {//type： 1提交并继续登记  2提交
            var saveData={//最终可以保存的数据
                inCollectMaterialVOList:[]
            };
            angular.forEach($scope.materialVOList,function (data) {
                if(data.select){
                    if(data.id&&data.childBox&&data.status==1){//全部领用
                        data.status=0;
                    }
                    data.terminal=1;
                    saveData.inCollectMaterialVOList.push(data);
                }
            })
            if(saveData.inCollectMaterialVOList.length>0){
                $http.post(basePath + "/saveMaterialInfo.htm?",parseParamForSpringMVC(saveData)).success(function (data) {
                    if (data.status == 0) {
                        ynuiNotification.success({msg: "保存成功！"});
                        if(type==1){//type： 1提交并继续登记  2提交
                            getUserInfo($scope.stuId);
                            scanCode();
                        }else{
                            $location.path("/stu_material_query");
                        }
                    }
                });
            }else{
                ynuiNotification.error({msg: "请至少勾选一项！"});
            }
        }

        function deleteData(info) {
            var tip='';
            if($scope.userAndMaterialInfo.loginUserName==info.regUserName){
                tip="“"+$scope.userAndMaterialInfo.userName+"”同学已领用了“<span class='text-danger'>"+info.name+"</span>”,您确定要删除领用记录吗？";
            }else{
                tip="“"+info.name+"”是“<span class='text-danger'>"+info.regUserName+"</span>”老师登记发放的,您确定删除领用记录吗？";
            }
            $ionicPopup.confirm({
                title: '操作提示',
                template: tip,
                cancelText: '取消',
                okText: '确认'
            }).then(function (res) {
                if (res) {
                    $http.get(basePath + "/deleteMaterialById.htm?id="+info.id).success(function (data) {
                        if (data.status == 0) {
                            ynuiNotification.success({msg: "删除成功！"});
                            $scope.materialVOList=[];
                            getUserInfo($scope.stuId);
                        }
                    });
                }
            });
        }

        function changeChildBox(info,type) {
            if(type==1){
                var select=info.select;
                info.childBox=!select;
                info.select=!select;
            }else{
                if(info.childBox){//选中时，把物资也选中
                    info.select=true;
                }
            }

        }

        function scanCode() {
            $cordovaBarcodeScanner.scan().then(function (barcodeData) {
                query(barcodeData.text);
            }, function (error) {
                ynuiNotification.error({msg: "扫描失败！"});
            });
        }

        function query(stuInfo) {
            $ionicLoading.show({
                template: "正在查询学生..."
            });

            // var userId = stuInfo["userId"];
            //
            // if(!userId){
            //     userId = stuInfo["USERID"];
            // }
            // if(!userId){
            //     userId = stuInfo["1|5"];
            // }
            var stuId='';
            //扫码返回的用户json格式   以前：{"userid":""}   新：1|5:userId
            if(stuInfo.indexOf("userId")>-1||stuInfo.indexOf("USERID")>-1){
                stuId=stuInfo.substring(11,stuInfo.length-2);
            }else if(stuInfo.indexOf("1|5")>-1){
                stuId=stuInfo.substring(4,stuInfo.length);
            } else{
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title:"提示",
                    template:'请确认二维码校牌是否正确！',
                    okText:"关闭"
                });

                return;
            }

            $http.post(basePath + '/validByStuInfo.htm',{sysUserId: stuId}).success(function (data) {
                $ionicLoading.hide();
                if (data.status == 0) {
                    $scope.commonInfo = data.result;
                    if($scope.commonInfo&&$scope.commonInfo.tip){
                        var validTip=$scope.commonInfo.tip;
                        if(validTip.indexOf("报到日期")>=0){
                            validTip= "<span class='text-danger'>报到时间还未开始，不能领用物资！</span>"+$scope.commonInfo.tip;
                        }else if(validTip.indexOf("同学")>=0){
                            var tipSplit=validTip.split("同学");
                            var tipSplit1=tipSplit[1].split('，');
                            validTip=tipSplit[0]+"同学<span class='text-danger'>"+tipSplit1[0]+"</span>，"+tipSplit1[1];
                        }
                        $ionicPopup.alert({
                            title:"提示",
                            template: validTip,
                            okText:"关闭"
                        });
                    }else{
                        //符合要求
                        // $location.path("/stu_material_detail").search({"sysUserId":stuId,"type":2});
                        $scope.stuId=stuId;
                        getUserInfo(stuId);
                    }
                } else {
                    ynuiNotification.error({msg: "查询学生失败！"});
                }
            }).error(function () {
                $ionicLoading.hide();
                ynuiNotification.error({msg: "查询学生失败！"});
            });
        }

        function backQuery() {
            $location.path("/stu_material_query");
        }
        /**
         * 把obj转化为Spring可接受状态
         * @param obj
         * @returns {{}}
         */
        var parseParamForSpringMVC = function (obj) {
            var resultObj = {};
            var deepParseParams = function (key, value, prefix) {
                if (value instanceof Array) {
                    for (var i in value) {
                        deepParseParams("", value[i], prefix + key + "[" + i + "]");
                    }
                }
                else if (value instanceof Object) {
                    for (var i in value) {
                        deepParseParams("." + i, value[i], prefix + key);
                    }
                }
                else {
                    resultObj[prefix + key] = value;
                }
            };
            for (var i in obj) {
                deepParseParams("", obj[i], i);
            }
            return resultObj;
        };
    }
})();

