/**
 * 补考管理
 * @author qiucheng lu
 * @Date 2021年4月15日10:51:40
 *
 */
(function () {
    'use strict';

    angular.module('starter')
        .config(bkConfig)
        .controller("supplementExamController", supplementExamController)
        .controller("manageStudentController", manageStudentController)
        .controller("retestArrangeStudentController", retestArrangeStudentController);
    bkConfig.$inject = ['$stateProvider'];

    function bkConfig($stateProvider) {
        $stateProvider
        // 补考学生确认
            .state('student_notarize', {
                url: '/student_notarize',
                templateUrl: 'templates/supplement_exam/manageStudent/supplementExam.html',
                data: {
                    prev: 'workspaceForTeacher',
                    title: '补考管理'
                },
                controller: 'supplementExamController'
            });
    }

    supplementExamController.$inject = ['$scope', '$location'];

    function supplementExamController($scope, $location) {
        //初始化选项卡
        $scope.tabRepeat = [
            {id: "1", name: "补考名单确认", active: true},
            {id: "2", name: "补考安排表", active: false}
        ];
        //点击选项卡
        $scope.clickTab = function (index) {
            $scope.activeKey = index;
            angular.forEach($scope.tabRepeat, function (value) {
                value.active = false;
                if (value.id == index) {
                    value.active = true;
                }
            })
        };
        //初始化选中效果
        var defActive = "1";
        $scope.clickTab(defActive);
    }

    manageStudentController.$inject = ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification', '$ionicScrollDelegate', '$filter', "$q", "ynNavigator"];

    function manageStudentController($scope, $ionicModal, $http, $location, ynuiNotification, $ionicScrollDelegate, $filter, $q, ynNavigator) {
        var basePath = originBaseUrl + "/third/CJRetestController";

        //选计划
        $scope.selectedPlanFun = selectedPlanFun;
        //选行政班
        $scope.selectedAdminFun = selectedAdminFun;
        //选补考状态
        $scope.selecteRetestFun = selectedRetestFun;
        //确认学生
        $scope.confirmStudentFun = confirmStudentFun;
        //选中原因
        $scope.selectedReasonFun = selectedReasonFun;
        //添加待申请学生
        $scope.addCJApplyStudentFun = addCJApplyStudentFun;
        $scope.addCJApplyStudentCancelFun = addCJApplyStudentCancelFun;
        $scope.selectedStudentFun = selectedStudentFun;
        //添加参加补考学生
        $scope.attendStudentFun = attendStudentFun;
        //审核
        $scope.checkApplyFun = checkApplyFun;
        //确认学生是否参加补考
        $scope.confirmStudentIsAttend = confirmStudentIsAttend;
        //取消确认学生的弹框
        $scope.cancelConfirm = cancelConfirm;

        $scope.searchData = {};
        $scope.selectedPlan = {};
        $scope.selectedAdminClass = {};
        $scope.selectedStatus = {};
        $scope.message = "";
        //补考状态
        $scope.retestStatus = [];
        $scope.comfirData = {};
        $scope.selectedReason = {};
        $scope.showData = {};
        $scope.message1 = "";


        $http.post(basePath + "/queryDictionarys.htm", {
            "key": "ATTEND_STATUS",
            "status": true
        }).success(function (data) {
            if (data.status == 0) {
                $scope.allReasonList = data.result.reverse();
            }
        });

        function selectedReasonFun(info) {
            if (info.dictCode != $scope.selectedReason.dictCode) {
                $scope.comfirData.reason = "";
                $scope.comfirData.cancelReasonType = info.dictCode;
                $scope.selectedReason = info
            }
        }

        //加载教学行政班
        var initDefer = $q.defer();
        //初始化
        initDefer.promise.then(function () {
            return findSysAdminClassByPlanId();
        }).then(function () {
            return hasPreExamApplyFun();
        }).then(function () {
            refreshConfirm();
        });

        //获取学期计划
        $http.get(basePath + "/findCjRetestPlanList.htm").success(function (data) {
            if (data.status == 0) {
                $scope.planList = data.result.cjRetestPlanVOList ? data.result.cjRetestPlanVOList : [];
                if ($scope.planList.length == 0) {
                    $scope.message = "无需确认补考名单！";
                    return;
                }
                $scope.searchData.planId = data.result.planId;
                findSelectedPlan();
                initDefer.resolve();
            }

        });

        function findSelectedPlan() {
            for (var i = 0; i < $scope.planList.length; i++) {
                var data1 = $scope.planList[i];
                if (data1.id == $scope.searchData.planId) {
                    $scope.selectedPlan = data1;
                }
            }
        }

        //系部是否到申请时间
        function hasPreExamApplyFun() {
            var hasPreExamDefer = $q.defer();
            var adminClassIds = [];
            angular.forEach($scope.selectedAdminClassList, function (data) {
                adminClassIds.push(data.id)
            });
            $http.post(basePath + "/hasPreExamApply.htm", {
                planId: $scope.searchData.planId,
                adminClassIds: adminClassIds
            }).success(function (data) {
                if (data) {
                    $scope.message = data;
                    return hasPreExamDefer.promise;
                }
                hasPreExamDefer.resolve();
            });
            return hasPreExamDefer.promise;
        }

        //行政班
        function findSysAdminClassByPlanId() {
            var adminClassDeffer = $q.defer();
            $scope.message = "";
            $scope.selectedAdminClassList = [];
            $http.post(basePath + "/findSysAdminClassByPlanId.htm", {planId: $scope.searchData.planId}).success(function (data) {
                if (data.status == 0) {
                    $scope.selectedAdminClassList = data.result;
                    if (data.result && data.result.length > 0) {
                        $scope.selectedAdminClass = data.result[0];
                        $scope.searchData.adminClassId = $scope.selectedAdminClass.id;
                        adminClassDeffer.resolve();
                    }
                    if (!data.result || data.result.length == 0) {
                        $scope.message = "本次补考安排没有您班的学生！";
                        return adminClassDeffer.promise;
                    }

                }
            });
            return adminClassDeffer.promise;
        }

        //获取选中id
        function selectedPlanFun(plan) {
            if (plan.id != $scope.searchData.planId) {
                $scope.resultSure = {};
                $scope.message = "";
                $scope.searchData.planId = plan.id;
                $scope.selectedPlan = plan;
                findSysAdminClassByPlanId().then(function () {
                    return hasPreExamApplyFun();
                }).then(function () {
                    refreshConfirm();
                });
            }
        }

        //获取选中行政班
        function selectedAdminFun(adminClass) {
            if (adminClass.id != $scope.searchData.adminClassId) {
                $scope.searchData.adminClassId = adminClass.id;
                $scope.selectedAdminClass = adminClass;
                refreshConfirm();
            }
        }

        //统计要补考、不补考、待审核个数
        function refreshConfirm(init) {
            $http.post(basePath + "/findCJRetestStudentCounts.htm", $scope.searchData).success(function (data) {
                $scope.retestStatus = [];
                if (data.status == 0) {
                    $scope.resultCount = data.result;
                    $scope.retestStatus.push({id: '1', name: '要补考', count: $scope.resultCount.needRetestCount});
                    $scope.retestStatus.push({id: '0', name: '不补考', count: $scope.resultCount.notRetestCount});
                    $scope.retestStatus.push({id: '2', name: '待审核', count: $scope.resultCount.needCheckCount});
                    if (!init) {
                        $scope.searchData.retestStatus = '1';
                        $scope.searchData.check = null;
                        $scope.selectedStatus = $scope.retestStatus[0];
                        if ($scope.resultCount.needCheckCount > 0) {
                            $scope.searchData.check = 0;
                            $scope.selectedStatus = $scope.retestStatus[2];
                        }
                    }
                    findStudentList();
                }
            });
        }

        //选中补考状态
        function selectedRetestFun(status) {
            $scope.searchData.retestStatus = null;
            $scope.searchData.check = null;
            if (status.id != $scope.selectedStatus.id) {
                if (status.id != '2') {
                    $scope.searchData.retestStatus = status.id;
                } else {
                    $scope.searchData.check = 0;
                }
                $scope.selectedStatus = status;
                findStudentList();
            }
        }

        //查找确认名单
        function findStudentList() {
            $scope.message1 = "";
            $http.post(basePath + "/findStudentList.htm", $scope.searchData).success(function (data) {
                if (data.status == 0) {
                    var message = data.result;
                    if (!message.result || message.result.length == 0) {
                        $scope.message1 = "没有相关数据！";
                    }
                    $scope.resultSure = message.result;
                    $ionicScrollDelegate.$getByHandle('dashboard').scrollTop(false);
                }
            });
            applyStudentFun();
        }


        //验证审核
        function checkAddCheckApplyStudent(applyId) {
            $http.post(basePath + "/checkAddCheckApplyStudent.htm", {id: applyId}).success(function (data) {
                if (data) {
                    ynuiNotification.error({msg: data});
                } else {
                    $scope.confirmStudentModal.show();
                }
            });
        }

        //验证是否安排补考
        function testIsArrange(id) {
            $http.post(basePath + "/testIsArrange.htm", {id: id}).success(function (data) {
                if (data) {
                    ynuiNotification.error({msg: data});
                } else {
                    $scope.confirmStudentModal.show();
                }
            });
        }

        //确认学生弹框
        $ionicModal.fromTemplateUrl('confirmStudent.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.confirmStudentModal = modal;
        });

        function confirmStudentFun(result) {
            if (result.overApplyTime) {
                ynuiNotification.error({msg: "已超过申请补考日期，不能再确认！"});
                return;
            }
            $scope.showData = angular.copy(result);
            if ($scope.showData.retestStatusName) {
                $scope.showData.retestStatusName = $scope.showData.retestStatusName.replace("补考", "");
            }

            $scope.selectedReason = {};
            $scope.comfirData = {};
            //待审核
            if ($scope.selectedStatus.id == "2") {
                $scope.comfirData = {ids: [result.applyId]};
                checkAddCheckApplyStudent(result.applyId);
            } else {
                $scope.comfirData = {ids: [result.id]};
                testIsArrange(result.id);
            }
        }

        function cancelConfirm() {
            $scope.confirmStudentModal.hide();
        }

        //审核申请
        function checkApplyFun(applyType) {
            $scope.comfirData.applyType = applyType;
            $http.post(basePath + "/addCheckApplyStudent.htm", $scope.comfirData).success(function (data) {
                if (data.status == 0) {
                    if (data.result.length > 0) {
                        ynuiNotification.error({msg: data.result[0]});
                        return;
                    }
                    ynuiNotification.success({msg: "操作成功！"});
                    //刷新页面
                    refreshConfirm(1);
                    cancelConfirm();
                } else {
                    ynuiNotification.error({msg: "操作失败！"});
                }
            });
        }

        // 学生代确认
        function confirmStudentIsAttend() {
            if ($scope.selectedStatus.id == "1") {
                $scope.comfirData.status = "0";
                if ($scope.comfirData.cancelReasonType == undefined || ($scope.comfirData.cancelReasonType == '5' && !$scope.comfirData.reason)) {
                    ynuiNotification.error({msg: "不参加补考原因必填！"});
                    return;
                }
            } else {
                $scope.comfirData.status = "1";
            }
            $http.post(basePath + "/sureRetestStudent.htm", $scope.comfirData).success(function (data) {
                if (data.status == 0) {
                    if (data.result.length > 0) {
                        ynuiNotification.error({msg: data.result[0]});
                        return;
                    }
                    ynuiNotification.success({msg: "操作成功！"});
                    cancelConfirm();
                    //刷新页面
                    refreshConfirm(1);
                } else {
                    ynuiNotification.error({msg: "操作失败！"});
                }
            });

        }

        //查找待申请学生
        function applyStudentFun() {
            var data = angular.copy($scope.searchData);
            data.retestStatus = '2';
            data.check = null;
            $http.post(basePath + "/findStudentList.htm", data).success(function (data) {
                if (data.status == 0) {
                    var message = data.result;
                    $scope.applyStudent = message.result;
                }
            });
        }

        //选择补考学生
        function selectedStudentFun(student) {
            !student.selected ? student.selected = 1 : student.selected = 0;
        }

        //确认学生参加补考
        function attendStudentFun() {
            var confirmAttendData = {ids: [], status: "1"};
            //放入选中的数据
            angular.forEach($scope.applyStudent, function (data) {
                if (data.selected == 1) {
                    confirmAttendData.ids.push(data.id);
                }
            });
            if (confirmAttendData.ids.length == 0) {
                ynuiNotification.error({msg: "至少勾选一项！"});
                return;
            }
            $http.post(basePath + "/sureRetestStudent.htm", confirmAttendData).success(function (data) {
                if (data.status == 0) {
                    if (data.result.length > 0) {
                        if (data.result.length == confirmAttendData.ids) {
                            ynuiNotification.error({msg: "操作失败！"});
                            return;
                        } else {
                            ynuiNotification.success({msg: "部分操作成功！"});
                        }
                    }
                    ynuiNotification.success({msg: "操作成功！"});
                    $scope.searchData.retestStatus = '1';
                    $scope.selectedStatus = $scope.retestStatus[0];
                    addCJApplyStudentCancelFun();
                } else {
                    ynuiNotification.error({msg: "操作失败！"});
                }
            });
        }


        // /*添加学生补考名单模态*/
        $ionicModal.fromTemplateUrl('addCJApplyStudent.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal1 = modal;
        });

        function addCJApplyStudentFun() {
            $scope.modal1.show();
            //注册拦截事件
            registerBackAction();
        }

        function addCJApplyStudentCancelFun() {
            $scope.modal1.hide();
            //刷新页面
            refreshConfirm(1);
            //关闭拦截事件注册
            setTimeout(function () {
                ynNavigator.cancelBackAction(201);
            });
        }

        //注册拦截事件
        function registerBackAction() {
            ynNavigator.registerBackAction(function () {
                addCJApplyStudentCancelFun();
            },201);
        }

    }

    retestArrangeStudentController.$inject = ['$scope', '$ionicModal', '$http', '$location', 'ynuiNotification', '$ionicScrollDelegate', '$filter', "$q", "$ionicPopup"];

    function retestArrangeStudentController($scope, $ionicModal, $http, $location, ynuiNotification, $ionicScrollDelegate, $filter, $q, $ionicPopup) {
        var basePath = originBaseUrl + "/third/CJRetestController";

        //选计划
        $scope.selectedTermFun = selectedTermFun;
        //选行政班
        $scope.selectedAdminFun = selectedAdminFun;
        //选时间
        $scope.selectedDateFun = selectedDateFun;


        $scope.searchData = {};
        $scope.selectedTerm = {};
        $scope.selectedDateStatus = {};
        $scope.selectedAdminClass = {};
        $scope.message1 = "";

        var termDefer = $q.defer();

        //初始化
        termDefer.promise.then(function () {
            if ($scope.searchData.termId) {
                return hasPlanInTermId();
            }
        }).then(function () {
            findSysAdminClassByPlanId();
        });
        //查询安排补考学期

        $http.post(basePath + "/getTerm.htm?isAsc=false&selectedTerm=1").success(function (data) {
            if (data.status == 0) {
                $scope.termList = data.result.values;
                if (data.result.selected) {
                    $scope.searchData.termId = data.result.selected;
                } else if ($scope.termList.length > 0) {
                    $scope.searchData.termId = $scope.termList[0].selected;
                }
                findSelectedTerm();
                termDefer.resolve();
            }
        });

        //学期下是有计划
        function hasPlanInTermId() {
            var existDefer = $q.defer();
            $http.post(basePath + "/hasPlanInTermId.htm?termId=" + $scope.searchData.termId).success(function (data) {
                if (data.length == 0) {
                    $scope.message1 = "该学期无补考安排！";
                } else {
                    existDefer.resolve();
                }
            });
            return existDefer.promise;
        }

        function findSelectedTerm() {
            for (var i = 0; i < $scope.termList.length; i++) {
                var data1 = $scope.termList[i];
                if (data1.id == $scope.searchData.termId) {
                    $scope.selectedTerm = data1;
                }
            }
        }

        //行政班
        function findSysAdminClassByPlanId() {
            $scope.message1 = "";
            $scope.studentList = [];
            $scope.selectedAdminClass = {};
            $http.post(basePath + "/findSysAdminClassByTermId.htm", {termId: $scope.searchData.termId}).success(function (data) {
                if (data.status == 0) {
                    $scope.selectedAdminClassList = data.result;
                    if (data.result.length > 0) {
                        $scope.selectedAdminClass = data.result[0];
                        $scope.searchData.adminClassId = $scope.selectedAdminClass.id;
                    }
                    if (!$scope.selectedAdminClassList || $scope.selectedAdminClassList.length == 0) {
                        $scope.message1 = "您的班级没有参加补考的学生！";
                        return;
                    }
                    refreshConfirm();
                }
            });
        }


        function refreshConfirm() {
            $scope.dateStatus = [];
            $http.post(basePath + "/findArrangeStudentCount.htm", $scope.searchData).success(function (data) {
                if (data.status == 0) {
                    if (data.message) {
                        $scope.message = data.message;
                        return;
                    }
                    $scope.dateStatus.push({id: '0', name: '全部', count: data.result.allCount});
                    $scope.dateStatus.push({id: '1', name: '今天', count: data.result.todayCount});
                    $scope.dateStatus.push({id: '2', name: '明天', count: data.result.tomorrowCount});
                    $scope.selectedDateStatus = $scope.dateStatus[0];
                    if (data.result.tomorrowCount > 0) {
                        $scope.selectedDateStatus = $scope.dateStatus[2];
                    }
                    if (data.result.todayCount > 0) {
                        $scope.selectedDateStatus = $scope.dateStatus[1];
                    }
                    $scope.searchData.type = $scope.selectedDateStatus.id;
                    findStudentList();
                }
            });
        }

        //获取选中id
        function selectedTermFun(term) {
            if (term.id != $scope.searchData.termId) {
                $scope.searchData.termId = term.id;
                $scope.selectedTerm = term;
                $scope.selectedAdminClassList = [];
                $scope.searchData.adminClassId = "";
                $scope.selectedAdminClass = {};
                hasPlanInTermId().then(function () {
                    findSysAdminClassByPlanId();
                });
            }

        }

        //获取选中行政班
        function selectedAdminFun(adminClass) {
            if (adminClass.id != $scope.searchData.adminClassId) {
                $scope.searchData.adminClassId = adminClass.id;
                $scope.selectedAdminClass = adminClass;
                refreshConfirm();
            }
        }

        //选中时间类型
        function selectedDateFun(status) {
            if (status.id != $scope.selectedDateStatus.id) {
                $scope.selectedDateStatus = status;
                $scope.searchData.type = $scope.selectedDateStatus.id;
                findStudentList();
            }
        }

        //查找数据
        function findStudentList() {
            $scope.message = '';
            $scope.studentList = [];
            $http.post(basePath + "/findStudentArrangeInfo.htm", $scope.searchData).success(function (data) {
                if (data.status == 0) {
                    $scope.studentList = data.result.arrangeStudentInfo;
                    $ionicScrollDelegate.$getByHandle('dashboard').scrollTop(false);
                }
            });
        }
    }


})();
