(function () {
  "use strict";

  angular
    .module("starter")
    .config(config)
    .controller('classInBedStudentController', classInBedStudentController);

  config.$inject = ['$stateProvider'];

  function config($stateProvider) {
    $stateProvider
      //在寝情况
      .state('class_inBedStudent', {
        url: '/teacher/workspace/class_inBedStudent',
        templateUrl: 'templates/classSituation/class_inBedStudent.html',
        controller: 'classInBedStudentController',
        data: {
          prev: 'workspaceForTeacher',
          title: '在寝学生(AI)'
        }
      });
  }

  classInBedStudentController.$inject = ['$rootScope', '$scope', '$http', 'storageService', 'modalManager', '$ionicModal'];

  function classInBedStudentController($rootScope, $scope, $http, storageService, modalManager, $ionicModal) {

    // 班级id
    $scope.classId = null;
    var basePath = originBaseUrl + "/third/newss/mobile";

    var vm = $scope.vm = {
      classId: $scope.classId,
      showDate: {
        showName: null,
      },
      inBedRoomInfo: null,
      // 星期
      arr: ["星期日", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六"],
      // 获取当前日期
      getSystemDate: function () {
        $http.post(basePath + "/getSystemDate.htm").success(function (data) {
          if (data.status == 0) {
            vm.showDate.showName = "[今天]" + data.result.day + " " + vm.arr[data.result.week];
            vm.getDataInfo();
          }
        });
      },
      doBack: function () {
        history.back(-1);
      },
      getDataInfo: function () {
        var param = {
          type: 1,
          classId: vm.classId
        };
        $http.post(basePath + "/findInBedCount.htm", param).success(function (data) {
          if (data.status == 0) {
            vm.inBedRoomInfo = angular.copy(data.result);
          }
        });
      },
      getRoomData: function (status, stuIdList, name, userCount) {
        // 1、人脸识别在寝 2、人脸识别未归寝 3、查寝在寝 4、查寝未归 5、查寝请假
        // 6、查寝实习不归寝  7、已超过X天未归寝学生 8、已超过X天未出寝室学生
        var param = {
          stuIdList: stuIdList,
          type: 1,
          status: status,
          name: name,
          userCount: userCount,
          showName: vm.showDate.showName,
          classId: vm.classId
        };
        storageService.setItem("in_bed_guild_room", param);
        $scope.$on("in_bed_guild_room", function (event, data) {
          if (data) {
            vm.getDataInfo();
          } else {
            if ($scope.buildRoomModal) {
              $scope.buildRoomModal.remove();
            }
          }
        });
        $ionicModal.fromTemplateUrl('templates/zbkq/dialog/buildRoom.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function (modal) {
          $scope.buildRoomModal = modal;
          modalManager.put("in_bed_guild_room", modal);
          modal.show();
        });
      },
      // 帮助提示
      helpDialog: function () {
        $scope.$on("in_bed_show_help", function (event, data) {
          if (data) {
            vm.getDataInfo();
          }
        });
        $ionicModal.fromTemplateUrl('templates/zbkq/dialog/showHelp.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function (modal) {
          modalManager.put("in_bed_show_help", modal);
          modal.show();
        });
      }

    };

    $scope.adminClasses = null;
    $scope.currentAdminClass = null;

    function getAdminClassesByUserId() {
      return $http.get(originBaseUrl + '/third/classStatistics/queryPlatformAdminClassNoGraduteByUserId.htm')
        .success(function (data) {
          if (data.status === 0) {
            $scope.adminClasses = data.result;
            if ($scope.adminClasses.length > 0 && null == $scope.currentAdminClass) {
              $scope.currentAdminClass = $scope.adminClasses[0];
              vm.classId = $scope.currentAdminClass.id;
            }
          }
        });
    }

    getAdminClassesByUserId().success(function () {
      vm.classId = $scope.currentAdminClass.id;
      vm.getSystemDate();
    });

    $scope.selectedAdminClass = selectedAdminClass;

    function selectedAdminClass(c) {
      vm.inBedRoomInfo = null;
      $scope.currentAdminClass = c;
      vm.classId = $scope.currentAdminClass.id;
      vm.getSystemDate();
    }
  }

})();
