(function () {
  "use strict";

  angular
    .module("starter")
    .config(config)
    .controller("classPunishStudentCtrl", ctrl);

  config.$inject = ['$stateProvider'];

  function config($stateProvider) {
    $stateProvider
      //在寝情况
      .state('class_punishStudent', {
        url: '/teacher/workspace/class_punishStudent',
        templateUrl: 'templates/classSituation/class_punishStudent.html',
        controller: 'classPunishStudentCtrl',
        data: {
          prev: 'workspaceForTeacher',
          title: '学生处分情况'
        }
      });
  }

  ctrl.$inject = ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location"];

  function ctrl($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location) {
    var classId = $location.search().classId;

    $scope.classId = null;
    $scope.emptyInfo = false;
    $scope.isExistStu = true;

    $scope.getData = function (func) {
      $scope.stuList = [];
      $http.get(originBaseUrl + '/third/classStatistics/queryClassStudentPunishInfo.htm?classId=' + $scope.classId + "&time=" + (new Date()).getTime()).success(function (data) {
        if (data.status == 0) {
          $scope.stuList = data.result;
          angular.forEach($scope.stuList, function (item) {
            item.isUnfold = false;
            if (item.headUrl != "" && item.headUrl != null) {
              item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
            }
          });
          $scope.emptyInfo = false;
          if ($scope.stuList && $scope.stuList.length > 0) {
            $scope.isExistStu = true;
          } else {
            $scope.isExistStu = false;
          }
        } else {
          ynuiNotification.error({msg: data.message});
        }

        if (func) {
          func();
        }
      }).error(function () {
        if (func) {
          func();
        }
        $scope.emptyInfo = true;
        $scope.dataErrorMsg = '加载失败，请重试！';
      });

    };
    $scope.clickUnfold = function (item) {
      item.isUnfold = !item.isUnfold;
    };
    $scope.doRefresh = function () {
      $ionicLoading.show({
        template: '正在刷新...'
      });
      $scope.getData(function () {
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $ionicScrollDelegate.scrollTop();
        $ionicLoading.hide();
      });
    };
    $scope.doBack = function () {
      history.back(-1);
    };

    $scope.adminClasses = null;
    $scope.currentAdminClass = null;
    $scope.currentIndex = null;

    function getAdminClassesByUserId() {
      return $http.get(originBaseUrl + '/third/classStatistics/queryPlatformAdminClassNoGraduteByUserId.htm')
        .success(function (data) {
          if (data.status === 0) {
            $scope.adminClasses = data.result;
            if ($scope.adminClasses.length > 0 && null == $scope.currentAdminClass) {
              if (classId) {
                angular.forEach($scope.adminClasses, function (c, index) {
                  if (c.id === classId) {
                    $scope.currentAdminClass = c;
                    $scope.currentIndex = index;
                    $scope.classId = c.id;
                  }
                });
              } else {
                $scope.currentAdminClass = $scope.adminClasses[0];
                $scope.currentIndex = 0;
                $scope.classId = $scope.currentAdminClass.id;
              }
            }
          }
        });
    }

    getAdminClassesByUserId().success(function () {
      $scope.classId = $scope.currentAdminClass.id;
      $scope.doRefresh();
    });

    $scope.selectedAdminClass = selectedAdminClass;

    function selectedAdminClass(index) {
      if ($scope.adminClasses.length > 0) {
        if ($scope.currentIndex + index >= 0 && $scope.currentIndex + index <= $scope.adminClasses.length - 1) {
          $scope.currentIndex += index;
          $scope.currentAdminClass = $scope.adminClasses[$scope.currentIndex];
          $scope.classId = $scope.currentAdminClass.id;
          $scope.doRefresh();
        }
      }
    }
  }
})();
