(function () {
  "use strict";

  angular
    .module("starter")
    .config(config)
    .controller("dormitoryCtrl", ctrl);

  config.$inject = ['$stateProvider'];

  function config($stateProvider) {
    $stateProvider
      //在寝情况
      .state('dormitory_list', {
        url: '/teacher/workspace/dormitory_list',
        templateUrl: 'templates/class_dormitory_statistics/dormitory_list.html',
        controller: 'dormitoryCtrl',
        data: {
          prev: 'workspaceForTeacher',
          title: '班级寝室'
        }
      });
  }

  ctrl.$inject = ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', '$ionicSlideBoxDelegate', '$state', '$location', '$window'];

  function ctrl($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $ionicSlideBoxDelegate, $state, $location, $window) {

      var localUrl = decodeURI($window.location.href);
      var params = localUrl.split(/[?&]/);
      $scope.backClassId = null;
      angular.forEach(params, function(url){
          if(url.indexOf("backClassId=") > -1){
              $scope.backClassId = url.replace("backClassId=", "");
          }
      });

    //跳转到申请页面
    $scope.toAnother = function(type){
      if(type === 1){
        $state.go('dormitory_modify_teacher');
      }else{
        $state.go('dormitory_apply');
      }
    };



    $ionicModal.fromTemplateUrl('dormitory_member.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function (modal) {
      $scope.modal = modal;
    });
    $scope.selectDormitory = null;
    $scope.openDormitory = function (item) {
      $scope.selectDormitory = item;
      $scope.getDormitoryDetailInfo(item.dormitoryRoomId, $scope.showClassDormitoryInfo.platformSysAdminClassId);

    };
    $scope.closeDormitory = function () {
      $scope.modal.hide();
    };

    //应对2021-5-14日何娇改的班级寝室ui取消模态框
    // $ionicModal.fromTemplateUrl('dormitory_Administrator.html', {
    //   scope: $scope,
    //   animation: 'slide-in-up'
    // }).then(function (modal1) {
    //   $scope.modal1 = modal1;
    // });
    $scope.openAdministrator = function () {
      $scope.modal1.show();
    };
    $scope.closeAdministrator = function () {
      $scope.modal1.hide();
    };
    $scope.showClassDormitoryInfo = null;
    $scope.selectGender = "all";

    $scope.nextSlide = function () {
      $ionicSlideBoxDelegate.next();
    }
    $scope.previousSlide = function () {
      $ionicSlideBoxDelegate.previous();
    }

    $scope.selectGenderChange = function (gender) {
      $scope.selectGender = gender;
      setTimeout(function () {
        $scope.$apply();
      });
      $scope.$broadcast('scroll.infiniteScrollComplete');
      $ionicScrollDelegate.scrollTop();
    }
    //滑动框展示的数据集合固定3个
    $scope.slideList = [{}, {}, {}];
    //滑动框滑动之结束后调用
    $scope.slideChange = function (index) {
      var currentIndex = $ionicSlideBoxDelegate.currentIndex();
      if ($scope.classDormitoryInfoList && $scope.classDormitoryInfoList.length > 0) {
        $scope.showClassDormitoryInfo = $scope.slideList[index];
        $scope.selectGender = "all";
        setTimeout(function () {
          $scope.$apply();
        });
        $ionicScrollDelegate.scrollTop();
        $scope.setNextAndPreviousClassInfo();
      }
    }
    //设置下一个班级和上一个班级信息
    $scope.setNextAndPreviousClassInfo = function () {
      var currentIndex = $ionicSlideBoxDelegate.currentIndex();
      var currentClassIndex = $scope.slideList[currentIndex].classIndex;
      if (currentClassIndex == $scope.classDormitoryInfoList.length - 1) {
        $scope.slideList[$scope.getNextAndPreviousSlideIndex("next")] = $scope.classDormitoryInfoList[0]
      } else {
        $scope.slideList[$scope.getNextAndPreviousSlideIndex("next")] = $scope.classDormitoryInfoList[currentClassIndex + 1]
      }
      if (currentClassIndex == 0) {
        $scope.slideList[$scope.getNextAndPreviousSlideIndex("previous")] = $scope.classDormitoryInfoList[$scope.classDormitoryInfoList.length - 1];
      } else {
        $scope.slideList[$scope.getNextAndPreviousSlideIndex("previous")] = $scope.classDormitoryInfoList[currentClassIndex - 1];
      }
    }
    //获取下一个或者上一个滑动框的序号
    $scope.getNextAndPreviousSlideIndex = function (type) {
      var currentIndex = $ionicSlideBoxDelegate.currentIndex();
      if (type == "next") {
        if (currentIndex == ($scope.slideList.length - 1)) {
          return 0;
        } else {
          return parseInt(currentIndex) + 1;
        }
      } else {
        if (currentIndex == 0) {
          return $scope.slideList.length - 1;
        } else {
          return parseInt(currentIndex) - 1;
        }
      }
    }
    $scope.queryClassDormitoryInfoByTeacher = function (func) {
      $http.get(originBaseUrl + '/third/classDormStatistics/queryClassDormitoryInfoByTeacher.htm?' + "_datatime=" + new Date().getTime()).success(function (data) {
        if (data.status == 0) {
          $scope.emptyInfo = false;
          $scope.classDormitoryInfoList = data.result;
          angular.forEach($scope.classDormitoryInfoList, function (item, index) {
            item.classIndex = index;
          });
          if ($scope.classDormitoryInfoList && $scope.classDormitoryInfoList.length > 0) {
            var currentIndex = $ionicSlideBoxDelegate.currentIndex();
            if(!$scope.backClassId){
                $scope.slideList[currentIndex] = $scope.classDormitoryInfoList[0];
                $scope.setNextAndPreviousClassInfo();
                $scope.showClassDormitoryInfo = $scope.classDormitoryInfoList[0];
            }else{
                angular.forEach($scope.classDormitoryInfoList, function(item){
                    if(item.platformSysAdminClassId === $scope.backClassId){
                        $scope.slideList[currentIndex] = item;
                        $scope.setNextAndPreviousClassInfo();
                        $scope.showClassDormitoryInfo = item;
                    }
                })
            }
            if ($scope.classDormitoryInfoList.length == 1) {
              //使滑动框不能滑动
              $ionicSlideBoxDelegate.enableSlide(false);
            } else {
              $ionicSlideBoxDelegate.enableSlide(true);
            }
          } else {
            //清空滑动框数据
            $scope.slideList = [{}, {}, {}];
            $ionicSlideBoxDelegate.enableSlide(false);
          }
        } else {
          ynuiNotification.error({msg: data.message});
        }
        if (func) {
          func();
        }
        $ionicSlideBoxDelegate.update()
      }).error(function () {
        if (func) {
          func();
        }
        $scope.emptyInfo = true;
        $scope.dataErrorMsg = '加载失败，请重试！';
      });
    }
    //刷新
    $scope.doRefresh = function (temp) {
      var template = '正在刷新...';
      if (temp) {
        template = temp;
      }
      $ionicLoading.show({
        template: template
      });
      $scope.classDormitoryInfoList = [];
      ;
      $scope.queryClassDormitoryInfoByTeacher(function () {
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $ionicScrollDelegate.scrollTop();
        $ionicLoading.hide();
      });
    };
    $scope.setectBedInfo = null;
    $scope.clickBedInfo = function (item) {
      if (!item.isFreeBed) {
        $scope.setectBedInfo = item;
      }
    }
    $scope.doRefresh("正在加载...");
    $scope.getDormitoryDetailInfo = function (dormitoryRoomId, platformSysAdminClassId) {
      $ionicLoading.show({
        template: "正在加载..."
      });
      $http.post(originBaseUrl + '/third/classDormStatistics/queryDormitoryDetailInfoById.htm?', {
        dormitoryRoomId: dormitoryRoomId,
        platformSysAdminClassId: platformSysAdminClassId
      }).success(function (data) {
        if (data.status == 0) {
          $scope.bedDetailInfoList = data.result;
          if ($scope.bedDetailInfoList.ssMobileBedDetailInfoVOList) {
            for (var i = 0; i < $scope.bedDetailInfoList.ssMobileBedDetailInfoVOList.length; i++) {
              if (!$scope.bedDetailInfoList.ssMobileBedDetailInfoVOList[i].isFreeBed) {
                $scope.clickBedInfo($scope.bedDetailInfoList.ssMobileBedDetailInfoVOList[i]);
                break;
              }
            }
          }

          $scope.modal.show();
        } else {
          ynuiNotification.error({msg: data.message});
        }
        $ionicLoading.hide();
      }).error(function () {
        $ionicLoading.hide();
        ynuiNotification.error({msg: '加载失败！'});
      });
    }

    //发起调寝申请
    $scope.goAddApply = function(stu){
        $scope.modal.hide();
      $location.path("/dormitory_apply_add").search({stuId : stu.platformSysUserId, classId : $scope.showClassDormitoryInfo.platformSysAdminClassId});
    }
  }
})();
