(function () {
  'use strict';

  angular
    .module('starter')
    .config(config)
    .controller('ktkqTatisticsController', ktkqTatisticsController)
    .controller('ktkqStudentCtrl', ktkqStudentCtrl);

  config.$inject = ['$stateProvider'];

  function config($stateProvider) {
    $stateProvider
      //课堂考勤统计
      .state('ktkq_atistics', {
        url: '/teacher/workspace/ktkq_atistics',
        templateUrl: 'templates/classSituation/ktkq_tatistics.html',
        data: {
          prev: 'workspaceForTeacher',
          title: '课堂考勤'
        }
      })
      .state('ktkq_student', {
        url: '/ktkq_student',
        templateUrl: 'templates/classSituation/ktkq_student.html',
        data: {
          prev: 'ktkq_atistics',
          title: '课堂考勤'
        }
      });
  }

  ktkqTatisticsController.$inject = ['$rootScope', '$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location", '$state'];

  function ktkqTatisticsController($rootScope, $scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location, $state) {
    // 从教职工首页跳进去的要带班级id
    var classId = $location.search().classId;
    $scope.emptyInfo = false;  //数据加载失败
    //获取当前时间
    $scope.getCurrentTime = function () {
      var addDay = new Date();
      var month2 = (addDay.getMonth() + 1) > 9 ? (addDay.getMonth() + 1) : '0' + (addDay.getMonth() + 1);
      var day2 = addDay.getDate() > 9 ? addDay.getDate() : '0' + addDay.getDate();
      addDay = addDay.getFullYear() + "-" + month2 + "-" + day2;
      return addDay;
    };

    $scope.conditions = {
      queryDate: $scope.getCurrentTime()
    };
    $scope.classInfo = {};
    $scope.classList = [];

    $scope.selectedClass = function (item) {
      $scope.classInfo = item;
      $scope.doRefresh();
    };
    $scope.classCountList = [];
    //课堂考勤统计
    $scope.queryKqktClassCountInfo = function (func) {
      if (!$scope.classInfo.id || !$scope.conditions.queryDate) {
        return false;
      }
      $http.get(originBaseUrl + '/third/attendance/queryKqktClassCountInfo.htm', {
        params: {
          classId: $scope.classInfo.id,
          queryDate: $scope.conditions.queryDate,
          time: (new Date()).getTime(),
          userType: $state.$current.name === 'ktkq_atistics' ? 1 : 2
        }
      }).success(function (data) {
        if (data.status == 0) {
          $scope.kqKTCount = data.result;
          $scope.emptyInfo = false;
        } else {
          ynuiNotification.error({msg: data.message});
        }
        if (func) {
          func();
        }
      }).error(function () {
        if (func) {
          func();
        }
        $scope.emptyInfo = true;
        $scope.dataErrorMsg = '加载失败，请重试！';
      });
    };
    //查询 （type）1：应到 2：请假 3：处分 4:课堂考勤学生 详情
    $scope.viewDetails = function (kqkt, ktStatus, timeType) {
      window.localStorage.setItem("classId", JSON.stringify($scope.classInfo.id));
      window.localStorage.setItem("queryDate", JSON.stringify($scope.conditions.queryDate));
      window.localStorage.setItem("ktkq_atistics_item", JSON.stringify(kqkt));
      $location.path("/ktkq_student").search("item", JSON.stringify({
        classId: $scope.classInfo.id,
        kqktId: kqkt.id,
        ktStatus: ktStatus,
        timeType: timeType
      }));
    };
    $scope.getData = function (func) {
      $scope.queryKqktClassCountInfo(func);
    };
    $scope.doRefresh = function () {
      $ionicLoading.show({
        template: '正在刷新...'
      });
      $scope.getData(function () {
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $ionicScrollDelegate.scrollTop();
        $ionicLoading.hide();
      });
    };
    //查询班级下拉列表
    $.ajax({
      url: originBaseUrl + '/third/classStatistics/queryPlatformAdminClassNoGraduteByUserId.htm?' +
        'access_token=' + $rootScope.authorizationStr.access_token +
        '&userId=' + $rootScope.authorizationStr.userId +
        '&userType=' + $rootScope.authorizationStr.userType,
      cache: false,
      async: false,
      type: "POST",
      dataType: 'json',
      success: function (data) {
        if (data.status == 0) {
          $scope.classList = data.result;
          if ($scope.classList && $scope.classList.length > 0) {
            var historyClassId = JSON.parse(window.localStorage.getItem("classId"));
            if (historyClassId) {
              angular.forEach($scope.classList, function (item) {
                if (item.id == historyClassId) {
                  $scope.classInfo = item;
                }
              });
              $scope.conditions.queryDate = JSON.parse(window.localStorage.getItem("queryDate"));
            } else if (classId) {
              angular.forEach($scope.classList, function (item) {
                if (item.id === classId) {
                  $scope.classInfo = item;
                }
              });
            } else {
              $scope.classInfo = $scope.classList[0];
            }
            $scope.doRefresh();
          }
        } else {
          ynuiNotification.error({msg: data.message});
        }
      }
    });
  }

  ktkqStudentCtrl.$inject = ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location"];

  function ktkqStudentCtrl($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location) {
    //考勤状态 all:应到 act:实到 1：请假 2：缺席 3：迟到 4：早退 5：按时到
    $scope.ktStatus = JSON.parse($location.search().item).ktStatus;
    $scope.timeType = JSON.parse($location.search().item).timeType;
    $scope.kqktItem = angular.fromJson(window.localStorage.getItem("ktkq_atistics_item"));

    $scope.statusList = []

    $scope.ktStatusList = [
      {ktStatus: "all", ktStatusName: "应到", show: true},
      {ktStatus: "act", ktStatusName: "实到", show: true},
      {ktStatus: "1", ktStatusName: "请假", show: true},
      {ktStatus: "2", ktStatusName: "缺席", show: true},
      {ktStatus: "3", ktStatusName: "迟到", show: true},
      {ktStatus: "4", ktStatusName: "早退", show: true},
      {ktStatus: "5", ktStatusName: "按时到", show: true}
    ];
    $scope.getStatusName = function (ktStatus) {
      var ktStatusName = "";
      if (ktStatus == "all") {
        ktStatusName = '应到';
      }
      if (ktStatus == "act") {
        ktStatusName = '实到';
      }
      if (ktStatus == "1") {
        ktStatusName = '请假';
      }
      if (ktStatus == "2") {
        ktStatusName = '缺席';
      }
      if (ktStatus == "3") {
        ktStatusName = '迟到';
      }
      if (ktStatus == "4") {
        ktStatusName = '早退';
      }
      if (ktStatus == "5") {
        ktStatusName = '按时到';
      }
      return ktStatusName;
    };
    $scope.ktStatusName = $scope.getStatusName($scope.ktStatus);
    $scope.classId = JSON.parse($location.search().item).classId;
    $scope.kqktId = JSON.parse($location.search().item).kqktId;
    $scope.emptyInfo = false;
    $scope.times = 0;
    $scope.getData = function (func) {
      $scope.stuList = [];
      $http.get(originBaseUrl + '/third/attendance/queryKqktClassStudentCountInfo.htm', {
        params: {
          classId: $scope.classId,
          kqktId: $scope.kqktId,
          ktStatus: $scope.ktStatus,
          time: (new Date()).getTime()
        }
      }).success(function (data) {
        if (data.status == 0) {
          $scope.stuList = data.result;
          var dictCodes = ['all', 'act'];
          angular.forEach($scope.stuList, function (item) {
            item.isUnfold = false;
            if (item.headUrl != "" && item.headUrl != null) {
              item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
            }
            if (item.dictCode && dictCodes.indexOf(item.dictCode) === -1) {
              dictCodes.push(item.dictCode);
            }
          });
          if ($scope.times === 0) {
            $scope.times = 1;
            angular.forEach($scope.ktStatusList, function (s) {
              if (dictCodes.indexOf(s.ktStatus) === -1) {
                s.show = false;
              }
            });
          }
          $scope.emptyInfo = false;
          if ($scope.stuList && $scope.stuList.length > 0) {
            $scope.isExistStu = true;
          } else {
            $scope.isExistStu = false;
          }
        } else {
          ynuiNotification.error({msg: data.message});
        }
        if (func) {
          func();
        }
      }).error(function () {
        if (func) {
          func();
        }
        $scope.emptyInfo = true;
        $scope.dataErrorMsg = '加载失败，请重试！';
      });

    };
    $scope.clickUnfold = function (item) {
      if (!item.leave) {
        return false;
      }
      item.isUnfold = !item.isUnfold;
    }
    $scope.doRefresh = function (ktStatus) {
      if (ktStatus) {
        $scope.ktStatus = ktStatus;
      }
      $ionicLoading.show({
        template: '正在刷新...'
      });
      $scope.getData(function () {
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $ionicScrollDelegate.scrollTop();
        $ionicLoading.hide();
      });
    };
    $scope.doRefresh();
    $scope.doBack = function () {
      history.back(-1);
    };
  }
})();
