(function () {
  'use strict';

  angular
    .module('starter')
    .config(config)
    .controller('classLeaveStudentCtrl', classLeaveStudentCtrl)
    .controller('createRecordByTeacherCtrl', createRecordByTeacherCtrl)
    .controller('teachCheckStuLeaveRecordViewCtrl', teachCheckStuLeaveRecordViewCtrl)
    .controller('leaveRecordByTeacherCtrl', leaveRecordByTeacherCtrl);

  config.$inject = ['$stateProvider'];

  function config($stateProvider) {
    $stateProvider
      //学生请假
      .state('class_leaveStudent', {
        url: '/teacher/workspace/class_leaveStudent',
        templateUrl: 'templates/classSituation/class_leaveStudent.html',
        data: {
          prev: 'workspaceForTeacher',
          title: '学生请假'
        }
      })
      .state('leave_delete_by_teacher', {
        url: '/teacher/workspace/leave_delete',
        templateUrl: 'templates/leave/leave_delete.html',
        data: {
          prev: 'workspaceForTeacher',
          title: '学生请假'
        },
        controller: 'leaveDeleteCtrl',
      })
        // 班级学生请假记录
        .state('leave_record_to_teacher', {
        url: '/leave_record_to_teacher',
        templateUrl: 'templates/workspaceforteacher/stu_leave/leave_record_by_teacher.html',
        data: {
          prev: 'workspaceForTeacher',
          title: '学生请假'
        },
        controller: 'leaveRecordByTeacherCtrl',
      })
        // 创建请假条
        .state('create_record_to_teacher', {
        url: '/create_record_to_teacher',
        templateUrl: 'templates/workspaceforteacher/stu_leave/create_record.html',
        data: {
          prev: 'workspaceForTeacher',
          title: '学生请假'
        },
        controller: 'createRecordByTeacherCtrl',
      })
        //班主任查看学生请假记录
        .state('teacher_check_stu_leave_record_view', {
          url: '/teacher_check_stu_leave_record_view',
          templateUrl: 'templates/workspaceforteacher/stu_leave/teacher_check_stu_leave_record_view.html',
          data: {
            title: '请假记录',
            prev: 'teacher/workspace/class_leaveStudent'
          },
          controller: 'teachCheckStuLeaveRecordViewCtrl'
        })
  }

  /******查看请假条start**********/
  teachCheckStuLeaveRecordViewCtrl.$inject = ['$rootScope', "$scope", "$http", "$ionicPopup", "$ionicModal", "$location","ynNavigator", "$sce"];


  function teachCheckStuLeaveRecordViewCtrl($rootScope, $scope, $http, $ionicPopup, $ionicModal, $location,ynNavigator, $sce) {

    var detailParam = angular.fromJson($location.search().detailParam);

    $scope.id = detailParam.id;
    $scope.activeStatus = detailParam.activeStatus+"";
    $scope.statusName = "";
    switch ($scope.activeStatus) {
      case "0":
        $scope.statusName = "未提交";
        break;
      case "1":
        $scope.statusName = "通过";
        break;
      case "2":
        $scope.statusName = "不通过";
        break;
      case "3":
        $scope.statusName = "审核中";
        break;
      case "4":
        $scope.statusName = "返回修改";
        break;
    }
    $scope.loadingError = false;
    $scope.loadingErrorInfo = "";
    //学生
    $scope.queryUserInfo = function (userId) {
      $http.get(originBaseUrl + "/third/leaveAndRelease/queryUserInfo.htm?userId=" + userId + "&needClass=true&time=" + (new Date()).getTime()).success(function (data) {
        if (data.status === 0) {
          $scope.userInfo = data.result;
          if ($scope.userInfo && $scope.userInfo.fsId) {
            $scope.userInfo.fsId = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.userInfo.fsId;
            $scope.userInfo.smallFsId = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.userInfo.smallFsId;
          } else if ($scope.userInfo) {
            if ($scope.userInfo.gender === '女') {
              $scope.userInfo.fsId = originBaseUrl + "/mobile/img/userface_2.png";
              $scope.userInfo.smallFsId = originBaseUrl + "/mobile/img/userface_2.png";
            } else {
              $scope.userInfo.fsId = originBaseUrl + "/mobile/img/userface_1.png";
              $scope.userInfo.smallFsId = originBaseUrl + "/mobile/img/userface_1.png";
            }
          }
        }
      }).error(function () {
        $scope.loadingError = true;
        $scope.loadingErrorInfo = '加载失败，请重试！';
      });
    };

    //请假信息查询
    $scope.queryLeaveInfo = function () {
      $http.get(originBaseUrl + "/third/leaveAndRelease/queryStuLeaveNote.htm?time=" + (new Date()).getTime()+"&leavePassId="+$scope.id).success(function (data) {
        if (data.status === 0) {
          $scope.leaveInfo =  data.result;
          $scope.queryUserInfo($scope.leaveInfo.stuPlatformSysUserId);
        }
      }).error(function () {

      });
    };


    $scope.queryLeaveInfo();

    $scope.goBack = goBack;

    function goBack(){
      $location.path("/leave_record_to_teacher").search({backFlag:true,backConditions:$location.search().detailParam});
      setTimeout(function () {
        $scope.$apply();
      });
    }

    // 返回处理
    ynNavigator.registerBackAction(function () {
      goBack();
    },101);

    //材料证明
    var MaterialsProve;
    $ionicModal.fromTemplateUrl('materials_prove.html', {
      scope: $scope,
      animation: 'slide-in-right'
    }).then(function (modal) {
      MaterialsProve = modal;
    });

    //判断文件是否支持预览
    $scope.previewFileOrDownload = function (fastId) {
      var isSupported = false;
      var type = fastId.substring(fastId.lastIndexOf(".") + 1).toLowerCase();
      type = type.toLowerCase();
      if (type == 'doc' || type == 'docx' || type == 'xls' || type == 'xlsx' || type == 'ppt' || type == 'pptx' || type == 'txt' || type == 'pdf') {
        //符合条件的文件格式，跳转到预览
        isSupported = true;
      }
      return isSupported;
    }
    $scope.previewFileOrDownloadImg = function (fastId) {
      var isSupported = false;
      var type = fastId.substring(fastId.lastIndexOf(".") + 1).toLowerCase();
      type = type.toLowerCase();
      if (type == 'gif' || type == 'jpg' || type == 'jpeg' || type == 'png' || type == 'bmp') {
        //符合条件的文件格式，跳转到预览
        isSupported = true;
      }
      return isSupported;
    }
    $scope.previewPhoto = function (photo) {
      var cordovaFileOpen = cordova.plugins.disusered.open;
      $scope.attachmentUrl = cordovaFileOpen(originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + photo, cordovaFileOpenSuccess, cordovaFileOpenError);

      function cordovaFileOpenSuccess() {
        // 从已安装程序中打开文件完成
      }

      function cordovaFileOpenError(code) {
        if (code === 1) {
          $ionicPopup.alert({
            title: '文件预览提示',
            template: '未能在手机已安装APP中找到可预览此文件的程序'
          });
        } else {
          $ionicPopup.alert({
            title: '文件预览提示',
            template: '预览时发生了未知错误 #' + code
          });
        }
      }
    };
    //下载
    $scope.downLoadAndpreView = function (item) {
      if ($scope.previewFileOrDownload(item.attachmentId)) {
        $scope.attachmentUrl = $sce.trustAsResourceUrl(originBaseUrl + "/static/yineng/components/22-ynuiPdfViewer/web/viewer.html?fastDFSId=" + item.attachmentId)
        MaterialsProve.show();
      } else if ($scope.previewFileOrDownloadImg(item.attachmentId)) {
        $scope.previewPhoto(item.attachmentId);
      } else {
        $ionicPopup.alert({title: '提示', template: '该文件格式不支持预览!'});
      }
    };

  }
  /********查看请假条end*************/

  classLeaveStudentCtrl.$inject = ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location", "$state","$ionicPopup"];

  function classLeaveStudentCtrl($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location, $state,$ionicPopup) {
    // 班主任工作跳转带的班级id
    var classId = $location.search().classId;

    $scope.queryType = 1;//0:出校学生  1:请假人数 2:逾期未销假人数
    $scope.classId = '';
    $scope.emptyInfo = false;
    $scope.isExistStu = true;
    $scope.showData = {
      all: 0,
      outed: 0,
      notBack: 0,
      stuList: null
    };
    var days = ['一', '二', '三', '四', '五', '六', '日'];
    $scope.nowDate = moment().format('M[月]DD[日]') + ' 星期' + days[parseInt(moment().format('E')) - 1];

    $scope.changeClass = changeClass;
    $scope.changeType = changeType;
    $scope.toAnother = toAnother;
    $scope.showLeaveWarning = showLeaveWarning;

    $scope.getData = function (type, func) {
      $scope.stuList = [];
      return $http.get(originBaseUrl + '/third/classStatistics/queryClassStudentCountInfo.htm', {
        params: {
          classId: $scope.currentAdminClass.id,
          queryType: type,
          time: new Date().getTime()
        }
      }).success(function (data) {
        if (data.status == 0) {
          if (type === $scope.queryType) {
            $scope.showData.stuList = data.result;
          }
          angular.forEach($scope.showData.stuList, function (item) {
            item.isUnfold = false;
            if (item.headUrl != "" && item.headUrl != null && item.headUrl.indexOf(originBaseUrl) === -1) {
              item.headUrl = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + item.headUrl;
            }
          });
          $scope.emptyInfo = false;
          if ($scope.showData.stuList && $scope.showData.stuList.length > 0) {
            $scope.isExistStu = true;
          } else {
            $scope.isExistStu = false;
          }
        } else {
          ynuiNotification.error({msg: data.message});
        }
        if (func) {
          func();
        }
        return data;
      }).error(function () {
        if (func) {
          func();
        }
        $scope.emptyInfo = true;
        $scope.dataErrorMsg = '加载失败，请重试！';
      });
    };

    $scope.clickUnfold = function (item) {
      item.isUnfold = !item.isUnfold;
    };

    $scope.doRefresh = function (type) {
      if (null == $scope.currentAdminClass) {
        return;
      }
      $ionicLoading.show({
        template: '正在刷新...'
      });
      $scope.getData(type, function () {
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $ionicScrollDelegate.scrollTop();
        $ionicLoading.hide();
      }).success(function (data) {
        if (data.status === 0) {
          if (type === 1) {
            $scope.showData.all = data.result.length;
          } else if (type === 0) {
            $scope.showData.outed = data.result.length;
          } else if (type === 2) {
            $scope.showData.notBack = data.result.length;
          }
        }
      });
    };

    $scope.adminClasses = [];
    $scope.currentAdminClass = null;
    $scope.currentIndex = null;

    queryPlatformAdminClass().success(function (data) {
      $scope.doRefresh(1);
      $scope.doRefresh(0);
      $scope.doRefresh(2);
    });


    $scope.doBack = function () {
      history.back(-1);
    };

    function queryPlatformAdminClass() {
      return $http.get(
        originBaseUrl + '/third/classStatistics/queryPlatformAdminClassNoGraduteByUserId.htm'
      ).success(function (data) {
        if (data.status === 0) {
          $scope.adminClasses = data.result;
          if (classId) {
            angular.forEach($scope.adminClasses, function (c, index) {
              if (c.id === classId) {
                $scope.currentAdminClass = c;
                $scope.currentIndex = index;
              }
            });
          } else {
            $scope.currentAdminClass = $scope.adminClasses.length > 0 ? $scope.adminClasses[0] : null;
            $scope.currentIndex = $scope.adminClasses.length > 0 ? 0 : null;
          }
        }
      });
    }

    function changeClass(step) {
      if ($scope.adminClasses.length > 0) {
        if ($scope.currentIndex + step < 0 || $scope.currentIndex + step > $scope.adminClasses.length - 1) {
          return;
        }
        $scope.currentIndex += step;
        $scope.currentAdminClass = $scope.adminClasses[$scope.currentIndex];
        // 刷新
        $scope.doRefresh(1);
        $scope.doRefresh(0);
        $scope.doRefresh(2);
      }
    }

    function changeType(type) {
      $scope.queryType = type;
      $scope.doRefresh(1);
      $scope.doRefresh(0);
      $scope.doRefresh(2);
    }

    function toAnother(type) {
      if (type === 1){
        $location.path("/leave_record_to_teacher");
      }else {
        $state.go('leave_delete_by_teacher');
      }
    }

    function showLeaveWarning() {
        var alertPopup = $ionicPopup.alert({
          title: '',
          cssClass:'popup-head-none',
          okText:'关闭',
          template: "<div class='text-left font-12'>" +
              "<p>1.请假学生：班级请假学生人数，计算规则为：1）请假手续已办理完成；2）请假时间已开始且还未结束。</p>" +
              "<p>2.已出校：班级中已请假已出校的学生数，计算规则为：1）请假手续已办理完成；2）请假时间已开始且还未结束；3）学生已出校还没有返校</p>" +
              "<p>3.逾期未返校：班级中请假已结束但还未返校的学生数，计算规则为：1）请假手续已办理完成；2）请假时间已结束；3）学生已出校还没有返校</p>" +
              "</div>"
        });
    }
  }


  leaveRecordByTeacherCtrl.$inject = ['$scope', '$http', '$timeout', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification', "$location","$ionicPopup","$state","$ionicModal"];

  function leaveRecordByTeacherCtrl($scope, $http, $timeout, $ionicLoading, $ionicScrollDelegate, ynuiNotification, $location,$ionicPopup,$state,$ionicModal) {
    // 返回信息
    var backConditions = $location.search().backConditions, backFlag = $location.search().backFlag;
    if (backFlag){
      backConditions = angular.fromJson(backConditions);
    }
    var basePath = originBaseUrl + '/third/leaveAndRelease';

    $scope.toAnother = toAnother;
    $scope.getStatusName = getStatusName;
    $scope.searchStu = searchStu;
    $scope.searchStuName = searchStuName;
    $scope.searchRecord = searchRecord;
    $scope.moreRecord = moreRecord;
    $scope.createLeave = createLeave;
    $scope.showOperate = showOperate;
    $scope.goOperate = goOperate;
    $scope.clickClassInfo = clickClassInfo;

    var vm = $scope.vm = {
      classList:[],
      statusList:[],
      recordList:[],
      selectItem:null,
      activeStatus:backFlag ? backConditions.activeStatus : null,
      pageNumber:backFlag ? backConditions.pageNumber : 0,
      pageSize:20,
      showLeaveRecord:null,
      lastPage:false,
      searchInfo:{
        name:backFlag ? backConditions.searchInfo.name :"",
        activeClass:backFlag ? backConditions.searchInfo.activeClass :{}
      }
    };

    function clickClassInfo(item) {
      vm.searchInfo.activeClass = item;
      vm.pageNumber = 0;
      vm.pageSize = 20;
      getClassStuLeave();
    }

    function searchStuName() {
      vm.pageNumber = 0;
      vm.pageSize = 20;
      getClassLeaveRecordStatus(vm.activeStatus,true);
    }

    function showOperate(type) {
      var flag = false;
      if (vm.selectItem){
        switch (type) {
            // 补传证明
          case 6:flag = vm.selectItem.status == '1' ||  vm.selectItem.status == '3';break;
            // 查看
          case 1:flag = vm.selectItem.status == '1' || vm.selectItem.status == '2' || vm.selectItem.status == '3';break;
            // 修改
          case 2:flag = vm.selectItem.status == '0' || vm.selectItem.status == '4';break;
            // 删除
          case 3:flag = vm.selectItem.status != '3' && !vm.selectItem.passStatus;break;
            // 续假
          case 5:flag = vm.selectItem.status == '1';break;
            // 审批情况
          case 7:flag = vm.selectItem.status == '1' || vm.selectItem.status == '2' || vm.selectItem.status == '3' || vm.selectItem.status == '4';break;
          default:break;
        }
      }
      return flag;
    }

    function goOperate(type) {
      switch (type) {
          // 查看
        case 1:goDetail();break;
          // 修改
        case 2:goModify();break;
          // 删除
        case 3:deleteLeavePassinfoByIdForTeacher();break;
          // 续假
        case 5:break;
          // 补传证明
        case 6:
          $scope.closeModal();
          uploadEvidence();
          break;
          // 审批情况
        case 7:goProcess();break;
        default:break;
      }
    }

    function deleteLeavePassinfoByIdForTeacher() {
      $scope.closeModal();
      $ionicPopup.confirm({
        title: '提示',
        template: '确认要删除当前请假条吗?',
        cancelText: '取消',
        okText: '确定'
      }).then(function (res) {
        if (res) {
          del();
        }
      });

    }

    function del() {
      $http.post(basePath + '/deleteLeavePassinfoByIdForTeacher.htm',{leavePassId:vm.selectItem.id}).success(function (data) {
        if (data.status === 0) {
          if (data.result && data.result.length > 0){
            ynuiNotification.error({msg:data.result[0].failedReason});
          }else {
            ynuiNotification.success({msg:"操作成功"});
            getClassLeaveRecordStatus(vm.activeStatus,true);
          }
        }else {
          ynuiNotification.error({msg:"操作失败"});
        }
      });
    }

    //审批情况
    function goProcess(){
      var param = {
        "fromType": 0,
        "procInstId": vm.selectItem.procInstId,
        "fromBusiness": 1,
        state:"leave_record_to_teacher",
        backUrl:"/leave_record_to_teacher",
        searchInfo:getParam()
      }
      $location.path("/askforleave").search(param);
      $scope.closeModal();
    }
/*********************************************补传证明start********************************************************/
    /**
     * 补传证明弹框
     */
    function uploadEvidence() {
      //为学生补传证明材料组件配置
      $scope.evidenceConfig = {
        initFiles: vm.selectItem.fsIdList,//附件数组
        cameraOption:{
          waterMark: moment().format("YYYY-MM-DD HH:mm:ss")//时间水印
        }
      };
      //上传材料
      var uploadEvidenceConfig = {
        templateUrl: 'templates/workspaceforteacher/stu_leave/leave_record_evidence.html',
        title: "补传证明材料",
        cssClass:'leave-evidence',
        scope: $scope,
        buttons: [
          {text: '取消'},
          {
            text: '<b>确认</b>',
            type: 'button-positive',
            onTap: function (e) {

              if ($scope.evidenceConfig.initFiles && $scope.evidenceConfig.initFiles.length > 0){
                var params = {
                  leaveNoteId: vm.selectItem.id,
                  fsIdList: $scope.evidenceConfig.initFiles
                }
                $http.post(basePath+'/uploadLeaveEvidence.htm',params).success(function (data){
                  if (data.status == 0){
                    ynuiNotification.success({msg: "上传成功！"});
                    searchStu(true);
                  }else {
                    ynuiNotification.error({msg: "上传失败！"});
                    e.preventDefault();
                  }
                })
              }else {
                ynuiNotification.error({msg: "请上传图片！"});
                e.preventDefault();
              }
            }
          }
        ]
      };
      $ionicPopup.show(uploadEvidenceConfig);
    }
/**************************************补传证明end**************************************************************/

    function scroll(id){
      var location = $location.hash(id);
      $ionicScrollDelegate.$getByHandle('leaveRecordForTeacherScroll').anchorScroll('#'+location);
    }

    function scrollToTop() {
      $ionicScrollDelegate.$getByHandle('leaveRecordForTeacherScroll').scrollTop();
    }

    function getParam(isCreate) {
      if (isCreate) {
        // 去掉学生搜索条件
        vm.searchInfo.name = null;
        var params = {
          id: null,
          activeStatus:null,
          pageNumber:0,
          pageSize:20,
          searchInfo:vm.searchInfo
        };
        return angular.toJson(params);
      }else {
        var params = {
          id: vm.selectItem.id,
          activeStatus:vm.activeStatus,
          pageNumber:vm.pageNumber,
          pageSize:vm.pageSize,
          searchInfo:vm.searchInfo
        };
        return angular.toJson(params);
      }

    }

    //查看明细
    function goDetail() {
      $location.path("/teacher_check_stu_leave_record_view").search({detailParam:getParam()});
      $scope.closeModal();
    }

    function getClassLeaveRecordStatus(activeStatus,flag,init) {
      $http.post(basePath + '/getClassLeaveRecordStatus.htm',{classId:vm.searchInfo.activeClass.id,name:vm.searchInfo.name}).success(function (data) {
        if (data.status === 0) {
          var total = 0;
          vm.statusList = angular.copy(data.result);
          if (flag){
            if (angular.isDefined(activeStatus) && activeStatus != null){
              vm.activeStatus = activeStatus;
              angular.forEach(vm.statusList,function (item) {
                total += Number(item.name);
              });
            }else {
              // 默认通过
              angular.forEach(vm.statusList,function (item) {
                total += Number(item.name);
                if (item.id === "1"){
                  vm.activeStatus = item.id;
                }
              });
            }
          }else if (backFlag){
            angular.forEach(vm.statusList,function (item) {
              total += Number(item.name);
              if (item.id == $location.search().activeStatus || item.id == activeStatus){
                vm.activeStatus = item.id;
              }
            });
          }else {
            // 默认通过
            angular.forEach(vm.statusList,function (item) {
              total += Number(item.name);
              if (item.id === "1"){
                vm.activeStatus = item.id;
              }
            });
          }
          vm.statusList = [{id:"",name:total+""}].concat(vm.statusList);
          if (vm.statusList && vm.statusList.length > 0){
            // 判断是否存在选中的状态
            var have = true;
            angular.forEach(vm.statusList,function (item) {
              if (item.id === vm.activeStatus){
                have = false;
              }
            });
            // 默认全部
            if (have){
              vm.activeStatus = "";
            }
            searchStu(true,init);
          }
        }
      });
    }

    function getClassStuLeave() {
      $http.post(basePath + '/getClassStuLeaveRecord.htm',{classId:vm.searchInfo.activeClass.id}).success(function (data) {
        if (data.status === 0) {
          vm.showLeaveRecord = data.result;
          if (vm.showLeaveRecord){
            getClassLeaveRecordStatus(vm.activeStatus,true,true);
          }else {
            vm.statusList = [];
          }
        }
      });
    }

    function searchRecord(status) {
      vm.activeStatus = status;
      vm.pageNumber = 0;
      vm.pageSize = 20;
      searchStu(true);
    }

    function moreRecord() {
      vm.pageNumber += 1;
      searchStu(false);
    }

    function searchStu(flag,init) {
      var param = {
        adminClassId:vm.searchInfo.activeClass.id,
        queryType:4,
        queryValue:vm.searchInfo.name,
        status:vm.activeStatus,
        pageNumber:vm.pageNumber,
        pageSize:vm.pageSize,
      };
      // 还原分页条数
      vm. pageSize = 20;
      $http.post(basePath + '/queryMyClassLeavePassPage.htm',param).success(function (data) {
        if (data.status === 0) {
          vm.lastPage = data.result.lastPage;
          if (flag === false){
            vm.recordList = vm.recordList.concat(data.result.content);
          }else {
            vm.recordList = data.result.content;
          }


          $timeout(function () {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicLoading.hide();
          }, 200);
          // 定位
          if (backFlag){
            // 获取返回对象
            var haveItem = vm.recordList.some(function (t) {return t.id === backConditions.id;});
            if (haveItem && init){
              scroll(backConditions.id);
            }else {
              // 置顶
              scrollToTop();
            }
          }else if (flag){
            // 置顶
            scrollToTop();
          }
        }
      });
    }


    function getStatusName(status) {
      var name = "";
      switch (status) {
        case '0':name="未提交";break;
        case '1':name="已通过";break;
        case '2':name="不通过";break;
        case '3':name="审核中";break;
        case '4':name="返回修改";break;
        default:name="全部";break;
      }

      return name;
    }

    function getClassList() {
      $http.get(
          originBaseUrl + '/third/classStatistics/queryPlatformAdminClassNoGraduteByUserId.htm'
      ).success(function (data) {
        if (data.status === 0) {
          vm.classList = data.result;
          // 默认第一个班级
          if (vm.classList && vm.classList.length > 0){
            // 判断是否有选中班级
            if (backConditions && backConditions.searchInfo && backConditions.searchInfo.activeClass){
              if (!vm.classList.some(function (t) {return t.id === backConditions.searchInfo.activeClass.id;})){
                vm.searchInfo.activeClass = {};
              }
            }
            if (!(vm.searchInfo.activeClass && vm.searchInfo.activeClass.id)){
              vm.searchInfo.activeClass = vm.classList[0];
            }
            getClassStuLeave();
          }
        }
      });
    }

    function goModify() {
      var modifySearch = {
        activeSearchInfo:getParam(),
        isModify:true,
        leavePassId:vm.selectItem.id,
        isShow:vm.selectItem.status!="4"
      };
      $location.path("/create_record_to_teacher").search(modifySearch);
      $scope.closeModal();
    }

    function createLeave() {
      if (vm.searchInfo.activeClass && vm.searchInfo.activeClass.id){
        var modifySearch = {
          activeSearchInfo:getParam(true),
          isShow:true
        };
        $location.path("/create_record_to_teacher").search(modifySearch);
      }else {
        ynuiNotification.error({msg:"请选择班级"});
      }
    }
    
    function init() {
      // 处理分页
      if (backFlag){
        vm.pageSize = (vm.pageNumber+1) * vm.pageSize;
        vm.pageNumber = 0;
      }
      getClassList();
    }

    init();

    function toAnother(type) {
        if (type === 1){
          $state.go('class_leaveStudent');
        }else {
          $state.go('leave_delete_by_teacher');
        }
    }

    $ionicModal.fromTemplateUrl('operateButton.html',{
      scope:$scope,
      animation:'slide-in-left'
    }).then(function(modal){
      $scope.operateModal = modal;
    });
    $scope.bottomModalClick = function(item) {
      vm.selectItem = item;
      $scope.operateModal.show();
    };
    $scope.closeModal = function() {
      $scope.operateModal.hide();
    };

  }

  createRecordByTeacherCtrl.$inject = ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', 'ynuiNotification',
    "$location","$ionicPopup","$timeout","ynNavigator"];

  function createRecordByTeacherCtrl($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, ynuiNotification,
                                     $location,$ionicPopup,$timeout,ynNavigator) {

    var basePath = originBaseUrl + '/third/leaveAndRelease' ,  activeSearchInfo = $location.search().activeSearchInfo ;

    if (activeSearchInfo){
      $scope.activeClass = angular.fromJson(activeSearchInfo).searchInfo.activeClass;
    }

    //注册父路由
    ynNavigator.registerBackAction(function () {
      var backParam = {
        backFlag:true,
        backConditions:activeSearchInfo
      };
      $location.path("/leave_record_to_teacher").search(backParam);
      setTimeout(function () {
        $scope.$apply();
      });

    },101);



    $scope.chooseStu = chooseStu;
    $scope.selectStu = selectStu;
    $scope.searchStu = searchStu;
    $scope.clickStu = clickStu;
    $scope.moreStu = moreStu;
    $scope.getClassList = getClassList;
    $scope.clickClassInfo = clickClassInfo;

    /*************************************查询班级start**************************************************************/
    function clickClassInfo(item) {
      $scope.activeClass = item;
      searchStu();
    }
    //获取班级
    function getClassList() {
      $http.get(
          originBaseUrl + '/third/classStatistics/queryPlatformAdminClassNoGraduteByUserId.htm'
      ).success(function (data) {
        if (data.status === 0) {
          $scope.searchInfo.classList = data.result;
        }
      });
    }
    /****************************************查询班级end**************************************************************/
    $scope.searchInfo = {
      isShow:$location.search().isShow,
      name:null,
      lastPage:false,
      pageNumber:0,
      pageSize:20,
      selectStu:{},
      classList: [],
    };

    /*选择图片或拍照*/
    $scope.vm = {
      cameraPtion:{
        waterMark: moment().format("YYYY-MM-DD HH:mm:ss")
      },
      initFiles:[],
      initFile:false
    }

    $scope.checkboxList = [];

    function moreStu() {
      $scope.searchInfo.pageNumber += 1;
      selectStu();
    }

    function goTop() {
      $ionicScrollDelegate.$getByHandle('leaveStuScroll').scrollTop();
    }

    function chooseStu() {
      modalRecordShow();
      selectStu();
      getClassList();
    }

    function searchStu() {
      $scope.searchInfo.pageNumber = 0;
      selectStu(true);
    }

    function selectStu(flag) {
      var param = {
        id:$scope.activeClass.id,
        name:$scope.searchInfo.name,
        pageNumber:$scope.searchInfo.pageNumber,
        pageSize:$scope.searchInfo.pageSize
      };
      $http.post(basePath + '/getStuPage.htm',param).success(function (data) {
        if (data.status === 0) {
          if (flag){
            $scope.checkboxList = data.result.content;
            goTop();
          }else {
            $scope.checkboxList = [];
            $scope.checkboxList = $scope.checkboxList.concat(data.result.content);
          }
          $scope.searchInfo.lastPage = data.result.lastPage;

          $timeout(function () {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicLoading.hide();
          }, 200);
        }else {
          ynuiNotification.error({msg:"获取数据失败"});
        }
      });

    }

    function clickStu(item){
        $scope.searchInfo.selectStu = item;
        modalRecordHide();
    }

/*************************************************数据处理***********************************************************/
//参数初始化
    $scope.initData = false;
    $scope.wordNumber = 0;
    $scope.leaveParam = {
      id: "",
      leaveReason: "",
      leaveStartTime: null,
      leaveEndTime: null,
      passStartTime: null,
      passEndTime: null,
      isOutSchool: true,
      leaveDays: "1",
      isBackSleep: false,
      isTakeByParent: false
    };
    $scope.moreType = false;
    if ($location.search().isModify && $location.search().leavePassId) {//修改时
      $scope.leaveParam.id = $location.search().leavePassId;
      //查询请假信息
      $http.get(originBaseUrl + "/third/leaveAndRelease/queryMoraleduLeavePassShowById.htm?leavePassId=" + $scope.leaveParam.id).success(function (data) {
        if (data.status == 0) {
          $scope.item = data.result;
          if ($scope.item) {
            //初始化添加（修改）信息
            $scope.leaveParam = {
              id: $scope.item.id,//ID
              leaveStartTime: $scope.item.leaveStartTime,//请假开始时间
              leaveEndTime: $scope.item.leaveEndTime,//请假结束时间
              dictCode: $scope.item.leaveTypeCode,//请假类型
              isOutSchool: $scope.item.outSchoolCode,//是否出校（默认否）
              leaveReason: $scope.item.leaveReason,//请假原因
              leaveDays: $scope.item.leaveDays,
              isBackSleep: $scope.item.backSleepCode,//是否归寝（默认否）
              isTakeByParent: $scope.item.takeByParentCode,
              status: $scope.item.status
            };
            $scope.searchInfo.selectStu = {
              id:$scope.item.platformSysUserId,
              gradeName:$scope.item.parentName,
              orgName:$scope.item.parentMobile,
              stuShowName:$scope.item.stuShowName
            }

            angular.forEach($scope.fourLeaveType, function (item) {
              if ($scope.leaveParam.dictCode == item.dictCode) {
                item.selected = true;
              }
            });
            angular.forEach($scope.lastLeaveType, function (item) {
              if ($scope.leaveParam.dictCode == item.dictCode) {
                item.selected = true;
              }
            });
            if ($scope.leaveParam.isOutSchool) {
              $scope.leaveParam.passStartTime = $scope.item.passStartTime;
              $scope.leaveParam.passEndTime = $scope.item.passEndTime;
            }
            if ($scope.item.attachmentList && $scope.item.attachmentList.length > 0) {
              //赋值保存老的附件list信息
              angular.forEach($scope.item.attachmentList, function (item) {
                $scope.vm.initFiles.push(item.attachmentId);
              });
            }

            $scope.initData = true;
            $scope.initFile = true;
          }
        }
      });
    }else {
      $scope.initFile = true;
    }
    //更多请假类型
    $scope.moreLeaveType = function () {
      $scope.moreType = !$scope.moreType;
    };
    //请假类型赋值
    $scope.selectLeaveType = function (code, no, num) {
      $scope.leaveParam.dictCode = code;
      var index = parseInt(no) + parseInt(num);
      angular.forEach($scope.fourLeaveType, function (item) {
        item.selected = false;
      });
      if (index < 5) {
        angular.forEach($scope.lastLeaveType, function (item) {
          item.selected = false;
        });
        $scope.fourLeaveType[no].selected = true;
      } else {
        angular.forEach($scope.lastLeaveType, function (item) {
          item.selected = false;
        });
        $scope.lastLeaveType[no].selected = true;
      }
    };
    //请假类型
    $scope.fourLeaveType = [];
    $scope.lastLeaveType = [];
    $scope.$watch(function () {
      return $scope.fourLeaveType.length + $scope.lastLeaveType.length;
    }, function () {
      if ($scope.fourLeaveType.length + $scope.lastLeaveType.length <= 5) {
        $scope.moreType = false;
      } else {
        $scope.moreType = true;
      }
    });
    $scope.queryUserInfo = function () {
      $http.get(originBaseUrl + "/third/leaveAndRelease/queryUserInfo.htm?needClass=false&time=" + (new Date()).getTime()).success(function (data) {
        if (data.status == 0) {
          $scope.userInfo = data.result;
          if ($scope.userInfo && $scope.userInfo.fsId) {
            $scope.userInfo.fsId = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.userInfo.fsId;
            $scope.userInfo.smallFsId = originBaseUrl + "/file/downloadStream.htm?fastDFSId=" + $scope.userInfo.smallFsId;
          } else if ($scope.userInfo) {
            if ($scope.userInfo.gender == '女') {
              $scope.userInfo.fsId = originBaseUrl + "/mobile/img/userface_2.png";
              $scope.userInfo.smallFsId = originBaseUrl + "/mobile/img/userface_2.png";
            } else {
              $scope.userInfo.fsId = originBaseUrl + "/mobile/img/userface_1.png";
              $scope.userInfo.smallFsId = originBaseUrl + "/mobile/img/userface_1.png";
            }
          }
        }
      }).error(function () {
        $scope.loadingError = true;
        $scope.loadingErrorInfo = '加载失败，请重试！';
      });
    }
    //请假类型 -----后期还需修改
    var getLeaveType = function () {
      $http.get(originBaseUrl + "/third/leaveAndRelease/leaveType.htm?time=" + (new Date()).getTime()).success(function (data) {
        if (data.status == 0) {
          var typeList = data.result;
          if (!$location.search().isModify) {
            $scope.leaveParam.dictCode = typeList[0].dictCode;
            typeList[0].selected = true;
          }
          if (typeList.length >= 5) {
            $scope.moreType = true;
            $scope.fourLeaveType = typeList.splice(0, 5);
            $scope.lastLeaveType = typeList;
          } else {
            $scope.fourLeaveType = typeList;
          }
        }
      });
    };
    $scope.queryUserInfo();
    getLeaveType();

    //请假原因
    $scope.leaveReasonList = [];
    var getLeaveReason = function () {
      $http.get(originBaseUrl + "/third/leaveAndRelease/leaveReason.htm?time=" + (new Date()).getTime()).success(function (data) {
        if (data.status == 0) {
          $scope.leaveReasonList = data.result;
        }
      });
    };
    getLeaveReason();
    //选择请假模板
    $scope.chooseTem = function (dictName) {
      $scope.leaveParam.leaveReason = dictName;
    };
    //两个时间相差天数 兼容firefox chrome
    $scope.getDays = function (sDate1, sDate2) {    //sDate1和sDate2是2006-12-18格式
      var dateSpan,
          iDays;
      sDate1 = Date.parse(sDate1);
      sDate2 = Date.parse(sDate2);
      dateSpan = sDate2 - sDate1;
      dateSpan = Math.abs(dateSpan);
      iDays = Math.floor(dateSpan / (24 * 3600 * 1000));
      return iDays + 1;
    };

    $scope.changeStartTime = function(){
      $scope.leaveParam.passStartTime = $scope.leaveParam.leaveStartTime;
      if($scope.leaveParam.leaveEndTime && $scope.leaveParam.leaveEndTime<$scope.leaveParam.leaveStartTime){
        $scope.leaveParam.leaveEndTime = $scope.leaveParam.leaveStartTime;
      }
      $scope.leaveParam.passStartTime = $scope.leaveParam.leaveStartTime;
      $scope.changeTimeLeave();
    }

    $scope.changeEndTime = function(){
      $scope.leaveParam.passEndTime = $scope.leaveParam.leaveEndTime;
      $scope.changeTimeLeave();
    }


    $scope.changePassStartTime = function () {
      if($scope.leaveParam.passEndTime && $scope.leaveParam.passEndTime<$scope.leaveParam.passStartTime){
        $scope.leaveParam.passEndTime = $scope.leaveParam.passStartTime;
      }
    };

    //出校时间随着请假时间变化
    $scope.changeTimeLeave = function () {
      if ($scope.leaveParam.leaveStartTime && $scope.leaveParam.leaveEndTime) {
        var beginDay = $scope.leaveParam.leaveStartTime.split(" ")[0];
        var endDay = $scope.leaveParam.leaveEndTime.split(" ")[0];
        var leaveDays = $scope.getDays(beginDay, endDay);
        var maxDays = 999;
        if (parseFloat(leaveDays) > maxDays) {
          ynuiNotification.error({msg: '请假天数最多为' + maxDays + '天！'});
        }
        $scope.initData = true;
      }
    };

    function getDay(){
      var day = 0;
      if ($scope.leaveParam.leaveStartTime && $scope.leaveParam.leaveEndTime) {
        var beginDay = new Date($scope.leaveParam.leaveStartTime).getTime();
        var endDay = new Date($scope.leaveParam.leaveEndTime).getTime();
        if (endDay > beginDay){
          // 天
          day = Math.floor((endDay - beginDay) / 3600000 / 24);
        }
      }
      return day;
    }

    $scope.getShowHeight = function(){
      if ($scope.getShowDifferent()){
        return '70px';
      }else {
        return '50px';
      }
    }

    $scope.getShowDifferent = function(){
      var str = "";
      var day = getDay();
      if ($scope.initData && $scope.leaveParam && $scope.leaveParam.leaveDays != day && ($scope.leaveParam.leaveDays >= 1 || day >= 1)){
        str = "该天数与系统计算天数不一致，请核对";
      }
      return str;
    }

    $scope.showDayAndHour = function(){
      var str = "";
      if ($scope.leaveParam.leaveStartTime && $scope.leaveParam.leaveEndTime) {
        var beginDay = new Date($scope.leaveParam.leaveStartTime).getTime();
        var endDay = new Date($scope.leaveParam.leaveEndTime).getTime();
        if (endDay > beginDay){
          // 天
          var day = Math.floor((endDay - beginDay) / 3600000 / 24);
          // 小时
          var hour = Math.floor(((endDay - beginDay) / 3600000) % 24);
          if (day){
            str = day+"天";
          }
          if (hour){
            str += hour+"小时";
          }
          if (str){
            str = "共"+str;
          }

        }
      }
      return str;
    }

    $scope.initLeaveday = function () {
      if (!$scope.leaveParam.leaveDays){
        $scope.leaveParam.leaveDays = "0";
      }
    };
    //校验天数
    $scope.tureDay = true;
    $scope.verifyLeaveDay = function () {
      var maxDays =  999;
      var a = $scope.leaveParam.leaveDays + "";
      var n = a.indexOf(".") + 1;//12.34
      if (((n > 0 && a.length - n >= 2) || (n == 5 && a.length == 5) || isNaN(a) || a < 0) || (n == 0 && a.length >= 4)) {
        $scope.tureDay = false;
        $scope.leaveParam.leaveDays = "";
      } else if (a == "") {
        $scope.tureDay = false;
        $scope.leaveParam.leaveDays = "";
      } else if (parseFloat($scope.leaveParam.leaveDays) > maxDays) {
        $scope.tureDay = false;
        ynuiNotification.error({msg: '请假天数最多为' + maxDays + '天！'});
        $scope.leaveParam.leaveDays = maxDays;
      } else {
        $scope.tureDay = true;
      }
    };
    //天数增减
    $scope.changeDays = function (num) {
      var maxDays =  999;
      if (num < 0 && parseFloat($scope.leaveParam.leaveDays) <= 0) {
        return false;
      } else if (parseFloat($scope.leaveParam.leaveDays) + num > maxDays) {
        ynuiNotification.error({msg: '请假天数最多为' + maxDays + '天！'});
        $scope.leaveParam.leaveDays = maxDays;
        return false;
      }
      var leaveDays = accAdd($scope.leaveParam.leaveDays,num);
      if (!isNaN(leaveDays) && leaveDays > 0) {
        $scope.leaveParam.leaveDays = leaveDays;
      }else {
        $scope.leaveParam.leaveDays = 0;
      }
    };
    //加法
    function accAdd(arg1,arg2){
      var r1,r2,m,precision;
      try{r1=arg1.toString().split(".")[1].length}catch(e){r1=0}
      try{r2=arg2.toString().split(".")[1].length}catch(e){r2=0}
      m=Math.pow(10,Math.max(r1,r2));
      precision = (r1 >= r2) ? r1:r2;
      return ((arg1*m+arg2*m)/m).toFixed(precision);
    }

    //字数
    $scope.changeNumber = function (num) {
      $scope.wordNumber = num.length;
    };
    $scope.$watch(function () {
      return $scope.leaveParam.leaveReason
    }, function () {
      if($scope.leaveParam.leaveReason){
        $scope.wordNumber = $scope.leaveParam.leaveReason.length;
      }else {
        $scope.wordNumber = 0;
      }
    });
    $scope.changeValue = function (type, value) {
      if (type == 0) {
        $scope.leaveParam.isOutSchool = value;
      } else if (type == 1) {
        $scope.leaveParam.isBackSleep = value;
      } else if (type == 2) {
        $scope.leaveParam.isTakeByParent = value;
      }
    };
    $scope.subInfo = {inSubmit: false};


    //请假信息提交
    $scope.commitLeave = function (isDraft) {
      if (!($scope.searchInfo.selectStu && $scope.searchInfo.selectStu.id)) {
        ynuiNotification.error({msg: '请选择请假学生!'});
        return;
      }
      var leaveInfo = {
        id: $scope.leaveParam.id,
        dictCode: $scope.leaveParam.dictCode,
        isOutSchool: $scope.leaveParam.isOutSchool,
        leaveReason: $scope.leaveParam.leaveReason,
        leaveEndTime: $scope.leaveParam.leaveEndTime,
        leaveStartTime: $scope.leaveParam.leaveStartTime,
        passStartTime: $scope.leaveParam.passStartTime,
        passEndTime: $scope.leaveParam.passEndTime,
        userIdList:[$scope.searchInfo.selectStu.id]
      };
      if (!$scope.leaveParam.leaveStartTime || !$scope.leaveParam.leaveEndTime) {
        ynuiNotification.error({msg: '请选择请假起止时间!'});
        return;
      }
      if ($scope.leaveParam.leaveReason == "") {
        ynuiNotification.error({msg: '请填写请假原因!'});
        return;
      }
      if (!$scope.leaveParam.leaveDays || $scope.leaveParam.leaveDays == "") {
        ynuiNotification.error({msg: '请填写请假天数！'});
        return;
      }
      if (!$scope.tureDay) {
        var maxDays = 999;
        ynuiNotification.error({msg: '请假天数最多为' + maxDays + '天！'});
        return;
      }
      if (leaveInfo.isOutSchool) {
        if (!$scope.leaveParam.passStartTime || !$scope.leaveParam.passEndTime) {
          ynuiNotification.error({msg: '请选择申请出校时间!'});
          return;
        }
        // 判断放行开始时间
        var leaveStart = new Date($scope.leaveParam.leaveStartTime).getTime();
        var passStart = new Date($scope.leaveParam.passStartTime).getTime();
        // 放行时间不允许早于请假开始时间
        if (passStart < leaveStart) {
          ynuiNotification.error({msg: '“申请出校开始时间”不能早于“请假开始时间”！'});
          return;
        }
        // 判断放行结束时间
        var leaveEnd = new Date($scope.leaveParam.leaveEndTime).getTime();
        var passEnd = new Date($scope.leaveParam.passEndTime).getTime();
        if (passEnd > leaveEnd) {
          ynuiNotification.error({msg: '“申请出校结束时间”不能晚于“请假结束时间”！'});
          return;
        }
      }
      // 允许出校时间判断
      if (passStart > passEnd){
        ynuiNotification.error({msg: '“申请出校开始时间”不能晚于“申请出校结束时间”！'});
        return;
      }
      leaveInfo.isDraft = isDraft;
      leaveInfo.leaveDays = $scope.leaveParam.leaveDays;
      leaveInfo.isBackSleep = $scope.leaveParam.isBackSleep;
      leaveInfo.isTakeByParent = $scope.leaveParam.isTakeByParent;
      if (!leaveInfo.isOutSchool) {
        //如果已经出校需要放行时间
        leaveInfo.passStartTime = "";//允许放行开始时间
        leaveInfo.passEndTime = "";//允许放行结束时间
        leaveInfo.isBackSleep = true;
        leaveInfo.isTakeByParent = false;
      }
      leaveInfo.fsIdList = $scope.vm.initFiles;
      if ($scope.subInfo.inSubmit) {
        return;
      }
      $scope.subInfo.inSubmit = true;
      function saveData(){
        $http.post(basePath + '/saveLeavePassInfoByTeacher.htm', leaveInfo).success(function (data) {
          setTimeout(function () {
            $scope.subInfo.inSubmit = false;
            $scope.$apply();
          }, 2000);
          if (data.status == 0) {
            if (data.result && data.result.length > 0) {
              $scope.errorMsgArr = [];
              angular.forEach(data.result, function (item) {
                $scope.errorMsgArr.push(item.failedReason);
              });
              ynuiNotification.error({msg: $scope.errorMsgArr.join(" ")});
            } else {
              var backSearchInfo = angular.fromJson(activeSearchInfo);
              if (isDraft) {
                ynuiNotification.success({msg: '保存草稿成功!'});
                // 草稿跳转未提交
                backSearchInfo.activeStatus = "0";
                backSearchInfo.searchInfo.activeClass = $scope.activeClass;
                // 草稿跳转未提交
                backSearchInfo.activeStatus = "0";
              } else {
                ynuiNotification.success({msg: '保存成功!'});
                // 提交跳转审核中
                backSearchInfo.activeStatus = "3";
                backSearchInfo.searchInfo.activeClass = $scope.activeClass;
              }
              var backInfo = {
                backConditions:angular.toJson(backSearchInfo),
                backFlag:true
              };
              $location.path("/leave_record_to_teacher").search(backInfo);
              setTimeout(function () {
                $scope.$apply();
              });
            }
          } else {
            if (isDraft) {
              ynuiNotification.error({msg: '保存草稿失败！'});
            } else {
              ynuiNotification.error({msg: data.message});
            }
          }
        }).error(function (data) {
          setTimeout(function () {
            $scope.subInfo.inSubmit = false;
            $scope.$apply();
          }, 2000);
        });
      }

      if($scope.getShowDifferent()) {
        $ionicPopup.confirm({
          title: '提示',
          template: '录入的请假天数与系统计算的请假天数不一致，您确定要提交？',
          cancelText: '取消',
          okText: '确定'
        }).then(function (res) {
          if (res) {
            saveData();
          }else {
            setTimeout(function () {
              $scope.subInfo.inSubmit = false;
              $scope.$apply();
            }, 200);
          }
        });
      }else {
        saveData();
      }
    };

/***************************************************数据处理*********************************************************/

    /*模态*/
    $ionicModal.fromTemplateUrl('studentRecordList.html',{
      scope:$scope,
      animation:'slide-in-left'
    }).then(function(modal){
      $scope.modalRecord = modal;
    });
    function modalRecordShow() {
      $scope.modalRecord.show();
    }
    function modalRecordHide() {
      $scope.modalRecord.hide();
    }

  }
})();
