(function () {
    'use strict';

    angular
        .module('starter')
        .config(config)
        .controller('wrCtrl', wrCtrl)

    config.$inject = ['$stateProvider'];

    function config($stateProvider) {
        $stateProvider
            // 报表
            .state('loading', {
                url: '/loading',
                template: '<div></div>',
                data: {
                    micro: true
                }
            })
            // 报表
            .state('wr', {
                url: '/wr',
                templateUrl: 'templates/wr/index.html',
                data: {
                    micro: true
                },
                controller: 'wrCtrl'
            })
            // 工作台自定义报表
            .state('wrstation', {
                url: '/wrstation',
                templateUrl: 'templates/wr/index.html',
                controller: 'wrCtrl'
            })
    }

    wrCtrl.$inject = ['$scope', 'microNav', '$rootScope', '$timeout', '$state', '$location', '$sce', 'ynNavigator', 'ynNavService'];

    function wrCtrl($scope, microNav, $rootScope, $timeout, $state, $location, $sce, ynNavigator, ynNavService) {
        // 用于重绘iframe
        $scope.show = false;

        function track(value){
            // 数据埋点, key: E10046, value: /yn_product/RS_YueGongZiChaXun-sj.cpt
            try {
                yn.plugin.yncordova.sensorsDataAPI.trackAppClick({key:'E10046', value: value});
            }catch (e) {

            }
        }

        var search = $location.search();

        // 工作台自定义报表
        if (search.microName) {
            ynNavigator.setNavTitle(search.microName);
        }

        var access_token = $rootScope.authorizationStr.access_token;
        var server = originBaseUrl.substring(0, originBaseUrl.lastIndexOf("/ynedut")) + "/wr";//替换context为报表服务器的 wr, 采用截取主要是为了二级域名为ynedut的学校不出错
        var wrUrlBase = server.concat('/ynauth?accessToken=', access_token);
        var wrUrl = wrUrlBase;
        angular.forEach(search, function (value, key) {
            wrUrl = wrUrl.concat('&', key, '=', value);
        })

        if(ynjs.Platform.isIOS()){
            ynNavService.getNav().then(function (data){
                if(data.length === 1){
                    // iOS端数据采集
                    track(search.reportlet);
                    window.webkit.messageHandlers.openUrl.postMessage({url:wrUrl});
                    yn.plugin.yncordova.close();
                } else {
                    microNav.showSubApp();
                }
            }, function (error) {
                window.webkit.messageHandlers.openUrl.postMessage({url: wrUrl});
                yn.plugin.yncordova.close();
            });
        }else{
            // Android端数据采集
            track(search.reportlet);

            $scope.show = true;
            $scope.targetUrl = $sce.trustAsResourceUrl(wrUrl);

            ynNavigator.registerBackAction(function () {
                // 回到初始报表界面再返回, 则关闭微应用界面
                var reportWindow = window.frames['report'];
                var cUrl = reportWindow.location.href;
                var oCpt = wrUrl.substring(wrUrl.indexOf('reportlet='), wrUrl.indexOf('.cpt') + 3);
                var cpt = cUrl.substring(cUrl.indexOf('reportlet='), cUrl.indexOf('.cpt') + 3);
                if (oCpt === cpt) {
                    if ($state.current.name === 'wrstation') {
                        // 工作台自定义报表
                        var from = $rootScope.fromState;
                        if (from.name) {
                            $state.go(from.name, from.data || {});
                        }
                    } else {
                        ynNavigator.pop(true);
                    }
                } else {
                    window.history.back();
                }
            }, 101);
        }
    }

})();