/**
 * 查看寝室数据
 *
 */

(function () {
    'use strict';

    angular.module('starter').config(stateConfig).controller('classInBedRoomController', classInBedRoomController);

    stateConfig.$inject = ['$stateProvider'];

    /**
     * 路由配置
     *
     * @param $stateProvider
     */
    function stateConfig($stateProvider) {
        $stateProvider.state('build_room', {
            firstPage: true,
            url: '/build_room',
            templateUrl: 'templates/zbkq/dialog/buildRoom.html',
            controller: 'classInBedRoomController'
        });
    }

    classInBedRoomController.$inject = ['$scope', '$http', '$timeout','attStorageService','$ionicModal','ynuiNotification',
        '$ionicPopup','$location'];

    function classInBedRoomController($scope, $http, $timeout,attStorageService,$ionicModal,ynuiNotification,$ionicPopup,$location) {


        var basePath = originBaseUrl + "/third/newss/mobile";
        var oldValue = attStorageService.getItem("in_bed_guild_room");
        if(!oldValue){
            oldValue = {};
        }
        var vm = $scope.vm = {
            showName:oldValue.showName,
            userCount:oldValue.userCount,
            name:oldValue.name,
            status:oldValue.status,
            roleName:oldValue.roleName,
            sourceType:oldValue.type,
            showRoomUser:null,
            showRoomUserCount:null,
            monthList : [],
            dateList : [],
            pageSize : 0,
            pageNumber : 0,
            findRoomSituation:function () {
                vm.monthList = [];
                vm.pageSize += 20;
                $http.post(basePath + '/findRoomSituation.htm',
                    {
                        pageNumber: vm.pageNumber,
                        pageSize: vm.pageSize,
                        type:oldValue.type,
                        roleType:oldValue.roleType,
                        stuIdList:oldValue.stuIdList
                    }
                ).then(function (response) {
                    if(response.data.status == 0 && response.data.result.length > 0){
                        vm.monthList = angular.copy(response.data.result);
                    }
                });
            },
            getRoomUser:function (month) {
                vm.showRoomOneUser = {roomId:month.id};
                if(month.child && month.child.length > 0){
                    delete month.child;
                    return false;
                }
                $http.post(basePath + '/findRoomUser.htm',
                    {
                        stuIdList:month.myClassUserIds,
                        roleType:oldValue.roleType,
                        type:oldValue.type,
                        status:oldValue.status
                    }
                ).then(function (response) {
                    var child = angular.copy(response.data.result.userList);
                    vm.showRoomOneUser.isRegistration = angular.copy(response.data.result.isRegistration);
                    // 判断是否全部同寝室
                    var set = new Set();
                    angular.forEach(child,function (va,index) {
                        if(va.className){
                            set.add(va.className);
                        }else {
                            set.add(index);
                        }
                    });

                    if(set.size === 1){
                        angular.forEach(child,function (va) {
                            vm.showRoomOneUser.className = va.className;
                            vm.showRoomOneUser.commonVOList = va.commonVOList;
                            va.className = null;
                            va.commonVOList = null;
                        });
                    }


                    $timeout(function () {
                        vm.dateList = angular.copy(child);
                        $scope.modal.show();
                    });

                })
            },
            // 登记归寝
            savaRegistration:function (type) {
                if (type == 4){
                    // 关闭
                    $scope.conditionPreviewHide();
                }else if(type == 5){
                    // 返回
                    vm.showRoomClick = 1;
                    vm.getRoomUser(vm.showRoomUser);
                }else if(type == 2){
                    vm.showRoomClick = 2;
                    vm.getRoomUser(vm.showRoomUser);
                }else {
                    var roomIds = [],ssReturnSleepSaveVOS = [];
                    angular.forEach(vm.monthList,function (value) {
                        roomIds.push(value.id);
                    });
                    angular.forEach(vm.dateList,function (value) {
                        ssReturnSleepSaveVOS.push({
                            stuId:value.id,
                            roomId:vm.showRoomUser.id,
                            status:value.status,
                            sysStatus:value.sysStatus,
                            returnSleepId:value.returnSleepId,
                            leaveId:value.leaveId,
                        });
                    });

                    var param = {
                        roomIds:roomIds,
                        ssReturnSleepSaveVOS:ssReturnSleepSaveVOS,
                        stuIds:attStorageService.getItemNoDel("faceNotInBedUserList")
                    };
                    $http.post(basePath + '/saveReturnInfo.htm', {jsonStr:angular.toJson(param)}).success(function (response) {
                        if (response.status == 0){
                            if(response.result){
                                $scope.dialogInfo = {okText: '1'};
                                var template =
                                    "<div class='text-left'>" +
                                    "   <div>您还有 <span class='text-danger'>"+response.result.failedId+"</span>个寝室未登记，这些寝室的学生人脸识别结果是在寝。您可以选择：</div>" +
                                    "   <div class='input-inline' ng-click='dialogInfo.okText = 1'><label class='label-inline'><input type='radio' name='saveReturnInfo' ng-model='dialogInfo.okText' value='1'  style='width: 20px;!important;'/></label>根据人脸识别结果系统自动登记</div>" +
                                    "   <div class='input-inline' ng-click='dialogInfo.okText = 2'><label class='label-inline'><input type='radio' name='saveReturnInfo' ng-model='dialogInfo.okText' value='2' style='width: 20px;!important;'/></label>去核查后手动登记</div>" +
                                    "</div>";
                                $ionicPopup.show({
                                    template: template,
                                    scope: $scope,
                                    title: '提示',
                                    buttons: [
                                        {
                                            text: '确定',
                                            type: 'button-positive',
                                            onTap: function (e) {
                                                // 一键登记
                                                if ($scope.dialogInfo.okText == '1' ) {
                                                    vm.saveReturnBuild();
                                                }else {
                                                    // 归寝登记
                                                    $scope.opStatusModalHide();
                                                    $scope.callPhoneModalHide();
                                                    $scope.conditionPreviewHide();
                                                    vm.goBack();
                                                    $location.path("/admin_dormitory_list").search({date:oldValue.date});
                                                }
                                            }
                                        }
                                    ]
                                });
                            }else {
                                ynuiNotification.success({'msg':'保存成功！'});
                                $scope.opStatusModalHide();
                                $scope.callPhoneModalHide();
                                $scope.conditionPreviewHide();
                                vm.findRoomSituation();
                            }
                        }else {
                            ynuiNotification.error({'msg':'保存失败！'});
                        }

                    })
                }


            },
            // 一键处理
            saveReturnBuild:function () {
                var param = {
                    buildId:attStorageService.getItemNoDel("inBedGuildBuildId")
                };
                $http.post(basePath + '/saveReturnBuild.htm', param).success(function (response) {
                    if (response.status == 0){
                        if(response.result){

                        }else {
                            ynuiNotification.success({'msg':'保存成功！'});
                            $scope.opStatusModalHide();
                            $scope.callPhoneModalHide();
                            $scope.conditionPreviewHide();
                            vm.goBack();
                        }
                    }else {
                        ynuiNotification.error({'msg':'保存失败！'});
                    }

                })

            },
            // 查看请假或出差
            leaveRecordClick:function(item){
                var param = {
                    sysUserId:item.id,
                    leaveId:item.leaveId
                };
                attStorageService.setItem("in_bed_leave_record",param);
                attStorageService.setItem("in_bed_leave_record_item",item);
                $scope.$on("in_bed_leave_record",function (event, data) {
                    vm.inBedLeaveRecord.remove();
                    if(data){
                        vm.getListInfo();
                    }
                });
                $ionicModal.fromTemplateUrl('templates/zbkq/dialog/in_bed_leave_record.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    vm.inBedLeaveRecord = modal;
                    vm.inBedLeaveRecord.show();
                });
            },
            goBack:function () {
                // 班主任
                if(oldValue.type == 1){
                    $location.path("/teacher/workspace/class_inBedStudent").search("item",JSON.stringify({classId:oldValue.classId}));
                    $scope.$emit("in_bed_guild_room",false);
                }else {
                    $scope.$emit("in_bed_guild_room",true);
                }

                if(vm.inBedLeaveRecord){
                    vm.inBedLeaveRecord.remove();
                }
            }
        };


        $ionicModal.fromTemplateUrl('callPhone.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.callPhoneModal = modal;
        });

        $scope.callPhone =function(phoneList){
            $scope.phoneList = angular.copy(phoneList);
            $scope.callPhoneModal.show();
        }

        $scope.callPhoneModalHide =function(){
            $scope.callPhoneModal.hide();
        }

        vm.findRoomSituation(true);



        function cordovaFileOpenSuccess() {
            // 从已安装程序中打开文件完成
        }

        function cordovaFileOpenError(code) {
            if (code === 1) {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '未能在手机已安装APP中找到可预览此文件的程序'
                });
            } else {
                $ionicPopup.alert({
                    title: '文件预览提示',
                    template: '预览时发生了未知错误 #' + code
                });
            }
        }

        // 预览照片
        $scope.previewPhoto = function (photo) {
            if(photo.uri){
                var cordovaFileOpen = cordova.plugins.disusered.open;
                cordovaFileOpen(originBaseUrl+"/file/downloadStream.htm?fastDFSId="+photo.uri, cordovaFileOpenSuccess, cordovaFileOpenError);
            }

        };


        /**
         * 返回
         */
        $scope.goBack = function() {
            yn.plugin.yncordova.close();
        }


        /*模态*/
        $ionicModal.fromTemplateUrl('condition_preview.html',{
            scope:$scope,
            animation:'slide-in-left'
        }).then(function(modal){
            $scope.modal = modal;
        });
        $scope.conditionClick = function(month,showRoomUserCount) {
            vm.showRoomUser = angular.copy(month);
            vm.showRoomUserCount = angular.copy(showRoomUserCount);
            vm.showRoomClick = 1;
            vm.getRoomUser(month);
        };
        $scope.conditionPreviewHide =function(){
            $scope.modal.hide();
        }

        $ionicModal.fromTemplateUrl('opStatus.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.opStatusModal = modal;
        });
        $scope.opStatusModalShow = function (item) {
            if(vm.showRoomOneUser.isRegistration == true || vm.showRoomClick === 2){
                $scope.opStatusModal.show();
                $scope.opStatusItem = angular.copy(item);
            }

        };
        $scope.opStatusModalHide = function () {
            $scope.opStatusModal.hide();
        };
        $scope.changeStatus = function (status) {
            angular.forEach(vm.dateList,function (value) {
                if(value.id === $scope.opStatusItem.id){
                    value.status = status;
                }
            });
            $scope.opStatusModal.hide();
        };


    }
})();
