/**
 * 学生实时在寝情况 寝室详情
 * 校领导/系主任 宿管员 值日老师
 */

(function () {
    'use strict';

    angular.module('starter')
      .config(stateConfig)
      .controller('zbkqInBedStudentController', zbkqInBedStudentController);

    stateConfig.$inject = ['$stateProvider'];

    /**
     * 路由配置
     *
     * @param $stateProvider
     */
    function stateConfig($stateProvider) {
        $stateProvider
          .state('zbkq_in_bedStudent_manager', {
              url: '/zbkq_in_bedStudent_manager',
              templateUrl: 'templates/zbkq/zbkq_inBedStudent.html',
              controller: 'zbkqInBedStudentController',
              data: {
                  title: '归寝登记',
                  micro: true
              }
          });
    }

    zbkqInBedStudentController.$inject = ['$scope', '$http', 'attStorageService', '$timeout', '$ionicModal','$location','$ionicPopup', '$state'];

    function zbkqInBedStudentController($scope, $http,  attStorageService, $timeout, $ionicModal,$location,$ionicPopup, $state) {
        var basePath = originBaseUrl + "/third/newss/mobile";
        var vm = $scope.vm = {
            // 全校住宿生
            totleStudent: 0,
            // 女住宿生
            girlStudent: 0,
            // 男住宿生
            boyStudent: 0,

            // 按时归
            onTimeNumber: 0,
            // 晚归寝
            backNumber: 0,
            // 未归寝
            notBackNumber: 0,
            // 待打卡
            stayClock: 0,
            // 无需考勤
            noNeedAttendance: 0,
            // 实习
            activeNumber: 0,
            // 请假
            leaveNumber: 0,

            //男生
            // 按时归
            onTimeBoyNumber: 0,
            // 晚归寝
            backBoyNumber: 0,
            // 未归寝
            notBackBoyNumber: 0,
            // 待打卡
            stayBoyClock: 0,
            // 无需考勤
            noNeedBoyAttendance: 0,
            // 实习
            activeBoyNumber: 0,
            // 请假
            leaveBoyNumber: 0,


            //女生
            // 按时归
            onTimeGirlNumber: 0,
            // 晚归寝
            backGirlNumber: 0,
            // 未归寝
            notBackGirlNumber: 0,
            // 待打卡
            stayGirlClock: 0,
            // 无需考勤
            noNeedGirlAttendance: 0,
            // 实习
            activeGirlNumber: 0,
            // 请假
            leaveGirlNumber: 0,
            //总人数
            totle: 0,
            sysOrgList: [],
            showOrgName: "",
            ais:0,
            panels:0,
            latelySleepList:[],
            // 选择校区
            selectedOrg: function (item, flag) {
                vm.showOrgName = item.name;
                $scope.getDataInfo(item.userNumber);
                //下拉时通过校区Id触发查询
            }
        };

        $scope.searchInfo = {
            selectDate : ""
        };

        //获取今日日期
        function getNowFormatDate() {
            var date = new Date();
            var seperator1 = "-";
            var year = date.getFullYear();
            var month = date.getMonth() + 1;
            var strDate = date.getDate();
            if (month >= 1 && month <= 9) {
                month = "0" + month;
            }
            if (strDate >= 0 && strDate <= 9) {
                strDate = "0" + strDate;
            }
            var currentdate = year + seperator1 + month + seperator1 + strDate;
            return currentdate;
        };
        function getWeek() {
            var seperator1 = "-";
            var year = date.getFullYear();
            var month = date.getMonth() + 1;
            var strDate = date.getDate();
            if (month >= 1 && month <= 9) {
                month = "0" + month;
            }
            if (strDate >= 0 && strDate <= 9) {
                strDate = "0" + strDate;
            }
            var currentdate = year + seperator1 + month + seperator1 + strDate;
            return currentdate;
        };
        $scope.currentdate = getNowFormatDate();
        $scope.searchInfo.selectDate = $scope.currentdate;
        $scope.roleSchoolAndBuild = function () {
            var param = {
                type: 3
                // ,userId: "ccdfe8e5-c194-4c2c-8b28-5fb59e8a6665"

            };
            $http.post(basePath + "/roleSchoolAndBuild.htm", param).success(function (data) {
                if (data.status == 0) {
                    var schoolAndBuild = angular.copy(data.result.schoolAndBuild);
                    $scope.getSchoolandBuildUserCount(schoolAndBuild);

                }
            });
        };
        $scope.roleSchoolAndBuild();

        $scope.getSchoolandBuildUserCount = function (schoolAndBuild) {
            if (schoolAndBuild && schoolAndBuild.sysOrgList &&
                schoolAndBuild.sysOrgList.length > 0
            ) {
                vm.sysOrgList = angular.copy(schoolAndBuild.sysOrgList);
                vm.showOrgName = vm.sysOrgList[0].name;
                var orgId = vm.sysOrgList[0].userNumber;
                $scope.getDataInfo(orgId);
            } else {
                $scope.getDataInfo();
            }
        };

        $scope.weekStr = "";
        $scope.changeDate = function () {
            $scope.getDataInfo(orgNumber);
            // $scope.weekStr = $scope.getWeek($scope.searchInfo.selectDate);
        };



        $scope.getWeek =  function(dateStr){
            var date = new Date(dateStr);
            var day = date.getDay();
            var weeks = new Array("周日", "周一", "周二", "周三", "周四", "周五", "周六");
            var week = weeks[day];
            return week;
        };

        var ON_TIME = [];
        var BACKED = [];
        var NOT_BACK = [];
        var DATE = [];
        var orgNumber = "";
        $scope.showTips = "";
        $scope.getDataInfo = function (org) {
            DATE = [];
            ON_TIME = [];
            BACKED = [];
            NOT_BACK = [];
            $scope.showTips = "";
            if(org){
                orgNumber = org;
            }else{
                org = "";
            }
            $http.post(basePath + "/queryStatistics.htm?orgNo=" + org+"&date="+$scope.searchInfo.selectDate).success(function (data) {
                if (data.status == 0) {
                    $scope.weekStr = $scope.getWeek($scope.searchInfo.selectDate);
                    vm.buildList = data.result.ssEquipmentInfoVO;
                    vm.totleStudent = data.result.totleStudent ? data.result.totleStudent : 0;
                    vm.girlStudent = data.result.girlStudent ? data.result.girlStudent : 0;
                    vm.boyStudent = data.result.boyStudent ? data.result.boyStudent : 0;
                    //最近7天
                    vm.latelySleepList = data.result.commonVOList;
                    vm.leaveNumber = (data.result.ssReturnSleepCountVO &&  data.result.ssReturnSleepCountVO.leaveNumber) ? data.result.ssReturnSleepCountVO.leaveNumber : 0;
                    vm.activeNumber = (data.result.ssReturnSleepCountVO && data.result.ssReturnSleepCountVO.activeNumber) ? data.result.ssReturnSleepCountVO.activeNumber : 0;
                    vm.notBackNumber =(data.result.ssReturnSleepCountVO && data.result.ssReturnSleepCountVO.notBackNumber) ? data.result.ssReturnSleepCountVO.notBackNumber : 0;
                    vm.stayClock = (data.result.ssReturnSleepCountVO && data.result.ssReturnSleepCountVO.stayClock) ? data.result.ssReturnSleepCountVO.stayClock : 0;
                    vm.backNumber = (data.result.ssReturnSleepCountVO && data.result.ssReturnSleepCountVO.backNumber) ? data.result.ssReturnSleepCountVO.backNumber : 0;
                    vm.onTimeNumber =(data.result.ssReturnSleepCountVO && data.result.ssReturnSleepCountVO.onTimeNumber) ? data.result.ssReturnSleepCountVO.onTimeNumber : 0;
                    vm.noNeedAttendance = (data.result.ssReturnSleepCountVO && data.result.ssReturnSleepCountVO.noNeedAttendance) ? data.result.ssReturnSleepCountVO.noNeedAttendance : 0;
                    vm.totle = vm.onTimeNumber+vm.backNumber+vm.notBackNumber+vm.stayClock+vm.noNeedAttendance+vm.activeNumber+vm.leaveNumber;

                    for(var i in vm.latelySleepList){
                        DATE.push(vm.latelySleepList[i].date);
                        ON_TIME.push(vm.latelySleepList[i].onTimeNumber);
                        BACKED.push(vm.latelySleepList[i].backNumber);
                        NOT_BACK.push(vm.latelySleepList[i].notBackNumber);
                    }

                    if(vm.totleStudent>0){
                        //延迟渲染
                        $timeout(function() {
                            $scope.barView();
                            $scope.pieView();
                        }, 700);
                    }
                }else{
                    $scope.weekStr = $scope.getWeek($scope.searchInfo.selectDate);
                    $scope.showTips = data.message;
                }
            });
        };

        /***************************Echarts start********************************************************/
        $scope.barView = function () {
            //树状图
            var myChart = echarts.init(document.getElementById('improve'));
            // 指定图表的配置项和数据
            var option = {
                title: {
                    text: '近7天归寝趋势分析'
                },
                tooltip: {
                    trigger: 'axis'
                },
                legend: {
                    // align: 'center', //水平方向位置
                    // verticalAlign: 'bottom', //垂直方向位置
                    x: '20%', //距离x轴的距离
                    y: '8%', //距离Y轴的距离
                    data: ['按时归', '晚归寝', '未归寝']
                },
                grid: {
                    left: '3%',
                    right: '4%',
                    bottom: '3%',
                    containLabel: true
                },
                xAxis: {
                    type: 'category',
                    boundaryGap: false,
                    data: DATE
                },
                yAxis: {
                    type: 'value'
                },
                series: [
                    {
                        name: '按时归',
                        type: 'line',
                        stack: '',
                        data:ON_TIME,
                        color:'#7ad05c'
                    },
                    {
                        name: '晚归寝',
                        type: 'line',
                        stack: '',
                        data: BACKED,
                        color:'#ff9211'
                    },
                    {
                        name: '未归寝',
                        type: 'line',
                        stack: '',
                        data: NOT_BACK,
                        color:'#5ec8ff'
                    }
                ]
            };
            // 使用刚指定的配置项和数据显示图表。
            myChart.setOption(option);
        };




        //饼图
        $scope.pieView = function () {
            var myChart1 = echarts.init(document.getElementById('improve1'));
            var option1 = {
                title: {
                    text: '宿舍考勤统计',
                    left: 'left'
                },
                tooltip : {  //hover提示
                    trigger: 'item',
                    formatter: function(arg) {
                        return arg.data.name;
                    }
                },
                series: [
                    {
                        type: 'pie',
                        radius: '65%',
                        center: ["50%", "50%"],
                        // label:{
                        //     normal:{
                        //         position: 'inner',
                        //         show:true
                        //     }
                        // },
                        data: [
                            {value: vm.onTimeNumber==0?null:vm.onTimeNumber, name: '按时归'+':'+vm.onTimeNumber, itemStyle: {color: '#7ad05c'}},
                            {value: vm.backNumber==0?null:vm.backNumber, name: '晚归寝'+':'+vm.backNumber, itemStyle: {color: '#ff9211'}},
                            {value: vm.notBackNumber==0?null:vm.notBackNumber, name: '未归寝'+':'+vm.notBackNumber, itemStyle: {color: '#5ec8ff'}},
                            {value: vm.stayClock==0?null:vm.stayClock, name: '待打卡'+':'+vm.stayClock, itemStyle: {color: '#f993bf'}},
                            {value: vm.activeNumber==0?null:vm.activeNumber, name: '实习'+':'+vm.activeNumber, itemStyle: {color: '#00736d'}},
                            {value: vm.leaveNumber==0?null:vm.leaveNumber, name: '请假'+':'+vm.leaveNumber, itemStyle: {color: '#ae5da1'}},
                            {value: vm.noNeedAttendance==0?null:vm.noNeedAttendance, name: '无需考勤'+':'+vm.noNeedAttendance, itemStyle: {color: '#556fb5'}}
                        ],
                        labelLine: {
                            show: true,//数据标签引导线
                            length: 2,
                            lineStyle: {
                                width: 1,
                                type: 'solid'
                            }
                        },
                        emphasis: {
                            show: true,
                            itemStyle: {
                                shadowOffsetX: 0,
                                borderWidth: 2,
                                borderColor: '#ffffff'
                            }
                        }
                    }
                ]
            };
            // 使用刚指定的配置项和数据显示图表 yn
            myChart1.setOption(option1);
            /***************************Echarts end********************************************************/
        }
    }
})();
