package com.yineng.ynbridge

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.view.KeyEvent
import com.tencent.smtt.sdk.WebChromeClient
import com.tencent.smtt.sdk.WebView
import com.tencent.smtt.sdk.WebViewClient
import com.yineng.ynbridge.engine.SystemWebViewEngine
import com.yineng.ynbridge.engine.YnSystemWebChromeClient
import com.yineng.ynbridge.engine.YnSystemWebViewClient

/**
 * ClassName YnBridgeWebView
 * User: zuoweichen
 * Date: 2022/3/14 11:05
 * Description: 描述
 */
class BridgeSystemWebView : WebView {
    private var viewClient: YnSystemWebViewClient? = null
    private var chromeClient: YnSystemWebChromeClient? = null
    private var parentEngine: SystemWebViewEngine? = null

    constructor(context: Context) : super(context) {
    }

    constructor(context: Context, attrs: AttributeSet?) : super(context, attrs) {
    }

    constructor(context: Context, attrs: AttributeSet?, defStyleAttr: Int) : super(
        context,
        attrs,
        defStyleAttr
    ) {
    }


    @SuppressLint("SetJavaScriptEnabled")
    fun init(parentEngine: SystemWebViewEngine) {
        this.parentEngine = parentEngine
        if (this.viewClient == null) {
            webViewClient = YnSystemWebViewClient(parentEngine)
        }

        if (chromeClient == null) {
            webChromeClient = YnSystemWebChromeClient(parentEngine)
        }
    }

    override fun setWebViewClient(client: WebViewClient) {
        viewClient = client as YnSystemWebViewClient
        super.setWebViewClient(client)
    }

    override fun setWebChromeClient(client: WebChromeClient?) {
        chromeClient = client as YnSystemWebChromeClient
        super.setWebChromeClient(client)
    }

    override fun dispatchKeyEvent(event: KeyEvent): Boolean {
        val ret = parentEngine?.client?.onDispatchKeyEvent(event)
        if (ret != null) {
            return ret
        }
        return super.dispatchKeyEvent(event)
    }
}