package com.yineng.ynbridge

import org.json.JSONObject

/**
 * ClassName PluginResult
 * User: zuoweichen
 * Date: 2022/3/18 13:42
 * Description: 描述
 */
class PluginResult {
    private val status: Int
    private val message: String

    /**
     * 是否保持
     */
    private var keepCallback = false

    constructor(status: Status) : this(status, StatusMessages[status.ordinal])

    constructor(status: Status, message: String) {
        this.message = message
        this.status = status.ordinal
    }

    constructor(status: Status, message: JSONObject) {
        this.status = status.ordinal
        this.message = message.toString()
    }

    fun getMessage(): String {
        return message
    }

    fun getStatus(): Int {
        return status
    }

    fun setKeepCallback(a: Boolean) {
        this.keepCallback = a
    }

    fun getKeepCallback(): Boolean {
        return keepCallback
    }

    companion object {
        var StatusMessages = arrayOf(
            "Error",
            "OK"
        )
    }

    enum class Status {
        ERROR,
        OK
    }
}