package com.yineng.ynbridge

import org.json.JSONArray
import org.json.JSONException

/**
 * ClassName YnWebPlugin
 * User: zuoweichen
 * Date: 2022/3/16 10:39
 * Description: 描述
 */
open class YnWebPlugin {
    private var serviceName: String? = null
    var webView: YnBridgeWebView? = null
    lateinit var ynBridge: YnBridgeInterface
    fun privateInitialize(
        serviceName: String,
        webView: YnBridgeWebView,
        ynBridge: YnBridgeInterface
    ) {
        this.serviceName = serviceName
        this.ynBridge = ynBridge
        this.webView = webView
    }

    @Throws(JSONException::class)
    open fun execute(action: String, rawArgs: String, callbackContext: CallbackContext): Boolean {
        val args = JSONArray(rawArgs)
        return execute(action, args, callbackContext)
    }

    open fun execute(
        action: String,
        rawArgs: JSONArray,
        callbackContext: CallbackContext
    ): Boolean {
        return false
    }
}