package com.yineng.ynbridge.engine

import android.text.TextUtils
import android.webkit.JavascriptInterface
import com.yineng.ynbridge.YnBridge
import org.json.JSONObject

/**
 * ClassName SystemExposedJsApi
 * User: zuoweichen
 * Date: 2022/3/16 15:31
 * Description: 向外暴露的jsapi 实现类
 */
class SystemExposedJsApi(private val bridge: YnBridge) : ExposedJsApi {

    @JavascriptInterface
    override fun exec(
        bridgeJson: String?
    ): String? {
        try {
            if (TextUtils.isEmpty(bridgeJson)) {
                return null
            }
            val jsonObject = JSONObject(bridgeJson!!)
            val bridgeSecret = jsonObject.get("secret") as Int
            val method = jsonObject.get("method") as String?
            val callbackId = jsonObject.get("callbackId") as String?
            val arguments = jsonObject.get("data") as String?
            if (!method.isNullOrEmpty()) {
                val split = method.split(".")
                if (split.size >= 2) {
                    val service = split[0]
                    val action = split[1]
                    return bridge.jsExec(bridgeSecret, service, action, callbackId, arguments)
                }
            }
        } catch (e: Exception) {
        }
        return null
    }
}