package com.yineng.ynbridge.engine

import android.annotation.SuppressLint
import android.content.Context
import com.tencent.smtt.sdk.ValueCallback
import com.tencent.smtt.sdk.WebView
import com.yineng.ynbridge.BridgeSystemWebView
import com.yineng.ynbridge.PluginManager
import com.yineng.ynbridge.YnBridge
import com.yineng.ynbridge.YnBridgeWebViewEngine

/**
 * ClassName SystemWebViewEngine
 * User: zuoweichen
 * Date: 2022/3/16 13:52
 * Description: 描述
 */
open class SystemWebViewEngine : YnBridgeWebViewEngine {
    protected val webView: BridgeSystemWebView

    lateinit var bridge: YnBridge
    public var client: YnBridgeWebViewEngine.Client? = null

    constructor(context: Context) : this(BridgeSystemWebView(context))

    constructor(systemWebView: BridgeSystemWebView) {
        this.webView = systemWebView
    }

    companion object {
        fun createEngine(context: Context): YnBridgeWebViewEngine {
            return SystemWebViewEngine(context)
        }

        fun exposeJsInterface(webView: WebView, bridge: YnBridge) {
            val exposedJsApi = SystemExposedJsApi(bridge)
            webView.addJavascriptInterface(exposedJsApi, "_ynbridge")
        }
    }

    override fun init(client: YnBridgeWebViewEngine.Client, pluginManager: PluginManager) {
        this.client=client
        webView.init(this)
        initWebViewSettings()
        bridge = YnBridge(pluginManager)
        exposeJsInterface(webView, bridge)
    }

    override fun loadUrl(url: String) {
        webView.loadUrl(url)
    }

    override fun evaluateJavascript(js: String, callback: ValueCallback<String>?) {
        webView.evaluateJavascript(js, callback)
    }

    /**
     * 初始化设置webview
     */
    @SuppressLint("SetJavaScriptEnabled")
    private fun initWebViewSettings() {
        val settings = webView.settings
        settings.javaScriptEnabled = true
        settings.domStorageEnabled = true
    }
}