/**
 * Created by wuhaiying on 2016/11/16.
 */
angular.module('starter')
    .config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
    //巡课登记-打开应用时显示效果
        .state('patrol_register', {
            url: '/teacher/class_patrol/list',
            templateUrl: 'templates/classpatrol/patrol_list.html',
            data: {
                title: '巡课',
                micro: true
            },
            cache: false
        })
        // 批量登记
        .state('patrol_register_batch', {
            url: '/teacher/class_patrol/batch',
            templateUrl: 'templates/classpatrol/batch_register.html',
            data: {
                title: '巡课登记',
                prev: 'classPatrolIndexByTea'
            },
            cache: false
        })
        // 批量登记 选择有课教室
        .state('patrol_register_batch_room', {
            url: '/patrol_register_batch_room',
            templateUrl: 'templates/classpatrol/select_floor.html',
            data: {
                title: '巡课登记'
            },
            cache: false
        })
        // 单个登记
        .state('patrol_register_single', {
            url: '/teacher/class_patrol/single?oldVm',
            templateUrl: 'templates/classpatrol/patrol_register.html',
            data: {
                title: '巡课登记',
                prev: 'classPatrolIndexByTea'
            }
        })
        //巡课登记-选择教室后显示效果
        .state('patrol_register_more', {
            url: '/teacher/class_patrol/single/more?oldVm',
            templateUrl: 'templates/classpatrol/patrol_register_more.html',
            data: {
                title: '巡课登记',
                prev: 'classPatrolIndexByTea'
            },
            cache: false
        })
        //选择教室
        .state('choose_classroom', {
            url: '/choose_classroom',
            templateUrl: 'templates/classpatrol/choose_classroom.html',
            data: {
                title: '巡课登记'
            },
            cache: false
        })
        //选择课程
        .state('choose_courses', {
            url: '/choose_courses',
            templateUrl: 'templates/classpatrol/choose_courses.html',
            data: {
                title: '巡课登记'
            },
            cache: false
        })
        //选择教师
        .state('choose_teacher', {
            url: '/choose_teacher',
            templateUrl: 'templates/classpatrol/choose_teacher.html',
            data: {
                title: '巡课登记'
            },
            cache: false
        })
        //选择班级
        .state('choose_grade', {
            url: '/choose_grade',
            templateUrl: 'templates/classpatrol/choose_grade.html',
            data: {
                title: '巡课登记'
            },
            cache: false
        })
        //选择巡课人
        .state('choose_patroller', {
            url: '/choose_patroller',
            templateUrl: 'templates/classpatrol/choose_patroller.html',
            data: {
                title: '巡课登记'
            },
            cache: false
        }).//备注
    state('patrol_tips', {
        url: '/patrol_tips',
        templateUrl: 'templates/classpatrol/patrol_tips.html',
        data: {
            title: '巡课登记'
        },
        cache: false
    });
})
    /**
     *  巡课列表
     */
    .controller("patrolListController", ['$scope', '$http', '$ionicModal', '$ionicLoading',
        '$ionicScrollDelegate', '$location', "ynuiNotification", "storageService","$document",
        "$ionicPopup","modalManager","$cordovaBarcodeScanner",
        function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location,
                  ynuiNotification, storageService,$document,$ionicPopup,modalManager,$cordovaBarcodeScanner) {

            // 路由信息
            var basePath = originBaseUrl + "/third/xcMobileNewRecord";


            var vm = $scope.vm = {
                // 查询对象
                queryVO:{
                    // 教室类型 1=全部教室 2=异常教室
                    roomType:2,
                    dateTimes:null,
                    termId:null,
                    week:null,
                    day:null,
                    knob:null,
                    timeType:null
                },
                currentDate:null,
                // 跳转来源 1=扫一扫，2=单个添加
                sourceType:null,
                // 全部教室数量
                allRoomNum:null,
                all:null,
                // 异常教室数量
                abnormalNum:null,
                // 列表数据
                xcRecordListVOList:[],
                // 所有节次
                knobList:[],
                // 查看、编辑 记录
                oldRecordToViewOrUpdate:null,
                // 获取列表
                findAllXCRecordList:function () {
                    var params = {
                        roomType:vm.queryVO.roomType,
                        dateTimes:vm.queryVO.dateTimes,
                        termId:vm.queryVO.termId,
                        week:vm.queryVO.week,
                        day:vm.queryVO.day,
                        knob:vm.queryVO.knob,
                        timeType:vm.queryVO.timeType
                    };
                    $http.post(basePath + "/findAllXCRecordList.htm",params).success(function (data) {
                        if(data.status == 0){
                            vm.allRoomNum = data.result.allRoomNum;
                            vm.all = data.result.all;
                            if(vm.allRoomNum == 0){
                                vm.xcRecordListVOList = [];
                            }else {
                                vm.xcRecordListVOList = data.result.xcRecordListVOList;
                            }
                            vm.abnormalNum = data.result.abnormalNum;
                        }else {

                        }
                    });
                },
                // 获取当前日期
                getCurrentDate:function () {
                    $http.post(basePath + "/getCurrentDate.htm").success(function (data) {
                        if(data.status == 0){
                            vm.queryVO.dateTimes = data.result;
                            vm.currentDate = data.result;
                            vm.getRegister(vm.queryVO.dateTimes);
                        }
                    });
                },
                // table 切换
                changeRoomType:function (type) {
                    vm.queryVO.roomType = type;
                    vm.findAllXCRecordList();
                },
                // 根据选择的日期查询出巡课的时间
                getRegister:function(date, fun) {
                    $http.get(originBaseUrl + "/third/xcMobileRecord/queryCheckInfoByDate.htm",
                        {params:{
                            date:date,
                            _timestamp:new Date().getTime()
                        }}).success(function (data) {
                        if (data.status == 0) {
                            var xcMobileStartVO = angular.copy(data.result);
                            vm.queryVO.dateTimes = xcMobileStartVO.checkDate;
                            vm.queryVO.checkDateStrs = xcMobileStartVO.checkDateStrs;
                            if(vm.currentDate == vm.queryVO.dateTimes){
                                vm.queryVO.checkDateStrs += " [今天]";
                            }
                            vm.queryVO.termId = xcMobileStartVO.checkPlatformSysTermId;
                            vm.queryVO.timeType = xcMobileStartVO.timeType;
                            vm.queryVO.knob = xcMobileStartVO.knob;
                            vm.queryVO.day = xcMobileStartVO.day;
                            vm.queryVO.week = xcMobileStartVO.week;
                            var hasDefault = false;
                            angular.forEach(xcMobileStartVO.xcMobileKnobVOs, function (item) {
                                item.select = false;
                                if (item.knob == xcMobileStartVO.knob && item.timeType == xcMobileStartVO.timeType) {
                                    item.select = true;
                                    hasDefault = true;
                                }
                            });
                            if (!hasDefault) {
                                var item = xcMobileStartVO.xcMobileKnobVOs[0];
                                if (item) {
                                    item.select = true;
                                    vm.queryVO.knob = item.knob;
                                    vm.queryVO.timeType = item.timeType;
                                }
                            }

                            vm.knobList = xcMobileStartVO.xcMobileKnobVOs;

                            vm.findAllXCRecordList();
                        } else {
                            ynuiNotification.error({msg: data.message});
                        }
                        if (fun) {
                            fun();
                        }
                    }).error(function () {
                        ynuiNotification.error({msg: "获取信息失败！"});
                        if (fun) {
                            fun();
                        }
                    });
                },
                // 选择日期
                selectDateTime:function (data) {
                    vm.getRegister(data, function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                // 选择节次
                selectKnob:function (item) {
                    angular.forEach(vm.knobList, function (knob) {
                        knob.select = false;
                    });
                    item.select = true;
                    vm.queryVO.knob = item.knob;
                    vm.queryVO.timeType = item.timeType;
                    vm.findAllXCRecordList();
                },
                /**
                 * 出现操作按钮
                 * @param $event 事件
                 * @param index 下标
                 */
                operationClick:function($event, index) {
                    $event.stopPropagation();
                    angular.forEach(vm.xcRecordListVOList,function (info, oldIndex) {
                        if(index !== oldIndex){
                            var elemnt = $document.find('#item-operation-wrap_' + oldIndex);
                            elemnt.fadeOut();
                        }
                    });
                    var del = $document.find('#item-operation-wrap_' + index);
                    del.fadeIn();
                    del.css({'line-height': $document.find('.examine-list-item.item')[index].offsetHeight + 'px'});
                },
                // 查看
                viewRecord:function (item) {
                    vm.oldRecordToViewOrUpdate = angular.copy(item);
                    $scope.$on("patrol_course_check",function (event, data) {
                        if(data){
                            vm.findAllXCRecordList();
                        }
                    });
                    $ionicModal.fromTemplateUrl('templates/classpatrol/patrol_course_check.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("patrol_course_check", modal);
                        modal.show();
                    });
                },
                // 修改
                updateRecord:function (item) {
                    vm.oldRecordToViewOrUpdate = angular.copy(item);
                    vm.resourceType = 1;
                    $scope.$on("patrol_register_update",function (event, data) {
                        if(data){
                            vm.findAllXCRecordList();
                        }
                    });
                    $ionicModal.fromTemplateUrl('templates/classpatrol/patrol_register_update.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("patrol_register_update", modal);
                        modal.show();
                    });
                },
                // 删除
                deleteRecord:function (item) {
                    $ionicPopup.confirm({
                        title: '提示',
                        template: '确认要删除吗?',
                        cancelText: '取消',
                        okText: '确认'
                    }).then(function (res) {
                        if (res) {
                            $http.post(basePath+"/deleteXCManage.htm",{ids:[item.id]}).success(function (data) {
                                if(data.status == 0){
                                    ynuiNotification.success({msg: "删除成功！"});
                                    vm.fadeOutAll();
                                    vm.changeRoomType(vm.queryVO.roomType);
                                }else {
                                    ynuiNotification.error({msg: data.message});
                                }
                            });
                        }
                    });
                },
                // 收起 操作按钮
                fadeOutAll:function () {
                    angular.forEach(vm.xcRecordListVOList,function (info, oldIndex) {
                        var elemnt = $document.find('#item-operation-wrap_' + oldIndex);
                        elemnt.fadeOut();
                    });
                }
            };

            // 返回 重新获取列表数据
            $scope.$on("patrolList", function (event,data) {
                if(data){
                    vm.findAllXCRecordList();
                }
            });



            function init() {
                vm.getCurrentDate();
            }

            init();


        }])

    /**
     *批量添加
     */
    .controller("batchRegisterController", ['$scope', '$http', '$ionicModal', '$ionicLoading',
        '$ionicScrollDelegate', '$location', "ynuiNotification", "storageService","modalManager", "$state",
        function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location,
                  ynuiNotification, storageService,modalManager, $state) {

            // 路由信息
            var basePath = originBaseUrl + "/third/xcMobileNewRecord";
            var vm = $scope.vm = {
                // 查询对象
                queryVO:{
                    // 教室类型 1=全部教室 2=异常教室
                    roomType:2,
                    dateTimes:null,
                    termId:null,
                    week:null,
                    day:null,
                    knob:null,
                    timeType:null
                },
                // 所有节次
                knobList:[],
                // 显示巡课教室
                allRoomList:[],
                // 修改楼栋
                updateRoom:null,
                // 获取当前日期
                getCurrentDate:function () {
                    $http.post(basePath + "/getCurrentDate.htm").success(function (data) {
                        if(data.status == 0){
                            vm.queryVO.dateTimes = data.result;
                            vm.getRegister(vm.queryVO.dateTimes);
                        }
                    });
                },
                // 根据选择的日期查询出巡课的时间
                getRegister:function(date, fun) {
                    // 清除教室
                    vm.allRoomList = [];
                    $http.get(originBaseUrl + "/third/xcMobileRecord/queryCheckInfoByDate.htm",
                        {params:{
                            date:date,
                            flag:true,
                            _timestamp:new Date().getTime()
                        }}).success(function (data) {
                        if (data.status == 0) {
                            var xcMobileStartVO = angular.copy(data.result);
                            vm.queryVO.dateTimes = xcMobileStartVO.checkDate;
                            vm.queryVO.checkDateStrs = xcMobileStartVO.checkDateStrs;
                            vm.queryVO.termId = xcMobileStartVO.checkPlatformSysTermId;
                            vm.queryVO.timeType = xcMobileStartVO.timeType;
                            vm.queryVO.knob = xcMobileStartVO.knob;
                            vm.queryVO.day = xcMobileStartVO.day;
                            vm.queryVO.week = xcMobileStartVO.week;
                            var hasDefault = false;
                            angular.forEach(xcMobileStartVO.xcMobileKnobVOs, function (item) {
                                item.select = false;
                                if (item.knob == xcMobileStartVO.knob && item.timeType == xcMobileStartVO.timeType) {
                                    item.select = true;
                                    hasDefault = true;
                                }
                            });
                            if (!hasDefault) {
                                var item = xcMobileStartVO.xcMobileKnobVOs[0];
                                if (item) {
                                    item.select = true;
                                    vm.queryVO.knob = item.knob;
                                    vm.queryVO.timeType = item.timeType;
                                }
                            }

                            vm.knobList = xcMobileStartVO.xcMobileKnobVOs;
                        } else {
                            ynuiNotification.error({msg: data.message});
                        }
                        if (fun) {
                            fun();
                        }
                    }).error(function () {
                        ynuiNotification.error({msg: "获取信息失败！"});
                        if (fun) {
                            fun();
                        }
                    });
                },
                // 选择日期
                selectDateTime:function (data) {
                    vm.getRegister(data, function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                // 选择节次
                selectKnob:function (item) {
                    // 清楚教室
                    vm.allRoomList = [];
                    var date = vm.queryVO.dateTimes+" "+item.startHourMinute;
                    vm.checkNowTime(date).then(function (info) {
                        if(info.data && info.data.status == 0 && info.data.result){
                            ynuiNotification.error({msg: "不能登记未上课的节次！"});
                        }else {
                            angular.forEach(vm.knobList, function (knob) {
                                knob.select = false;
                            });
                            item.select = true;
                            vm.queryVO.knob = item.knob;
                            vm.queryVO.timeType = item.timeType;
                        }
                    });

                },
                // 取消
                backList:function () {
                    // modalManager.remove("batch_register");
                    $state.go('classPatrolIndexByTea');
                },
                // 选择有课教室
                chooseRoom:function () {
                    // 判断日期、节次
                    if(vm.queryVO.dateTimes && vm.queryVO.day && vm.queryVO.knob &&
                        vm.queryVO.termId && vm.queryVO.timeType && vm.queryVO.week){
                        $ionicModal.fromTemplateUrl('templates/classpatrol/select_floor.html', {
                            scope: $scope,
                            animation: 'slide-in-up'
                        }).then(function (modal) {
                            modalManager.put("patrol_register_batch_room", modal);
                            modal.show();
                        });
                    }else {
                        ynuiNotification.error({msg: "请选择巡课日期/巡课节次！"});
                        return false;
                    }
                },
                // 已选教室数量
                getAllRoomNum:function () {
                    var num = 0;
                    if(vm.allRoomList && vm.allRoomList.length > 0){
                        angular.forEach(vm.allRoomList,function (val) {
                            angular.forEach(val.buildScheduleVOList,function (value) {
                                angular.forEach(value.classRoomList,function () {
                                    num++;
                                });
                            });
                        });
                    }
                    return num;
                },
                // 修改
                updateBuildRoom:function (info) {
                    vm.updateRoom = info;
                    $ionicModal.fromTemplateUrl('templates/classpatrol/modification.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("patrol_register_batch_modification", modal);
                        modal.show();
                    });
                },
                // 禁用提交按钮
                getDisabled:function () {
                    if(!(vm.allRoomList && vm.allRoomList.length > 0)){
                        return "disabled"
                    }
                },
                // 提交
                submit:function () {
                    var roomIds = [];
                    angular.forEach(vm.allRoomList,function (val) {
                        angular.forEach(val.buildScheduleVOList,function (value) {
                            angular.forEach(value.classRoomList,function (room) {
                                roomIds.push(room.id);
                            });
                        });
                    });
                    var params = {
                        dateTimes:vm.queryVO.dateTimes,
                        termId:vm.queryVO.termId,
                        week:vm.queryVO.week,
                        day:vm.queryVO.day,
                        knob:vm.queryVO.knob,
                        timeType:vm.queryVO.timeType,
                        registration:2,
                        roomIds:roomIds
                    };
                    $http.post(basePath + "/addBatchManageInfo.htm",params).success(function (data) {
                        if(data.status == 0){
                            ynuiNotification.success({msg: "提交成功！"});
                            $scope.$emit("patrolList", true);
                            $state.go('classPatrolIndexByTea');
                        }else {
                            ynuiNotification.error({msg: data.message});
                            return false;
                        }
                    });
                },
                // 节次验证
                checkNowTime:function (date) {
                    return $http.post(originBaseUrl + "/third/xcMobileRecord/checkNowTime.htm",{date:date});
                }

            };

            // 选择有课教室
            $scope.$on("patrol_register_batch_room",function (event, data) {
                if(data && data.length > 0){
                    vm.allRoomList = data;
                    angular.forEach(vm.allRoomList,function (val) {
                        var num = 0;
                        angular.forEach(val.buildScheduleVOList,function (value) {
                            var nameList = [];
                            angular.forEach(value.classRoomList,function (room) {
                                num++;
                                nameList.push(room.name);
                            });
                            value.nameList = nameList.join("、")+";";
                        });
                        val.roomNum = num;
                    });
                }
            });

            // 修改教室
            $scope.$on("patrol_register_batch_modification",function (event, data) {
                if(data){
                    var newRoomList = [];
                    angular.forEach(vm.allRoomList,function (val) {
                        var num = 0;
                        if(val.name === data.name){
                            val = angular.copy(data);
                        }
                        angular.forEach(val.buildScheduleVOList,function (value) {
                            var nameList = [];
                            angular.forEach(value.classRoomList,function (room) {
                                num++;
                                nameList.push(room.name);
                            });
                            value.nameList = nameList.join("、")+";";
                        });
                        val.roomNum = num;
                        if(num > 0){
                            newRoomList.push(val);
                        }
                    });
                    vm.allRoomList = angular.copy(newRoomList);
                }
            });

            function init() {
                vm.getCurrentDate();
            }

            init();


        }])

    /**
     *批量添加 选择有课教室
     */
    .controller("selectFloorController", ['$scope', '$http', '$ionicModal',
        "ynuiNotification", "modalManager","storageService", "ynNavigator",
        function ($scope, $http, $ionicModal, ynuiNotification, modalManager,storageService, ynNavigator) {

            // 路由信息
            var basePath = originBaseUrl + "/third/xcMobileNewRecord";
            var oldQueryVO = $scope.vm.queryVO;
            var vm = $scope.vm = {
                // 查询对象
                queryVO:oldQueryVO,
                // 查询下拉值
                dropDown:{
                    xcAreas:[{id:null,name:"全部"}],
                    areaStatus:[{id:null,name:"全部"}],
                    classRoomPurpose:[{id:null,name:"全部"}],
                    platformSysTeachBuildList:[{id:null,name:"全部"}]
                },
                // 下拉展示
                showInfo:{
                    areaFlag:false,
                    classRoomPurposeFlag:false,
                    areaStatusFlag:false,
                    roomTypeFlag:false
                },
                area:{},
                areaStatus:{},
                classRoomPurpose:{},
                roomType:{},
                // 列表数据
                xcRoomList:[],
                // 全选所有楼栋 默认否
                allBuildFlag:false,
                // 选择 教室分组
                chooseArea:function (info) {
                    vm.showInfo.areaFlag = !vm.showInfo.areaFlag;
                    if(info){
                        vm.area = info;
                    }
                },
                // 状态
                chooseAreaStatus:function (info) {
                    vm.showInfo.areaStatusFlag = !vm.showInfo.areaStatusFlag;
                    if(info){
                        vm.areaStatus = info;
                    }
                },
                // 用途
                chooseClassRoomPurpose:function (info) {
                    vm.showInfo.classRoomPurposeFlag = !vm.showInfo.classRoomPurposeFlag;
                    if(info){
                        vm.classRoomPurpose = info;
                    }
                },
                // 类型
                chooseRoomType:function (info) {
                    vm.showInfo.roomTypeFlag = !vm.showInfo.roomTypeFlag;
                    if(info){
                        vm.roomType = info;
                    }
                },
                // 取消
                backList:function () {
                    modalManager.remove("patrol_register_batch_room");
                },
                // 选择有课教室
                chooseBuildRoom:function () {
                    var params = {
                        dateTimes:oldQueryVO.dateTimes,
                        termId:oldQueryVO.termId,
                        week:oldQueryVO.week,
                        day:oldQueryVO.day,
                        knob:oldQueryVO.knob,
                        timeType:oldQueryVO.timeType,
                        status:vm.areaStatus.id,
                        purpose:vm.classRoomPurpose.id,
                        roomGroupId:vm.area.id,
                        type:vm.roomType.id
                    };
                    $http.post(basePath + "/findBuildScheduleByAll.htm",params).success(function (data) {
                        if(data.status == 0){

                            vm.xcRoomList = angular.copy(data.result);
                            angular.forEach(vm.xcRoomList,function (value,index) {
                                // 默认展开第一个
                                value.up = index == 0;
                                // 默认不选中
                                value.allSelectedFlag = false;
                                angular.forEach(value.buildScheduleVOList,function (val) {
                                    val.selectedFlag = false;
                                });
                            });
                        }
                    });
                },
                // 选择有课教室 下拉值
                findDropDownList:function (org) {
                    $http.post(basePath + "/findDropDownList.htm").success(function (data) {
                        if(data.status == 0){
                            vm.dropDown.xcAreas = vm.dropDown.xcAreas.concat(angular.copy(data.result.xcAreas));
                            vm.dropDown.areaStatus = vm.dropDown.areaStatus.concat(angular.copy(data.result.areaStatus));
                            vm.dropDown.classRoomPurpose = vm.dropDown.classRoomPurpose.concat(angular.copy(data.result.classRoomPurpose));
                            vm.dropDown.platformSysTeachBuildList = vm.dropDown.platformSysTeachBuildList.concat(angular.copy(data.result.classRoomType));
                            // 默认最后一次选择
                            var areaOld = storageService.getItemNoDel("area");
                            if(areaOld){
                                vm.area = areaOld;
                            }else {
                                if(vm.dropDown.xcAreas && vm.dropDown.xcAreas.length > 1){
                                    var flag = true;
                                    angular.forEach(vm.dropDown.xcAreas,function (val) {
                                        if(val.userNumber == org && flag){
                                            flag = false;
                                            vm.area = val;
                                        }
                                    });
                                }
                            }

                        }
                    });

                },
                // 登记人所在行政线-机构  所属校区
                findUserOrg:function () {
                    $http.post(basePath + "/findUserOrg.htm").success(function (data) {
                        if(data.status == 0){
                            vm.findDropDownList(data.result);
                            vm.chooseBuildRoom();
                        }
                    });
                },
                // 筛选条件选中状态
                getAreaClass:function (info,type) {
                    if(type == 1){
                        if(info.id == vm.area.id){
                            return "icon ion-checkmark-circled calm";
                        }else {
                            return "";
                        }
                    }else if(type == 2){
                        if(info.id == vm.areaStatus.id){
                            return "icon ion-checkmark-circled calm";
                        }else {
                            return "";
                        }
                    }else if(type == 3){
                        if(info.id == vm.classRoomPurpose.id){
                            return "icon ion-checkmark-circled calm";
                        }else {
                            return "";
                        }
                    }else if(type == 4){
                        if(info.id == vm.roomType.id){
                            return "icon ion-checkmark-circled calm";
                        }else {
                            return "";
                        }
                    }

                },
                // 节次类型显示
                getShowTimeType:function () {
                    var str = " ";
                    if(oldQueryVO.timeType == 1){
                        str = " 上午 ";
                    }else if(oldQueryVO.timeType == 2){
                        str = " 下午 ";
                    }else if(oldQueryVO.timeType == 3){
                        str = " 晚上 ";
                    }

                    return str;
                },
                // 节次显示
                getShowKnob:function () {
                    return "第"+oldQueryVO.knob+"节";
                },
                // 选择楼层
                selectedItem:function (item,list,info) {
                    item.selectedFlag = !item.selectedFlag;
                    var num = 0;
                    angular.forEach(list,function (val) {
                        if(val.selectedFlag){
                            num++;
                        }
                    });
                    // 全选楼栋下所有的有课教室
                    if(num == list.length){
                        info.allSelectedFlag = true;
                    }else {
                        info.allSelectedFlag = false;
                    }

                    //全选所有楼栋所有教室
                    var allNum = 0;
                    angular.forEach(vm.xcRoomList,function (val) {
                        if(val.allSelectedFlag){
                            allNum++;
                        }
                    });
                    if(allNum == vm.xcRoomList.length){
                        vm.allBuildFlag = true;
                    }else {
                        vm.allBuildFlag = false;
                    }
                },
                // 选择楼栋下所有教室
                chooseAllSelected:function (info) {
                    info.allSelectedFlag = !info.allSelectedFlag;
                    angular.forEach(info.buildScheduleVOList,function (value) {
                        value.selectedFlag = info.allSelectedFlag;
                    });
                    //全选所有楼栋所有教室
                    var allNum = 0;
                    angular.forEach(vm.xcRoomList,function (val) {
                        if(val.allSelectedFlag){
                            allNum++;
                        }
                    });
                    if(allNum == vm.xcRoomList.length){
                        vm.allBuildFlag = true;
                    }else {
                        vm.allBuildFlag = false;
                    }
                },
                // 全选所有楼栋
                chooseAllBuildRoom:function () {
                    vm.allBuildFlag = !vm.allBuildFlag;
                    angular.forEach(vm.xcRoomList,function (val) {
                        val.allSelectedFlag = vm.allBuildFlag;
                        angular.forEach(val.buildScheduleVOList,function (value) {
                            value.selectedFlag = vm.allBuildFlag;
                        });
                    });
                },
                // 已选教室数量
                allRoomNum:function () {
                    var num = 0;
                    if(vm.xcRoomList && vm.xcRoomList.length > 0){
                        angular.forEach(vm.xcRoomList,function (val) {
                            angular.forEach(val.buildScheduleVOList,function (value) {
                                if(value.selectedFlag){
                                    num += value.classRoomNum;
                                }
                            });
                        })
                    }
                    return num;
                },
                // 获取教室展开 样式
                getUpOrDownClass:function (info) {
                    if(info.up){
                        return {'ion-chevron-up': true};
                    }else {
                        return {'ion-chevron-down': true};
                    }
                },
                //教室展开
                clickUpOrDown:function (info) {
                    info.up = !info.up;
                    angular.forEach(vm.xcRoomList,function (val) {
                        if(info.name !== val.name){
                            val.up = false;
                        }
                    });
                },
                // 完成选择
                submit:function () {
                    var roomList = [];
                    if(vm.xcRoomList && vm.xcRoomList.length > 0){

                        angular.forEach(vm.xcRoomList,function (val) {
                            var buildScheduleVOList = [];
                            angular.forEach(val.buildScheduleVOList,function (value) {
                                if(value.selectedFlag){
                                    buildScheduleVOList.push(value);
                                }
                            });
                            if(buildScheduleVOList.length > 0){
                                roomList.push({name:val.name,buildScheduleVOList:buildScheduleVOList});
                            }
                        });
                        if(roomList.length == 0){
                            ynuiNotification.error({msg: "请至少选择一个教室！"});
                            return false;
                        }else {
                            $scope.$emit("patrol_register_batch_room", roomList);
                            modalManager.remove("patrol_register_batch_room");
                            // ynNavigator.pop();
                        }
                    }else {
                        ynuiNotification.error({msg: "请至少选择一个教室！"});
                        return false;
                    }

                },
                submitSearch:function () {
                    storageService.setItem("area",vm.area);
                    vm.chooseBuildRoom();
                    $scope.rightModalClickHide();
                }

            };


            function init() {
                vm.findUserOrg();
            }

            init();

            /*模态*/
            $ionicModal.fromTemplateUrl('student.html',{
                scope:$scope,
                animation:'slide-in-left'
            }).then(function(modal){
                $scope.modal = modal;
            });
            $scope.rightModalClick = function() {
                $scope.modal.show();
            };
            $scope.rightModalClickHide = function() {
                $scope.modal.hide();
            };
        }])

    /**
     *移除部分教室
     */
    .controller("modificationController", ['$scope', '$http', '$ionicModal',
        "ynuiNotification", "modalManager",
        function ($scope, $http, $ionicModal, ynuiNotification, modalManager) {

            var updateRoom = angular.copy($scope.vm.updateRoom);
            var vm = $scope.vm = {
                // 列表数据
                updateRoom:updateRoom,
                //移除数量
                removeRoomNum:0,
                // 取消
                backList:function () {
                    modalManager.remove("patrol_register_batch_modification");
                },
                // 移除
                removeRoom:function (item) {
                    vm.removeRoomNum++;
                    var floors = [];
                    angular.forEach(vm.updateRoom.buildScheduleVOList,function (val) {
                        var list = [];
                        angular.forEach(val.classRoomList,function (value) {
                            if(item.id !== value.id){
                                list.push(value);
                            }
                        });
                        val.classRoomList = angular.copy(list);
                        val.classRoomNum = list.length;
                        if(list.length > 0){
                            floors.push(val);
                        }
                    });
                    vm.updateRoom.buildScheduleVOList = angular.copy(floors);
                },
                clickFloor:function (info) {
                    info.up = !info.up;
                    angular.forEach(vm.updateRoom.buildScheduleVOList,function (val) {
                        if(info.floorName !== val.floorName){
                            val.up = false;
                        }
                    });
                },
                // 展开样式
                getClass:function (info) {
                    if(info.up){
                        return {'ion-chevron-up':true};
                    }else {
                        return {'ion-chevron-down':true};
                    }

                },
                // 完成选择
                submit:function () {
                    $scope.$emit("patrol_register_batch_modification", vm.updateRoom);
                    modalManager.remove("patrol_register_batch_modification");
                }

            };


            function init() {
                // 默认展开第一个
                if(vm.updateRoom && vm.updateRoom.buildScheduleVOList.length > 0){
                    angular.forEach(vm.updateRoom.buildScheduleVOList,function (val,index) {
                        val.up = index == 0;
                    });
                }
            }

            init();
        }])


    /**
     *查看巡课记录
     */
    .controller("patrolCourseCheckController", ['$scope', '$http', '$ionicModal',
        "ynuiNotification", "modalManager","$ionicPopup",
        function ($scope, $http, $ionicModal, ynuiNotification, modalManager,$ionicPopup) {
            var basePath = originBaseUrl + "/third/xcMobileNewRecord";
            var oldRecordToViewOrUpdate = angular.copy($scope.vm.oldRecordToViewOrUpdate);
            var vm = $scope.vm = {
                // 列表数据
                viewRoom:null,
                // 显示字段
                colList:[],
                allShowCustomField:[],
                showInfo:{
                    attendanceFlag:false,
                    postFlag:false,
                    photoFlag:false,
                    remarkFlag:false,
                    stuFlag:false,
                    oneFlag:false,
                    twoFlag:false,
                    threeFlag:false,
                    fourFlag:false
                },
                tkInfo:{
                    list:[],
                    showInfo:null
                },
                // 获取查看数据
                findXCManage:function () {
                    $http.post(basePath+"/findXCManage.htm",{id:oldRecordToViewOrUpdate.id}).
                    success(function (data) {
                        if(data.status == 0){
                            vm.viewRoom = angular.copy(data.result);
                            if(vm.viewRoom.fsIdList && vm.viewRoom.fsIdList.length > 0){
                                var list = [];
                                angular.forEach(vm.viewRoom.fsIdList,function (val) {
                                    list.push(originBaseUrl + '/third/file/download.htm?fileId='+val);
                                });
                                vm.viewRoom.fsIdList = list;
                            }
                            vm.findTkglConfig();
                            vm.findAllShowCustomField();
                        }
                    });
                },
                // 取消
                backList:function () {
                    $scope.$emit("patrol_course_check",true);
                    modalManager.remove("patrol_course_check");
                },
                // 删除
                deleteRecord:function () {
                    $ionicPopup.confirm({
                        title: '提示',
                        template: '确认要删除吗?',
                        cancelText: '取消',
                        okText: '确认'
                    }).then(function (res) {
                        if (res) {
                            $http.post(basePath+"/deleteXCManage.htm",{ids:[oldRecordToViewOrUpdate.id]}).success(function (data) {
                                if(data.status == 0){
                                    ynuiNotification.success({msg: "删除成功！"});
                                    vm.submit();
                                }else {
                                    ynuiNotification.error({msg: data.message});
                                }
                            });
                        }
                    });
                },
                // 展开样式
                getClass:function (info) {
                    if(info.up){
                        return {'ion-chevron-up':true};
                    }else {
                        return {'ion-chevron-down':true};
                    }

                },
                // 完成选择
                submit:function () {
                    $scope.$emit("patrolList", true);
                    modalManager.remove("patrol_course_check");
                },
                // 修改
                updateViewRoom:function () {
                    vm.resourceType = 2;
                    vm.oldRecordToViewOrUpdate = oldRecordToViewOrUpdate;
                    $scope.$on("patrol_register_update_fromview",function (event, data) {
                        if(data){
                            vm.oldRecordToViewOrUpdate = data;
                            init();
                        }
                    });
                    $ionicModal.fromTemplateUrl('templates/classpatrol/patrol_register_update.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("patrol_register_update_fromview", modal);
                        modal.show();
                    });
                },
                // 获取听课管理配置信息
                findTkglConfig:function() {
                    $http.post(originBaseUrl + "/third/xcMobileRecord/findTkglConfig.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.isNeedRegisterReport = data.result.isNeedRegisterReport;
                            if(vm.isNeedRegisterReport){
                                vm.findTkTeacherAndUserDutyList();
                            }
                        }
                    });
                },
                // 获取某节课某个地点的听课人到岗情况
                findTkTeacherAndUserDutyList:function() {
                    var searchInfo = {
                        classRoomId:vm.viewRoom.platformSysClassRoomVO.id,
                        termId:vm.viewRoom.termId,
                        week:vm.viewRoom.week,
                        day:vm.viewRoom.day,
                        timeType:vm.viewRoom.timeType,
                        knob:vm.viewRoom.knob
                    };
                    $http.post(originBaseUrl + "/third/xcMobileRecord/findTkTeacherAndUserDutyList.htm",searchInfo).success(function (data) {
                        if (data.status === 0) {
                            vm.tkInfo.list = angular.copy(data.result);
                            if(vm.tkInfo.list.length > 0){
                                // 听课人+到岗情况值
                                var nameList = [];
                                angular.forEach(vm.tkInfo.list,function (value) {
                                    value.userId = value.tkUserId;
                                    if(value.remarks){
                                        value.remarks = ("，" + value.remarks);
                                    }else {
                                        value.remarks = "";
                                    }
                                    if(value.listenStatus == 0){
                                        nameList.push(value.tkUserName+"：未去听课"+value.remarks);
                                    }else {
                                        nameList.push(value.tkUserName+"：在听课"+value.remarks);
                                    }

                                });
                                vm.tkInfo.showInfo = nameList.join("；");
                            }else {
                                vm.tkInfo.showInfo = "";
                            }
                        }
                    });
                },
                // 显示字段
                getAllOptions:function () {
                    $http.get(originBaseUrl + "/third/xcMobileRecord/getAllOptions.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.colList = angular.copy(data.result);
                            angular.forEach(data.result,function (info) {
                                if(info.itemName === '教师考勤情况'){
                                    vm.showInfo.attendanceFlag = true;
                                }
                                if(info.itemName === '教师到岗情况'){
                                    vm.showInfo.postFlag = true;
                                }
                                if(info.itemName === '巡课照片'){
                                    vm.showInfo.photoFlag = true;
                                }
                                if(info.itemName === '备注'){
                                    vm.showInfo.remarkFlag = true;
                                }
                                if(info.itemName === '应到人数'){
                                    vm.showInfo.oneFlag = true;
                                    vm.showInfo.stuFlag = true;
                                }
                                if(info.itemName === '请假人数'){
                                    vm.showInfo.twoFlag = true;
                                    vm.showInfo.stuFlag = true;
                                }
                                if(info.itemName === '未到人数'){
                                    vm.showInfo.threeFlag = true;
                                    vm.showInfo.stuFlag = true;
                                }
                                if(info.itemName === '实到人数'){
                                    vm.showInfo.fourFlag = true;
                                    vm.showInfo.stuFlag = true;
                                }
                            });


                        }
                    });
                },
                // 自定义显示字段
                findAllShowCustomField:function () {
                    $http.get(basePath + "/findAllShowCustomField.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.allShowCustomField = angular.copy(data.result);
                            angular.forEach(vm.viewRoom.xcMobileCustomFieldVOs,function (val) {
                                angular.forEach(vm.allShowCustomField,function (value) {
                                    if(val.id == value.id){
                                        value.value = val.value;
                                    }
                                });
                            });
                        }
                    });
                },
                getShowClass:function (info, type) {
                    if(type == 1 && info.chooseStatus != 1){
                        return "label-orange"
                    }else if(type == 2 && info.postInfo != 1){
                        return "label-orange"
                    }
                },
                getShowAttendance:function (info,type) {
                    var str = "";
                    if(type == 1){
                        switch (info.chooseStatus){
                            case "1":str = "按时到";break;
                            case "2":str = "迟到";break;
                            case "3":str = "未到";break;
                            case "4":str = "早退";break;
                        }
                    }else if (type == 2){
                        switch (info.postInfo){
                            case 1:str = "在岗";break;
                            case 2:str = "不在岗";break;
                        }
                    }
                    return str;
                },
                /**
                 * 预览照片
                 * @param photo
                 */
                previewPhoto: function (photo) {

                    var cordovaFileOpen = cordova.plugins.disusered.open;
                    cordovaFileOpen(
                        photo,
                        // 预览成功回调事件
                        function () {
                        },
                        /**
                         * 预览出错回调事件
                         * @param code
                         */
                        function (code) {
                            var template = code === 1 ? '未能在手机已安装APP中找到可预览此文件的程序' : '预览时发生了未知错误 #' + code;
                            $ionicPopup.alert({
                                title: '文件预览提示',
                                template: template
                            });
                        }
                    );
                }

            };


            function init() {
                vm.findXCManage();
                vm.getAllOptions();
            }

            init();
        }])


    /**
     *  巡课登记
     */
    .controller("patrolRegisterController", ['$scope', '$http', '$ionicModal', '$ionicLoading',
        '$ionicScrollDelegate', '$location', "ynuiNotification", "storageService", "modalManager", '$state', '$stateParams',
        function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location,
                  ynuiNotification, storageService, modalManager, $state, $stateParams) {

            // 路由信息
            var basePath = originBaseUrl + "/third/xcMobileRecord";
            console.log($stateParams.oldVm);
            // 获取来源
            var oldVm = angular.fromJson($stateParams.oldVm);

            // 教室方式
            var showClassTypeOld = storageService.getItemNoDel("showClassTypeVO");
            if(!showClassTypeOld){
                showClassTypeOld = {
                    classType:1,//默认登记方式：按班级固定教室选
                    classTypeName:'按班级固定教室选'
                };
            }
            // 教室分组
            var classRoomOld = storageService.getItemNoDel("classRoom");
            if(!classRoomOld){
                classRoomOld = {areaGroupOld:null};
            }
            var vm = $scope.vm = {
                scanRoomId:oldVm.scanRoomId,
                sourceType:oldVm.sourceType,
                // 巡课的时间
                xcMobileStartVO:null,
                // 登记方式 初始
                showClassTypeVO :showClassTypeOld,
                // 巡课教室
                classRoom:{
                    areaGroupOld:classRoomOld.areaGroupOld,
                    room:null,
                    num:0
                },
                // 上课(带班)教师
                teacher:{
                    list:[],
                    // 默认 全校教职工
                    teacherType:1,
                    teaShowInfo:null
                },
                // 上课课程
                course:{
                    info:null,
                    courseShowInfo:null
                },
                // 巡课班级
                teachClass : {
                    list:[],
                    teachClassShowInfo:null
                },
                // 巡课人
                checkTeacher:{
                    userId:null,
                    showName:null
                },
                // 巡课人
                checkOldTeacher:{
                    userId:null,
                    showName:null
                },
                clickMobile:function (info) {
                    ynuiNotification.error({msg: info.name+"在系统中没有设置手机号，不能拨号！"});
                },
                //下一步
                nextStep:function () {
                    if(!isNotBlank(vm.xcMobileStartVO.checkDateStrs)){
                        notifyError("请选择巡课日期！");
                        return false;
                    }
                    if(!isNotBlank(vm.xcMobileStartVO.knob)){
                        notifyError("请选择巡课节次！");
                        return false;
                    }
                    if (!isNotBlank(vm.classRoom.room.id)) {
                        notifyError("请选择巡课教室！");
                        return false;
                    }
                    if (!(vm.teacher && vm.teacher.list.length > 0)) {
                        notifyError("请选择上课[带班]教师！");
                        return false;
                    }
                    if (!isNotBlank(vm.checkTeacher.userId)) {
                        notifyError("请选择巡课人！");
                        return false;
                    }
                    // 缓存 登记方式
                    storageService.setItem("showClassTypeVO",vm.showClassTypeVO);
                    // 不清空巡课日期、节次，同时选中巡课教室分组的下一个教室， 如果没有分组，则显示“请选择教室”
                    $scope.$on("patrol_register_more",function (event, data) {
                        if(data && vm.classRoom.areaGroupOld && vm.classRoom.areaGroupOld.id){
                            getSelectInitialClassRoom(vm.classRoom.areaGroupOld.id,true,true);
                        }else {
                            // 清空 教室、班级、课程、教师
                            vm.classRoom.num = 0;
                            vm.classRoom.room = null;
                            vm.teachClass.list = [];
                            vm.teachClass.teachClassShowInfo = null;
                            vm.course.courseShowInfo = null;
                            vm.course.info = null;
                            vm.teacher.list = [];
                            vm.teacher.teaShowInfo = null;
                            vm.checkTeacher = angular.copy(vm.checkOldTeacher);
                        }
                    });

                    $state.go('patrol_register_more', {oldVm: angular.toJson(vm)});
                    // $ionicModal.fromTemplateUrl('templates/classpatrol/patrol_register_more.html', {
                    //     scope: $scope,
                    //     animation: 'slide-in-up'
                    // }).then(function (modal) {
                    //     modalManager.put("patrol_register_more", modal);
                    //     modal.show();
                    // });
                },
                // 取消
                backList:function () {
                    $scope.$emit("single_register",true);
                    modalManager.remove("single_register");
                },
                // 获取当前日期
                getCurrentDate:function () {
                    $http.post(basePath + "/getCurrentUser.htm").success(function (data) {
                        if(data.status == 0){
                            var info = data.result;
                            vm.checkTeacher.userId = info.userId;
                            vm.checkTeacher.showName = info.showName;
                            vm.checkOldTeacher = angular.copy(vm.checkTeacher);
                            vm.getRegister(info.date,null,true);
                        }
                    });
                },
                // 根据选择的日期查询出巡课的时间 课程节次
                getRegister:function(date, fun,flag) {
                    // 清空教室、上课教师、课程、班级
                    // 扫一扫 教室不改变
                    if(vm.scanRoomId && vm.sourceType == 1){

                    }else if(!flag){
                        vm.classRoom.room = null;
                        vm.classRoom.num = 0;
                    }
                    vm.teacher.list = [];
                    vm.teacher.teaShowInfo = null;
                    vm.course.info = null;
                    vm.course.courseShowInfo = null;
                    vm.teachClass.list = [];
                    vm.teachClass.teachClassShowInfo = null;
                    $http.get(basePath + "/queryCheckInfoByDate.htm",
                        {params:{
                            date:date,
                            flag:true,
                            _timestamp:new Date().getTime()
                        }}).success(function (data) {
                        if (data.status == 0) {
                            vm.xcMobileStartVO = data.result;
                            if (vm.xcMobileStartVO) {
                                var hasDefault = false;
                                angular.forEach(vm.xcMobileStartVO.xcMobileKnobVOs, function (item) {
                                    item.select = false;
                                    if (item.knob == vm.xcMobileStartVO.knob && item.timeType == vm.xcMobileStartVO.timeType) {
                                        item.select = true;
                                        hasDefault = true;
                                    }
                                });
                                if (!hasDefault) {
                                    var item = vm.xcMobileStartVO.xcMobileKnobVOs[0];
                                    if (item) {
                                        item.select = true;
                                        vm.xcMobileStartVO.knob = item.knob;
                                        vm.xcMobileStartVO.timeType = item.timeType;
                                    }
                                }

                                // 扫一扫 教室不改变
                                if(vm.scanRoomId && vm.sourceType == 1 && flag != true){
                                    getSelect(true);
                                }else if(flag){
                                    // 扫一扫
                                    if(oldVm.scanRoomId){
                                        getSelect(true);
                                    }else {
                                        // 重新获取默认值
                                        if(vm.classRoom.areaGroupOld){
                                            getSelectInitialClassRoom(vm.classRoom.areaGroupOld.id,true);
                                        }else {
                                            getSelectInitialClassRoom(null,true);
                                        }
                                    }
                                }else if(!date){
                                    // 单个添加
                                    if(vm.classRoom.areaGroupOld && vm.classRoom.areaGroupOld.id){
                                        // 获取 默认教室，退出应用后再进入应用默认上一次登记分组内的下一个教室
                                        var selectInitRoom = storageService.getItemNoDel("classRoom");
                                        if(selectInitRoom){
                                            $http.get(basePath + "/quertAllClassRoomByGroup.htm?",
                                                {params:{
                                                    roomGroupId:vm.classRoom.areaGroupOld.id,
                                                    name:"",
                                                    registrationMethod:vm.showClassTypeVO.classType,
                                                    termId:vm.xcMobileStartVO.checkPlatformSysTermId,
                                                    timeType:vm.xcMobileStartVO.timeType,
                                                    knob:vm.xcMobileStartVO.knob,
                                                    day:vm.xcMobileStartVO.day,
                                                    week:vm.xcMobileStartVO.week,
                                                    _timestamp:new Date().getTime()
                                                }}).success(function (data) {

                                                if(data.result && data.result.length > 0){
                                                    var currentIndex = -1;
                                                    angular.forEach(data.result,function (selectRoom,index) {
                                                        if(selectRoom.id == selectInitRoom.id){
                                                            currentIndex = index;
                                                        }
                                                    });

                                                    if(currentIndex > -1){
                                                        vm.classRoom.room = selectInitRoom;
                                                        getSelect();
                                                    }
                                                }

                                            });
                                        }else {
                                            getSelectInitialClassRoom(vm.classRoom.areaGroupOld.id,false);
                                        }

                                    }

                                }else {
                                    // 重新获取默认值
                                    if(vm.classRoom.areaGroupOld){
                                        getSelectInitialClassRoom(vm.classRoom.areaGroupOld.id,true);
                                    }else {
                                        getSelectInitialClassRoom(null,true);
                                    }
                                }


                            }
                        } else {
                            notifyError(data.message);
                        }
                        if (fun) {
                            fun();
                        }
                    }).error(function () {
                        notifyError("获取信息失败");
                        if (fun) {
                            fun();
                        }
                    });
                },
                // 切换登记方式
                changeClassType:function(type) {
                    vm.showClassTypeVO.classType = type;
                    switch (type){
                        case 1:
                            vm.showClassTypeVO.classTypeName = '按班级固定教室选';
                            break;
                        case 2:
                            vm.showClassTypeVO.classTypeName = '按课表教室选';
                            break;
                        case 3:
                            vm.showClassTypeVO.classTypeName = '从全校教室选';
                            break;
                        default:break;
                    }
                    storageService.setItem("showClassTypeVO",vm.showClassTypeVO);
                    // 重新获取默认值
                    getSelectInitialClassRoom(vm.classRoom.areaGroupOld ? vm.classRoom.areaGroupOld.id:null,true);
                },
                // 获取已巡课次数
                getPatrolNum:function(classRoomId) {
                    $http.get(basePath+"/getPatrolNum.htm",
                        {params:{classRoomId:classRoomId,date:vm.xcMobileStartVO.checkDate}}).
                    success(function (data) {
                        vm.classRoom.num = data.result;
                    });
                },
                // 选中节次
                selectKnob : function (item) {
                    var date = vm.xcMobileStartVO.checkDate+" "+item.startHourMinute;
                    vm.checkNowTime(date).then(function (info) {
                        if(info.data && info.data.status == 0 && info.data.result){
                            notifyError("不能登记未上课的节次！");
                        }else {
                            angular.forEach(vm.xcMobileStartVO.xcMobileKnobVOs, function (knob) {
                                knob.select = false;
                            });
                            item.select = true;
                            vm.xcMobileStartVO.knob = item.knob;
                            vm.xcMobileStartVO.timeType = item.timeType;

                            vm.teacher.list = [];
                            vm.teacher.teaShowInfo = null;
                            vm.course.info = null;
                            vm.course.courseShowInfo = null;
                            vm.teachClass.list = [];
                            vm.teachClass.teachClassShowInfo = null;
                            // 扫一扫 教室不改变
                            if(vm.scanRoomId && vm.sourceType == 1){
                                getSelect(true);
                            }else {
                                // 重新获取默认值
                                getSelectInitialClassRoom(vm.classRoom.areaGroupOld ? vm.classRoom.areaGroupOld.id:null,true);
                                // 清空教室、上课教师、课程、班级
                                vm.classRoom.room = null;
                                vm.classRoom.num = 0;
                            }

                        }
                    });

                },
                // 选择班级
                selectTeachClass :function () {
                    if(vm.showClassTypeVO.classType === 1){
                        //下拉值为选择的教室作为固定教室的行政班关联的教学行政班
                        if(!vm.classRoom.room){
                            notifyError("请选择巡课教室！");
                            return false;
                        }
                    }
                    // 选择班级后
                    $scope.$on("choose_grade",function (event, data) {
                        if(data && data.length > 0){
                            var list = [],nameList = [], ids = [];
                            angular.forEach(data,function (val) {
                                list.push(val);
                                nameList.push(val.name);
                                ids.push(val.id);
                            });
                            vm.teachClass.list = list;
                            vm.teachClass.teachClassShowInfo = nameList.join(",");
                            // 固定教室、没有课程 情况 需要获取班主任
                            if(vm.showClassTypeVO.classType == 1 && !(vm.course && vm.course.info)){
                                queryClassTeacher(ids);
                            }
                        }else {
                            vm.teachClass.list = [];
                            vm.teachClass.teachClassShowInfo = null;
                        }
                    });

                    $ionicModal.fromTemplateUrl('templates/classpatrol/choose_grade.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("choose_grade", modal);
                        modal.show();
                    });
                },
                // 选择教室
                selectClassRoom : function () {
                    // 选择节次在课表中所有已安排的教室
                    if(vm.showClassTypeVO.classType === 2){
                        if(!vm.xcMobileStartVO.checkDateStrs){
                            notifyError("请选择巡查日期！");
                            return false;
                        }
                    }

                    // 回填
                    $scope.$on("choose_classroom",function (event, room,info) {
                        vm.classRoom.room = room;
                        if(info.id){
                            vm.classRoom.areaGroupOld = {id:info.id,groupName:info.groupName};
                        }else {
                            vm.classRoom.areaGroupOld = null;
                        }
                        // 获取已巡课次数
                        vm.getPatrolNum(room.id);
                        storageService.setItem("classRoom",vm.classRoom);
                        //
                        getSelect();
                    });

                    $ionicModal.fromTemplateUrl('templates/classpatrol/choose_classroom.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("choose_classroom", modal);
                        modal.show();
                    });

                },
                // 重新选择巡课日期
                selectDateTime: function (data) {
                    vm.getRegister(data, function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                // 获取 默认老师类型
                findDefaultTeachType:function () {
                    var classIdList = [];
                    angular.forEach(vm.teachClass.list,function (va) {
                        classIdList.push(va.id);
                    });
                    var params = {
                        termId:vm.xcMobileStartVO.checkPlatformSysTermId,
                        type:vm.xcMobileStartVO.timeType,
                        knob:vm.xcMobileStartVO.knob,
                        date:vm.xcMobileStartVO.day,
                        week:vm.xcMobileStartVO.week,
                        classRoomId:vm.classRoom.room.id,
                        selectedClassList:classIdList,
                        flag:true
                    };
                    return $http.post(basePath+"/findDefaultTeachType.htm",params);

                },
                // 选择巡查的教师
                selectPatrollTeacher: function (type) {
                    if(type == 1){
                        // 获取 默认老师类型
                        if(vm.classRoom.room){

                            vm.findDefaultTeachType().then(function (data) {
                                if(data.status == 200 && data.data.result){
                                    vm.teacher.teacherType = 2;
                                }else {
                                    vm.teacher.teacherType = 1;
                                }
                                $scope.$on('choose_patroller', function (event,teacher) {
                                    var list = [],nameList = [];
                                    angular.forEach(teacher.selectTeacher,function (val) {
                                        list.push(val);
                                        if(val.name === val.alien || !val.alien){
                                            nameList.push(angular.copy(val.name));
                                        }else {
                                            nameList.push(angular.copy(val.name+"("+val.alien+")"));
                                        }
                                    });
                                    vm.teacher.teacherType = teacher.teacherType;
                                    vm.teacher.list = list;
                                    vm.teacher.teaShowInfo = nameList.join(",");
                                });
                                // 上课老师
                                $ionicModal.fromTemplateUrl('templates/classpatrol/choose_patroller.html', {
                                    scope: $scope,
                                    animation: 'slide-in-up'
                                }).then(function (modal) {
                                    modalManager.put("choose_patroller", modal);
                                    modal.show();
                                });
                            });
                        }else {
                            vm.teacher.teacherType = 1;
                            $scope.$on('choose_patroller', function (event,teacher) {
                                var list = [],nameList = [];
                                angular.forEach(teacher.selectTeacher,function (val) {
                                    list.push(val);
                                    if(val.name === val.alien || !val.alien){
                                        nameList.push(angular.copy(val.name));
                                    }else {
                                        nameList.push(angular.copy(val.name+"("+val.alien+")"));
                                    }
                                });
                                vm.teacher.list = list;
                                vm.teacher.teacherType = teacher.teacherType;
                                vm.teacher.teaShowInfo = nameList.join(",");
                            });
                            // 上课老师
                            $ionicModal.fromTemplateUrl('templates/classpatrol/choose_patroller.html', {
                                scope: $scope,
                                animation: 'slide-in-up'
                            }).then(function (modal) {
                                modalManager.put("choose_patroller", modal);
                                modal.show();
                            });
                        }




                    }else {
                        $scope.$on('choose_teacher', function (event,teacher) {
                            if(teacher.name === teacher.alien || !teacher.alien){
                                vm.checkTeacher.showName = angular.copy(teacher.name);
                            }else {
                                vm.checkTeacher.showName = angular.copy(teacher.name+"("+teacher.alien+")");
                            }
                            vm.checkTeacher.userId = angular.copy(teacher.userId);
                        });
                        // 巡课人
                        $ionicModal.fromTemplateUrl('templates/classpatrol/choose_teacher.html', {
                            scope: $scope,
                            animation: 'slide-in-up'
                        }).then(function (modal) {
                            modalManager.put("choose_teacher", modal);
                            modal.show();
                        });
                    }
                },
                // 选择课程
                selectCourse:function () {
                    // 【选择的巡课日期+选择的对应节次+选中的巡课班级上课的所有课程（显示“课程名称+课程号”）】+自习课（自习课排第一个）
                    if(vm.showClassTypeVO.classType === 1){
                        if(!vm.xcMobileStartVO.checkDateStrs){
                            notifyError("请选择巡查日期！");
                            return false;
                        }
                    }else if(vm.showClassTypeVO.classType === 2){
                        //“自习课”+【选择的巡课日期+选择的对应教室+选择的对应节次上课的课程】
                        if(!vm.xcMobileStartVO.checkDateStrs){
                            notifyError("请选择巡查日期！");
                            return false;
                        }
                        if (!vm.classRoom.room) {
                            notifyError("请选择巡查的教室！");
                            return false;
                        }

                    }


                    // 选择课程后
                    $scope.$on("choose_courses",function (event, data) {
                        if(data){
                            vm.course.info = data;
                            vm.course.courseShowInfo = data.courseName;
                        }else {
                            vm.course.info = null;
                            vm.course.courseShowInfo = null;
                        }
                    });

                    $ionicModal.fromTemplateUrl('templates/classpatrol/choose_courses.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("choose_courses", modal);
                        modal.show();
                    });

                },
                // 节次验证
                checkNowTime:function (date) {
                    return $http.post(basePath + "/checkNowTime.htm",{date:date});
                }


            };


            function init() {
                if(oldVm.scanRoomId){
                    vm.classRoom.room = {
                        id:oldVm.scanRoomId.id,
                        buildName:oldVm.scanRoomId.userNumber,
                        name:oldVm.scanRoomId.name
                    };
                    vm.showClassTypeVO.classType = 5;
                }
                vm.getCurrentDate();
            }

            init();



            function getSelect(flag) {
                vm.xcMobileStartVO.classRoomId = vm.classRoom.room?vm.classRoom.room.id:null;
                vm.teachClass.list = [];
                vm.teachClass.teachClassShowInfo = null;
                if(flag){
                    // 扫一扫 处理 获取默认班级
                    queryDefaultTeaAdminClass(vm.xcMobileStartVO.classRoomId,5);
                }else
                if(vm.showClassTypeVO.classType === 1 || vm.showClassTypeVO.classType === 2){
                    // 获取默认班级
                    queryDefaultTeaAdminClass(vm.xcMobileStartVO.classRoomId,vm.showClassTypeVO.classType);
                }else {
                    // 获取 老师、课程
                    findSelectPKTeachTeacherAndCourse(vm.xcMobileStartVO.classRoomId,vm.showClassTypeVO.classType);
                }
                // 获取已巡课次数
                vm.getPatrolNum(vm.xcMobileStartVO.classRoomId);
            }

            function getSelectInitialClassRoom(groupId,flag,isBack) {
                var params = {
                    roomGroupId:groupId,
                    name:"",
                    registrationMethod:vm.showClassTypeVO.classType,
                    termId:vm.xcMobileStartVO.checkPlatformSysTermId,
                    timeType:vm.xcMobileStartVO.timeType,
                    knob:vm.xcMobileStartVO.knob,
                    day:vm.xcMobileStartVO.day,
                    week:vm.xcMobileStartVO.week,
                    _timestamp:new Date().getTime()
                };
                $http.post(basePath + "/quertAllClassRoomByGroup.htm?",params).success(function (data) {
                    if(data.result && data.result.length > 0){
                        // 提交继续、获取分组 默认下一个教室
                        if(isBack){
                            var oldIndex = null;
                            angular.forEach(data.result,function (ro,index) {
                                if(vm.classRoom.room && vm.classRoom.room.id == ro.id){
                                    oldIndex = index;
                                }
                            });
                            if(oldIndex == null){
                                vm.classRoom.room = data.result[0];
                            }else if((oldIndex+1) == data.result.length){
                                vm.classRoom.room = data.result[0];
                            }else {
                                vm.classRoom.room = data.result[(oldIndex+1)];
                            }
                            getSelect();
                        }else {
                            vm.classRoom.room = data.result[0];
                            getSelect();
                        }

                    }
                });

            }

            // 字符串处理
            function isNotBlank(str) {
                var test = /\S+/;
                if (null == str) {
                    return false;
                }
                if (test.test(str)) {
                    return true;
                }
                return false;
            }

            /**
             * 报错工具
             * @param message
             */
            var notifyError = function (message) {
                if (message == null || message == "") {
                    message = "获取数据失败";
                }
                ynuiNotification.error({msg: message});
            };


            /**
             * 获取班级 （默认值）
             */
            function queryDefaultTeaAdminClass(classRoomId,registrationMethod) {
                var searchInfo = {
                    classType:registrationMethod,
                    classRoomId:classRoomId,
                    termId:vm.xcMobileStartVO.checkPlatformSysTermId,
                    week:vm.xcMobileStartVO.week,
                    day:vm.xcMobileStartVO.day,
                    timeType:vm.xcMobileStartVO.timeType,
                    knob:vm.xcMobileStartVO.knob
                };

                $http.post(basePath + "/findSelectClass.htm",searchInfo).success(function (data) {
                    if (data.status === 0) {
                        if(registrationMethod != 3){
                            vm.teachClass.list = angular.copy(data.result);
                            if(vm.teachClass.list && vm.teachClass.list.length > 0){
                                var nameList = [];
                                angular.forEach(vm.teachClass.list,function (value) {
                                    nameList.push(value.name);
                                });
                                vm.teachClass.teachClassShowInfo = nameList.join(",");
                            }
                            if(registrationMethod == 5){
                                // 扫一扫 处理
                                if(vm.teachClass.list && vm.teachClass.list.length > 0){
                                    // 获取 老师、课程
                                    findSelectPKTeachTeacherAndCourse(classRoomId,registrationMethod);
                                }
                            }else {
                                // 获取 老师、课程
                                findSelectPKTeachTeacherAndCourse(classRoomId,registrationMethod);
                            }

                        }
                    }
                });
            }

            // 获取班主任
            function queryClassTeacher(list) {
                if(list && list.length > 0){
                    $http.post(basePath + "/queryClassTeacher.htm" ,
                        {
                            pageSize:100,
                            pageNumber:0,
                            type:3,
                            classIds:list,
                            useDomain:false,
                            _timestamp:new Date().getTime()
                        }
                    ).success(function (data) {
                        if (data.status == 0) {
                            var arr = data.result ? data.result.content : [];
                            if (arr.length > 0) {
                                var list = [],nameList = [];
                                angular.forEach(arr,function (val) {
                                    list.push(val);
                                    if(val.name === val.alien || !val.alien){
                                        nameList.push(angular.copy(val.name));
                                    }else {
                                        nameList.push(angular.copy(val.name+"("+val.alien+")"));
                                    }
                                });
                                vm.teacher.list = list;
                                vm.teacher.teacherType = 2;
                                vm.teacher.teaShowInfo = nameList.join(",");
                            }
                        }

                    });
                }else {
                    vm.teacher.list = [];
                    vm.teacher.teacherType = 2;
                    vm.teacher.teaShowInfo = null;
                }

            }

            /**
             * 获取老师、课程
             */
            function findSelectPKTeachTeacherAndCourse(classRoomId,classType) {
                // 清空 课程、上课教师
                vm.teacher.list = [];
                vm.teacher.teaShowInfo = null;
                vm.course.info = null;
                vm.course.courseShowInfo = null;

                var classIdList = [];
                angular.forEach(vm.teachClass.list,function (va) {
                    classIdList.push(va.id);
                });
                if(classType == 1 && classIdList.length == 0){
                    return false;
                }
                var params = {
                    termId:vm.xcMobileStartVO.checkPlatformSysTermId,
                    week:vm.xcMobileStartVO.week,
                    day:vm.xcMobileStartVO.day,
                    timeType:vm.xcMobileStartVO.timeType,
                    knob:vm.xcMobileStartVO.knob,
                    classRoomId: classRoomId,
                    classType:classType,
                    classIds:classIdList
                };
                $http.post(basePath + "/findSelectPKTeachTeacherAndCourse.htm", params).success(function (data) {
                    if (data.status == 0) {
                        var allData = data.result;
                        // 课程
                        var courseList = allData.kcCourseVOList;
                        if(courseList && courseList.length > 0){
                            vm.course.info = {
                                courseId:courseList[0].id,
                                courseName:courseList[0].name
                            };
                            vm.course.courseShowInfo = courseList[0].name;
                        }else {
                            vm.course.info = {
                                courseId:"-1",
                                courseName:"自习课"
                            };
                            vm.course.courseShowInfo = "自习课";
                        }

                        // 上课老师
                        var platformSysUserVOList = allData.platformSysUserVOList;
                        if(platformSysUserVOList && platformSysUserVOList.length > 0){
                            var allTea = [],nameList = [];
                            angular.forEach(platformSysUserVOList,function (user) {
                                allTea.push({
                                    userId:user.id,
                                    alien:user.name,
                                    mobile:user.mobile,
                                    name:user.name
                                });
                                nameList.push(user.name);
                            });
                            vm.teacher.list = allTea;
                            vm.teacher.teaShowInfo = nameList.join(",");

                        }else{
                            // 按班级固定教室选时，选择了班级，“上课教师”未默认所选班级的班主任
                            if(classType == 1 && (vm.teachClass.list && vm.teachClass.list.length > 0) && !(allData.kcCourseVOList && allData.kcCourseVOList.length > 0)){
                                var ids = [];
                                angular.forEach(vm.teachClass.list,function (c) {
                                    ids.push(c.id);
                                });
                                queryClassTeacher(ids);
                            }
                        }


                    }
                });

            }



        }])


    /**
     *  修改巡课登记
     */
    .controller("patrolRegisterUpdateController", ['$scope', '$http', '$ionicModal', '$ionicLoading',
        '$ionicScrollDelegate', '$location', "ynuiNotification", "storageService", "modalManager",
        function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location,
                  ynuiNotification, storageService, modalManager) {

            // 路由信息
            var basePath = originBaseUrl + "/third/xcMobileRecord";
            // 获取来源
            var oldVm = angular.copy($scope.vm);
            var oldRecordToViewOrUpdate = angular.copy(oldVm.oldRecordToViewOrUpdate);

            var vm = $scope.vm = {
                oldRecordToViewOrUpdate:oldRecordToViewOrUpdate,
                showClassTypeVO:{
                    classType:3
                },
                // 1=列表，2=查看
                resourceType:oldVm.resourceType,
                // 巡课的时间
                xcMobileStartVO:null,
                xcMobileDetailInfoVO:{xcMobileCustomFieldVOs:[],xcMobileStartVO:null},
                viewRoom:null,
                // 巡课教室
                classRoom:{
                    room:null,
                    num:0
                },
                // 上课(带班)教师
                teacher:{
                    list:[],
                    // 默认 全校教职工
                    teacherType:1,
                    teaShowInfo:null
                },
                // 上课课程
                course:{
                    info:null,
                    courseShowInfo:null
                },
                // 巡课班级
                teachClass : {
                    list:[],
                    teachClassShowInfo:null
                },
                // 巡课人
                checkTeacher:{
                    userId:null,
                    showName:null
                },
                // 巡课人
                checkOldTeacher:{
                    userId:null,
                    showName:null
                },
                showInfo:{
                    attendanceFlag:false,
                    postFlag : false,
                    photoFlag : false,
                    remarkFlag : false,
                    oneFlag : false,
                    twoFlag : false,
                    threeFlag: false,
                    fourkFlag : false
                },
                clickMobile:function (info) {
                    ynuiNotification.error({msg: info.name+"在系统中没有设置手机号，不能拨号！"});
                },
                //下一步
                nextStep:function () {
                    if(!isNotBlank(vm.xcMobileStartVO.checkDateStrs)){
                        notifyError("请选择巡课日期！");
                        return false;
                    }
                    if(!isNotBlank(vm.xcMobileStartVO.knob)){
                        notifyError("请选择巡课节次！");
                        return false;
                    }
                    if (!isNotBlank(vm.classRoom.room.id)) {
                        notifyError("请选择巡课教室！");
                        return false;
                    }
                    if (!(vm.teacher && vm.teacher.list.length > 0)) {
                        notifyError("请选择上课[带班]教师！");
                        return false;
                    }
                    if (!isNotBlank(vm.checkTeacher.userId)) {
                        notifyError("请选择巡课人！");
                        return false;
                    }
                    $ionicModal.fromTemplateUrl('templates/classpatrol/patrol_register_more_update.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("patrol_register_more_update", modal);
                        modal.show();
                    });
                },
                // 取消
                backList:function () {
                    if(vm.resourceType == 1){
                        $scope.$emit("patrol_register_update",true);
                        modalManager.remove("patrol_register_update");
                    }else {
                        $scope.$emit("patrol_register_update_fromview",oldRecordToViewOrUpdate);
                        modalManager.remove("patrol_register_update_fromview");
                    }

                },
                // 默认光标
                setFocus:function() {
                    if(vm.showInfo.oneFlag){
                        $("#shouldNumberEdit").focus();
                    }else if(vm.showInfo.twoFlag){
                        $("#leaveNumberEdit").focus();
                    }else if(vm.showInfo.threeFlag){
                        $("#absenteeismNumberEdit").focus();
                    }else if(vm.showInfo.fourFlag){
                        $("#toNumberEdit").focus();
                    }
                },
                // 根据选择的日期查询出巡课的时间 课程节次
                getRegister:function(date) {
                    $http.get(basePath + "/queryCheckInfoByDate.htm",
                        {params:{
                            date:date,
                            _timestamp:new Date().getTime()
                        }}).success(function (data) {
                        if (data.status == 0) {
                            vm.xcMobileStartVO = angular.copy(data.result);
                            if (vm.xcMobileStartVO) {
                                angular.forEach(vm.xcMobileStartVO.xcMobileKnobVOs, function (item) {
                                    if(item.knob == vm.viewRoom.knob && item.timeType == vm.viewRoom.timeType){
                                        item.select = true;
                                        vm.xcMobileStartVO.knob = item.knob;
                                        vm.xcMobileStartVO.timeType = item.timeType;
                                    }else {
                                        item.select = false;
                                    }
                                });
                                vm.xcMobileDetailInfoVO.xcMobileStartVO = vm.xcMobileStartVO;
                            }
                        } else {
                            notifyError(data.message);
                        }

                    }).error(function () {
                        notifyError("获取信息失败");
                    });
                },
                // 获取数据
                findXCManageToUpdate:function () {
                    $http.post(originBaseUrl+"/third/xcMobileNewRecord/findXCManageToUpdate.htm",{id:oldRecordToViewOrUpdate.id}).
                    success(function (data) {
                        if(data.status == 0){
                            vm.viewRoom = angular.copy(data.result);
                            // 教室
                            if(vm.viewRoom.platformSysClassRoomVO){
                                vm.classRoom.room = vm.viewRoom.platformSysClassRoomVO;
                                vm.getPatrolNum(vm.classRoom.room.id);
                            }
                            // 上课老师
                            if(vm.viewRoom.teacherDropList && vm.viewRoom.teacherDropList.length > 0){
                                var nameList = [],list = [];
                                angular.forEach(vm.viewRoom.teacherDropList,function (val) {
                                    nameList.push(val.name);
                                    list.push({
                                        id:val.id,
                                        userId:val.id,
                                        name:val.name,
                                        mobile:val.userNumber,
                                        alien:val.name
                                    });
                                });
                                vm.teacher.teaShowInfo = nameList.join(",");
                                vm.teacher.teacherType = vm.viewRoom.teacherType;
                                vm.teacher.list = list;
                            }
                            // 课程
                            if(vm.viewRoom.courseDropList && vm.viewRoom.courseDropList.length > 0){
                                vm.course.info = {
                                    courseId:vm.viewRoom.courseDropList[0].id,
                                    courseName:vm.viewRoom.courseDropList[0].name
                                };
                                vm.course.courseShowInfo = vm.viewRoom.courseDropList[0].name;
                            }
                            // 班级
                            if(vm.viewRoom.classDropList && vm.viewRoom.classDropList.length > 0){
                                var nameList = [];
                                angular.forEach(vm.viewRoom.classDropList,function (val) {
                                    nameList.push(val.name);
                                });
                                vm.teachClass.list = vm.viewRoom.classDropList;
                                vm.teachClass.teachClassShowInfo = nameList.join(",");
                            }
                            // 巡课人
                            vm.checkTeacher.userId = vm.viewRoom.tourClassUser;
                            vm.checkTeacher.showName = vm.viewRoom.tourClassUserName;

                            vm.getRegister(data.result.dateTimes);
                        }
                    });
                },
                // 自定义显示字段
                findAllShowCustomField:function () {
                    $http.get(originBaseUrl + "/third/xcMobileNewRecord/findAllShowCustomField.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.xcMobileDetailInfoVO.xcMobileCustomFieldVOs = angular.copy(data.result);
                            vm.findXCManageToUpdate();
                        }
                    });
                },
                // 获取固定字段 显示
                getAllOptions:function () {
                    $http.get(basePath + "/getAllOptions.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.colList = angular.copy(data.result);
                            angular.forEach(data.result,function (info) {
                                if(info.itemName === '教师考勤情况'){
                                    vm.showInfo.attendanceFlag = true;
                                }
                                if(info.itemName === '教师到岗情况'){
                                    vm.showInfo.postFlag = true;
                                }
                                if(info.itemName === '巡课照片'){
                                    vm.showInfo.photoFlag = true;
                                    //巡课照片
                                    vm.options = {};
                                    vm.initFiles = storageService.getItemNoDel("initFiles");
                                    if(vm.initFiles){

                                    }
                                }
                                if(info.itemName === '备注'){
                                    vm.showInfo.remarkFlag = true;
                                }
                                if(info.itemName === '应到人数'){
                                    vm.showInfo.oneFlag = true;
                                }
                                if(info.itemName === '请假人数'){
                                    vm.showInfo.twoFlag = true;
                                }
                                if(info.itemName === '未到人数'){
                                    vm.showInfo.threeFlag = true;
                                }
                                if(info.itemName === '实到人数'){
                                    vm.showInfo.fourFlag = true;
                                }
                            });
                            if(vm.showInfo.oneFlag || vm.showInfo.twoFlag || vm.showInfo.threeFlag || vm.showInfo.fourFlag){
                                setTimeout(function () {
                                    vm.setFocus();
                                },150);
                            }

                        }
                    });
                },
                // 获取已巡课次数
                getPatrolNum:function(classRoomId) {
                    $http.get(basePath+"/getPatrolNum.htm",
                        {params:{classRoomId:classRoomId,date:vm.viewRoom.dateTimes}}).
                    success(function (data) {
                        vm.classRoom.num = data.result;
                    });
                },
                // 选择班级
                selectTeachClass :function () {
                    // 选择班级后
                    vm.updateType = true;
                    $scope.$on("choose_grade_update",function (event, data) {
                        if(data && data.length > 0){
                            var list = [],nameList = [];
                            angular.forEach(data,function (val) {
                                list.push(val);
                                nameList.push(val.name);
                            });
                            vm.teachClass.list = list;
                            vm.teachClass.teachClassShowInfo = nameList.join(",");
                        }else {
                            vm.teachClass.list = [];
                            vm.teachClass.teachClassShowInfo = null;
                        }
                    });

                    $ionicModal.fromTemplateUrl('templates/classpatrol/choose_grade.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("choose_grade_update", modal);
                        modal.show();
                    });
                },
                // 重新选择巡课日期
                selectDateTime: function (data) {
                    vm.getRegister(data, function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                // 选择巡查的教师
                selectPatrollTeacher: function (type) {
                    if(type == 1){
                        // 没有选择班级 默认全校教职工
                        if(vm.teachClass.list && vm.teachClass.list.length > 0 && vm.teacher.teacherType == 2){
                            vm.teacher.teacherType = 2;
                        }else {
                            vm.teacher.teacherType = 1;
                        }
                        // 获取教师类型
                        $scope.$on('choose_patroller', function (event,teacher) {
                            var list = [],nameList = [];
                            angular.forEach(teacher.selectTeacher,function (val) {
                                list.push(val);
                                if(val.name === val.alien || !val.alien){
                                    nameList.push(angular.copy(val.name));
                                }else {
                                    nameList.push(angular.copy(val.name+"("+val.alien+")"));
                                }
                            });
                            vm.teacher.list = list;
                            vm.teacher.teacherType = teacher.teacherType;
                            vm.teacher.teaShowInfo = nameList.join(",");
                        });
                        // 上课老师
                        $ionicModal.fromTemplateUrl('templates/classpatrol/choose_patroller.html', {
                            scope: $scope,
                            animation: 'slide-in-up'
                        }).then(function (modal) {
                            modalManager.put("choose_patroller", modal);
                            modal.show();
                        });
                    }else {
                        $scope.$on('choose_teacher', function (event,teacher) {
                            if(teacher.name === teacher.alien  || !teacher.alien){
                                vm.checkTeacher.showName = angular.copy(teacher.name);
                            }else {
                                vm.checkTeacher.showName = angular.copy(teacher.name+"("+teacher.alien+")");
                            }
                            vm.checkTeacher.userId = angular.copy(teacher.userId);
                        });
                        // 巡课人
                        $ionicModal.fromTemplateUrl('templates/classpatrol/choose_teacher.html', {
                            scope: $scope,
                            animation: 'slide-in-up'
                        }).then(function (modal) {
                            modalManager.put("choose_teacher", modal);
                            modal.show();
                        });
                    }
                },
                // 选择课程
                selectCourse:function () {
                    // 【选择的巡课日期+选择的对应节次+选中的巡课班级上课的所有课程（显示“课程名称+课程号”）】+自习课（自习课排第一个）
                    if(vm.showClassTypeVO.classType === 1){
                        if(!vm.xcMobileStartVO.checkDateStrs){
                            notifyError("请选择巡查日期！");
                            return false;
                        }
                    }else if(vm.showClassTypeVO.classType === 2){
                        //“自习课”+【选择的巡课日期+选择的对应教室+选择的对应节次上课的课程】
                        if(!vm.xcMobileStartVO.checkDateStrs){
                            notifyError("请选择巡查日期！");
                            return false;
                        }
                        if (!vm.classRoom.room) {
                            notifyError("请选择巡查的教室！");
                            return false;
                        }

                    }


                    // 选择课程后
                    $scope.$on("choose_courses",function (event, data) {
                        if(data){
                            vm.course.info = data;
                            vm.course.courseShowInfo = data.courseName;
                        }else {
                            vm.course.info = null;
                            vm.course.courseShowInfo = null;
                        }
                    });

                    $ionicModal.fromTemplateUrl('templates/classpatrol/choose_courses.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("choose_courses", modal);
                        modal.show();
                    });

                }


            };


            function init() {
                vm.getAllOptions();
                vm.findAllShowCustomField();
            }

            init();



            function getSelect() {
                vm.xcMobileStartVO.classRoomId = vm.classRoom.room?vm.classRoom.room.id:null;
                if(vm.showClassTypeVO.classType === 1 || vm.showClassTypeVO.classType === 2){
                    vm.teachClass.list = [];
                    vm.teachClass.teachClassShowInfo = null;
                    // 获取默认班级
                    queryDefaultTeaAdminClass(vm.xcMobileStartVO.classRoomId,vm.showClassTypeVO.classType);
                }else {
                    // 获取 老师、课程
                    findSelectPKTeachTeacherAndCourse(vm.xcMobileStartVO.classRoomId,vm.showClassTypeVO.classType);
                }
                // 获取已巡课次数
                vm.getPatrolNum(vm.xcMobileStartVO.classRoomId);
            }

            function getSelectInitialClassRoom(groupId) {
                var params = {
                    roomGroupId:groupId,
                    name:"",
                    registrationMethod:vm.showClassTypeVO.classType,
                    termId:vm.xcMobileStartVO.checkPlatformSysTermId,
                    timeType:vm.xcMobileStartVO.timeType,
                    knob:vm.xcMobileStartVO.knob,
                    day:vm.xcMobileStartVO.day,
                    week:vm.xcMobileStartVO.week,
                    _timestamp:new Date().getTime()
                };
                $http.post(basePath + "/quertAllClassRoomByGroup.htm?",params).success(function (data) {
                    if(data.result && data.result.length > 0){
                        vm.classRoom.room = data.result[0];
                        getSelect();
                    }
                });

            }

            // 字符串处理
            function isNotBlank(str) {
                var test = /\S+/;
                if (null == str) {
                    return false;
                }
                if (test.test(str)) {
                    return true;
                }
                return false;
            }

            /**
             * 报错工具
             * @param message
             */
            var notifyError = function (message) {
                if (message == null || message == "") {
                    message = "获取数据失败";
                }
                ynuiNotification.error({msg: message});
            };


            /**
             * 获取班级 （默认值）
             */
            function queryDefaultTeaAdminClass(classRoomId,registrationMethod) {
                var searchInfo = {
                    classType:registrationMethod,
                    classRoomId:classRoomId,
                    termId:vm.xcMobileStartVO.checkPlatformSysTermId,
                    week:vm.xcMobileStartVO.week,
                    day:vm.xcMobileStartVO.day,
                    timeType:vm.xcMobileStartVO.timeType,
                    knob:vm.xcMobileStartVO.knob
                };

                $http.post(basePath + "/findSelectClass.htm",searchInfo).success(function (data) {
                    if (data.status === 0) {
                        if(registrationMethod != 3){
                            vm.teachClass.list = angular.copy(data.result);
                            if(vm.teachClass.list && vm.teachClass.list.length > 0){
                                var nameList = [];
                                angular.forEach(vm.teachClass.list,function (value) {
                                    nameList.push(value.name);
                                });
                                vm.teachClass.teachClassShowInfo = nameList.join(",");
                            }
                            // 获取 老师、课程
                            findSelectPKTeachTeacherAndCourse(classRoomId,registrationMethod);
                        }
                    }
                });
            }

            /**
             * 获取老师、课程
             */
            function findSelectPKTeachTeacherAndCourse(classRoomId,classType) {
                // 清空 课程、上课教师
                vm.teacher.list = [];
                vm.teacher.teaShowInfo = null;
                vm.course.info = null;
                vm.course.courseShowInfo = null;

                var classIdList = [];
                angular.forEach(vm.teachClass.list,function (va) {
                    classIdList.push(va.id);
                });
                if(classType == 1 && classIdList.length == 0){
                    return false;
                }
                var params = {
                    termId:vm.xcMobileStartVO.checkPlatformSysTermId,
                    week:vm.xcMobileStartVO.week,
                    day:vm.xcMobileStartVO.day,
                    timeType:vm.xcMobileStartVO.timeType,
                    knob:vm.xcMobileStartVO.knob,
                    classRoomId: classRoomId,
                    classType:classType,
                    classIds:classIdList
                };
                $http.post(basePath + "/findSelectPKTeachTeacherAndCourse.htm", params).success(function (data) {
                    if (data.status == 0) {
                        var allData = data.result;
                        // 课程
                        var courseList = allData.kcCourseVOList;
                        if(courseList && courseList.length > 0){
                            vm.course.info = {
                                courseId:courseList[0].id,
                                courseName:courseList[0].name
                            };
                            vm.course.courseShowInfo = courseList[0].name;
                        }else {
                            vm.course.info = {
                                courseId:"-1",
                                courseName:"自习课"
                            };
                            vm.course.courseShowInfo = "自习课";
                        }

                        // 上课老师
                        var platformSysUserVOList = allData.platformSysUserVOList;
                        if(platformSysUserVOList && platformSysUserVOList.length > 0){
                            var allTea = [],nameList = [];
                            angular.forEach(platformSysUserVOList,function (user) {
                                allTea.push({
                                    userId:user.id,
                                    mobile:user.mobile,
                                    alien:user.name,
                                    name:user.name
                                });
                                nameList.push(user.name);
                            });
                            vm.teacher.list = allTea;
                            vm.teacher.teaShowInfo = nameList.join(",");

                        }


                    }
                });

            }



        }])

    /**
     *选择巡课人
     */
    .controller("chooseTeacherController", ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate',
        '$location', "ynuiNotification","modalManager",
        function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location,
                  ynuiNotification,modalManager) {

            /**
             * 路由信息
             * @type {string}
             */
            var basePath = originBaseUrl + "/third/xcMobileRecord";


            var vm = $scope.vm = {
                teacher:null,
                condition : {
                    isQuery: false,
                    length: 0,
                    pageNumber: 0,
                    pageSize: 20,
                    name: "", //查询条件
                    title: "", //显示信息
                    character: ""// 字母
                },
                // 取消
                cancelTeacher :function () {
                    modalManager.remove("choose_teacher");
                },
                // 选择
                overSelect :function (teacher) {
                    $scope.$emit("choose_teacher",teacher);
                    modalManager.remove("choose_teacher");
                },
                //刷新数据
                doRefresh: function () {
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    vm.condition.name = "";
                    vm.teacherList = [];
                    vm.queryClassTeacher();
                },
                // 清楚查询条件
                clearCondition: function () {
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    vm.condition.name = "";
                    vm.teacherList = [];
                    vm.queryClassTeacher();
                },
                // 加载更多
                loadMore: function (flag) {
                    if (vm.condition.pageNumber >= vm.condition.totalPage) {
                        return false;
                    }
                    vm.condition.pageNumber = vm.condition.pageNumber + 1;
                    vm.queryClassTeacher(function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        // $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    },flag);
                },
                // 选择字母
                selectCharacter: function (char) {
                    vm.condition.character = char;
                    vm.teacherList = [];
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    vm.queryClassTeacher();
                },
                // 查询老师
                queryClassTeacher: function (fun,flag) {
                    vm.condition.isQuery = true;
                    $http.get(basePath + "/queryClassTeacher.htm" ,
                        {
                            params:{
                                value:(vm.condition.name ? vm.condition.name : ""),
                                pageSize:vm.condition.pageSize,
                                pageNumber:vm.condition.pageNumber,
                                character:(vm.condition.character ? vm.condition.character : ""),
                                type:1,
                                useDomain:false,
                                _timestamp:new Date().getTime()
                            }
                        }
                    ).success(function (data) {
                        if (data.status == 0) {
                            var arr = data.result ? data.result.content : [];
                            if (!data.result || arr.length == 0) {
                                vm.condition.title = "没有可选教师";
                                vm.condition.error = false;
                                vm.condition.more = false;
                                vm.teacherList = [];
                            }else{
                              if (!vm.teacherList || flag) {
                                  vm.teacherList = [];
                              }
                                vm.teacherList = vm.teacherList.concat(angular.copy(arr));
                                vm.condition.pageSize = data.result.size;
                                vm.condition.pageNumber = data.result.number;
                                vm.condition.itemSize = data.result.totalElements;
                                vm.condition.totalPage = data.result.totalPages;
                                vm.more = vm.condition && vm.teacherList.length < vm.condition.itemSize;
                            }
                        } else {
                            vm.condition.title = "获取教师失败";
                            vm.condition.error = true;
                        }
                        vm.condition.isQuery = false;
                        if (fun) {
                            fun();
                        }
                    }).error(function () {
                        vm.condition.title = "获取教师失败";
                        vm.condition.error = true;
                        vm.condition.isQuery = false;
                        if (fun) {
                            fun();
                        }
                    });
                },
                // 名称查询
                changeQueryName:function () {
                    $scope.setTime  = window.setTimeout(function(){
                        window.clearTimeout($scope.setTime);
                        vm.condition.pageNumber = 0;
                        vm.condition.pageSize = 20;
                        vm.queryClassTeacher(function () {
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                            $ionicScrollDelegate.scrollTop();
                            $ionicLoading.hide();
                        }, true);
                    },500);
                }

            };

            function init() {
                vm.queryClassTeacher();
            }

            init();

            $scope.$on('stateChangeSuccess', function () {
                vm.loadMore();
            });

        }])

    /***
     * 选择上课老师
     */
    .controller("teacherController", ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', '$location',
        "ynuiNotification","modalManager","$timeout",
        function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location,
                  ynuiNotification,modalManager,$timeout) {

            /**
             * 路由信息
             * @type {string}
             */
            var basePath = originBaseUrl + "/third/xcMobileRecord";

            var _items = angular.copy($scope.vm.teacher);
            var _itemClass = angular.copy($scope.vm.teachClass);
            var size = 0;
            if(_itemClass && _itemClass.length > 0){
                size = _itemClass.length;
            }
            var vm = $scope.vm = {
                isShowMoreCourse:false,
                classSize:size,
                selectTeacher:[],
                condition : {
                    isQuery: false,
                    length: 0,
                    pageNumber: 0,
                    teacherType: _items.teacherType,
                    pageSize: 20,
                    name: "", //查询条件
                    title: "", //显示信息
                    character: ""// 字母
                },
                teacherTypeList:[
                    {id:1,name:"全校教职工"},
                    {id:2,name:"班主任"}
                ],
                getTeacherTypeClass:function (info) {
                    if(info.id == vm.condition.teacherType){
                        return "active";
                    }
                },
                getTeacherType:function () {
                    if(vm.condition.teacherType == 2){
                        return "班主任";
                    }else {
                        return "全校教职工";
                    }
                },
                // 切换老师类型
                clickTeacherType:function (info) {
                    vm.condition.teacherType = info.id;
                    // 全校
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    vm.teacherList = [];
                    // 清空所选
                    vm.selectTeacher = [];
                    if(vm.condition.teacherType == 1){
                        vm.queryClassTeacher(null,1,true);
                    }else {
                        // 班主任
                        vm.queryClassTeacher(null,3,true);
                    }
                },
                // 取消
                cancelTeacher :function () {
                    modalManager.remove("choose_patroller");
                },
                //刷新数据
                doRefresh: function () {
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    vm.condition.name = "";
                    vm.teacherList = [];
                    if(vm.condition.teacherType == 1){
                        vm.queryClassTeacher(null,1);
                    }else {
                        // 班主任
                        vm.queryClassTeacher(null,3);
                    }
                },
                // 清楚查询条件
                clearCondition: function () {
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    vm.condition.name = "";
                    vm.teacherList = [];
                    if(vm.condition.teacherType == 1){
                        vm.queryClassTeacher(null,1);
                    }else {
                        // 班主任
                        vm.queryClassTeacher(null,3);
                    }
                },
                // 加载更多
                loadMore: function () {
                    if (vm.condition.pageNumber >= vm.condition.totalPage) {
                        return false;
                    }
                    vm.condition.pageNumber = vm.condition.pageNumber + 1;
                    vm.queryClassTeacher(function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                // 选择字母
                selectCharacter: function (char) {
                    vm.condition.character = char;
                    vm.teacherList = [];
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    if(vm.condition.teacherType == 1){
                        vm.queryClassTeacher(null,1);
                    }else {
                        // 班主任
                        vm.queryClassTeacher(null,3);
                    }
                },
                // 查询老师
                queryClassTeacher: function (fun,type,flag) {
                    vm.condition.isQuery = true;
                    var list = [];
                    angular.forEach(_itemClass.list,function (value) {
                        list.push(value.id);
                    });
                    $http.post(basePath + "/queryClassTeacher.htm" ,
                        {
                            value:(vm.condition.name ? vm.condition.name : ""),
                            pageSize:vm.condition.pageSize,
                            pageNumber:vm.condition.pageNumber,
                            character:(vm.condition.character ? vm.condition.character : ""),
                            type:type,
                            classIds:list,
                            useDomain:false,
                            _timestamp:new Date().getTime()
                        }
                    ).success(function (data) {
                        if (data.status == 0) {
                            var arr = data.result ? data.result.content : [];
                            if (!data.result || arr.length == 0) {
                                if(vm.classSize == 0 && vm.condition.teacherType == 2){
                                    vm.condition.title = "请先选择巡课班级！";
                                }else {
                                    vm.condition.title = "没有可选教师！";
                                }
                                vm.condition.error = false;
                                vm.condition.more = false;
                                vm.teacherList = [];
                            }else{
                                if(flag != true){
                                    if(_items && _items.list.length > 0){
                                        vm.selectTeacher =_items.list;
                                    }
                                }

                                angular.forEach(arr, function (item) {
                                    item.selected = false;
                                    if (vm.selectTeacher.length > 0) {
                                        angular.forEach(vm.selectTeacher,function (key) {
                                            if(key.userId == item.userId){
                                                item.selected = true;
                                            }
                                        });
                                    }
                                });
                                vm.teacherList = angular.copy(arr);
                                vm.condition.pageSize = data.result.size;
                                vm.condition.pageNumber = data.result.number;
                                vm.condition.itemSize = data.result.totalElements;
                                vm.condition.totalPage = data.result.totalPages;
                                vm.condition.error = false;
                                vm.more = vm.condition && vm.teacherList.length < vm.condition.itemSize;
                            }
                        } else {
                            vm.condition.title = "获取教师失败";
                            vm.condition.error = true;
                        }
                        $timeout(function () {
                            vm.condition.isQuery = false;
                        }, 1500);

                        if (fun) {
                            fun();
                        }
                    }).error(function () {
                        vm.condition.title = "获取教师失败";
                        vm.condition.error = true;
                        vm.condition.isQuery = false;
                        if (fun) {
                            fun();
                        }
                    });
                },
                // 名称查询
                changeQueryName:function () {
                    var setTime  = window.setTimeout(function(){
                        window.clearTimeout(setTime);
                        vm.condition.pageNumber = 0;
                        vm.condition.pageSize = 20;
                        vm.queryClassTeacher(function () {
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                            $ionicScrollDelegate.scrollTop();
                            $ionicLoading.hide();
                        });
                    },200);
                },
                // 完成
                overSelectTeachers:function () {
                    if(vm.selectTeacher.length == 0){
                        ynuiNotification.error({msg: "请选择教师！"});
                        return false;
                    }
                    var data = {
                        selectTeacher:vm.selectTeacher,
                        teacherType:vm.condition.teacherType
                    };
                    $scope.$emit('choose_patroller',data);
                    vm.cancelTeacher();
                },
                //多选
                chooseTeacher: function (tea) {
                    tea.selected = !tea.selected;
                    if(tea.selected){
                        vm.selectTeacher.unshift(tea);
                    }else {
                        if(vm.selectTeacher && vm.selectTeacher.length > 0){
                            var _index = null;
                            angular.forEach(vm.selectTeacher,function (val, index) {
                                if(tea.userId == val.userId){
                                    _index = index;
                                }
                            });
                            if(_index != null){
                                vm.selectTeacher.splice(_index,1);
                            }
                        }
                    }

                },
                // 删除选择的对象
                deleteSelectTeacher: function(index){
                    var item = vm.selectTeacher[index];
                    vm.selectTeacher.splice(index,1);
                    angular.forEach(vm.teacherList, function (teacher) {
                        if(teacher.userId == item.userId){
                            teacher.selected = false;
                        }
                    });
                },
                // 查看已选班级浮动框
                selectClass_view:function(){
                    vm.isShowMoreCourse = !vm.isShowMoreCourse;
                }

            };

            function init() {
                if(vm.condition.teacherType == 1){
                    vm.queryClassTeacher(null,1);
                }else {
                    // 班主任
                    vm.queryClassTeacher(null,3);
                }
            }

            init();



            $scope.$on('stateChangeSuccess', function () {
                $scope.loadMore();
            });


        }])

    /***
     * 选择听课老师
     */
    .controller("tkTeacherController", ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', '$location',
        "ynuiNotification","modalManager",
        function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location,
                  ynuiNotification,modalManager) {

            /**
             * 路由信息
             * @type {string}
             */
            var basePath = originBaseUrl + "/third/xcMobileRecord";

            var oldVm = angular.copy($scope.vm);

            var vm = $scope.vm = {
                isShowMoreCourse:false,
                selectTeacher:[],
                condition : {
                    isQuery: false,
                    length: 0,
                    pageNumber: 0,
                    pageSize: 20,
                    name: "", //查询条件
                    title: "", //显示信息
                    character: ""// 字母
                },
                // 取消
                cancelTeacher :function () {
                    modalManager.remove("choose_tkUser");
                },
                //刷新数据
                doRefresh: function () {
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    vm.condition.name = "";
                    vm.teacherList = [];
                    vm.queryClassTeacher();
                },
                // 清楚查询条件
                clearCondition: function () {
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    vm.condition.name = "";
                    vm.teacherList = [];
                    vm.queryClassTeacher();
                },
                // 加载更多
                loadMore: function () {
                    if (vm.condition.pageNumber >= vm.condition.totalPage) {
                        return false;
                    }
                    vm.condition.pageNumber = vm.condition.pageNumber + 1;
                    vm.queryClassTeacher(function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                // 选择字母
                selectCharacter: function (char) {
                    vm.condition.character = char;
                    vm.teacherList = [];
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    vm.queryClassTeacher();
                },
                // 查询老师
                queryClassTeacher: function (fun) {
                    vm.condition.isQuery = true;
                    $http.post(basePath + "/queryClassTeacher.htm" ,
                        {
                            value:(vm.condition.name ? vm.condition.name : ""),
                            pageSize:vm.condition.pageSize,
                            pageNumber:vm.condition.pageNumber,
                            character:(vm.condition.character ? vm.condition.character : ""),
                            type:1,
                            useDomain:false,
                            _timestamp:new Date().getTime()
                        }
                    ).success(function (data) {
                        if (data.status == 0) {
                            var arr = data.result ? data.result.content : [];
                            if (!data.result || arr.length == 0) {
                                vm.condition.title = "没有可选教师";
                                vm.condition.error = false;
                                vm.condition.more = false;
                                vm.teacherList = [];
                            }else{

                                angular.forEach(arr, function (item) {
                                    item.selected = false;
                                    if (vm.selectTeacher.length > 0) {
                                        angular.forEach(vm.selectTeacher,function (key) {
                                            if(key.userId == item.userId){
                                                item.selected = true;
                                                key.name = item.name;
                                                key.alien = item.alien;
                                            }
                                        });
                                    }
                                });
                                vm.teacherList = angular.copy(arr);
                                vm.condition.pageSize = data.result.size;
                                vm.condition.pageNumber = data.result.number;
                                vm.condition.itemSize = data.result.totalElements;
                                vm.condition.totalPage = data.result.totalPages;
                                vm.more = vm.condition && vm.teacherList.length < vm.condition.itemSize;
                            }
                        } else {
                            vm.condition.title = "获取教师失败";
                            vm.condition.error = true;
                        }
                        vm.condition.isQuery = false;
                        if (fun) {
                            fun();
                        }
                    }).error(function () {
                        vm.condition.title = "获取教师失败";
                        vm.condition.error = true;
                        vm.condition.isQuery = false;
                        if (fun) {
                            fun();
                        }
                    });
                },
                // 名称查询
                changeQueryName:function () {
                    var setTime  = window.setTimeout(function(){
                        window.clearTimeout(setTime);
                        vm.condition.pageNumber = 0;
                        vm.condition.pageSize = 20;
                        vm.queryClassTeacher(function () {
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                            $ionicScrollDelegate.scrollTop();
                            $ionicLoading.hide();
                        });
                    },200);
                },
                // 完成
                overSelectTeachers:function () {
                    if(vm.selectTeacher.length == 0){
                        ynuiNotification.error({msg: "请选择教师！"});
                        return false;
                    }
                    $scope.$emit('choose_tkUser',vm.selectTeacher);
                    vm.cancelTeacher();
                },
                //多选
                chooseTeacher: function (tea) {
                    if(vm.getDisabled(tea)){
                        return false;
                    }
                    tea.selected = !tea.selected;
                    if(tea.selected){
                        vm.selectTeacher.unshift(tea);
                    }else {
                        if(vm.selectTeacher && vm.selectTeacher.length > 0){
                            var _index = null;
                            angular.forEach(vm.selectTeacher,function (val, index) {
                                if(tea.userId == val.userId){
                                    _index = index;
                                }
                            });
                            if(_index != null){
                                vm.selectTeacher.splice(_index,1);
                            }
                        }
                    }

                },
                //
                getShowFlag:function (info) {
                    // 有任务的不能删除
                    var flag = true;
                    if(oldVm.tkUserInfo.list && oldVm.tkUserInfo.list){
                        angular.forEach(oldVm.tkUserInfo.list,function (val) {
                            if(val.userId == info.userId && val.source == 1){
                                flag = false;
                            }
                        });
                    }
                    return flag;
                },
                // 删除选择的对象
                deleteSelectTeacher: function(index){


                    var item = vm.selectTeacher[index];
                    vm.selectTeacher.splice(index,1);
                    angular.forEach(vm.teacherList, function (teacher) {
                        if(teacher.userId == item.userId){
                            teacher.selected = false;
                        }
                    });
                },
                // 查看已选班级浮动框
                selectClass_view:function(){
                    vm.isShowMoreCourse = !vm.isShowMoreCourse;
                },
                getDisabled:function (info) {
                    var flag = false;
                    if(oldVm.tkUserInfo.list && oldVm.tkUserInfo.list){
                        angular.forEach(oldVm.tkUserInfo.list,function (val) {
                            if(val.userId == info.userId && val.source == 1){
                                flag = true;
                            }
                        });
                    }
                    return flag;
                }

            };

            function init() {
                if(oldVm.tkUserInfo.list && oldVm.tkUserInfo.list){
                    //
                    var list = [];
                    angular.forEach(oldVm.tkUserInfo.list,function (val) {
                        list.push({
                            userId:val.tkUserId,
                            name:val.tkUserName,
                            alien:val.tkUserName
                        });
                    });
                    vm.selectTeacher = list;
                }
                vm.queryClassTeacher();
            }

            init();



        }])

    /**
     * 选择班级信息
     */
    .controller("classController", ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', '$location',
        "ynuiNotification", "modalManager",
        function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate,
                  $location, ynuiNotification, modalManager) {


            /**
             * 路由信息
             * @type {string}
             */
            var basePath = originBaseUrl + "/third/xcMobileRecord";

            var oldVm = angular.copy($scope.vm),_items = angular.copy($scope.vm.teachClass);

            var vm = $scope.vm = {
                isShowMoreCourse:false,
                gradeList:[],
                classList:[],
                selectClass:[],
                condition : {
                    isQuery: false,
                    pageNumber: 0,
                    pageSize: 20,
                    gradeId: "",
                    name: "",
                    selectedLength: 0,
                    title: ""
                },
                // 查询年级
                queryThreeGrade: function () {
                    vm.condition.isQuery = true;
                    vm.gradeList = [{
                        id: "", name: "不限"
                    }];
                    $http.get(basePath + "/queryAllGrade.htm" ,
                        {params:{_timestamp:new Date().getTime()}}).success(function (data) {
                        if (data.status == 0) {
                            vm.condition.error = false;
                            var arr = data.result;
                            if (arr.length > 0) {
                                angular.forEach(arr, function (grade) {
                                    vm.gradeList.push(grade);
                                });
                                vm.condition.gradeId = vm.gradeList[0].id;
                                vm.queryTeachClass(function () {
                                    $scope.$broadcast('scroll.infiniteScrollComplete');
                                    $ionicScrollDelegate.scrollTop();
                                    $ionicLoading.hide();
                                });
                            }
                        } else {
                            vm.condition.title = "获取班级失败";
                            vm.condition.error = true;
                            vm.condition.isQuery = false;
                        }
                    }).error(function () {
                        vm.condition.title = "获取班级失败";
                        vm.condition.error = true;
                        vm.condition.isQuery = false;
                    })
                },
                // 查询班级
                queryTeachClass: function (fun) {
                    vm.condition.isQuery = true;
                    var params = {
                        classType:oldVm.showClassTypeVO.classType,
                        classRoomId:oldVm.classRoom.room ? oldVm.classRoom.room.id :null,
                        gradeId:vm.condition.gradeId,
                        name:vm.condition.name,
                        pageSize:vm.condition.pageSize ,
                        pageNumber: vm.condition.pageNumber ,
                        _timestamp:new Date().getTime()
                    };
                    $http.post(basePath + "/queryPKClassByPage.htm",params).success(function (data) {
                        if (data.status == 0) {
                            var arr = data.result.content;
                            if (arr.length == 0) {
                                vm.condition.title = "没有可选班级";
                                vm.condition.error = false;
                                vm.classList = [];
                            } else {
                                vm.condition.error = false;
                                if (_items && _items.list.length > 0) {
                                    vm.selectClass = _items.list;
                                }
                                angular.forEach(arr,function(cla){
                                    angular.forEach(vm.selectClass, function (c) {
                                        if (c.id == cla.id) {
                                            cla.selected = true;
                                        }
                                    });
                                });
                                vm.classList = angular.copy(arr);
                                vm.condition.pageSize = data.result.size;
                                vm.condition.pageNumber = data.result.number;
                                vm.condition.itemSize = data.result.totalElements;
                                vm.condition.totalPage = data.result.totalPages;
                                vm.classMore = vm.condition && vm.classList.length < vm.condition.itemSize;
                            }
                        } else {
                            vm.condition.title = "获取班级失败";
                            vm.condition.error = true;
                        }
                        vm.condition.isQuery = false;
                        if(fun){
                            fun();
                        }
                    }).error(function () {
                        vm.condition.title = "获取班级失败";
                        vm.condition.error = true;
                        vm.condition.isQuery = false;
                        if(fun){
                            fun();
                        }
                    })
                },
                // 加载更多
                loadMore: function () {
                    if (vm.condition.pageNumber >= vm.condition.totalPage) {
                        return false;
                    }
                    vm.condition.pageNumber = vm.condition.pageNumber + 1;
                    vm.queryTeachClass(function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                scrollTop:function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                },
                // 选中年级
                getSelectGrade: function (item) {
                    vm.condition.gradeId = item.id;
                    vm.condition.pageNumber = 0;
                    vm.condition.pageSize = 20;
                    vm.classList = [];
                    vm.queryTeachClass(function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                // 选择被选中的班级
                getSelectClass: function (item) {
                    item.selected = !item.selected;
                    if(item.selected){
                        vm.selectClass.unshift(item);
                    }else {
                        if(vm.selectClass && vm.selectClass.length > 0){
                            var _index = null;
                            angular.forEach(vm.selectClass,function (val, index) {
                                if(item.id == val.id){
                                    _index = index;
                                }
                            });
                            if(_index != null){
                                vm.selectClass.splice(_index,1);
                            }
                        }
                    }

                },
                // 删除选择的数据
                deleteSelectClass: function(item,index){
                    angular.forEach(vm.classList,function (val) {
                        if(item.id == val.id){
                            val.selected = false;
                        }
                    });
                    vm.selectClass.splice(index,1);
                },
                // 取消
                cancel: function () {
                    if(oldVm.updateType){
                        modalManager.remove("choose_grade_update");
                    }else {
                        modalManager.remove("choose_grade");
                    }
                },
                // 完成选择
                overSelectClass: function () {
                    if(oldVm.updateType){
                        $scope.$emit("choose_grade_update",vm.selectClass);
                    }else {
                        $scope.$emit("choose_grade",vm.selectClass);
                    }
                    vm.cancel();
                },
                // 清除输入的班级的名称
                clearCondition: function () {
                    vm.condition.name = null;
                    vm.queryTeachClass();
                },
                // 查看已选班级浮动框
                selectClass_view: function(){
                    vm.isShowMoreCourse = !vm.isShowMoreCourse;
                }


            };

            /**
             * 监控
             */
            function initSelectClass(){
                vm.classList = [];
                vm.condition.pageNumber = 0;
                vm.condition.pageSize = 20;
                vm.queryThreeGrade();
                vm.queryTeachClass(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                });
            }

            initSelectClass();

            /**监控
             *
             */
            $scope.$on('stateChangeSuccess', function () {
                vm.loadMore();
            });


        }])

    /**
     * 选择课程
     */
.controller("courseController", ['$scope', '$http', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate',
        '$location', "ynuiNotification","modalManager",
function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location,
                  ynuiNotification,modalManager) {

            /**
             * 路由信息
             * @type {string}
             */
            var basePath = originBaseUrl + "/third/xcMobileRecord";

            var old = angular.copy($scope.vm);
            var vm = $scope.vm = {
                condition: {
                    isQuery: false,
                    pageNumber: 0,
                    pageSize: 20,
                    name: "",
                    title: ""
                },
                courseList: [{
                    "courseId":"-1",
                    "courseName":"自习课",
                    "courseNo":null,
                    "courseTeachType":"如果没有找到相应课程，可以选择此项"
                }],
                // 查询课程
                queryTeachCourse: function (fun,flag,isMore) {

                    vm.condition.isQuery = true;
                    var classIds = [];
                    if(old.teachClass.list && old.teachClass.list.length > 0){
                        angular.forEach(old.teachClass.list,function (val) {
                            classIds.push(val.id);
                        });
                    }
                    if(flag){
                        vm.condition.pageNumber = 0;
                    }
                    var params = {
                        name:vm.condition.name,
                        pageSize:vm.condition.pageSize,
                        pageNumber:vm.condition.pageNumber,
                        classDate:old.xcMobileStartVO.checkDate,
                        classRoomId:old.classRoom.room ? old.classRoom.room.id:null ,
                        knob:old.xcMobileStartVO.knob,
                        termId:old.xcMobileStartVO.checkPlatformSysTermId,
                        classType:old.showClassTypeVO.classType,
                        timeType:old.xcMobileStartVO.timeType,
                        classIds:classIds,
                        _timestamp:new Date().getTime()
                    };
                    $http.post(basePath + "/queryMobileCourseVO.htm",params).success(function (data) {
                        if (data.status == 0) {
                            vm.condition.isQuery = false;
                            var arrs = data.result;
                            if (arrs && arrs.content.length > 0) {
                                // 获取更多
                                if(isMore){
                                    if(vm.courseList && vm.courseList.length > 0){
                                        angular.forEach(arrs.content,function (ar) {
                                            vm.courseList.push(ar);
                                        });
                                        // vm.courseList.concat(arrs.content);
                                    }else {
                                        vm.courseList = arrs.content;
                                    }
                                }else {
                                    vm.courseList = arrs.content;
                                }
                                var flag = true;
                                angular.forEach(vm.courseList,function (value) {
                                    if(value.courseId == '-1' || value.courseName == '自习课'){
                                        flag = false;
                                    }
                                });
                                if(flag){
                                    vm.courseList.unshift({
                                        "courseId":"-1",
                                        "courseName":"自习课",
                                        "courseNo":null,
                                        "courseTeachType":"如果没有找到相应课程，可以选择此项"
                                    });
                                }

                                vm.condition.pageSize = data.result.size;
                                vm.condition.pageNumber = data.result.number;
                                vm.condition.itemSize = data.result.totalElements;
                                vm.condition.totalPage = data.result.totalPages;
                                vm.courseMore = vm.condition && vm.courseList.length < vm.condition.itemSize;
                                console.log(vm.courseMore)

                            }else if (!arrs || !arrs.content || arrs.content.length == 0) {
                                vm.condition.title = "没有可选课程";
                                vm.condition.error = false;
                                vm.courseList =  [{
                                    "courseId":"-1",
                                    "courseName":"自习课",
                                    "courseNo":null,
                                    "courseTeachType":"如果没有找到相应课程，可以选择此项"
                                }];
                            }
                        } else {
                            vm.condition.title = "获取课程失败";
                            vm.condition.error = true;
                            vm.courseList =  [{
                                "courseId":"-1",
                                "courseName":"自习课",
                                "courseNo":null,
                                "courseTeachType":"如果没有找到相应课程，可以选择此项"
                            }];
                        }

                    }).error(function () {
                        vm.condition.title = "获取课程失败";
                        vm.condition.error = true;
                        vm.condition.isQuery = false;
                        vm.courseList =  [{
                            "courseId":"-1",
                            "courseName":"自习课",
                            "courseNo":null,
                            "courseTeachType":"如果没有找到相应课程，可以选择此项"
                        }];
                        if (fun) {
                            fun();
                        }
                    })
                },
                // 清楚查询条件
                clearCondition: function () {
                    vm.condition.pageNumber= 0;
                    vm.condition.pageSize=20;
                    vm.condition.name = "";
                },
                // 刷新数据
                doRefresh: function () {
                    vm.condition.pageNumber= 0;
                    vm.condition.pageSize=20;
                    vm.courseList = [];
                    vm.queryTeachCourse(function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                scrollTop:function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                },
                // 选中
                selectCourse: function (item) {
                    $scope.$emit("choose_courses",item);
                    vm.cancelCourse();
                },
                // 取消
                cancelCourse: function () {
                    modalManager.remove("choose_courses");
                }

            };


            function intCourseWatch(){
                vm.condition.pageNumber = 0;
                vm.condition.pageSize = 20;
                vm.queryTeachCourse(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                });
            }

            intCourseWatch();



            $scope.loadMore = function (flag) {
                if (vm.condition.pageNumber >= vm.condition.totalPage) {
                    return false;
                }
                vm.condition.pageNumber = vm.condition.pageNumber + 1;
                vm.queryTeachCourse(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    // $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                },false,flag);
            }

        }])


    /**
     *  巡查的教室
     */
.controller("chooseClassRoomCont", ['$scope', '$http', '$ionicModal', '$ionicLoading',
        '$ionicScrollDelegate', '$location', "ynuiNotification", "storageService","modalManager",'ynNavigator',
function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate,
                  $location, ynuiNotification, storageService,modalManager, ynNavigator) {

            /**
             * 路由信息
             * @type {string}
             */
            var basePath = originBaseUrl + "/third/xcMobileRecord";

            var old = angular.copy($scope.vm);


            var vm = $scope.vm = {
                // 教室下拉列表
                classRoomList: [],
                // 区域的列表
                areaList: [],
                condition: {
                    classRoom:null,
                    name: "",
                    id: old.classRoom.areaGroupOld ? old.classRoom.areaGroupOld.id:null,
                    groupName: old.classRoom.areaGroupOld ? old.classRoom.areaGroupOld.groupName:null,
                    isQuery: false
                },
                // 获取全部的区域（分组）
                getXCArea: function (fun,classRoomId) {
                    vm.areaList = [];
                    $http.get(basePath + "/queryAllCheckGroup.htm",
                        {params:
                            {
                                classRoomId:classRoomId,
                                _timestamp:new Date().getTime()
                            }
                        }).success(function (data) {
                        if (data.status == 0) {
                            vm.areaList = angular.copy(data.result);
                            if (vm.areaList.length > 0) {
                                if(vm.condition.id || vm.condition.groupName){
                                    var flag = true;
                                    angular.forEach(vm.areaList,function (value) {
                                        if(value.id == vm.condition.id){
                                            flag = false;
                                        }
                                    });
                                    if(flag){
                                        vm.condition.id = null;
                                        vm.condition.groupName =  "全部教室";
                                    }
                                }else {
                                    vm.condition.id = null;
                                    vm.condition.groupName =  "全部教室";
                                }
                            }else{
                                vm.condition.id = null;
                                vm.condition.groupName = "全部教室";
                            }

                            vm.getXCAreaClassRoom(vm.condition, "",fun);
                        } else {
                            notifyError("获取巡查区域失败！");
                        }
                        if (fun) {
                            fun();
                        }
                    }).error(function () {
                        notifyError("获取巡查区域失败！");
                        if (fun) {
                            fun();
                        }
                    })
                },
                // 选择分组
                getXCAreaRoom: function(area){
                    vm.classRoomList = [];
                    vm.condition.isQuery = true;
                    vm.condition.groupName = area.name;
                    vm.condition.id = area.id;
                    vm.getXCAreaClassRoom(vm.condition, vm.condition.name,function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                // 置顶
                scrollTop:function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                },
                /**
                 *查询巡查区域下的教室信息
                 * @param groupId 分组id
                 * @param classRoomName 教室名称
                 */
                getXCAreaClassRoom: function (_group, classRoomName,fun) {
                    vm.classRoomList = [];
                    vm.condition.isQuery = true;
                    vm.condition.groupName = _group.groupName;
                    vm.condition.id = _group.id;
                    var params = {
                        roomGroupId:vm.condition.id,
                        name:classRoomName,
                        registrationMethod:old.showClassTypeVO.classType,
                        termId:old.xcMobileStartVO.checkPlatformSysTermId,
                        timeType:old.xcMobileStartVO.timeType,
                        knob:old.xcMobileStartVO.knob,
                        day:old.xcMobileStartVO.day,
                        week:old.xcMobileStartVO.week,
                        _timestamp:new Date().getTime()
                    };
                    $http.post(basePath + "/quertAllClassRoomByGroup.htm?",params).success(function (data) {
                        vm.condition.isQuery = false;
                        vm.classRoomList = angular.copy(data.result);
                        if (vm.classRoomList && vm.classRoomList.length > 0){
                            vm.condition.title = "";
                            vm.condition.error = false;
                            // 默认值 设定
                            switch (old.showClassTypeVO.classType){
                                case '1':
                                    //默认值为排第一的教室
                                    if(vm.classRoomList && vm.classRoomList.length > 0){
                                        vm.condition.classRoom = vm.classRoomList[0];
                                        // 获取分组
                                        vm.getXCAreaSelect(vm.condition.classRoom.id);
                                    }
                                    break;
                                case '2':
                                    //默认值为排第一的教室
                                    if(vm.classRoomList && vm.classRoomList.length > 0){
                                        vm.condition.classRoom = vm.classRoomList[0];
                                        // 获取分组
                                        vm.getXCAreaSelect(vm.condition.classRoom.id);
                                    }
                                    break;
                                case '3':
                                    //选择分组时默认值为分组排第一的教室；未选择分组时，无默认值；
                                    if(roomGroupId && vm.classRoomList && vm.classRoomList.length > 0){
                                        vm.condition.classRoom = vm.classRoomList[0];
                                        // 获取分组
                                        vm.getXCAreaSelect(vm.condition.classRoom.id);
                                    }else {
                                        vm.condition.classRoom = null;
                                    }
                                    break;
                                default:break;
                            }
                        }else{
                            vm.condition.title = "没有可选教室";
                            vm.condition.error = false;
                            vm.classRoomList = [];
                        }
                        if (fun) {
                            fun();
                        }

                    }).error(function () {
                        vm.condition.isQuery = false;
                        vm.condition.title = "获取教室失败";
                        vm.condition.error = true;
                        if (fun) {
                            fun();
                        }
                    });
                },
                // 清除查询条件
                clearConditon: function () {
                    vm.condition.name = null;
                    vm.doRefresh();
                },
                // 刷新数据
                doRefresh: function () {
                    vm.condition.name = null;
                    vm.getXCAreaClassRoom(vm.condition, vm.condition.name,function () {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $ionicScrollDelegate.scrollTop();
                        $ionicLoading.hide();
                    });
                },
                // 选中教室
                selectClassRoom: function (item) {
                    // 获取教室对应的分组
                    vm.getXCAreaSelect(item.id,item);
                },
                // 取消选择教室
                cancelSelectClass: function () {
                    modalManager.remove("choose_classroom");
                },
                // 获取教室对应分组
                getXCAreaSelect:function(classRoomId,flag) {
                    // 未分组则查询分组
                    if(!(vm.condition.id)){
                        $http.get(basePath + "/queryAllCheckGroup.htm",
                            {params:
                                {
                                    classRoomId:classRoomId,
                                    _timestamp:new Date().getTime()
                                }
                            }).success(function (data) {
                            if (data.status == 0) {
                                vm.areaList = data.result;
                                if (vm.areaList.length > 0) {
                                    if(old.classRoom.areaGroupOld && old.classRoom.areaGroupOld.id){
                                        if(old.groupName === '全部教室' && vm.areaList[0].name === '全部教室' && vm.areaList.length > 1){
                                            vm.condition.id = vm.areaList[1].id;
                                            vm.condition.groupName =  vm.areaList[1].name;
                                        }
                                    }else {
                                        if(vm.areaList[0].name === '全部教室' && vm.areaList.length > 1){
                                            vm.condition.id = vm.areaList[1].id;
                                            vm.condition.groupName =  vm.areaList[1].name;
                                        }else {
                                            vm.condition.id = vm.areaList[0].id;
                                            vm.condition.groupName =  vm.areaList[0].name;
                                        }
                                    }

                                }
                                if(flag){
                                    $scope.$emit("choose_classroom",flag,vm.condition);
                                    vm.cancelSelectClass();
                                }


                            }
                        });
                    }else {
                        if(flag){
                            $scope.$emit("choose_classroom",flag,vm.condition);
                            vm.cancelSelectClass();
                        }

                    }

                }

            };

            /**
             * 报错工具
             * @param message
             */
            var notifyError = function (message) {
                if (message == null || message == "") {
                    message = "获取数据失败";
                }
                ynuiNotification.error({msg: message});
            };

            /**
             * 获取数据
             */
            vm.getXCArea();




        }])
    /**
     * 详情
     */
.controller("patrolRegisterMoreController", ['$scope', '$http', '$ionicModal', '$ionicLoading',
        '$ionicScrollDelegate', '$location', "ynuiNotification", "storageService","$rootScope", "$ionicPopup",
        'stringsConstant', '$cordovaFileTransfer', '$cordovaFile', '$timeout','$filter',"modalManager", '$state', '$stateParams',
        'ynNavigator',
function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location, ynuiNotification,
                  storageService,$rootScope,$ionicPopup,stringsConstant, $cordovaFileTransfer, $cordovaFile, $timeout,
                  $filter,modalManager, $state, $stateParams, ynNavigator) {

            // 路由信息
            var basePath = originBaseUrl + "/third/xcMobileRecord";
            // 第一步 选择对象数据
            var oldVm = angular.fromJson($stateParams.oldVm),oldKnob = null;
            if(oldVm.xcMobileStartVO.xcMobileKnobVOs){
                angular.forEach(oldVm.xcMobileStartVO.xcMobileKnobVOs,function (val,index) {
                    if(val.select){
                        oldKnob = index+1;
                    }
                });
            }
            var oldinitFiles = storageService.getItem("initFiles");
            if(!(oldinitFiles && oldinitFiles.length > 0)){
                oldinitFiles = [];
            }

            var vm = $scope.vm = {
                sourceType:oldVm.sourceType,
                showInfo:{
                    attendanceFlag:false,
                    postFlag : false,
                    photoFlag : false,
                    remarkFlag : false,
                    oneFlag : false,
                    twoFlag : false,
                    threeFlag: false,
                    fourkFlag : false,
                    dateAndWeekAndKnob:oldVm.xcMobileStartVO.checkDateStrs+" 第"+oldKnob+"节",
                    dateAndKnob:oldVm.xcMobileStartVO.checkDate+" 第"+oldKnob+"节",
                    buildAndRoom:oldVm.classRoom.room.buildName+"/"+oldVm.classRoom.room.name,
                    classRoomNum:oldVm.classRoom.num,
                    classShowName:oldVm.teachClass.teachClassShowInfo,
                    courseShowInfo:oldVm.course.courseShowInfo?"【"+oldVm.course.courseShowInfo+"】":"",
                    teacherShowName:oldVm.teacher.teaShowInfo
                },
                xcMobileDetailInfoVO:{xcMobileCustomFieldVOs:[],xcMobileStartVO:oldVm.xcMobileStartVO},
                // 是否展示听课
                isNeedRegisterReport:false,
                // 听课信息
                tkInfo:{
                    list:[],
                    showInfo:null
                },
                // 删除的听课老师
                delUserIdList:[],
                // 教师考勤
                teacherList:[],
                // 照片
                initFiles:oldinitFiles,
                cameraPtion:{
                    waterMark: moment().format("YYYY-MM-DD HH:mm:ss")
                },
                // 上一步
                lastStep:function () {
                    storageService.setItem("initFiles",vm.initFiles);
                    // modalManager.remove("patrol_register_more");
                  // console.log($state);
                  // $state.go('patrol_register_single', {oldVm: angular.toJson(vm)});
                  // console.log($location);
                  window.history.back();
                },
                // 获取听课管理配置信息
                findTkglConfig:function() {
                    $http.post(basePath + "/findTkglConfig.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.isNeedRegisterReport = data.result.isNeedRegisterReport;
                            if(vm.isNeedRegisterReport){
                                vm.findTkTeacherAndUserDutyList();
                            }
                        }
                    });
                },
                // 获取某节课某个地点的听课人到岗情况
                findTkTeacherAndUserDutyList:function() {
                    var searchInfo = {
                        classRoomId:oldVm.classRoom.room.id,
                        termId:oldVm.xcMobileStartVO.checkPlatformSysTermId,
                        week:oldVm.xcMobileStartVO.week,
                        day:oldVm.xcMobileStartVO.day,
                        timeType:oldVm.xcMobileStartVO.timeType,
                        knob:oldVm.xcMobileStartVO.knob
                    };
                    $http.post(basePath + "/findTkTeacherAndUserDutyList.htm",searchInfo).success(function (data) {
                        if (data.status === 0) {
                            vm.tkInfo.list = angular.copy(data.result);
                            if(vm.tkInfo.list.length > 0){
                                // 听课人+到岗情况值
                                var nameList = [];
                                angular.forEach(vm.tkInfo.list,function (value) {
                                    value.userId = value.tkUserId;
                                    if(value.listenStatus == 0){
                                        nameList.push(value.tkUserName+"：未去听课");
                                    }else {
                                        nameList.push(value.tkUserName+"：在听课");
                                    }

                                });
                                vm.tkInfo.showInfo = nameList.join("；");
                            }
                        }
                    });
                },
                // 获取教师考勤、到岗情况 样式
                getAttClass:function(info,type) {
                    if(type === 1){
                        if(info.attendanceInfo === 1 ){
                            return "button-label";
                        }else {
                            return "button-label label-orange";
                        }
                    }else {
                        if(info.postInfo === 1 ){
                            return "button-label";
                        }else {
                            return "button-label label-orange";
                        }
                    }

                },
                // 获取教师考勤、到岗情况 样式
                getAttDialogClass:function(info,type,index) {
                    if(type === 1){
                        if(index === info.attendanceInfo){
                            return 'margin-top-10 button button-calm button-mini';
                        }else {
                            return "margin-top-10 button button-calm button-mini button-outline";
                        }
                    }else {
                        if(info.postInfo === index ){
                            return "margin-top-10 button button-calm button-mini";
                        }else {
                            return "margin-top-10 button button-calm  button-mini button-outline";
                        }
                    }
                },
                //获取应到人数，请假人数
                getXCRecordDefaultInfo:function(classIds,id) {
                    var params = {
                            termId:vm.xcMobileDetailInfoVO.xcMobileStartVO.checkPlatformSysTermId,
                            type:vm.xcMobileDetailInfoVO.xcMobileStartVO.timeType,
                            setsuji:vm.xcMobileDetailInfoVO.xcMobileStartVO.knob,
                            date:vm.xcMobileDetailInfoVO.xcMobileStartVO.day,
                            week:vm.xcMobileDetailInfoVO.xcMobileStartVO.week,
                            classRoomId:id,
                            startDateTime:vm.xcMobileDetailInfoVO.xcMobileStartVO.checkDate,
                            endDateTime:vm.xcMobileDetailInfoVO.xcMobileStartVO.checkDate,
                            list:classIds
                        };
                    $http.post(basePath + "/getXCRecordDefaultInfo.htm",params).success(function (data) {
                        if (data.status == 0) {
                            vm.xcMobileDetailInfoVO.shouldNumber = data.result.id;
                            vm.xcMobileDetailInfoVO.leaveNumber = data.result.name;
                            vm.xcMobileDetailInfoVO.absenteeismNumber = 0;
                            if(vm.showInfo.oneFlag && vm.showInfo.twoFlag){
                                vm.xcMobileDetailInfoVO.toNumber = vm.xcMobileDetailInfoVO.shouldNumber - vm.xcMobileDetailInfoVO.leaveNumber;
                            }
                        }
                    });
                },
                // 默认光标
                setFocus:function() {
                    if(vm.showInfo.oneFlag){
                        $("#shouldNumberEdit").focus();
                    }else if(vm.showInfo.twoFlag){
                        $("#leaveNumberEdit").focus();
                    }else if(vm.showInfo.threeFlag){
                        $("#absenteeismNumberEdit").focus();
                    }else if(vm.showInfo.fourFlag){
                        $("#toNumberEdit").focus();
                    }
                },
                // 单选  显示
                selectCustom: function (custom) {
                    // 如果是下拉单选
                    if (custom.itemType == 4) {
                        $scope.optionList = custom.xcMobileCustFieldValueVOs;
                        $scope.singSelect.show();
                    }
                    $scope.custom = custom;
                },
                // 当选选项
                selectOption: function (custom) {
                    $scope.custom.value = custom.name;
                    $scope.hideTableSingle();
                },
                // 提交
                saveDetail: function () {
                    // 复制一份数据
                    var obj = angular.copy(vm.xcMobileDetailInfoVO);
                    if(vm.showInfo.oneFlag){
                        var info = Number(vm.xcMobileDetailInfoVO.shouldNumber);
                        if(!eventAction(info)){
                            notifyError("应到人数请输入大于或等于0的整数！");
                            return false;
                        }
                    }else {
                        vm.xcMobileDetailInfoVO.shouldNumber = null;
                    }
                    if(vm.showInfo.twoFlag){

                        var info = Number(vm.xcMobileDetailInfoVO.leaveNumber);
                        if(!eventAction(info)){
                            notifyError("请假人数请输入大于或等于0的整数！");
                            return false;
                        }
                    }else {
                        vm.xcMobileDetailInfoVO.leaveNumber = null;
                    }
                    if(vm.showInfo.threeFlag){
                        var info = Number(vm.xcMobileDetailInfoVO.absenteeismNumber);
                        if(!eventAction(info)){
                            notifyError("未到人数请输入大于或等于0的整数！");
                            return false;
                        }
                    }else {
                        vm.xcMobileDetailInfoVO.absenteeismNumber = null;
                    }
                    if(vm.showInfo.fourFlag){
                        var info = Number(vm.xcMobileDetailInfoVO.toNumber);
                        if(!eventAction(info)){
                            notifyError("实到人数请输入大于或等于0的整数！");
                            return false;
                        }
                    }else {
                        vm.xcMobileDetailInfoVO.toNumber = null;
                    }

                    if(obj.xcMobileCustomFieldVOs && obj.xcMobileCustomFieldVOs.length  > 0){
                        var error = false;
                        angular.forEach(obj.xcMobileCustomFieldVOs,function(custom){
                            if(!error){
                                error = $scope.changeInputItem(custom);
                            }
                        });
                        if(error){
                            return false;
                        }
                    }
                    /**check the data*/
                    $http.get(basePath + "/checkXCDetail.htm",
                        {
                            params:{
                                checkDate:vm.xcMobileDetailInfoVO.xcMobileStartVO.checkDate,
                                week:vm.xcMobileDetailInfoVO.xcMobileStartVO.week,
                                timeType:vm.xcMobileDetailInfoVO.xcMobileStartVO.timeType,
                                day:vm.xcMobileDetailInfoVO.xcMobileStartVO.day,
                                knob:vm.xcMobileDetailInfoVO.xcMobileStartVO.knob,
                                classRoomId:vm.xcMobileDetailInfoVO.xcMobileStartVO.classRoomId,
                                xcTeacherId:oldVm.checkTeacher.userId,
                                // currentUserId:vm.authorizationStr.userId,
                                _timestamp:new Date().getTime()
                            }
                        }).success(function (data) {
                        if (data.status == 0) {
                            var item = data.result;
                            if(isNotBlank(item.failedReason)){
                                item.failedReason = item.failedReason.replace("&%$",oldKnob);
                                var confirmPopup = item.userName == "-1" ? $ionicPopup.alert({
                                        title: "提示",
                                        template: item.failedReason,
                                        okText: "确定"
                                    }) : $ionicPopup.confirm({
                                        title: "提示",
                                        template: item.failedReason,
                                        cancelText: "取消",
                                        okText: "确定"
                                    });
                                confirmPopup.then(function(result){
                                    if(result){
                                        /**自己以前的记录，可以修改 点击确定有保存数据*/
                                        if("1" == item.userName){
                                            vm.saveDetailInfo();
                                        }else{
                                            /**别人已经巡查，不可更改 点击确认后不做任何处理*/
                                        }
                                    }else{
                                        /**点击取消不做任何处理*/
                                    }
                                })
                            }else{
                                /**没有已经保存的数据 则直接保存*/
                                vm.saveDetailInfo();
                            }
                        }
                    });
                },
                // 保存
                saveDetailInfo: function(){
                    // 复制一份数据
                    var obj = angular.copy(vm.xcMobileDetailInfoVO);

                    if(obj.xcMobileCustomFieldVOs && obj.xcMobileCustomFieldVOs.length  > 0){
                        var error = false;
                        angular.forEach(obj.xcMobileCustomFieldVOs,function(custom){
                            if(!error){
                                error = $scope.changeInputItem(custom);
                            }
                        });
                        if(error){
                            return false;
                        }
                    }
                    //巡课人
                    obj.checkTeacher = oldVm.checkTeacher;
                    // 获取教室
                    obj.xcMobileStartVO.classRoomId = oldVm.classRoom.room.id;
                    // 巡查课程信息
                    obj.xcMobileDetailCourseVO = oldVm.course.info;
                    // 班级
                    obj.xcMobileDetailClassVOs = oldVm.teachClass.list;
                    // 课[带班]教师
                    obj.classTeacherList = vm.teacherList;
                    obj.teacherType = oldVm.teacher.teacherType;
                    //照片
                    obj.fsIdList = vm.initFiles;
                    delete  obj.xcMobileStartVO.xcMobileKnobVOs;

                    angular.forEach(obj.classTeacherList,function (ctl) {
                        if(!vm.showInfo.attendanceFlag){
                            ctl.attendanceInfo = null;
                        }
                        if(!vm.showInfo.postFlag){
                            ctl.postInfo = null;
                        }
                    });
                    // 听课人
                    if(vm.isNeedRegisterReport){
                        var list = [];
                        angular.forEach(vm.tkInfo.list,function (tkUser) {
                            list.push({
                                id:tkUser.id,
                                tkUserId:tkUser.userId,
                                listenStatus:tkUser.listenStatus,
                                remarks:tkUser.remarks
                            });
                        });
                        obj.tkglUserDutySaveVO = {
                            userDutyList:list,
                            delUserIdList:vm.delUserIdList
                        };
                    }
                    $http.post(basePath + "/saveXCMobileRecordDetail.htm", parseParamForSpringMVC(obj)).success(function (data) {
                        if (data.status == 0) {
                            notifySuccess("提交成功！");
                            // 扫一扫
                            if(vm.sourceType == 1){
                                // 返回列表页面
                                $scope.$emit("single_register",true);
                                // modalManager.remove("single_register");
                                $state.go('classPatrolIndexByTea');
                                // vm.lastStep();
                            }else if(vm.sourceType == 2){
                                // 单个登记
                                $scope.$emit("patrol_register_more",true);
                                vm.lastStep();
                            }

                        }else {
                            notifyError("保存失败！");
                        }
                    });
                },
                // 获取固定字段 显示
                getAllOptions:function () {
                    $http.get(basePath + "/getAllOptions.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.colList = angular.copy(data.result);
                            angular.forEach(data.result,function (info) {
                                if(info.itemName === '教师考勤情况'){
                                    vm.showInfo.attendanceFlag = true;
                                }
                                if(info.itemName === '教师到岗情况'){
                                    vm.showInfo.postFlag = true;
                                }
                                if(info.itemName === '巡课照片'){
                                    vm.showInfo.photoFlag = true;
                                    //巡课照片
                                    vm.options = {};
                                    vm.initFiles = storageService.getItemNoDel("initFiles");
                                    if(vm.initFiles){

                                    }
                                }
                                if(info.itemName === '备注'){
                                    vm.showInfo.remarkFlag = true;
                                }
                                if(info.itemName === '应到人数'){
                                    vm.showInfo.oneFlag = true;
                                }
                                if(info.itemName === '请假人数'){
                                    vm.showInfo.twoFlag = true;
                                }
                                if(info.itemName === '未到人数'){
                                    vm.showInfo.threeFlag = true;
                                }
                                if(info.itemName === '实到人数'){
                                    vm.showInfo.fourFlag = true;
                                }
                            });
                            if(vm.showInfo.oneFlag || vm.showInfo.twoFlag || vm.showInfo.threeFlag || vm.showInfo.fourFlag){
                                setTimeout(function () {
                                    vm.setFocus();
                                },150);
                            }

                        }
                    });
                },
                // 自定义显示字段
                findAllShowCustomField:function () {
                    $http.get(originBaseUrl + "/third/xcMobileNewRecord/findAllShowCustomField.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.xcMobileDetailInfoVO.xcMobileCustomFieldVOs = angular.copy(data.result);
                            // 给默认值
                            if(vm.xcMobileDetailInfoVO.xcMobileCustomFieldVOs && vm.xcMobileDetailInfoVO.xcMobileCustomFieldVOs.length > 0){
                                angular.forEach(vm.xcMobileDetailInfoVO.xcMobileCustomFieldVOs,function (val) {
                                    if(val.xcMobileCustFieldValueVOs && val.xcMobileCustFieldValueVOs.length > 0){
                                        angular.forEach(val.xcMobileCustFieldValueVOs,function (value) {
                                            if(value.defaultValue){
                                                val.value = value.name;
                                            }
                                        });
                                    }
                                });
                            }
                        }
                    });
                },
                // 开启备注弹框
                openDiageRemark:function (){
                    // 回填
                    $scope.$on("patrol_tips",function (event, data) {
                        vm.xcMobileDetailInfoVO.remark = data;
                    });
                    $ionicModal.fromTemplateUrl('templates/classpatrol/patrol_tips.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("patrol_tips", modal);
                        modal.show();
                    });
                },
                // 修改听课信息
                updateTkUser:function () {
                    $scope.$on("teacher_list",function (event, data) {
                        var list = [];
                        if(data && data.length > 0){
                            var nameList = [];
                            angular.forEach(data,function (val) {
                                if(val.listenStatus == 0){
                                    nameList.push(val.tkUserName+"：未去听课");
                                }else {
                                    nameList.push(val.tkUserName+"：在听课");
                                }
                                list.push(val);
                            });
                            vm.tkInfo.showInfo = nameList.join("；");
                            // 确定删除听课人
                            angular.forEach(vm.tkInfo.list,function (value) {
                                if(value.id){
                                    var flag = true;
                                    angular.forEach(data,function (val) {
                                        if(val.userId == value.userId){
                                            flag = false;
                                        }
                                    });
                                    if(flag){
                                        vm.delUserIdList.push(value.userId);
                                    }
                                }

                            });
                        }
                        vm.tkInfo.list = list;
                    });
                    $ionicModal.fromTemplateUrl('templates/classpatrol/teacher_list.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("teacher_list", modal);
                        modal.show();
                    });
                }


            };


            function init() {
                vm.findTkglConfig();
                vm.getAllOptions();
                vm.findAllShowCustomField();
                // 学生出勤情况
                var ids = [];
                if(oldVm.teachClass.list.length > 0){
                    angular.forEach(oldVm.teachClass.list,function (val) {
                        ids.push(val.id);
                    });
                }
                vm.getXCRecordDefaultInfo(ids,oldVm.classRoom.room.id);


                //上课[带班]教师
                var teacherListOld = oldVm.teacher.list;
                if(teacherListOld){
                    // 默认：按时到、在岗
                    angular.forEach(teacherListOld,function (tea) {
                        tea.attendanceInfo = 1;
                        tea.postInfo = 1;
                        tea.showName = (tea.name == tea.alien || tea.alien  ? tea.name : tea.name+"("+tea.alien+")");
                        vm.teacherList.push(tea);
                    });
                }
            }

            init();





            // 报错工具
            var notifyError = function (message) {
                if (message == null || message == "") {
                    message = "获取数据失败";
                }
                ynuiNotification.error({msg: message});
            };
            /**
             * 字符串处理
             * @param str
             * @returns {boolean}
             */
            var isNotBlank = function (str) {
                if (null == str) {
                    return false;
                }
                if (/\S+/.test(str)) {
                    return true;
                }
                return false;
            };
            /**
             * 成功的消息提示
             * @param message
             */
            var notifySuccess = function (message) {
                if (!isNotBlank(message)) {
                    message = "操作成功！";
                }
                ynuiNotification.success({msg: message});
            };

            /**
             *  单选
             */
            $ionicModal.fromTemplateUrl('single-select.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.singSelect = modal;
            });
            /**
             * 单选  隐藏
             */
            $scope.hideTableSingle = function () {
                $scope.singSelect.hide();
            };

            // 多选
            $ionicModal.fromTemplateUrl('more-select.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.moreSelect = modal;
            });
            /**
             * 多选  隐藏
             */
            $scope.hideTableMore = function () {
                $scope.moreSelect.hide();
            };
            /**
             * 多选 显示
             */
            $scope.showTableMore = function () {
                $scope.moreSelect.show();
            };
            /**
             *修改教师出勤情况
             */
            $ionicModal.fromTemplateUrl('teacher-cq.html',{
                scope:$scope,
                animation:'slide-in-up'
            }).then(function(modal){
                $scope.modal1 = modal;
            });
            $scope.teacherCqClick = function() {
                $scope.modal1.show();
            };
            $scope.teacherCqClickClose = function() {
                storageService.setItem("teacherListOld",$scope.teacherList);
                $scope.modal1.hide();
            };
            /**
             * 显示节次
             * @type {boolean}
             */
            $scope.moreKnob = true;
            /**
             * 把obj转化为Spring可接受状态
             * @param obj
             * @returns {{}}
             */
            var parseParamForSpringMVC = function (obj) {
                var resultObj = {};
                var deepParseParams = function (key, value, prefix) {
                    if (value instanceof Array) {
                        for (var i in value) {
                            deepParseParams("", value[i], prefix + key + "[" + i + "]");
                        }
                    }
                    else if (value instanceof Object) {
                        for (var i in value) {
                            deepParseParams("." + i, value[i], prefix + key);
                        }
                    }
                    else {
                        resultObj[prefix + key] = value;
                    }
                };
                for (var i in obj) {
                    deepParseParams("", obj[i], i);
                }
                return resultObj;
            };


            var eventAction = function(event){
                var regex = new RegExp("^\\d+$");
                var flag = regex.test(event);
                return flag;
            };

            function getNumberTo() {
                var shouldNumber = Number(vm.xcMobileDetailInfoVO.shouldNumber);
                if(!shouldNumber){
                    shouldNumber = 0;
                }
                var absenteeismNumber = Number(vm.xcMobileDetailInfoVO.absenteeismNumber);
                if(!absenteeismNumber){
                    absenteeismNumber = 0;
                }
                var leaveNumber = Number(vm.xcMobileDetailInfoVO.leaveNumber);
                if(!leaveNumber){
                    leaveNumber = 0;
                }
                var result = 0;
                if(vm.showInfo.oneFlag){
                    result = shouldNumber - absenteeismNumber -leaveNumber;
                }
                return result;

            }

            /**
             * 修改应到人数
             */
            $scope.clickShouldNumberEdit = function () {
                    vm.xcMobileDetailInfoVO.shouldNumberEdit = !vm.xcMobileDetailInfoVO.shouldNumberEdit;
                    if (vm.xcMobileDetailInfoVO.shouldNumberEdit) {
                        var shouldNumberEdit = Number(vm.xcMobileDetailInfoVO.shouldNumber);
                        if(eventAction(shouldNumberEdit)){
                            vm.xcMobileDetailInfoVO.shouldNumber = shouldNumberEdit;
                            vm.xcMobileDetailInfoVO.toNumber = getNumberTo();
                        }else {
                            notifyError("应到人数请输入大于或等于0的整数！");
                        }

                    } else if (isNaN(parseInt(vm.xcMobileDetailInfoVO.shouldNumber))) {
                        vm.xcMobileDetailInfoVO.shouldNumber = 0;
                    }

            };
            /**
             * 学生请假人数
             */
            $scope.clickleaveNumberEdit = function () {
                // if(eventAction(event)){
                    vm.xcMobileDetailInfoVO.leaveNumberEdit = !vm.xcMobileDetailInfoVO.leaveNumberEdit;
                    if (vm.xcMobileDetailInfoVO.leaveNumberEdit) {
                        var leaveNumberEdit = Number(vm.xcMobileDetailInfoVO.leaveNumber);
                        if(eventAction(leaveNumberEdit)){
                            vm.xcMobileDetailInfoVO.leaveNumber = leaveNumberEdit;
                            vm.xcMobileDetailInfoVO.toNumber = getNumberTo();
                        }else {
                            notifyError("请假人数请输入大于或等于0的整数！");
                        }
                    } else if (isNaN(parseInt(vm.xcMobileDetailInfoVO.leaveNumber))) {
                        vm.xcMobileDetailInfoVO.leaveNumber = 0;
                    }
                // }
            };
            /**
             * 未到人数
             */
            $scope.clickAbsenteeismNumberEdit = function () {
                // if(eventAction(event)){
                    vm.xcMobileDetailInfoVO.absenteeismNumberEdit = !vm.xcMobileDetailInfoVO.absenteeismNumberEdit;
                    if (vm.xcMobileDetailInfoVO.absenteeismNumberEdit) {
                        var absenteeismNumberEdit = Number(vm.xcMobileDetailInfoVO.absenteeismNumber);
                        if(eventAction(absenteeismNumberEdit)){
                            vm.xcMobileDetailInfoVO.absenteeismNumber = absenteeismNumberEdit;
                            vm.xcMobileDetailInfoVO.toNumber = getNumberTo();
                        }else {
                            notifyError("未到人数请输入大于或等于0的整数！");
                        }
                    } else if (isNaN(parseInt(vm.xcMobileDetailInfoVO.absenteeismNumber))) {
                        vm.xcMobileDetailInfoVO.absenteeismNumber = 0;
                    }
                // }
            };
            /**
             * 实到人数
             */
            $scope.clickToNumberEdit = function () {
                // if(eventAction(event)){
                    vm.xcMobileDetailInfoVO.toNumberEdit = !vm.xcMobileDetailInfoVO.toNumberEdit;
                    if (vm.xcMobileDetailInfoVO.toNumberEdit) {
                        var toNumberEdit = Number(vm.xcMobileDetailInfoVO.toNumber);
                        if(eventAction(toNumberEdit)){
                            if(Number(vm.xcMobileDetailInfoVO.toNumber) > Number(vm.xcMobileDetailInfoVO.shouldNumber)){
                                notifyError("实到人数不能大于应到人数！");
                            }
                        }else {
                            notifyError("实到人数请输入大于或等于0的整数！");
                        }
                    } else if (isNaN(parseFloat(vm.xcMobileDetailInfoVO.toNumber))) {
                        vm.xcMobileDetailInfoVO.toNumber = 0;
                    }
                // }
            };
            $scope.onBlured = function (item) {
                window.setTimeout(function () {
                    $scope.$apply( $("#"+item).focus());
                });
            };


            /**
             * 修改上课教师的状态
             * @param item
             * @param type
             */
            $scope.selectType = function (item, type) {
                item.attendanceInfo = type;
            };



            var getCheckRule = function(columnFields){
                var obj = [];
                if(columnFields.xcRange) {
                    obj = columnFields.xcRange.split(",");
                }
                var cusCheckRule = "";
                var msg = "";
                //空
                if(columnFields.inputRuleType == 1){
//                cusCheckRule = /^.{0,15}$/;
                    eval("cusCheckRule = \/^.{0,"+columnFields.maxLength+"}$\/");
                }
                //数字整数
                if(columnFields.inputRuleType == 2){
                    var a="";
                    var b="";
                    var c="";
                    for (var i in obj) {
                        if (obj[i] == "1") {
                            a ="1"
                        }
                        if (obj[i] == "2") {
                            b ="2"
                        }
                        if (obj[i] == "3") {
                            c ="3"
                        }
                        //整数
                        if(a!=""&&b!=""&&c!=""){
                            cusCheckRule = /^-?\d+$/;
                            msg = columnFields.showName+"：请输入整数";
                        }else if(a!=""&&b!=""&&c==""){//大于等于0整数
                            eval("cusCheckRule = \/^(0|[1-9][0-9]{0,"+(columnFields.maxLength-1)+"})$\/");
                            msg = columnFields.showName+"：请输入大于等于0整数";
                        }else if(a!=""&&b==""&&c==""){//大于0整数
                            eval("cusCheckRule = \/^[1-9]\\d{0,"+(columnFields.maxLength-1)+"}$\/");
                            msg = columnFields.showName+"：请输入大于0整数";
                        }else if(a==""&&b!=""&&c==""){//等于0整数
                            cusCheckRule = /^(0)$/;
                            msg = columnFields.showName+"：请输入0";
                        }else if(a==""&&b!=""&&c!=""){//小于等于0整数
                            eval("cusCheckRule = \/^(0|-[0-9]\\d{0,"+(columnFields.maxLength-1)+"})$\/");
                            msg = columnFields.showName+"：请输入小于等于0整数";
                        }else if(a==""&&b==""&&c!=""){//小于0整数
                            eval("cusCheckRule = \/^-[1-9]\\d{0,"+(columnFields.maxLength-1)+"}$\/");
                            msg = columnFields.showName+"：请输入小于0整数";
                        }
                    }
                }
                //数字小数
                if(columnFields.inputRuleType == 3){
                    var a="";
                    var b="";
                    var c="";
                    for (var i in obj) {
                        if (obj[i] == "1") {
                            a ="1"
                        }
                        if (obj[i] == "2") {
                            b ="2"
                        }
                        if (obj[i] == "3") {
                            c ="3"
                        }
                        //整数
                        if(a!=""&&b!=""&&c!=""){
                            cusCheckRule = /^(-?\d+)(\.\d+)?$/;
                            msg = columnFields.showName+"：请输入整数或者小数";
                        }else if(a!=""&&b!=""&&c==""){//大于等于0小数
                            eval("cusCheckRule = \/^\\d{0,"+columnFields.maxLength+"}(\\.\\d{0,"+columnFields.maxLengthFloat+"})?$\/");
                            msg = columnFields.showName+"：请输入大于等于0整数或者小数";
                        }else if(a!=""&&b==""&&c==""){//大于0小数
                            eval("cusCheckRule = \/^[0-9]{0,"+columnFields.maxLength+"}(\\.[0-9]{0,"+columnFields.maxLengthFloat+"}){0,1}$\/");
                            msg = columnFields.showName+"：请输入大于0整数或者小数";
                        }else if(a==""&&b!=""&&c==""){//等于0
                            cusCheckRule = /^(0)$/;
                            msg = columnFields.showName+"：请输入0";
                        }else if(a==""&&b!=""&&c!=""){//小于等于0小数
                            eval("cusCheckRule = \/^-\\d{0,"+columnFields.maxLength+"}(\\.\\d{0,"+columnFields.maxLengthFloat+"})?$\/");
                            msg = columnFields.showName+"：请输入小于等于0整数或者小数";
                        }else if(a==""&&b==""&&c!=""){//小于0小数
                            eval("cusCheckRule = \/^-[0-9]{0,"+columnFields.maxLength+"}(\\.[0-9]{0,"+columnFields.maxLengthFloat+"}){0,1}$\/");
                            msg = columnFields.showName+"：请输入小于0整数或者小数";
                        }
                    }
                }
                return cusCheckRule;
            }

            var getCustomMsg = function(columnFields){
                var obj = [];
                if(columnFields.xcRange) {
                    obj = columnFields.xcRange.split(",");
                }
                var msg = "";
                //数字整数
                if(columnFields.inputRuleType == 1){
                    msg = columnFields.showName+"：请输入0-"+columnFields.maxLength+"位字符!";
                }
                if(columnFields.inputRuleType == 2){
                    var a="";
                    var b="";
                    var c="";
                    for (var i in obj) {
                        if (obj[i] == "1") {
                            a ="1"
                        }
                        if (obj[i] == "2") {
                            b ="2"
                        }
                        if (obj[i] == "3") {
                            c ="3"
                        }
                        //整数
                        if(a!=""&&b!=""&&c!=""){
                            msg = columnFields.showName+"：请输入整数";
                        }else if(a!=""&&b!=""&&c==""){//大于等于0整数
                            msg = columnFields.showName+"：请输入大于等于0，"+columnFields.maxLength+"位整数";
                        }else if(a!=""&&b==""&&c==""){//大于0整数
                            msg = columnFields.showName+"：请输入大于0，"+columnFields.maxLength+"位整数";
                        }else if(a==""&&b!=""&&c==""){//等于0整数
                            msg = columnFields.showName+"：请输入0";
                        }else if(a==""&&b!=""&&c!=""){//小于等于0整数
                            msg = columnFields.showName+"：请输入小于等于0，"+columnFields.maxLength+"位整数";
                        }else if(a==""&&b==""&&c!=""){//小于0整数
                            msg = columnFields.showName+"：请输入小于0，"+columnFields.maxLength+"位整数";
                        }
                    }
                }
                //数字小数
                if(columnFields.inputRuleType == 3){
                    var a="";
                    var b="";
                    var c="";
                    for (var i in obj) {
                        if (obj[i] == "1") {
                            a ="1"
                        }
                        if (obj[i] == "2") {
                            b ="2"
                        }
                        if (obj[i] == "3") {
                            c ="3"
                        }
                        //整数
                        if(a!=""&&b!=""&&c!=""){
                            msg = columnFields.showName+"：请输入整数或者小数";
                        }else if(a!=""&&b!=""&&c==""){//大于等于0小数
                            msg = columnFields.showName+"：请输入大于等于0，"+columnFields.maxLength+"位整数或者"+columnFields.maxLengthFloat+"位小数";
                        }else if(a!=""&&b==""&&c==""){//大于0小数
                            msg = columnFields.showName+"：请输入大于0，"+columnFields.maxLength+"位整数或者"+columnFields.maxLengthFloat+"位小数";
                        }else if(a==""&&b!=""&&c==""){//等于0
                            msg = columnFields.showName+"：请输入0";
                        }else if(a==""&&b!=""&&c!=""){//小于等于0小数
                            msg = columnFields.showName+"：请输入小于等于0，"+columnFields.maxLength+"位整数或者"+columnFields.maxLengthFloat+"位小数";
                        }else if(a==""&&b==""&&c!=""){//小于0小数
                            msg = columnFields.showName+"：请输入小于0，"+columnFields.maxLength+"位整数或者"+columnFields.maxLengthFloat+"位小数";
                        }
                    }
                }
                return msg;
            }


            /**
             * 自定义字段的验证
             * （1.文本+无限制  2.文本+整数  3.文本+整数或小数  4.日期  5.时间  6.时间+日期  7.单选下拉框）
             * @param custom
             */
            $scope.changeInputItem = function (custom) {
                var error = false;

                /*文本+整数   xcRange（1.大于0  2.等于0  3.小于0）*/
                var maxLength =custom.maxLength,range = custom.xcRange,
                    errorMsg = getCustomMsg(custom), checkRule =  getCheckRule(custom);

                if(1 == custom.inputRuleType && custom.value && custom.value.length > maxLength){
                    notifyError(errorMsg);
                    return true;
                }


                if(2 != custom.inputRuleType && 3 != custom.inputRuleType){
                    // storageService.setItem("xcMobileDetailInfoVO",$scope.xcMobileDetailInfoVO);
                    return error;
                }

                if(isNotBlank(custom.value) && checkRule && !checkRule.test(custom.value)  ){
                    notifyError(errorMsg);
                    error = true;
                }
                if(isNotBlank(custom.value) && isNotBlank(range)){
                    var simple = $scope.getCalutSimple(range);
                    if(isNotBlank(simple)){
                        if(!eval(custom.value+simple +"0")){
                            notifyError($scope.getCalutErrorInfo(range));
                            error = true;
                        }
                    }
                }

                if(!error){
                    // storageService.setItem("xcMobileDetailInfoVO",$scope.xcMobileDetailInfoVO);
                }
                return error;
            };
            /**
             * 返回计算符号
             * @param range
             */
            $scope.getCalutSimple = function(range) {
                var simple = "",arr = range.split(","),sum = -1 ;
                /*3 做特殊处理*/
                if(arr.length == 2 && $scope.sumRange(arr) == 3){
                    simple = ">=";
                }else{
                    sum = $scope.sumRange(arr);
                    switch(sum){
                        case 1: simple = ">"; break;
                        case 2: simple = "=="; break;
                        case 3: simple = "<";break;
                        case 4: simple = "!=";break;
                        case 5: simple = "<=";break;
                        case 6: simple = null; break;
                        case -1: simple = null; break;
                        default : console.error(range + " is not number!");
                    }
                }
                return simple;
            };
            /**
             * 返回计算符号
             * @param range
             */
            $scope.getCalutErrorInfo = function(range) {
                var simple = "",arr = range.split(","),sum = -1 ;
                /*3 做特殊处理*/
                if(arr.length == 2 && $scope.sumRange(arr) == 3){
                    simple = "请输入大于等于0的数";
                }else{
                    sum = $scope.sumRange(arr);
                    switch(sum){
                        case 1: simple = "请输入大于0的数"; break;
                        case 2: simple = "请输入等于0的数"; break;
                        case 3: simple = "请输入小于0的数";break;
                        case 4: simple = "请输入不等于0的数";break;
                        case 5: simple = "请输入小于等于0的数";break;
                        case 6: simple = null; break;
                        default : console.error(range + " is not number!");
                    }
                }
                return simple;
            };
            /**
             * 获取值
             * @param arr
             */
            $scope.sumRange = function(arr){
                var sum = -1;
                if(angular.isArray(arr)){
                    angular.forEach(arr,function (item) {
                        sum += parseInt(item);
                    })
                }else{
                    sum = parseInt(arr) -1 ;
                }
                return sum == -1 ? -1  : parseInt(sum)+1;
            };


        }])

/**
 * 修改详情
 */
.controller("patrolRegisterMoreUpdateController", ['$scope', '$http', '$ionicModal', '$ionicLoading',
        '$ionicScrollDelegate', '$location', "ynuiNotification", "storageService","$rootScope", "$ionicPopup",
        'stringsConstant', '$cordovaFileTransfer', '$cordovaFile', '$timeout','$filter',"modalManager",
function ($scope, $http, $ionicModal, $ionicLoading, $ionicScrollDelegate, $location, ynuiNotification,
                  storageService,$rootScope,$ionicPopup,stringsConstant, $cordovaFileTransfer, $cordovaFile, $timeout,
                  $filter,modalManager) {

            // 路由信息
            var basePath = originBaseUrl + "/third/xcMobileRecord";
            // 列表选择对象数据
            var oldVm = angular.copy($scope.vm),oldKnob = null;
            if(oldVm.xcMobileStartVO.xcMobileKnobVOs){
                angular.forEach(oldVm.xcMobileStartVO.xcMobileKnobVOs,function (val,index) {
                    if(val.select){
                        oldKnob = index+1;
                    }
                });
            }
            var oldRecordToViewOrUpdate = angular.copy($scope.vm.oldRecordToViewOrUpdate);
            var oldinitFiles = storageService.getItem("initFiles");
            if(!(oldinitFiles && oldinitFiles.length > 0)){
                oldinitFiles = [];
            }

            var vm = $scope.vm = {
                sourceType:oldVm.sourceType,
                showInfo:{
                    attendanceFlag:false,
                    postFlag : false,
                    photoFlag : false,
                    remarkFlag : false,
                    oneFlag : false,
                    twoFlag : false,
                    threeFlag: false,
                    fourkFlag : false,
                    dateAndWeekAndKnob:oldVm.xcMobileStartVO.checkDateStrs+" 第"+oldKnob+"节",
                    dateAndKnob:oldVm.xcMobileStartVO.checkDate+" 第"+oldKnob+"节",
                    buildAndRoom:oldVm.classRoom.room.teachBuildName+"/"+oldVm.classRoom.room.name,
                    classRoomNum:oldVm.classRoom.num,
                    classShowName:oldVm.teachClass.teachClassShowInfo,
                    courseShowInfo:oldVm.course.courseShowInfo?"【"+oldVm.course.courseShowInfo+"】":"",
                    teacherShowName:oldVm.teacher.teaShowInfo
                },
                xcMobileDetailInfoVO:{xcMobileCustomFieldVOs:[],xcMobileStartVO:oldVm.xcMobileStartVO},
                // 是否展示听课
                isNeedRegisterReport:false,
                viewRoom:null,
                // 听课信息
                tkInfo:{
                    list:[],
                    showInfo:null
                },
                // 删除的听课老师
                delUserIdList:[],
                // 教师考勤
                teacherList:[],
                // 照片fsid
                initFiles:oldinitFiles,
                cameraPtion:{
                    waterMark: moment().format("YYYY-MM-DD HH:mm:ss")
                },
                // 上一步
                lastStep:function () {
                    storageService.setItem("initFiles",vm.initFiles);
                    modalManager.remove("patrol_register_more_update");
                },
                // 获取查看数据
                findXCManage:function () {
                    $http.post(originBaseUrl + "/third/xcMobileNewRecord/findXCManage.htm",{id:oldRecordToViewOrUpdate.id}).
                    success(function (data) {
                        if(data.status == 0){
                            vm.viewRoom = angular.copy(data.result);
                            // 应到人数
                            vm.xcMobileDetailInfoVO.shouldNumber = vm.viewRoom.shouldNumber;
                            // 请假人数
                            vm.xcMobileDetailInfoVO.leaveNumber = vm.viewRoom.leaveNumber;
                            // 未到人数
                            vm.xcMobileDetailInfoVO.absenteeismNumber = vm.viewRoom.absenteeismNumber;
                            // 实到人数
                            vm.xcMobileDetailInfoVO.toNumber = vm.viewRoom.toNumber;
                            // 备注
                            vm.xcMobileDetailInfoVO.remark = vm.viewRoom.remark;
                            // 教师考勤情况

                            if(oldVm.teacher.list && oldVm.teacher.list.length > 0){
                                // 默认：按时到、在岗
                                // 修改时处理
                                angular.forEach(oldVm.teacher.list,function (oldTea) {
                                    var teaFlag = null;
                                    angular.forEach(vm.viewRoom.teaCondition,function (tea) {
                                        if(tea.teacherId == oldTea.userId){
                                            teaFlag = tea;
                                        }
                                    });
                                    if(teaFlag){
                                        if(Number(teaFlag.chooseStatus)){
                                            teaFlag.attendanceInfo = Number(teaFlag.chooseStatus);
                                        }else {
                                            teaFlag.attendanceInfo = 1;
                                        }
                                        if(teaFlag.postInfo){
                                            teaFlag.postInfo = teaFlag.postInfo;
                                        }else {
                                            teaFlag.postInfo = 1;
                                        }
                                        teaFlag.showName = teaFlag.name ;
                                        teaFlag.userId = teaFlag.teacherId ;
                                        vm.teacherList.push(teaFlag);
                                    }else {
                                        oldTea.attendanceInfo = 1;
                                        oldTea.postInfo = 1;
                                        oldTea.showName = oldTea.name;
                                        oldTea.userId = oldTea.userId;
                                        vm.teacherList.push(oldTea);
                                    }

                                });

                            }
                            // 自定义字段
                            if(vm.xcMobileDetailInfoVO.xcMobileCustomFieldVOs && vm.xcMobileDetailInfoVO.xcMobileCustomFieldVOs.length > 0){
                                var list = [];
                                angular.forEach(vm.xcMobileDetailInfoVO.xcMobileCustomFieldVOs,function (val) {
                                    angular.forEach(vm.viewRoom.xcMobileCustomFieldVOs,function (value) {
                                        if(val.id == value.id){
                                            list.push(value);
                                        }
                                    });
                                });
                                vm.xcMobileDetailInfoVO.xcMobileCustomFieldVOs = list;
                            }
                            // 巡课照片
                            if(vm.viewRoom.fsIdList && vm.viewRoom.fsIdList.length > 0){
                                vm.initFiles = vm.viewRoom.fsIdList;
                            }
                        }
                    });
                },
                // 获取听课管理配置信息
                findTkglConfig:function() {
                    $http.post(basePath + "/findTkglConfig.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.isNeedRegisterReport = data.result.isNeedRegisterReport;
                            if(vm.isNeedRegisterReport){
                                vm.findTkTeacherAndUserDutyList();
                            }
                        }
                    });
                },
                // 获取某节课某个地点的听课人到岗情况
                findTkTeacherAndUserDutyList:function() {
                    var searchInfo = {
                        classRoomId:oldVm.classRoom.room.id,
                        termId:oldVm.xcMobileStartVO.checkPlatformSysTermId,
                        week:oldVm.xcMobileStartVO.week,
                        day:oldVm.xcMobileStartVO.day,
                        timeType:oldVm.xcMobileStartVO.timeType,
                        knob:oldVm.xcMobileStartVO.knob
                    };
                    $http.post(basePath + "/findTkTeacherAndUserDutyList.htm",searchInfo).success(function (data) {
                        if (data.status === 0) {
                            vm.tkInfo.list = angular.copy(data.result);
                            if(vm.tkInfo.list.length > 0){
                                // 听课人+到岗情况值
                                var nameList = [];
                                angular.forEach(vm.tkInfo.list,function (value) {
                                    value.userId = value.tkUserId;
                                    if(value.listenStatus == 0){
                                        nameList.push(value.tkUserName+"：未去听课");
                                    }else {
                                        nameList.push(value.tkUserName+"：在听课");
                                    }

                                });
                                vm.tkInfo.showInfo = nameList.join("；");
                            }
                        }
                    });
                },
                // 获取教师考勤、到岗情况 样式
                getAttClass:function(info,type) {
                    if(type === 1){
                        if(info.attendanceInfo === 1 ){
                            return "button-label";
                        }else {
                            return "button-label label-orange";
                        }
                    }else {
                        if(info.postInfo === 1 ){
                            return "button-label";
                        }else {
                            return "button-label label-orange";
                        }
                    }

                },
                // 获取教师考勤、到岗情况 样式
                getAttDialogClass:function(info,type,index) {
                    if(type === 1){
                        if(index === info.attendanceInfo){
                            return 'margin-top-10 button button-calm button-mini';
                        }else {
                            return "margin-top-10 button button-calm button-mini button-outline";
                        }
                    }else {
                        if(info.postInfo === index ){
                            return "margin-top-10 button button-calm button-mini";
                        }else {
                            return "margin-top-10 button button-calm  button-mini button-outline";
                        }
                    }
                },
                // 默认光标
                setFocus:function() {
                    if(vm.showInfo.oneFlag){
                        $("#shouldNumberEdit").focus();
                    }else if(vm.showInfo.twoFlag){
                        $("#leaveNumberEdit").focus();
                    }else if(vm.showInfo.threeFlag){
                        $("#absenteeismNumberEdit").focus();
                    }else if(vm.showInfo.fourFlag){
                        $("#toNumberEdit").focus();
                    }
                },
                // 单选  显示
                selectCustom: function (custom) {
                    // 如果是下拉单选
                    if (custom.itemType == 4) {
                        $scope.optionList = custom.xcMobileCustFieldValueVOs;
                        $scope.singSelect.show();
                    }
                    $scope.custom = custom;
                },
                // 当选选项
                selectOption: function (custom) {
                    $scope.custom.value = custom.name;
                    $scope.hideTableSingle();
                },
                // 提交
                saveDetail: function () {
                    // 复制一份数据
                    var obj = angular.copy(vm.xcMobileDetailInfoVO);
                    if(vm.showInfo.oneFlag){
                        var info = Number(vm.xcMobileDetailInfoVO.shouldNumber);
                        if(!eventAction(info)){
                            notifyError("应到人数请输入大于或等于0的整数！");
                            return false;
                        }
                    }else {
                        vm.xcMobileDetailInfoVO.shouldNumber = null;
                    }
                    if(vm.showInfo.twoFlag){

                        var info = Number(vm.xcMobileDetailInfoVO.leaveNumber);
                        if(!eventAction(info)){
                            notifyError("请假人数请输入大于或等于0的整数！");
                            return false;
                        }
                    }else {
                        vm.xcMobileDetailInfoVO.leaveNumber = null;
                    }
                    if(vm.showInfo.threeFlag){
                        var info = Number(vm.xcMobileDetailInfoVO.absenteeismNumber);
                        if(!eventAction(info)){
                            notifyError("未到人数请输入大于或等于0的整数！");
                            return false;
                        }
                    }else {
                        vm.xcMobileDetailInfoVO.absenteeismNumber = null;
                    }
                    if(vm.showInfo.fourFlag){
                        var info = Number(vm.xcMobileDetailInfoVO.toNumber);
                        if(!eventAction(info)){
                            notifyError("实到人数请输入大于或等于0的整数！");
                            return false;
                        }
                    }else {
                        vm.xcMobileDetailInfoVO.toNumber = null;
                    }

                    if(obj.xcMobileCustomFieldVOs && obj.xcMobileCustomFieldVOs.length  > 0){
                        var error = false;
                        angular.forEach(obj.xcMobileCustomFieldVOs,function(custom){
                            if(!error){
                                error = $scope.changeInputItem(custom);
                            }
                        });
                        if(error){
                            return false;
                        }
                    }
                    /**check the data*/
                    $http.get(basePath + "/checkXCDetail.htm",
                        {
                            params:{
                                checkDate:vm.xcMobileDetailInfoVO.xcMobileStartVO.checkDate,
                                week:vm.xcMobileDetailInfoVO.xcMobileStartVO.week,
                                timeType:vm.xcMobileDetailInfoVO.xcMobileStartVO.timeType,
                                day:vm.xcMobileDetailInfoVO.xcMobileStartVO.day,
                                knob:vm.xcMobileDetailInfoVO.xcMobileStartVO.knob,
                                classRoomId:vm.xcMobileDetailInfoVO.xcMobileStartVO.classRoomId,
                                xcTeacherId:oldVm.checkTeacher.userId,
                                // currentUserId:vm.authorizationStr.userId,
                                _timestamp:new Date().getTime()
                            }
                        }).success(function (data) {
                        if (data.status == 0) {
                            var item = data.result;
                            if(isNotBlank(item.failedReason)){
                                item.failedReason = item.failedReason.replace("&%$",oldKnob);
                                var confirmPopup = item.userName == "-1" ? $ionicPopup.alert({
                                        title: "提示",
                                        template: item.failedReason,
                                        okText: "确定"
                                    }) : $ionicPopup.confirm({
                                        title: "提示",
                                        template: item.failedReason,
                                        cancelText: "取消",
                                        okText: "确定"
                                    });
                                confirmPopup.then(function(result){
                                    if(result){
                                        /**自己以前的记录，可以修改 点击确定有保存数据*/
                                        if("1" == item.userName){
                                            vm.saveDetailInfo();
                                        }else{
                                            /**别人已经巡查，不可更改 点击确认后不做任何处理*/
                                        }
                                    }else{
                                        /**点击取消不做任何处理*/
                                    }
                                })
                            }else{
                                /**没有已经保存的数据 则直接保存*/
                                vm.saveDetailInfo();
                            }
                        }
                    });
                },
                // 保存
                saveDetailInfo: function(){
                    // 复制一份数据
                    var obj = angular.copy(vm.xcMobileDetailInfoVO);
                    obj.id = oldRecordToViewOrUpdate.id;
                    if(obj.xcMobileCustomFieldVOs && obj.xcMobileCustomFieldVOs.length  > 0){
                        var error = false;
                        angular.forEach(obj.xcMobileCustomFieldVOs,function(custom){
                            if(!error){
                                error = $scope.changeInputItem(custom);
                            }
                        });
                        if(error){
                            return false;
                        }
                    }
                    //巡课人
                    obj.checkTeacher = oldVm.checkTeacher;
                    // 获取教室
                    obj.xcMobileStartVO.classRoomId = oldVm.classRoom.room.id;
                    // 巡查课程信息
                    obj.xcMobileDetailCourseVO = oldVm.course.info;
                    // 班级
                    obj.xcMobileDetailClassVOs = oldVm.teachClass.list;
                    // 课[带班]教师
                    obj.classTeacherList = vm.teacherList;
                    obj.teacherType = oldVm.teacher.teacherType;
                    //照片
                    obj.fsIdList = vm.initFiles;
                    delete  obj.xcMobileStartVO.xcMobileKnobVOs;

                    angular.forEach(obj.classTeacherList,function (ctl) {
                        if(!vm.showInfo.attendanceFlag){
                            ctl.attendanceInfo = null;
                        }
                        if(!vm.showInfo.postFlag){
                            ctl.postInfo = null;
                        }
                    });
                    // 听课人
                    if(vm.isNeedRegisterReport){
                        var list = [];
                        angular.forEach(vm.tkInfo.list,function (tkUser) {
                            list.push({
                                id:tkUser.id,
                                tkUserId:tkUser.userId,
                                listenStatus:tkUser.listenStatus,
                                remarks:tkUser.remarks
                            });
                        });
                        obj.tkglUserDutySaveVO = {
                            userDutyList:list,
                            delUserIdList:vm.delUserIdList
                        };
                    }
                    $http.post(basePath + "/saveXCMobileRecordDetail.htm", parseParamForSpringMVC(obj)).success(function (data) {
                        if (data.status == 0) {
                            notifySuccess("提交成功！");

                            if(oldVm.resourceType == 1){
                                // 返回列表页面
                                $scope.$emit("patrol_register_update",true);
                                modalManager.remove("patrol_register_update");
                            }else if(oldVm.resourceType == 2){
                                // 查看
                                $scope.$emit("patrol_register_update_fromview",true);
                                modalManager.remove("patrol_register_update_fromview");
                            }
                            vm.lastStep();
                        }else {
                            notifyError("保存失败！");
                        }
                    });
                },
                // 获取固定字段 显示
                getAllOptions:function () {
                    $http.get(basePath + "/getAllOptions.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.colList = angular.copy(data.result);
                            angular.forEach(data.result,function (info) {
                                if(info.itemName === '教师考勤情况'){
                                    vm.showInfo.attendanceFlag = true;
                                }
                                if(info.itemName === '教师到岗情况'){
                                    vm.showInfo.postFlag = true;
                                }
                                if(info.itemName === '巡课照片'){
                                    vm.showInfo.photoFlag = true;
                                    //巡课照片
                                    vm.options = {};
                                    vm.initFiles = storageService.getItemNoDel("initFiles");
                                    if(vm.initFiles){

                                    }
                                }
                                if(info.itemName === '备注'){
                                    vm.showInfo.remarkFlag = true;
                                }
                                if(info.itemName === '应到人数'){
                                    vm.showInfo.oneFlag = true;
                                }
                                if(info.itemName === '请假人数'){
                                    vm.showInfo.twoFlag = true;
                                }
                                if(info.itemName === '未到人数'){
                                    vm.showInfo.threeFlag = true;
                                }
                                if(info.itemName === '实到人数'){
                                    vm.showInfo.fourFlag = true;
                                }
                            });
                            if(vm.showInfo.oneFlag || vm.showInfo.twoFlag || vm.showInfo.threeFlag || vm.showInfo.fourFlag){
                                setTimeout(function () {
                                    vm.setFocus();
                                },150);
                            }

                        }
                    });
                },
                // 自定义显示字段
                findAllShowCustomField:function () {
                    $http.get(originBaseUrl + "/third/xcMobileNewRecord/findAllShowCustomField.htm").success(function (data) {
                        if (data.status === 0) {
                            vm.xcMobileDetailInfoVO.xcMobileCustomFieldVOs = angular.copy(data.result);
                            vm.findXCManage();
                        }
                    });
                },
                // 开启备注弹框
                openDiageRemark:function (){
                    // 回填
                    $scope.$on("patrol_tips",function (event, data) {
                        vm.xcMobileDetailInfoVO.remark = data;
                    });
                    $ionicModal.fromTemplateUrl('templates/classpatrol/patrol_tips.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("patrol_tips", modal);
                        modal.show();
                    });
                },
                // 修改听课信息
                updateTkUser:function () {
                    $scope.$on("teacher_list",function (event, data) {
                        var list = [];
                        if(data && data.length > 0){
                            var nameList = [];
                            angular.forEach(data,function (val) {
                                if(val.listenStatus == 0){
                                    nameList.push(val.tkUserName+"：未去听课");
                                }else {
                                    nameList.push(val.tkUserName+"：在听课");
                                }
                                list.push(val);
                            });
                            vm.tkInfo.showInfo = nameList.join("；");
                            // 确定删除听课人
                            angular.forEach(vm.tkInfo.list,function (value) {
                                if(value.id){
                                    var flag = true;
                                    angular.forEach(data,function (val) {
                                        if(val.userId == value.userId){
                                            flag = false;
                                        }
                                    });
                                    if(flag){
                                        vm.delUserIdList.push(value.userId);
                                    }
                                }

                            });
                        }else {
                            // 全部删除 处理
                            angular.forEach(vm.tkInfo.list,function (value) {
                                vm.delUserIdList.push(value.userId);
                            });
                            vm.tkInfo.showInfo = "";
                        }
                        vm.tkInfo.list = list;
                    });
                    $ionicModal.fromTemplateUrl('templates/classpatrol/teacher_list.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("teacher_list", modal);
                        modal.show();
                    });
                }


            };


            function init() {
                vm.findTkglConfig();
                vm.getAllOptions();
                vm.findAllShowCustomField();
            }

            init();





            // 报错工具
            var notifyError = function (message) {
                if (message == null || message == "") {
                    message = "获取数据失败";
                }
                ynuiNotification.error({msg: message});
            };
            /**
             * 字符串处理
             * @param str
             * @returns {boolean}
             */
            var isNotBlank = function (str) {
                if (null == str) {
                    return false;
                }
                if (/\S+/.test(str)) {
                    return true;
                }
                return false;
            };
            /**
             * 成功的消息提示
             * @param message
             */
            var notifySuccess = function (message) {
                if (!isNotBlank(message)) {
                    message = "操作成功！";
                }
                ynuiNotification.success({msg: message});
            };

            /**
             *  单选
             */
            $ionicModal.fromTemplateUrl('single-select.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.singSelect = modal;
            });
            /**
             * 单选  隐藏
             */
            $scope.hideTableSingle = function () {
                $scope.singSelect.hide();
            };

            // 多选
            $ionicModal.fromTemplateUrl('more-select.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.moreSelect = modal;
            });
            /**
             * 多选  隐藏
             */
            $scope.hideTableMore = function () {
                $scope.moreSelect.hide();
            };
            /**
             * 多选 显示
             */
            $scope.showTableMore = function () {
                $scope.moreSelect.show();
            };
            /**
             *修改教师出勤情况
             */
            $ionicModal.fromTemplateUrl('teacher-cq.html',{
                scope:$scope,
                animation:'slide-in-up'
            }).then(function(modal){
                $scope.modal1 = modal;
            });
            $scope.teacherCqClick = function() {
                $scope.modal1.show();
            };
            $scope.teacherCqClickClose = function() {
                storageService.setItem("teacherListOld",$scope.teacherList);
                $scope.modal1.hide();
            };
            /**
             * 显示节次
             * @type {boolean}
             */
            $scope.moreKnob = true;
            /**
             * 把obj转化为Spring可接受状态
             * @param obj
             * @returns {{}}
             */
            var parseParamForSpringMVC = function (obj) {
                var resultObj = {};
                var deepParseParams = function (key, value, prefix) {
                    if (value instanceof Array) {
                        for (var i in value) {
                            deepParseParams("", value[i], prefix + key + "[" + i + "]");
                        }
                    }
                    else if (value instanceof Object) {
                        for (var i in value) {
                            deepParseParams("." + i, value[i], prefix + key);
                        }
                    }
                    else {
                        resultObj[prefix + key] = value;
                    }
                };
                for (var i in obj) {
                    deepParseParams("", obj[i], i);
                }
                return resultObj;
            };


            var eventAction = function(event){
                var regex = new RegExp("^\\d+$");
                var flag = regex.test(event);
                return flag;
            };


            function getNumberTo() {
                var shouldNumber = Number(vm.xcMobileDetailInfoVO.shouldNumber);
                if(!shouldNumber){
                    shouldNumber = 0;
                }
                var absenteeismNumber = Number(vm.xcMobileDetailInfoVO.absenteeismNumber);
                if(!absenteeismNumber){
                    absenteeismNumber = 0;
                }
                var leaveNumber = Number(vm.xcMobileDetailInfoVO.leaveNumber);
                if(!leaveNumber){
                    leaveNumber = 0;
                }
                var result = 0;
                if(vm.showInfo.oneFlag){
                    result = shouldNumber - absenteeismNumber -leaveNumber;
                }
                return result;

            }

            /**
             * 修改应到人数
             */
            $scope.clickShouldNumberEdit = function () {
                vm.xcMobileDetailInfoVO.shouldNumberEdit = !vm.xcMobileDetailInfoVO.shouldNumberEdit;
                if (vm.xcMobileDetailInfoVO.shouldNumberEdit) {
                    var shouldNumberEdit = Number(vm.xcMobileDetailInfoVO.shouldNumber);
                    if(eventAction(shouldNumberEdit)){
                        vm.xcMobileDetailInfoVO.shouldNumber = shouldNumberEdit;
                        vm.xcMobileDetailInfoVO.toNumber = getNumberTo();
                    }else {
                        notifyError("应到人数请输入大于或等于0的整数！");
                    }

                } else if (isNaN(parseInt(vm.xcMobileDetailInfoVO.shouldNumber))) {
                    vm.xcMobileDetailInfoVO.shouldNumber = 0;
                }

            };
            /**
             * 学生请假人数
             */
            $scope.clickleaveNumberEdit = function () {
                // if(eventAction(event)){
                vm.xcMobileDetailInfoVO.leaveNumberEdit = !vm.xcMobileDetailInfoVO.leaveNumberEdit;
                if (vm.xcMobileDetailInfoVO.leaveNumberEdit) {
                    var leaveNumberEdit = Number(vm.xcMobileDetailInfoVO.leaveNumber);
                    if(eventAction(leaveNumberEdit)){
                        vm.xcMobileDetailInfoVO.leaveNumber = leaveNumberEdit;
                        vm.xcMobileDetailInfoVO.toNumber = getNumberTo();
                    }else {
                        notifyError("请假人数请输入大于或等于0的整数！");
                    }
                } else if (isNaN(parseInt(vm.xcMobileDetailInfoVO.leaveNumber))) {
                    vm.xcMobileDetailInfoVO.leaveNumber = 0;
                }
                // }
            };
            /**
             * 未到人数
             */
            $scope.clickAbsenteeismNumberEdit = function () {
                // if(eventAction(event)){
                vm.xcMobileDetailInfoVO.absenteeismNumberEdit = !vm.xcMobileDetailInfoVO.absenteeismNumberEdit;
                if (vm.xcMobileDetailInfoVO.absenteeismNumberEdit) {
                    var absenteeismNumberEdit = Number(vm.xcMobileDetailInfoVO.absenteeismNumber);
                    if(eventAction(absenteeismNumberEdit)){
                        vm.xcMobileDetailInfoVO.absenteeismNumber = absenteeismNumberEdit;
                        vm.xcMobileDetailInfoVO.toNumber = getNumberTo();
                    }else {
                        notifyError("未到人数请输入大于或等于0的整数！");
                    }
                } else if (isNaN(parseInt(vm.xcMobileDetailInfoVO.absenteeismNumber))) {
                    vm.xcMobileDetailInfoVO.absenteeismNumber = 0;
                }
                // }
            };
            /**
             * 实到人数
             */
            $scope.clickToNumberEdit = function () {
                // if(eventAction(event)){
                vm.xcMobileDetailInfoVO.toNumberEdit = !vm.xcMobileDetailInfoVO.toNumberEdit;
                if (vm.xcMobileDetailInfoVO.toNumberEdit) {
                    var toNumberEdit = Number(vm.xcMobileDetailInfoVO.toNumber);
                    if(eventAction(toNumberEdit)){
                        if(Number(vm.xcMobileDetailInfoVO.toNumber) > Number(vm.xcMobileDetailInfoVO.shouldNumber)){
                            notifyError("实到人数不能大于应到人数！");
                        }
                    }else {
                        notifyError("实到人数请输入大于或等于0的整数！");
                    }
                } else if (isNaN(parseFloat(vm.xcMobileDetailInfoVO.toNumber))) {
                    vm.xcMobileDetailInfoVO.toNumber = 0;
                }
                // }
            };
            $scope.onBlured = function (item) {
                window.setTimeout(function () {
                    $scope.$apply( $("#"+item).focus());
                });
            };


            /**
             * 修改上课教师的状态
             * @param item
             * @param type
             */
            $scope.selectType = function (item, type) {
                item.attendanceInfo = type;
            };



            var getCheckRule = function(columnFields){
                var obj = [];
                if(columnFields.xcRange) {
                    obj = columnFields.xcRange.split(",");
                }
                var cusCheckRule = "";
                var msg = "";
                //空
                if(columnFields.inputRuleType == 1){
//                cusCheckRule = /^.{0,15}$/;
                    eval("cusCheckRule = \/^.{0,"+columnFields.maxLength+"}$\/");
                }
                //数字整数
                if(columnFields.inputRuleType == 2){
                    var a="";
                    var b="";
                    var c="";
                    for (var i in obj) {
                        if (obj[i] == "1") {
                            a ="1"
                        }
                        if (obj[i] == "2") {
                            b ="2"
                        }
                        if (obj[i] == "3") {
                            c ="3"
                        }
                        //整数
                        if(a!=""&&b!=""&&c!=""){
                            cusCheckRule = /^-?\d+$/;
                            msg = "请输入整数";
                        }else if(a!=""&&b!=""&&c==""){//大于等于0整数
                            eval("cusCheckRule = \/^(0|[1-9][0-9]{0,"+(columnFields.maxLength-1)+"})$\/");
                            msg = "请输入大于等于0整数";
                        }else if(a!=""&&b==""&&c==""){//大于0整数
                            eval("cusCheckRule = \/^[1-9]\\d{0,"+(columnFields.maxLength-1)+"}$\/");
                            msg = "请输入大于0整数";
                        }else if(a==""&&b!=""&&c==""){//等于0整数
                            cusCheckRule = /^(0)$/;
                            msg = "请输入0";
                        }else if(a==""&&b!=""&&c!=""){//小于等于0整数
                            eval("cusCheckRule = \/^(0|-[0-9]\\d{0,"+(columnFields.maxLength-1)+"})$\/");
                            msg = "请输入小于等于0整数";
                        }else if(a==""&&b==""&&c!=""){//小于0整数
                            eval("cusCheckRule = \/^-[1-9]\\d{0,"+(columnFields.maxLength-1)+"}$\/");
                            msg = "请输入小于0整数";
                        }
                    }
                }
                //数字小数
                if(columnFields.inputRuleType == 3){
                    var a="";
                    var b="";
                    var c="";
                    for (var i in obj) {
                        if (obj[i] == "1") {
                            a ="1"
                        }
                        if (obj[i] == "2") {
                            b ="2"
                        }
                        if (obj[i] == "3") {
                            c ="3"
                        }
                        //整数
                        if(a!=""&&b!=""&&c!=""){
                            cusCheckRule = /^(-?\d+)(\.\d+)?$/;
                            msg = "请输入整数或者小数";
                        }else if(a!=""&&b!=""&&c==""){//大于等于0小数
                            eval("cusCheckRule = \/^\\d{0,"+columnFields.maxLength+"}(\\.\\d{0,"+columnFields.maxLengthFloat+"})?$\/");
                            msg = "请输入大于等于0整数或者小数";
                        }else if(a!=""&&b==""&&c==""){//大于0小数
                            eval("cusCheckRule = \/^[0-9]{0,"+columnFields.maxLength+"}(\\.[0-9]{0,"+columnFields.maxLengthFloat+"}){0,1}$\/");
                            msg = "请输入大于0整数或者小数";
                        }else if(a==""&&b!=""&&c==""){//等于0
                            cusCheckRule = /^(0)$/;
                            msg = "请输入0";
                        }else if(a==""&&b!=""&&c!=""){//小于等于0小数
                            eval("cusCheckRule = \/^-\\d{0,"+columnFields.maxLength+"}(\\.\\d{0,"+columnFields.maxLengthFloat+"})?$\/");
                            msg = "请输入小于等于0整数或者小数";
                        }else if(a==""&&b==""&&c!=""){//小于0小数
                            eval("cusCheckRule = \/^-[0-9]{0,"+columnFields.maxLength+"}(\\.[0-9]{0,"+columnFields.maxLengthFloat+"}){0,1}$\/");
                            msg = "请输入小于0整数或者小数";
                        }
                    }
                }
                return cusCheckRule;
            }

            var getCustomMsg = function(columnFields){
                var obj = [];
                if(columnFields.xcRange) {
                    obj = columnFields.xcRange.split(",");
                }
                var msg = "";
                //数字整数
                if(columnFields.inputRuleType == 1){
                    msg = "请输入0-"+columnFields.maxLength+"位字符!";
                }
                if(columnFields.inputRuleType == 2){
                    var a="";
                    var b="";
                    var c="";
                    for (var i in obj) {
                        if (obj[i] == "1") {
                            a ="1"
                        }
                        if (obj[i] == "2") {
                            b ="2"
                        }
                        if (obj[i] == "3") {
                            c ="3"
                        }
                        //整数
                        if(a!=""&&b!=""&&c!=""){
                            msg = "请输入整数";
                        }else if(a!=""&&b!=""&&c==""){//大于等于0整数
                            msg = "请输入大于等于0，"+columnFields.maxLength+"位整数";
                        }else if(a!=""&&b==""&&c==""){//大于0整数
                            msg = "请输入大于0，"+columnFields.maxLength+"位整数";
                        }else if(a==""&&b!=""&&c==""){//等于0整数
                            msg = "请输入0";
                        }else if(a==""&&b!=""&&c!=""){//小于等于0整数
                            msg = "请输入小于等于0，"+columnFields.maxLength+"位整数";
                        }else if(a==""&&b==""&&c!=""){//小于0整数
                            msg = "请输入小于0，"+columnFields.maxLength+"位整数";
                        }
                    }
                }
                //数字小数
                if(columnFields.inputRuleType == 3){
                    var a="";
                    var b="";
                    var c="";
                    for (var i in obj) {
                        if (obj[i] == "1") {
                            a ="1"
                        }
                        if (obj[i] == "2") {
                            b ="2"
                        }
                        if (obj[i] == "3") {
                            c ="3"
                        }
                        //整数
                        if(a!=""&&b!=""&&c!=""){
                            msg = "请输入整数或者小数";
                        }else if(a!=""&&b!=""&&c==""){//大于等于0小数
                            msg = "请输入大于等于0，"+columnFields.maxLength+"位整数或者"+columnFields.maxLengthFloat+"位小数";
                        }else if(a!=""&&b==""&&c==""){//大于0小数
                            msg = "请输入大于0，"+columnFields.maxLength+"位整数或者"+columnFields.maxLengthFloat+"位小数";
                        }else if(a==""&&b!=""&&c==""){//等于0
                            msg = "请输入0";
                        }else if(a==""&&b!=""&&c!=""){//小于等于0小数
                            msg = "请输入小于等于0，"+columnFields.maxLength+"位整数或者"+columnFields.maxLengthFloat+"位小数";
                        }else if(a==""&&b==""&&c!=""){//小于0小数
                            msg = "请输入小于0，"+columnFields.maxLength+"位整数或者"+columnFields.maxLengthFloat+"位小数";
                        }
                    }
                }
                return msg;
            }


            /**
             * 自定义字段的验证
             * （1.文本+无限制  2.文本+整数  3.文本+整数或小数  4.日期  5.时间  6.时间+日期  7.单选下拉框）
             * @param custom
             */
            $scope.changeInputItem = function (custom) {
                var error = false;

                /*文本+整数   xcRange（1.大于0  2.等于0  3.小于0）*/
                var maxLength =custom.maxLength,range = custom.xcRange,
                    errorMsg = getCustomMsg(custom), checkRule =  getCheckRule(custom);

                if(1 == custom.inputRuleType && custom.value && custom.value.length > maxLength){
                    notifyError(errorMsg);
                    return true;
                }


                if(2 != custom.inputRuleType && 3 != custom.inputRuleType){
                    // storageService.setItem("xcMobileDetailInfoVO",$scope.xcMobileDetailInfoVO);
                    return error;
                }

                if(isNotBlank(custom.value) && checkRule && !checkRule.test(custom.value)  ){
                    notifyError(errorMsg);
                    error = true;
                }
                if(isNotBlank(custom.value) && isNotBlank(range)){
                    var simple = $scope.getCalutSimple(range);
                    if(isNotBlank(simple)){
                        if(!eval(custom.value+simple +"0")){
                            notifyError($scope.getCalutErrorInfo(range));
                            error = true;
                        }
                    }
                }

                if(!error){
                    // storageService.setItem("xcMobileDetailInfoVO",$scope.xcMobileDetailInfoVO);
                }
                return error;
            };
            /**
             * 返回计算符号
             * @param range
             */
            $scope.getCalutSimple = function(range) {
                var simple = "",arr = range.split(","),sum = -1 ;
                /*3 做特殊处理*/
                if(arr.length == 2 && $scope.sumRange(arr) == 3){
                    simple = ">=";
                }else{
                    sum = $scope.sumRange(arr);
                    switch(sum){
                        case 1: simple = ">"; break;
                        case 2: simple = "=="; break;
                        case 3: simple = "<";break;
                        case 4: simple = "!=";break;
                        case 5: simple = "<=";break;
                        case 6: simple = null; break;
                        case -1: simple = null; break;
                        default : console.error(range + " is not number!");
                    }
                }
                return simple;
            };
            /**
             * 返回计算符号
             * @param range
             */
            $scope.getCalutErrorInfo = function(range) {
                var simple = "",arr = range.split(","),sum = -1 ;
                /*3 做特殊处理*/
                if(arr.length == 2 && $scope.sumRange(arr) == 3){
                    simple = "请输入大于等于0的数";
                }else{
                    sum = $scope.sumRange(arr);
                    switch(sum){
                        case 1: simple = "请输入大于0的数"; break;
                        case 2: simple = "请输入等于0的数"; break;
                        case 3: simple = "请输入小于0的数";break;
                        case 4: simple = "请输入不等于0的数";break;
                        case 5: simple = "请输入小于等于0的数";break;
                        case 6: simple = null; break;
                        default : console.error(range + " is not number!");
                    }
                }
                return simple;
            };
            /**
             * 获取值
             * @param arr
             */
            $scope.sumRange = function(arr){
                var sum = -1;
                if(angular.isArray(arr)){
                    angular.forEach(arr,function (item) {
                        sum += parseInt(item);
                    })
                }else{
                    sum = parseInt(arr) -1 ;
                }
                return sum == -1 ? -1  : parseInt(sum)+1;
            };


        }])


/**
 * 备注
 */
.controller("remarkController", ['$scope', "modalManager",
        function ($scope, modalManager) {
            var oldVm = angular.copy($scope.vm);
            var vm = $scope.vm = {
                remark:oldVm.xcMobileDetailInfoVO.remark,
                // 取消备注
                cancelPopRemark: function () {
                    modalManager.remove("patrol_tips");
                },
                // 确定
                okPopRemark: function () {
                    $scope.$emit("patrol_tips",vm.remark);
                    vm.cancelPopRemark();
                }

            };

        }])

/**
 * 听课教师到岗情况
 */
.controller("teacherListController", ['$scope', "modalManager","$ionicModal","$ionicPopup",
function ($scope, modalManager,$ionicModal,$ionicPopup) {

            var oldValue = angular.copy($scope.vm);
            var vm = $scope.vm = {
                showInfo:oldValue.showInfo,
                tkUserInfo:{
                    list:oldValue.tkInfo.list
                },
                // 返回
                cancel: function (flag) {
                    if(flag){
                        // 验证到有听课人到岗情况是“未去听课”或有听课人老师备注不为空
                        // 有数据未保存，是否放弃保存数据并返回？
                        var haveInfo = false;
                        if(vm.tkUserInfo.list && vm.tkUserInfo.list.length > 0){
                            angular.forEach(vm.tkUserInfo.list,function (val) {
                                if(val.remarks || val.listenStatus != 1){
                                    haveInfo = true;
                                }
                            });
                        }
                        if(haveInfo){
                            $ionicPopup.confirm({
                                title: '返回确认',
                                template: '有数据未保存，是否放弃保存数据并返回？',
                                cancelText: '取消',
                                okText: '确定'
                            }).then(function (res) {
                                if (res) {
                                    modalManager.remove("teacher_list");
                                }
                            });
                        }else {
                            modalManager.remove("teacher_list");
                        }

                    }else {
                        modalManager.remove("teacher_list");
                    }
                },
                // 确定
                submit: function () {
                    $scope.$emit("teacher_list",vm.tkUserInfo.list);
                    vm.cancel();
                },
                // 移除
                removeUser:function (index) {
                    vm.tkUserInfo.list.splice(index,1);
                },
                // 选择听课教师
                chooseTeacher:function () {
                    $scope.$on("choose_tkUser",function (event, data) {
                        var list = [];
                        angular.forEach(data,function (val) {
                            var old = null;
                            angular.forEach(vm.tkUserInfo.list,function (value) {
                                if(value.source == 1 && val.userId == value.userId){
                                    old = value;
                                }
                            });
                            if(old){
                                list.push(old);
                            }else {
                                list.push({
                                    id: null,
                                    up:false,
                                    listenStatus: 1,
                                    mainOrgName: val.mainOrgName,
                                    registed: false,
                                    remarks: null,
                                    source: 0,
                                    tkUserId: val.userId,
                                    userId: val.userId,
                                    tkUserName: (val.name == val.alien || val.alien == null ? val.name: val.name+"("+val.alien+")")
                                });
                            }
                        });

                        vm.tkUserInfo.list = list;

                    });
                    $ionicModal.fromTemplateUrl('templates/classpatrol/choose_tkUser.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        modalManager.put("choose_tkUser", modal);
                        modal.show();
                    });
                },
                // 显示隐藏备注
                clickUpOrDown:function (info) {
                    info.up = !info.up;
                },
                getActiveClass:function (info,type) {
                    if(type == 1){
                        if(info.listenStatus == 1){
                            return 'active';
                        }else {
                            return "";
                        }
                    }else {
                        if(info.listenStatus != 1){
                            return 'active';
                        }else {
                            return "";
                        }
                    }

                },
                getListenStatus:function (info, type) {
                    info.listenStatus = type;
                }

            };


            function init() {
                if(vm.tkUserInfo.list && vm.tkUserInfo.list.length > 0){
                    angular.forEach(vm.tkUserInfo.list,function (val,index) {
                        // 默认展开第一个
                        val.up = index == 0;
                        // 默认 在听课
                        if(val.listenStatus !== 0){
                            val.listenStatus = 1;
                        }
                    });
                }
            }

            init();

}]);
